/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],ee=function(x){for(var e=[],I=0,M=x.length;I<M;I++)e[I]=Z[x[I]];return e};define(Z[126],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(k,m){const d=Math.pow(10,m);return Math.round(k*d)/d}class M{constructor(m,d,w,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=I(Math.max(Math.min(1,v),0),3)}static equals(m,d){return m.r===d.r&&m.g===d.g&&m.b===d.b&&m.a===d.a}}e.RGBA=M;class n{constructor(m,d,w,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=I(Math.max(Math.min(1,d),0),3),this.l=I(Math.max(Math.min(1,w),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(m,d){return m.h===d.h&&m.s===d.s&&m.l===d.l&&m.a===d.a}static fromRGBA(m){const d=m.r/255,w=m.g/255,v=m.b/255,b=m.a,u=Math.max(d,w,v),y=Math.min(d,w,v);let p=0,a=0;const g=(y+u)/2,f=u-y;if(f>0){switch(a=Math.min(g<=.5?f/(2*g):f/(2-2*g),1),u){case d:p=(w-v)/f+(w<v?6:0);break;case w:p=(v-d)/f+2;break;case v:p=(d-w)/f+4;break}p*=60,p=Math.round(p)}return new n(p,a,g,b)}static i(m,d,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?m+(d-m)*6*w:w<1/2?d:w<2/3?m+(d-m)*(2/3-w)*6:m}static toRGBA(m){const d=m.h/360,{s:w,l:v,a:b}=m;let u,y,p;if(w===0)u=y=p=v;else{const a=v<.5?v*(1+w):v+w-v*w,g=2*v-a;u=n.i(g,a,d+1/3),y=n.i(g,a,d),p=n.i(g,a,d-1/3)}return new M(Math.round(u*255),Math.round(y*255),Math.round(p*255),b)}}e.HSLA=n;class R{constructor(m,d,w,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=I(Math.max(Math.min(1,d),0),3),this.v=I(Math.max(Math.min(1,w),0),3),this.a=I(Math.max(Math.min(1,v),0),3)}static equals(m,d){return m.h===d.h&&m.s===d.s&&m.v===d.v&&m.a===d.a}static fromRGBA(m){const d=m.r/255,w=m.g/255,v=m.b/255,b=Math.max(d,w,v),u=Math.min(d,w,v),y=b-u,p=b===0?0:y/b;let a;return y===0?a=0:b===d?a=((w-v)/y%6+6)%6:b===w?a=(v-d)/y+2:a=(d-w)/y+4,new R(Math.round(a*60),p,b,m.a)}static toRGBA(m){const{h:d,s:w,v,a:b}=m,u=v*w,y=u*(1-Math.abs(d/60%2-1)),p=v-u;let[a,g,f]=[0,0,0];return d<60?(a=u,g=y):d<120?(a=y,g=u):d<180?(g=u,f=y):d<240?(g=y,f=u):d<300?(a=y,f=u):d<=360&&(a=u,f=y),a=Math.round((a+p)*255),g=Math.round((g+p)*255),f=Math.round((f+p)*255),new M(a,g,f,b)}}e.HSVA=R;class C{static fromHex(m){return C.Format.CSS.parseHex(m)||C.red}static equals(m,d){return!m&&!d?!0:!m||!d?!1:m.equals(d)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof M)this.rgba=m;else if(m instanceof n)this.i=m,this.rgba=n.toRGBA(m);else if(m instanceof R)this.j=m,this.rgba=R.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&M.equals(this.rgba,m.rgba)&&n.equals(this.hsla,m.hsla)&&R.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=C.k(this.rgba.r),d=C.k(this.rgba.g),w=C.k(this.rgba.b),v=.2126*m+.7152*d+.0722*w;return I(v,4)}static k(m){const d=m/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(m){const d=this.getRelativeLuminance(),w=m.getRelativeLuminance();return d>w?(d+.05)/(w+.05):(w+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const d=this.getRelativeLuminance(),w=m.getRelativeLuminance();return d>w}isDarkerThan(m){const d=this.getRelativeLuminance(),w=m.getRelativeLuminance();return d<w}lighten(m){return new C(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new C(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:d,g:w,b:v,a:b}=this.rgba;return new C(new M(d,w,v,b*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const d=m.rgba,w=this.rgba.a,v=d.a,b=w+v*(1-w);if(b<1e-6)return C.transparent;const u=this.rgba.r*w/b+d.r*v*(1-w)/b,y=this.rgba.g*w/b+d.g*v*(1-w)/b,p=this.rgba.b*w/b+d.b*v*(1-w)/b;return new C(new M(u,y,p,b))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:d,g:w,b:v,a:b}=this.rgba;return new C(new M(m.rgba.r-b*(m.rgba.r-d),m.rgba.g-b*(m.rgba.g-w),m.rgba.b-b*(m.rgba.b-v),1))}flatten(...m){const d=m.reduceRight((w,v)=>C.o(v,w));return C.o(this,d)}static o(m,d){const w=1-m.rgba.a;return new C(new M(w*d.rgba.r+m.rgba.a*m.rgba.r,w*d.rgba.g+m.rgba.a*m.rgba.g,w*d.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(m,d,w){if(m.isLighterThan(d))return m;w=w||.5;const v=m.getRelativeLuminance(),b=d.getRelativeLuminance();return w=w*(b-v)/b,m.lighten(w)}static getDarkerColor(m,d,w){if(m.isDarkerThan(d))return m;w=w||.5;const v=m.getRelativeLuminance(),b=d.getRelativeLuminance();return w=w*(v-b)/v,m.darken(w)}}C.white=new C(new M(255,255,255,1)),C.black=new C(new M(0,0,0,1)),C.red=new C(new M(255,0,0,1)),C.blue=new C(new M(0,0,255,1)),C.green=new C(new M(0,255,0,1)),C.cyan=new C(new M(0,255,255,1)),C.lightgrey=new C(new M(211,211,211,1)),C.transparent=new C(new M(0,0,0,0)),e.Color=C,function(k){let m;(function(d){let w;(function(v){function b(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}v.formatRGB=b;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}v.formatHSL=y;function p(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=p;function a(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function g(t){return`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}`}v.formatHex=g;function f(t,c=!1){return c&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}${a(Math.round(t.rgba.a*255))}`}v.formatHexA=f;function E(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}v.format=E;function S(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),s=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new k(new M(i,s,o,1))}if(c===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),s=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),l=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new k(new M(i,s,o,l/255))}if(c===4){const i=D(t.charCodeAt(1)),s=D(t.charCodeAt(2)),o=D(t.charCodeAt(3));return new k(new M(16*i+i,16*s+s,16*o+o))}if(c===5){const i=D(t.charCodeAt(1)),s=D(t.charCodeAt(2)),o=D(t.charCodeAt(3)),l=D(t.charCodeAt(4));return new k(new M(16*i+i,16*s+s,16*o+o,(16*l+l)/255))}return null}v.parseHex=S;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=d.CSS||(d.CSS={}))})(m=k.Format||(k.Format={}))}(C=e.Color||(e.Color={})),e.Color=C}),define(Z[54],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(C){return(k,m,d)=>{let w=null,v=null;if(typeof d.value=="function"?(w="value",v=d.value):typeof d.get=="function"&&(w="get",v=d.get),!v)throw new Error("not supported");d[w]=C(v,m)}}function M(C,k,m){let d=null,w=null;if(typeof m.value=="function"?(d="value",w=m.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(d="get",w=m.get),!w)throw new Error("not supported");const v=`$memoize$${k}`;m[d]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,b)}),this[v]}}e.memoize=M;function n(C,k,m){return I((d,w)=>{const v=`$debounce$${w}`,b=`$debounce$result$${w}`;return function(...u){this[b]||(this[b]=m?m():void 0),clearTimeout(this[v]),k&&(this[b]=k(this[b],...u),u=[this[b]]),this[v]=setTimeout(()=>{d.apply(this,u),this[b]=m?m():void 0},C)}})}e.debounce=n;function R(C,k,m){return I((d,w)=>{const v=`$throttle$timer$${w}`,b=`$throttle$result$${w}`,u=`$throttle$lastRun$${w}`,y=`$throttle$pending$${w}`;return function(...p){if(this[b]||(this[b]=m?m():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),k&&(this[b]=k(this[b],...p)),this[y])return;const a=this[u]+C;a<=Date.now()?(this[u]=Date.now(),d.apply(this,[this[b]]),this[b]=m?m():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),d.apply(this,[this[b]]),this[b]=m?m():void 0},a-Date.now()))}})}e.throttle=R}),define(Z[13],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?S.isErrorNoTelemetry(c)?new S(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(i=>{i(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=I,e.errorHandler=new I;function M(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=M;function n(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function R(t){d(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function C(t){d(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function k(t){if(t instanceof Error){const{name:c,message:i}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:s,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const m="Canceled";function d(t){return t instanceof w?!0:t instanceof Error&&t.name===m&&t.message===m}e.isCancellationError=d;class w extends Error{constructor(){super(m),this.name=this.message}}e.CancellationError=w;function v(){const t=new Error(m);return t.name=t.message,t}e.canceled=v;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=u;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function p(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=p;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=a;class g extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=g;class f extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=f;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=E;class S extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof S)return c;const i=new S;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class D extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(Z[25],ee([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function M(j,K=0){return j[j.length-(1+K)]}e.tail=M;function n(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=n;function R(j,K,J=(re,de)=>re===de){if(j===K)return!0;if(!j||!K||j.length!==K.length)return!1;for(let re=0,de=j.length;re<de;re++)if(!J(j[re],K[re]))return!1;return!0}e.equals=R;function C(j,K){const J=j.length-1;K<J&&(j[K]=j[J]),j.pop()}e.removeFastWithoutKeepingOrder=C;function k(j,K,J){return m(j.length,re=>J(j[re],K))}e.binarySearch=k;function m(j,K){let J=0,re=j-1;for(;J<=re;){const de=(J+re)/2|0,Ce=K(de);if(Ce<0)J=de+1;else if(Ce>0)re=de-1;else return de}return-(J+1)}e.binarySearch2=m;function d(j,K){let J=0,re=j.length;if(re===0)return 0;for(;J<re;){const de=Math.floor((J+re)/2);K(j[de])?re=de:J=de+1}return J}e.findFirstInSorted=d;function w(j,K,J){if(j=j|0,j>=K.length)throw new TypeError("invalid index");const re=K[Math.floor(K.length*Math.random())],de=[],Ce=[],Re=[];for(const De of K){const Oe=J(De,re);Oe<0?de.push(De):Oe>0?Ce.push(De):Re.push(De)}return j<de.length?w(j,de,J):j<de.length+Re.length?Re[0]:w(j-(de.length+Re.length),Ce,J)}e.quickSelect=w;function v(j,K){const J=[];let re;for(const de of j.slice(0).sort(K))!re||K(re[0],de)!==0?(re=[de],J.push(re)):re.push(de);return J}e.groupBy=v;function b(j,K,J){const re=[];function de(De,Oe,$e){if(Oe===0&&$e.length===0)return;const fe=re[re.length-1];fe&&fe.start+fe.deleteCount===De?(fe.deleteCount+=Oe,fe.toInsert.push(...$e)):re.push({start:De,deleteCount:Oe,toInsert:$e})}let Ce=0,Re=0;for(;;){if(Ce===j.length){de(Ce,0,K.slice(Re));break}if(Re===K.length){de(Ce,j.length-Ce,[]);break}const De=j[Ce],Oe=K[Re],$e=J(De,Oe);$e===0?(Ce+=1,Re+=1):$e<0?(de(Ce,1,[]),Ce+=1):$e>0&&(de(Ce,0,[Oe]),Re+=1)}return re}e.sortedDiff=b;function u(j,K,J){const re=b(j,K,J),de=[],Ce=[];for(const Re of re)de.push(...j.slice(Re.start,Re.start+Re.deleteCount)),Ce.push(...Re.toInsert);return{removed:de,added:Ce}}e.delta=u;function y(j,K,J){if(J===0)return[];const re=j.slice(0,J).sort(K);return a(j,K,re,J,j.length),re}e.top=y;function p(j,K,J,re,de){return J===0?Promise.resolve([]):new Promise((Ce,Re)=>{(async()=>{const De=j.length,Oe=j.slice(0,J).sort(K);for(let $e=J,fe=Math.min(J+re,De);$e<De;$e=fe,fe=Math.min(fe+re,De)){if($e>J&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new I.CancellationError;a(j,K,Oe,$e,fe)}return Oe})().then(Ce,Re)})}e.topAsync=p;function a(j,K,J,re,de){for(const Ce=J.length;re<de;re++){const Re=j[re];if(K(Re,J[Ce-1])<0){J.pop();const De=d(J,Oe=>K(Re,Oe)<0);J.splice(De,0,Re)}}}function g(j){return j.filter(K=>!!K)}e.coalesce=g;function f(j){let K=0;for(let J=0;J<j.length;J++)j[J]&&(j[K]=j[J],K+=1);j.length=K}e.coalesceInPlace=f;function E(j,K,J){j.splice(J,0,j.splice(K,1)[0])}e.move=E;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function D(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=D;function t(j,K=J=>J){const J=new Set;return j.filter(re=>{const de=K(re);return J.has(de)?!1:(J.add(de),!0)})}e.distinct=t;function c(j){const K=new Set;return J=>{const re=j(J);return K.has(re)?!1:(K.add(re),!0)}}e.uniqueFilter=c;function i(j,K){const J=s(j,K);if(J!==-1)return j[J]}e.findLast=i;function s(j,K){for(let J=j.length-1;J>=0;J--){const re=j[J];if(K(re))return J}return-1}e.lastIndex=s;function o(j,K){return j.length>0?j[0]:K}e.firstOrDefault=o;function l(j,K){return j.length>0?j[j.length-1]:K}e.lastOrDefault=l;function r(j,K,J=(re,de)=>re===de){let re=0;for(let de=0,Ce=Math.min(j.length,K.length);de<Ce&&J(j[de],K[de]);de++)re++;return re}e.commonPrefixLength=r;function h(j){return[].concat(...j)}e.flatten=h;function P(j,K){let J=typeof K=="number"?j:0;typeof K=="number"?J=j:(J=0,K=j);const re=[];if(J<=K)for(let de=J;de<K;de++)re.push(de);else for(let de=J;de>K;de--)re.push(de);return re}e.range=P;function A(j,K,J){return j.reduce((re,de)=>(re[K(de)]=J?J(de):de,re),Object.create(null))}e.index=A;function T(j,K){return j.push(K),()=>N(j,K)}e.insert=T;function N(j,K){const J=j.indexOf(K);if(J>-1)return j.splice(J,1),K}e.remove=N;function z(j,K,J){const re=j.slice(0,K),de=j.slice(K);return re.concat(J,de)}e.arrayInsert=z;function H(j,K){let J;if(typeof K=="number"){let re=K;J=()=>{const de=Math.sin(re++)*179426549;return de-Math.floor(de)}}else J=Math.random;for(let re=j.length-1;re>0;re-=1){const de=Math.floor(J()*(re+1)),Ce=j[re];j[re]=j[de],j[de]=Ce}}e.shuffle=H;function ie(j,K){const J=j.indexOf(K);J>-1&&(j.splice(J,1),j.unshift(K))}e.pushToStart=ie;function se(j,K){const J=j.indexOf(K);J>-1&&(j.splice(J,1),j.push(K))}e.pushToEnd=se;function oe(j,K){for(const J of K)j.push(J)}e.pushMany=oe;function ue(j,K){return Array.isArray(j)?j.map(K):K(j)}e.mapArrayOrNot=ue;function le(j){return Array.isArray(j)?j:[j]}e.asArray=le;function me(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=me;function G(j,K){for(const J of j){const re=K(J);if(re!==void 0)return re}}e.mapFind=G;function B(j,K,J){const re=q(j,K),de=j.length,Ce=J.length;j.length=de+Ce;for(let Re=de-1;Re>=re;Re--)j[Re+Ce]=j[Re];for(let Re=0;Re<Ce;Re++)j[Re+re]=J[Re]}e.insertInto=B;function O(j,K,J,re){const de=q(j,K),Ce=j.splice(de,J);return B(j,de,re),Ce}e.splice=O;function q(j,K){return K<0?Math.max(K+j.length,0):Math.min(K,j.length)}var Y;(function(j){function K(de){return de<0}j.isLessThan=K;function J(de){return de>0}j.isGreaterThan=J;function re(de){return de===0}j.isNeitherLessOrGreaterThan=re,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function te(j,K){return(J,re)=>K(j(J),j(re))}e.compareBy=te;function ne(...j){return(K,J)=>{for(const re of j){const de=re(K,J);if(!Y.isNeitherLessOrGreaterThan(de))return de}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=ne;const L=(j,K)=>j-K;e.numberComparator=L;function F(j,K){if(j.length===0)return;let J=j[0];for(let re=1;re<j.length;re++){const de=j[re];K(de,J)>0&&(J=de)}return J}e.findMaxBy=F;function W(j,K){if(j.length===0)return;let J=j[0];for(let re=1;re<j.length;re++){const de=j[re];K(de,J)>=0&&(J=de)}return J}e.findLastMaxBy=W;function U(j,K){return F(j,(J,re)=>-K(J,re))}e.findMinBy=U;class ${constructor(K){this.f=K,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(K){let J=this.c;for(;J<this.f.length&&K(this.f[J]);)J++;const re=J===this.c?null:this.f.slice(this.c,J);return this.c=J,re}takeFromEndWhile(K){let J=this.d;for(;J>=0&&K(this.f[J]);)J--;const re=J===this.d?null:this.f.slice(J+1,this.d+1);return this.d=J,re}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const K=this.f[this.c];return this.c++,K}removeLast(){const K=this.f[this.d];return this.d--,K}takeCount(K){const J=this.f.slice(this.c,this.c+K);return this.c+=K,J}}e.ArrayQueue=$;class V{constructor(K){this.iterate=K}forEach(K){this.iterate(J=>(K(J),!0))}toArray(){const K=[];return this.iterate(J=>(K.push(J),!0)),K}filter(K){return new V(J=>this.iterate(re=>K(re)?J(re):!0))}map(K){return new V(J=>this.iterate(re=>J(K(re))))}some(K){let J=!1;return this.iterate(re=>(J=K(re),!J)),J}findFirst(K){let J;return this.iterate(re=>K(re)?(J=re,!1):!0),J}findLast(K){let J;return this.iterate(re=>(K(re)&&(J=re),!0)),J}findLastMaxBy(K){let J,re=!0;return this.iterate(de=>((re||Y.isGreaterThan(K(de,J)))&&(re=!1,J=de),!0)),J}}V.empty=new V(j=>{}),e.CallbackIterable=V}),define(Z[127],ee([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function M(m,d){if(!m)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=M;function n(m,d="Unreachable"){throw new Error(d)}e.assertNever=n;function R(m){if(!m)throw new I.BugIndicatingError("Assertion Failed")}e.assert=R;function C(m){if(!m()){debugger;m(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function k(m,d){let w=0;for(;w<m.length-1;){const v=m[w],b=m[w+1];if(!d(v,b))return!1;w++}return!0}e.checkAdjacentItems=k}),define(Z[50],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(M){const n=this;let R=!1,C;return function(){return R||(R=!0,C=M.apply(n,arguments)),C}}e.once=I}),define(Z[70],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(M){function n(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=n;const R=Object.freeze([]);function C(){return R}M.empty=C;function*k(S){yield S}M.single=k;function m(S){return n(S)?S:k(S)}M.wrap=m;function d(S){return S||R}M.from=d;function w(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=w;function v(S){return S[Symbol.iterator]().next().value}M.first=v;function b(S,D){for(const t of S)if(D(t))return!0;return!1}M.some=b;function u(S,D){for(const t of S)if(D(t))return t}M.find=u;function*y(S,D){for(const t of S)D(t)&&(yield t)}M.filter=y;function*p(S,D){let t=0;for(const c of S)yield D(c,t++)}M.map=p;function*a(...S){for(const D of S)for(const t of D)yield t}M.concat=a;function g(S,D,t){let c=t;for(const i of S)c=D(c,i);return c}M.reduce=g;function*f(S,D,t=S.length){for(D<0&&(D+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);D<t;D++)yield S[D]}M.slice=f;function E(S,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,S];const c=S[Symbol.iterator]();for(let i=0;i<D;i++){const s=c.next();if(s.done)return[t,M.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return c}}]}M.consume=E})(I=e.Iterable||(e.Iterable={}))}),define(Z[43],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function C(t,c=!1){let i=0;const s=t.length;let o="",l=0,r=16,h=0;function P(se){let oe=0,ue=0;for(;oe<se;){const le=t.charCodeAt(i);if(le>=48&&le<=57)ue=ue*16+le-48;else if(le>=65&&le<=70)ue=ue*16+le-65+10;else if(le>=97&&le<=102)ue=ue*16+le-97+10;else break;i++,oe++}return oe<se&&(ue=-1),ue}function A(se){i=se,o="",l=0,r=16,h=0}function T(){const se=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&d(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&d(t.charCodeAt(i)))for(i++;i<t.length&&d(t.charCodeAt(i));)i++;else return h=3,t.substring(se,i);let oe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&d(t.charCodeAt(i))){for(i++;i<t.length&&d(t.charCodeAt(i));)i++;oe=i}else h=3;return t.substring(se,oe)}function N(){let se="",oe=i;for(;;){if(i>=s){se+=t.substring(oe,i),h=2;break}const ue=t.charCodeAt(i);if(ue===34){se+=t.substring(oe,i),i++;break}if(ue===92){if(se+=t.substring(oe,i),i++,i>=s){h=2;break}switch(t.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const me=P(4);me>=0?se+=String.fromCharCode(me):h=4;break}default:h=5}oe=i;continue}if(ue>=0&&ue<=31)if(m(ue)){se+=t.substring(oe,i),h=2;break}else h=6;i++}return se}function z(){if(o="",h=0,l=i,i>=s)return l=s,r=17;let se=t.charCodeAt(i);if(k(se)){do i++,o+=String.fromCharCode(se),se=t.charCodeAt(i);while(k(se));return r=15}if(m(se))return i++,o+=String.fromCharCode(se),se===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),r=14;switch(se){case 123:return i++,r=1;case 125:return i++,r=2;case 91:return i++,r=3;case 93:return i++,r=4;case 58:return i++,r=6;case 44:return i++,r=5;case 34:return i++,o=N(),r=10;case 47:{const oe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!m(t.charCodeAt(i));)i++;return o=t.substring(oe,i),r=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=s-1;let le=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,le=!0;break}i++}return le||(i++,h=1),o=t.substring(oe,i),r=13}return o+=String.fromCharCode(se),i++,r=16}case 45:if(o+=String.fromCharCode(se),i++,i===s||!d(t.charCodeAt(i)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),r=11;default:for(;i<s&&H(se);)i++,se=t.charCodeAt(i);if(l!==i){switch(o=t.substring(l,i),o){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return o+=String.fromCharCode(se),i++,r=16}}function H(se){if(k(se)||m(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let se;do se=z();while(se>=12&&se<=15);return se}return{setPosition:A,getPosition:()=>i,scan:c?ie:z,getToken:()=>r,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>h}}e.createScanner=C;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function v(t,c){const i=[],s=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function h(P,A,T,N){l.value=P,l.offset=A,l.length=T,l.type=N,l.colonOffset=void 0,o=l}try{E(t,{onObjectBegin:(P,A)=>{if(c<=P)throw s;o=void 0,r=c>P,i.push("")},onObjectProperty:(P,A,T)=>{if(c<A||(h(P,A,T,"property"),i[i.length-1]=P,c<=A+T))throw s},onObjectEnd:(P,A)=>{if(c<=P)throw s;o=void 0,i.pop()},onArrayBegin:(P,A)=>{if(c<=P)throw s;o=void 0,i.push(0)},onArrayEnd:(P,A)=>{if(c<=P)throw s;o=void 0,i.pop()},onLiteralValue:(P,A,T)=>{if(c<A||(h(P,A,T,D(P)),c<=A+T))throw s},onSeparator:(P,A,T)=>{if(c<=A)throw s;if(P===":"&&o&&o.type==="property")o.colonOffset=A,r=!1,o=void 0;else if(P===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(r=!0,i[i.length-1]=""),o=void 0}}})}catch(P){if(P!==s)throw P}return{path:i,previousNode:o,isAtPropertyKey:r,matches:P=>{let A=0;for(let T=0;A<P.length&&T<i.length;T++)if(P[A]===i[T]||P[A]==="*")A++;else if(P[A]!=="**")return!1;return A===P.length}}}e.getLocation=v;function b(t,c=[],i=R.DEFAULT){let s=null,o=[];const l=[];function r(P){Array.isArray(o)?o.push(P):s!==null&&(o[s]=P)}return E(t,{onObjectBegin:()=>{const P={};r(P),l.push(o),o=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const P=[];r(P),l.push(o),o=P,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:r,onError:(P,A,T)=>{c.push({error:P,offset:A,length:T})}},i),o[0]}e.parse=b;function u(t,c=[],i=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function l(P){return s.children.push(P),P}E(t,{onObjectBegin:P=>{s=l({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,A,T)=>{s=l({type:"property",offset:A,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:A,length:T,parent:s})},onObjectEnd:(P,A)=>{s.length=P+A-s.offset,s=s.parent,o(P+A)},onArrayBegin:(P,A)=>{s=l({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,A)=>{s.length=P+A-s.offset,s=s.parent,o(P+A)},onLiteralValue:(P,A,T)=>{l({type:D(P),offset:A,length:T,parent:s,value:P}),o(A+T)},onSeparator:(P,A,T)=>{s.type==="property"&&(P===":"?s.colonOffset=A:P===","&&o(A))},onError:(P,A,T)=>{c.push({error:P,offset:A,length:T})}},i);const h=s.children[0];return h&&delete h.parent,h}e.parseTree=u;function y(t,c){if(!t)return;let i=t;for(const s of c)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===s){i=l.children[1],o=!0;break}if(!o)return}else{const o=s;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=y;function p(t){if(!t.parent||!t.parent.children)return[];const c=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=p;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const c=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(c[i.children[0].value]=a(s))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function g(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=g;function f(t,c,i=!1){if(g(t,c,i)){const s=t.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=c;o++){const l=f(s[o],c,i);if(l)return l}return t}}e.findNodeAtOffset=f;function E(t,c,i=R.DEFAULT){const s=C(t,!1);function o(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(te){return te?ne=>te(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=o(c.onObjectBegin),h=l(c.onObjectProperty),P=o(c.onObjectEnd),A=o(c.onArrayBegin),T=o(c.onArrayEnd),N=l(c.onLiteralValue),z=l(c.onSeparator),H=o(c.onComment),ie=l(c.onError),se=i&&i.disallowComments,oe=i&&i.allowTrailingComma;function ue(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:se||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(te){case 12:case 13:se?le(10):H();break;case 16:le(1);break;case 15:case 14:break;default:return te}}}function le(te,ne=[],L=[]){if(ie(te),ne.length+L.length>0){let F=s.getToken();for(;F!==17;){if(ne.indexOf(F)!==-1){ue();break}else if(L.indexOf(F)!==-1)break;F=ue()}}}function me(te){const ne=s.getTokenValue();return te?N(ne):h(ne),ue(),!0}function G(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(le(2),te=0)}catch{le(2)}N(te);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ue(),!0}function B(){return s.getToken()!==10?(le(3,[],[2,5]),!1):(me(!1),s.getToken()===6?(z(":"),ue(),Y()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function O(){r(),ue();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||le(4,[],[]),z(","),ue(),s.getToken()===2&&oe)break}else te&&le(6,[],[]);B()||le(4,[],[2,5]),te=!0}return P(),s.getToken()!==2?le(7,[2],[]):ue(),!0}function q(){A(),ue();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||le(4,[],[]),z(","),ue(),s.getToken()===4&&oe)break}else te&&le(6,[],[]);Y()||le(4,[],[4,5]),te=!0}return T(),s.getToken()!==4?le(8,[4],[]):ue(),!0}function Y(){switch(s.getToken()){case 3:return q();case 1:return O();case 10:return me(!0);default:return G()}}return ue(),s.getToken()===17?i.allowEmptyContent?!0:(le(4,[],[]),!1):Y()?(s.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=E;function S(t,c){const i=C(t),s=[];let o,l=0,r;do switch(r=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:l!==r&&s.push(t.substring(l,r)),c!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,c)),l=i.getPosition();break}while(o!==17);return s.join("")}e.stripComments=S;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(Z[128],ee([0,1,43]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function M(d,w,v){let b,u,y,p,a;if(w){for(p=w.offset,a=p+w.length,y=p;y>0&&!m(d,y-1);)y--;let r=a;for(;r<d.length&&!m(d,r);)r++;u=d.substring(y,r),b=C(u,v)}else u=d,b=0,y=0,p=0,a=d.length;const g=k(v,d);let f=!1,E=0,S;v.insertSpaces?S=R(" ",v.tabSize||4):S="	";const D=(0,I.createScanner)(u,!1);let t=!1;function c(){return g+R(S,b+E)}function i(){let r=D.scan();for(f=!1;r===15||r===14;)f=f||r===14,r=D.scan();return t=r===16||D.getTokenError()!==0,r}const s=[];function o(r,h,P){!t&&h<a&&P>p&&d.substring(h,P)!==r&&s.push({offset:h,length:P-h,content:r})}let l=i();if(l!==17){const r=D.getTokenOffset()+y,h=R(S,b);o(h,y,r)}for(;l!==17;){let r=D.getTokenOffset()+D.getTokenLength()+y,h=i(),P="";for(;!f&&(h===12||h===13);){const T=D.getTokenOffset()+y;o(" ",r,T),r=D.getTokenOffset()+D.getTokenLength()+y,P=h===12?c():"",h=i()}if(h===2)l!==1&&(E--,P=c());else if(h===4)l!==3&&(E--,P=c());else{switch(l){case 3:case 1:E++,P=c();break;case 5:case 12:P=c();break;case 13:f?P=c():P=" ";break;case 6:P=" ";break;case 10:if(h===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?P=" ":h!==5&&h!==17&&(t=!0);break;case 16:t=!0;break}f&&(h===12||h===13)&&(P=c())}const A=D.getTokenOffset()+y;o(P,r,A),l=h}return s}e.format=M;function n(d,w){const v=JSON.stringify(d,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?v.replace(/\r\n|\r|\n/g,w.eol):v}e.toFormattedString=n;function R(d,w){let v="";for(let b=0;b<w;b++)v+=d;return v}function C(d,w){let v=0,b=0;const u=w.tabSize||4;for(;v<d.length;){const y=d.charAt(v);if(y===" ")b++;else if(y==="	")b+=u;else break;v++}return Math.floor(b/u)}function k(d,w){for(let v=0;v<w.length;v++){const b=w.charAt(v);if(b==="\r")return v+1<w.length&&w.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=k;function m(d,w){return`\r
`.indexOf(d.charAt(w))!==-1}e.isEOL=m}),define(Z[129],ee([0,1,43,128]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(d,w,v){return R(d,w,void 0,v)}e.removeProperty=n;function R(d,w,v,b,u){const y=w.slice(),p=[],a=(0,I.parseTree)(d,p);let g,f;for(;y.length>0&&(f=y.pop(),g=(0,I.findNodeAtLocation)(a,y),g===void 0&&v!==void 0);)typeof f=="string"?v={[f]:v}:v=[v];if(g)if(g.type==="object"&&typeof f=="string"&&Array.isArray(g.children)){const E=(0,I.findNodeAtLocation)(g,[f]);if(E!==void 0)if(v===void 0){if(!E.parent)throw new Error("Malformed AST");const S=g.children.indexOf(E.parent);let D,t=E.parent.offset+E.parent.length;if(S>0){const c=g.children[S-1];D=c.offset+c.length}else D=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return C(d,{offset:D,length:t-D,content:""},b)}else return C(d,{offset:E.offset,length:E.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const S=`${JSON.stringify(f)}: ${JSON.stringify(v)}`,D=u?u(g.children.map(c=>c.children[0].value)):g.children.length;let t;if(D>0){const c=g.children[D-1];t={offset:c.offset+c.length,length:0,content:","+S}}else g.children.length===0?t={offset:g.offset+1,length:0,content:S}:t={offset:g.offset+1,length:0,content:S+","};return C(d,t,b)}}else if(g.type==="array"&&typeof f=="number"&&Array.isArray(g.children))if(v!==void 0){const E=`${JSON.stringify(v)}`;let S;if(g.children.length===0||f===0)S={offset:g.offset+1,length:0,content:g.children.length===0?E:E+","};else{const D=f===-1||f>g.children.length?g.children.length:f,t=g.children[D-1];S={offset:t.offset+t.length,length:0,content:","+E}}return C(d,S,b)}else{const E=f,S=g.children[E];let D;if(g.children.length===1)D={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===E){const t=g.children[E-1],c=t.offset+t.length,i=g.offset+g.length;D={offset:c,length:i-2-c,content:""}}else D={offset:S.offset,length:g.children[E+1].offset-S.offset,content:""};return C(d,D,b)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${g.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return C(d,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(v)},b)}}e.setProperty=R;function C(d,w,v){let b=k(d,w),u=w.offset,y=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;u>0&&!(0,M.isEOL)(b,u-1);)u--;for(;y<b.length&&!(0,M.isEOL)(b,y);)y++}const p=(0,M.format)(b,{offset:u,length:y-u},v);for(let g=p.length-1;g>=0;g--){const f=p[g];b=k(b,f),u=Math.min(u,f.offset),y=Math.max(y,f.offset+f.length),y+=f.content.length-f.length}const a=d.length-(b.length-y)-u;return[{offset:u,length:a,content:b.substring(u,y)}]}e.withFormatting=C;function k(d,w){return d.substring(0,w.offset)+w.content+d.substring(w.offset+w.length)}e.applyEdit=k;function m(d,w){const v=w.slice(0).sort((u,y)=>{const p=u.offset-y.offset;return p===0?u.length-y.length:p});let b=d.length;for(let u=v.length-1;u>=0;u--){const y=v[u];if(y.offset+y.length<=b)d=k(d,y);else throw new Error("Overlapping edit");b=y.offset}return d}e.applyEdits=m}),define(Z[130],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=I}),define(Z[2],ee([0,1,50,70]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let R=null;function C(l){R=l}if(e.setDisposableTracker=C,n){const l="__is_disposable_tracked__";C(new class{trackDisposable(r){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[l]||console.log(h)},3e3)}setParent(r,h){if(r&&r!==f.None)try{r[l]=!0}catch{}}markAsDisposed(r){if(r&&r!==f.None)try{r[l]=!0}catch{}}markAsSingleton(r){}})}function k(l){return R?.trackDisposable(l),l}function m(l){R?.markAsDisposed(l)}function d(l,r){R?.setParent(l,r)}function w(l,r){if(!!R)for(const h of l)R.setParent(h,r)}function v(l){return R?.markAsSingleton(l),l}e.markAsSingleton=v;function b(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=b;function u(l){if(M.Iterable.is(l)){const r=[];for(const h of l)if(h)try{h.dispose()}catch(P){r.push(P)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=u;function y(l){for(const r of l)b(r)&&r.dispose();return[]}e.disposeIfDisposable=y;function p(...l){const r=a(()=>u(l));return w(l,r),r}e.combinedDisposable=p;function a(l){const r=k({dispose:(0,I.once)(()=>{m(r),l()})});return r}e.toDisposable=a;class g{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(m(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{u(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return d(r,this),this.f?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}g.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=g;class f{constructor(){this.q=new g,k(this),d(this.q,this)}dispose(){m(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class E{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&d(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&d(r,null),r}}e.MutableDisposable=E;class S{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(r){let h=r;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,m(this))},this}}e.SafeDisposable=D;class t{constructor(){this.a=new Map}acquire(r,...h){let P=this.a.get(r);P||(P={counter:0,object:this.b(r,...h)},this.a.set(r,P));const{object:A}=P,T=(0,I.once)(()=>{--P.counter===0&&(this.c(r,P.object),this.a.delete(r))});return P.counter++,{object:A,dispose:T}}}e.ReferenceCollection=t;class c{constructor(r){this.a=r}async acquire(r,...h){const P=this.a.acquire(r,...h);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(A){throw P.dispose(),A}}}e.AsyncReferenceCollection=c;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function s(l){const r=new g;try{l(r)}finally{r.dispose()}}e.disposeOnReturn=s;class o{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,h,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(r)?.dispose(),this.a.set(r,h)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(Z[99],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class M{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let R=this.a;for(;R!==I.Undefined;){const C=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=C}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const k=new I(R);if(this.a===I.Undefined)this.a=k,this.b=k;else if(C){const d=this.b;this.b=k,k.prev=d,d.next=k}else{const d=this.a;this.a=k,k.next=d,d.prev=k}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(k))}}shift(){if(this.a!==I.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==I.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===I.Undefined&&R.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):R.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):R.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.LinkedList=M}),define(Z[35],ee([0,1]),function(x,e){"use strict";var I,M,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(y,p,a){let g=y.get(p);return g===void 0&&(g=a,y.set(p,g)),g}e.getOrSet=R;function C(y){const p=[];return y.forEach((a,g)=>{p.push(`${g} => ${a}`)}),`Map(${y.size}) {${p.join(", ")}}`}e.mapToString=C;function k(y){const p=[];return y.forEach(a=>{p.push(a)}),`Set(${y.size}) {${p.join(", ")}}`}e.setToString=k;class m{constructor(p,a){this.uri=p,this.value=a}}class d{constructor(p,a){this[I]="ResourceMap",p instanceof d?(this.b=new Map(p.b),this.c=a??d.a):(this.b=new Map,this.c=p??d.a)}set(p,a){return this.b.set(this.c(p),new m(p,a)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,a){typeof a<"u"&&(p=p.bind(a));for(const[g,f]of this.b)p(f.value,f.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}d.a=y=>y.toString(),e.ResourceMap=d;class w{constructor(p,a){this[M]="ResourceSet",!p||typeof p=="function"?this.a=new d(p):(this.a=new d(a),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,a){this.a.forEach((g,f)=>p.call(a,f,f,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var v;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class b{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,a=0){const g=this.a.get(p);if(!!g)return a!==0&&this.j(g,a),g.value}set(p,a,g=0){let f=this.a.get(p);if(f)f.value=a,g!==0&&this.j(f,g);else{switch(f={key:p,value:a,next:void 0,previous:void 0},g){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(p,f),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const a=this.a.get(p);if(!!a)return this.a.delete(p),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,a){const g=this.e;let f=this.b;for(;f;){if(a?p.bind(a)(f.value,f.key,this):p(f.value,f.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const p=this,a=this.e;let g=this.b;const f={[Symbol.iterator](){return f},next(){if(p.e!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const E={value:g.key,done:!1};return g=g.next,E}else return{value:void 0,done:!0}}};return f}values(){const p=this,a=this.e;let g=this.b;const f={[Symbol.iterator](){return f},next(){if(p.e!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const E={value:g.value,done:!1};return g=g.next,E}else return{value:void 0,done:!0}}};return f}entries(){const p=this,a=this.e;let g=this.b;const f={[Symbol.iterator](){return f},next(){if(p.e!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const E={value:[g.key,g.value],done:!1};return g=g.next,E}else return{value:void 0,done:!0}}};return f}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let a=this.b,g=this.size;for(;a&&g>p;)this.a.delete(a.key),a=a.next,g--;this.b=a,this.d=g,a&&(a.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const a=p.next,g=p.previous;if(!a||!g)throw new Error("Invalid list");a.previous=g,g.next=a}p.next=void 0,p.previous=void 0,this.e++}j(p,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(p===this.b)return;const g=p.next,f=p.previous;p===this.c?(f.next=void 0,this.c=f):(g.previous=f,f.next=g),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(a===2){if(p===this.c)return;const g=p.next,f=p.previous;p===this.b?(g.previous=void 0,this.b=g):(g.previous=f,f.next=g),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((a,g)=>{p.push([g,a])}),p}fromJSON(p){this.clear();for(const[a,g]of p)this.set(a,g)}}e.LinkedMap=b;class u extends b{constructor(p,a=1){super(),this.k=p,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,a=2){return super.get(p,a)}peek(p){return super.get(p,0)}set(p,a){return super.set(p,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=u}),define(Z[80],ee([0,1,35]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new I.LRUCache(1e4);function n(d){return m(d,"NFC",M)}e.normalizeNFC=n;const R=new I.LRUCache(1e4);function C(d){return m(d,"NFD",R)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function m(d,w,v){if(!d)return d;const b=v.get(d);if(b)return b;let u;return k.test(d)?u=d.normalize(w):u=d,v.set(d,u),u}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(w){return C(w).replace(d,"")}}()}),define(Z[131],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function I(k,m,d){return Math.min(Math.max(k,m),d)}e.clamp=I;function M(k,m){return(m+k%m)%m}e.rot=M;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class R{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class C{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const d=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function x(n){const R=[];typeof n=="number"&&R.push("code/timeOrigin",n);function C(m){R.push(m,Date.now())}function k(){const m=[];for(let d=0;d<R.length;d+=2)m.push({name:R[d],startTime:R[d+1]});return m}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(n+C.startTime)});return R}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function I(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=I(M))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var M in I)(typeof exports=="object"?exports:x)[M]=I[M]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function I(M){if(e[M])return e[M].exports;var n=e[M]={i:M,l:!1,exports:{}};return x[M].call(n.exports,n,n.exports,I),n.l=!0,n.exports}return I.m=x,I.c=e,I.d=function(M,n,R){I.o(M,n)||Object.defineProperty(M,n,{enumerable:!0,get:R})},I.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},I.t=function(M,n){if(1&n&&(M=I(M)),8&n||4&n&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&n&&typeof M!="string")for(var C in M)I.d(R,C,function(k){return M[k]}.bind(null,C));return R},I.n=function(M){var n=M&&M.__esModule?function(){return M.default}:function(){return M};return I.d(n,"a",n),n},I.o=function(M,n){return Object.prototype.hasOwnProperty.call(M,n)},I.p="",I(I.s=0)}([function(x,e,I){(function(M){var n;e=x.exports=L,n=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],m=e.src=[],d=0,w=d++;m[w]="0|[1-9]\\d*";var v=d++;m[v]="[0-9]+";var b=d++;m[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=d++;m[u]="("+m[w]+")\\.("+m[w]+")\\.("+m[w]+")";var y=d++;m[y]="("+m[v]+")\\.("+m[v]+")\\.("+m[v]+")";var p=d++;m[p]="(?:"+m[w]+"|"+m[b]+")";var a=d++;m[a]="(?:"+m[v]+"|"+m[b]+")";var g=d++;m[g]="(?:-("+m[p]+"(?:\\."+m[p]+")*))";var f=d++;m[f]="(?:-?("+m[a]+"(?:\\."+m[a]+")*))";var E=d++;m[E]="[0-9A-Za-z-]+";var S=d++;m[S]="(?:\\+("+m[E]+"(?:\\."+m[E]+")*))";var D=d++,t="v?"+m[u]+m[g]+"?"+m[S]+"?";m[D]="^"+t+"$";var c="[v=\\s]*"+m[y]+m[f]+"?"+m[S]+"?",i=d++;m[i]="^"+c+"$";var s=d++;m[s]="((?:<|>)?=?)";var o=d++;m[o]=m[v]+"|x|X|\\*";var l=d++;m[l]=m[w]+"|x|X|\\*";var r=d++;m[r]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[g]+")?"+m[S]+"?)?)?";var h=d++;m[h]="[v=\\s]*("+m[o]+")(?:\\.("+m[o]+")(?:\\.("+m[o]+")(?:"+m[f]+")?"+m[S]+"?)?)?";var P=d++;m[P]="^"+m[s]+"\\s*"+m[r]+"$";var A=d++;m[A]="^"+m[s]+"\\s*"+m[h]+"$";var T=d++;m[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=d++;m[N]="(?:~>?)";var z=d++;m[z]="(\\s*)"+m[N]+"\\s+",k[z]=new RegExp(m[z],"g");var H=d++;m[H]="^"+m[N]+m[r]+"$";var ie=d++;m[ie]="^"+m[N]+m[h]+"$";var se=d++;m[se]="(?:\\^)";var oe=d++;m[oe]="(\\s*)"+m[se]+"\\s+",k[oe]=new RegExp(m[oe],"g");var ue=d++;m[ue]="^"+m[se]+m[r]+"$";var le=d++;m[le]="^"+m[se]+m[h]+"$";var me=d++;m[me]="^"+m[s]+"\\s*("+c+")$|^$";var G=d++;m[G]="^"+m[s]+"\\s*("+t+")$|^$";var B=d++;m[B]="(\\s*)"+m[s]+"\\s*("+c+"|"+m[r]+")",k[B]=new RegExp(m[B],"g");var O=d++;m[O]="^\\s*("+m[r]+")\\s+-\\s+("+m[r]+")\\s*$";var q=d++;m[q]="^\\s*("+m[h]+")\\s+-\\s+("+m[h]+")\\s*$";var Y=d++;m[Y]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)n(te,m[te]),k[te]||(k[te]=new RegExp(m[te]));function ne(_,ce){if(_ instanceof L)return _;if(typeof _!="string"||_.length>R||!(ce?k[i]:k[D]).test(_))return null;try{return new L(_,ce)}catch{return null}}function L(_,ce){if(_ instanceof L){if(_.loose===ce)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(_,ce);n("SemVer",_,ce),this.loose=ce;var he=_.trim().match(ce?k[i]:k[D]);if(!he)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Ae=+Ie;if(Ae>=0&&Ae<C)return Ae}return Ie}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=ne,e.valid=function(_,ce){var he=ne(_,ce);return he?he.version:null},e.clean=function(_,ce){var he=ne(_.trim().replace(/^[=v]+/,""),ce);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(_){return n("SemVer.compare",this.version,this.loose,_),_ instanceof L||(_=new L(_,this.loose)),this.compareMain(_)||this.comparePre(_)},L.prototype.compareMain=function(_){return _ instanceof L||(_=new L(_,this.loose)),W(this.major,_.major)||W(this.minor,_.minor)||W(this.patch,_.patch)},L.prototype.comparePre=function(_){if(_ instanceof L||(_=new L(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ce=0;do{var he=this.prerelease[ce],Ie=_.prerelease[ce];if(n("prerelease compare",ce,he,Ie),he===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(he===void 0)return-1;if(he!==Ie)return W(he,Ie)}while(++ce)},L.prototype.inc=function(_,ce){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ce,he,Ie){typeof he=="string"&&(Ie=he,he=void 0);try{return new L(_,he).inc(ce,Ie).version}catch{return null}},e.diff=function(_,ce){if(j(_,ce))return null;var he=ne(_),Ie=ne(ce);if(he.prerelease.length||Ie.prerelease.length){for(var Ae in he)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&he[Ae]!==Ie[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in he)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&he[Ae]!==Ie[Ae])return Ae},e.compareIdentifiers=W;var F=/^[0-9]+$/;function W(_,ce){var he=F.test(_),Ie=F.test(ce);return he&&Ie&&(_=+_,ce=+ce),he&&!Ie?-1:Ie&&!he?1:_<ce?-1:_>ce?1:0}function U(_,ce,he){return new L(_,he).compare(new L(ce,he))}function $(_,ce,he){return U(_,ce,he)>0}function V(_,ce,he){return U(_,ce,he)<0}function j(_,ce,he){return U(_,ce,he)===0}function K(_,ce,he){return U(_,ce,he)!==0}function J(_,ce,he){return U(_,ce,he)>=0}function re(_,ce,he){return U(_,ce,he)<=0}function de(_,ce,he,Ie){var Ae;switch(ce){case"===":typeof _=="object"&&(_=_.version),typeof he=="object"&&(he=he.version),Ae=_===he;break;case"!==":typeof _=="object"&&(_=_.version),typeof he=="object"&&(he=he.version),Ae=_!==he;break;case"":case"=":case"==":Ae=j(_,he,Ie);break;case"!=":Ae=K(_,he,Ie);break;case">":Ae=$(_,he,Ie);break;case">=":Ae=J(_,he,Ie);break;case"<":Ae=V(_,he,Ie);break;case"<=":Ae=re(_,he,Ie);break;default:throw new TypeError("Invalid operator: "+ce)}return Ae}function Ce(_,ce){if(_ instanceof Ce){if(_.loose===ce)return _;_=_.value}if(!(this instanceof Ce))return new Ce(_,ce);n("comparator",_,ce),this.loose=ce,this.parse(_),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(_,ce){return W(ce,_)},e.major=function(_,ce){return new L(_,ce).major},e.minor=function(_,ce){return new L(_,ce).minor},e.patch=function(_,ce){return new L(_,ce).patch},e.compare=U,e.compareLoose=function(_,ce){return U(_,ce,!0)},e.rcompare=function(_,ce,he){return U(ce,_,he)},e.sort=function(_,ce){return _.sort(function(he,Ie){return e.compare(he,Ie,ce)})},e.rsort=function(_,ce){return _.sort(function(he,Ie){return e.rcompare(he,Ie,ce)})},e.gt=$,e.lt=V,e.eq=j,e.neq=K,e.gte=J,e.lte=re,e.cmp=de,e.Comparator=Ce;var Re={};function De(_,ce){if(_ instanceof De)return _.loose===ce?_:new De(_.raw,ce);if(_ instanceof Ce)return new De(_.value,ce);if(!(this instanceof De))return new De(_,ce);if(this.loose=ce,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Oe(_){return!_||_.toLowerCase()==="x"||_==="*"}function $e(_,ce,he,Ie,Ae,Te,Fe,je,ze,We,He,X,ae){return((ce=Oe(he)?"":Oe(Ie)?">="+he+".0.0":Oe(Ae)?">="+he+"."+Ie+".0":">="+ce)+" "+(je=Oe(ze)?"":Oe(We)?"<"+(+ze+1)+".0.0":Oe(He)?"<"+ze+"."+(+We+1)+".0":X?"<="+ze+"."+We+"."+He+"-"+X:"<="+je)).trim()}function fe(_,ce){for(var he=0;he<_.length;he++)if(!_[he].test(ce))return!1;if(ce.prerelease.length){for(he=0;he<_.length;he++)if(n(_[he].semver),_[he].semver!==Re&&_[he].semver.prerelease.length>0){var Ie=_[he].semver;if(Ie.major===ce.major&&Ie.minor===ce.minor&&Ie.patch===ce.patch)return!0}return!1}return!0}function pe(_,ce,he){try{ce=new De(ce,he)}catch{return!1}return ce.test(_)}function Me(_,ce,he,Ie){var Ae,Te,Fe,je,ze;switch(_=new L(_,Ie),ce=new De(ce,Ie),he){case">":Ae=$,Te=re,Fe=V,je=">",ze=">=";break;case"<":Ae=V,Te=J,Fe=$,je="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(_,ce,Ie))return!1;for(var We=0;We<ce.set.length;++We){var He=ce.set[We],X=null,ae=null;if(He.forEach(function(ge){ge.semver===Re&&(ge=new Ce(">=0.0.0")),X=X||ge,ae=ae||ge,Ae(ge.semver,X.semver,Ie)?X=ge:Fe(ge.semver,ae.semver,Ie)&&(ae=ge)}),X.operator===je||X.operator===ze||(!ae.operator||ae.operator===je)&&Te(_,ae.semver)||ae.operator===ze&&Fe(_,ae.semver))return!1}return!0}Ce.prototype.parse=function(_){var ce=this.loose?k[me]:k[G],he=_.match(ce);if(!he)throw new TypeError("Invalid comparator: "+_);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Re},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(_){return n("Comparator.test",_,this.loose),this.semver===Re||(typeof _=="string"&&(_=new L(_,this.loose)),de(_,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(_,ce){if(!(_ instanceof Ce))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new De(_.value,ce),pe(this.value,he,ce);if(_.operator==="")return he=new De(this.value,ce),pe(_.semver,he,ce);var Ie=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Te=this.semver.version===_.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),je=de(this.semver,"<",_.semver,ce)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=de(this.semver,">",_.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Ie||Ae||Te&&Fe||je||ze},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(_){var ce=this.loose;_=_.trim(),n("range",_,ce);var he=ce?k[q]:k[O];_=_.replace(he,$e),n("hyphen replace",_),_=_.replace(k[B],"$1$2$3"),n("comparator trim",_,k[B]),_=(_=(_=_.replace(k[z],"$1~")).replace(k[oe],"$1^")).split(/\s+/).join(" ");var Ie=ce?k[me]:k[G],Ae=_.split(" ").map(function(Te){return function(Fe,je){return n("comp",Fe),Fe=function(ze,We){return ze.trim().split(/\s+/).map(function(He){return function(X,ae){n("caret",X,ae);var ge=ae?k[le]:k[ue];return X.replace(ge,function(be,we,Le,Ue,Ve){var Ge;return n("caret",X,be,we,Le,Ue,Ve),Oe(we)?Ge="":Oe(Le)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=we==="0"?">="+we+"."+Le+".0 <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+".0 <"+(+we+1)+".0.0":Ve?(n("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=we==="0"?Le==="0"?">="+we+"."+Le+"."+Ue+Ve+" <"+we+"."+Le+"."+(+Ue+1):">="+we+"."+Le+"."+Ue+Ve+" <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+"."+Ue+Ve+" <"+(+we+1)+".0.0"):(n("no pr"),Ge=we==="0"?Le==="0"?">="+we+"."+Le+"."+Ue+" <"+we+"."+Le+"."+(+Ue+1):">="+we+"."+Le+"."+Ue+" <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+"."+Ue+" <"+(+we+1)+".0.0"),n("caret return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),n("caret",Fe),Fe=function(ze,We){return ze.trim().split(/\s+/).map(function(He){return function(X,ae){var ge=ae?k[ie]:k[H];return X.replace(ge,function(be,we,Le,Ue,Ve){var Ge;return n("tilde",X,be,we,Le,Ue,Ve),Oe(we)?Ge="":Oe(Le)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=">="+we+"."+Le+".0 <"+we+"."+(+Le+1)+".0":Ve?(n("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+we+"."+Le+"."+Ue+Ve+" <"+we+"."+(+Le+1)+".0"):Ge=">="+we+"."+Le+"."+Ue+" <"+we+"."+(+Le+1)+".0",n("tilde return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),n("tildes",Fe),Fe=function(ze,We){return n("replaceXRanges",ze,We),ze.split(/\s+/).map(function(He){return function(X,ae){X=X.trim();var ge=ae?k[A]:k[P];return X.replace(ge,function(be,we,Le,Ue,Ve,Ge){n("xRange",X,be,we,Le,Ue,Ve,Ge);var Ke=Oe(Le),Ye=Ke||Oe(Ue),Ze=Ye||Oe(Ve);return we==="="&&Ze&&(we=""),Ke?be=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(Ue=0),Ze&&(Ve=0),we===">"?(we=">=",Ye?(Le=+Le+1,Ue=0,Ve=0):Ze&&(Ue=+Ue+1,Ve=0)):we==="<="&&(we="<",Ye?Le=+Le+1:Ue=+Ue+1),be=we+Le+"."+Ue+"."+Ve):Ye?be=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ze&&(be=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0"),n("xRange return",be),be})}(He,We)}).join(" ")}(Fe,je),n("xrange",Fe),Fe=function(ze,We){return n("replaceStars",ze,We),ze.trim().replace(k[Y],"")}(Fe,je),n("stars",Fe),Fe}(Te,ce)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Te){return!!Te.match(Ie)})),Ae=Ae.map(function(Te){return new Ce(Te,ce)})},De.prototype.intersects=function(_,ce){if(!(_ instanceof De))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ie){return _.set.some(function(Ae){return Ae.every(function(Te){return Ie.intersects(Te,ce)})})})})},e.toComparators=function(_,ce){return new De(_,ce).set.map(function(he){return he.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},De.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new L(_,this.loose));for(var ce=0;ce<this.set.length;ce++)if(fe(this.set[ce],_))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(_,ce,he){var Ie=null,Ae=null;try{var Te=new De(ce,he)}catch{return null}return _.forEach(function(Fe){Te.test(Fe)&&(Ie&&Ae.compare(Fe)!==-1||(Ae=new L(Ie=Fe,he)))}),Ie},e.minSatisfying=function(_,ce,he){var Ie=null,Ae=null;try{var Te=new De(ce,he)}catch{return null}return _.forEach(function(Fe){Te.test(Fe)&&(Ie&&Ae.compare(Fe)!==1||(Ae=new L(Ie=Fe,he)))}),Ie},e.validRange=function(_,ce){try{return new De(_,ce).range||"*"}catch{return null}},e.ltr=function(_,ce,he){return Me(_,ce,"<",he)},e.gtr=function(_,ce,he){return Me(_,ce,">",he)},e.outside=Me,e.prerelease=function(_,ce){var he=ne(_,ce);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(_,ce,he){return _=new De(_,he),ce=new De(ce,he),_.intersects(ce)},e.coerce=function(_){if(_ instanceof L)return _;if(typeof _!="string")return null;var ce=_.match(k[T]);return ce==null?null:ne((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,I(1))},function(x,e){var I,M,n=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(a){if(I===setTimeout)return setTimeout(a,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(a,0);try{return I(a,0)}catch{try{return I.call(null,a,0)}catch{return I.call(this,a,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{M=typeof clearTimeout=="function"?clearTimeout:C}catch{M=C}})();var m,d=[],w=!1,v=-1;function b(){w&&m&&(w=!1,m.length?d=m.concat(d):v=-1,d.length&&u())}function u(){if(!w){var a=k(b);w=!0;for(var g=d.length;g;){for(m=d,d=[];++v<g;)m&&m[v].run();v=-1,g=d.length}m=null,w=!1,function(f){if(M===clearTimeout)return clearTimeout(f);if((M===C||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(f);try{M(f)}catch{try{return M.call(null,f)}catch{return M.call(this,f)}}}(a)}}function y(a,g){this.fun=a,this.array=g}function p(){}n.nextTick=function(a){var g=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)g[f-1]=arguments[f];d.push(new y(a,g)),d.length!==1||w||k(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=p,n.addListener=p,n.once=p,n.off=p,n.removeListener=p,n.removeAllListeners=p,n.emit=p,n.prependListener=p,n.prependOnceListener=p,n.listeners=function(a){return[]},n.binding=function(a){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(a){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(Z[132],ee([0,1]),function(x,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,m,d){this.level=k,this.key=m,this.value=d,this.forward=[]}}const n=void 0;class R{constructor(k,m=2**16){this.comparator=k,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(m)|0),this.e=new M(this.c,n,n)}get size(){return this.f}clear(){this.e=new M(this.c,n,n)}has(k){return Boolean(R.g(this,k,this.comparator))}get(k){return R.g(this,k,this.comparator)?.value}set(k,m){return R.h(this,k,m,this.comparator)&&(this.f+=1),this}delete(k){const m=R.k(this,k,this.comparator);return m&&(this.f-=1),m}forEach(k,m){let d=this.e.forward[0];for(;d;)k.call(m,d.value,d.key,this),d=d.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",m=this.e.forward[0];for(;m;)k+=`node(${m.key}, ${m.value}, lvl:${m.level})`,m=m.forward[0];return k}static g(k,m,d){let w=k.e;for(let v=k.d-1;v>=0;v--)for(;w.forward[v]&&d(w.forward[v].key,m)<0;)w=w.forward[v];if(w=w.forward[0],w&&d(w.key,m)===0)return w}static h(k,m,d,w){const v=[];let b=k.e;for(let u=k.d-1;u>=0;u--){for(;b.forward[u]&&w(b.forward[u].key,m)<0;)b=b.forward[u];v[u]=b}if(b=b.forward[0],b&&w(b.key,m)===0)return b.value=d,!1;{const u=R.j(k);if(u>k.d){for(let y=k.d;y<u;y++)v[y]=k.e;k.d=u}b=new M(u,m,d);for(let y=0;y<u;y++)b.forward[y]=v[y].forward[y],v[y].forward[y]=b;return!0}}static j(k,m=.5){let d=1;for(;Math.random()<m&&d<k.c;)d+=1;return d}static k(k,m,d){const w=[];let v=k.e;for(let b=k.d-1;b>=0;b--){for(;v.forward[b]&&d(v.forward[b].key,m)<0;)v=v.forward[b];w[b]=v}if(v=v.forward[0],!v||d(v.key,m)!==0)return!1;for(let b=0;b<k.d&&w[b].forward[b]===v;b++)w[b].forward[b]=v.forward[b];for(;k.d>0&&k.e.forward[k.d-1]===n;)k.d-=1;return!0}}e.SkipList=R}),define(Z[59],ee([0,1,13,2]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(S){const D=S;return D?typeof D.read=="function":!1}e.isReadable=n;function R(S){const D=S;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function C(S){const D=S;return D?R(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(S,D){return new m(S,D)}e.newWriteableStream=k;class m{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,I.onUnexpectedError)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let c;switch(D){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(S,D){const t=[];let c;for(;(c=S.read())!==null;)t.push(c);return D(t)}e.consumeReadable=d;function w(S,D,t){const c=[];let i;for(;(i=S.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?D(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return S.read()}}}e.peekReadable=w;function v(S,D){return new Promise((t,c)=>{const i=[];b(S,{onData:s=>{D&&i.push(s)},onError:s=>{D?c(s):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=v;function b(S,D){let t=!1;return S.on("error",c=>{t||D.onError(c)}),S.on("end",()=>{t||D.onEnd()}),S.on("data",c=>{t||D.onData(c)}),(0,M.toDisposable)(()=>t=!0)}e.listenStream=b;function u(S,D){return new Promise((t,c)=>{const i=new M.DisposableStore,s=[],o=h=>{if(s.push(h),s.length>D)return i.dispose(),S.pause(),t({stream:S,buffer:s,ended:!1})},l=h=>c(h),r=()=>t({stream:S,buffer:s,ended:!0});i.add((0,M.toDisposable)(()=>S.removeListener("error",l))),S.on("error",l),i.add((0,M.toDisposable)(()=>S.removeListener("end",r))),S.on("end",r),i.add((0,M.toDisposable)(()=>S.removeListener("data",o))),S.on("data",o)})}e.peekStream=u;function y(S,D){const t=k(D);return t.end(S),t}e.toStream=y;function p(){const S=k(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=p;function a(S){let D=!1;return{read:()=>D?null:(D=!0,S)}}e.toReadable=a;function g(S,D,t){const c=k(t);return b(S,{onData:i=>c.write(D.data(i)),onError:i=>c.error(D.error?D.error(i):i),onEnd:()=>c.end()}),c}e.transform=g;function f(S,D,t){let c=!1;return{read:()=>{const i=D.read();return c?i:(c=!0,i!==null?t([S,i]):S)}}}e.prefixedReadable=f;function E(S,D,t){let c=!1;const i=k(t);return b(D,{onData:s=>c?i.write(s):(c=!0,i.write(t([S,s]))),onError:s=>i.error(s),onEnd:()=>{c||(c=!0,i.write(S)),i.end()}}),i}e.prefixedStream=E}),define(Z[17],ee([0,1,59]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer<"u";let n,R;class C{static alloc(h){return M?new C(Buffer.allocUnsafe(h)):new C(new Uint8Array(h))}static wrap(h){return M&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new C(h)}static fromString(h,P){return!(P?.dontUseNodeBuffer||!1)&&M?new C(Buffer.from(h)):(n||(n=new TextEncoder),new C(n.encode(h)))}static fromByteArray(h){const P=C.alloc(h.length);for(let A=0,T=h.length;A<T;A++)P.buffer[A]=h[A];return P}static concat(h,P){if(typeof P>"u"){P=0;for(let N=0,z=h.length;N<z;N++)P+=h[N].byteLength}const A=C.alloc(P);let T=0;for(let N=0,z=h.length;N<z;N++){const H=h[N];A.set(H,T),T+=H.byteLength}return A}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=C.alloc(this.byteLength);return h.set(this),h}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(h,P){return new C(this.buffer.subarray(h,P))}set(h,P){if(h instanceof C)this.buffer.set(h.buffer,P);else if(h instanceof Uint8Array)this.buffer.set(h,P);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),P);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return d(this.buffer,h)}writeUInt32BE(h,P){w(this.buffer,h,P)}readUInt32LE(h){return v(this.buffer,h)}writeUInt32LE(h,P){b(this.buffer,h,P)}readUInt8(h){return u(this.buffer,h)}writeUInt8(h,P){y(this.buffer,h,P)}}e.VSBuffer=C;function k(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0}e.readUInt16LE=k;function m(r,h,P){r[P+0]=h&255,h=h>>>8,r[P+1]=h&255}e.writeUInt16LE=m;function d(r,h){return r[h]*2**24+r[h+1]*2**16+r[h+2]*2**8+r[h+3]}e.readUInt32BE=d;function w(r,h,P){r[P+3]=h,h=h>>>8,r[P+2]=h,h=h>>>8,r[P+1]=h,h=h>>>8,r[P]=h}e.writeUInt32BE=w;function v(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0|r[h+2]<<16>>>0|r[h+3]<<24>>>0}e.readUInt32LE=v;function b(r,h,P){r[P+0]=h&255,h=h>>>8,r[P+1]=h&255,h=h>>>8,r[P+2]=h&255,h=h>>>8,r[P+3]=h&255}e.writeUInt32LE=b;function u(r,h){return r[h]}e.readUInt8=u;function y(r,h,P){r[P]=h}e.writeUInt8=y;function p(r){return I.consumeReadable(r,h=>C.concat(h))}e.readableToBuffer=p;function a(r){return I.toReadable(r)}e.bufferToReadable=a;function g(r){return I.consumeStream(r,h=>C.concat(h))}e.streamToBuffer=g;async function f(r){return r.ended?C.concat(r.buffer):C.concat([...r.buffer,await g(r.stream)])}e.bufferedStreamToBuffer=f;function E(r){return I.toStream(r,h=>C.concat(h))}e.bufferToStream=E;function S(r){return I.transform(r,{data:h=>typeof h=="string"?C.fromString(h):C.wrap(h)},h=>C.concat(h))}e.streamToBufferReadableStream=S;function D(r){return I.newWriteableStream(h=>C.concat(h),r)}e.newWriteableBufferStream=D;function t(r,h){return I.prefixedReadable(r,h,P=>C.concat(P))}e.prefixedBufferReadable=t;function c(r,h){return I.prefixedStream(r,h,P=>C.concat(P))}e.prefixedBufferStream=c;function i(r){let h=0,P=0,A=0;const T=new Uint8Array(Math.floor(r.length/4*3)),N=H=>{switch(P){case 3:T[A++]=h|H,P=0;break;case 2:T[A++]=h|H>>>2,h=H<<6,P=3;break;case 1:T[A++]=h|H>>>4,h=H<<4,P=2;break;default:h=H<<2,P=1}};for(let H=0;H<r.length;H++){const ie=r.charCodeAt(H);if(ie>=65&&ie<=90)N(ie-65);else if(ie>=97&&ie<=122)N(ie-97+26);else if(ie>=48&&ie<=57)N(ie-48+52);else if(ie===43||ie===45)N(62);else if(ie===47||ie===95)N(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${r[H]}`)}}const z=A;for(;P>0;)N(0);return C.wrap(T).slice(0,z)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:r},h=!0,P=!1){const A=P?o:s;let T="";const N=r.byteLength%3;let z=0;for(;z<r.byteLength-N;z+=3){const H=r[z+0],ie=r[z+1],se=r[z+2];T+=A[H>>>2],T+=A[(H<<4|ie>>>4)&63],T+=A[(ie<<2|se>>>6)&63],T+=A[se&63]}if(N===1){const H=r[z+0];T+=A[H>>>2],T+=A[H<<4&63],h&&(T+="==")}else if(N===2){const H=r[z+0],ie=r[z+1];T+=A[H>>>2],T+=A[(H<<4|ie>>>4)&63],T+=A[ie<<2&63],h&&(T+="=")}return T}e.encodeBase64=l}),define(Z[133],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Z[10],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(c){return typeof c=="string"}e.isString=I;function M(c){return Array.isArray(c)&&c.every(i=>I(i))}e.isStringArray=M;function n(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=n;function R(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=R;function C(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=C;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function m(c){return c===!0||c===!1}e.isBoolean=m;function d(c){return typeof c>"u"}e.isUndefined=d;function w(c){return!v(c)}e.isDefined=w;function v(c){return d(c)||c===null}e.isUndefinedOrNull=v;function b(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=b;function u(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=u;function y(...c){const i=[];for(let s=0;s<c.length;s++){const o=c[s];if(v(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(o)}return i}e.assertAllDefined=y;const p=Object.prototype.hasOwnProperty;function a(c){if(!n(c))return!1;for(const i in c)if(p.call(c,i))return!1;return!0}e.isEmptyObject=a;function g(c){return typeof c=="function"}e.isFunction=g;function f(...c){return c.length>0&&c.every(g)}e.areFunctions=f;function E(c,i){const s=Math.min(c.length,i.length);for(let o=0;o<s;o++)S(c[o],i[o])}e.validateConstraints=E;function S(c,i){if(I(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(c instanceof i)return}catch{}if(!v(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function D(c){return c===null?void 0:c}e.withNullAsUndefined=D;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(Z[134],ee([0,1,10]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const M=Object.create(null);function n(k,m){if((0,I.isString)(m)){const d=M[m];if(d===void 0)throw new Error(`${k} references an unknown codicon: ${m}`);m=d}return M[k]=m,{id:k}}function R(){return M}e.getCodiconFontCharacters=R;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(Z[37],ee([0,1,10]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const f=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([E,S])=>{f[E]=S&&typeof S=="object"?M(S):S}),f}e.deepClone=M;function n(g){if(!g||typeof g!="object")return g;const f=[g];for(;f.length>0;){const E=f.shift();Object.freeze(E);for(const S in E)if(R.call(E,S)){const D=E[S];typeof D=="object"&&!Object.isFrozen(D)&&!(0,I.isTypedArray)(D)&&f.push(D)}}return g}e.deepFreeze=n;const R=Object.prototype.hasOwnProperty;function C(g,f){return k(g,f,new Set)}e.cloneAndChange=C;function k(g,f,E){if((0,I.isUndefinedOrNull)(g))return g;const S=f(g);if(typeof S<"u")return S;if(Array.isArray(g)){const D=[];for(const t of g)D.push(k(t,f,E));return D}if((0,I.isObject)(g)){if(E.has(g))throw new Error("Cannot clone recursive data-structure");E.add(g);const D={};for(const t in g)R.call(g,t)&&(D[t]=k(g[t],f,E));return E.delete(g),D}return g}function m(g,f,E=!0){return(0,I.isObject)(g)?((0,I.isObject)(f)&&Object.keys(f).forEach(S=>{S in g?E&&((0,I.isObject)(g[S])&&(0,I.isObject)(f[S])?m(g[S],f[S],E):g[S]=f[S]):g[S]=f[S]}),g):f}e.mixin=m;function d(g,f){if(g===f)return!0;if(g==null||f===null||f===void 0||typeof g!=typeof f||typeof g!="object"||Array.isArray(g)!==Array.isArray(f))return!1;let E,S;if(Array.isArray(g)){if(g.length!==f.length)return!1;for(E=0;E<g.length;E++)if(!d(g[E],f[E]))return!1}else{const D=[];for(S in g)D.push(S);D.sort();const t=[];for(S in f)t.push(S);if(t.sort(),!d(D,t))return!1;for(E=0;E<D.length;E++)if(!d(g[D[E]],f[D[E]]))return!1}return!0}e.equals=d;function w(g){const f=new Set;return JSON.stringify(g,(E,S)=>{if((0,I.isObject)(S)||Array.isArray(S)){if(f.has(S))return"[Circular]";f.add(S)}return S})}e.safeStringify=w;function v(g,f){const E=Object.create(null);return!g||!f||Object.keys(f).forEach(D=>{const t=g[D],c=f[D];d(t,c)||(E[D]=c)}),E}e.distinct=v;function b(g,f){const E=f.toLowerCase(),S=Object.keys(g).find(D=>D.toLowerCase()===E);return S?g[S]:g[f]}e.getCaseInsensitive=b;function u(g,f){const E=Object.create(null);for(const[S,D]of Object.entries(g))f(S,D)&&(E[S]=D);return E}e.filter=u;function y(g){let f=[],E=Object.getPrototypeOf(g);for(;Object.prototype!==E;)f=f.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return f}e.getAllPropertyNames=y;function p(g){const f=[];for(const E of y(g))typeof g[E]=="function"&&f.push(E);return f}e.getAllMethodNames=p;function a(g,f){const E=D=>function(){const t=Array.prototype.slice.call(arguments,0);return f(D,t)},S={};for(const D of g)S[D]=E(D);return S}e.createProxyObject=a}),define(Z[135],ee([0,1,134]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var M;(function(C){function k(m){return m&&typeof m=="object"&&typeof m.id=="string"}C.isThemeColor=k})(M=e.ThemeColor||(e.ThemeColor={}));function n(C){return{id:C}}e.themeColorFromId=n;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function m(f){const E=k.exec(f.id);if(!E)return m(I.Codicon.error);const[,S,D]=E,t=["codicon","codicon-"+S];return D&&t.push("codicon-modifier-"+D.substring(1)),t}C.asClassNameArray=m;function d(f){return m(f).join(" ")}C.asClassName=d;function w(f){return"."+m(f).join(".")}C.asCSSSelector=w;function v(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||M.isThemeColor(f.color))}C.isThemeIcon=v;const b=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function u(f){const E=b.exec(f);if(!E)return;const[,S]=E;return{id:S}}C.fromString=u;function y(f){return{id:f}}C.fromId=y;function p(f,E){let S=f.id;const D=S.lastIndexOf("~");return D!==-1&&(S=S.substring(0,D)),E&&(S=`${S}~${E}`),{id:S}}C.modify=p;function a(f){const E=f.id.lastIndexOf("~");if(E!==-1)return f.id.substring(E+1)}C.getModifier=a;function g(f,E){return f.id===E.id&&f.color?.id===E.color?.id}C.isEqual=g})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(Z[31],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(n){return I.test(n)}e.isUUID=M,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(k){for(let m=0;m<k.length;m++)k[m]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){n(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,d="";return d+=C[R[m++]],d+=C[R[m++]],d+=C[R[m++]],d+=C[R[m++]],d+="-",d+=C[R[m++]],d+=C[R[m++]],d+="-",d+=C[R[m++]],d+=C[R[m++]],d+="-",d+=C[R[m++]],d+=C[R[m++]],d+="-",d+=C[R[m++]],d+=C[R[m++]],d+=C[R[m++]],d+=C[R[m++]],d+=C[R[m++]],d+=C[R[m++]],d}}()}),define(Z[136],ee([0,1,81,41,50]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(C,k){if(await new Promise((w,v)=>{const b=M.createReadStream(C),u=I.createHash("sha1");b.pipe(u);const y=(0,n.once)((p,a)=>{b.removeAllListeners(),u.removeAllListeners(),p?v(p):w(a)});b.once("error",y),b.once("end",y),u.once("error",y),u.once("data",p=>y(void 0,p.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[137],ee([0,1,26]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(C){const k=C.replace(/\-/g,":").toLowerCase();return!M.has(k)}function R(){const C=(0,I.networkInterfaces)();for(const k in C){const m=C[k];if(m){for(const{mac:d}of m)if(n(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[100],ee([0,1,82]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function M(k,m,d,w=1){let v=!1;return new Promise(b=>{const u=setTimeout(()=>{if(!v)return v=!0,b(0)},d);n(k,m,w,y=>{if(!v)return v=!0,clearTimeout(u),b(y)})})}e.findFreePort=M;function n(k,m,d,w){if(m===0)return w(0);const v=new I.Socket;v.once("connect",()=>(C(v),n(k+d,m-1,d,w))),v.once("data",()=>{}),v.once("error",b=>(C(v),b.code!=="ECONNREFUSED"?n(k+d,m-1,d,w):w(k))),v.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,m,d,w="127.0.0.1"){let v=!1,b,u=1;const y=I.createServer({pauseOnConnect:!0});function p(a,g){v||(v=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),g(a))}return new Promise(a=>{b=setTimeout(()=>{p(0,a)},d),y.on("listening",()=>{p(k,a)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&u<m?(k++,u++,y.listen(k,w)):p(0,a)}),y.on("close",()=>{p(0,a)}),y.listen(k,w)})}e.findFreePortFaster=R;function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(m){console.error(m)}}}),define(Z[138],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[139],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(n,R){this.a=n,this.onMessage=R}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(Z[42],ee([0,1,15,13]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(C,k){const m=(d,...w)=>{this.b(C,d)&&k(d,...w)};return this.a.set(k,m),I.ipcMain.on(C,m),this}once(C,k){return I.ipcMain.once(C,(m,...d)=>{this.b(C,m)&&k(m,...d)}),this}handle(C,k){return I.ipcMain.handle(C,(m,...d)=>this.b(C,m)?k(m,...d):Promise.reject(`Invalid channel '${C}' or sender for ipcMain.handle() usage.`)),this}removeHandler(C){return I.ipcMain.removeHandler(C),this}removeListener(C,k){const m=this.a.get(k);return m&&(I.ipcMain.removeListener(C,m),this.a.delete(k)),this}b(C,k){if(!C||!C.startsWith("vscode:"))return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because the channel is unknown.`),!1;const m=k.senderFrame,d=m.url;if(!d)return!0;let w="unknown";try{w=new URL(d).host}catch{return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a malformed URL '${d}'.`),!1}return w!=="vscode-app"?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a bad origin of '${w}'.`),!1):m.parent!==null?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(Z[140],ee([0,1,15,42,10,138]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){M.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(m,d,w,v,b)=>{const u=k(m,v,w);u.popup({window:(0,n.withNullAsUndefined)(I.BrowserWindow.fromWebContents(m.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{u&&m.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=C;function k(m,d,w){const v=new I.Menu;return w.forEach(b=>{let u;b.type==="separator"?u=new I.MenuItem({type:b.type}):Array.isArray(b.submenu)?u=new I.MenuItem({submenu:k(m,d,b.submenu),label:b.label}):u=new I.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,p,a)=>m.sender.send(d,b.id,a)}),v.append(u)}),v}}),define(Z[141],ee([12,11]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[142],ee([0,1,141]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,n=M*60,R=n*24,C=R*7,k=R*30,m=R*365;function d(v,b,u,y){typeof v!="number"&&(v=v.getTime());const p=Math.round((new Date().getTime()-v)/1e3);if(p<-30)return(0,I.localize)(0,null,d(new Date().getTime()+p*1e3,!1));if(!y&&p<30)return(0,I.localize)(1,null);let a;return p<M?(a=p,b?a===1?u?(0,I.localize)(2,null,a):(0,I.localize)(3,null,a):u?(0,I.localize)(4,null,a):(0,I.localize)(5,null,a):a===1?u?(0,I.localize)(6,null,a):(0,I.localize)(7,null,a):u?(0,I.localize)(8,null,a):(0,I.localize)(9,null,a)):p<n?(a=Math.floor(p/M),b?a===1?u?(0,I.localize)(10,null,a):(0,I.localize)(11,null,a):u?(0,I.localize)(12,null,a):(0,I.localize)(13,null,a):a===1?u?(0,I.localize)(14,null,a):(0,I.localize)(15,null,a):u?(0,I.localize)(16,null,a):(0,I.localize)(17,null,a)):p<R?(a=Math.floor(p/n),b?a===1?u?(0,I.localize)(18,null,a):(0,I.localize)(19,null,a):u?(0,I.localize)(20,null,a):(0,I.localize)(21,null,a):a===1?u?(0,I.localize)(22,null,a):(0,I.localize)(23,null,a):u?(0,I.localize)(24,null,a):(0,I.localize)(25,null,a)):p<C?(a=Math.floor(p/R),b?a===1?(0,I.localize)(26,null,a):(0,I.localize)(27,null,a):a===1?(0,I.localize)(28,null,a):(0,I.localize)(29,null,a)):p<k?(a=Math.floor(p/C),b?a===1?u?(0,I.localize)(30,null,a):(0,I.localize)(31,null,a):u?(0,I.localize)(32,null,a):(0,I.localize)(33,null,a):a===1?u?(0,I.localize)(34,null,a):(0,I.localize)(35,null,a):u?(0,I.localize)(36,null,a):(0,I.localize)(37,null,a)):p<m?(a=Math.floor(p/k),b?a===1?u?(0,I.localize)(38,null,a):(0,I.localize)(39,null,a):u?(0,I.localize)(40,null,a):(0,I.localize)(41,null,a):a===1?u?(0,I.localize)(42,null,a):(0,I.localize)(43,null,a):u?(0,I.localize)(44,null,a):(0,I.localize)(45,null,a)):(a=Math.floor(p/m),b?a===1?u?(0,I.localize)(46,null,a):(0,I.localize)(47,null,a):u?(0,I.localize)(48,null,a):(0,I.localize)(49,null,a):a===1?u?(0,I.localize)(50,null,a):(0,I.localize)(51,null,a):u?(0,I.localize)(52,null,a):(0,I.localize)(53,null,a))}e.fromNow=d;function w(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=w}),define(Z[143],ee([12,11]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,25,10,143]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(v,b){return b&&(v.stack||v.stacktrace)?n.localize(0,null,k(v),C(v.stack)||C(v.stacktrace)):k(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function k(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?n.localize(1,null,v.message):v.message||n.localize(2,null)}function m(v=null,b=!1){if(!v)return n.localize(3,null);if(Array.isArray(v)){const u=I.coalesce(v),y=m(u[0],b);return u.length>1?n.localize(4,null,y,u.length):y}if(M.isString(v))return v;if(v.detail){const u=v.detail;if(u.error)return R(u.error,b);if(u.exception)return R(u.exception,b)}return v.stack?R(v,b):v.message?v.message:n.localize(5,null)}e.toErrorMessage=m;function d(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=d;function w(v,b){let u;return typeof v=="string"?u=new Error(v):u=v,u.actions=b,u}e.createErrorWithActions=w}),define(Z[144],ee([12,11]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[145],ee([0,1,144]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function M(n){switch(n){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=M}),define(Z[146],ee([12,11]),function(x,e){return x.create("vs/base/common/platform",e)}),define(Z[4],ee([0,1,146]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let M=!1,n=!1,R=!1,C=!1,k=!1,m=!1,d=!1,w=!1,v=!1,b=!1,u,y=e.LANGUAGE_DEFAULT,p,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const f=typeof g?.versions?.electron=="string",E=f&&g?.type==="renderer";if(typeof navigator=="object"&&!E)a=navigator.userAgent,M=a.indexOf("Windows")>=0,n=a.indexOf("Macintosh")>=0,w=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,b=a?.indexOf("Mobi")>=0,m=!0,u=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,y=u;else if(typeof g=="object"){M=g.platform==="win32",n=g.platform==="darwin",R=g.platform==="linux",C=R&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,d=f,v=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const r=g.env.VSCODE_NLS_CONFIG;if(r)try{const h=JSON.parse(r),P=h.availableLanguages["*"];u=h.locale,y=P||e.LANGUAGE_DEFAULT,p=h._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function D(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let t=0;n?t=1:M?t=3:R&&(t=2),e.isWindows=M,e.isMacintosh=n,e.isLinux=R,e.isLinuxSnap=C,e.isNative=k,e.isElectron=d,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isMobile=b,e.isCI=v,e.platform=t,e.userAgent=a,e.language=y;var c;(function(r){function h(){return e.language}r.value=h;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=P;function A(){return e.language==="en"}r.isDefault=A})(c=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let A=0,T=r.length;A<T;A++){const N=r[A];if(N.id===P.data.vscodeScheduleAsyncWork){r.splice(A,1),N.callback();return}}});let h=0;return P=>{const A=++h;r.push({id:A,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return r=>setTimeout(r)})();var i;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||w?2:M?1:3;let s=!0,o=!1;function l(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let M;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const n=I.globals.vscode.process;M={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.arch=M.arch}),define(Z[9],ee([0,1,36]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,n=97,R=90,C=122,k=46,m=47,d=92,w=58,v=63;class b extends Error{constructor(c,i,s){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const l=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${l} ${o} of type ${i}`;r+=`. Received type ${typeof s}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,c){if(t===null||typeof t!="object")throw new b(c,"Object",t)}function y(t,c){if(typeof t!="string")throw new b(c,"string",t)}const p=I.platform==="win32";function a(t){return t===m||t===d}function g(t){return t===m}function f(t){return t>=M&&t<=R||t>=n&&t<=C}function E(t,c,i,s){let o="",l=0,r=-1,h=0,P=0;for(let A=0;A<=t.length;++A){if(A<t.length)P=t.charCodeAt(A);else{if(s(P))break;P=m}if(s(P)){if(!(r===A-1||h===1))if(h===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const T=o.lastIndexOf(i);T===-1?(o="",l=0):(o=o.slice(0,T),l=o.length-1-o.lastIndexOf(i)),r=A,h=0;continue}else if(o.length!==0){o="",l=0,r=A,h=0;continue}}c&&(o+=o.length>0?`${i}..`:"..",l=2)}else o.length>0?o+=`${i}${t.slice(r+1,A)}`:o=t.slice(r+1,A),l=A-r-1;r=A,h=0}else P===k&&h!==-1?++h:h=-1}return o}function S(t,c){u(c,"pathObject");const i=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${s}`:`${i}${t}${s}`:s}e.win32={resolve(...t){let c="",i="",s=!1;for(let o=t.length-1;o>=-1;o--){let l;if(o>=0){if(l=t[o],y(l,"path"),l.length===0)continue}else c.length===0?l=I.cwd():(l=I.env[`=${c}`]||I.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===d)&&(l=`${c}\\`));const r=l.length;let h=0,P="",A=!1;const T=l.charCodeAt(0);if(r===1)a(T)&&(h=1,A=!0);else if(a(T))if(A=!0,a(l.charCodeAt(1))){let N=2,z=N;for(;N<r&&!a(l.charCodeAt(N));)N++;if(N<r&&N!==z){const H=l.slice(z,N);for(z=N;N<r&&a(l.charCodeAt(N));)N++;if(N<r&&N!==z){for(z=N;N<r&&!a(l.charCodeAt(N));)N++;(N===r||N!==z)&&(P=`\\\\${H}\\${l.slice(z,N)}`,h=N)}}}else h=1;else f(T)&&l.charCodeAt(1)===w&&(P=l.slice(0,2),h=2,r>2&&a(l.charCodeAt(2))&&(A=!0,h=3));if(P.length>0)if(c.length>0){if(P.toLowerCase()!==c.toLowerCase())continue}else c=P;if(s){if(c.length>0)break}else if(i=`${l.slice(h)}\\${i}`,s=A,A&&c.length>0)break}return i=E(i,!s,"\\",a),s?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){y(t,"path");const c=t.length;if(c===0)return".";let i=0,s,o=!1;const l=t.charCodeAt(0);if(c===1)return g(l)?"\\":t;if(a(l))if(o=!0,a(t.charCodeAt(1))){let h=2,P=h;for(;h<c&&!a(t.charCodeAt(h));)h++;if(h<c&&h!==P){const A=t.slice(P,h);for(P=h;h<c&&a(t.charCodeAt(h));)h++;if(h<c&&h!==P){for(P=h;h<c&&!a(t.charCodeAt(h));)h++;if(h===c)return`\\\\${A}\\${t.slice(P)}\\`;h!==P&&(s=`\\\\${A}\\${t.slice(P,h)}`,i=h)}}}else i=1;else f(l)&&t.charCodeAt(1)===w&&(s=t.slice(0,2),i=2,c>2&&a(t.charCodeAt(2))&&(o=!0,i=3));let r=i<c?E(t.slice(i),!o,"\\",a):"";return r.length===0&&!o&&(r="."),r.length>0&&a(t.charCodeAt(c-1))&&(r+="\\"),s===void 0?o?`\\${r}`:r:o?`${s}\\${r}`:`${s}${r}`},isAbsolute(t){y(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return a(i)||c>2&&f(i)&&t.charCodeAt(1)===w&&a(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let l=0;l<t.length;++l){const r=t[l];y(r,"path"),r.length>0&&(c===void 0?c=i=r:c+=`\\${r}`)}if(c===void 0)return".";let s=!0,o=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++o;const l=i.length;l>1&&a(i.charCodeAt(1))&&(++o,l>2&&(a(i.charCodeAt(2))?++o:s=!1))}if(s){for(;o<c.length&&a(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(t,c){if(y(t,"from"),y(c,"to"),t===c)return"";const i=e.win32.resolve(t),s=e.win32.resolve(c);if(i===s||(t=i.toLowerCase(),c=s.toLowerCase(),t===c))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===d;)o++;let l=t.length;for(;l-1>o&&t.charCodeAt(l-1)===d;)l--;const r=l-o;let h=0;for(;h<c.length&&c.charCodeAt(h)===d;)h++;let P=c.length;for(;P-1>h&&c.charCodeAt(P-1)===d;)P--;const A=P-h,T=r<A?r:A;let N=-1,z=0;for(;z<T;z++){const ie=t.charCodeAt(o+z);if(ie!==c.charCodeAt(h+z))break;ie===d&&(N=z)}if(z!==T){if(N===-1)return s}else{if(A>T){if(c.charCodeAt(h+z)===d)return s.slice(h+z+1);if(z===2)return s.slice(h+z)}r>T&&(t.charCodeAt(o+z)===d?N=z:z===2&&(N=3)),N===-1&&(N=0)}let H="";for(z=o+N+1;z<=l;++z)(z===l||t.charCodeAt(z)===d)&&(H+=H.length===0?"..":"\\..");return h+=N,H.length>0?`${H}${s.slice(h,P)}`:(s.charCodeAt(h)===d&&++h,s.slice(h,P))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===d){if(c.charCodeAt(1)===d){const i=c.charCodeAt(2);if(i!==v&&i!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===w&&c.charCodeAt(2)===d)return`\\\\?\\${c}`;return t},dirname(t){y(t,"path");const c=t.length;if(c===0)return".";let i=-1,s=0;const o=t.charCodeAt(0);if(c===1)return a(o)?t:".";if(a(o)){if(i=s=1,a(t.charCodeAt(1))){let h=2,P=h;for(;h<c&&!a(t.charCodeAt(h));)h++;if(h<c&&h!==P){for(P=h;h<c&&a(t.charCodeAt(h));)h++;if(h<c&&h!==P){for(P=h;h<c&&!a(t.charCodeAt(h));)h++;if(h===c)return t;h!==P&&(i=s=h+1)}}}}else f(o)&&t.charCodeAt(1)===w&&(i=c>2&&a(t.charCodeAt(2))?3:2,s=i);let l=-1,r=!0;for(let h=c-1;h>=s;--h)if(a(t.charCodeAt(h))){if(!r){l=h;break}}else r=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,c){c!==void 0&&y(c,"ext"),y(t,"path");let i=0,s=-1,o=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let r=c.length-1,h=-1;for(l=t.length-1;l>=i;--l){const P=t.charCodeAt(l);if(a(P)){if(!o){i=l+1;break}}else h===-1&&(o=!1,h=l+1),r>=0&&(P===c.charCodeAt(r)?--r===-1&&(s=l):(r=-1,s=h))}return i===s?s=h:s===-1&&(s=t.length),t.slice(i,s)}for(l=t.length-1;l>=i;--l)if(a(t.charCodeAt(l))){if(!o){i=l+1;break}}else s===-1&&(o=!1,s=l+1);return s===-1?"":t.slice(i,s)},extname(t){y(t,"path");let c=0,i=-1,s=0,o=-1,l=!0,r=0;t.length>=2&&t.charCodeAt(1)===w&&f(t.charCodeAt(0))&&(c=s=2);for(let h=t.length-1;h>=c;--h){const P=t.charCodeAt(h);if(a(P)){if(!l){s=h+1;break}continue}o===-1&&(l=!1,o=h+1),P===k?i===-1?i=h:r!==1&&(r=1):i!==-1&&(r=-1)}return i===-1||o===-1||r===0||r===1&&i===o-1&&i===s+1?"":t.slice(i,o)},format:S.bind(null,"\\"),parse(t){y(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let s=0,o=t.charCodeAt(0);if(i===1)return a(o)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(a(o)){if(s=1,a(t.charCodeAt(1))){let N=2,z=N;for(;N<i&&!a(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&a(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&!a(t.charCodeAt(N));)N++;N===i?s=N:N!==z&&(s=N+1)}}}}else if(f(o)&&t.charCodeAt(1)===w){if(i<=2)return c.root=c.dir=t,c;if(s=2,a(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;s=3}}s>0&&(c.root=t.slice(0,s));let l=-1,r=s,h=-1,P=!0,A=t.length-1,T=0;for(;A>=s;--A){if(o=t.charCodeAt(A),a(o)){if(!P){r=A+1;break}continue}h===-1&&(P=!1,h=A+1),o===k?l===-1?l=A:T!==1&&(T=1):l!==-1&&(T=-1)}return h!==-1&&(l===-1||T===0||T===1&&l===h-1&&l===r+1?c.base=c.name=t.slice(r,h):(c.name=t.slice(r,l),c.base=t.slice(r,h),c.ext=t.slice(l,h))),r>0&&r!==s?c.dir=t.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(p){const t=/\\/g;return()=>{const c=I.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>I.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let s=t.length-1;s>=-1&&!i;s--){const o=s>=0?t[s]:D();y(o,"path"),o.length!==0&&(c=`${o}/${c}`,i=o.charCodeAt(0)===m)}return c=E(c,!i,"/",g),i?`/${c}`:c.length>0?c:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===m,i=t.charCodeAt(t.length-1)===m;return t=E(t,!c,"/",g),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const s=t[i];y(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(y(t,"from"),y(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,s=t.length,o=s-i,l=1,r=c.length-l,h=o<r?o:r;let P=-1,A=0;for(;A<h;A++){const N=t.charCodeAt(i+A);if(N!==c.charCodeAt(l+A))break;N===m&&(P=A)}if(A===h)if(r>h){if(c.charCodeAt(l+A)===m)return c.slice(l+A+1);if(A===0)return c.slice(l+A)}else o>h&&(t.charCodeAt(i+A)===m?P=A:A===0&&(P=0));let T="";for(A=i+P+1;A<=s;++A)(A===s||t.charCodeAt(A)===m)&&(T+=T.length===0?"..":"/..");return`${T}${c.slice(l+P)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===m;let i=-1,s=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===m){if(!s){i=o;break}}else s=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&y(c,"ext"),y(t,"path");let i=0,s=-1,o=!0,l;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let r=c.length-1,h=-1;for(l=t.length-1;l>=0;--l){const P=t.charCodeAt(l);if(P===m){if(!o){i=l+1;break}}else h===-1&&(o=!1,h=l+1),r>=0&&(P===c.charCodeAt(r)?--r===-1&&(s=l):(r=-1,s=h))}return i===s?s=h:s===-1&&(s=t.length),t.slice(i,s)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===m){if(!o){i=l+1;break}}else s===-1&&(o=!1,s=l+1);return s===-1?"":t.slice(i,s)},extname(t){y(t,"path");let c=-1,i=0,s=-1,o=!0,l=0;for(let r=t.length-1;r>=0;--r){const h=t.charCodeAt(r);if(h===m){if(!o){i=r+1;break}continue}s===-1&&(o=!1,s=r+1),h===k?c===-1?c=r:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||s===-1||l===0||l===1&&c===s-1&&c===i+1?"":t.slice(c,s)},format:S.bind(null,"/"),parse(t){y(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===m;let s;i?(c.root="/",s=1):s=0;let o=-1,l=0,r=-1,h=!0,P=t.length-1,A=0;for(;P>=s;--P){const T=t.charCodeAt(P);if(T===m){if(!h){l=P+1;break}continue}r===-1&&(h=!1,r=P+1),T===k?o===-1?o=P:A!==1&&(A=1):o!==-1&&(A=-1)}if(r!==-1){const T=l===0&&i?1:l;o===-1||A===0||A===1&&o===r-1&&o===l+1?c.base=c.name=t.slice(T,r):(c.name=t.slice(T,o),c.base=t.slice(T,r),c.ext=t.slice(o,r))}return l>0?c.dir=t.slice(0,l-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(Z[71],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var M;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(M=e.Source||(e.Source={}));var n;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...m){const d=m.reduce((b,u)=>(b[u]=!0,b),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(b=>!d[b]).forEach(b=>{for(let u=0;u<w.length;u++)if(b.search(w[u])!==-1){delete k[b];break}})}e.sanitizeProcessEnvironment=R;function C(k){!k||(delete k.DEBUG,I.isMacintosh&&delete k.DYLD_LIBRARY_PATH,I.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Z[72],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=I.globals.performance&&typeof I.globals.performance.now=="function";class n{static create(C=!0){return new n(C)}constructor(C){this.a=M&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=n}),define(Z[3],ee([0,1,13,50,2,99,72]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,m=!1;var d;(function(l){l.None=()=>n.Disposable.None;function r(U){if(m){const{onDidAddListener:$}=U,V=y.create();let j=0;U.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),$?.()}}}function h(U,$){return oe(U,()=>{},0,void 0,!0,void 0,$)}l.defer=h;function P(U){return($,V=null,j)=>{let K=!1,J;return J=U(re=>{if(!K)return J?J.dispose():K=!0,$.call(V,re)},null,j),K&&J.dispose(),J}}l.once=P;function A(U,$,V){return se((j,K=null,J)=>U(re=>j.call(K,$(re)),null,J),V)}l.map=A;function T(U,$,V){return se((j,K=null,J)=>U(re=>{$(re),j.call(K,re)},null,J),V)}l.forEach=T;function N(U,$,V){return se((j,K=null,J)=>U(re=>$(re)&&j.call(K,re),null,J),V)}l.filter=N;function z(U){return U}l.signal=z;function H(...U){return($,V=null,j)=>(0,n.combinedDisposable)(...U.map(K=>K(J=>$.call(V,J),null,j)))}l.any=H;function ie(U,$,V,j){let K=V;return A(U,J=>(K=$(K,J),K),j)}l.reduce=ie;function se(U,$){let V;const j={onWillAddFirstListener(){V=U(K.fire,K)},onDidRemoveLastListener(){V?.dispose()}};$||r(j);const K=new a(j);return $?.add(K),K.event}function oe(U,$,V=100,j=!1,K=!1,J,re){let de,Ce,Re,De=0,Oe;const $e={leakWarningThreshold:J,onWillAddFirstListener(){de=U(pe=>{De++,Ce=$(Ce,pe),j&&!Re&&(fe.fire(Ce),Ce=void 0),Oe=()=>{const Me=Ce;Ce=void 0,Re=void 0,(!j||De>1)&&fe.fire(Me),De=0},typeof V=="number"?(clearTimeout(Re),Re=setTimeout(Oe,V)):Re===void 0&&(Re=0,queueMicrotask(Oe))})},onWillRemoveListener(){K&&De>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,de.dispose()}};re||r($e);const fe=new a($e);return re?.add(fe),fe.event}l.debounce=oe;function ue(U,$=0,V){return l.debounce(U,(j,K)=>j?(j.push(K),j):[K],$,void 0,!0,void 0,V)}l.accumulate=ue;function le(U,$=(j,K)=>j===K,V){let j=!0,K;return N(U,J=>{const re=j||!$(J,K);return j=!1,K=J,re},V)}l.latch=le;function me(U,$,V){return[l.filter(U,$,V),l.filter(U,j=>!$(j),V)]}l.split=me;function G(U,$=!1,V=[]){let j=V.slice(),K=U(de=>{j?j.push(de):re.fire(de)});const J=()=>{j?.forEach(de=>re.fire(de)),j=null},re=new a({onWillAddFirstListener(){K||(K=U(de=>re.fire(de)))},onDidAddFirstListener(){j&&($?setTimeout(J):J())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return re.event}l.buffer=G;class B{constructor($){this.event=$,this.c=new n.DisposableStore}map($){return new B(A(this.event,$,this.c))}forEach($){return new B(T(this.event,$,this.c))}filter($){return new B(N(this.event,$,this.c))}reduce($,V){return new B(ie(this.event,$,V,this.c))}latch(){return new B(le(this.event,void 0,this.c))}debounce($,V=100,j=!1,K=!1,J){return new B(oe(this.event,$,V,j,K,J,this.c))}on($,V,j){return this.event($,V,j)}once($,V,j){return P(this.event)($,V,j)}dispose(){this.c.dispose()}}function O(U){return new B(U)}l.chain=O;function q(U,$,V=j=>j){const j=(...de)=>re.fire(V(...de)),K=()=>U.on($,j),J=()=>U.removeListener($,j),re=new a({onWillAddFirstListener:K,onDidRemoveLastListener:J});return re.event}l.fromNodeEventEmitter=q;function Y(U,$,V=j=>j){const j=(...de)=>re.fire(V(...de)),K=()=>U.addEventListener($,j),J=()=>U.removeEventListener($,j),re=new a({onWillAddFirstListener:K,onDidRemoveLastListener:J});return re.event}l.fromDOMEventEmitter=Y;function te(U){return new Promise($=>P(U)($))}l.toPromise=te;function ne(U,$){return $(void 0),U(V=>$(V))}l.runAndSubscribe=ne;function L(U,$){let V=null;function j(J){V?.dispose(),V=new n.DisposableStore,$(J,V)}j(void 0);const K=U(J=>j(J));return(0,n.toDisposable)(()=>{K.dispose(),V?.dispose()})}l.runAndSubscribeWithStore=L;class F{constructor($,V){this.obs=$,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};V||r(j),this.emitter=new a(j),V&&V.add(this.emitter)}beginUpdate($){this.c++}handleChange($,V){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(U,$){return new F(U,$).emitter.event}l.fromObservable=W})(d=e.Event||(e.Event={}));class w{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${w.c++}`,w.all.add(this)}start(r){this.d=new C.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}w.all=new Set,w.c=0,e.EventProfiling=w;let v=-1;function b(l){const r=v;return v=l,{dispose(){v=r}}}e.setGlobalLeakWarningThreshold=b;class u{constructor(r,h=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=h,this.d=0}dispose(){this.c?.clear()}check(r,h){const P=this.threshold;if(P<=0||h<P)return;this.c||(this.c=new Map);const A=this.c.get(r.value)||0;if(this.c.set(r.value,A+1),this.d-=1,this.d<=0){this.d=P*.5;let T,N=0;for(const[z,H]of this.c)(!T||N<H)&&(T=z,N=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.c.get(r.value)||0;this.c.set(r.value,T-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(r,h,P){this.callback=r,this.callbackThis=h,this.stack=P,this.subscription=new n.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class a{constructor(r){this.j=!1,this.d=r,this.f=v>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new w(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const r=Array.from(this.q);queueMicrotask(()=>{for(const h of r)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,h,P)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const A=this.q.isEmpty();A&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=y.create(),T=this.f.check(N,this.q.size+1)),k&&(N=N??y.create());const z=new p(r,h,N),H=this.q.push(z);A&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,h);const ie=z.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return P instanceof n.DisposableStore?P.add(ie):Array.isArray(P)&&P.push(ie),ie}),this.l}fire(r){if(this.q){this.m||(this.m=new f);for(const h of this.q)this.m.push(this,h,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class g{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(r,h,P){this.c.push(new E(r,h,P))}clear(r){const h=new R.LinkedList;for(const P of this.c)P.emitter!==r&&h.push(P);this.c=h}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(h){(0,I.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=g;class f extends g{clear(r){this.c.clear()}}class E{constructor(r,h,P){this.emitter=r,this.listener=h,this.event=P}}class S extends a{async fireAsync(r,h,P){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const A of this.q)this.c.push([A,r]);for(;this.c.size>0&&!h.isCancellationRequested;){const[A,T]=this.c.shift(),N=[],z={...T,token:h,waitUntil:H=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");P&&(H=P(H,A.callback)),N.push(H)}};try{A.invoke(z)}catch(H){(0,I.onUnexpectedError)(H);continue}Object.freeze(N),await Promise.allSettled(N).then(H=>{for(const ie of H)ie.status==="rejected"&&(0,I.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=S;class D extends a{constructor(r){super(r),this.h=0,this.s=new R.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=D;class t extends D{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=t;class c extends a{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const h={event:r,listener:null};this.f.push(h),this.d&&this.j(h);const P=()=>{this.d&&this.k(h);const A=this.f.indexOf(h);this.f.splice(A,1)};return(0,n.toDisposable)((0,M.once)(P))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(h=>this.c.fire(h))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.c=[]}wrapEvent(r){return(h,P,A)=>r(T=>{const N=this.c[this.c.length-1];N?N.push(()=>h.call(P,T)):h.call(P,T)},void 0,A)}bufferEvents(r){const h=[];this.c.push(h);const P=r();return this.c.pop(),h.forEach(A=>A()),P}}e.EventBufferer=s;class o{constructor(){this.c=!1,this.d=d.None,this.f=n.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(Z[22],ee([0,1,3]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(k,m){const d=setTimeout(k.bind(m),0);return{dispose(){clearTimeout(d)}}});var n;(function(k){function m(d){return d===k.None||d===k.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}k.isCancellationToken=m,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(n=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(m){this.a=void 0,this.b=void 0,this.b=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=n.Cancelled}dispose(m=!1){m&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=C}),define(Z[147],ee([0,1,22]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class M{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.CancellationTokenSource,m=this.b(k.token);return this.a={promise:m,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=M;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const m=JSON.stringify(k);return this.b!==m&&(this.b=m,this.a=this.c(k)),this.a}}e.LRUCachedFunction=n;class R{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const m=this.b(k);return this.a.set(k,m),m}}e.CachedFunction=R}),define(Z[27],ee([0,1,147,130]),function(x,e,I,M){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function k(X,...ae){return ae.length===0?X:X.replace(C,function(ge,be){const we=parseInt(be,10);return isNaN(we)||we<0||we>=ae.length?ge:ae[we]})}e.format=k;const m=/{([^}]+)}/g;function d(X,ae){return X.replace(m,(ge,be)=>ae[be]??ge)}e.format2=d;function w(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=w;function v(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function b(X,ae){let ge=0;const be=ae.charCodeAt(0);for(let we=X.length-1;we>=0;we--)X.charCodeAt(we)===be&&ge++;return ge}e.count=b;function u(X,ae,ge="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ge}`}e.truncate=u;function y(X,ae=" "){const ge=p(X,ae);return a(ge,ae)}e.trim=y;function p(X,ae){if(!X||!ae)return X;const ge=ae.length;if(ge===0||X.length===0)return X;let be=0;for(;X.indexOf(ae,be)===be;)be=be+ge;return X.substring(be)}e.ltrim=p;function a(X,ae){if(!X||!ae)return X;const ge=ae.length,be=X.length;if(ge===0||be===0)return X;let we=be,Le=-1;for(;Le=X.lastIndexOf(ae,we-1),!(Le===-1||Le+ge!==we);){if(Le===0)return"";we=Le}return X.substring(0,we)}e.rtrim=a;function g(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function f(X){return X.replace(/\*/g,"")}e.stripWildcards=f;function E(X,ae,ge={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=v(X)),ge.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let be="";return ge.global&&(be+="g"),ge.matchCase||(be+="i"),ge.multiline&&(be+="m"),ge.unicode&&(be+="u"),new RegExp(X,be)}e.createRegExp=E;function S(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function D(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function i(X){for(let ae=0,ge=X.length;ae<ge;ae++){const be=X.charCodeAt(ae);if(be!==32&&be!==9)return ae}return-1}e.firstNonWhitespaceIndex=i;function s(X,ae=0,ge=X.length){for(let be=ae;be<ge;be++){const we=X.charCodeAt(be);if(we!==32&&we!==9)return X.substring(ae,be)}return X.substring(ae,ge)}e.getLeadingWhitespace=s;function o(X,ae=X.length-1){for(let ge=ae;ge>=0;ge--){const be=X.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function l(X,ae,ge){const be=[];let we=0;for(const Le of X.matchAll(ae)){if(be.push(X.slice(we,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");we=Le.index+Le[0].length,be.push(ge(Le[0],...Le.slice(1),Le.index,X,Le.groups))}return be.push(X.slice(we)),Promise.all(be).then(Le=>Le.join(""))}e.replaceAsync=l;function r(X,ae){return X<ae?-1:X>ae?1:0}e.compare=r;function h(X,ae,ge=0,be=X.length,we=0,Le=ae.length){for(;ge<be&&we<Le;ge++,we++){const Ge=X.charCodeAt(ge),Ke=ae.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const Ue=be-ge,Ve=Le-we;return Ue<Ve?-1:Ue>Ve?1:0}e.compareSubstring=h;function P(X,ae){return A(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=P;function A(X,ae,ge=0,be=X.length,we=0,Le=ae.length){for(;ge<be&&we<Le;ge++,we++){let Ge=X.charCodeAt(ge),Ke=ae.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return h(X.toLowerCase(),ae.toLowerCase(),ge,be,we,Le);N(Ge)&&(Ge-=32),N(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const Ue=be-ge,Ve=Le-we;return Ue<Ve?-1:Ue>Ve?1:0}e.compareSubstringIgnoreCase=A;function T(X){return X>=48&&X<=57}e.isAsciiDigit=T;function N(X){return X>=97&&X<=122}e.isLowerAsciiLetter=N;function z(X){return X>=65&&X<=90}e.isUpperAsciiLetter=z;function H(X,ae){return X.length===ae.length&&A(X,ae)===0}e.equalsIgnoreCase=H;function ie(X,ae){const ge=ae.length;return ae.length>X.length?!1:A(X,ae,0,ge)===0}e.startsWithIgnoreCase=ie;function se(X,ae){const ge=Math.min(X.length,ae.length);let be;for(be=0;be<ge;be++)if(X.charCodeAt(be)!==ae.charCodeAt(be))return be;return ge}e.commonPrefixLength=se;function oe(X,ae){const ge=Math.min(X.length,ae.length);let be;const we=X.length-1,Le=ae.length-1;for(be=0;be<ge;be++)if(X.charCodeAt(we-be)!==ae.charCodeAt(Le-be))return be;return ge}e.commonSuffixLength=oe;function ue(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ue;function le(X){return 56320<=X&&X<=57343}e.isLowSurrogate=le;function me(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=me;function G(X,ae,ge){const be=X.charCodeAt(ge);if(ue(be)&&ge+1<ae){const we=X.charCodeAt(ge+1);if(le(we))return me(be,we)}return be}e.getNextCodePoint=G;function B(X,ae){const ge=X.charCodeAt(ae-1);if(le(ge)&&ae>1){const be=X.charCodeAt(ae-2);if(ue(be))return me(be,ge)}return ge}class O{get offset(){return this.e}constructor(ae,ge=0){this.c=ae,this.d=ae.length,this.e=ge}setOffset(ae){this.e=ae}prevCodePoint(){const ae=B(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=G(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}e.CodePointIterator=O;class q{get offset(){return this.c.offset}constructor(ae,ge=0){this.c=new O(ae,ge)}nextGraphemeLength(){const ae=Ie.getInstance(),ge=this.c,be=ge.offset;let we=ae.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Le=ge.offset,Ue=ae.getGraphemeBreakType(ge.nextCodePoint());if(ce(we,Ue)){ge.setOffset(Le);break}we=Ue}return ge.offset-be}prevGraphemeLength(){const ae=Ie.getInstance(),ge=this.c,be=ge.offset;let we=ae.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Le=ge.offset,Ue=ae.getGraphemeBreakType(ge.prevCodePoint());if(ce(Ue,we)){ge.setOffset(Le);break}we=Ue}return be-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=q;function Y(X,ae){return new q(X,ae).nextGraphemeLength()}e.nextCharLength=Y;function te(X,ae){return new q(X,ae).prevGraphemeLength()}e.prevCharLength=te;function ne(X,ae){ae>0&&le(X.charCodeAt(ae))&&ae--;const ge=ae+Y(X,ae);return[ge-te(X,ge),ge]}e.getCharContainingOffset=ne;function L(X){const ae=new q(X);let ge=0;for(;!ae.eol();)ge++,ae.nextGraphemeLength();return ge}e.charCount=L;let F;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(X){return F||(F=W()),F.test(X)}e.containsRTL=U;const $=/^[\t\n\r\x20-\x7E]*$/;function V(X){return $.test(X)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=j;function K(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=K;function J(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=J;function re(X,ae){if(X.length<ae)return X;const ge=/\b/g;let be=0;for(;ge.test(X)&&!(X.length-ge.lastIndex<ae);)be=ge.lastIndex,ge.lastIndex+=1;return X.substring(be).replace(/^\s/,"")}e.lcut=re;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function Ce(X){return X&&(X=X.replace(de,"")),X}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function De(X){return Re(X)?X.substr(1):X}e.stripUTF8BOM=De;function Oe(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ge=ae.length,be=X.toLowerCase();let we=0,Le=-1;for(;we<ge;){const Ue=be.indexOf(ae[we],Le+1);if(Ue<0)return!1;Le=Ue,we++}return!0}e.fuzzyContains=Oe;function $e(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=$e;function fe(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=fe;function pe(X,ae=1){if(ae===0)return"";let ge=-1;do ge=X.indexOf(`
`,ge+1),ae--;while(ae>0&&ge>=0);return ge===-1?X:(X[ge-1]==="\r"&&ge--,X.substr(0,ge))}e.getNLines=pe;function Me(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Me;function _(X){return Ie.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=_;function ce(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var he;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Ae()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ge=this.d,be=ge.length/3;let we=1;for(;we<=be;)if(ae<ge[3*we])we=2*we;else if(ae>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}Ie.c=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(X,ae){if(X===0)return 0;const ge=Fe(X,ae);if(ge!==void 0)return ge;const be=new O(ae,X);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Te;function Fe(X,ae){const ge=new O(ae,X);let be=ge.prevCodePoint();for(;je(be)||be===65039||be===8419;){if(ge.offset===0)return;be=ge.prevCodePoint()}if(!J(be))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function je(X){return 127995<=X&&X<=127999}var ze;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class We{static getInstance(ae){return We.d.get(Array.from(ae))}static getLocales(){return We.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}n=We,We.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new I.LRUCachedFunction(X=>{function ae(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function ge(Ke,Ye){const Ze=new Map(Ke);for(const[st,ct]of Ye)Ze.set(st,ct);return Ze}function be(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[st,ct]of Ke)Ye.has(st)&&Ze.set(st,ct);return Ze}const we=n.c.value;let Le=X.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Le.length===0&&(Le=["_default"]);let Ue;for(const Ke of Le){const Ye=ae(we[Ke]);Ue=be(Ue,Ye)}const Ve=ae(we._common),Ge=ge(Ve,Ue);return new We(Ge)}),We.e=new M.Lazy(()=>Object.keys(We.c.value).filter(X=>!X.startsWith("_"))),e.AmbiguousCharacters=We;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ae){return He.e().has(ae)}static get codePoints(){return He.e()}}He.d=void 0,e.InvisibleCharacters=He}),define(Z[32],ee([0,1,9,4,27,10]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(o){return o===47||o===92}e.isPathSeparator=C;function k(o){return o.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=k;function m(o){return o.indexOf("/")===-1&&(o=k(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=m;function d(o,l=I.posix.sep){if(!o)return"";const r=o.length,h=o.charCodeAt(0);if(C(h)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let A=3;const T=A;for(;A<r&&!C(o.charCodeAt(A));A++);if(T!==A&&!C(o.charCodeAt(A+1))){for(A+=1;A<r;A++)if(C(o.charCodeAt(A)))return o.slice(0,A+1).replace(/[\\/]/g,l)}}return l}else if(g(h)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<r;P++)if(C(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.getRoot=d;function w(o){if(!M.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let r=2;const h=r;for(;r<o.length&&(l=o.charCodeAt(r),l!==92);r++);return!(h===r||(l=o.charCodeAt(r+1),isNaN(l)||l===92))}e.isUNC=w;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,l=M.isWindows){const r=l?v:b;return!(!o||o.length===0||/^\s+$/.test(o)||(r.lastIndex=0,r.test(o))||l&&u.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=y;function p(o,l,r){const h=o===l;return!r||h?h:!o||!l?!1:(0,n.equalsIgnoreCase)(o,l)}e.isEqual=p;function a(o,l,r,h=I.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(r){if(!(0,n.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let A=l.length;return l.charAt(l.length-1)===h&&A--,o.charAt(A)===h}return l.charAt(l.length-1)!==h&&(l+=h),o.indexOf(l)===0}e.isEqualOrParent=a;function g(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=g;function f(o,l){return M.isWindows&&o.endsWith(":")&&(o+=I.sep),(0,I.isAbsolute)(o)||(o=(0,I.join)(l,o)),o=(0,I.normalize)(o),M.isWindows?(o=(0,n.rtrim)(o,I.sep),o.endsWith(":")&&(o+=I.sep)):(o=(0,n.rtrim)(o,I.sep),o||(o=I.sep)),o}e.sanitizeFilePath=f;function E(o){const l=(0,I.normalize)(o);return M.isWindows?o.length>3?!1:S(l)&&(o.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=E;function S(o,l=M.isWindows){return l?g(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function D(o){return S(o)?o[0]:void 0}e.getDriveLetter=D;function t(o,l,r){return l.length>o.length?-1:o===l?0:(r&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=t;function c(o){const l=o.split(":");let r,h,P;for(const A of l){const T=Number(A);(0,R.isNumber)(T)?h===void 0?h=T:P===void 0&&(P=T):r=r?[r,A].join(":"):A}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:h!==void 0?h:void 0,column:P!==void 0?P:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,l,r=8){let h="";for(let A=0;A<r;A++)h+=i.charAt(Math.floor(Math.random()*i.length));let P;return l?P=`${l}-${h}`:P=h,o?(0,I.join)(o,P):P}e.randomPath=s}),define(Z[60],ee([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function M(g){return n(g,0)}e.hash=M;function n(g,f){switch(typeof g){case"object":return g===null?R(349,f):Array.isArray(g)?m(g,f):d(g,f);case"string":return k(g,f);case"boolean":return C(g,f);case"number":return R(g,f);case"undefined":return R(937,f);default:return R(617,f)}}e.doHash=n;function R(g,f){return(f<<5)-f+g|0}e.numberHash=R;function C(g,f){return R(g?433:863,f)}function k(g,f){f=R(149417,f);for(let E=0,S=g.length;E<S;E++)f=R(g.charCodeAt(E),f);return f}e.stringHash=k;function m(g,f){return f=R(104579,f),g.reduce((E,S)=>n(S,E),f)}function d(g,f){return f=R(181387,f),Object.keys(g).sort().reduce((E,S)=>(E=k(S,E),n(g[S],E)),f)}class w{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=n(f,this.g),this.g}}e.Hasher=w;var v;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(g,f,E=32){const S=E-f,D=~((1<<S)-1);return(g<<f|(D&g)>>>S)>>>0}function u(g,f=0,E=g.byteLength,S=0){for(let D=0;D<E;D++)g[f+D]=S}function y(g,f,E="0"){for(;g.length<f;)g=E+g;return g}function p(g,f=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(E=>E.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),f/4)}e.toHexString=p;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const E=f.length;if(E===0)return;const S=this.p;let D=this.r,t=this.u,c,i;for(t!==0?(c=t,i=-1,t=0):(c=f.charCodeAt(0),i=0);;){let s=c;if(I.isHighSurrogate(c))if(i+1<E){const o=f.charCodeAt(i+1);I.isLowSurrogate(o)?(i++,s=I.computeCodePoint(c,o)):s=65533}else{t=c;break}else I.isLowSurrogate(c)&&(s=65533);if(D=this.w(S,D,s),i++,i<E)c=f.charCodeAt(i);else break}this.r=D,this.u=t}w(f,E,S){return S<128?f[E++]=S:S<2048?(f[E++]=192|(S&1984)>>>6,f[E++]=128|(S&63)>>>0):S<65536?(f[E++]=224|(S&61440)>>>12,f[E++]=128|(S&4032)>>>6,f[E++]=128|(S&63)>>>0):(f[E++]=240|(S&1835008)>>>18,f[E++]=128|(S&258048)>>>12,f[E++]=128|(S&4032)>>>6,f[E++]=128|(S&63)>>>0),E>=64&&(this.y(),E-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=a.g,E=this.q;for(let r=0;r<64;r+=4)f.setUint32(r,E.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)f.setUint32(r,b(f.getUint32(r-12,!1)^f.getUint32(r-32,!1)^f.getUint32(r-56,!1)^f.getUint32(r-64,!1),1),!1);let S=this.h,D=this.l,t=this.m,c=this.n,i=this.o,s,o,l;for(let r=0;r<80;r++)r<20?(s=D&t|~D&c,o=1518500249):r<40?(s=D^t^c,o=1859775393):r<60?(s=D&t|D&c|t&c,o=2400959708):(s=D^t^c,o=3395469782),l=b(S,5)+s+i+o+f.getUint32(r*4,!1)&4294967295,i=c,c=t,t=b(D,30),D=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+i&4294967295}}a.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=a}),define(Z[73],ee([0,1,27]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(M||(M={})),function(n){const R="error",C="warning",k="warn",m="info",d="ignore";function w(b){return b?I.equalsIgnoreCase(R,b)?n.Error:I.equalsIgnoreCase(C,b)||I.equalsIgnoreCase(k,b)?n.Warning:I.equalsIgnoreCase(m,b)?n.Info:n.Ignore:n.Ignore}n.fromValue=w;function v(b){switch(b){case n.Error:return R;case n.Warning:return C;case n.Info:return m;default:return d}}n.toString=v}(M||(M={})),e.default=M}),define(Z[61],ee([0,1,25,27]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const y=u.charCodeAt(0),p=this.b.charCodeAt(this.c);return y-p}value(){return this.b[this.c]}}e.StringIterator=n;class R{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,M.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class C{constructor(u=!0,y=!0){this.f=u,this.g=y}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let y=u.length-1;y>=0;y--,this.c--){const p=this.b.charCodeAt(y);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,M.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var k;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(k||(k={}));class m{constructor(u,y){this.f=u,this.g=y,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,M.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=m;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(w||(w={}));class v{static forUris(u=()=>!1,y=()=>!1){return new v(new m(u,y))}static forPaths(u=!1){return new v(new C(void 0,!u))}static forStrings(){return new v(new n)}static forConfigKeys(){return new v(new R)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,y){if(y){const p=y.slice(0);(0,I.shuffle)(p);for(const a of p)this.set(a,u)}else{const p=u.slice(0);(0,I.shuffle)(p);for(const a of p)this.set(a[0],a[1])}}set(u,y){const p=this.b.reset(u);let a;this.c||(this.c=new d,this.c.segment=p.value());const g=[];for(a=this.c;;){const E=p.cmp(a.segment);if(E>0)a.left||(a.left=new d,a.left.segment=p.value()),g.push([-1,a]),a=a.left;else if(E<0)a.right||(a.right=new d,a.right.segment=p.value()),g.push([1,a]),a=a.right;else if(p.hasNext())p.next(),a.mid||(a.mid=new d,a.mid.segment=p.value()),g.push([0,a]),a=a.mid;else break}const f=a.value;a.value=y,a.key=u;for(let E=g.length-1;E>=0;E--){const S=g[E][1];S.updateHeight();const D=S.balanceFactor();if(D<-1||D>1){const t=g[E][0],c=g[E+1][0];if(t===1&&c===1)g[E][1]=S.rotateLeft();else if(t===-1&&c===-1)g[E][1]=S.rotateRight();else if(t===1&&c===-1)S.right=g[E+1][1]=g[E+1][1].rotateRight(),g[E][1]=S.rotateLeft();else if(t===-1&&c===1)S.left=g[E+1][1]=g[E+1][1].rotateLeft(),g[E][1]=S.rotateRight();else throw new Error;if(E>0)switch(g[E-1][0]){case-1:g[E-1][1].left=g[E][1];break;case 1:g[E-1][1].right=g[E][1];break;case 0:g[E-1][1].mid=g[E][1];break}else this.c=g[0][1]}}return f}get(u){return this.d(u)?.value}d(u){const y=this.b.reset(u);let p=this.c;for(;p;){const a=y.cmp(p.segment);if(a>0)p=p.left;else if(a<0)p=p.right;else if(y.hasNext())y.next(),p=p.mid;else break}return p}has(u){const y=this.d(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,y){const p=this.b.reset(u),a=[];let g=this.c;for(;g;){const f=p.cmp(g.segment);if(f>0)a.push([-1,g]),g=g.left;else if(f<0)a.push([1,g]),g=g.right;else if(p.hasNext())p.next(),a.push([0,g]),g=g.mid;else break}if(!!g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const f=this.f(g.right);if(f.key){const{key:E,value:S,segment:D}=f;this.e(f.key,!1),g.key=E,g.value=S,g.segment=D}}else{const f=g.left??g.right;if(a.length>0){const[E,S]=a[a.length-1];switch(E){case-1:S.left=f;break;case 0:S.mid=f;break;case 1:S.right=f;break}}else this.c=f}for(let f=a.length-1;f>=0;f--){const E=a[f][1];E.updateHeight();const S=E.balanceFactor();if(S>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),a[f][1]=E.rotateLeft()):S<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),a[f][1]=E.rotateRight()),f>0)switch(a[f-1][0]){case-1:a[f-1][1].left=a[f][1];break;case 1:a[f-1][1].right=a[f][1];break;case 0:a[f-1][1].mid=a[f][1];break}else this.c=a[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this.b.reset(u);let p=this.c,a;for(;p;){const g=y.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(y.hasNext())y.next(),a=p.value||a,p=p.mid;else break}return p&&p.value||a}findSuperstr(u){return this.g(u,!1)}g(u,y){const p=this.b.reset(u);let a=this.c;for(;a;){const g=p.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(p.hasNext())p.next(),a=a.mid;else return a.mid?this.h(a.mid):y?a.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[y,p]of this)u(p,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const y=[];return this.j(u,y),y[Symbol.iterator]()}j(u,y){!u||(u.left&&this.j(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this.j(u.mid,y),u.right&&this.j(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const p=y.balanceFactor();return p<-1||p>1?!1:u(y.left)&&u(y.right)};return u(this.c)}}e.TernarySearchTree=v}),define(Z[8],ee([0,1,9,4]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function k(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(i,s){return!i&&!s?"file":i}function d(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const w="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(s){return s instanceof u?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,l,r,h,P=!1){typeof s=="object"?(this.scheme=s.scheme||w,this.authority=s.authority||w,this.path=s.path||w,this.query=s.query||w,this.fragment=s.fragment||w):(this.scheme=m(s,P),this.authority=o||w,this.path=d(this.scheme,l||w),this.query=r||w,this.fragment=h||w,k(this,P))}get fsPath(){return E(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:l,path:r,query:h,fragment:P}=s;return o===void 0?o=this.scheme:o===null&&(o=w),l===void 0?l=this.authority:l===null&&(l=w),r===void 0?r=this.path:r===null&&(r=w),h===void 0?h=this.query:h===null&&(h=w),P===void 0?P=this.fragment:P===null&&(P=w),o===this.scheme&&l===this.authority&&r===this.path&&h===this.query&&P===this.fragment?this:new p(o,l,r,h,P)}static parse(s,o=!1){const l=b.exec(s);return l?new p(l[2]||w,c(l[4]||w),c(l[5]||w),c(l[7]||w),c(l[9]||w),o):new p(w,w,w,w,w)}static file(s){let o=w;if(M.isWindows&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const l=s.indexOf(v,2);l===-1?(o=s.substring(2),s=v):(o=s.substring(2,l),s=s.substring(l)||v)}return new p("file",o,s,w,w)}static from(s){const o=new p(s.scheme,s.authority,s.path,s.query,s.fragment);return k(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return M.isWindows&&s.scheme==="file"?l=u.file(I.win32.join(E(s,!0),...o)).path:l=I.posix.join(s.path,...o),s.with({path:l})}toString(s=!1){return S(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof u)return s;{const o=new p(s);return o._formatted=s.external,o._fsPath=s._sep===y?s.fsPath:null,o}}else return s}}e.URI=u;const y=M.isWindows?1:void 0;class p extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(s=!1){return s?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=y),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,s,o){let l,r=-1;for(let h=0;h<i.length;h++){const P=i.charCodeAt(h);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||s&&P===47||o&&P===91||o&&P===93||o&&P===58)r!==-1&&(l+=encodeURIComponent(i.substring(r,h)),r=-1),l!==void 0&&(l+=i.charAt(h));else{l===void 0&&(l=i.substr(0,h));const A=a[P];A!==void 0?(r!==-1&&(l+=encodeURIComponent(i.substring(r,h)),r=-1),l+=A):r===-1&&(r=h)}}return r!==-1&&(l+=encodeURIComponent(i.substring(r))),l!==void 0?l:i}function f(i){let s;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);l===35||l===63?(s===void 0&&(s=i.substr(0,o)),s+=a[l]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function E(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,M.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=E;function S(i,s){const o=s?f:g;let l="",{scheme:r,authority:h,path:P,query:A,fragment:T}=i;if(r&&(l+=r,l+=":"),(h||r==="file")&&(l+=v,l+=v),h){let N=h.indexOf("@");if(N!==-1){const z=h.substr(0,N);h=h.substr(N+1),N=z.lastIndexOf(":"),N===-1?l+=o(z,!1,!1):(l+=o(z.substr(0,N),!1,!1),l+=":",l+=o(z.substr(N+1),!1,!0)),l+="@"}h=h.toLowerCase(),N=h.lastIndexOf(":"),N===-1?l+=o(h,!1,!0):(l+=o(h.substr(0,N),!1,!0),l+=h.substr(N))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const N=P.charCodeAt(1);N>=65&&N<=90&&(P=`/${String.fromCharCode(N+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const N=P.charCodeAt(0);N>=65&&N<=90&&(P=`${String.fromCharCode(N+32)}:${P.substr(2)}`)}l+=o(P,!0,!1)}return A&&(l+="?",l+=o(A,!1,!1)),T&&(l+="#",l+=s?T:g(T,!1,!1)),l}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,s=>D(s)):i}}),define(Z[148],ee([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(d){const w=d;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.isRemoteConsoleLog=M;function n(d){const w=[];let v;try{const b=JSON.parse(d.arguments),u=b[b.length-1];u&&u.__$stack&&(b.pop(),v=u.__$stack),w.push(...b)}catch{w.push("Unable to log remote console arguments",d.arguments)}return{args:w,stack:v}}e.parse=n;function R(d){if(typeof d!="string")return R(n(d).stack);const w=d;if(w){const v=C(w),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function C(d){if(!d)return d;const w=d.indexOf(`
`);return w===-1?d:d.substring(0,w)}function k(d,w){const{args:v,stack:b}=n(d),u=typeof v[0]=="string"&&v.length===1;let y=C(b);y&&(y=`(${y.trim()})`);let p=[];if(typeof v[0]=="string"?y&&u?p=[`%c[${w}] %c${v[0]} %c${y}`,m("blue"),m(""),m("grey")]:p=[`%c[${w}] %c${v[0]}`,m("blue"),m(""),...v.slice(1)]:p=[`%c[${w}]%`,m("blue"),...v],y&&!u&&p.push(y),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,p)}e.log=k;function m(d){return`color: ${d}`}}),define(Z[83],ee([0,1,17,27,8]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(d){return JSON.stringify(d,k)}e.stringify=R;function C(d){let w=JSON.parse(d);return w=m(w),w}e.parse=C;function k(d,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,M.regExpFlags)(w)}:w}function m(d,w=0){if(!d||w>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return n.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof I.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let v=0;v<d.length;++v)d[v]=m(d[v],w+1);else for(const v in d)Object.hasOwnProperty.call(d,v)&&(d[v]=m(d[v],w+1))}return d}e.revive=m}),define(Z[14],ee([0,1,13,4,8]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${R.vscodeRemoteResource}`}set(w,v,b){this.a[w]=v,this.b[w]=b}setConnectionToken(w,v){this.c[w]=v}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(a){return I.onUnexpectedError(a),w}const v=w.authority;let b=this.a[v];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const u=this.b[v],y=this.c[v];let p=`path=${encodeURIComponent(w.path)}`;return typeof y=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),n.URI.from({scheme:M.isWeb?this.d:R.vscodeRemoteResource,authority:`${b}:${u}`,path:this.f,query:p})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(w){const v=this.b(w,x);return this.uriToBrowserUri(v)}uriToBrowserUri(w){return w.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===R.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${R.vscodeFileResource}://${k.a}`)?w.with({scheme:R.vscodeFileResource,authority:w.authority||k.a,query:null,fragment:null}):w}asFileUri(w){const v=this.b(w,x);return this.uriToFileUri(v)}uriToFileUri(w){return w.scheme===R.vscodeFileResource?w.with({scheme:R.file,authority:w.authority!==k.a?w.authority:null,query:null,fragment:null}):w}b(w,v){return n.URI.isUri(w)?w:n.URI.parse(v.toUrl(w))}}k.a="vscode-app",e.FileAccess=new k;var m;(function(d){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(w.get("3"));const v="vscode-coi";function b(y){let p;typeof y=="string"?p=new URL(y).searchParams:y instanceof URL?p=y.searchParams:n.URI.isUri(y)&&(p=new URL(y.toString(!0)).searchParams);const a=p?.get(v);if(!!a)return w.get(a)}d.getHeadersFromQuery=b;function u(y,p,a){if(!globalThis.crossOriginIsolated)return;const g=p&&a?"3":a?"2":"1";y instanceof URLSearchParams?y.set(v,g):y[v]=g}d.addSearchParam=u})(m=e.COI||(e.COI={}))}),define(Z[19],ee([0,1,32,14,9,4,27,8]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(u){return(0,k.uriToFsPath)(u,!0)}e.originalFSPath=m;class d{constructor(y){this.a=y}compare(y,p,a=!1){return y===p?0:(0,C.compare)(this.getComparisonKey(y,a),this.getComparisonKey(p,a))}isEqual(y,p,a=!1){return y===p?!0:!y||!p?!1:this.getComparisonKey(y,a)===this.getComparisonKey(p,a)}getComparisonKey(y,p=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,p,a=!1){if(y.scheme===p.scheme){if(y.scheme===M.Schemas.file)return I.isEqualOrParent(m(y),m(p),this.a(y))&&y.query===p.query&&(a||y.fragment===p.fragment);if((0,e.isEqualAuthority)(y.authority,p.authority))return I.isEqualOrParent(y.path,p.path,this.a(y),"/")&&y.query===p.query&&(a||y.fragment===p.fragment)}return!1}joinPath(y,...p){return k.URI.joinPath(y,...p)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return n.posix.basename(y.path)}extname(y){return n.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let p;return y.scheme===M.Schemas.file?p=k.URI.file(n.dirname(m(y))).path:(p=n.posix.dirname(y.path),y.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),p="/")),y.with({path:p})}normalizePath(y){if(!y.path.length)return y;let p;return y.scheme===M.Schemas.file?p=k.URI.file(n.normalize(m(y))).path:p=n.posix.normalize(y.path),y.with({path:p})}relativePath(y,p){if(y.scheme!==p.scheme||!(0,e.isEqualAuthority)(y.authority,p.authority))return;if(y.scheme===M.Schemas.file){const f=n.relative(m(y),m(p));return R.isWindows?I.toSlashes(f):f}let a=y.path||"/";const g=p.path||"/";if(this.a(y)){let f=0;for(const E=Math.min(a.length,g.length);f<E&&!(a.charCodeAt(f)!==g.charCodeAt(f)&&a.charAt(f).toLowerCase()!==g.charAt(f).toLowerCase());f++);a=g.substr(0,f)+a.substr(f)}return n.posix.relative(a,g)}resolvePath(y,p){if(y.scheme===M.Schemas.file){const a=k.URI.file(n.resolve(m(y),p));return y.with({authority:a.authority,path:a.path})}return p=I.toPosixPath(p),y.with({path:n.posix.resolve(y.path,p)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,p){return y===p||y!==void 0&&p!==void 0&&(0,C.equalsIgnoreCase)(y,p)}hasTrailingPathSeparator(y,p=n.sep){if(y.scheme===M.Schemas.file){const a=m(y);return a.length>I.getRoot(a).length&&a[a.length-1]===p}else{const a=y.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,p=n.sep){return(0,e.hasTrailingPathSeparator)(y,p)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,p=n.sep){let a=!1;if(y.scheme===M.Schemas.file){const g=m(y);a=g!==void 0&&g.length===I.getRoot(g).length&&g[g.length-1]===p}else{p="/";const g=y.path;a=g.length===1&&g.charCodeAt(g.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(y,p)?y.with({path:y.path+"/"}):y}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(u=>u.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new d(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(u,y){const p=[];for(let a=0;a<u.length;a++){const g=y(u[a]);u.some((f,E)=>E===a?!1:(0,e.isEqualOrParent)(g,y(f)))||p.push(u[a])}return p}e.distinctParents=w;var v;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(p){const a=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(E=>{const[S,D]=E.split(":");S&&D&&a.set(S,D)});const f=p.path.substring(0,p.path.indexOf(";"));return f&&a.set(u.META_DATA_MIME,f),a}u.parseMetaData=y})(v=e.DataUri||(e.DataUri={}));function b(u,y,p){if(y){let a=u.path;return a&&a[0]!==n.posix.sep&&(a=n.posix.sep+a),u.with({scheme:p,authority:y,path:a})}return u.with({scheme:p})}e.toLocalResource=b}),define(Z[7],ee([0,1,22,13,3,2,19,4,133]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(L){return!!L&&typeof L.then=="function"}e.isThenable=d;function w(L){const F=new I.CancellationTokenSource,W=L(F.token),U=new Promise(($,V)=>{const j=F.token.onCancellationRequested(()=>{j.dispose(),F.dispose(),V(new M.CancellationError)});Promise.resolve(W).then(K=>{j.dispose(),F.dispose(),$(K)},K=>{j.dispose(),F.dispose(),V(K)})});return new class{cancel(){F.cancel()}then($,V){return U.then($,V)}catch($){return this.then(void 0,$)}finally($){return U.finally($)}}}e.createCancelablePromise=w;function v(L,F,W){return new Promise((U,$)=>{const V=F.onCancellationRequested(()=>{V.dispose(),U(W)});L.then(U,$).finally(()=>V.dispose())})}e.raceCancellation=v;function b(L,F){return new Promise((W,U)=>{const $=F.onCancellationRequested(()=>{$.dispose(),U(new M.CancellationError)});L.then(W,U).finally(()=>$.dispose())})}e.raceCancellationError=b;async function u(L){let F=-1;const W=L.map(($,V)=>$.then(j=>(F=V,j))),U=await Promise.race(W);return L.forEach(($,V)=>{V!==F&&$.cancel()}),U}e.raceCancellablePromises=u;function y(L,F,W){let U;const $=setTimeout(()=>{U?.(void 0),W?.()},F);return Promise.race([L.finally(()=>clearTimeout($)),new Promise(V=>U=V)])}e.raceTimeout=y;function p(L){return new Promise((F,W)=>{const U=L();d(U)?U.then(F,W):F(U)})}e.asPromise=p;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(F){if(this.a){if(this.d=F,!this.b){const W=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(W,W).then(U)})}return new Promise((W,U)=>{this.b.then(W,U)})}return this.a=F(),new Promise((W,U)=>{this.a.then($=>{this.a=null,W($)},$=>{this.a=null,U($)})})}}e.Throttler=a;class g{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.Sequencer=g;class f{constructor(){this.a=new Map}queue(F,W){const $=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(F)===$&&this.a.delete(F)});return this.a.set(F,$),$}}e.SequencerByKey=f;const E=(L,F)=>{let W=!0;const U=setTimeout(()=>{W=!1,F()},L);return{isTriggered:()=>W,dispose:()=>{clearTimeout(U),W=!1}}},S=L=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,L())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class D{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,W=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise(($,V)=>{this.d=$,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const $=this.g;return this.g=null,$()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=W===m.MicrotaskDelay?S(U):E(W,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(F){this.a=new D(F),this.b=new a}trigger(F,W){return this.a.trigger(()=>this.b.queue(F),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((F,W)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class i extends c{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function s(L,F){return F?new Promise((W,U)=>{const $=setTimeout(()=>{V.dispose(),W()},L),V=F.onCancellationRequested(()=>{clearTimeout($),V.dispose(),U(new M.CancellationError)})}):w(W=>s(L,W))}e.timeout=s;function o(L,F=0){const W=setTimeout(L,F);return(0,R.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function l(L){const F=[];let W=0;const U=L.length;function $(){return W<U?L[W++]():null}function V(j){j!=null&&F.push(j);const K=$();return K?K.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=l;function r(L,F=U=>!!U,W=null){let U=0;const $=L.length,V=()=>{if(U>=$)return Promise.resolve(W);const j=L[U++];return Promise.resolve(j()).then(J=>F(J)?Promise.resolve(J):V())};return V()}e.first=r;function h(L,F=U=>!!U,W=null){if(L.length===0)return Promise.resolve(W);let U=L.length;const $=()=>{U=-1;for(const V of L)V.cancel?.()};return new Promise((V,j)=>{for(const K of L)K.then(J=>{--U>=0&&F(J)?($(),V(J)):U===0&&V(W)}).catch(J=>{--U>=0&&($(),j(J))})})}e.firstParallel=h;class P{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((W,U)=>{this.f.push({factory:F,c:W,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const W=F.factory();W.then(F.c,F.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=P;class A extends P{constructor(){super(1)}}e.Queue=A;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const F=new B;return this.b.add(F),F.p}d(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,W=C.extUri){const U=W.getComparisonKey(F);let $=this.a.get(U);return $||($=new A,n.Event.once($.onDrained)(()=>{$?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,$)),$}f(){!this.d()||this.g()}g(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class N{constructor(F,W){this.a=-1,typeof F=="function"&&typeof W=="number"&&this.setIfNotSet(F,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},W)}setIfNotSet(F,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},W))}}e.TimeoutTimer=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,W){this.cancel(),this.a=setInterval(()=>{F()},W)}}e.IntervalTimer=z;class H{constructor(F,W){this.b=-1,this.a=F,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class ie{constructor(F,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=F,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ie;class se extends H{constructor(F,W){super(F,W),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=se;class oe extends R.Disposable{constructor(F,W){super(),this.g=F,this.h=W,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of F)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=L=>{(0,k.setTimeout0)(()=>{if(F)return;const W=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(L,F)=>{const W=requestIdleCallback(L,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(W))}}}}();class ue{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ue;async function le(L,F,W){let U;for(let $=0;$<W;$++)try{return await L()}catch(V){U=V,await s(F)}throw U}e.retry=le;class me{hasPending(F){return this.a?typeof F=="number"?this.a.taskId===F:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(F,W,U){return this.a={taskId:F,cancel:()=>U?.(),promise:W},W.then(()=>this.d(F),()=>this.d(F)),W}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this.b)this.b.run=F;else{let W,U;const $=new Promise((V,j)=>{W=V,U=j});this.b={run:F,promise:$,promiseResolve:W,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=me;class G{constructor(F,W=()=>Date.now()){this.d=F,this.f=W,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.IntervalCounter=G;class B{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((F,W)=>{this.a=F,this.b=W})}complete(F){return new Promise(W=>{this.a(F),this.f=!0,W()})}error(F){return new Promise(W=>{this.b(F),this.d=!0,W()})}cancel(){new Promise(F=>{this.b(new M.CancellationError),this.d=!0,F()})}}e.DeferredPromise=B;var O;(function(L){async function F(U){let $;const V=await Promise.all(U.map(j=>j.then(K=>K,K=>{$||($=K)})));if(typeof $<"u")throw $;return V}L.settled=F;function W(U){return new Promise(async($,V)=>{try{await U($,V)}catch(j){V(j)}})}L.withAsyncBody=W})(O=e.Promises||(e.Promises={}));var q;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(q||(q={}));class Y{static fromArray(F){return new Y(W=>{W.emitMany(F)})}static fromPromise(F){return new Y(async W=>{W.emitMany(await F)})}static fromPromises(F){return new Y(async W=>{await Promise.all(F.map(async U=>W.emitOne(await U)))})}static merge(F){return new Y(async W=>{await Promise.all(F.map(async U=>{for await(const $ of U)W.emitOne($)}))})}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const W={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(F(W)),this.j()}catch(U){this.k(U)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(F,W){return new Y(async U=>{for await(const $ of F)U.emitOne(W($))})}map(F){return Y.map(this,F)}static filter(F,W){return new Y(async U=>{for await(const $ of F)W($)&&U.emitOne($)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,W=>!!W)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const W=[];for await(const U of F)W.push(U);return W}toPromise(){return Y.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}Y.EMPTY=Y.fromArray([]),e.AsyncIterableObject=Y;class te extends Y{constructor(F,W){super(W),this.l=F}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=te;function ne(L){const F=new I.CancellationTokenSource,W=L(F.token);return new te(F,async U=>{const $=F.token.onCancellationRequested(()=>{$.dispose(),F.dispose(),U.reject(new M.CancellationError)});try{for await(const V of W){if(F.token.isCancellationRequested)return;U.emitOne(V)}$.dispose(),F.dispose()}catch(V){$.dispose(),F.dispose(),U.reject(V)}})}e.createCancelableAsyncIterable=ne}),define(Z[101],ee([0,1,25,7,32,35,9,4,27]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const w="[/\\\\]",v="[^/\\\\]",b=/\//g;function u(G,B){switch(G){case 0:return"";case 1:return`${v}*?`;default:return`(?:${w}|${v}+${w}${B?`|${w}${v}+`:""})*?`}}function y(G,B){if(!G)return[];const O=[];let q=!1,Y=!1,te="";for(const ne of G){switch(ne){case B:if(!q&&!Y){O.push(te),te="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}te+=ne}return te&&O.push(te),O}e.splitGlobAware=y;function p(G){if(!G)return"";let B="";const O=y(G,e.GLOB_SPLIT);if(O.every(q=>q===e.GLOBSTAR))B=".*";else{let q=!1;O.forEach((Y,te)=>{if(Y===e.GLOBSTAR){if(q)return;B+=u(2,te===O.length-1)}else{let ne=!1,L="",F=!1,W="";for(const U of Y){if(U!=="}"&&ne){L+=U;continue}if(F&&(U!=="]"||!W)){let $;U==="-"?$=U:(U==="^"||U==="!")&&!W?$="^":U===e.GLOB_SPLIT?$="":$=(0,m.escapeRegExpCharacters)(U),W+=$;continue}switch(U){case"{":ne=!0;continue;case"[":F=!0;continue;case"}":{B+=`(?:${y(L,",").map(j=>p(j)).join("|")})`,ne=!1,L="";break}case"]":{B+="["+W+"]",F=!1,W="";break}case"?":B+=v;continue;case"*":B+=u(1);continue;default:B+=(0,m.escapeRegExpCharacters)(U)}}te<O.length-1&&(O[te+1]!==e.GLOBSTAR||te+2<O.length)&&(B+=w)}q=Y===e.GLOBSTAR})}return B}const a=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),c=function(){return!1},i=function(){return null};function s(G,B){if(!G)return i;let O;typeof G!="string"?O=G.pattern:O=G,O=O.trim();const q=`${O}_${!!B.trimForExclusions}`;let Y=t.get(q);if(Y)return o(Y,G);let te;return a.test(O)?Y=r(O.substr(4),O):(te=g.exec(l(O,B)))?Y=h(te[1],O):(B.trimForExclusions?E:f).test(O)?Y=P(O,B):(te=S.exec(l(O,B)))?Y=A(te[1].substr(1),O,!0):(te=D.exec(l(O,B)))?Y=A(te[1],O,!1):Y=T(O),t.set(q,Y),o(Y,G)}function o(G,B){if(typeof B=="string")return G;const O=function(q,Y){return(0,n.isEqualOrParent)(q,B.base,!k.isLinux)?G((0,m.ltrim)(q.substr(B.base.length),C.sep),Y):null};return O.allBasenames=G.allBasenames,O.allPaths=G.allPaths,O.basenames=G.basenames,O.patterns=G.patterns,O}function l(G,B){return B.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function r(G,B){return function(O,q){return typeof O=="string"&&O.endsWith(G)?B:null}}function h(G,B){const O=`/${G}`,q=`\\${G}`,Y=function(ne,L){return typeof ne!="string"?null:L?L===G?B:null:ne===G||ne.endsWith(O)||ne.endsWith(q)?B:null},te=[G];return Y.basenames=te,Y.patterns=[B],Y.allBasenames=te,Y}function P(G,B){const O=le(G.slice(1,-1).split(",").map(L=>s(L,B)).filter(L=>L!==i),G),q=O.length;if(!q)return i;if(q===1)return O[0];const Y=function(L,F){for(let W=0,U=O.length;W<U;W++)if(O[W](L,F))return G;return null},te=O.find(L=>!!L.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=O.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return ne.length&&(Y.allPaths=ne),Y}function A(G,B,O){const q=C.sep===C.posix.sep,Y=q?G:G.replace(b,C.sep),te=C.sep+Y,ne=C.posix.sep+G;let L;return O?L=function(F,W){return typeof F=="string"&&(F===Y||F.endsWith(te)||!q&&(F===G||F.endsWith(ne)))?B:null}:L=function(F,W){return typeof F=="string"&&(F===Y||!q&&F===G)?B:null},L.allPaths=[(O?"*/":"./")+G],L}function T(G){try{const B=new RegExp(`^${p(G)}$`);return function(O){return B.lastIndex=0,typeof O=="string"&&B.test(O)?G:null}}catch{return i}}function N(G,B,O){return!G||typeof B!="string"?!1:z(G)(B,void 0,O)}e.match=N;function z(G,B={}){if(!G)return c;if(typeof G=="string"||H(G)){const O=s(G,B);if(O===i)return c;const q=function(Y,te){return!!O(Y,te)};return O.allBasenames&&(q.allBasenames=O.allBasenames),O.allPaths&&(q.allPaths=O.allPaths),q}return oe(G,B)}e.parse=z;function H(G){const B=G;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=H;function ie(G){return G.allBasenames||[]}e.getBasenameTerms=ie;function se(G){return G.allPaths||[]}e.getPathTerms=se;function oe(G,B){const O=le(Object.getOwnPropertyNames(G).map(L=>ue(L,G[L],B)).filter(L=>L!==i)),q=O.length;if(!q)return i;if(!O.some(L=>!!L.requiresSiblings)){if(q===1)return O[0];const L=function(U,$){let V;for(let j=0,K=O.length;j<K;j++){const J=O[j](U,$);if(typeof J=="string")return J;(0,M.isThenable)(J)&&(V||(V=[]),V.push(J))}return V?(async()=>{for(const j of V){const K=await j;if(typeof K=="string")return K}return null})():null},F=O.find(U=>!!U.allBasenames);F&&(L.allBasenames=F.allBasenames);const W=O.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return W.length&&(L.allPaths=W),L}const Y=function(L,F,W){let U,$;for(let V=0,j=O.length;V<j;V++){const K=O[V];K.requiresSiblings&&W&&(F||(F=(0,C.basename)(L)),U||(U=F.substr(0,F.length-(0,C.extname)(L).length)));const J=K(L,F,U,W);if(typeof J=="string")return J;(0,M.isThenable)(J)&&($||($=[]),$.push(J))}return $?(async()=>{for(const V of $){const j=await V;if(typeof j=="string")return j}return null})():null},te=O.find(L=>!!L.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=O.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return ne.length&&(Y.allPaths=ne),Y}function ue(G,B,O){if(B===!1)return i;const q=s(G,O);if(q===i)return i;if(typeof B=="boolean")return q;if(B){const Y=B.when;if(typeof Y=="string"){const te=(ne,L,F,W)=>{if(!W||!q(ne,L))return null;const U=Y.replace("$(basename)",()=>F),$=W(U);return(0,M.isThenable)($)?$.then(V=>V?G:null):$?G:null};return te.requiresSiblings=!0,te}}return q}function le(G,B){const O=G.filter(L=>!!L.basenames);if(O.length<2)return G;const q=O.reduce((L,F)=>{const W=F.basenames;return W?L.concat(W):L},[]);let Y;if(B){Y=[];for(let L=0,F=q.length;L<F;L++)Y.push(B)}else Y=O.reduce((L,F)=>{const W=F.patterns;return W?L.concat(W):L},[]);const te=function(L,F){if(typeof L!="string")return null;if(!F){let U;for(U=L.length;U>0;U--){const $=L.charCodeAt(U-1);if($===47||$===92)break}F=L.substr(U)}const W=q.indexOf(F);return W!==-1?Y[W]:null};te.basenames=q,te.patterns=Y,te.allBasenames=q;const ne=G.filter(L=>!L.basenames);return ne.push(te),ne}function me(G,B){return(0,I.equals)(G,B,(O,q)=>typeof O=="string"&&typeof q=="string"?O===q:typeof O!="string"&&typeof q!="string"?O.base===q.base&&O.pattern===q.pattern:!1)}e.patternsEquals=me}),define(Z[45],ee([0,1,25,32,9,4,19,27]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function m(i,s){const{os:o,tildify:l,relative:r}=s;if(r){const A=d(i,r,o);if(typeof A=="string")return A}let h=i.fsPath;if(o===1&&!R.isWindows?h=h.replace(/\//g,"\\"):o!==1&&R.isWindows&&(h=h.replace(/\\/g,"/")),o!==1&&l?.userHome){const A=l.userHome.fsPath;let T;i.scheme!==l.userHome.scheme&&i.path.startsWith(n.posix.sep)?T=l.userHome.with({path:i.path}).fsPath:T=i.fsPath,h=b(T,A,o)}return(o===1?n.win32:n.posix).normalize(w(h,o===1))}e.getPathLabel=m;function d(i,s,o){const l=o===1?n.win32:n.posix,r=o===3?C.extUri:C.extUriIgnorePathCase,h=s.getWorkspace(),P=(0,I.firstOrDefault)(h.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=P.uri.with({path:i.path}));const A=s.getWorkspaceFolder(i);if(!A)return;let T;if(r.isEqual(A.uri,i)?T="":T=r.relativePath(A.uri,i)??"",T&&(T=l.normalize(T)),h.folders.length>1&&!s.noPrefix){const N=A.name?A.name:r.basenameOrAuthority(A.uri);T=T?`${N} \u2022 ${T}`:N}return T}function w(i,s=R.isWindows){return(0,M.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=w;let v=Object.create(null);function b(i,s,o=R.OS){if(o===1||!i||!s)return i;let l=v.original===s?v.normalized:void 0;l||(l=s,R.isWindows&&(l=(0,M.toSlashes)(l)),l=`${(0,k.rtrim)(l,n.posix.sep)}${n.posix.sep}`,v={original:s,normalized:l});let r=i;return R.isWindows&&(r=(0,M.toSlashes)(r)),(o===3?r.startsWith(l):(0,k.startsWithIgnoreCase)(r,l))?`~/${r.substr(l.length)}`:i}e.tildify=b;function u(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=u;const y="\u2026",p="\\\\",a="~";function g(i,s=n.sep){const o=new Array(i.length);let l=!1;for(let r=0;r<i.length;r++){const h=i[r];if(h===""){o[r]=`.${s}`;continue}if(!h){o[r]=h;continue}l=!0;let P="",A=h;A.indexOf(p)===0?(P=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length)):A.indexOf(s)===0?(P=A.substr(0,A.indexOf(s)+s.length),A=A.substr(A.indexOf(s)+s.length)):A.indexOf(a)===0&&(P=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length));const T=A.split(s);for(let N=1;l&&N<=T.length;N++)for(let z=T.length-N;l&&z>=0;z--){l=!1;let H=T.slice(z,z+N).join(s);for(let ie=0;!l&&ie<i.length;ie++)if(ie!==r&&i[ie]&&i[ie].indexOf(H)>-1){const se=z+N===T.length,oe=z>0&&i[ie].indexOf(s)>-1?s+H:H,ue=i[ie].endsWith(oe);l=!se||ue}if(!l){let ie="";(T[0].endsWith(":")||P!=="")&&(z===1&&(z=0,N++,H=T[0]+s+H),z>0&&(ie=T[0]+s),ie=P+ie),z>0&&(ie=ie+y+s),ie=ie+H,z+N<T.length&&(ie=ie+s+y),o[r]=ie}}l&&(o[r]=h)}return o}e.shorten=g;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function E(i,s=Object.create(null)){const o=[];let l=!1,r="";for(const h of i)if(h==="$"||l&&h==="{")r&&o.push({value:r,type:f.TEXT}),r="",l=!0;else if(h==="}"&&l){const P=s[r];if(typeof P=="string")P.length&&o.push({value:P,type:f.VARIABLE});else if(P){const A=o[o.length-1];(!A||A.type!==f.SEPARATOR)&&o.push({value:P.label,type:f.SEPARATOR})}r="",l=!1}else r+=h;return r&&!l&&o.push({value:r,type:f.TEXT}),o.filter((h,P)=>{if(h.type===f.SEPARATOR){const A=o[P-1],T=o[P+1];return[A,T].every(N=>N&&(N.type===f.VARIABLE||N.type===f.TEXT)&&N.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=E;function S(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function D(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const s=i.indexOf("/")!==-1?n.posix:n.win32,o=s.basename(i),l=s.dirname(i);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(Z[149],ee([0,1,17,8]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(v){return v.toJSON()}class R{constructor(b){this.a=b}transformIncoming(b){const u=this.a.transformIncoming(b);return u===b?b:n(M.URI.from(u))}transformOutgoing(b){const u=this.a.transformOutgoing(b);return u===b?b:n(M.URI.from(u))}transformOutgoingURI(b){const u=this.a.transformOutgoing(b);return u===b?b:M.URI.from(u)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function C(v,b,u){if(!v||u>200)return null;if(typeof v=="object"){if(v instanceof M.URI)return b.transformOutgoing(v);for(const y in v)if(Object.hasOwnProperty.call(v,y)){const p=C(v[y],b,u+1);p!==null&&(v[y]=p)}}return null}function k(v,b){const u=C(v,b,0);return u===null?v:u}e.transformOutgoingURIs=k;function m(v,b,u,y){if(!v||y>200)return null;if(typeof v=="object"){if(v.$mid===1)return u?M.URI.revive(b.transformIncoming(v)):b.transformIncoming(v);if(v instanceof I.VSBuffer)return null;for(const p in v)if(Object.hasOwnProperty.call(v,p)){const a=m(v[p],b,u,y+1);a!==null&&(v[p]=a)}}return null}function d(v,b){const u=m(v,b,!1,0);return u===null?v:u}e.transformIncomingURIs=d;function w(v,b){const u=m(v,b,!0,0);return u===null?v:u}e.transformAndReviveIncomingURIs=w}),define(Z[84],ee([0,1,26,13,61,31,137]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(w){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,v=0;const b=(0,I.networkInterfaces)();for(const u in b){const y=b[u];if(y)for(const{mac:p,internal:a}of y)a||(v+=1,this.c(p.toUpperCase())&&(w+=1))}this.b=v>0?w/v:0}return this.b}};let k;async function m(){return k||(k=(async()=>await d()||R.generateUuid())()),k}e.getMachineId=m;async function d(){try{const w=await new Promise((b,u)=>{x(["crypto"],b,u)}),v=(0,C.getMac)();return w.createHash("sha256").update(v,"utf8").digest("hex")}catch(w){M.onUnexpectedError(w);return}}}),define(Z[23],ee([0,1,41,26,150,7,32,80,9,4,19,8]),function(x,e,I,M,n,R,C,k,m,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function u(oe,ue=b.UNLINK){if((0,C.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");return ue===b.UNLINK?p(oe):y(oe)}async function y(oe){try{const ue=(0,C.randomPath)((0,M.tmpdir)());try{await I.promises.rename(oe,ue)}catch(le){return le.code==="ENOENT"?void 0:p(oe)}p(ue).catch(le=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function p(oe){return(0,n.promisify)(I.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function a(oe){if((0,C.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function g(oe,ue){return S(await(ue?f(oe):(0,n.promisify)(I.readdir)(oe)))}async function f(oe){try{return await(0,n.promisify)(I.readdir)(oe,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const ue=[],le=await g(oe);for(const me of le){let G=!1,B=!1,O=!1;try{const q=await e.Promises.lstat((0,m.join)(oe,me));G=q.isFile(),B=q.isDirectory(),O=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ue.push({name:me,isFile:()=>G,isDirectory:()=>B,isSymbolicLink:()=>O})}return ue}function E(oe){return S(I.readdirSync(oe))}e.readdirSync=E;function S(oe){return oe.map(ue=>typeof ue=="string"?d.isMacintosh?(0,k.normalizeNFC)(ue):ue:(ue.name=d.isMacintosh?(0,k.normalizeNFC)(ue.name):ue.name,ue))}async function D(oe){const ue=await g(oe),le=[];for(const me of ue)await c.existsDirectory((0,m.join)(oe,me))&&le.push(me);return le}function t(oe,ue=1e3){return new Promise(le=>{let me=!1;const G=setInterval(()=>{me||(me=!0,I.access(oe,B=>{me=!1,B&&(clearInterval(G),le(void 0))}))},ue)})}e.whenDeleted=t;var c;(function(oe){async function ue(G){let B;try{if(B=await e.Promises.lstat(G),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(d.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw q}throw O}}oe.stat=ue;async function le(G){try{const{stat:B,symbolicLink:O}=await oe.stat(G);return B.isFile()&&O?.dangling!==!0}catch{}return!1}oe.existsFile=le;async function me(G){try{const{stat:B,symbolicLink:O}=await oe.stat(G);return B.isDirectory()&&O?.dangling!==!0}catch{}return!1}oe.existsDirectory=me})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function s(oe,ue,le){return i.queueFor(v.URI.file(oe),w.extUriBiasedIgnorePathCase).queue(()=>{const me=P(le);return new Promise((G,B)=>r(oe,ue,me,O=>O?B(O):G()))})}let o=!0;function l(oe){o=oe}e.configureFlushOnWrite=l;function r(oe,ue,le,me){if(!o)return I.writeFile(oe,ue,{mode:le.mode,flag:le.flag},me);I.open(oe,le.flag,le.mode,(G,B)=>{if(G)return me(G);I.writeFile(B,ue,O=>{if(O)return I.close(B,()=>me(O));I.fdatasync(B,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l(!1)),I.close(B,Y=>me(Y))))})})}function h(oe,ue,le){const me=P(le);if(!o)return I.writeFileSync(oe,ue,{mode:me.mode,flag:me.flag});const G=I.openSync(oe,me.flag,me.mode);try{I.writeFileSync(G,ue);try{I.fdatasyncSync(G)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),l(!1)}}finally{I.closeSync(G)}}e.writeFileSync=h;function P(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function A(oe,ue){if(oe!==ue)try{await e.Promises.rename(oe,ue)}catch(le){if(oe.toLowerCase()!==ue.toLowerCase()&&le.code==="EXDEV"||oe.endsWith("."))await T(oe,ue,{preserveSymlinks:!1}),await u(oe,b.MOVE);else throw le}}async function T(oe,ue,le){return z(oe,ue,{root:{source:oe,target:ue},options:le,handledSourcePaths:new Set})}const N=511;async function z(oe,ue,le){if(le.handledSourcePaths.has(oe))return;le.handledSourcePaths.add(oe);const{stat:me,symbolicLink:G}=await c.stat(oe);if(G){if(le.options.preserveSymlinks)try{return await se(oe,ue,le)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(G.dangling)return}return me.isDirectory()?H(oe,ue,me.mode&N,le):ie(oe,ue,me.mode&N)}async function H(oe,ue,le,me){await e.Promises.mkdir(ue,{recursive:!0,mode:le});const G=await g(oe);for(const B of G)await z((0,m.join)(oe,B),(0,m.join)(ue,B),me)}async function ie(oe,ue,le){await e.Promises.copyFile(oe,ue),await e.Promises.chmod(ue,le)}async function se(oe,ue,le){let me=await e.Promises.readlink(oe);(0,C.isEqualOrParent)(me,le.root.source,!d.isLinux)&&(me=(0,m.join)(le.root.target,me.substr(le.root.source.length+1))),await e.Promises.symlink(me,ue)}e.Promises=new class{get access(){return(0,n.promisify)(I.access)}get stat(){return(0,n.promisify)(I.stat)}get lstat(){return(0,n.promisify)(I.lstat)}get utimes(){return(0,n.promisify)(I.utimes)}get read(){return(oe,ue,le,me,G)=>new Promise((B,O)=>{I.read(oe,ue,le,me,G,(q,Y,te)=>q?O(q):B({bytesRead:Y,buffer:te}))})}get readFile(){return(0,n.promisify)(I.readFile)}get write(){return(oe,ue,le,me,G)=>new Promise((B,O)=>{I.write(oe,ue,le,me,G,(q,Y,te)=>q?O(q):B({bytesWritten:Y,buffer:te}))})}get appendFile(){return(0,n.promisify)(I.appendFile)}get fdatasync(){return(0,n.promisify)(I.fdatasync)}get truncate(){return(0,n.promisify)(I.truncate)}get rename(){return(0,n.promisify)(I.rename)}get copyFile(){return(0,n.promisify)(I.copyFile)}get open(){return(0,n.promisify)(I.open)}get close(){return(0,n.promisify)(I.close)}get symlink(){return(0,n.promisify)(I.symlink)}get readlink(){return(0,n.promisify)(I.readlink)}get chmod(){return(0,n.promisify)(I.chmod)}get mkdir(){return(0,n.promisify)(I.mkdir)}get unlink(){return(0,n.promisify)(I.unlink)}get rmdir(){return(0,n.promisify)(I.rmdir)}get realpath(){return(0,n.promisify)(I.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return D}get writeFile(){return s}get rm(){return u}get move(){return A}get copy(){return T}}}),define(Z[102],ee([0,1,41,9,4,27,23]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(b){if(n.isLinux)return b;const u=(0,M.dirname)(b);if(b===u)return b;const y=((0,M.basename)(b)||b).toLowerCase();try{const a=(0,C.readdirSync)(u).filter(g=>g.toLowerCase()===y);if(a.length===1){const g=k(u);if(g)return(0,M.join)(g,a[0])}else if(a.length>1){const g=a.indexOf(y);if(g>=0){const f=k(u);if(f)return(0,M.join)(f,a[g])}}}catch{}return null}e.realcaseSync=k;async function m(b){if(n.isLinux)return b;const u=(0,M.dirname)(b);if(b===u)return b;const y=((0,M.basename)(b)||b).toLowerCase();try{const a=(await C.Promises.readdir(u)).filter(g=>g.toLowerCase()===y);if(a.length===1){const g=await m(u);if(g)return(0,M.join)(g,a[0])}else if(a.length>1){const g=a.indexOf(y);if(g>=0){const f=await m(u);if(f)return(0,M.join)(f,a[g])}}}catch{}return null}e.realcase=m;async function d(b){try{return await C.Promises.realpath(b)}catch{const y=v(b);return await C.Promises.access(y,I.constants.R_OK),y}}e.realpath=d;function w(b){try{return I.realpathSync(b)}catch{const y=v(b);return I.accessSync(y,I.constants.R_OK),y}}e.realpathSync=w;function v(b){return(0,R.rtrim)((0,M.normalize)(b),M.sep)}}),define(Z[151],ee([0,1,26,9,23]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,C=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var m;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(m||(m={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class v{constructor(D,t,c){this.exePath=D,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:S=!1}={}){return S?d===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:S=!1,findPreview:D=!1}={}){const t=b({useAlternateBitness:S});if(!t)return null;const c=M.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(c))return null;let i=-1,s=null;for(const r of await n.Promises.readdir(c)){let h=-1;if(D){const A=r.indexOf("-");if(A<0)continue;const T=r.substring(0,A);if(!R.test(T)||r.substring(A+1)!=="preview")continue;h=parseInt(T,10)}else{if(!R.test(r))continue;h=parseInt(r,10)}if(h<=i)continue;const P=M.join(c,r,"pwsh.exe");!await n.SymlinkSupport.existsFile(P)||(s=P,i=h)}if(!s)return null;const o=t.includes("x86")?" (x86)":"",l=D?" Preview":"";return new v(s,`PowerShell${l}${o}`,!0)}async function y({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const D=M.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=S?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(D))if(t.test(i)){const s=M.join(D,i,"pwsh.exe");return new v(s,c)}return null}function p(){const S=M.join(I.homedir(),".dotnet","tools","pwsh.exe");return new v(S,".NET Core PowerShell Global Tool")}function a(){const S=M.join(process.env.windir,d===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(S,"Windows PowerShell",!0)}async function*g(){let S=await u();S&&(yield S),S=await u({useAlternateBitness:!0}),S&&(yield S),S=await y(),S&&(yield S),S=p(),S&&(yield S),S=await u({findPreview:!0}),S&&(yield S),S=await y({findPreview:!0}),S&&(yield S),S=await u({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=a(),S&&(yield S)}async function*f(){for await(const S of g())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=f;async function E(){for await(const S of f())return S;return null}e.getFirstAvailablePowerShellInstallation=E}),define(Z[85],ee([0,1,9,4,36,71,10,23]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function m(v=n.env){return v.comspec||"cmd.exe"}e.getWindowsShell=m;function d(v){let b=[],u=!1;const y=function(p){if(u){b.push(p);return}(!v.send(p,g=>{if(g&&console.error(g),u=!1,b.length>0){const f=b.slice(0);b=[],f.forEach(E=>y(E))}})||M.isWindows)&&(u=!0)};return{send:y}}e.createQueuedSender=d;var w;(function(v){async function b(u,y,p){if(I.isAbsolute(u))return u;if(y===void 0&&(y=n.cwd()),I.dirname(u)!=="."||(p===void 0&&C.isString(n.env.PATH)&&(p=n.env.PATH.split(I.delimiter)),p===void 0||p.length===0))return I.join(y,u);async function g(f){if(await k.Promises.exists(f)){let E;try{E=await k.Promises.stat(f)}catch(S){S.message.startsWith("EACCES")&&(E=await k.Promises.lstat(f))}return E?!E.isDirectory():!1}return!1}for(const f of p){let E;if(I.isAbsolute(f)?E=I.join(f,u):E=I.join(y,f,u),await g(E))return E;let S=E+".com";if(await g(S)||(S=E+".exe",await g(S)))return S}return I.join(y,u)}v.findExecutable=b})(w=e.win32||(e.win32={}))}),define(Z[103],ee([0,1,46,14]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(C){return new Promise((k,m)=>{let d;const w=new Map;function v(u,y,p,a,g){const f=w.get(y);if(u===C||f){const E={name:b(p),cmd:p,pid:u,ppid:y,load:a,mem:g};w.set(u,E),u===C&&(d=E),f&&(f.children||(f.children=[]),f.children.push(E),f.children.length>1&&(f.children=f.children.sort((S,D)=>S.pid-D.pid)))}}function b(u){const y=/--vscode-window-kind=shared-process/i,p=/--vscode-window-kind=issue-reporter/i,a=/--vscode-window-kind=process-explorer/i,g=/--utility-sub-type=network/i,f=/--vscode-utility-kind=extensionHost/i,E=/--vscode-utility-kind=fileWatcher/i,S=/--vscode-utility-kind=shared-process/i,D=/--ms-enable-electron-run-as-node/i,t=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,i=/conhost\.exe/i,s=/--type=([a-zA-Z-]+)/;if(t.exec(u))return"electron-crash-reporter";if(c.exec(u))return"winpty-process";if(i.exec(u))return"console-window-host (Windows internal process)";let o=s.exec(u);if(o&&o.length===2){if(o[1]==="renderer")return y.exec(u)?"shared-process":p.exec(u)?"issue-reporter":a.exec(u)?"process-explorer":"window";if(o[1]==="utility"){if(g.exec(u))return"utility-network-service";if(f.exec(u))return"extension-host";if(E.exec(u))return"file-watcher";if(S.exec(u))return"shared-process"}else if(o[1]==="extensionHost")return"extension-host";return o[1]}const l=/[a-zA-Z-]+\.js/g;let r="";do o=l.exec(u),o&&(r+=o+" ");while(o);return r&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs ${r}`:D.exec(u)?"electron-nodejs":u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substr(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substr(5):y;new Promise((y,p)=>{x(["windows-process-tree"],y,p)}).then(y=>{y.getProcessList(C,p=>{if(!p){m(new Error(`Root process ${C} not found`));return}y.getProcessCpuUsage(p,a=>{const g=new Map;a.forEach(f=>{const E=u(f.commandLine||"");g.set(f.pid,{name:b(E),cmd:E,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),d=g.get(C),d?(g.forEach(f=>{const E=g.get(f.ppid);E&&(E.children||(E.children=[]),E.children.push(f))}),g.forEach(f=>{f.children&&(f.children=f.children.sort((E,S)=>E.pid-S.pid))}),k(d)):m(new Error(`Root process ${C} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[d];const p=[];for(;y.length;){const g=y.shift();g&&(p.push(g.pid),g.children&&(y=y.concat(g.children)))}let a=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+p.join(" "),(0,I.exec)(a,{},(g,f,E)=>{if(g||E)m(g||new Error(E.toString()));else{const S=f.toString().split(`
`);for(let D=0;D<p.length;D++){const t=w.get(p[D]);t.load=parseFloat(S[D])}if(!d){m(new Error(`Root process ${C} not found`));return}k(d)}})};(0,I.exec)("which ps",{},(y,p,a)=>{if(y||a)if(process.platform!=="linux")m(y||new Error(a.toString()));else{const g=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(g,{},(f,E,S)=>{f||S?m(f||new Error(S.toString())):(R(E,v),u())})}else{const g=p.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${g} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(E,S,D)=>{E||D&&!D.includes("screen size is bogus")?m(E||new Error(D.toString())):(R(S,v),process.platform==="linux"?u():d?k(d):m(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=n;function R(C,k){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=C.toString().split(`
`);for(const w of d){const v=m.exec(w.trim());v&&v.length===6&&k(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Z[152],ee([0,1,26,4,151,85]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(v,b){return v===1?M.isWindows?w():R.getWindowsShell(b):m(v,b)}e.getSystemShell=C;let k=null;function m(v,b){if(M.isLinux&&v===2||M.isMacintosh&&v===3)return"/bin/bash";if(!k){let u;if(M.isWindows)u="/bin/bash";else{if(u=b.SHELL,!u)try{u=(0,I.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}k=u}return k}let d=null;async function w(){return d||(d=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),d}});var ve=this&&this.__decorate||function(x,e,I,M){var n=arguments.length,R=n<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,I):M,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,e,I,M);else for(var k=x.length-1;k>=0;k--)(C=x[k])&&(R=(n<3?C(R):n>3?C(e,I,R):C(e,I))||R);return n>3&&R&&Object.defineProperty(e,I,R),R};define(Z[47],ee([0,1,25,7,17,22,54,13,3,2,83,27,10]),function(x,e,I,M,n,R,C,k,m,d,w,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(u||(u={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(p||(p={}));function a(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(g||(g={}));function f(B){let O=0;for(let q=0;;q+=7){const Y=B.read(1);if(O|=(Y.buffer[0]&127)<<q,!(Y.buffer[0]&128))return O}}const E=i(0);function S(B,O){if(O===0){B.write(E);return}let q=0;for(let te=O;te!==0;te=te>>>7)q++;const Y=n.VSBuffer.alloc(q);for(let te=0;O!==0;te++)Y.buffer[te]=O&127,O=O>>>7,O>0&&(Y.buffer[te]|=128);B.write(Y)}class D{constructor(O){this.b=O,this.a=0}read(O){const q=this.b.slice(this.a,this.a+O);return this.a+=q.byteLength,q}}e.BufferReader=D;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(O){this.a.push(O)}}e.BufferWriter=t;var c;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(c||(c={}));function i(B){const O=n.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const s={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},o=typeof Buffer<"u";function l(B,O){if(typeof O>"u")B.write(s.Undefined);else if(typeof O=="string"){const q=n.VSBuffer.fromString(O);B.write(s.String),S(B,q.byteLength),B.write(q)}else if(o&&Buffer.isBuffer(O)){const q=n.VSBuffer.wrap(O);B.write(s.Buffer),S(B,q.byteLength),B.write(q)}else if(O instanceof n.VSBuffer)B.write(s.VSBuffer),S(B,O.byteLength),B.write(O);else if(Array.isArray(O)){B.write(s.Array),S(B,O.length);for(const q of O)l(B,q)}else if(typeof O=="number"&&(O|0)===O)B.write(s.Uint),S(B,O);else{const q=n.VSBuffer.fromString(JSON.stringify(O));B.write(s.Object),S(B,q.byteLength),B.write(q)}}e.serialize=l;function r(B){switch(B.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return B.read(f(B)).toString();case c.Buffer:return B.read(f(B)).buffer;case c.VSBuffer:return B.read(f(B));case c.Array:{const q=f(B),Y=[];for(let te=0;te<q;te++)Y.push(r(B));return Y}case c.Object:return JSON.parse(B.read(f(B)).toString());case c.Int:return f(B)}}e.deserialize=r;class h{constructor(O,q,Y=null,te=1e3){this.h=O,this.j=q,this.k=Y,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(O,q){this.b.set(O,q),setTimeout(()=>this.w(O),0)}m(O){switch(O.type){case 200:{const q=this.o([O.type]);this.k?.logOutgoing(q,0,1,a(O.type));return}case 201:case 202:case 204:case 203:{const q=this.o([O.type,O.id],O.data);this.k?.logOutgoing(q,O.id,1,a(O.type),O.data);return}}}o(O,q=void 0){const Y=new t;return l(Y,O),l(Y,q),this.p(Y.buffer)}p(O){try{return this.h.send(O),O.byteLength}catch{return 0}}q(O){const q=new D(O),Y=r(q),te=r(q),ne=Y[0];switch(ne){case 100:return this.k?.logIncoming(O.byteLength,Y[1],1,`${y(ne)}: ${Y[2]}.${Y[3]}`,te),this.s({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case 102:return this.k?.logIncoming(O.byteLength,Y[1],1,`${y(ne)}: ${Y[2]}.${Y[3]}`,te),this.t({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case 101:return this.k?.logIncoming(O.byteLength,Y[1],1,`${y(ne)}`),this.u({type:ne,id:Y[1]});case 103:return this.k?.logIncoming(O.byteLength,Y[1],1,`${y(ne)}`),this.u({type:ne,id:Y[1]})}}s(O){const q=this.b.get(O.channelName);if(!q){this.v(O);return}const Y=new R.CancellationTokenSource;let te;try{te=q.call(this.j,O.name,O.arg,Y.token)}catch(F){te=Promise.reject(F)}const ne=O.id;te.then(F=>{this.m({id:ne,data:F,type:201}),this.d.delete(O.id)},F=>{F instanceof Error?this.m({id:ne,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:ne,data:F,type:203}),this.d.delete(O.id)});const L=(0,d.toDisposable)(()=>Y.cancel());this.d.set(O.id,L)}t(O){const q=this.b.get(O.channelName);if(!q){this.v(O);return}const Y=O.id,ne=q.listen(this.j,O.name,O.arg)(L=>this.m({id:Y,data:L,type:204}));this.d.set(O.id,ne)}u(O){const q=this.d.get(O.id);q&&(q.dispose(),this.d.delete(O.id))}v(O){let q=this.g.get(O.channelName);q||(q=[],this.g.set(O.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.m({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:O,timeoutTimer:Y})}w(O){const q=this.g.get(O);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(O)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var P;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(O,q=null){this.l=O,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=q}getChannel(O){const q=this;return{call(Y,te,ne){return q.a?Promise.reject(new k.CancellationError):q.m(O,Y,te,ne)},listen(Y,te){return q.a?m.Event.None:q.o(O,Y,te)}}}m(O,q,Y,te=R.CancellationToken.None){const ne=this.g++,F={id:ne,type:100,channelName:O,name:q,arg:Y};if(te.isCancellationRequested)return Promise.reject(new k.CancellationError);let W;return new Promise(($,V)=>{if(te.isCancellationRequested)return V(new k.CancellationError);const j=()=>{const de=Ce=>{switch(Ce.type){case 201:this.f.delete(ne),$(Ce.data);break;case 202:{this.f.delete(ne);const Re=new Error(Ce.data.message);Re.stack=Array.isArray(Ce.data.stack)?Ce.data.stack.join(`
`):Ce.data.stack,Re.name=Ce.data.name,V(Re);break}case 203:this.f.delete(ne),V(Ce.data);break}};this.f.set(ne,de),this.p(F)};let K=null;this.b===g.Idle?j():(K=(0,M.createCancelablePromise)(de=>this.u()),K.then(()=>{K=null,j()}));const J=()=>{K?(K.cancel(),K=null):this.p({id:ne,type:101}),V(new k.CancellationError)},re=te.onCancellationRequested(J);W=(0,d.combinedDisposable)((0,d.toDisposable)(J),re),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(O,q,Y){const te=this.g++,L={id:te,type:102,channelName:O,name:q,arg:Y};let F=null;const W=new m.Emitter({onWillAddFirstListener:()=>{F=(0,M.createCancelablePromise)($=>this.u()),F.then(()=>{F=null,this.d.add(W),this.p(L)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(W),this.p({id:te,type:103}))}}),U=$=>W.fire($.data);return this.f.set(te,U),W.event}p(O){switch(O.type){case 100:case 102:{const q=this.q([O.type,O.id,O.channelName,O.name],O.arg);this.j?.logOutgoing(q,O.id,0,`${y(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const q=this.q([O.type,O.id]);this.j?.logOutgoing(q,O.id,0,y(O.type));return}}}q(O,q=void 0){const Y=new t;return l(Y,O),l(Y,q),this.r(Y.buffer)}r(O){try{return this.l.send(O),O.byteLength}catch{return 0}}s(O){const q=new D(O),Y=r(q),te=r(q),ne=Y[0];switch(ne){case 200:return this.j?.logIncoming(O.byteLength,0,0,a(ne)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(O.byteLength,Y[1],0,a(ne),te),this.t({type:Y[0],id:Y[1],data:te})}}t(O){if(O.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(O.id)?.(O)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}ve([C.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class T{get connections(){const O=[];return this.f.forEach(q=>O.push(q)),O}constructor(O){this.a=new Map,this.f=new Set,this.g=new m.Emitter,this.onDidAddConnection=this.g.event,this.h=new m.Emitter,this.onDidRemoveConnection=this.h.event,O(({protocol:q,onDidClientDisconnect:Y})=>{m.Event.once(q.onMessage)(ne=>{const L=new D(ne),F=r(L),W=new h(q,F),U=new A(q);this.a.forEach((V,j)=>W.registerChannel(j,V));const $={channelServer:W,channelClient:U,ctx:F};this.f.add($),this.g.fire($),Y(()=>{W.dispose(),U.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(O,q){const Y=this;return{call(te,ne,L){let F;if((0,b.isFunction)(q)){const U=(0,I.getRandomElement)(Y.connections.filter(q));F=U?Promise.resolve(U):m.Event.toPromise(m.Event.filter(Y.onDidAddConnection,q))}else F=q.routeCall(Y,te,ne);const W=F.then(U=>U.channelClient.getChannel(O));return z(W).call(te,ne,L)},listen(te,ne){if((0,b.isFunction)(q))return Y.j(O,q,te,ne);const L=q.routeEvent(Y,te,ne).then(F=>F.channelClient.getChannel(O));return z(L).listen(te,ne)}}}j(O,q,Y,te){const ne=this;let L=new d.DisposableStore;const F=new m.Emitter({onWillAddFirstListener:()=>{L=new d.DisposableStore;const W=new m.EventMultiplexer,U=new Map,$=j=>{const J=j.channelClient.getChannel(O).listen(Y,te),re=W.add(J);U.set(j,re)},V=j=>{const K=U.get(j);!K||(K.dispose(),U.delete(j))};ne.connections.filter(q).forEach($),m.Event.filter(ne.onDidAddConnection,q)($,void 0,L),ne.onDidRemoveConnection(V,void 0,L),W.event(F.fire,F,L),L.add(W)},onDidRemoveLastListener:()=>{L.dispose()}});return F.event}registerChannel(O,q){this.a.set(O,q),this.f.forEach(Y=>{Y.channelServer.registerChannel(O,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class N{constructor(O,q,Y=null){const te=new t;l(te,q),O.send(te.buffer),this.a=new A(O,Y),this.d=new h(O,q,Y)}getChannel(O){return this.a.getChannel(O)}registerChannel(O,q){this.d.registerChannel(O,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function z(B){return{call(O,q,Y){return B.then(te=>te.call(O,q,Y))},listen(O,q){const Y=new m.Relay;return B.then(te=>Y.input=te.listen(O,q)),Y.event}}}e.getDelayedChannel=z;function H(B){let O=!1;return{call(q,Y,te){return O?B.call(q,Y,te):(0,M.timeout)(0).then(()=>O=!0).then(()=>B.call(q,Y,te))},listen(q,Y){if(O)return B.listen(q,Y);const te=new m.Relay;return(0,M.timeout)(0).then(()=>O=!0).then(()=>te.input=B.listen(q,Y)),te.event}}}e.getNextTickChannel=H;class ie{constructor(O){this.a=O}routeCall(O){return this.b(O)}routeEvent(O){return this.b(O)}async b(O){for(const q of O.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await m.Event.toPromise(O.onDidAddConnection),await this.b(O)}}e.StaticRouter=ie;var se;(function(B){function O(ne,L){const F=ne,W=L&&L.disableMarshalling,U=new Map;for(const $ in F)Y($)&&U.set($,m.Event.buffer(F[$],!0));return new class{listen($,V,j){const K=U.get(V);if(K)return K;if(te(V)){const J=F[V];if(typeof J=="function")return J.call(F,j)}throw new Error(`Event not found: ${V}`)}call($,V,j){const K=F[V];if(typeof K=="function"){if(!W&&Array.isArray(j))for(let J=0;J<j.length;J++)j[J]=(0,w.revive)(j[J]);return K.apply(F,j)}throw new Error(`Method not found: ${V}`)}}}B.fromService=O;function q(ne,L){const F=L&&L.disableMarshalling;return new Proxy({},{get(W,U){if(typeof U=="string")return L?.properties?.has(U)?L.properties.get(U):te(U)?function($){return ne.listen(U,$)}:Y(U)?ne.listen(U):async function(...$){let V;L&&!(0,b.isUndefinedOrNull)(L.context)?V=[L.context,...$]:V=$;const j=await ne.call(U,V);return F?j:(0,w.revive)(j)};throw new Error(`Property not found: ${String(U)}`)}})}B.toService=q;function Y(ne){return ne[0]==="o"&&ne[1]==="n"&&v.isUpperAsciiLetter(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&v.isUpperAsciiLetter(ne.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const O=B.toString();if(O!=="[object Object]")return O}return B}function le(B){return Array.isArray(B)?B.map(ue):ue(B)}function me(B,O,q,Y,te,ne,L){L=le(L);const F=oe[te],W=F[Y%F.length];let U=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(ne)?(U=U.concat(L),U.push(")")):U.push(L),console.log.apply(console,U)}class G{constructor(O,q){this.d=O,this.f=q,this.a=0,this.b=0}logOutgoing(O,q,Y,te,ne){this.b+=O,me(this.d,this.b,O,q,Y,te,ne)}logIncoming(O,q,Y,te,ne){this.a+=O,me(this.f,this.a,O,q,Y,te,ne)}}e.IPCLogger=G}),define(Z[153],ee([0,1,17,3,47]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(m){this.a=m,this.onMessage=M.Event.fromDOMEventEmitter(this.a,"message",d=>I.VSBuffer.wrap(d.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class C extends n.IPCClient{constructor(m,d){const w=new R(m);super(w,d),this.b=w}dispose(){this.b.disconnect()}}e.Client=C}),define(Z[104],ee([0,1,7,17,3,2,47]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(A){A.Created="created",A.Read="read",A.Write="write",A.Open="open",A.Error="error",A.Close="close",A.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",A.NodeEndReceived="nodeEndReceived",A.NodeEndSent="nodeEndSent",A.NodeDrainBegin="nodeDrainBegin",A.NodeDrainEnd="nodeDrainEnd",A.zlibInflateError="zlibInflateError",A.zlibInflateData="zlibInflateData",A.zlibInflateInitialWrite="zlibInflateInitialWrite",A.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",A.zlibInflateWrite="zlibInflateWrite",A.zlibInflateFlushFired="zlibInflateFlushFired",A.zlibDeflateError="zlibDeflateError",A.zlibDeflateData="zlibDeflateData",A.zlibDeflateWrite="zlibDeflateWrite",A.zlibDeflateFlushFired="zlibDeflateFlushFired",A.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",A.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",A.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",A.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",A.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",A.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",A.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",A.ProtocolHeaderRead="protocolHeaderRead",A.ProtocolMessageRead="protocolMessageRead",A.ProtocolHeaderWrite="protocolHeaderWrite",A.ProtocolMessageWrite="protocolMessageWrite",A.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var m;(function(A){A.enableDiagnostics=!1,A.records=[];const T=new WeakMap;let N=0;function z(ie,se){if(!T.has(ie)){const oe=String(++N);T.set(ie,oe)}return T.get(ie)}function H(ie,se,oe,ue){if(!A.enableDiagnostics)return;const le=z(ie,se);if(ue instanceof M.VSBuffer||ue instanceof Uint8Array||ue instanceof ArrayBuffer||ArrayBuffer.isView(ue)){const me=M.VSBuffer.alloc(ue.byteLength);me.set(ue),A.records.push({timestamp:Date.now(),id:le,label:se,type:oe,buff:me})}else A.records.push({timestamp:Date.now(),id:le,label:se,type:oe,data:ue})}A.traceSocketEvent=H})(m=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(A){A[A.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",A[A.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function v(){return w||(w=M.VSBuffer.alloc(0)),w}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,N){if(T===0)return v();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const se=this.a[0];return N&&(this.a.shift(),this.b-=T),se}if(this.a[0].byteLength>T){const se=this.a[0].slice(0,T);return N&&(this.a[0]=this.a[0].slice(T),this.b-=T),se}const z=M.VSBuffer.alloc(T);let H=0,ie=0;for(;T>0;){const se=this.a[ie];if(se.byteLength>T){const oe=se.slice(0,T);z.set(oe,H),H+=T,N&&(this.a[ie]=se.slice(T),this.b-=T),T-=T}else z.set(se,H),H+=se.byteLength,N?(this.a.shift(),this.b-=se.byteLength):ie++,T-=se.byteLength}return z}}e.ChunkStream=b;var u;(function(A){A[A.None=0]="None",A[A.Regular=1]="Regular",A[A.Control=2]="Control",A[A.Ack=3]="Ack",A[A.Disconnect=5]="Disconnect",A[A.ReplayRequest=6]="ReplayRequest",A[A.Pause=7]="Pause",A[A.Resume=8]="Resume",A[A.KeepAlive=9]="KeepAlive",A[A.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",A[A.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(u||(u={}));function y(A){switch(A){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(A){A[A.HeaderLength=13]="HeaderLength",A[A.AcknowledgeTime=2e3]="AcknowledgeTime",A[A.TimeoutTime=2e4]="TimeoutTime",A[A.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",A[A.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",A[A.KeepAliveSendTime=5e3]="KeepAliveSendTime",A[A.LatencySampleTime=6e4]="LatencySampleTime",A[A.LatencySampleCount=5]="LatencySampleCount",A[A.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",A[A.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(T,N,z,H){this.type=T,this.id=N,this.ack=z,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends R.Disposable{constructor(T){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new b,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const z=this.g.messageType,H=this.g.id,ie=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new a(z,H,ie,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=M.VSBuffer.alloc(13);N.writeUInt8(T.type,0),N.writeUInt32BE(T.id,1),N.writeUInt32BE(T.ack,5),N.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(N,T.data)}g(T,N){const z=this.f===0;return this.d.push(T,N),this.f+=T.byteLength+N.byteLength,z}h(){const T=M.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,N){this.g(T,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class E extends R.Disposable{constructor(T){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new f(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new a(1,0,0,T))}}e.Protocol=E;class S extends C.IPCClient{static fromSocket(T,N){return new S(new E(T),N)}get onDidDispose(){return this.b.onDidDispose}constructor(T,N,z=null){super(T,N,z),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=S;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class t{constructor(T){this.data=T,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let T=0,N=this.a;for(;N;)N=N.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let N=0,z=this.a;for(;z;)T[N++]=z.data,z=z.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const N=new t(T);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let N=0;N<i.a;N++)this.c[N]=T-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),N=(1+i.a)*1e3;let z=0;for(let H=0;H<i.a;H++)T-this.c[H]<=N&&z++;return 1-z/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var s;(function(A){A[A.Good=0]="Good",A[A.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function o(A){switch(A){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class l{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=l;class r{constructor(T,N){this.roundTripTime=T,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=r;class h{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=T.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new a(5,0,0,v());this.p.write(T),this.p.flush()}sendPause(){const T=new a(7,0,0,v());this.p.write(T)}sendResume(){const T=new a(8,0,0,v());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,N){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new a(3,0,this.h,v());this.p.write(T);const N=this.b.toArray();for(let z=0,H=N.length;z<H;z++)this.p.write(N[z]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const N=this.b.peek();if(N&&N.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new a(6,0,0,v())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let z=0,H=N.length;z<H;z++)this.p.write(N[z]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const N=++this.c;this.h=this.g;const z=new a(1,N,this.h,T);this.b.push(z),this.a||(this.p.write(z),this.G())}sendControl(T){const N=new a(2,0,0,T);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),N=Date.now()-T.writtenTime,z=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(N>=2e4&&z>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:z});return}const ie=Math.max(2e4-N,2e4-z,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},ie)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new a(3,0,this.h,v());this.p.write(T)}I(){this.h=this.g;const T=new a(9,0,this.h,v());this.p.write(T)}J(T){this.h=this.g;const N=new a(10,0,this.h,T);this.p.write(N)}K(T){this.h=this.g;const N=new a(11,0,this.h,T);this.p.write(N)}}e.PersistentProtocol=h;class P extends R.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new I.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,N=M.VSBuffer.alloc(4);N.writeUInt32BE(T,0),this.a.fire(N)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const N=T.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const z=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=z;const ie=this.l,se=this.j.filter(oe=>oe>=1e3).length;this.l=se>=3?1:0,z>1e3&&this.b.fire(new r(z,se)),ie!==this.l&&this.c.fire(this.l)}}}),define(Z[154],ee([0,1,42,17,3,2,47,139]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function m(w,v){const b=n.Event.fromNodeEventEmitter(I.validatedIpcMain,v,(y,p)=>({event:y,message:p})),u=n.Event.filter(b,({event:y})=>y.sender.id===w);return n.Event.map(u,({message:y})=>y&&M.VSBuffer.wrap(y))}class d extends C.IPCServer{static d(){const v=n.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:b})=>b);return n.Event.map(v,b=>{const u=b.id;d.b.get(u)?.dispose();const p=new n.Emitter;d.b.set(u,(0,R.toDisposable)(()=>p.fire()));const a=m(u,"vscode:message"),g=n.Event.any(n.Event.signal(m(u,"vscode:disconnect")),p.event);return{protocol:new k.Protocol(b,a),onDidClientDisconnect:g}})}constructor(){super(d.d())}}d.b=new Map,e.Server=d}),define(Z[105],ee([0,1,42,3,31,153]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class C extends R.Client{constructor(d,w){super({addEventListener:(v,b)=>d.addListener(v,b),removeEventListener:(v,b)=>d.removeListener(v,b),postMessage:v=>d.postMessage(v),start:()=>d.start(),close:()=>d.close()},w)}}e.Client=C;async function k(m){if(m.isDestroyed()||m.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,n.generateUuid)();m.webContents.send("vscode:createMessageChannel",d);const w=M.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(b,u)=>({nonce:u,port:b.ports[0]})),{port:v}=await M.Event.toPromise(M.Event.once(M.Event.filter(w,b=>b.nonce===d)));return v}e.connect=k}),define(Z[155],ee([0,1,46,7,17,22,148,13,3,2,37,85,71,47]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends u.ChannelServer{constructor(g){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",f=>n.VSBuffer.wrap(Buffer.from(f,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=y;class p{constructor(g,f){this.i=g,this.j=f,this.c=new Set,this.g=new Map,this.h=new m.Emitter,this.onDidProcessExit=this.h.event;const E=f&&f.timeout?f.timeout:6e4;this.b=new M.Delayer(E),this.d=null,this.f=null}getChannel(g){const f=this;return{call(E,S,D){return f.k(g,E,S,D)},listen(E,S){return f.l(g,E,S)}}}k(g,f,E,S=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const D=this.n(g),t=(0,M.createCancelablePromise)(s=>D.call(f,E,s)),c=S.onCancellationRequested(()=>t.cancel()),i=(0,d.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{c.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,f,E){if(!this.b)return m.Event.None;this.b.cancel();let S;const D=new m.Emitter({onWillAddFirstListener:()=>{S=this.n(g).listen(f,E)(D.fire,D),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(f.env),this.d=(0,I.fork)(this.i,g,f);const E=new m.Emitter;m.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.isRemoteConsoleLog)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}E.fire(n.VSBuffer.wrap(Buffer.from(o,"base64")))});const D=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&D.send(o.buffer.toString("base64")),c=E.event,i={send:t,onMessage:c};this.f=new u.ChannelClient(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),this.c.forEach(r=>(0,d.dispose)(r)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(g){let f=this.g.get(g);return f||(f=this.m.getChannel(g),this.g.set(g,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(Z[86],ee([0,1,17,13,3,2,9,4,31,47,104]),function(x,e,I,M,n,R,C,k,m,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(r,h){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,h)}constructor(r,h=""){this.f=!0,this.debugLabel=h,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,M.onUnexpectedError)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const h=P=>{this.traceSocketEvent("read",P),r(I.VSBuffer.wrap(P))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(r){const h=P=>{r({type:0,hadError:P,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(r){const h=()=>{r()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,M.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,M.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=b;var u;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(u||(u={}));var y;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(y||(y={}));class p extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,h){this.socket.traceSocketEvent(r,h)}constructor(r,h,P,A){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:P?.byteLength||0,recordInflateBytes:A}),this.a=this.B(new a(this,h,P,A,this.f,(T,N)=>this.k(T,N))),this.B(this.a.onError(T=>{console.error(T),(0,M.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new w.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let P=2;r.byteLength<126?P+=0:r.byteLength<2**16?P+=2:P+=8;const A=I.VSBuffer.alloc(P);if(h?A.writeUInt8(194,0):A.writeUInt8(130,0),r.byteLength<126)A.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){A.writeUInt8(126,1);let T=1;A.writeUInt8(r.byteLength>>>8&255,++T),A.writeUInt8(r.byteLength>>>0&255,++T)}else{A.writeUInt8(127,1);let T=1;A.writeUInt8(0,++T),A.writeUInt8(0,++T),A.writeUInt8(0,++T),A.writeUInt8(0,++T),A.writeUInt8(r.byteLength>>>24&255,++T),A.writeUInt8(r.byteLength>>>16&255,++T),A.writeUInt8(r.byteLength>>>8&255,++T),A.writeUInt8(r.byteLength>>>0&255,++T)}this.socket.write(I.VSBuffer.concat([A,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),P=h.readUInt8(0),A=(P&128)>>>7,T=(P&64)>>>6,N=h.readUInt8(1),z=(N&128)>>>7,H=N&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=A,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(A),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),P=h.readUInt8(1),A=(P&128)>>>7;let T=P&127,N=1;T===126?T=h.readUInt8(++N)*2**8+h.readUInt8(++N):T===127&&(T=h.readUInt8(++N)*0+h.readUInt8(++N)*0+h.readUInt8(++N)*0+h.readUInt8(++N)*0+h.readUInt8(++N)*2**24+h.readUInt8(++N)*2**16+h.readUInt8(++N)*2**8+h.readUInt8(++N));let z=0;A&&(z=h.readUInt8(++N)*2**24+h.readUInt8(++N)*2**16+h.readUInt8(++N)*2**8+h.readUInt8(++N)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),E(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class a extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(r,h,P,A,T,N){super(),this.k=r,this.l=T,this.m=N,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,h?(this.b=this.B(new g(this.k,A,P,{windowBits:15})),this.f=this.B(new f(this.k,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const h=await this.r(this.f,r);this.m(h,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,h){return new Promise((P,A)=>{r.write(h),r.flush(T=>P(T))})}acceptFrame(r,h,P){this.h.push({data:r,isCompressed:h,isLastFrameOfMessage:P}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const h=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(h)}else this.l.fire(r.data)}this.s=!1}}u(r,h,P){return new Promise((A,T)=>{r.write(h),P&&r.write(I.VSBuffer.fromByteArray([0,0,255,255])),r.flush(N=>A(N))})}}class g extends R.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(r,h,P,A){super(),this.h=r,this.j=h,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(A),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(I.VSBuffer.wrap(T))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=I.VSBuffer.concat(this.g);this.g.length=0,r(h)})}}class f extends R.Disposable{constructor(r,h){super(),this.g=r,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(I.VSBuffer.wrap(P))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=I.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),r(h)})}}function E(l,r){if(r===0)return;const h=l.byteLength>>>2;for(let H=0;H<h;H++){const ie=l.readUInt32BE(H*4);l.writeUInt32BE(ie^r,H*4)}const P=h*4,A=l.byteLength-P,T=r>>>24&255,N=r>>>16&255,z=r>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(P)^T,P),A>=2&&l.writeUInt8(l.readUInt8(P+1)^N,P+1),A>=3&&l.writeUInt8(l.readUInt8(P+2)^z,P+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function D(){const l=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):r=(0,C.join)(v().os.tmpdir(),`vscode-ipc-${l}.sock`),c(r),r}e.createRandomIPCHandle=D;function t(l,r,h){const P=v().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${h}-${r}-sock`;const A=h.substr(0,4),T=r.substr(0,6),N=P.substr(0,8);let z;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${A}-${T}.sock`):z=(0,C.join)(l,`${A}-${T}.sock`),c(z),z}e.createStaticIPCHandle=t;function c(l){const r=S[k.platform];typeof r=="number"&&l.length>=r&&console.warn(`WARNING: IPC handle "${l}" is longer than ${r} chars, try a shorter --user-data-dir`)}class i extends d.IPCServer{static b(r){const h=n.Event.fromNodeEventEmitter(r,"connection");return n.Event.map(h,P=>({protocol:new w.Protocol(new b(P,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(P,"close"))}))}constructor(r){super(i.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function s(l){return new Promise((r,h)=>{const P=v().net.createServer();P.on("error",h),P.listen(l,()=>{P.removeListener("error",h),r(new i(P))})})}e.serve=s;function o(l,r){return new Promise((h,P)=>{const A=v().net.createConnection(l,()=>{A.removeListener("error",P),h(w.Client.fromSocket(new b(A,`ipc-client${r}`),r))});A.once("error",P)})}e.connect=o}),define(Z[106],ee([0,1,7,3,2,10]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function k(v){const b=v;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var m;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(m=e.StorageState||(e.StorageState={}));class d extends n.Disposable{constructor(b,u=Object.create(null)){super(),this.m=b,this.n=u,this.b=this.B(new M.Emitter),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new I.ThrottledDelayer(d.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((u,y)=>this.s(y,u)),b.deleted?.forEach(u=>this.s(u,void 0))}s(b,u){if(this.c===m.Closed)return;let y=!1;(0,R.isUndefinedOrNull)(u)?y=this.f.delete(b):this.f.get(b)!==u&&(this.f.set(b,u),y=!0),y&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,u){const y=this.f.get(b);return(0,R.isUndefinedOrNull)(y)?u:y}getBoolean(b,u){const y=this.get(b);return(0,R.isUndefinedOrNull)(y)?u:y==="true"}getNumber(b,u){const y=this.get(b);return(0,R.isUndefinedOrNull)(y)?u:parseInt(y,10)}async set(b,u){if(this.c===m.Closed)return;if((0,R.isUndefinedOrNull)(u))return this.delete(b);const y=String(u);if(this.f.get(b)!==y)return this.f.set(b,y),this.j.set(b,y),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===m.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}d.a=100,e.Storage=d;class w{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((u,y)=>this.a.set(y,u)),b.delete?.forEach(u=>this.a.delete(u))}async close(){}}e.InMemoryStorageDatabase=w}),define(Z[156],ee([0,1,7,3,35,9,23]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return M.Event.None}constructor(w,v=Object.create(null)){this.g=w,this.h=v,this.c=(0,R.basename)(this.g),this.d=new m(this.h.logging),this.f=this.n(this.g)}async getItems(){const w=await this.f,v=new Map;return(await this.s(w,"SELECT * FROM ItemTable")).forEach(u=>v.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(w){const v=await this.f;return this.j(v,w)}j(w,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,n.mapToString)(v.insert):"0"}), delete(${v.delete?(0,n.setToString)(v.delete):"0"})`),this.t(w,()=>{const b=v.insert,u=v.delete;if(b&&b.size>0){const y=[];y.push([]);let p=0;b.forEach((a,g)=>{let f=y[p];f.length>k.b&&(p++,f=[],y.push(f)),f.push(g,a)}),y.forEach(a=>{this.u(w,`INSERT INTO ItemTable VALUES ${new Array(a.length/2).fill("(?,?)").join(",")}`,g=>g.run(a),()=>{const g=[];let f=0;return b.forEach((E,S)=>{g.push(S),f+=E.length}),`Keys: ${g.join(", ")} Length: ${f}`})})}if(u&&u.size){const y=[];y.push([]);let p=0;u.forEach(a=>{let g=y[p];g.length>k.b&&(p++,g=[],y.push(g)),g.push(a)}),y.forEach(a=>{this.u(w,`DELETE FROM ItemTable WHERE key IN (${new Array(a.length).fill("?").join(",")})`,g=>g.run(a),()=>{const g=[];return u.forEach(f=>{g.push(f)}),`Keys: ${g.join(", ")}`})})}})}async close(w){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,w)}k(w,v){return new Promise((b,u)=>{w.db.close(y=>(y&&this.o(w,`[storage ${this.c}] close(): ${y}`),this.g===k.IN_MEMORY_PATH?b():!w.isErroneous&&!w.isInMemory?this.l().then(b,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),b())):typeof v=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const a=()=>this.k(p,void 0);return this.j(p,{insert:v()}).then(()=>a(),g=>(a(),Promise.reject(g)))})).then(b,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const w=this.m(this.g);return C.Promises.copy(this.g,w,{preserveSymlinks:!1})}m(w){return`${w}.backup`}async checkIntegrity(w){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${w})`);const v=await this.f,b=await this.r(v,w?"PRAGMA integrity_check":"PRAGMA quick_check"),u=w?b.integrity_check:b.quick_check;return v.isErroneous?`${u} (last error: ${v.lastError})`:v.isInMemory?`${u} (in-memory!)`:u}async n(w,v=!0){this.d.trace(`[storage ${this.c}] open(${w}, retryOnBusy: ${v})`);try{return await this.p(w)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,I.timeout)(k.a),this.n(w,!1);try{await C.Promises.unlink(w);try{await C.Promises.rename(this.m(w),w)}catch{}return await this.p(w)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(k.IN_MEMORY_PATH)}}}o(w,v){w.isErroneous=!0,w.lastError=v,this.d.error(v)}p(w){return new Promise((v,b)=>{new Promise((u,y)=>{x(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.d.isTracing?u.verbose().Database:u.Database)(w,p=>p?y.db&&p.code!=="SQLITE_CANTOPEN"?y.db.close(()=>b(p)):b(p):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(y),a=>y.db.close(()=>b(a)))),isInMemory:w===k.IN_MEMORY_PATH};y.db.on("error",p=>this.o(y,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&y.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},b)})}q(w,v){return new Promise((b,u)=>{w.db.exec(v,y=>y?(this.o(w,`[storage ${this.c}] exec(): ${y}`),u(y)):b())})}r(w,v){return new Promise((b,u)=>{w.db.get(v,(y,p)=>y?(this.o(w,`[storage ${this.c}] get(): ${y}`),u(y)):b(p))})}s(w,v){return new Promise((b,u)=>{w.db.all(v,(y,p)=>y?(this.o(w,`[storage ${this.c}] all(): ${y}`),u(y)):b(p))})}t(w,v){return new Promise((b,u)=>{w.db.serialize(()=>{w.db.run("BEGIN TRANSACTION"),v(),w.db.run("END TRANSACTION",y=>y?(this.o(w,`[storage ${this.c}] transaction(): ${y}`),u(y)):b())})})}u(w,v,b,u){const y=w.db.prepare(v),p=a=>{this.o(w,`[storage ${this.c}] prepare(): ${a} (${v}). Details: ${u()}`)};y.on("error",p),b(y),y.finalize(a=>{a&&p(a),y.removeListener("error",p)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class m{constructor(w){w&&typeof w.logTrace=="function"&&process.env[m.VSCODE_TRACE_STORAGE]&&(this.a=w.logTrace),w&&typeof w.logError=="function"&&(this.b=w.logError)}get isTracing(){return!!this.a}trace(w){this.a?.(w)}error(w){this.b?.(w)}}m.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[157],ee([12,11]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(Z[158],ee([12,11]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[159],ee([12,11]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(Z[160],ee([12,11]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[161],ee([12,11]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(Z[162],ee([12,11]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(Z[163],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[164],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[165],ee([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[166],ee([12,11]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[167],ee([12,11]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[168],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[169],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(Z[170],ee([12,11]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[171],ee([12,11]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[172],ee([12,11]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[173],ee([12,11]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[174],ee([12,11]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[175],ee([12,11]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[176],ee([12,11]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[177],ee([12,11]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[178],ee([12,11]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[179],ee([12,11]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[180],ee([12,11]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[181],ee([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[182],ee([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[183],ee([12,11]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[184],ee([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[185],ee([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[186],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function M(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=M}),define(Z[187],ee([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function M(C){return typeof C?.backupFolder=="string"}e.isEmptyWindowBackupInfo=M;function n(C){let k=[];try{Array.isArray(C.workspaces)&&(k=C.workspaces.map(m=>({workspace:{id:m.id,configPath:I.URI.parse(m.configURIPath)},remoteAuthority:m.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=n;function R(C){let k=[];try{Array.isArray(C.folders)&&(k=C.folders.map(m=>({folderUri:I.URI.parse(m.folderUri),remoteAuthority:m.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=R}),define(Z[188],ee([0,1,3,2]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(k,m,d){switch(m){case"close":return Promise.resolve(this.a.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(k,m,d){switch(m){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}n.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=n;class R extends M.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,m,d){this.b.call("attach",[k,m,d])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,m){this.b.call("terminate",[k,m])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,m){return this.b.call("openExtensionDevelopmentHostWindow",[k,m])}}e.ExtensionHostDebugChannelClient=R}),define(Z[189],ee([0,1,142,54,14,9,36,19,8]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,R.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return m.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return m.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.b.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return m.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(m.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=C.env.VSCODE_PORTABLE;return u?m.URI.file((0,R.join)(u,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,R.resolve)(u):(0,R.normalize)((0,R.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?m.URI.file((0,R.resolve)(u)):m.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,R.resolve)(u);const y=C.env.VSCODE_EXTENSIONS;if(y)return y;const p=C.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?m.URI.parse(y):m.URI.file((0,R.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?m.URI.parse(u):m.URI.file((0,R.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);p&&p[1]&&p[2]&&u.push([p[1],p[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return m.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=C.env.VSCODE_PORTABLE;return u?m.URI.file((0,R.join)(u,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,y,p){this.a=u,this.b=y,this.c=p,this.editSessionId=this.args.editSessionId}}ve([M.memoize],d.prototype,"appRoot",null),ve([M.memoize],d.prototype,"userHome",null),ve([M.memoize],d.prototype,"userDataPath",null),ve([M.memoize],d.prototype,"appSettingsHome",null),ve([M.memoize],d.prototype,"tmpDir",null),ve([M.memoize],d.prototype,"cacheHome",null),ve([M.memoize],d.prototype,"stateResource",null),ve([M.memoize],d.prototype,"userRoamingDataHome",null),ve([M.memoize],d.prototype,"userDataSyncHome",null),ve([M.memoize],d.prototype,"userDataSyncLogResource",null),ve([M.memoize],d.prototype,"editSessionsLogResource",null),ve([M.memoize],d.prototype,"sync",null),ve([M.memoize],d.prototype,"machineSettingsResource",null),ve([M.memoize],d.prototype,"workspaceStorageHome",null),ve([M.memoize],d.prototype,"localHistoryHome",null),ve([M.memoize],d.prototype,"keyboardLayoutResource",null),ve([M.memoize],d.prototype,"argvResource",null),ve([M.memoize],d.prototype,"isExtensionDevelopment",null),ve([M.memoize],d.prototype,"untitledWorkspacesHome",null),ve([M.memoize],d.prototype,"installSourcePath",null),ve([M.memoize],d.prototype,"builtinExtensionsPath",null),ve([M.memoize],d.prototype,"extensionsPath",null),ve([M.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ve([M.memoize],d.prototype,"extensionDevelopmentKind",null),ve([M.memoize],d.prototype,"extensionTestsLocationURI",null),ve([M.memoize],d.prototype,"debugExtensionHost",null),ve([M.memoize],d.prototype,"logLevel",null),ve([M.memoize],d.prototype,"extensionLogLevel",null),ve([M.memoize],d.prototype,"serviceMachineIdResource",null),ve([M.memoize],d.prototype,"telemetryLogResource",null),ve([M.memoize],d.prototype,"disableWorkspaceTrust",null),ve([M.memoize],d.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=d;function w(b,u){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,u,b.debugId,b.extensionEnvironment)}e.parseExtensionHostDebugPort=w;function v(b,u,y,p,a,g){const E=Number(u||b)||(p?null:y),S=E?Boolean(!!u):!1;let D;if(g)try{D=JSON.parse(g)}catch{}return{port:E,break:S,debugId:a,env:D}}e.parseDebugParams=v}),define(Z[107],ee([0,1,287,4,161]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(p,a,g=C){const f=p.find(l=>l.length>0&&l[0]!=="-"),E={},S=["_"],D=[],t={};let c;for(const l in a){const r=a[l];r.type==="subcommand"?l===f&&(c=r):(r.alias&&(E[l]=r.alias),r.type==="string"||r.type==="string[]"?(S.push(l),r.deprecates&&S.push(...r.deprecates)):r.type==="boolean"&&(D.push(l),r.deprecates&&D.push(...r.deprecates)),r.global&&(t[l]=r))}if(c&&f){const l=t;for(const A in c.options)l[A]=c.options[A];const r=p.filter(A=>A!==f),h=g.getSubcommandReporter?g.getSubcommandReporter(f):void 0,P=k(r,l,h);return{[f]:P,_:[]}}const i=I(p,{string:S,boolean:D,alias:E}),s={},o=i;s._=i._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(const l in a){const r=a[l];if(r.type==="subcommand")continue;r.alias&&delete o[r.alias];let h=o[l];if(r.deprecates)for(const P of r.deprecates)o.hasOwnProperty(P)&&(h||(h=o[P],h&&g.onDeprecatedOption(P,r.deprecationMessage||(0,n.localize)(36,null,l))),delete o[P]);if(typeof h<"u"){if(r.type==="string[]"){if(Array.isArray(h)||(h=[h]),!r.allowEmptyValue){const P=h.filter(A=>A.length>0);P.length!==h.length&&(g.onEmptyValue(l),h=P.length>0?P:void 0)}}else r.type==="string"&&(Array.isArray(h)?(h=h.pop(),g.onMultipleValues(l,h)):!h&&!r.allowEmptyValue&&(g.onEmptyValue(l),h=void 0));s[l]=h,r.deprecationMessage&&g.onDeprecatedOption(l,r.deprecationMessage)}delete o[l]}for(const l in o)g.onUnknownOption(l);return s}e.parseArgs=k;function m(p,a){let g="";return a.args&&(Array.isArray(a.args)?g=` <${a.args.join("> <")}>`:g=` <${a.args}>`),a.alias?`-${a.alias} --${p}${g}`:`--${p}${g}`}function d(p,a){const g=[];for(const f in p){const E=p[f],S=m(f,E);g.push([S,E.description])}return w(g,a)}e.formatOptions=d;function w(p,a){const f=p.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(a-f<25)return p.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const E=a-f-1,S=[];for(const D of p){const t=D[0],c=b(D[1],E),i=v(f-t.length-2);S.push("  "+t+i+c[0]);for(let s=1;s<c.length;s++)S.push(v(f)+c[s])}return S}function v(p){return" ".repeat(p)}function b(p,a){const g=[];for(;p.length;){const f=p.length<a?p.length:p.lastIndexOf(" ",a),E=p.slice(0,f).trim();p=p.slice(f),g.push(E)}return g}function u(p,a,g,f,E){const S=process.stdout.isTTY&&process.stdout.columns||80,D=E?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${p} ${g}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${a} [${(0,n.localize)(39,null)}]${D}`),t.push(""),E?.noPipe!==!0&&(M.isWindows?t.push((0,n.localize)(40,null,a)):t.push((0,n.localize)(41,null,a)),t.push(""));const c={},i=[];for(const s in f){const o=f[s];if(o.type==="subcommand")o.description&&i.push({command:s,description:o.description});else if(o.description&&o.cat){let l=c[o.cat];l||(c[o.cat]=l={}),l[s]=o}}for(const s in c){const o=s,l=c[o];l&&(t.push(R[o]),t.push(...d(l,S)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...w(i.map(s=>[s.command,s.description]),S)),t.push("")),t.join(`
`)}e.buildHelpMessage=u;function y(p,a){return`${p||(0,n.localize)(43,null)}
${a||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[190],ee([0,1,82,188,107]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends M.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,m,d){return m==="openExtensionDevelopmentHostWindow"?this.g(d[0],d[1]):super.call(k,m,d)}async g(k,m){const d=(0,n.parseArgs)(k,n.OPTIONS);d.debugRenderer=m;const w=d.extensionDevelopmentPath;if(!w)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(w,{context:5,cli:d,forceProfile:d.profile,forceTempProfile:d["profile-temp"]});if(!m)return{success:!0};const b=v.win;if(!b)return{success:!0};const u=b.webContents.debugger;let y=u.isAttached()?1/0:0;const p=(0,I.createServer)(a=>{y++===0&&u.attach();let g=!1;const f=D=>{g||a.write(JSON.stringify(D)+"\0")},E=(D,t,c,i)=>f({method:t,params:c,sessionId:i});b.on("close",()=>{u.removeListener("message",E),a.end(),g=!0}),u.addListener("message",E);let S=Buffer.alloc(0);a.on("data",D=>{S=Buffer.concat([S,D]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let c;try{const i=S.slice(0,t).toString("utf8");S=S.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}u.sendCommand(c.method,c.params,c.sessionId).then(i=>f({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>f({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),a.on("error",D=>{console.error("error on cdp pipe:",D)}),a.on("close",()=>{g=!0,--y===0&&u.detach()})});return await new Promise(a=>p.listen(0,a)),b.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[62],ee([0,1,288,162,107]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function C(b,u){const y=(S,D)=>{console.warn((0,M.localize)(0,null,S,D))},p=S=>{console.warn((0,M.localize)(1,null,S))},a=(S,D)=>{console.warn((0,M.localize)(2,null,S,D))},g=S=>({onUnknownOption:D=>{S!=="tunnel"&&console.warn((0,M.localize)(3,null,D,S))},onMultipleValues:y,onEmptyValue:p,onDeprecatedOption:a,getSubcommandReporter:S!=="tunnel"?g:void 0}),f={onUnknownOption:S=>{console.warn((0,M.localize)(4,null,S))},onMultipleValues:y,onEmptyValue:p,onDeprecatedOption:a,getSubcommandReporter:g},E=(0,n.parseArgs)(b,n.OPTIONS,u?f:void 0);return E.goto&&E._.forEach(S=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,M.localize)(5,null))),E["max-memory"]&&I(parseInt(E["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),E}function k(b){const u=b.findIndex(y=>!/^-/.test(y));if(u>-1)return[...b.slice(0,u),...b.slice(u+1)]}function m(b){let[,...u]=b;process.env.VSCODE_DEV&&(u=k(u)||[]);const y=!v(process.env);return C(u,y)}e.parseMainProcessArgv=m;function d(b){let[,,...u]=b;return process.env.VSCODE_DEV&&(u=k(u)||[]),C(u,!0)}e.parseCLIProcessArgv=d;function w(b,...u){const y=b.indexOf("--");return y===-1?b.push(...u):b.splice(y,0,...u),b}e.addArg=w;function v(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function x(e,I,M){function n(C,k){const m=R(C,k),d=[m];return e.isAbsolute(m)||d.unshift(M),e.resolve(...d)}function R(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,k);const w=C["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(v,"AppData","Roaming")}break;case"darwin":d=e.join(I.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,k)}return{getUserDataPath:n}}if(typeof define=="function")define(Z[191],ee([192,26,36]),function(e,I,M){return x(e,I,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=x(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[108],ee([0,1,26,189,191]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class R extends M.AbstractNativeEnvironmentService{constructor(d,w){super(d,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,n.getUserDataPath)(d,w.nameShort)},w)}}e.NativeEnvironmentService=R;function C(m,d){return(0,M.parseDebugParams)(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,d,m.extensionEnvironment)}e.parsePtyHostDebugPort=C;function k(m,d){return(0,M.parseDebugParams)(m["inspect-sharedprocess"],m["inspect-brk-sharedprocess"],5879,d,m.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(Z[193],ee([0,1,41,26,32]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(C){const k=(0,n.randomPath)((0,M.tmpdir)());try{return(0,I.writeFileSync)(k,""),C&&console.log(`Marker file for --wait created: ${k}`),k}catch(m){C&&console.error(`Failed to create marker file for --wait: ${m}`);return}}e.createWaitMarkerFileSync=R}),define(Z[194],ee([0,1,10,164]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(C,k,m){try{R(C,k,m)}catch(d){console.error(d?.message??d)}return C}e.localizeManifest=n;function R(C,k,m){const d=(w,v,b)=>{const u=w[v];if((0,I.isString)(u)){const y=u,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const a=y.substr(1,p-2);let g=k[a];g===void 0&&m&&(g=m[a]);const f=typeof g=="string"?g:g?.message,E=m?.[a],S=typeof E=="string"?E:E?.message;if(!f){S||console.warn(`[${C.name}]: ${(0,M.localize)(0,null,a)}`);return}if(b&&(v==="title"||v==="category")&&S&&S!==f){const D={value:f,original:S};w[v]=D}else w[v]=f}}else if((0,I.isObject)(u))for(const y in u)u.hasOwnProperty(y)&&(y==="commands"?d(u,y,!0):d(u,y,b));else if(Array.isArray(u))for(let y=0;y<u.length;y++)d(u,y,b)};for(const w in C)C.hasOwnProperty(w)&&d(C,w)}}),define(Z[195],ee([0,1,13]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class M{constructor(){this.a=new Map}register(R,C){this.a.set(R,C)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const C in R.contributes){const k=this.a.get(C);if(!k)continue;const m=R.contributes[C],d=Array.isArray(m)?m:[m];try{k(d,R.activationEvents)}catch(w){(0,I.onUnexpectedError)(w)}}}}e.ImplicitActivationEventsImpl=M,e.ImplicitActivationEvents=new M}),define(Z[196],ee([0,1,19,73,166,197]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function m(g){return g=g.trim(),g==="*"||C.test(g)}e.isValidVersionStr=m;function d(g){if(!m(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=g.match(C);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=d;function w(g){if(!g)return null;const f=g.majorBase,E=g.majorMustEqual,S=g.minorBase;let D=g.minorMustEqual;const t=g.patchBase;let c=g.patchMustEqual;g.hasCaret&&(f===0||(D=!1),c=!1);let i=0;if(g.preRelease){const s=k.exec(g.preRelease);if(s){const[,o,l,r]=s;i=Date.UTC(Number(o),Number(l)-1,Number(r))}}return{majorBase:f,majorMustEqual:E,minorBase:S,minorMustEqual:D,patchBase:t,patchMustEqual:c,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=w;function v(g,f,E){let S;typeof g=="string"?S=w(d(g)):S=g;let D;f instanceof Date?D=f.getTime():typeof f=="string"&&(D=new Date(f).getTime());let t;if(typeof E=="string"?t=w(d(E)):t=E,!S||!t)return!1;const c=S.majorBase,i=S.minorBase,s=S.patchBase;let o=t.majorBase,l=t.minorBase,r=t.patchBase;const h=t.notBefore;let P=t.majorMustEqual,A=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:i>l?!0:i<l||D&&D<h?!1:s>=r:(c===1&&o===0&&(!P||!A||!T)&&(o=1,l=0,r=0,P=!0,A=!1,T=!1),c<o?!1:c>o?!P:i<l?!1:i>l?!A:s<r?!1:s>r?!T:!(D&&D<h))}e.isValidVersion=v;function b(g,f,E,S,D){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([M.default.Error,n.localize(0,null)]),t;if(typeof S.name!="string")return t.push([M.default.Error,n.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([M.default.Error,n.localize(2,null,"version")]),t;if(!S.engines)return t.push([M.default.Error,n.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([M.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!a(S.extensionDependencies))return t.push([M.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!a(S.activationEvents))return t.push([M.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([M.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([M.default.Warning,n.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([M.default.Error,n.localize(9,null,"main")]),t;{const s=(0,I.joinPath)(E,S.main);(0,I.isEqualOrParent)(s,E)||t.push([M.default.Warning,n.localize(10,null,s.path,E.path)])}if(typeof S.activationEvents>"u")return t.push([M.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([M.default.Error,n.localize(12,null,"browser")]),t;{const s=(0,I.joinPath)(E,S.browser);(0,I.isEqualOrParent)(s,E)||t.push([M.default.Warning,n.localize(13,null,s.path,E.path)])}if(typeof S.activationEvents>"u")return t.push([M.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(S.version))return t.push([M.default.Error,n.localize(15,null)]),t;const c=[];if(!u(g,f,S,D,c))for(const s of c)t.push([M.default.Error,s]);return t}e.validateExtensionManifest=b;function u(g,f,E,S,D){return S||typeof E.main>"u"&&typeof E.browser>"u"?!0:p(g,f,E.engines.vscode,D)}e.isValidExtensionVersion=u;function y(g,f,E){return g==="*"||p(f,E,g)}e.isEngineValid=y;function p(g,f,E,S=[]){const D=w(d(E));if(!D)return S.push(n.localize(16,null,E)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return S.push(n.localize(17,null,E)),!1}else if(!D.majorMustEqual)return S.push(n.localize(18,null,E)),!1;return v(g,f,D)?!0:(S.push(n.localize(19,null,g,E)),!1)}function a(g){if(!Array.isArray(g))return!1;for(let f=0,E=g.length;f<E;f++)if(typeof g[f]!="string")return!1;return!0}}),define(Z[198],ee([0,1,17,31]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(R,C,k){let m=k&&k.get("storage.serviceMachineId",-1)||null;if(m)return m;try{const w=(await C.readFile(R.serviceMachineIdResource)).value.toString();m=(0,M.isUUID)(w)?w:null}catch{m=null}if(!m){m=(0,M.generateUuid)();try{await C.writeFile(R.serviceMachineIdResource,I.VSBuffer.fromString(m))}catch{}}return k?.store("storage.serviceMachineId",m,-1,1),m}e.getServiceMachineId=n}),define(Z[74],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(n,R=[],C=!1){this.ctor=n,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=I}),define(Z[199],ee([0,1,74]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const M=[];var n;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function R(k,m,d){m instanceof I.SyncDescriptor||(m=new I.SyncDescriptor(m,[],Boolean(d))),M.push([k,m])}e.registerSingleton=R;function C(){return M}e.getSingletonServiceDescriptors=C}),define(Z[200],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const k=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(C);k.outgoing.set(m.key,m),m.incoming.set(k.key,k)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let k=this.a.get(C);return k||(k=new I(C,R),this.a.set(C,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,k]of this.a)R.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const k=new Set([R]),m=this.c(C,k);if(m)return m}}c(R,C){for(const[k,m]of R.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const d=this.c(m,C);if(d)return d;C.delete(k)}}}e.Graph=M}),define(Z[6],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(m){return m[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(I=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function M(C,k,m){k[I.DI_TARGET]===k?k[I.DI_DEPENDENCIES].push({id:C,index:m}):(k[I.DI_DEPENDENCIES]=[{id:C,index:m}],k[I.DI_TARGET]=k)}function n(C){if(I.serviceIds.has(C))return I.serviceIds.get(C);const k=function(m,d,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(k,m,w)};return k.toString=()=>C,I.serviceIds.set(C,k),k}e.createDecorator=n;function R(C){return C}e.refineServiceDecorator=R}),define(Z[63],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(Z[18],ee([0,1,10,8,6]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationOverrides=R;function C(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function m(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=m;function d(a,g){const f=Object.create(null);for(const E in a)w(f,E,a[E],g);return f}e.toValuesTree=d;function w(a,g,f,E){const S=g.split("."),D=S.pop();let t=a;for(let c=0;c<S.length;c++){const i=S[c];let s=t[i];switch(typeof s){case"undefined":s=t[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${g} as ${S.slice(0,c+1).join(".")} is ${JSON.stringify(s)}`);return}t=s}if(typeof t=="object"&&t!==null)try{t[D]=f}catch{E(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=w;function v(a,g){const f=g.split(".");b(a,f)}e.removeFromValueTree=v;function b(a,g){const f=g.shift();if(g.length===0){delete a[f];return}if(Object.keys(a).indexOf(f)!==-1){const E=a[f];typeof E=="object"&&!Array.isArray(E)&&(b(E,g),Object.keys(E).length===0&&delete a[f])}}function u(a,g,f){function E(t,c){let i=t;for(const s of c){if(typeof i!="object"||i===null)return;i=i[s]}return i}const S=g.split("."),D=E(a,S);return typeof D>"u"?f:D}e.getConfigurationValue=u;function y(a,g,f){Object.keys(g).forEach(E=>{E!=="__proto__"&&(E in a?I.isObject(a[E])&&I.isObject(g[E])?y(a[E],g[E],f):f&&(a[E]=g[E]):a[E]=g[E])})}e.merge=y;function p(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(Z[75],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class M{constructor(){this.a={}}async getPassword(R,C){return this.a[R]?.[C]??null}async setPassword(R,C,k){this.a[R]=this.a[R]??{},this.a[R][C]=k}async deletePassword(R,C){return this.a[R]?.[C]?(delete this.a[R][C],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const C=[];for(const k of Object.keys(this.a[R]||{}))C.push({account:k,password:this.a[R][k]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=M}),define(Z[87],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function M(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=M;class n{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=n}),define(Z[88],ee([0,1,19,73,159,6,45,4,37]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var d;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(d||(d={}));class w{a(a){return this.d(a,d.Confirmation)}b(a){return this.d(a,d.Prompt)}c(a){return this.d(a,d.Input)}d(a,g){const f=[];switch(g){case d.Confirmation:{const E=a;E.primaryButton?f.push(E.primaryButton):f.push((0,n.localize)(0,null)),E.cancelButton?f.push(E.cancelButton):f.push((0,n.localize)(1,null));break}case d.Prompt:{const E=a;Array.isArray(E.buttons)&&E.buttons.length>0&&f.push(...E.buttons.map(S=>S.label)),E.cancelButton&&(E.cancelButton===!0?f.push((0,n.localize)(2,null)):typeof E.cancelButton=="string"?f.push(E.cancelButton):E.cancelButton.label?f.push(E.cancelButton.label):f.push((0,n.localize)(3,null))),f.length===0&&f.push((0,n.localize)(4,null));break}case d.Input:{const E=a;E.primaryButton?f.push(E.primaryButton):f.push((0,n.localize)(5,null)),E.cancelButton?f.push(E.cancelButton):f.push((0,n.localize)(6,null));break}}return f}e(a){if(typeof a=="string")return a;if(typeof a=="number")return a===M.default.Info?"info":a===M.default.Error?"error":a===M.default.Warning?"warning":"none"}async f(a,g,f){const E=[...a.buttons??[]];return a.cancelButton&&typeof a.cancelButton!="string"&&typeof a.cancelButton!="boolean"&&E.push(a.cancelButton),{result:await E[g]?.run({checkboxChecked:f}),checkboxChecked:f}}}e.AbstractDialogHandler=w,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var v;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(v=e.ConfirmResult||(e.ConfirmResult={}));const b=10;function u(p){const a=[];return a.push(...p.slice(0,b).map(g=>typeof g=="string"?g:(0,I.basename)(g))),p.length>b&&(p.length-b===1?a.push((0,n.localize)(7,null)):a.push((0,n.localize)(8,null,p.length-b))),a.push(""),a.join(`
`)}e.getFileNamesMessage=u;function y(p,a){const g=(0,m.deepClone)(p);let f=(g.buttons??[]).map(t=>(0,C.mnemonicButtonLabel)(t)),E=(p.buttons||[]).map((t,c)=>c),S=0,D=g.cancelId??f.length-1;if(f.length>1){const t=typeof D=="number"?f[D]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&f.length>1&&D!==1){f.splice(D,1),f.splice(1,0,t);const c=E[D];E.splice(D,1),E.splice(1,0,c),D=1}k.isLinux&&f.length>1&&(f=f.reverse(),E=E.reverse(),S=f.length-1,typeof t=="string"&&(D=S-1))}else if(k.isWindows&&typeof t=="string"&&f.length>1&&D!==f.length-1){f.splice(D,1),f.push(t);const c=E[D];E.splice(D,1),E.push(c),D=f.length-1}}return g.buttons=f,g.defaultId=S,g.cancelId=D,g.noLink=!0,g.title=g.title||a.nameLong,{options:g,buttonIndeces:E}}e.massageMessageBoxOptions=y}),define(Z[109],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(Z[34],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],ee([0,1,54,9,86,34,108,6]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(R.IEnvironmentService);class m extends C.NativeEnvironmentService{get cachedLanguagesPath(){return(0,M.join)(this.userDataPath,"clp")}get backupHome(){return(0,M.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,M.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([I.memoize],m.prototype,"cachedLanguagesPath",null),ve([I.memoize],m.prototype,"backupHome",null),ve([I.memoize],m.prototype,"mainIPCHandle",null),ve([I.memoize],m.prototype,"mainLockfile",null),ve([I.memoize],m.prototype,"disableUpdates",null),ve([I.memoize],m.prototype,"disableKeytar",null),ve([I.memoize],m.prototype,"crossOriginIsolated",null),ve([I.memoize],m.prototype,"codeCachePath",null),ve([I.memoize],m.prototype,"useCodeCache",null),e.EnvironmentMainService=m}),define(Z[110],ee([0,1,163,6]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function n(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(g,f){switch(g){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function k(g,f){return f==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function m(g,f,E){return k(f,E)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===E?!0:d(E).includes(g)}e.isTargetPlatformCompatible=m;function d(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=w;var v;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var b;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var u;(function(g){g.Install="install",g.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var y;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var p;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal",g.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(f,E){super(f),this.code=E,this.name=E}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,I.localize)(1,null),original:"Preferences"}}),define(Z[201],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(Z[202],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[111],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(Z[203],ee([0,1,46,14,9,4,71,23,85,167,111]),function(x,e,I,M,n,R,C,k,m,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=d.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends b{openTerminal(S,D){return this.spawnTerminal(I,S,m.getWindowsShell(),D)}spawnTerminal(S,D,t,c){const i=D.windowsExec||u.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const s=n.basename(i,".exe").toLowerCase();if(s==="cmder")return S.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),s==="wt"&&o.push("-d ."),new Promise((l,r)=>{const h=a(process),P=S.spawn(t,o,{cwd:c,env:h});P.on("error",r),P.on("exit",()=>l())})}runInTerminal(S,D,t,c,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:u.getDefaultTerminalWindows();return new Promise((o,l)=>{const r=`"${D} - ${v}"`,h=`""${t.join('" "')}" & pause"`,P=Object.assign({},a(process),c);Object.keys(P).filter(H=>P[H]===null).forEach(H=>delete P[H]);const A={cwd:D,env:P,windowsVerbatimArguments:!0};let T,N;n.basename(s,".exe")==="wt"?(T=s,N=["-d",".",u.b,"/c",h]):(T=u.b,N=["/c","start",r,"/wait",s,"/c",h]),I.spawn(T,N,A).on("error",H=>{l(g(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return u.d}}u.b="cmd.exe",e.WindowsExternalTerminalService=u;class y extends b{openTerminal(S,D){return this.spawnTerminal(I,S,D)}runInTerminal(S,D,t,c,i){const s=i.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((o,l)=>{if(s===w.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const r=s===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[M.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",S||v,"-w",D];for(const N of t)P.push("-a"),P.push(N);if(c){const N=Object.assign({},a(process),c);for(const z in N){const H=N[z];H===null?(P.push("-u"),P.push(z)):(P.push("-e"),P.push(`${z}=${H}`))}}let A="";const T=I.spawn(y.b,P);T.on("error",N=>{l(g(N))}),T.stderr.on("data",N=>{A+=N.toString()}),T.on("exit",N=>{if(N===0)o(void 0);else if(A){const z=A.split(`
`,1);l(new Error(z[0]))}else l(new Error(d.localize(1,null,r,N)))})}else l(new Error(d.localize(2,null,s)))})}spawnTerminal(S,D,t){const c=D.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const o=["-a",c];t&&o.push(t);const l=a(process),r=S.spawn("/usr/bin/open",o,{cwd:t,env:l});r.on("error",s),r.on("exit",()=>i())})}}y.b="/usr/bin/osascript",e.MacExternalTerminalService=y;class p extends b{openTerminal(S,D){return this.spawnTerminal(I,S,D)}runInTerminal(S,D,t,c,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,l)=>{const r=[];s.then(h=>{h.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const P=`${f(t)}; echo; read -p "${p.b}" -n1;`;r.push(`''${P}''`);const A=Object.assign({},a(process),c);Object.keys(A).filter(H=>A[H]===null).forEach(H=>delete A[H]);const T={cwd:D,env:A};let N="";const z=I.spawn(h,r,T);z.on("error",H=>{l(g(H))}),z.stderr.on("data",H=>{N+=H.toString()}),z.on("exit",H=>{if(H===0)o(void 0);else if(N){const ie=N.split(`
`,1);l(new Error(ie[0]))}else l(new Error(d.localize(4,null,h,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!R.isLinux)p.d=Promise.resolve("xterm");else{const S=await k.Promises.exists("/etc/debian_version");p.d=new Promise(D=>{S?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return p.d}spawnTerminal(S,D,t){const c=D.linuxExec?Promise.resolve(D.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{c.then(o=>{const l=a(process),r=S.spawn(o,[],{cwd:t,env:l});r.on("error",s),r.on("exit",()=>i())})})}}p.b=d.localize(3,null),e.LinuxExternalTerminalService=p;function a(E){const S={...E.env};return(0,C.sanitizeProcessEnvironment)(S),S}function g(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(d.localize(5,null,E.path)):E}function f(E){let S="";for(const D of E)D.indexOf(" ")>=0?S+='"'+D+'"':S+=D,S+=" ";return S}}),define(Z[16],ee([0,1,61,9,27,10,8,169,6,4,14]),function(x,e,I,M,n,R,C,k,m,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function v(O){return O.create===!0}e.isFileOpenForWriteOptions=v;var b;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var u;(function(O){O[O.Readonly=1]="Readonly"})(u=e.FilePermission||(e.FilePermission={}));var y;(function(O){O[O.None=0]="None",O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock",O[O.FileAtomicRead=16384]="FileAtomicRead",O[O.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=p;function a(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=a;function g(O){return!!(O.capabilities&32768)}e.hasFileCloneCapability=g;function f(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function E(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=E;function S(O){return p(O)?!!(O.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var D;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(q,Y){const te=new t(q.toString(),Y);return s(te,Y),te}constructor(q,Y){super(q),this.code=Y}}e.FileSystemProviderError=t;function c(O,q){return t.create(O,q)}e.createFileSystemProviderError=c;function i(O){return O||c((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function s(O,q){return O.name=q?`${q} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=s;function o(O){if(!O)return D.Unknown;if(O instanceof t)return O.code;const q=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!q)return D.Unknown;switch(q[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=o;function l(O){if(O instanceof N)return O.fileOperationResult;switch(o(O)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY",O[O.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class h{constructor(q,Y,te){this.resource=q,this.operation=Y,this.target=te}isOperation(q){return this.operation===q}}e.FileOperationEvent=h;var P;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(P=e.FileChangeType||(e.FileChangeType={}));class A{constructor(q,Y){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ne of q){const L=te.get(ne.type);switch(L?L.push([ne.resource,ne]):te.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,L]of te)switch(ne){case 1:this.a=I.TernarySearchTree.forUris(()=>Y),this.a.fill(L);break;case 0:this.b=I.TernarySearchTree.forUris(()=>Y),this.b.fill(L);break;case 2:this.c=I.TernarySearchTree.forUris(()=>Y),this.c.fill(L);break}}contains(q,...Y){return this.d(q,{includeChildren:!1},...Y)}affects(q,...Y){return this.d(q,{includeChildren:!0},...Y)}d(q,Y,...te){if(!q)return!1;const ne=te.length>0;return!!((!ne||te.includes(1))&&(this.a?.get(q)||Y.includeChildren&&this.a?.findSuperstr(q))||(!ne||te.includes(0))&&(this.b?.get(q)||Y.includeChildren&&this.b?.findSuperstr(q))||(!ne||te.includes(2))&&(this.c?.findSubstr(q)||Y.includeChildren&&this.c?.findSuperstr(q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=A;function T(O,q,Y){return!O||!q||O===q||q.length>O.length?!1:(q.charAt(q.length-1)!==M.sep&&(q+=M.sep),Y?(0,n.startsWithIgnoreCase)(O,q):O.indexOf(q)===0)}e.isParent=T;class N extends Error{constructor(q,Y,te){super(q),this.fileOperationResult=Y,this.options=te}}e.FileOperationError=N;class z extends N{constructor(q,Y,te,ne){super(q,Y,ne),this.fileOperationResult=Y,this.size=te}}e.TooLargeFileOperationError=z;class H extends N{constructor(q,Y,te){super(q,2,te),this.stat=Y}}e.NotModifiedSinceFileOperationError=H;var ie;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var se;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(se=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function oe(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=oe;async function ue(O,q){if(!q.hasProvider(C.URI.from({scheme:O.scheme})))return new Promise(Y=>{const te=q.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===O.scheme&&ne.added&&(te.dispose(),Y())})})}e.whenProviderRegistered=ue,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(q){return(0,R.isNumber)(q)||(q=0),q<le.KB?(0,k.localize)(1,null,q.toFixed(0)):q<le.MB?(0,k.localize)(2,null,(q/le.KB).toFixed(2)):q<le.GB?(0,k.localize)(3,null,(q/le.MB).toFixed(2)):q<le.TB?(0,k.localize)(4,null,(q/le.GB).toFixed(2)):(0,k.localize)(5,null,(q/le.TB).toFixed(2))}}le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB,e.ByteSize=le;var me;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function G(O){return{maxFileSize:O===0?300*le.MB:16*le.GB,maxHeapSize:O===0?700*le.MB:2*700*le.MB}}e.getPlatformFileLimits=G;function B(O){const q=typeof O=="string"||O?.scheme===w.Schemas.vscodeRemote;return typeof O!="string"&&O?.scheme===w.Schemas.file?1024*le.MB:q?10*le.MB:d.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=B}),define(Z[204],ee([0,1,17,44,13,3,2,59,8,31,16]),function(x,e,I,M,n,R,C,k,m,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends C.Disposable{constructor(u,y){super(),this.a=u,this.b=y,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,d.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,y){const{buffer:p}=await this.a.call("readFile",[u,y]);return p}readFileStream(u,y,p){const a=(0,k.newWriteableStream)(f=>I.VSBuffer.concat(f.map(E=>I.VSBuffer.wrap(E))).buffer),g=this.a.listen("readFileStream",[u,y])(f=>{if(f instanceof I.VSBuffer)a.write(f.buffer);else{if(f==="end")a.end();else{let E;if(f instanceof Error)E=f;else{const S=f;E=(0,w.createFileSystemProviderError)(S.message??(0,M.toErrorMessage)(S),S.code??w.FileSystemProviderErrorCode.Unknown)}a.error(E),a.end()}g.dispose()}});return p.onCancellationRequested(()=>{a.error((0,n.canceled)()),a.end(),g.dispose()}),a}writeFile(u,y,p){return this.a.call("writeFile",[u,I.VSBuffer.wrap(y),p])}open(u,y){return this.a.call("open",[u,y])}close(u){return this.a.call("close",[u])}async read(u,y,p,a,g){const[f,E]=await this.a.call("read",[u,y,g]);return p.set(f.buffer.slice(0,E),a),E}write(u,y,p,a,g){return this.a.call("write",[u,y,I.VSBuffer.wrap(p),a,g])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,y){return this.a.call("delete",[u,y])}rename(u,y,p){return this.a.call("rename",[u,y,p])}copy(u,y,p){return this.a.call("copy",[u,y,p])}cloneFile(u,y){return this.a.call("cloneFile",[u,y])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const y=u;this.f.fire(y.map(p=>({resource:m.URI.revive(p.resource),type:p.type})))}else{const y=u;this.g.fire(y)}}))}watch(u,y){const p=(0,d.generateUuid)();return this.a.call("watch",[this.h,p,u,y]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=v}),define(Z[112],ee([0,1,17,13,170,16]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(w,v,b,u,y,p){let a;try{await k(w,v,b,u,y,p)}catch(g){a=g}finally{a&&y.errorTransformer&&(a=y.errorTransformer(a)),typeof a<"u"&&b.error(a),b.end()}}e.readFileIntoStream=C;async function k(w,v,b,u,y,p){m(p);const a=await w.open(v,{create:!1});try{m(p);let g=0,f=0,E=y&&typeof y.length=="number"?y.length:void 0,S=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof E=="number"?E:y.bufferSize)),D=y&&typeof y.position=="number"?y.position:0,t=0;do f=await w.read(a,D,S.buffer,t,S.byteLength-t),D+=f,t+=f,g+=f,typeof E=="number"&&(E-=f),t===S.byteLength&&(await b.write(u(S)),S=I.VSBuffer.alloc(Math.min(y.bufferSize,typeof E=="number"?E:y.bufferSize)),t=0);while(f>0&&(typeof E!="number"||E>0)&&m(p)&&d(g,y));if(t>0){let c=t;typeof E=="number"&&(c=Math.min(t,E)),b.write(u(S.slice(0,c)))}}catch(g){throw(0,R.ensureFileSystemProviderError)(g)}finally{await w.close(a)}}function m(w){if(w.isCancellationRequested)throw(0,M.canceled)();return!0}function d(w,v){if(v?.limits){if(typeof v.limits.memory=="number"&&w>v.limits.memory)throw(0,R.createFileSystemProviderError)((0,n.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&w>v.limits.size)throw(0,R.createFileSystemProviderError)((0,n.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[76],ee([0,1,101,2,9,4,8,16]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function m(g){return g.recursive===!0}e.isRecursiveWatchRequest=m;class d extends M.Disposable{constructor(f,E,S,D){super(),this.h=f,this.i=E,this.j=S,this.k=D,this.c=this.B(new M.MutableDisposable),this.f=void 0,this.g=0}m(){const f=new M.DisposableStore;this.c.value=f,this.b=this.l(f),this.b.setVerboseLogging(this.j),f.add(this.b.onDidChangeFile(E=>this.h(E))),f.add(this.b.onDidLogMessage(E=>this.i(E))),f.add(this.b.onDidError(E=>this.n(E)))}n(f){this.k.restartOnError?this.g<d.a&&this.f?(this.r(`restarting watcher after error: ${f}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${f}`):this.r(f)}p(f){this.g++,this.m(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.j=f,await this.b?.setVerboseLogging(f)}r(f){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${f}`})}s(f){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}d.a=5,e.AbstractWatcherClient=d;class w extends d{constructor(f,E,S){super(f,E,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class v extends d{constructor(f,E,S){super(f,E,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function b(g){return g.map(f=>({type:f.type,resource:C.URI.file(f.path)}))}e.toFileChanges=b;function u(g){const f=new a;for(const E of g)f.processEvent(E);return f.coalesce()}e.coalesceEvents=u;function y(g,f){return typeof f=="string"&&!f.startsWith(I.GLOBSTAR)&&!(0,n.isAbsolute)(f)?{base:g,pattern:f}:f}e.normalizeWatcherPattern=y;function p(g,f){const E=[];for(const S of f)E.push((0,I.parse)(y(g,S)));return E}e.parseWatcherPatterns=p;class a{constructor(){this.a=new Set,this.b=new Map}c(f){return R.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const E=this.b.get(this.c(f));let S=!1;if(E){const D=E.type,t=f.type;E.path!==f.path&&(f.type===2||f.type===1)?S=!0:D===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(E)):D===2&&t===1?E.type=0:D===1&&t===0||(E.type=t)}else S=!0;S&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],E=[];return Array.from(this.a).filter(S=>S.type!==2?(f.push(S),!1):!0).sort((S,D)=>S.path.length-D.path.length).filter(S=>E.some(D=>(0,k.isParent)(S.path,D,!R.isLinux))?!1:(E.push(S.path),!0)).concat(f)}}}),define(Z[205],ee([0,1,41,7,22,32,2,80,9,4,102,23,76]),function(x,e,I,M,n,R,C,k,m,d,w,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends C.Disposable{constructor(a,g,f,E){super(),this.j=a,this.k=g,this.l=f,this.m=E,this.c=this.B(new M.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new M.RunOnceWorker(S=>this.u(S),u.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await v.Promises.stat(a);this.B(await this.s(a,g.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let g=a.path;try{g=await v.Promises.realpath(a.path),a.path===g&&(g=await(0,w.realcase)(a.path)??a.path),a.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${g})`)}catch{}return g}async s(a,g){if(d.isMacintosh&&(0,R.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const f=new n.CancellationTokenSource(this.i.token),E=new C.DisposableStore;try{const S=(0,m.basename)(a),D=(0,I.watch)(a);E.add((0,C.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${a}'`);const t=new Set;if(g)try{for(const i of await v.Promises.readdir(a))t.add(i)}catch(i){this.w(i)}const c=new Map;E.add((0,C.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),D.on("error",(i,s)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),D.on("change",(i,s)=>{if(f.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),d.isMacintosh&&(o=(0,k.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){c.get(o)?.dispose();const l=setTimeout(async()=>{if(c.delete(o),o===S&&!await v.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,m.join)(a,o));if(f.token.isCancellationRequested)return;let h;r?t.has(o)?h=0:(h=1,t.add(o)):(t.delete(o),h=2),this.t({path:(0,m.join)(this.j.path,o),type:h})},u.a);c.set(o,(0,C.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(o)?l=0:(l=1,t.add(o)),this.t({path:(0,m.join)(this.j.path,o),type:l})}else if(i==="rename"||o!==S){const l=setTimeout(async()=>{const r=await v.Promises.exists(a);f.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),E.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);E.clear(),E.add((0,C.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await v.Promises.exists(a)&&!f.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${S.toString()})`)}return(0,C.toDisposable)(()=>{f.dispose(!0),E.dispose()})}t(a,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!g&&this.g.some(f=>f(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(f=>f(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const g=(0,b.coalesceEvents)(a);if(g.length>0){if(this.m)for(const E of g)this.z(`>> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(d.isLinux)return v.Promises.exists(a);try{const g=(0,m.basename)(a);return(await v.Promises.readdir((0,m.dirname)(a))).some(E=>E===g)}catch(g){return this.z(g),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}u.a=100,u.b=75,e.NodeJSFileWatcherLibrary=u;async function y(p,a,g,f,E=512){const S=await v.Promises.open(p,"r"),D=Buffer.allocUnsafe(E),t=new n.CancellationTokenSource(f);let c,i=!1;const s={path:p,excludes:[],recursive:!1},o=new u(s,l=>{(async()=>{for(const{type:r}of l)if(r===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:h}=await v.Promises.read(S,D,0,E,null);if(!h||t.token.isCancellationRequested)break;a(D.slice(0,h))}}catch(h){c=new Error(h),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,g(),new Promise((l,r)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await v.Promises.close(S)}catch(h){c=new Error(h)}c?r(c):l()})})}e.watchFileContents=y}),define(Z[206],ee([0,1,3,101,2,4,205]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(d){const w=this.i(d),v=w.filter(u=>{const y=this.c.get(u.path);return y?!(0,M.patternsEquals)(y.request.excludes,u.excludes)||!(0,M.patternsEquals)(y.request.includes,u.includes):!0}),b=Array.from(this.c.values()).filter(({request:u})=>!w.find(y=>y.path===u.path&&(0,M.patternsEquals)(y.excludes,u.excludes)&&(0,M.patternsEquals)(y.includes,u.includes))).map(({request:u})=>u.path);v.length&&this.j(`Request to start watching: ${v.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const u of b)this.h(u);for(const u of v)this.g(u)}g(d){const w=new C.NodeJSFileWatcherLibrary(d,b=>this.a.fire(b),b=>this.b.fire(b),this.f),v={request:d,instance:w};this.c.set(d.path,v)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const w=this.c.get(d);w&&(this.c.delete(d),w.instance.dispose())}i(d){const w=new Map;for(const v of d){const b=R.isLinux?v.path:v.path.toLowerCase();w.set(b,v)}return Array.from(w.values())}async setVerboseLogging(d){this.f=d;for(const[,w]of this.c)w.instance.setVerboseLogging(d)}j(d){this.f&&this.b.fire({type:"trace",message:this.k(d)})}k(d,w){return w?`[File Watcher (node.js)] ${d} (path: ${w.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=k}),define(Z[207],ee([0,1,76,206]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends I.AbstractNonRecursiveWatcherClient{constructor(C,k,m){super(C,k,m),this.m()}l(){return new M.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(Z[208],ee([0,1,14,47,155,76]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends R.AbstractUniversalWatcherClient{constructor(m,d,w){super(m,d,w),this.m()}l(m){const d=m.add(new n.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(d.onDidProcessExit(({code:w,signal:v})=>this.n(`terminated by itself with code ${w}, signal: ${v}`))),M.ProxyChannel.toService((0,M.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(Z[89],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...n){this.a=new Map;for(const[R,C]of n)this.set(R,C)}set(n,R){const C=this.a.get(n);return this.a.set(n,R),C}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=I}),define(Z[209],ee([0,1,7,13,2,74,200,6,89,99]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class b{constructor(a=new m.ServiceCollection,g=!1,f,E=w){this.f=a,this.g=g,this.h=f,this.i=E,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=E?f?._globalGraph??new C.Graph(S=>S):void 0}createChild(a){return new b(a,this.g,this,this.i)}invokeFunction(a,...g){const f=y.traceInvocation(this.i,a);let E=!1;try{return a({get:D=>{if(E)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(D,f);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...g)}finally{E=!0,f.stop()}}createInstance(a,...g){let f,E;return a instanceof R.SyncDescriptor?(f=y.traceCreation(this.i,a.ctor),E=this.j(a.ctor,a.staticArguments.concat(g),f)):(f=y.traceCreation(this.i,a),E=this.j(a,g,f)),f.stop(),E}j(a,g=[],f){const E=k._util.getServiceDependencies(a).sort((t,c)=>t.index-c.index),S=[];for(const t of E){const c=this.m(t.id,f);c||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(c)}const D=E.length>0?E[0].index:g.length;if(g.length!==D){console.trace(`[createInstance] First service dependency of ${a.name} at position ${D+1} conflicts with ${g.length} static arguments`);const t=D-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,D)}return Reflect.construct(a,g.concat(S))}k(a,g){if(this.f.get(a)instanceof R.SyncDescriptor)this.f.set(a,g);else if(this.h)this.h.k(a,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const g=this.f.get(a);return!g&&this.h?this.h.l(a):g}m(a,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const f=this.l(a);return f instanceof R.SyncDescriptor?this.q(a,f,g.branch(a,!0)):(g.branch(a,!1),f)}q(a,g,f){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,g,f)}finally{this.o.delete(a)}}r(a,g,f){const E=new C.Graph(t=>t.id.toString());let S=0;const D=[{id:a,desc:g,_trace:f}];for(;D.length;){const t=D.pop();if(E.lookupOrInsertNode(t),S++>1e3)throw new v(E);for(const c of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(c.id);if(i||this.u(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof R.SyncDescriptor){const s={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};E.insertEdge(t,s),D.push(s)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new v(E);break}for(const{data:c}of t){if(this.l(c.id)instanceof R.SyncDescriptor){const s=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,s)}E.removeNode(c)}}return this.l(a)}s(a,g,f=[],E,S){if(this.f.get(a)instanceof R.SyncDescriptor)return this.t(a,g,f,E,S);if(this.h)return this.h.s(a,g,f,E,S);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(a,g,f=[],E,S){if(E){const D=new b(void 0,this.g,this,this.i);D.c=String(a);const t=new Map,c=new I.IdleValue(()=>{const i=D.j(g,f,S);for(const[s,o]of t){const l=i[s];if(typeof l=="function")for(const r of o)l.apply(i,r)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!c.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let r=t.get(s);return r||(r=new d.LinkedList,t.set(s,r)),(P,A,T)=>{const N=r.push([P,A,T]);return(0,n.toDisposable)(N)}}if(s in i)return i[s];const o=c.value;let l=o[s];return typeof l!="function"||(l=l.bind(o),i[s]=l),l},set(i,s,o){return c.value[s]=o,!0},getPrototypeOf(i){return g.prototype}})}else return this.j(g,f,S)}u(a,g){if(g&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=b;var u;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(u||(u={}));class y{static traceInvocation(a,g){return a?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(a,g){return a?new y(1,g.name):y.c}constructor(a,g){this.type=a,this.name=g,this.g=Date.now(),this.h=[]}branch(a,g){const f=new y(3,a.toString());return this.h.push([a,g,f]),f}stop(){const a=Date.now()-this.g;y.f+=a;let g=!1;function f(S,D){const t=[],c=new Array(S+1).join("	");for(const[i,s,o]of D.h)if(s&&o){g=!0,t.push(`${c}CREATES -> ${i}`);const l=f(S+1,o);l&&t.push(l)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(a>2||g)&&y.all.add(E.join(`
`))}}y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0,e.Trace=y}),define(Z[5],ee([0,1,44,3,2,35,4,10,8,6]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function w(){return new Date().toISOString()}function v(r){return(0,k.isNumber)(r)}e.isLogLevel=v;var b;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function u(r,h,P){switch(h){case b.Trace:r.trace(P);break;case b.Debug:r.debug(P);break;case b.Info:r.info(P);break;case b.Warning:r.warn(P);break;case b.Error:r.error(P);break;case b.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=u;function y(r){let h="";for(let P=0;P<r.length;P++){let A=r[P];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}h+=(P>0?" ":"")+A}return h}e.format=y;class p extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new M.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==b.Off&&this.b<=h}}e.AbstractLogger=p;class a extends p{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...P){this.f(b.Trace)&&this.g(b.Trace,y([h,...P]))}debug(h,...P){this.f(b.Debug)&&this.g(b.Debug,y([h,...P]))}info(h,...P){this.f(b.Info)&&this.g(b.Info,y([h,...P]))}warn(h,...P){this.f(b.Warning)&&this.g(b.Warning,y([h,...P]))}error(h,...P){if(this.f(b.Error))if(h instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=h.stack,this.g(b.Error,y(A))}else this.g(b.Error,y([h,...P]))}flush(){}}e.AbstractMessageLogger=a;class g extends p{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.g=!C.isWindows}trace(h,...P){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,h,...P):console.log(`[main ${w()}]`,h,...P))}debug(h,...P){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,h,...P):console.log(`[main ${w()}]`,h,...P))}info(h,...P){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,h,...P):console.log(`[main ${w()}]`,h,...P))}warn(h,...P){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,h,...P):console.warn(`[main ${w()}]`,h,...P))}error(h,...P){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,h,...P):console.error(`[main ${w()}]`,h,...P))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class f extends p{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h)}trace(h,...P){this.f(b.Trace)&&console.log("%cTRACE","color: #888",h,...P)}debug(h,...P){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",h,...P)}info(h,...P){this.f(b.Info)&&console.log("%c INFO","color: #33f",h,...P)}warn(h,...P){this.f(b.Warning)&&console.log("%c WARN","color: #993",h,...P)}error(h,...P){this.f(b.Error)&&console.log("%c  ERR","color: #f33",h,...P)}dispose(){}flush(){}}e.ConsoleLogger=f;class E extends p{constructor(h,P=e.DEFAULT_LOG_LEVEL){super(),this.g=h,this.setLevel(P)}trace(h,...P){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(h),...P])}debug(h,...P){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(h),...P])}info(h,...P){this.f(b.Info)&&this.g.log(b.Info,[this.h(h),...P])}warn(h,...P){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(h),...P])}error(h,...P){this.f(b.Error)&&this.g.log(b.Error,[this.h(h),...P])}h(h){return typeof h=="string"?h:(0,I.toErrorMessage)(h,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class S extends p{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const P of this.g)P.setLevel(h);super.setLevel(h)}trace(h,...P){for(const A of this.g)A.trace(h,...P)}debug(h,...P){for(const A of this.g)A.debug(h,...P)}info(h,...P){for(const A of this.g)A.info(h,...P)}warn(h,...P){for(const A of this.g)A.warn(h,...P)}error(h,...P){for(const A of this.g)A.error(h,...P)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.MultiplexLogger=S;class D extends n.Disposable{constructor(h,P){if(super(),this.j=h,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new M.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new M.Emitter),this.onDidChangeVisibility=this.h.event,P)for(const A of P)this.c.set(A.resource,A)}getLogger(h){return this.b.get(h)}createLogger(h,P){let A=this.b.get(h);const T=P?.logLevel==="always"?b.Trace:P?.logLevel;return A||(A=this.k(h,T??this.getLogLevel(h)??this.j,P),this.b.set(h,A)),this.registerLogger({resource:h,id:P?.id??h.toString(),logLevel:T,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId}),A}setLogLevel(h,P){if(m.URI.isUri(h)){const A=h,T=P,N=this.c.get(A);N&&T!==N.logLevel&&(N.logLevel=T===this.j?void 0:T,this.b.get(A)?.setLevel(T),this.c.set(N.resource,N),this.g.fire([A,T]))}else{this.j=h;for(const[A,T]of this.b.entries())this.c.get(A)?.logLevel===void 0&&T.setLevel(this.j);this.g.fire(this.j)}}setVisibility(h,P){const A=this.c.get(h);A&&P!==!A.hidden&&(A.hidden=!P,this.c.set(A.resource,A),this.h.fire([h,P]))}getLogLevel(h){let P;return h&&(P=this.c.get(h)?.logLevel),P??this.j}registerLogger(h){const P=this.c.get(h.resource);P?P.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.c.set(h.resource,h),this.f.fire({added:[h],removed:[]}))}deregisterLogger(h){const P=this.c.get(h);if(P){this.c.delete(h);const A=this.b.get(h);A&&(this.b.delete(h),A.dispose()),this.f.fire({added:[],removed:[P]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(h){return this.c.get(h)}dispose(){this.b.forEach(h=>h.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=D;class t{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(h){}getLevel(){return b.Info}trace(h,...P){}debug(h,...P){}info(h,...P){}warn(h,...P){}error(h,...P){}critical(h,...P){}dispose(){}flush(){}}e.NullLogger=t;class c extends t{}e.NullLogService=c;class i extends D{constructor(){super(b.Info)}k(h,P,A){return new t}}e.NullLoggerService=i;function s(r){if(r.verbose)return b.Trace;if(typeof r.logLevel=="string"){const h=l(r.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function o(r){switch(r){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=o;function l(r){switch(r){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=l});var Q=this&&this.__param||function(x,e){return function(I,M){e(I,M,x)}};define(Z[210],ee([0,1,75,3,2,5,4,7]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let m=class ut extends n.Disposable{constructor(w){super(),this.g=w,this.c=this.B(new M.Emitter),this.onDidChangePassword=this.c.event}async getPassword(w,v){this.g.trace("Getting password from keytar:",w,v);let b;try{b=await this.h()}catch{return null}const u=await(0,k.retry)(()=>b.getPassword(w,v),50,3);if(!u)return this.g.trace("Did not get a password from keytar for account:",v),u;let y,p;try{const a=JSON.parse(u);y=a.content,p=a.hasNextChunk}catch{}if(!y||!p)return this.g.trace("Got password from keytar for account:",v),u;try{let a=1;for(;p;){const g=await(0,k.retry)(()=>b.getPassword(w,`${v}-${a}`),50,3),f=JSON.parse(g);y+=f.content,p=f.hasNextChunk,a++}return this.g.trace(`Got ${a}-chunked password from keytar for account:`,v),y}catch(a){return this.g.error(a),u}}async setPassword(w,v,b){this.g.trace("Setting password using keytar:",w,v);let u;try{u=await this.h()}catch(y){throw this.i?.(y),y}if(C.isWindows&&b.length>ut.a){let y=0,p=0,a=!0;for(;a;){const g=b.substring(y,y+ut.b);y+=ut.b,a=b.length-y>0;const f={content:g,hasNextChunk:a};await(0,k.retry)(()=>u.setPassword(w,p?`${v}-${p}`:v,JSON.stringify(f)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,v)}else await(0,k.retry)(()=>u.setPassword(w,v,b),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:w,account:v})}async deletePassword(w,v){this.g.trace("Deleting password using keytar:",w,v);let b;try{b=await this.h()}catch(g){throw this.i?.(g),g}const u=await b.getPassword(w,v);if(!u)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let y,p;try{const g=JSON.parse(u);y=g.content,p=g.hasNextChunk}catch{}let a=0;if(y&&p)try{for(a++;p;){const g=`${v}-${a}`,f=await b.getPassword(w,g);await b.deletePassword(w,g),p=JSON.parse(f).hasNextChunk,a++}}catch(g){this.g.error(g)}return await b.deletePassword(w,v)?(this.c.fire({service:w,account:v}),this.g.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,v),!1)}async findPassword(w){let v;try{v=await this.h()}catch{return null}return await v.findPassword(w)}async findCredentials(w){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(w)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};m.a=2500,m.b=m.a-100,m=ve([Q(0,R.ILogService)],m),e.BaseCredentialsMainService=m}),define(Z[211],ee([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let M=class{constructor(R,C){this.a=R,this.b=C}c(){return new Promise((R,C)=>x(["vscode-encrypt"],R,C))}async encrypt(R){let C;try{C=await this.c()}catch{return R}try{return C.encrypt(this.a,R)}catch(k){return this.b.error(k),R}}async decrypt(R){let C;try{C=await this.c()}catch{return R}try{return C.decrypt(this.a,R)}catch(k){return this.b.error(k),R}}};M=ve([Q(1,I.ILogService)],M),e.EncryptionMainService=M}),define(Z[212],ee([0,1,25,7,13,3,2,9,76,5]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class w extends C.Disposable{constructor(b,u){super(),this.a=b,this.b=u,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.ThrottledDelayer(0)),this.s=[],this.t=this.B(new M.ThrottledDelayer(0))}watch(b,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(b,u):this.u(b,u)}l(b,u){const y={path:this.C(b),excludes:u.excludes,includes:u.includes,recursive:u.recursive},p=(0,I.insert)(this.j,y);return this.m(),(0,C.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,n.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,m.toFileChanges)(u)),u=>this.z(u),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const u of this.j)(0,m.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const u of this.j)(0,m.isRecursiveWatchRequest)(u)&&b.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,u){const y={path:this.C(b),excludes:u.excludes,includes:u.includes,recursive:!1},p=(0,I.insert)(this.s,y);return this.v(),(0,C.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,n.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,m.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,k.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=w}),define(Z[213],ee([0,1,25,7,17,22,3,60,70,2,61,14,64,19,59,168,16,112,5,13]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends d.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new M.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const i=new d.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(s=>this.R.fire(new a.FileChangesEvent(s,!this.O(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,d.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,d.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(i){c.push(i)}}),!this.h.has(t)&&await M.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return m.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,u.isAbsolutePath)(t))throw new a.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const i=new E.ErrorNoTelemetry;throw i.message=(0,p.localize)(1,null,t.toString()),i}return c}async k(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c)||(0,a.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(i){throw(0,a.toFileSystemProviderErrorCode)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,a.ensureFileSystemProviderError)(i)}}async n(t,c){const i=await this.j(t),s=this.O(i),o=c?.resolveTo,l=c?.resolveSingleChildDescendants,r=c?.resolveMetadata,h=await i.stat(t);let P;return this.p(i,t,h,void 0,!!r,(A,T)=>(P||(P=w.TernarySearchTree.forUris(()=>!s),P.set(t,!0),o&&P.fill(!0,o)),P.get(A.resource)||P.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&l?T===1:!1))}async p(t,c,i,s,o,l){const{providerExtUri:r}=this.N(t),h={resource:c,name:r.basename(c),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&a.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,a.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(h.isDirectory&&l(h,s)){try{const P=await t.readdir(c),A=await M.Promises.settled(P.map(async([T,N])=>{try{const z=r.joinPath(c,T),H=o?await t.stat(z):{type:N};return await this.p(t,z,H,P.length,o,l)}catch(z){return this.b.trace(z),null}}));h.children=(0,I.coalesce)(A)}catch(P){this.b.trace(P),h.children=[]}return h}return h}async resolveAll(t){return M.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),i=await c.stat(t);return this.p(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(i){return i}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new a.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=n.VSBuffer.fromString(""),i){await this.r(t,i);const s=await this.writeFile(t,c);return this.m.fire(new a.FileOperationEvent(t,0,s)),s}async writeFile(t,c,i){const s=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(s);try{await this.s(s,t,i)||await this.P(s,o.dirname(t));let r;if((0,a.hasReadWriteCapability)(s)&&!(c instanceof n.VSBuffer))if((0,y.isReadableStream)(c)){const h=await(0,y.peekStream)(c,3);h.ended?r=n.VSBuffer.concat(h.buffer):r=h}else r=(0,y.peekReadable)(c,h=>n.VSBuffer.concat(h),3);else r=c;!(0,a.hasOpenReadWriteCloseCapability)(s)||(0,a.hasReadWriteCapability)(s)&&r instanceof n.VSBuffer?await this.cb(s,t,i,r):await this.Y(s,t,i,r instanceof n.VSBuffer?(0,n.bufferToReadable)(r):r),this.m.fire(new a.FileOperationEvent(t,4))}catch(l){throw new a.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,a.ensureFileSystemProviderError)(l).toString()),(0,a.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(c)));let o;try{o=await t.stat(c)}catch{return}if((o.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,p.localize)(6,null,this.nb(c)),0,i);if(this.mb(c,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,a.etag)({mtime:i.mtime,size:o.size}))throw new a.FileOperationError((0,p.localize)(7,null),3,i);return o}async readFile(t,c,i){const s=await this.k(t);return c?.atomic?this.t(s,t,c,i):this.u(s,t,c,i)}async t(t,c,i,s){return new Promise((o,l)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const r=await this.u(t,c,i,s);o(r)}catch(r){l(r)}})})}async u(t,c,i,s){const o=await this.v(t,c,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,n.streamToBuffer)(o.value)}}async readFileStream(t,c,i){const s=await this.k(t);return this.v(s,t,c,i)}async v(t,c,i,s){const o=new R.CancellationTokenSource(s),l=this.F(c,i).then(h=>h,h=>{throw o.cancel(),h});let r;try{return typeof i?.etag=="string"&&i.etag!==a.ETAG_DISABLED&&await l,i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)||!((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasFileReadStreamCapability)(t))||(0,a.hasReadWriteCapability)(t)&&i?.preferUnbuffered?r=this.D(t,c,i):(0,a.hasFileReadStreamCapability)(t)?r=this.z(t,c,o.token,i):r=this.C(t,c,o.token,i),{...await l,value:r}}catch(h){throw r&&await(0,y.consumeStream)(r),this.w(h,c,i)}}w(t,c,i){const s=(0,p.localize)(8,null,this.nb(c),(0,a.ensureFileSystemProviderError)(t).toString());return t instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(s,t.stat,i):t instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(s,t.fileOperationResult,t.size,t.options):new a.FileOperationError(s,(0,a.toFileOperationResult)(t),i)}z(t,c,i,s=Object.create(null)){const o=t.readFileStream(c,s,i);return(0,y.transform)(o,{data:l=>l instanceof n.VSBuffer?l:n.VSBuffer.wrap(l),error:l=>this.w(l,c,s)},l=>n.VSBuffer.concat(l))}C(t,c,i,s=Object.create(null)){const o=(0,n.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,c,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.w(l,c,s)},i),o}D(t,c,i){const s=(0,y.newWriteableStream)(o=>n.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)?o=await t.readFile(c,{atomic:!0}):o=await t.readFile(c),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(c,o.byteLength,i),s.end(n.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async F(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new a.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==a.ETAG_DISABLED&&c.etag===i.etag)throw new a.NotModifiedSinceFileOperationError((0,p.localize)(10,null),i,c);return this.G(t,i.size,c),i}G(t,c,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&c>i.limits.size&&(s=7),typeof s=="number")throw new a.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),s,c,i)}}async canMove(t,c,i){return this.H(t,c,"move",i)}async canCopy(t,c,i){return this.H(t,c,"copy",i)}async H(t,c,i,s){if(t.toString()!==c.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(c),c);await this.M(o,t,l,c,i,s)}catch(o){return o}return!0}async move(t,c,i){const s=this.lb(await this.l(t),t),o=this.lb(await this.l(c),c),l=await this.I(s,t,o,c,"move",!!i),r=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,l==="move"?2:3,r)),r}async copy(t,c,i){const s=await this.k(t),o=this.lb(await this.l(c),c),l=await this.I(s,t,o,c,"copy",!!i),r=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,l==="copy"?3:2,r)),r}async I(t,c,i,s,o,l){if(c.toString()===s.toString())return o;const{exists:r,isSameResourceWithDifferentPathCase:h}=await this.M(t,c,i,s,o,l);if(r&&!h&&l&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),o==="copy"){if(t===i&&(0,a.hasFileFolderCopyCapability)(t))await t.copy(c,s,{overwrite:l});else{const P=await this.resolve(c);P.isDirectory?await this.L(t,P,i,s):await this.J(t,c,i,s)}return o}else return t===i?(await t.rename(c,s,{overwrite:l}),o):(await this.I(t,c,i,s,"copy",l),await this.del(c,{recursive:!0}),"copy")}async J(t,c,i,s){if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.eb(t,c,i,s);if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.kb(t,c,i,s);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.ib(t,c,i,s);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.gb(t,c,i,s)}async L(t,c,i,s){await i.mkdir(s),Array.isArray(c.children)&&await M.Promises.settled(c.children.map(async o=>{const l=this.N(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,l):this.J(t,o.resource,i,l)}))}async M(t,c,i,s,o,l){let r=!1;if(t===i){const{providerExtUri:P,isPathCaseSensitive:A}=this.N(t);if(A||(r=P.isEqual(c,s)),r&&o==="copy")throw new Error((0,p.localize)(12,null,this.nb(c),this.nb(s)));if(!r&&P.isEqualOrParent(s,c))throw new Error((0,p.localize)(13,null,this.nb(c),this.nb(s)))}const h=await this.exists(s);if(h&&!r){if(!l)throw new a.FileOperationError((0,p.localize)(14,null,this.nb(c),this.nb(s)),4);if(t===i){const{providerExtUri:P}=this.N(t);if(P.isEqualOrParent(c,s))throw new Error((0,p.localize)(15,null,this.nb(c),this.nb(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:r}}N(t){const c=this.O(t);return{providerExtUri:c?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,0,i)),i}async P(t,c){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(c,s.dirname(c));)try{if(((await t.stat(c)).type&a.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(c)));break}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(c)),c=s.dirname(c)}for(let o=i.length-1;o>=0;o--){c=s.joinPath(c,i[o]);try{await t.mkdir(c)}catch(l){if((0,a.toFileSystemProviderErrorCode)(l)!==a.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,c){try{await this.Q(t,c)}catch(i){return i}return!0}async Q(t,c){const i=this.lb(await this.j(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new a.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!c?.recursive){const r=await this.resolve(t);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return i}async del(t,c){const i=await this.Q(t,c),s=!!c?.useTrash,o=!!c?.recursive;await i.delete(t,{recursive:o,useTrash:s}),this.m.fire(new a.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.j(t),s=this.lb(await this.l(c),c);if(i===s&&this.N(i).providerExtUri.isEqual(t,c))return;if(i===s&&(0,a.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.P(s,this.N(s).providerExtUri.dirname(c));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,a.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,c,{overwrite:!0})):o.queue(()=>this.J(i,t,s,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new d.DisposableStore;let s=!1,o=()=>{s=!0};return i.add((0,d.toDisposable)(()=>o())),(async()=>{try{const l=await this.W(t,c);s?(0,d.dispose)(l):o=()=>(0,d.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,c){const i=await this.j(t),s=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),c]);let o=this.U.get(s);return o||(o={count:0,disposable:i.watch(t,c)},this.U.set(s,o)),o.count+=1,(0,d.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,d.dispose)(o.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,d.dispose)(t.disposable);this.U.clear()}async Y(t,c,i,s){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(s)||(0,y.isReadableBufferedStream)(s)?await this.Z(t,o,s):await this.ab(t,o,s)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await t.close(o)}})}async Z(t,c,i){let s=0,o;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=n.VSBuffer.concat(i.buffer);await this.bb(t,c,l,l.byteLength,s,0),s+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,r)=>{(0,y.listenStream)(o,{onData:async h=>{o.pause();try{await this.bb(t,c,h,h.byteLength,s,0)}catch(P){return r(P)}s+=h.byteLength,setTimeout(()=>o.resume())},onError:h=>r(h),onEnd:()=>l()})})}async ab(t,c,i){let s=0,o;for(;(o=i.read())!==null;)await this.bb(t,c,o,o.byteLength,s,0),s+=o.byteLength}async bb(t,c,i,s,o,l){let r=0;for(;r<s;)r+=await t.write(c,o+r,i.buffer,l+r,s-r)}async cb(t,c,i,s){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,i,s))}async db(t,c,i,s){let o;s instanceof n.VSBuffer?o=s:(0,y.isReadableStream)(s)?o=await(0,n.streamToBuffer)(s):(0,y.isReadableBufferedStream)(s)?o=await(0,n.bufferedStreamToBuffer)(s):o=(0,n.readableToBuffer)(s),await t.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,c,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,c,i,s))}async fb(t,c,i,s){let o,l;try{o=await t.open(c,{create:!1}),l=await i.open(s,{create:!0,unlock:!1});const r=n.VSBuffer.alloc(this.a);let h=0,P=0,A=0;do A=await t.read(o,h,r.buffer,P,r.byteLength-P),await this.bb(i,l,r,A,h,P),h+=A,P+=A,P===r.byteLength&&(P=0);while(A>0)}catch(r){throw(0,a.ensureFileSystemProviderError)(r)}finally{await M.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,c,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,c,i,s))}async hb(t,c,i,s){return i.writeFile(s,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(t,c,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,c,i,s))}async jb(t,c,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const l=await t.readFile(c);await this.bb(i,o,n.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await i.close(o)}}async kb(t,c,i,s){const o=await(0,n.streamToBuffer)(this.C(t,c,R.CancellationToken.None));await this.cb(i,s,void 0,o)}lb(t,c){if(t.capabilities&2048)throw new a.FileOperationError((0,p.localize)(20,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};S=ve([Q(0,f.ILogService)],S),e.FileService=S}),define(Z[90],ee([0,1,41,289,7,35,17,3,32,2,9,4,19,59,23,172,16,112,212,44,208,207]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,M.gracefulify)(I)}catch(c){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(c)}`)}})();class t extends f.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s),this.onDidChangeCapabilities=k.Event.None,this.H=new R.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:o}=await y.SymlinkSupport.stat(this.C(i));return{type:this.G(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(i){try{const s=await y.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async l=>{try{let r;l.isSymbolicLink()?r=(await this.stat((0,b.joinPath)(i,l.name))).type:r=this.G(l),o.push([l.name,r])}catch(r){this.a.trace(r)}})),o}catch(s){throw this.Y(s)}}G(i,s){let o;return s?.dangling?o=a.FileType.Unknown:i.isFile()?o=a.FileType.File:i.isDirectory()?o=a.FileType.Directory:o=a.FileType.Unknown,s&&(o|=a.FileType.SymbolicLink),o}async I(i){const s=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const l=new n.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,d.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),l.open()})}async readFile(i,s){let o;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const l=this.C(i);return await y.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,s,o){const l=(0,u.newWriteableStream)(r=>C.VSBuffer.concat(r.map(h=>C.VSBuffer.wrap(h))).buffer);return(0,g.readFileIntoStream)(this,i,l,r=>r.buffer,{...s,bufferSize:256*1024},o),l}async writeFile(i,s,o){let l;try{const r=this.C(i);if(!o.create||!o.overwrite){if(await y.Promises.exists(r)){if(!o.overwrite)throw(0,a.createFileSystemProviderError)((0,p.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,a.createFileSystemProviderError)((0,p.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(l,0,s,0,s.byteLength)}catch(r){throw await this.Z(i,r)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,s){const o=this.C(i);let l;(0,a.isFileOpenForWriteOptions)(s)&&(l=await this.I(i));let r;try{if((0,a.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:P}=await y.SymlinkSupport.stat(o);P.mode&128||await y.Promises.chmod(o,P.mode|128)}catch(P){this.a.trace(P)}let h;if((0,a.isFileOpenForWriteOptions)(s)){if(v.isWindows)try{await y.Promises.truncate(o,0),h="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}h||(h="w")}else h="r";r=await y.Promises.open(o,h)}catch(h){throw l?.dispose(),(0,a.isFileOpenForWriteOptions)(s)?await this.Z(i,h):this.Y(h)}if(this.L.set(r,0),(0,a.isFileOpenForWriteOptions)(s)&&this.N.set(r,i),l){const h=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${o})`),this.M.set(r,l),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${o})`),h.dispose())}return r}async close(i){const s=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await y.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await y.Promises.close(i)}catch(o){throw this.Y(o)}finally{s&&(this.M.get(i)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,o,l,r){const h=this.P(i,s);let P=null;try{P=(await y.Promises.read(i,o,l,r,h)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,h,P)}return P}P(i,s){return s===this.L.get(i)?null:s}Q(i,s,o){const l=this.L.get(i);typeof l=="number"&&(typeof s=="number"||(typeof o=="number"?this.L.set(i,l+o):this.L.delete(i)))}async write(i,s,o,l,r){return(0,n.retry)(()=>this.R(i,s,o,l,r),100,3)}async R(i,s,o,l,r){const h=this.P(i,s);let P=null;try{P=(await y.Promises.write(i,o,l,r,h)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,h,P)}return P}async mkdir(i){try{await y.Promises.mkdir(this.C(i))}catch(s){throw this.Y(s)}}async delete(i,s){try{const o=this.C(i);s.recursive?await y.Promises.rm(o,y.RimRafMode.MOVE):await y.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,s,o){const l=this.C(i),r=this.C(s);if(l!==r)try{await this.S(i,s,"move",o.overwrite),await y.Promises.move(l,r)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,p.localize)(2,null,(0,w.basename)(l),(0,w.basename)((0,w.dirname)(r)),h.toString()))),this.Y(h)}}async copy(i,s,o){const l=this.C(i),r=this.C(s);if(l!==r)try{await this.S(i,s,"copy",o.overwrite),await y.Promises.copy(l,r,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,p.localize)(3,null,(0,w.basename)(l),(0,w.basename)((0,w.dirname)(r)),h.toString()))),this.Y(h)}}async S(i,s,o,l){const r=this.C(i),h=this.C(s);let P=!1;if(!!(this.capabilities&1024)||(P=(0,m.isEqual)(r,h,!0)),P&&o==="copy")throw(0,a.createFileSystemProviderError)((0,p.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!P&&await y.Promises.exists(h)){if(!l)throw(0,a.createFileSystemProviderError)((0,p.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.U(i,s,!1)}async U(i,s,o){const l=this.C(i),r=this.C(s),h=!!(this.capabilities&1024);if((0,m.isEqual)(l,r,!h))return;const P=new d.DisposableStore;try{const[A,T]=await Promise.all([this.I(i),this.I(s)]);P.add(A),P.add(T),o&&await y.Promises.mkdir((0,w.dirname)(r),{recursive:!0}),await y.Promises.copyFile(l,r)}catch(A){if(A.code==="ENOENT"&&!o)return this.U(i,s,!0);throw this.Y(A)}finally{P.dispose()}}p(i,s,o){return new S.UniversalWatcherClient(l=>i(l),l=>s(l),o)}y(i,s,o){return new D.NodeJSWatcherClient(l=>i(l),l=>s(l),o)}Y(i){if(i instanceof a.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,s)}async Z(i,s){let o=this.Y(s);if(i&&o.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await y.SymlinkSupport.stat(this.C(i));l.mode&128||(o=(0,a.createFileSystemProviderError)(s,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return o}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Z[214],ee([0,1,3,90,2,17,59,22]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class m extends n.Disposable{constructor(v,b){super(),this.a=v,this.b=b,this.w=new Map,this.y=new Map}call(v,b,u){const y=this.c(v);switch(b){case"stat":return this.g(y,u[0]);case"readdir":return this.h(y,u[0]);case"open":return this.l(y,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(y,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(y,u[0],u[1],u[2]);case"rename":return this.t(y,u[0],u[1],u[2]);case"copy":return this.u(y,u[0],u[1],u[2]);case"cloneFile":return this.v(y,u[0],u[1]);case"mkdir":return this.r(y,u[0]);case"delete":return this.s(y,u[0],u[1]);case"watch":return this.C(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,u){const y=this.c(v);switch(b){case"fileChange":return this.z(y,u[0]);case"readFileStream":return this.j(y,u[0],u[1])}throw new Error(`Unknown event ${b}`)}g(v,b){const u=this.f(v,b,!0);return this.a.stat(u)}h(v,b){const u=this.f(v,b);return this.a.readdir(u)}async i(v,b,u){const y=this.f(v,b,!0),p=await this.a.readFile(y,u);return R.VSBuffer.wrap(p)}j(v,b,u){const y=this.f(v,b,!0),p=new k.CancellationTokenSource,a=new I.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),g=this.a.readFileStream(y,u,p.token);return(0,C.listenStream)(g,{onData:f=>a.fire(R.VSBuffer.wrap(f)),onError:f=>a.fire(f),onEnd:()=>{a.fire("end"),a.dispose(),p.dispose()}}),a.event}k(v,b,u,y){const p=this.f(v,b);return this.a.writeFile(p,u.buffer,y)}l(v,b,u){const y=this.f(v,b,!0);return this.a.open(y,u)}m(v){return this.a.close(v)}async n(v,b,u){const y=R.VSBuffer.alloc(u),p=0,a=await this.a.read(v,b,y.buffer,p,u);return[y,a]}p(v,b,u,y,p){return this.a.write(v,b,u.buffer,y,p)}r(v,b){const u=this.f(v,b);return this.a.mkdir(u)}s(v,b,u){const y=this.f(v,b);return this.a.delete(y,u)}t(v,b,u,y){const p=this.f(v,b),a=this.f(v,u);return this.a.rename(p,a,y)}u(v,b,u,y){const p=this.f(v,b),a=this.f(v,u);return this.a.copy(p,a,y)}v(v,b,u){const y=this.f(v,b),p=this.f(v,u);return this.a.cloneFile(y,p)}z(v,b){const u=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(v,u))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(b)),this.w.delete(b)}});return u.event}async C(v,b,u,y,p){const a=this.w.get(b);if(a){const g=this.f(v,y),f=a.watch(u,g,p);this.y.set(b+u,f)}}async D(v,b){const u=v+b,y=this.y.get(u);y&&((0,n.dispose)(y),this.y.delete(u))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=m;class d extends n.Disposable{constructor(v,b,u,y){super(),this.c=v,this.f=u,this.g=y,this.a=new Map,this.b=this.B(new M.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(v){const b=this.B(new I.Emitter);this.B(b.event(u=>{v.fire(u.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(u=>b.fire(u))),this.B(this.b.onDidWatchError(u=>v.fire(u)))}i(v){}j(v){}watch(v,b,u){const y=this.j(this.g);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.a.set(v,this.b.watch(b,u)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=d}),define(Z[215],ee([0,1,15,171,4,8,16,9,214,149]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class w extends m.AbstractDiskFileSystemProviderChannel{constructor(u,y,p){super(u,y),this.G=p}c(u){return d.DefaultURITransformer}f(u,y){return R.URI.revive(y)}async s(u,y,p){if(!p.useTrash)return super.s(u,y,p);const a=this.f(u,y),g=(0,k.normalize)(a.fsPath);try{await I.shell.trashItem(g)}catch{throw(0,C.createFileSystemProviderError)(n.isWindows?(0,M.localize)(0,null,(0,k.basename)(g)):(0,M.localize)(1,null,(0,k.basename)(g)),C.FileSystemProviderErrorCode.Unknown)}}F(u,y){return new v(u,y,this.b,this.G)}}e.DiskFileSystemProviderChannel=w;class v extends m.AbstractSessionFileWatcher{watch(u,y,p){if(p.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,p)}}}),define(Z[216],ee([0,1,5]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class M extends I.AbstractMessageLogger{constructor(R=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(C=>{this.l?.setLevel(C)}))}set logger(R){this.l=R;for(const{level:C,message:k}of this.k)(0,I.log)(R,C,k);this.k=[]}g(R,C){this.l?(0,I.log)(this.l,R,C):this.getLevel()<=R&&this.k.push({level:R,message:C})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=M}),define(Z[217],ee([0,1,2,5]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends I.Disposable{constructor(C,k=[]){super(),this.a=new M.MultiplexLogger([C,...k]),this.B(C.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.LogService=n}),define(Z[218],ee([0,1,35,8,5]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class R{constructor(k){this.b=k,this.a=new I.ResourceMap}listen(k,m,d){switch(m){case"onDidChangeLoggers":return d?this.b.getOnDidChangeLoggersEvent(d):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return d?this.b.getOnDidChangeLogLevelEvent(d):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return d?this.b.getOnDidChangeVisibilityEvent(d):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${m}`)}async call(k,m,d){switch(m){case"createLogger":this.c(M.URI.revive(d[0]),d[1],d[2]);return;case"log":return this.e(M.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1]);case"setLogLevel":return(0,n.isLogLevel)(d[0])?this.b.setLogLevel(d[0]):this.b.setLogLevel(M.URI.revive(d[0]),d[1]);case"setVisibility":return this.b.setVisibility(M.URI.revive(d[0]),d[1]);case"registerLogger":return this.b.registerLogger({...d[0],resource:M.URI.revive(d[0].resource)},d[1]);case"deregisterLogger":return this.b.deregisterLogger(M.URI.revive(d[0]))}throw new Error(`Call not found: ${m}`)}c(k,m,d){this.a.set(k,this.b.createLogger(k,m,d))}d(k,m){let d=console.log;switch(k){case n.LogLevel.Error:d=console.error;break;case n.LogLevel.Warning:d=console.warn;break;case n.LogLevel.Info:d=console.info;break}d.call(console,...m)}e(k,m){const d=this.a.get(k);if(!d)throw new Error("Create the logger before logging");for(const[w,v]of m)(0,n.log)(d,w,v)}}e.LoggerChannel=R}),define(Z[219],ee([0,1,16,5]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(n||(n={}));async function R(d,w,v,b,u){try{const y=await new Promise((a,g)=>{x(["spdlog"],a,g)});y.setFlushOn(n.Trace);const p=await y.createAsyncRotatingLogger(d,w,v,b);return u?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(y){console.error(y)}return null}function C(d,w,v){switch(w){case M.LogLevel.Trace:d.trace(v);break;case M.LogLevel.Debug:d.debug(v);break;case M.LogLevel.Info:d.info(v);break;case M.LogLevel.Warning:d.warn(v);break;case M.LogLevel.Error:d.error(v);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function k(d,w){switch(w){case M.LogLevel.Trace:d.setLevel(n.Trace);break;case M.LogLevel.Debug:d.setLevel(n.Debug);break;case M.LogLevel.Info:d.setLevel(n.Info);break;case M.LogLevel.Warning:d.setLevel(n.Warning);break;case M.LogLevel.Error:d.setLevel(n.Error);break;case M.LogLevel.Off:d.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class m extends M.AbstractMessageLogger{constructor(w,v,b,u,y){super(),this.k=[],this.setLevel(y),this.l=this.n(w,v,b,u),this.B(this.onDidChangeLogLevel(p=>{this.m&&k(this.m,p)}))}async n(w,v,b,u){const y=b?6:1,p=30/y*I.ByteSize.MB,a=await R(w,v,p,y,u);if(a){this.m=a,k(this.m,this.getLevel());for(const{level:g,message:f}of this.k)C(this.m,g,f);this.k=[]}}g(w,v){this.m?C(this.m,w,v):this.getLevel()<=w&&this.k.push({level:w,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=m}),define(Z[220],ee([0,1,31,5,219]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends M.AbstractLoggerService{k(k,m,d){return new n.SpdLogLogger((0,I.generateUuid)(),k.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,m)}}e.LoggerService=R}),define(Z[65],ee([0,1,35,3,6,5,220]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(R.ILoggerService);class k extends C.LoggerService{constructor(){super(...arguments),this.m=new I.ResourceMap}createLogger(d,w,v){v!==void 0&&this.m.set(d,v);try{return super.createLogger(d,w)}catch(b){throw this.m.delete(d),b}}registerLogger(d,w){w!==void 0&&this.m.set(d.resource,w),super.registerLogger(d)}deregisterLogger(d){this.m.delete(d),super.deregisterLogger(d)}getRegisteredLoggers(d){const w=[];for(const v of super.getRegisteredLoggers())d===this.m.get(v.resource)&&w.push(v);return w}getOnDidChangeLogLevelEvent(d){return M.Event.filter(this.onDidChangeLogLevel,w=>(0,R.isLogLevel)(w)||this.n(w[0],d))}getOnDidChangeVisibilityEvent(d){return M.Event.filter(this.onDidChangeVisibility,([w])=>this.n(w,d))}getOnDidChangeLoggersEvent(d){return M.Event.filter(M.Event.map(this.onDidChangeLoggers,w=>({added:[...w.added].filter(b=>this.n(b.resource,d)),removed:[...w.removed].filter(b=>this.n(b.resource,d))})),w=>w.added.length>0||w.removed.length>0)}deregisterLoggers(d){for(const[w,v]of this.m)v===d&&this.deregisterLogger(w)}n(d,w){const v=this.m.get(d);return v===void 0||v===w}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=k}),define(Z[221],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(C){return C.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function M(C){return C.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function n(C){return C.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function R(C){return!I(C)&&!M(C)&&!n(C)}e.isMenubarMenuItemAction=R}),define(Z[38],ee([0,1,3,70,2,6]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class C extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const w=Object.keys(this.f).length;return this.f={...d,...this.f},w!==Object.keys(this.f).length&&await this.i(d),M.Iterable.reduce(this.g.entries(),(v,[b,u])=>({...v,[b]:u}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return M.Iterable.reduce(Object.entries(this.f),(d,[w,v])=>({...d,[w]:{definition:v,value:this.g.get(w)}}),{})}}e.AbstractPolicyService=C;class k{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(Z[222],ee([0,1,7,3,70,10,16,5,38]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function d(v,b){const u=[];for(const y of new Set(n.Iterable.concat(v.keys(),b.keys())))v.get(y)!==b.get(y)&&u.push(y);return u}let w=class extends m.AbstractPolicyService{constructor(b,u,y){super(),this.j=b,this.k=u,this.l=y,this.c=this.B(new I.ThrottledDelayer(500));const p=M.Event.filter(u.onDidFilesChange,a=>a.affects(b));this.B(u.watch(b)),this.B(p(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const b=new Map;try{const u=await this.k.readFile(this.j),y=JSON.parse(u.value.toString());if(!(0,R.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(y))this.f[p]&&b.set(p,y[p])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return b}async p(){const b=await this.n(),u=d(this.g,b);this.g=b,u.length>0&&this.h.fire(u)}};w=ve([Q(1,C.IFileService),Q(2,k.ILogService)],w),e.FilePolicyService=w}),define(Z[223],ee([0,1,3,2,38]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(m){this.b=m,this.a=new M.DisposableStore}listen(m,d){switch(d){case"onDidChange":return I.Event.map(this.b.onDidChange,w=>w.reduce((v,b)=>({...v,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(m,d,w){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(w)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class C extends n.AbstractPolicyService{constructor(m,d){super(),this.a=d;for(const w in m){const{definition:v,value:b}=m[w];this.f[w]=v,b!==void 0&&this.g.set(w,b)}this.a.listen("onDidChange")(w=>{for(const v in w){const b=w[v];b===null?this.g.delete(v):this.g.set(v,b)}this.h.fire(Object.keys(w))})}async i(m){const d=await this.a.call("updatePolicyDefinitions",m);for(const w in d)this.g.set(w,d[w])}}e.PolicyChannelClient=C}),define(Z[224],ee([0,1,38,7,290,2,5]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends I.AbstractPolicyService{constructor(d,w){super(),this.j=d,this.k=w,this.a=new M.Throttler,this.b=this.B(new R.MutableDisposable)}async i(d){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`),await this.a.queue(()=>new Promise((w,v)=>{try{this.b.value=(0,n.createWatcher)(this.k,d,b=>{this.m(b),w()})}catch(b){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}m(d){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const w in d){const v=d[w];v===void 0?this.g.delete(w):this.g.set(w,v)}this.h.fire(Object.keys(d))}};k=ve([Q(0,C.ILogService)],k),e.NativePolicyService=k}),define(Z[66],ee([0,1,4,36]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const R=I.globals.vscode.context.configuration();if(R)n=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:R.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(Z[21],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[225],ee([0,1,81,5,21]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(k,m){this.b=k,this.c=m,this.a=new Map}async isExtensionUrlTrusted(k,m){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(m);if(!d)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",m),!1;const[,w,v]=d;let b=this.a.get(k);if(!b){if(b=this.b.trustedExtensionUrlPublicKeys[k],!b||b.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...b])}const u=Buffer.from(decodeURIComponent(v),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",m),!1;const y=u.slice(0,6),p=u.readUIntBE(0,6),a=Date.now()-p;if(a<0||a>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",m),!1;const g=u.slice(6),f=I.createVerify("SHA256");f.write(y),f.write(Buffer.from(w)),f.end();for(let E=0;E<b.length;E++){let S=b[E];if(S!==null){if(typeof S=="string")try{S=I.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),b[E]=S}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${E+1} for ${k}:`,D),b[E]=null;continue}if(f.verify(S,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",m),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",m),!1}};R=ve([Q(0,n.IProductService),Q(1,M.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[226],ee([0,1,7,5]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(C,k,m){this.a=C,this.b=k,this.c=m}async inspect(C){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(C);const m=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),m.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};n=ve([Q(2,M.ILogService)],n),e.WindowProfiler=n}),define(Z[67],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(Z[51],ee([0,1,127,10]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(C,k){I.ok(M.isString(C)),I.ok(M.isObject(k)),I.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new n}),define(Z[227],ee([0,1,3,51]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,d){this.a[n(m)]=d,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;M.Registry.add(e.Extensions.JSONContribution,C)}),define(Z[68],ee([0,1,25,3,10,158,18,227,51]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=m.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new M.Emitter,this.onDidSchemaChange=this.i.event,this.j=new M.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.n(t,c,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.o(t,c),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.o(c,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const i=[];for(const{overrides:s,source:o}of t)for(const l in s)if(c.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const r=this.a.get(l),h=r?.valuesSources??new Map;if(o)for(const N of Object.keys(s[l]))h.set(N,o);const P={...r?.value||{},...s[l]};this.a.set(l,{source:o,value:P,valuesSources:h});const A=(0,C.getLanguageTagSettingPlainKey)(l),T={type:"object",default:P,description:R.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:n.isString(o)?void 0:o,defaultValueSource:o};i.push(...p(l)),this.d[l]=T,this.b.properties[l]=T}else{this.a.set(l,{value:s[l],source:o});const r=this.d[l];r&&(this.w(l,r),this.r(l,r))}this.m(i)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:i,source:s}of t)for(const o in i){const l=this.a.get(o),r=n.isString(s)?s:s?.id,h=n.isString(l?.source)?l?.source:l?.source?.id;if(r===h)if(c.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const P=this.d[o];P&&(this.w(o,P),this.r(o,P))}}this.u()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,i){t.forEach(s=>{this.p(s,c,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,c){const i=s=>{if(s.properties)for(const o in s.properties){c.add(o);const l=this.d[o];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>i(o))};for(const s of t){i(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(t,c=!0,i,s,o=3,l){o=n.isUndefinedOrNull(t.scope)?o:t.scope;const r=t.properties;if(r)for(const P in r){const A=r[P];if(c&&E(P,A)){delete r[P];continue}if(A.source=i,A.defaultDefaultValue=r[P].default,this.w(P,A),e.OVERRIDE_PROPERTY_REGEX.test(P)?A.scope=void 0:(A.scope=n.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=n.isUndefinedOrNull(A.restricted)?!!s?.includes(P):A.restricted),r[P].hasOwnProperty("included")&&!r[P].included){this.f[P]=r[P],delete r[P];continue}else this.d[P]=r[P],r[P].policy?.name&&this.e.set(r[P].policy.name,P);!r[P].deprecationMessage&&r[P].markdownDeprecationMessage&&(r[P].deprecationMessage=r[P].markdownDeprecationMessage),l.add(P)}const h=t.allOf;if(h)for(const P of h)this.p(P,c,i,s,o,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=i=>{const s=i.properties;if(s)for(const l in s)this.r(l,s[l]);i.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const i=this.a.get(t);let s=i?.value,o=i?.source;n.isUndefined(s)&&(s=c.defaultDefaultValue,o=void 0),n.isUndefined(s)&&(s=g(c.type)),c.default=s,c.defaultValueSource=o}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let c=y.exec(D);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=y.exec(D)}}return(0,I.distinct)(t)}e.overrideIdentifiersFromKey=p;function a(D){return D.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=a;function g(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const f=new b;m.Registry.add(e.Extensions.Configuration,f);function E(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?R.localize(7,null,D):f.getConfigurationProperties()[D]!==void 0?R.localize(8,null,D):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,D,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=E;function S(){const D=[],t=f.getConfigurationProperties();for(const c of Object.keys(t))D.push([c,t[c].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=S}),define(Z[113],ee([0,1,25,3,43,2,35,37,10,8,18,68,51]),function(x,e,I,M,n,R,C,k,m,d,w,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(c){return Object.isFrozen(c)?c:k.deepFreeze(c)}class y{constructor(i={},s=[],o=[],l){this.b=i,this.c=s,this.d=o,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof y)return s;const o=new p("");return o.parseRaw(s),o.configurationModel});this.f=i.reduce((s,o)=>o===s?o:s.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,w.getConfigurationValue)(this.contents,i):this.contents}inspect(i,s){const o=this.rawConfiguration.getValue(i),l=s?this.rawConfiguration.getOverrideValue(i,s):void 0,r=s?this.rawConfiguration.override(s).getValue(i):o;return{value:o,override:l,merged:r}}getOverrideValue(i,s){const o=this.i(s);return o?i?(0,w.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const o of this.overrides)o.identifiers.includes(i)&&s.push(...o.keys);return I.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return I.distinct(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=k.deepClone(this.contents),o=k.deepClone(this.overrides),l=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const h of i)if(r.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(s,h.contents);for(const P of h.overrides){const[A]=o.filter(T=>I.equals(T.identifiers,P.identifiers));A?(this.h(A.contents,P.contents),A.keys.push(...P.keys),A.keys=I.distinct(A.keys)):o.push(k.deepClone(P))}for(const P of h.keys)l.indexOf(P)===-1&&l.push(P)}return new y(s,l,o,r.every(h=>h instanceof y)?void 0:r)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const l of I.distinct([...Object.keys(this.contents),...Object.keys(s)])){let r=this.contents[l];const h=s[l];h&&(typeof r=="object"&&typeof h=="object"?(r=k.deepClone(r),this.h(r,h)):r=h),o[l]=r}return new y(o,this.keys,this.overrides)}h(i,s){for(const o of Object.keys(s)){if(o in i&&m.isObject(i[o])&&m.isObject(s[o])){this.h(i[o],s[o]);continue}i[o]=k.deepClone(s[o])}}i(i){let s=null,o=null;const l=r=>{r&&(o?this.h(o,r):o=k.deepClone(r))};for(const r of this.overrides)I.equals(r.identifiers,[i])?s=r.contents:r.identifiers.includes(i)&&l(r.contents);return l(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,w.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>I.equals(o.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,s,o){(0,w.addToValueTree)(this.contents,i,s,l=>console.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,w.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=y;class p{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!m.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:o,keys:l,overrides:r,restricted:h,hasExcludedProperties:P}=this.h(i,s);this.b=new y(o,l,r,P?[i]:void 0),this.c=h||[]}g(i){let s={},o=null,l=[];const r=[],h=[];function P(T){Array.isArray(l)?l.push(T):o!==null&&(l[o]=T)}const A={onObjectBegin:()=>{const T={};P(T),r.push(l),l=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{l=r.pop()},onArrayBegin:()=>{const T=[];P(T),r.push(l),l=T,o=null},onArrayEnd:()=>{l=r.pop()},onLiteralValue:P,onError:(T,N,z)=>{h.push({error:T,offset:N,length:z})}};if(i)try{n.visit(i,A),s=l[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return s}h(i,s){const o=b.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,o,!0,s);i=l.raw;const r=(0,w.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),h=Object.keys(i),P=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:r,keys:h,overrides:P,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,s,o,l){let r=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:r};const h={},P=[];for(const A in i)if(v.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const T=this.i(i[A],s,!1,l);h[A]=T.raw,r=r||T.hasExcludedProperties,P.push(...T.restricted)}else{const T=s[A],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&P.push(A),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&!(l.skipRestricted&&T?.restricted)?h[A]=i[A]:r=!0}return{raw:h,restricted:P,hasExcludedProperties:r}}j(i,s){const o=[];for(const l of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(l)){const r={};for(const h in i[l])r[h]=i[l][h];o.push({identifiers:(0,v.overrideIdentifiersFromKey)(l),keys:Object.keys(r),contents:(0,w.toValuesTree)(r,s)})}return o}}e.ConfigurationModelParser=p;class a extends R.Disposable{constructor(i,s,o,l){super(),this.f=i,this.g=s,this.h=l,this.c=this.B(new M.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(M.Event.any(M.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),M.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class g{constructor(i,s,o,l,r,h,P,A,T,N,z,H,ie){this.a=i,this.b=s,this.c=o,this.overrideIdentifiers=l,this.d=r,this.f=h,this.g=P,this.h=A,this.i=T,this.j=N,this.k=z,this.l=H,this.m=ie}get value(){return u(this.c)}n(i,s,o){const l=i.inspect(s,o);return{get value(){return u(l.value)},get override(){return u(l.override)},get merged(){return u(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,s,o,l,r=new y,h=new y,P=new C.ResourceMap,A=new y,T=new C.ResourceMap){this.c=i,this.d=s,this.f=o,this.g=l,this.h=r,this.i=h,this.j=P,this.l=A,this.m=T,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(i,s,o){return this.q(i,s,o).getValue(i)}updateValue(i,s,o={}){let l;o.resource?(l=this.m.get(o.resource),l||(l=new y,this.m.set(o.resource,l))):l=this.l,s===void 0?l.removeValue(i):l.setValue(i,s),o.resource||(this.a=null)}inspect(i,s,o){const l=this.q(i,s,o),r=this.u(s.resource,o),h=s.resource?this.m.get(s.resource)||this.l:this.l,P=new Set;for(const A of l.overrides)for(const T of A.identifiers)l.getOverrideValue(i,T)!==void 0&&P.add(T);return new g(i,s,l.getValue(i),P.size?[...P]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,r||void 0,h)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const o=[];if(!s){const{added:l,updated:r,removed:h}=D(this.c,i);s=[...l,...r,...h]}for(const l of s)for(const r of(0,v.overrideIdentifiersFromKey)(l)){const h=this.c.getKeysForOverrideIdentifier(r),P=i.getKeysForOverrideIdentifier(r),A=[...P.filter(T=>h.indexOf(T)===-1),...h.filter(T=>P.indexOf(T)===-1),...h.filter(T=>!k.equals(this.c.override(r).getValue(T),i.override(r).getValue(T)))];o.push([r,A])}return this.updateDefaultConfiguration(i),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:o,removed:l}=D(this.d,i),r=[...s,...o,...l];return r.length&&this.updatePolicyConfiguration(i),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:o,removed:l,overrides:r}=D(this.applicationConfiguration,i),h=[...s,...o,...l];return h.length&&this.updateApplicationConfiguration(i),{keys:h,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:o,removed:l,overrides:r}=D(this.localUserConfiguration,i),h=[...s,...o,...l];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:r}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:o,removed:l,overrides:r}=D(this.remoteUserConfiguration,i),h=[...s,...o,...l];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:r}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:o,removed:l,overrides:r}=D(this.workspaceConfiguration,i),h=[...s,...o,...l];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:r}}compareAndUpdateFolderConfiguration(i,s){const o=this.p.get(i),{added:l,updated:r,removed:h,overrides:P}=D(o,s),A=[...l,...r,...h];return(A.length||!o)&&this.updateFolderConfiguration(i,s),{keys:A,overrides:P}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:r,overrides:h}=D(s,void 0);return{keys:[...o,...l,...r],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,o){let l=this.r(s,o);return s.overrideIdentifier&&(l=l.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},s){let o=this.s();if(s&&i){const l=s.getFolder(i);l&&(o=this.t(l.uri)||o);const r=this.m.get(i);r&&(o=o.merge(r))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const o=this.s(),l=this.j.get(i);l?(s=o.merge(l),this.b.set(i,s)):s=o}return s}u(i,s){if(s&&i){const o=s.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:o,overrides:l,keys:r}=this.j.get(s);return i.push([s,{contents:o,overrides:l,keys:r}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>s.add(l))),[...s.values()]}static parse(i){const s=this.x(i.defaults),o=this.x(i.policy),l=this.x(i.application),r=this.x(i.user),h=this.x(i.workspace),P=i.folders.reduce((A,T)=>(A.set(d.URI.revive(T[0]),this.x(T[1])),A),new C.ResourceMap);return new f(s,o,l,r,new y,h,P,new y,new C.ResourceMap)}static x(i){return new y(i.contents,i.keys,i.overrides)}}e.Configuration=f;function E(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,s=new Map;for(const l of c)l.keys.forEach(r=>i.add(r)),l.overrides.forEach(([r,h])=>{const P=(0,C.getOrSet)(s,r,new Set);h.forEach(A=>P.add(A))});const o=[];return s.forEach((l,r)=>o.push([r,[...l.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=E;class S{constructor(i,s,o,l){this.change=i,this.f=s,this.g=o,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of i.keys)this.affectedKeys.add(r);for(const[,r]of i.overrides)for(const h of r)this.affectedKeys.add(h);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,s){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const r=l+o.length;if(r>=this.d.length)return!1;const h=this.d.charCodeAt(r);if(h!==this.b&&h!==this.c)return!1;if(s){const P=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,A=this.g.getValue(i,s,this.h);return!k.equals(P,A)}return!0}}e.ConfigurationChangeEvent=S;function D(c,i){const{added:s,removed:o,updated:l}=t(i?.rawConfiguration,c?.rawConfiguration),r=[],h=c?.getAllOverrideIdentifiers()||[],P=i?.getAllOverrideIdentifiers()||[];if(i){const A=P.filter(T=>!h.includes(T));for(const T of A)r.push([T,i.getKeysForOverrideIdentifier(T)])}if(c){const A=h.filter(T=>!P.includes(T));for(const T of A)r.push([T,c.getKeysForOverrideIdentifier(T)])}if(i&&c){for(const A of h)if(P.includes(A)){const T=t({contents:c.getOverrideValue(void 0,A)||{},keys:c.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});r.push([A,[...T.added,...T.removed,...T.updated]])}}return{added:s,removed:o,updated:l,overrides:r}}function t(c,i){const s=c?i?c.keys.filter(r=>i.keys.indexOf(r)===-1):[...c.keys]:[],o=i?c?i.keys.filter(r=>c.keys.indexOf(r)===-1):[...i.keys]:[],l=[];if(c&&i){for(const r of i.keys)if(c.keys.indexOf(r)!==-1){const h=(0,w.getConfigurationValue)(i.contents,r),P=(0,w.getConfigurationValue)(c.contents,r);k.equals(h,P)||l.push(r)}}return{added:s,removed:o,updated:l}}}),define(Z[228],ee([0,1,25,3,2,37,10,113,68,5,38,51]),function(x,e,I,M,n,R,C,k,m,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:g})=>this.c(Array.from(a),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,g){this.h(a,v.Registry.as(m.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new k.ConfigurationModel;const a=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,g){const f=this.f();for(const E of a){const S=f[E],D=g[E];S!==void 0?this.b.addValue(E,S):D?this.b.addValue(E,D.default):this.b.removeValue(E)}}}e.DefaultConfiguration=b;class u{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let y=class extends n.Disposable{get configurationModel(){return this.b}constructor(a,g,f){super(),this.c=a,this.f=g,this.g=f,this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const g={},f=[],E=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const S of a){const D=E[S];if(!D){f.push(S);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}f.push(S),g[D.policy.name]={type:D.type}}}return(0,C.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),f}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const g=v.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),f=(0,I.coalesce)(a.map(E=>g.get(E)));this.j(f,!0)}j(a,g){this.g.trace("PolicyConfiguration#update",a);const f=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),E=[],S=this.b.isEmpty();for(const D of a){const t=f[D]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(S?c!==void 0:!(0,R.equals)(this.b.getValue(D),c))&&E.push([D,c])}else this.b.getValue(D)!==void 0&&E.push([D,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const D=this.b;this.b=new k.ConfigurationModel;for(const t of D.keys)this.b.setValue(t,D.getValue(t));for(const[t,c]of E)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);g&&this.a.fire(this.b)}}};y=ve([Q(1,w.IPolicyService),Q(2,d.ILogService)],y),e.PolicyConfiguration=y}),define(Z[229],ee([0,1,7,3,2,19,18,113,228,38]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class w extends n.Disposable{constructor(b,u,y,p){super(),this.i=b,this.h=this.B(new M.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.DefaultConfiguration),this.c=y instanceof d.NullPolicyService?new m.NullPolicyConfiguration:this.B(new m.PolicyConfiguration(this.b,y,p)),this.f=this.B(new k.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,u)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:g})=>this.k(a,g))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,u,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(b,u,new k.ConfigurationModel,y)}getConfigurationData(){return this.a.toData()}getValue(b,u){const y=typeof b=="string"?b:void 0,p=(0,C.isConfigurationOverrides)(b)?b:(0,C.isConfigurationOverrides)(u)?u:{};return this.a.getValue(y,p,void 0)}updateValue(b,u,y,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const u=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(y,u,2)}k(b,u){const y=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,u);this.m(p,y,7)}l(b){const u=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(b);this.m(y,u,7)}m(b,u,y){const p=new k.ConfigurationChangeEvent(b,{data:u},this.a);p.source=y,p.sourceConfig=this.n(y),this.h.fire(p)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=w}),define(Z[230],ee([0,1,13,6]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,M.createDecorator)("remoteAuthorityResolverService");var n;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends I.ErrorNoTelemetry{static isNotAvailable(m){return m instanceof R&&m._code===n.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof R&&m._code===n.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof R&&m._code===n.NoResolverFound}static isHandled(m){return m instanceof R&&m.isHandled}constructor(m,d=n.Unknown,w){super(m),this._message=m,this._code=d,this._detail=w,this.isHandled=d===n.NotAvailable&&w===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function C(k){const m=k.indexOf("+");return m===-1?k:k.substring(0,m)}e.getRemoteAuthorityPrefix=C}),define(Z[55],ee([0,1,14]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function M(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=M;function n(d){if(!d)return;const w=d.indexOf("+");return w<0?d:d.substr(0,w)}e.getRemoteName=n;function R(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=R;function C(d){const{host:w,port:v}=m(d);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:v}}e.parseAuthorityWithPort=C;function k(d,w){let{host:v,port:b}=m(d);return typeof b>"u"&&(b=w),{host:v,port:b}}e.parseAuthorityWithOptionalPort=k;function m(d){const w=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const v=d.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=d.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:d,port:void 0}}}),define(Z[114],ee([0,1,27,6,55]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var k;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,p){if(typeof y>"u"||y===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof y=="string"||typeof p=="string"){const a=typeof y=="string"?y:y.value,g=typeof p=="string"?p:p.value;return I.equalsIgnoreCase(a,g)}return y.c===p.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=m;function d(u){return w(u)}e.isApplicationScopedExtension=d;function w(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function v(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function b(u,y){if(y){const p=`onResolveRemoteAuthority:${(0,n.getRemoteName)(y)}`;return!!u.activationEvents?.includes(p)}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[231],ee([0,1,7,17,22,13,3,2,64,72,31,104,230,55]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var p;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function a(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(W){const U=new n.CancellationTokenSource;return setTimeout(()=>U.cancel(),W),U.token}function f(W,U){if(W.isCancellationRequested||U.isCancellationRequested)return n.CancellationToken.Cancelled;const $=new n.CancellationTokenSource;return W.onCancellationRequested(()=>$.cancel()),U.onCancellationRequested(()=>$.cancel()),$.token}class E{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise(($,V)=>{this.f=$,this.g=V}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function S(W,U){const $=new E(U);return $.registerDisposable(W.onControlMessage(V=>{const j=JSON.parse(V.toString()),K=q(j);K?$.reject(K):$.resolve(j)})),$.promise}function D(W,U,$,V,j,K,J,re,de){const Ce=new E(de),Re=d.StopWatch.create(!1);return W.info(`Creating a socket (${re})...`),m.mark(`code/willCreateSocket/${J}`),U.connect($,V,j,K,re,(De,Oe)=>{Ce.didTimeout?(m.mark(`code/didCreateSocketError/${J}`),W.info(`Creating a socket (${re}) finished after ${Re.elapsed()} ms, but this is too late and has timed out already.`),De&&W.error(De),Oe?.dispose()):De||!Oe?(m.mark(`code/didCreateSocketError/${J}`),W.info(`Creating a socket (${re}) returned an error after ${Re.elapsed()} ms.`),Ce.reject(De)):(m.mark(`code/didCreateSocketOK/${J}`),W.info(`Creating a socket (${re}) was successful after ${Re.elapsed()} ms.`),Ce.resolve(Oe))}),Ce.promise}function t(W,U){const $=new E(U);return W.then(V=>{$.didTimeout||$.resolve(V)},V=>{$.didTimeout||$.reject(V)}),$.promise}async function c(W,U,$,V){const j=L(W,U);W.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let K;try{K=await D(W.logService,W.socketFactory,W.host,W.port,(0,u.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,a(U),`renderer-${a(U)}-${W.reconnectionToken}`,V)}catch(Re){throw W.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),W.logService.error(Re),Re}W.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let J,re;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(K,null),J=W.reconnectionProtocol,re=!1):(J=new v.PersistentProtocol({socket:K,measureRoundTripTime:!0}),re=!0),W.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const de=await t(W.signService.createNewMessage((0,w.generateUuid)()),V),Ce={type:"auth",auth:W.connectionToken||"00000000000000000000",data:de.data};J.sendControl(M.VSBuffer.fromString(JSON.stringify(Ce)));try{const Re=await S(J,f(V,g(1e4)));if(Re.type!=="sign"||typeof Re.data!="string"){const fe=new Error("Unexpected handshake message");throw fe.code="VSCODE_CONNECTION_ERROR",fe}if(W.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(W.signService.validate(de,Re.signedData),V)){const fe=new Error("Refused to connect to unsupported server");throw fe.code="VSCODE_CONNECTION_ERROR",fe}const Oe=await t(W.signService.sign(Re.data),V),$e={type:"connectionType",commit:W.commit,signedData:Oe,desiredConnectionType:U};return $&&($e.args=$),W.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(M.VSBuffer.fromString(JSON.stringify($e))),{protocol:J,ownsProtocol:re}}catch(Re){throw Re&&Re.code==="ETIMEDOUT"&&(W.logService.error(`${j} the handshake timed out. Error:`),W.logService.error(Re)),Re&&Re.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${j} received error control message when negotiating connection. Error:`),W.logService.error(Re)),re&&O(J),Re}}async function i(W,U,$,V){const j=Date.now(),K=L(W,U),{protocol:J,ownsProtocol:re}=await c(W,U,$,V),de=new E(V);return de.registerDisposable(J.onControlMessage(Ce=>{const Re=JSON.parse(Ce.toString()),De=q(Re);De?(W.logService.error(`${K} received error control message when negotiating connection. Error:`),W.logService.error(De),re&&O(J),de.reject(De)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${F(j)}!`),de.resolve({protocol:J,firstMessage:Re}))})),de.promise}async function s(W,U){const{protocol:$}=await i(W,1,void 0,U);return{protocol:$}}async function o(W,U,$){const{protocol:V,firstMessage:j}=await i(W,2,U,$),K=j&&j.debugPort;return{protocol:V,debugPort:K}}async function l(W,U,$){const V=Date.now(),j=L(W,3),{protocol:K}=await c(W,3,U,$);return W.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${F(V)}!`),K}async function r(W,U,$){const{host:V,port:j,connectionToken:K}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:V,port:j,connectionToken:K,reconnectionToken:U,reconnectionProtocol:$,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function h(W,U,$){return A(W,async V=>{const{protocol:j}=await s(V,n.CancellationToken.None);return new G(W,U,$,V.reconnectionToken,j)})}e.connectRemoteAgentManagement=h;async function P(W,U){return A(W,async $=>{const{protocol:V,debugPort:j}=await o($,U,n.CancellationToken.None);return new B(W,U,$.reconnectionToken,V,j)})}e.connectRemoteAgentExtensionHost=P;async function A(W,U){for(let V=1;;V++)try{const j=(0,w.generateUuid)(),K=await r(W,j,null);return await U(K)}catch(j){if(V<5)W.logService.error(`[remote-connection][attempt ${V}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(j);else throw W.logService.error(`[remote-connection][attempt ${V}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(j),me.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(j)),j}}async function T(W,U,$){const V=await r(W,(0,w.generateUuid)(),null);return await l(V,{host:U,port:$},n.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function N(W){return(0,I.createCancelablePromise)(U=>new Promise(($,V)=>{const j=setTimeout($,W*1e3);U.onCancellationRequested(()=>{clearTimeout(j),$()})}))}var z;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class H{constructor(U,$){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=H;class ie{constructor(U,$,V,j){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.durationSeconds=V,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ie;class se{constructor(U,$,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=se;class oe{constructor(U,$,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=V,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(U,$){this.reconnectionToken=U,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=ue;class le{constructor(U,$,V,j){this.reconnectionToken=U,this.millisSinceLastIncomingData=$,this.attempt=V,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=le;class me extends k.Disposable{static triggerPermanentFailure(U,$,V){this._permanentFailure=!0,this.f=U,this.g=$,this.h=V,this.i.forEach(j=>j.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.s())}static debugPauseSocketWriting(){this.i.forEach(U=>U.w())}get k(){return this.c||me._permanentFailure}constructor(U,$,V,j,K){super(),this.n=U,this.p=$,this.reconnectionToken=V,this.protocol=j,this.r=K,this.j=this.B(new C.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new oe(this.reconnectionToken,0,0)),this.B(j.onSocketClose(J=>{const re=ne(this.n,this.reconnectionToken,!0);J?J.type===0?(this.p.logService.info(`${re} received socket close event (hadError: ${J.hadError}).`),J.error&&this.p.logService.error(J.error)):(this.p.logService.info(`${re} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.p.logService.error(J.event)):this.p.logService.info(`${re} received socket close event.`),this.s()})),this.B(j.onSocketTimeout(J=>{const re=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(j.onHighRoundTripTime(J=>{const re=te(this.n,this.reconnectionToken);this.p.logService.info(`${re} high roundtrip time: ${J.roundTripTime}ms (${J.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(j.onDidChangeConnectionHealth(J=>{this.j.fire(new ue(this.reconnectionToken,J))})),me.i.push(this),this.B((0,k.toDisposable)(()=>{const J=me.i.indexOf(this);J>=0&&me.i.splice(J,1)})),this.k&&this.v(me.f,me.g,me.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const U=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const j=V<$.length?$[V]:$[$.length-1];try{if(j>0){const J=N(j);this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,J)),this.p.logService.info(`${U} waiting for ${j} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.p.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this.p.logService.info(`${U} resolving connection...`);const K=await r(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${U} connecting to ${K.host}:${K.port}...`),await this.y(K,g(y)),this.p.logService.info(`${U} reconnected!`),this.j.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this.p.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this.p.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.p.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(K);continue}if((0,R.isCancellationError)(K)){this.p.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(K);continue}if(K instanceof b.RemoteAuthorityResolverError){this.p.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,b.RemoteAuthorityResolverError.isHandled(K));break}this.p.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!this.k&&!this.m)}u(U,$,V){this.r?me.triggerPermanentFailure(U,$,V):this.v(U,$,V)}v(U,$,V){this.j.fire(new le(this.reconnectionToken,U,$,V)),O(this.protocol)}w(){this.protocol.pauseSocketWriting()}}me._permanentFailure=!1,me.f=0,me.g=0,me.h=!1,me.i=[],e.PersistentConnection=me;class G extends me{constructor(U,$,V,j,K){super(1,U,j,K,!0),this.client=this.B(new v.Client(K,{remoteAuthority:$,clientId:V},U.ipcLogger))}async y(U,$){await s(U,$)}}e.ManagementPersistentConnection=G;class B extends me{constructor(U,$,V,j,K){super(2,U,V,j,!1),this.z=$,this.debugPort=K}async y(U,$){await o(U,this.z,$)}}e.ExtensionHostPersistentConnection=B;function O(W){try{W.acceptDisconnect();const U=W.getSocket();W.dispose(),U.dispose()}catch(U){(0,R.onUnexpectedError)(U)}}function q(W){if(W&&W.type==="error"){const U=new Error(`Connection error: ${W.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Y(W,U){for(;W.length<U;)W+=" ";return W}function te(W,U){return`[remote-connection][${Y(a(W),13)}][${U.substr(0,5)}\u2026]`}function ne(W,U,$){return`${te(W,U)}[${$?"reconnect":"initial"}]`}function L(W,U){return`${ne(U,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function F(W){return`${Date.now()-W} ms`}}),define(Z[232],ee([0,1,82,86]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,R,C,k,m,d){const w=b=>d(b,void 0),v=I.createConnection({host:n,port:R},()=>{v.removeListener("error",w);const b=Buffer.alloc(16);for(let a=0;a<16;a++)b[a]=Math.round(Math.random()*256);const u=b.toString("base64"),y=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${R}${C}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];v.write(y.join(`\r
`)+`\r
\r
`);const p=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",p),d(void 0,new M.NodeSocket(v,m)))};v.on("data",p)});v.setNoDelay(!0),v.once("error",w)}}}),define(Z[233],ee([0,1,26,46,41,192]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let C;async function k(u=!1){return(C===void 0||u)&&(C=m()),C}e.hasWSLFeatureInstalled=k;async function m(){const u=d();if(u===void 0)return!1;if(u>=22e3){const y=v();if(y)return new Promise(p=>{M.execFile(y,["--status"],a=>p(!a))})}else{const y=b();if(y)try{if((await n.promises.stat(y)).isFile())return!0}catch{}}return!1}function d(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(u)return parseInt(u[3])}function w(u){const y=process.env.SystemRoot;if(y){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(y,p?"Sysnative":"System32",u)}}function v(){return w("wsl.exe")}function b(){return w("lxss\\LxssManager.dll")}}),define(Z[56],ee([0,1,17,176,68,6,51]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function k(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=k;function m(p){return p.res.statusCode===204}async function d(p){return m(p)?null:(await(0,I.streamToBuffer)(p.stream)).toString()}e.asText=d;async function w(p){if(!k(p))throw new Error("Server returned "+p.res.statusCode);return d(p)}e.asTextOrError=w;async function v(p){if(!k(p))throw new Error("Server returned "+p.res.statusCode);if(m(p))return null;const g=(await(0,I.streamToBuffer)(p.stream)).toString();try{return JSON.parse(g)}catch(f){throw f.message+=`:
`+g,f}}e.asJson=v;function b(p){y(p)}e.updateProxyConfigurationsScope=b;let u;function y(p){const a=C.Registry.as(n.Extensions.Configuration),g=u;u={id:"http",order:15,title:(0,M.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(4,null),(0,M.localize)(5,null),(0,M.localize)(6,null),(0,M.localize)(7,null)],default:"override",description:(0,M.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(9,null),restricted:!0}}},a.updateConfigurations({add:[u],remove:g?[g]:[]})}y(2)}),define(Z[234],ee([0,1,17,22]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(k){this.a=k}listen(k,m){throw new Error("Invalid listen")}call(k,m,d,w=M.CancellationToken.None){switch(m){case"request":return this.a.request(d[0],w).then(async({res:v,stream:b})=>{const u=await(0,I.streamToBuffer)(b);return[{statusCode:v.statusCode,headers:v.headers},u]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class R{constructor(k){this.a=k}async request(k,m){const[d,w]=await this.a.call("request",[k],m);return{res:d,stream:(0,I.bufferToStream)(w)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=R}),define(Z[235],ee([0,1,236,10]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(C,k){return C.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:C.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(C,k,m={}){const d=(0,I.parse)(C),w=m.proxyUrl||n(d,k);if(!w)return null;const v=(0,I.parse)(w);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,M.isBoolean)(m.strictSSL)?m.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((u,y)=>{x(["http-proxy-agent"],u,y)}))(b):new(await new Promise((u,y)=>{x(["https-proxy-agent"],u,y)}))(b)}e.getProxyAgent=R}),define(Z[115],ee([0,1,46,9,177,22,44,13,4,31,152,62,7,131]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function p(g,f,E,S){return E["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(S)&&!E["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(S)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=b.Promises.withAsyncBody(async(D,t)=>{const c=new R.CancellationTokenSource;let i=1e4;const s=g.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,u.clamp)(s,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{D(await a(f,c.token))}catch(l){!(0,k.isCancellationError)(l)&&!c.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,C.toErrorMessage)(l)))):D({})}finally{clearTimeout(o),c.dispose()}})),y)}e.getResolvedShellEnv=p;async function a(g,f){const E=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",E);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const D=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",c);const i=await(0,w.getSystemShell)(m.OS,c);return g.trace("getUnixShellEnvironment#shell",i),new Promise((s,o)=>{if(f.isCancellationRequested)return o(new k.CancellationError);const l=(0,M.basename)(i);let r,h;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(r=`& '${process.execPath}' ${P} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,h=["-Login","-Command"]):(r=`'${process.execPath}' ${P} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,l==="tcsh"||l==="csh"?h=["-ic"]:h=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),r);const A=(0,I.spawn)(i,[...h,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});f.onCancellationRequested(()=>(A.kill(),o(new k.CancellationError))),A.on("error",z=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(z)),o(z)});const T=[];A.stdout.on("data",z=>T.push(z));const N=[];A.stderr.on("data",z=>N.push(z)),A.on("close",(z,H)=>{const ie=Buffer.concat(T).toString("utf8");g.trace("getUnixShellEnvironment#raw",ie);const se=Buffer.concat(N).toString("utf8");if(se.trim()&&g.trace("getUnixShellEnvironment#stderr",se),z||H)return o(new Error((0,n.localize)(2,null,z,H)));const oe=t.exec(ie),ue=oe?oe[1]:"{}";try{const le=JSON.parse(ue);E?le.ELECTRON_RUN_AS_NODE=E:delete le.ELECTRON_RUN_AS_NODE,S?le.ELECTRON_NO_ATTACH_CONSOLE=S:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",le),s(le)}catch(le){g.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(le)),o(le)}})})}}),define(Z[91],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[237],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((n,R)=>x(["vsda"],n,R))}async createNewMessage(n){try{const R=await this.c(),C=new R.validator;if(C){const k=String(I.a++);return this.b.set(k,C),{id:k,data:C.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,R){if(!n.id)return!0;const C=this.b.get(n.id);if(!C)return!1;this.b.delete(n.id);try{return C.validate(R)==="ok"}catch{return!1}}async sign(n){try{const R=await this.c(),C=new R.signer;if(C)return C.sign(n)}catch{}return n}}I.a=1,e.SignService=I}),define(Z[33],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,I.createDecorator)("stateReadService"),e.IStateService=(0,I.createDecorator)("stateService")}),define(Z[20],ee([0,1,15,42,7,3,2,4,36,10,6,5,33,28]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(y=e.ShutdownReason||(e.ShutdownReason={}));var p;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let a=class ht extends C.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(f,E,S){super(),this.v=f,this.w=E,this.y=S,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ht.b),this.j&&this.w.removeItem(ht.b)}C(){const f=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",f);const E=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",E),I.app.once("will-quit",S=>{this.L("Lifecycle#app.on(will-quit) - begin"),S.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),I.app.removeListener("before-quit",f),I.app.removeListener("window-all-closed",E),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),I.app.quit()})})}D(f){if(this.s)return this.s;const E=this.v;this.L("Lifecycle#onWillShutdown.fire()");const S=[];return this.f.fire({reason:f,join(D,t){E.trace(`Lifecycle#onWillShutdown - begin '${D}'`),S.push(t.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.s=(async()=>{try{await n.Promises.settled(S)}catch(D){this.v.error(D)}try{await this.w.close()}catch(D){this.v.error(D)}})(),this.s}set phase(f){if(f<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===f)return;this.L(`lifecycle (main): phase changed (value: ${f})`),this.k=f;const E=this.u.get(this.k);E&&(E.open(),this.u.delete(this.k))}async when(f){if(f<=this.k)return;let E=this.u.get(f);E||(E=new n.Barrier,this.u.set(f,E)),await E.wait()}registerWindow(f){const E=new C.DisposableStore;this.n++,E.add(f.onWillLoad(D=>this.g.fire({window:f,workspace:D.workspace,reason:D.reason})));const S=(0,d.assertIsDefined)(f.win);S.on("close",D=>{const t=f.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${f.id}`),D.preventDefault(),this.unload(f,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(f),f.close()})}),S.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${f.id}`),this.n--,E.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(f,E){await this.unload(f,3)||f.reload(E)}unload(f,E){const S=this.t.get(f.id);if(S)return S;const D=this.F(f,E).finally(()=>{this.t.delete(f.id)});return this.t.set(f.id,D),D}async F(f,E){if(!f.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${f.id}`);const S=this.i?2:E,D=await this.I(f,S);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${f.id})`),this.G(D)):(await this.J(f,S),!1)}G(f){return f?(this.H(!0),this.i=!1,!0):!1}H(f){this.r&&(this.r(f),this.r=void 0,this.p=void 0)}I(f,E){return new Promise(S=>{const D=this.m++,t=`vscode:ok${D}`,c=`vscode:cancel${D}`;M.validatedIpcMain.once(t,()=>{S(!1)}),M.validatedIpcMain.once(c,()=>{S(!0)}),f.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:E})})}J(f,E){return new Promise(S=>{const t=`vscode:reply${this.m++}`;M.validatedIpcMain.once(t,()=>S()),f.send("vscode:onWillUnload",{replyChannel:t,reason:E})})}quit(f){return this.L(`Lifecycle#quit() - begin (willRestart: ${f})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(f&&this.w.setItem(ht.b,!0),this.p=new Promise(E=>{this.r=E,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(f){this.y.args["enable-smoke-test-driver"]?this.v.info(f):this.v.trace(f)}async relaunch(f){this.L("Lifecycle#relaunch()");const E=process.argv.slice(1);if(f?.addArgs&&E.push(...f.addArgs),f?.removeArgs)for(const t of f.removeArgs){const c=E.indexOf(t);c>=0&&E.splice(c,1)}const S=()=>{try{if(k.isWindows){const t=(0,m.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:E})};I.app.once("quit",S),await this.quit(!0)&&I.app.removeListener("quit",S)}async kill(f){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const E of I.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let S;E.webContents&&!E.webContents.isDestroyed()?S=new Promise(D=>E.once("closed",D)):S=Promise.resolve(),E.destroy(),await S}})()]),I.app.exit(f)}};a.b="lifecycle.quitAndRestart",a=ve([Q(0,v.ILogService),Q(1,b.IStateService),Q(2,u.IEnvironmentMainService)],a),e.LifecycleMainService=a}),define(Z[238],ee([0,1,4,3,2,6,20]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(w){super(),this.a=this.B(new M.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,w.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const w=await new Promise((v,b)=>{x(["native-keymap"],v,b)});this.c=m(w),I.isCI||w.onDidChangeKeyboardLayout(()=>{this.c=m(w),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ve([Q(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function m(d){const w=d.getKeyMap(),v=d.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:v}}}),define(Z[116],ee([0,1,7,17,10,34,16,5]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var m;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(m=e.SaveStrategy||(e.SaveStrategy={}));class d{constructor(u,y,p,a){this.f=u,this.g=p,this.h=a,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=y===0?void 0:new I.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==1&&this.g.error(u)}}getItem(u,y){const p=this.a[u];return(0,n.isUndefinedOrNull)(p)?y:p}setItem(u,y){this.setItems([{key:u,data:y}])}setItems(u){let y=!1;for(const{key:p,data:a}of u)this.a[p]!==a&&((0,n.isUndefinedOrNull)(a)?(0,n.isUndefined)(this.a[p])||(this.a[p]=void 0,y=!0):(this.a[p]=a,y=!0));y&&this.j()}removeItem(u){(0,n.isUndefined)(this.a[u])||(this.a[u]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.h.writeFile(this.f,M.VSBuffer.fromString(u)),this.b=u}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=d;let w=class{constructor(u,y,p,a){this.a=new d(y.stateResource,u,p,a)}async init(){await this.a.init()}getItem(u,y){return this.a.getItem(u,y)}};w=ve([Q(1,R.IEnvironmentService),Q(2,k.ILogService),Q(3,C.IFileService)],w),e.StateReadonlyService=w;class v extends w{setItem(u,y){this.a.setItem(u,y)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.StateService=v}),define(Z[92],ee([0,1,4,36,8,31]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(d){if(I.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function k(d,w,v,b,u,y,p,a,g,f){const E=Object.create(null);E["common.machineId"]=p,E.sessionID=(0,R.generateUuid)()+Date.now(),E.commitHash=u,E.version=y,E["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,I.PlatformToString)(I.platform),E["common.nodePlatform"]=M.platform,E["common.nodeArch"]=b,E["common.product"]=f||"desktop",a&&(E["common.msftInternal"]=a);let S=0;const D=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),I.isLinuxSnap&&(E["common.snap"]="true");const t=C(v);t&&(E["common.platformDetail"]=t);try{const c=await d.readFile(n.URI.file(g));E["common.source"]=c.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=k;function m(d){const w=M.env.USERDNSDOMAIN;if(!w)return!1;const v=w.toLowerCase();return d.some(b=>v===b)}e.verifyMicrosoftInternalDomain=m}),define(Z[24],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[239],ee([0,1,26,7,43,14,9,4,8,84,23,103,87,16,21,24]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function g(t,c){const i=`${t}::${c.join(":")}`,s=a.get(i);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,r=new Map,h=2e4;function P(T,N,z,H){const ie=N.substring(T.length+1);return M.Promises.withAsyncBody(async se=>{let oe;try{oe=await w.Promises.readdir(N,{withFileTypes:!0})}catch{se();return}if(H.count>=h){H.count+=oe.length,H.maxReached=!0,se();return}let ue=oe.length;if(ue===0){se();return}let le=oe;H.count+oe.length>h&&(H.maxReached=!0,ue=h-H.count,le=oe.slice(0,ue)),H.count+=oe.length;for(const me of le)if(me.isDirectory()){if(z.includes(me.name)||await P(T,(0,C.join)(N,me.name),z,H),--ue===0){se();return}}else{const G=me.name.lastIndexOf(".");if(G>=0){const B=me.name.substring(G+1);B&&l.set(B,(l.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(ie)!==!1&&B.filePattern.test(me.name)&&r.set(B.tag,(r.get(B.tag)??0)+1);if(--ue===0){se();return}}})}const A=M.Promises.withAsyncBody(async T=>{const N={count:0,maxReached:!1};await P(t,t,c,N);const z=await S(t);T({configFiles:f(r),fileTypes:f(l),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:z})});return a.set(i,A),A}e.collectWorkspaceStats=g;function f(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function E(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},c=I.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=E;async function S(t){try{const c=new Map,i=(0,C.join)(t,".vscode","launch.json"),s=await w.Promises.readFile(i),o=[],l=(0,n.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(l)==="object"&&l.configurations)for(const r of l.configurations){const h=r.type;h&&(c.has(h)?c.set(h,c.get(h)+1):c.set(h,1))}return f(c)}catch{return[]}}e.collectLaunchConfigs=S;let D=class{constructor(c,i){this.c=c,this.d=i}f(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}g(c){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${I.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,v.listProcesses)(c.mainPID),this.k(c)]).then(async s=>{let[o,l]=s,r=this.m(c,o);return i.forEach(h=>{if((0,b.isRemoteDiagnosticError)(h))r+=`
${h.errorMessage}`,l+=`
${h.errorMessage}`;else if(r+=`

Remote: ${h.hostName}`,h.processes&&(r+=`
${this.m(c,h.processes)}`),h.workspaceMetadata){l+=`
|  Remote: ${h.hostName}`;for(const P of Object.keys(h.workspaceMetadata)){const A=h.workspaceMetadata[P];let T=`${A.fileCount} files`;A.maxFilesReached&&(T=`more than ${T}`),l+=`|    Folder (${P}): ${T}`,l+=this.h(A)}}}),{processInfo:r,workspaceInfo:l}})}async getSystemInfo(c,i){const{memory:s,vmHint:o,os:l,cpus:r}=E(),h={os:l,memory:s,cpus:r,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(h.load=`${I.loadavg().map(P=>Math.round(P)).join(", ")}`),k.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(c,i){const s=[];return(0,v.listProcesses)(c.mainPID).then(async o=>(s.push(""),s.push(this.g(c)),s.push(""),s.push(this.m(c,o)),c.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(c))),i.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.f(l.machineInfo)),l.processes&&s.push(this.m(c,l.processes)),l.workspaceMetadata)for(const r of Object.keys(l.workspaceMetadata)){const h=l.workspaceMetadata[r];let P=`${h.fileCount} files`;h.maxFilesReached&&(P=`more than ${P}`),s.push(`Folder (${r}): ${P}`),s.push(this.h(h))}}),s.push(""),s.push(""),s.join(`
`)))}h(c){const i=[];let o=0;const l=(A,T)=>{const N=` ${A}(${T})`;o+N.length>60?(i.push(r),r="|                 ",o=r.length):o+=N.length,r+=N};let r="|      File types:";const h=10,P=c.fileTypes.length>h?h:c.fileTypes.length;for(let A=0;A<P;A++){const T=c.fileTypes[A];l(T.name,T.count)}if(i.push(r),c.configFiles.length>=0&&(r="|      Conf files:",o=0,c.configFiles.forEach(A=>{l(A.name,A.count)}),i.push(r)),c.launchConfigFiles.length>0){let A="|      Launch Configs:";c.launchConfigFiles.forEach(T=>{A+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(A)}return i.join(`
`)}j(c){const i=Math.max(...Object.keys(c).map(s=>s.length));return Object.keys(c).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${c[s]}`).join(`
                  `)}k(c){const i=[],s=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const r=m.URI.revive(l);if(r.scheme===R.Schemas.file){const h=r.fsPath;s.push(g(h,["node_modules",".git"]).then(P=>{let A=`${P.fileCount} files`;P.maxFilesReached&&(A=`more than ${A}`),i.push(`|    Folder (${(0,C.basename)(h)}): ${A}`),i.push(this.h(P))}).catch(P=>{i.push(`|      Error: Unable to collect workspace stats for folder ${h} (${P.toString()})`)}))}else i.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(c,i){const s=new Map;c.windows.forEach(l=>s.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(c.mainPID,s,o,i,0),o.join(`
`)}n(c,i,s,o,l){const r=l===0;let h;r?h=o.pid===c?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(h=`${h} (${i.get(o.pid)})`));const P=process.platform==="win32"?o.mem:I.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(P/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(o.children)&&o.children.forEach(A=>this.n(c,i,s,A,l+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:s}of c.folders){const o=m.URI.revive(s);if(o.scheme!==R.Schemas.file)continue;const l=o.fsPath;try{(await g(l,["node_modules",".git"])).fileTypes.forEach(h=>i.add(h.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const s=m.URI.revive(i);if(s.scheme!==R.Schemas.file)continue;const o=s.fsPath;try{const l=await g(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),l.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:r.name,count:r.count})}),l.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:r.name,count:r.count})}),l.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};D=ve([Q(0,p.ITelemetryService),Q(1,y.IProductService)],D),e.DiagnosticsService=D}),define(Z[240],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(R){this.b=R}listen(R,C){throw new Error(`Event not found: ${C}`)}call(R,C,{eventName:k,data:m}){return this.b.forEach(d=>d.log(k,m)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class M{constructor(R){this.b=R}log(R,C){return this.b.call("log",{eventName:R,data:C}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(Z[48],ee([0,1,37,10,3,18,55,92,24]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class d{constructor(r){this.value=r}}e.TelemetryTrustedValue=d;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,h){return Promise.resolve(void 0)}publicLog2(r,h){return this.publicLog(r,h)}publicLogError(r,h){return Promise.resolve(void 0)}publicLogError2(r,h){return this.publicLogError(r,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class v{async publicLog(r,h,P){}async publicLogError(r,h,P){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(l,r){return n.Event.debounce(r.onDidChangeConfiguration,(P,A)=>{const T=P?new Set([...P.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:T}},1e3,!0)(P=>{P.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(P.source),configurationKeys:S(P.affectedKeys)})})}e.configurationTelemetry=b;function u(l,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!l.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=u;function y(l,r){return!(r.isBuilt||r.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=y;function p(l){const r=l.getValue(m.TELEMETRY_SETTING_ID),h=l.getValue(m.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(m.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function a(l){const r={},h={},P={};E(l,P);for(let A in P){A=A.length>150?A.substr(A.length-149):A;const T=P[A];typeof T=="number"?h[A]=T:typeof T=="boolean"?h[A]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${T.length}`),r[A]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(r[A]=T)}return{properties:r,measurements:h}}e.validateTelemetryData=a;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function f(l){if(!l)return"none";const r=(0,C.getRemoteName)(l);return g.has(r)?r:"other"}e.cleanRemoteAuthority=f;function E(l,r,h=0,P){if(!!l)for(const A of Object.getOwnPropertyNames(l)){const T=l[A],N=P?P+A:A;Array.isArray(T)?r[N]=(0,I.safeStringify)(T):T instanceof Date?r[N]=T.toISOString():(0,M.isObject)(T)?h<2?E(T,r,h+1,N+"."):r[N]=(0,I.safeStringify)(T):r[N]=T}}function S(l){if(!l)return[];const r=[];return D(r,"",l),r}function D(l,r,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(P=>D(l,r?`${r}.${P}`:P,h[P])):l.push(r)}function t(l,r){const h=l.msftInternalDomains||[],P=r.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(h)||P}e.isInternalTelemetry=t;function c(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=c;function i(l,r){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let h=l;const P=[];for(const z of r)for(;;){const H=z.exec(l);if(!H)break;P.push([H.index,z.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(h="";;){const z=T.exec(l);if(!z)break;const H=P.some(([ie,se])=>z.index<se&&ie<T.lastIndex);!A.test(z[0])&&!H&&(h+=l.substring(N,z.index)+"<REDACTED: user-file-path>",N=T.lastIndex)}return N<l.length&&(h+=l.substr(N)),h}function s(l){if(!l)return l;const r=l.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const P of h)if(P.regex.test(r))return`<REDACTED: ${P.label}>`;return l}function o(l,r){return(0,I.cloneAndChange)(l,h=>{if(h instanceof d)return h.value;if(typeof h=="string"){let P=h.replaceAll("%20"," ");P=i(P,r);for(const A of r)P=P.replace(A,"");return P=s(P),P}})}e.cleanData=o}),define(Z[117],ee([0,1,27,110,114,4,8,13,36,48]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,I.compareIgnoreCase)(i.id,s.id)===0}e.areSameExtensions=w;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(s){const o=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new b(s.identifier,o,l)}static parse(s){const o=v.exec(s);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,l="undefined"){this.version=o,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof b?w(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=b;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const s=u.exec(i);return s&&s[1]?[a(s[1]),s[2]]:[a(i),void 0]}e.getIdAndVersion=y;function p(i,s){return`${i}.${s}`}e.getExtensionId=p;function a(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function g(i,s){return a(p(i,s))}e.getGalleryExtensionId=g;function f(i,s){const o=[],l=r=>{for(const h of o)if(h.some(P=>w(s(P),s(r))))return h;return null};for(const r of i){const h=l(r);h?h.push(r):o.push([r])}return o}e.groupByExtension=f;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function S(i){return{id:new d.TelemetryTrustedValue(i.identifier.id),name:new d.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function D(i,s){const o=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const r=l.shift();if(r&&o.every(h=>!w(h.identifier,{id:r}))){const h=i.filter(P=>w(P.identifier,{id:r}));h.length===1&&(o.push(h[0]),l.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=D;async function t(i,s){if(!R.isLinux)return!1;let o;try{o=(await i.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){s.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(r))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(i,s){const o=await t(i,s),l=(0,M.getTargetPlatform)(o?"alpine":R.platform,m.arch);return s.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=c}),define(Z[241],ee([0,1,198,48]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(R,C,k,m,d,w,v){const b={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${C.nameShort})`};if((0,M.supportsTelemetry)(C,k)&&(0,M.getTelemetryLevel)(m)===3){const u=await(0,I.getServiceMachineId)(k,d,w),{machineId:y}=await v.getTelemetryInfo();b["X-Market-User-Id"]=u,b["VSCode-SessionId"]=y||u}return b}e.resolveMarketplaceHeaders=n}),define(Z[242],ee([0,1,13,37,48]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function k(d,w,v){const b=await new Promise((g,f)=>{x(["@microsoft/1ds-core-js"],g,f)}),u=await new Promise((g,f)=>{x(["@microsoft/1ds-post-js"],g,f)}),y=new b.AppInsightsCore,p=new u.PostChannel,a={instrumentationKey:d,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(v){a.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:v};a.extensionConfig[p.identifier]=g}return y.initialize(a,[]),y.addTelemetryInitializer(g=>{w&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),y}class m{constructor(w,v,b,u,y){this.e=w,this.f=v,this.g=b,this.h=y,this.c=R,this.d=C,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(w){if(!!this.a){if(typeof this.a!="string"){w(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(v=>{w(v)},v=>{(0,I.onUnexpectedError)(v),console.error(v)})}}log(w,v){if(!this.a)return;v=(0,M.mixin)(v,this.g),v=(0,n.validateTelemetryData)(v);const b=this.f+"/"+w;try{this.i(u=>{u.pluginVersionString=v?.properties.version??"Unknown",u.track({name:b,baseData:{name:b,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(w=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=m}),define(Z[118],ee([0,1,2,37,4,27,178,18,68,66,21,51,24,48]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(g,f,E){this.k=f,this.l=E,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=g.appenders,this.c=g.commonProperties||Promise.resolve({}),this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(b.TELEMETRY_SETTING_ID)||S.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(g,f){this.d[g]=f}m(){let g=(0,u.getTelemetryLevel)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const E=f.usage?3:f.error?2:0;g=Math.min(g,E)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const g=await this.c,f=g.sessionID,E=g["common.machineId"],S=g["common.firstSessionDate"],D=g["common.msftInternal"];return{sessionId:f,machineId:E,firstSessionDate:S,msftInternal:D}}dispose(){this.i.dispose()}n(g,f,E){return this.g<f?Promise.resolve(void 0):this.c.then(S=>{E=(0,M.mixin)(E,this.d),E=(0,u.cleanData)(E,this.j),E=(0,M.mixin)(E,S),this.b.forEach(D=>D.log(g,E))},S=>{console.error(S)})}publicLog(g,f){return this.n(g,3,f)}publicLog2(g,f){return this.publicLog(g,f)}publicLogError(g,f){return this.h?this.n(g,2,f):Promise.resolve(void 0)}publicLogError2(g,f){return this.publicLogError(g,f)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ve([Q(1,k.IConfigurationService),Q(2,w.IProductService)],y),e.TelemetryService=y;function p(){const a=(0,C.localize)(0,null,d.default.nameLong),g=d.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=n.isWeb?"":(0,C.localize)(3,null),E=(0,C.localize)(4,null),S=(0,C.localize)(5,null),D=(0,C.localize)(6,null),t=(0,C.localize)(7,null),c=`
|       | ${E} | ${S} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,C.localize)(8,null);return`
${a} ${g} ${f}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}v.Registry.as(m.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(m.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,C.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,C.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[243],ee([0,1,291,242]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends M.AbstractOneDataSystemAppender{constructor(C,k,m,d){const w={sendPOST:(v,b)=>{const u={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const y=I.request(v.urlString,u,p=>{p.on("data",function(a){b(p.statusCode??200,p.headers,a.toString())}),p.on("error",function(a){b(0,{})})});y.write(v.data),y.end()}catch{b(0,{})}}};super(C,k,m,d,w)}}e.OneDataSystemAppender=n}),define(Z[244],ee([0,1,4,84,24]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(C){let k=C.getItem(n.machineIdKey);return(typeof k!="string"||I.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,M.getMachineId)()),k}e.resolveMachineId=R}),define(Z[119],ee([0,1,24,244]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(R){const C=await(0,M.resolveMachineId)(R);return R.setItem(I.machineIdKey,C),C}e.resolveMachineId=n}),define(Z[69],ee([0,1,15,3,2,4,18,6,33]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const d="#FFFFFF",w="#1E1E1E",v="#000000",b="#FFFFFF",u="theme",y="themeBackground",p="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let a=class extends n.Disposable{constructor(f,E){super(),this.b=f,this.c=E,this.a=this.B(new M.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?v:b;let E=this.b.getItem(y,null);if(!E)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":E=d;break;case"hc-black":E=v;break;case"hc-light":E=b;break;default:E=w}return R.isMacintosh&&E.toUpperCase()===w&&(E="#171717"),E}saveWindowSplash(f,E){this.b.setItems([{key:u,data:E.baseTheme},{key:y,data:E.colorInfo.background},{key:p,data:E}]),typeof f=="number"&&this.f(f,E)}f(f,E){for(const S of I.BrowserWindow.getAllWindows())if(S.id===f){S.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};a=ve([Q(0,m.IStateService),Q(1,C.IConfigurationService)],a),e.ThemeMainService=a}),define(Z[120],ee([0,1,3,18,6,5]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var C;(function(p){p.Http="http",p.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var m;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(m=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=v;function b(p,a,g,f){if(g===1)return!1;if(g===2&&v(a)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(E?.length===4&&parseInt(E[1])>=18)return!1}return p<1024}e.isPortPrivileged=b;class u{constructor(a,g,f){this.remoteAddress=a,this.localAddress=g,this.b=f,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=u;let y=class{constructor(a,g){this.i=a,this.j=g,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],g=Array.from(this.d.values());for(const f of g){const E=Array.from(f.values());for(const S of E){const D=await S.value;D&&a.push(D)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:g}of a.values())await g.then(f=>f?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,g,f,E,S){this.o(a,g,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:g,localAddress:f,privacy:E,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,g){(v(a)||w(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const f=this.q(a,g);if(f)return++f.refcount,f.value}openTunnel(a,g,f,E,S,D=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${f} on local port ${S}.`),!a)return;if(g||(g="localhost"),E||(E=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(a,g,f,E,S,D,t,c);return i?i.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(g,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(s);return(s.tunnelRemoteHost!==g||s.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const g=this.d.get(a.tunnelRemoteHost);if(g){const f=g.get(a.tunnelRemotePort);f&&(f.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,f))}}}}async n(a,g,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${g}.`);const E=f.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(g),E}}async closeTunnel(a,g){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${g} `);const f=this.d.get(a);if(f&&f.has(g)){const E=f.get(g);E.refcount=0,await this.n(a,g,E)}}o(a,g,f){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(g,{refcount:1,value:f})}async p(a,g){const f=this.d.get(a);f&&(await f.get(g)||f.delete(g),f.size===0&&this.d.delete(a))}q(a,g){const f=[a];w(a)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):v(a)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const E=f.map(S=>this.d.get(S));for(const S of E){const D=S?.get(g);if(D)return D}}canTunnel(a){return!!d(a)}s(a,g,f,E,S,D,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${f} on local port ${E}.`);const c=f;this.h.add(c);const i=E===void 0?f:E,s={elevationRequired:S?this.isPortPrivileged(i):!1},o={remoteAddress:{host:g,port:f},localAddressPort:E,privacy:D,public:D?D!==k.Private:void 0,protocol:t},l=a.forwardPort(o,s);return l?(this.o(g,f,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),l}};y=ve([Q(0,R.ILogService),Q(1,M.IConfigurationService)],y),e.AbstractTunnelService=y}),define(Z[245],ee([0,1,82,26,100,232,7,2,18,5,21,231,120,91,4]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(S,D,t,c,i){let s;for(let o=3;o&&(s?.dispose(),s=await new a(S,D,t,c,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));o--);return s}class a extends k.Disposable{constructor(D,t,c,i,s){super(),this.j=t,this.k=s,this.privacy=b.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=I.createServer(),this.c=new C.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,t=(0,b.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,n.findFreePortFaster)(D,2,1e3,t),i=null;return this.b.listen(c,this.j),await this.c.wait(),i=this.b.address(),i||(c=0,this.b.listen(c,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const t=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&D.write(s.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let g=class extends b.AbstractTunnelService{constructor(D,t,c,i,s){super(t,s),this.t=D,this.u=c,this.v=i}isPortPrivileged(D){return(0,b.isPortPrivileged)(D,this.k,y.OS,M.release())}r(D,t,c,i,s,o,l,r){const h=this.q(t,c);if(h)return++h.refcount,h.value;if(this.e)return this.s(this.e,t,c,s,o,l,r);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${s}.`);const P={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},A=p(P,i,t,c,s);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,A),A}}};g=ve([Q(1,d.ILogService),Q(2,u.ISignService),Q(3,w.IProductService),Q(4,m.IConfigurationService)],g),e.BaseTunnelService=g;let f=class extends g{constructor(D,t,c,i){super(R.nodeSocketFactory,D,t,c,i)}};f=ve([Q(0,d.ILogService),Q(1,u.ISignService),Q(2,w.IProductService),Q(3,m.IConfigurationService)],f),e.TunnelService=f;let E=class extends k.Disposable{constructor(D,t,c,i){super(),this.b=D,this.c=t,this.f=c,this.g=i,this.a=new Map}async openTunnel(D,t,c,i,s,o,l,r,h){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this.a.has(D)){const P=new f(this.b,this.f,this.c,this.g);this.B(P),this.a.set(D,P),P.onTunnelClosed(async()=>{(await P.tunnels).length===0&&(P.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(t,c,i,s,o,l,r,h)}};E=ve([Q(0,d.ILogService),Q(1,w.IProductService),Q(2,u.ISignService),Q(3,m.IConfigurationService)],E),e.SharedTunnelsService=E}),define(Z[49],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(M=e.StateType||(e.StateType={}));var n;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,C)=>({type:"idle",updateType:R,error:C}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(Z[246],ee([0,1,4,179,68,51]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,M.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,M.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,M.localize)(2,null),(0,M.localize)(3,null),(0,M.localize)(4,null),(0,M.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,M.localize)(6,null),deprecationMessage:(0,M.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,M.localize)(8,null),description:(0,M.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,M.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[247],ee([0,1,3,49]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(k){this.a=k}listen(k,m){switch(m){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${m}`)}call(k,m,d){switch(m){case"checkForUpdates":return this.a.checkForUpdates(d);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(d)}throw new Error(`Call not found: ${m}`)}}e.UpdateChannel=n;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=M.State.Uninitialized,this.c.listen("onStateChange")(m=>this.state=m),this.c.call("_getInitialState").then(m=>this.state=m)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=R}),define(Z[93],ee([0,1,7,22,3,18,28,20,5,21,56,49]),function(x,e,I,M,n,R,C,k,m,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(y,p,a){return`${a.updateUrl}/api/update/${y}/${p}/${a.commit}`}e.createUpdateURL=b;let u=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,a,g,f,E,S){this.f=p,this.g=a,this.h=g,this.i=f,this.j=E,this.k=S,this.b=v.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),a=this.l(p);if(!a){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(a),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,g=>this.j.error(g))}l(p){return p==="none"?void 0:this.k.quality}m(p=60*60*1e3){return(0,I.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},M.CancellationToken.None)).res.statusCode===204}catch(a){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(a);return}}async _applySpecificUpdate(p){}p(){return 1}q(){}};u=ve([Q(0,k.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,C.IEnvironmentMainService),Q(3,w.IRequestService),Q(4,m.ILogService),Q(5,d.IProductService)],u),e.AbstractUpdateService=u}),define(Z[248],ee([0,1,15,54,3,2,18,28,20,5,21,56,24,49,93]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends y.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"error",(g,f)=>f)}get v(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(g,f,E)=>({url:f,version:E,productVersion:E}))}get x(){return n.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(g,f,E,S)=>({releaseNotes:f,version:E,productVersion:E,date:S}))}constructor(g,f,E,S,D,t,c){super(g,f,S,D,t,c),this.y=E,this.t=new R.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(g){this.j.error("UpdateService error:",g);const E=(this.state.type==="checking for updates"?this.state.explicit:!0)?g:void 0;this.d(u.State.Idle(1,E))}r(g){let f;this.k.darwinUniversalAssetId?f=this.k.darwinUniversalAssetId:f=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,y.createUpdateURL)(f,g,this.k);try{I.autoUpdater.setFeedURL({url:E})}catch(S){this.j.error("Failed to set update feed URL",S);return}return E}s(g){this.d(u.State.CheckingForUpdates(g)),I.autoUpdater.checkForUpdates()}C(g){this.state.type==="checking for updates"&&this.d(u.State.Downloading(g))}D(g){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:g.version}),this.d(u.State.Ready(g)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ve([M.memoize],p.prototype,"u",null),ve([M.memoize],p.prototype,"v",null),ve([M.memoize],p.prototype,"w",null),ve([M.memoize],p.prototype,"x",null),p=ve([Q(0,m.ILifecycleMainService),Q(1,C.IConfigurationService),Q(2,b.ITelemetryService),Q(3,k.IEnvironmentMainService),Q(4,v.IRequestService),Q(5,d.ILogService),Q(6,w.IProductService)],p),e.DarwinUpdateService=p}),define(Z[249],ee([0,1,46,41,7,3,9,28,20,5,24,49]),function(x,e,I,M,n,R,C,k,m,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,a,g){if(this.f=p,this.g=g,this.a=v.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,a.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(p=60*60*1e3){return(0,n.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};b=ve([Q(0,m.ILifecycleMainService),Q(1,k.IEnvironmentMainService),Q(2,d.ILogService)],b);let u=class extends b{constructor(p,a,g,f,E,S){super(g,f,E),this.o=p,this.p=a,this.q=S;const D=(0,M.watch)(C.dirname(this.o)),t=R.Event.fromNodeEventEmitter(D,"change",(o,l)=>l),c=R.Event.filter(t,o=>o==="current"),s=R.Event.debounce(c,(o,l)=>l,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{s.dispose(),D.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((g,f)=>(0,M.realpath)(`${C.dirname(this.o)}/current`,(E,S)=>E?f(E):g(S))),a=C.basename(p);return this.p!==a}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=ve([Q(2,m.ILifecycleMainService),Q(3,k.IEnvironmentMainService),Q(4,d.ILogService),Q(5,w.ITelemetryService)],u),e.SnapUpdateService=u}),define(Z[39],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(Z[250],ee([0,1,39,199,16,19,132,3,2]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{constructor(b){this.uri=b,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let w=class{constructor(b){this.g=b,this.c=new m.DisposableStore,this.f=2**16;const u=new Map,y=p=>{let a=u.get(p.scheme);return a===void 0&&(a=b.hasProvider(p)&&!this.g.hasCapability(p,1024),u.set(p.scheme,a)),a};this.c.add(k.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{u.delete(p.scheme)})),this.extUri=new R.ExtUri(y),this.d=new C.SkipList((p,a)=>this.extUri.compare(p,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,R.normalizePath)(b));const u=this.d.get(b);return u?u.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new d(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((y,p)=>y[1].time<p[1].time?1:y[1].time>p[1].time?-1:0);d._clock=0,this.d.clear();const u=this.f*.5;for(let y=0;y<u;y++)this.d.set(b[y][0],b[y][1].touch())}};w=ve([Q(0,n.IFileService)],w),e.UriIdentityService=w,(0,M.registerSingleton)(I.IUriIdentityService,w,1)}),define(Z[121],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(Z[251],ee([0,1,8]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(k){this.a=k}listen(k,m){throw new Error(`Event not found: ${m}`)}call(k,m,d){switch(m){case"handleURL":return this.a.handleURL(I.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${m}`)}}e.URLHandlerChannel=M;class n{constructor(k){this.a=k}handleURL(k,m){return this.a.call("handleURL",[k.toJSON(),m])}}e.URLHandlerChannelClient=n;class R{constructor(k,m){this.a=k,this.b=m}async routeCall(k,m,d,w){if(m!=="handleURL")throw new Error(`Call not found: ${m}`);if(Array.isArray(d)&&d.length>0){const v=I.URI.revive(d[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const u=b[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,v.toString(!0));const y=new RegExp(`window:${u}`),p=k.connections.find(a=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",a.ctx),y.test(a.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,m,d,w)}routeEvent(k,m){throw new Error(`Event not found: ${m}`)}}e.URLHandlerRouter=R}),define(Z[252],ee([0,1,7,2,8,21]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends M.Disposable{constructor(){super(...arguments),this.a=new Set}open(d,w){const v=[...this.a.values()];return(0,I.first)(v.map(b=>()=>b.handleURL(d,w)),void 0,!1).then(b=>b||!1)}registerHandler(d){return this.a.add(d),(0,M.toDisposable)(()=>this.a.delete(d))}}e.AbstractURLService=C;let k=class extends C{constructor(d){super(),this.b=d}create(d){let{authority:w,path:v,query:b,fragment:u}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return w&&v&&v.indexOf("/")!==0&&(v=`/${v}`),n.URI.from({scheme:this.b.urlProtocol,authority:w,path:v,query:b,fragment:u})}};k=ve([Q(0,R.IProductService)],k),e.NativeURLService=k}),define(Z[253],ee([0,1,15,7,3,2,4,8]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class m{constructor(w,v,b,u,y,p){if(this.f=v,this.g=p,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,w&&(p.trace("ElectronURLListener initialUrisToHandle:",w.map(f=>f.originalUrl)),this.a=w),C.isWindows){const f=u.isBuilt?[]:[`"${u.appRoot}"`];f.push("--open-url","--"),I.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,f)}const a=n.Event.map(n.Event.fromNodeEventEmitter(I.app,"open-url",(f,E)=>({event:f,url:E})),({event:f,url:E})=>(f.preventDefault(),E));this.d.add(a(f=>{const E=this.h(f);!E||this.f.open(E,{originalUrl:f})})),b.getWindows().filter(f=>f.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(b.onDidSignalReadyWindow)(this.i,this,this.d))}h(w){try{return k.URI.parse(w)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const w=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),w.push(v));w.length!==0&&(this.a=w,this.c=(0,M.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=m}),define(Z[254],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(Z[255],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(Z[256],ee([0,1,15,2,14,8]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends M.Disposable{constructor(){super();const m=this.b.bind(this);I.protocol.registerFileProtocol(n.Schemas.vscodeWebview,m)}b(m,d){try{const w=R.URI.parse(m.url),v=C.a.get(w.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,u=n.FileAccess.asFileUri(b);return d({path:decodeURIComponent(u.fsPath),headers:{...n.COI.getHeadersFromQuery(m.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return d({error:-10})}catch{}return d({error:-2})}}C.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=C}),define(Z[77],ee([0,1,4]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(w){return!!w.workspaceUri}e.isWorkspaceToOpen=M;function n(w){return!!w.folderUri}e.isFolderToOpen=n;function R(w){return!!w.fileUri}e.isFileToOpen=R;function C(w){const v=k(w),b=w.getValue("window.menuBarVisibility");return b==="default"||v==="native"&&b==="compact"||I.isMacintosh&&I.isNative?"classic":b}e.getMenuBarVisibility=C;function k(w){if(I.isWeb)return"custom";const v=w.getValue("window");if(v){if(I.isMacintosh&&v.nativeTabs===!0||I.isMacintosh&&v.nativeFullScreen===!1)return"native";const y=v.titleBarStyle;if(y==="native"||y==="custom")return y}return I.isLinux?"native":"custom"}e.getTitleBarStyle=k;function m(w){if(!I.isWindows||I.isWeb||k(w)==="native")return!1;const v=w.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=m;function d(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=d}),define(Z[122],ee([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var M;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));const n=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=n;var R;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var C;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(C=e.WindowError||(e.WindowError={}))}),define(Z[30],ee([0,1,6]),function(x,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var M;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}))}),define(Z[257],ee([0,1,15,22,3,60,2,31,75,109,5,21,30]),function(x,e,I,M,n,R,C,k,m,d,w,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let y=class extends C.Disposable{constructor(a,g,f,E,S){super(),this.g=a,this.h=g,this.i=f,this.j=E,this.k=S,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=u.Initial,this.f=void 0,this.l()}l(){const a=n.Event.fromNodeEventEmitter(I.app,"login",(g,f,E,S,D)=>({event:g,webContents:f,req:E,authInfo:S,callback:D}));this.B(a(this.m,this))}async m({event:a,authInfo:g,req:f,callback:E}){if(!g.isProxy)return;if(!this.b&&this.c===u.LoginDialogShown&&f.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}a.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(g);try{S=await this.b}finally{this.b=void 0}}E(S?.username,S?.password)}async n(a){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.p(a);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(a){this.g.trace("auth#doResolveProxyCredentials - enter",a);const g=String((0,R.hash)({scheme:a.scheme,host:a.host,port:a.port}));let f,E;try{const c=await this.i.getPassword(this.a,g);if(c){const i=JSON.parse(await this.j.decrypt(c));f=i.username,E=i.password}}catch(c){this.g.error(c)}if(this.c!==u.StoredCredentialsUsed&&typeof f=="string"&&typeof E=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=u.StoredCredentialsUsed,{username:f,password:E};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const D={authInfo:a,username:this.f?.username??f,password:this.f?.password??E,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,D),this.c=u.LoginDialogShown;const t=await new Promise(c=>{const i=async(s,o,l)=>{if(o===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",i),l){const r={username:l.username,password:l.password};try{if(l.remember){const h=await this.j.encrypt(JSON.stringify(r));await this.i.setPassword(this.a,g,h)}else await this.i.deletePassword(this.a,g)}catch(h){this.g.error(h)}c({username:r.username,password:r.password})}else c(void 0)};S.win?.webContents.on("ipc-message",i)});return this.f=t,t}};y=ve([Q(0,w.ILogService),Q(1,b.IWindowsMainService),Q(2,m.ICredentialsMainService),Q(3,d.IEncryptionMainService),Q(4,v.IProductService)],y),e.ProxyAuthHandler=y}),define(Z[258],ee([0,1,75,5,34,21,30,210]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let m=class extends k.BaseCredentialsMainService{constructor(w,v,b,u){super(w),this.j=v,this.k=b,this.l=u,this.i=y=>{this.l.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const w=await new Promise((v,b)=>{x(["keytar"],v,b)});return await w.findCredentials("test-keytar-loads"),this.f=w,this.f}};m=ve([Q(0,M.ILogService),Q(1,n.INativeEnvironmentService),Q(2,R.IProductService),Q(3,C.IWindowsMainService)],m),e.CredentialsNativeMainService=m}),define(Z[259],ee([0,1,15,25,4,8,23,18,62,6,5,121,30]),function(x,e,I,M,n,R,C,k,m,d,w,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,d.createDecorator)(e.ID);let u=class{constructor(p,a,g,f){this.a=p,this.b=a,this.c=g,this.d=f}async start(p,a){this.a.trace("Received data from other instance: ",p,a),n.isMacintosh&&I.app.focus({steal:!0});const g=this.e(p);if(g.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const E=(0,M.firstOrDefault)(await this.b.openEmptyWindow({context:4}));E&&(f=E.ready())}f.then(()=>{for(const{uri:E,originalUrl:S}of g)this.c.open(E,{originalUrl:S})})}else return this.f(p,a)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,M.coalesce)(p._urls.map(a=>{try{return{uri:R.URI.parse(a),originalUrl:a}}catch{return null}})):[]}async f(p,a){const g=(0,m.isLaunchedFromCli)(a)?0:4;let f=[];const E=p.wait&&p.waitMarkerFilePath?R.URI.file(p.waitMarkerFilePath):void 0,S=p.remote||void 0,D={context:g,cli:p,userEnv:a,waitMarkerFileURI:E,remoteAuthority:S,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,D);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let t=!1;if(p["new-window"]||p["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(p["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)f=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,D),f=[c]):f=await this.b.open({...D,forceEmpty:!0})}}else f=await this.b.open({...D,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(E&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,C.whenDeleted)(E.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};u=ve([Q(0,w.ILogService),Q(1,b.IWindowsMainService),Q(2,v.IURLService),Q(3,k.IConfigurationService)],u),e.LaunchMainService=u}),define(Z[94],ee([0,1,15,2,3,5,260,7,14,30,73,24,20,71,37]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;let p=class It extends M.Disposable{constructor(f,E,S){super(),this.m=f,this.n=E,this.p=S,this.b=String(++It.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0}r(f,E){let S;switch(this.l?.correlationId?S=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${f}`:S=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${f}`,E){case w.default.Error:this.m.error(S);break;case w.default.Warning:this.m.warn(S);break;case w.default.Info:this.m.info(S);break}}s(){return this.j?(this.r("Cannot start utility process because it is already running...",w.default.Error),!1):!0}start(f){const E=this.t(f,!1);return E&&f.payload&&this.postMessage(f.payload),E}t(f,E){if(!this.s())return!1;this.l=f;const S=`${this.l.type}-${this.b}`,D=m.FileAccess.asFileUri("bootstrap-fork.js").fsPath,t=this.l.args??[],c=[...this.l.execArgv??[],`--vscode-utility-kind=${this.l.type}`],i=this.l.allowLoadingUnsignedLibraries,s="pipe",o=this.u(f,E);return this.r("creating new...",w.default.Info),this.j=I.utilityProcess.fork(D,t,{serviceName:S,env:o,execArgv:c,allowLoadingUnsignedLibraries:i,stdio:s}),this.v(this.j,this.l,S,E),!0}u(f,E){const S=f.env?{...f.env}:{...(0,y.deepClone)(process.env)};S.VSCODE_AMD_ENTRYPOINT=f.entryPoint,typeof f.parentLifecycleBound=="number"&&(S.VSCODE_PARENT_PID=String(f.parentLifecycleBound)),E&&(S.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),S.VSCODE_CRASH_REPORTER_PROCESS_TYPE=f.type,(0,u.removeDangerousEnvVariables)(S);for(const D of Object.keys(S))S[D]=String(S[D]);return S}v(f,E,S,D){if(f.stdout){const t=new C.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(f.stdout,"data")(c=>this.c.fire(typeof c=="string"?c:t.write(c))))}if(f.stderr){const t=new C.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(f.stderr,"data")(c=>this.f.fire(typeof c=="string"?c:t.write(c))))}this.B(n.Event.fromNodeEventEmitter(f,"message")(t=>this.g.fire(t))),this.B(n.Event.fromNodeEventEmitter(f,"spawn")(()=>{this.k=f.pid,this.r("successfully created",w.default.Info)})),this.B(n.Event.fromNodeEventEmitter(f,"exit")(t=>{this.r(`received exit event with code ${t}`,w.default.Info),this.h.fire({pid:this.k,code:t,signal:"unknown"}),this.w()})),this.B(n.Event.fromNodeEventEmitter(I.app,"child-process-gone",(t,c)=>({event:t,details:c}))(({details:t})=>{t.type==="Utility"&&t.name===S&&(this.r(`crashed with code ${t.exitCode} and reason '${t.reason}'`,w.default.Error),this.n.publicLog2("utilityprocesscrash",{type:E.type,reason:t.reason,code:t.exitCode,sandboxed:D?"1":"0"}),this.i.fire({pid:this.k,code:t.exitCode,reason:t.reason}),this.w())}))}once(f,E){const S=this.B(this.g.event(D=>{D===f&&(S.dispose(),E())}))}postMessage(f,E){!this.j||this.j.postMessage(f,E)}connect(f){const{port1:E,port2:S}=new I.MessageChannelMain;return this.postMessage(f,[S]),E}enableInspectPort(){if(!this.j||typeof this.k!="number")return!1;this.r("enabling inspect port",w.default.Info);const f=process;return typeof f._debugProcess=="function"?(f._debugProcess(this.k),!0):!1}kill(){if(!this.j)return;this.r("attempting to kill the process...",w.default.Info),this.j.kill()?(this.r("successfully killed the process",w.default.Info),this.w()):this.r("unable to kill the process",w.default.Warning)}w(){this.j=void 0}async waitForExit(f){!this.j||(this.r("waiting to exit...",w.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,k.timeout)(f)]),this.j&&(this.r(`did not exit within ${f}ms, will kill it now...`,w.default.Info),this.kill()))}};p.a=0,p=ve([Q(0,R.ILogService),Q(1,v.ITelemetryService),Q(2,b.ILifecycleMainService)],p),e.UtilityProcess=p;let a=class extends p{constructor(f,E,S,D){super(f,S,D),this.y=E}start(f){const E=this.y.getWindowById(f.responseWindowId);if(!E?.win||E.win.isDestroyed()||E.win.webContents.isDestroyed())return this.r("Refusing to start utility process because requesting window cannot be found or is destroyed...",w.default.Error),!0;if(!super.t(f,E.isSandboxed))return!1;this.z(E.win,f);const D=this.connect(f.payload);return E.win.webContents.postMessage(f.responseChannel,f.responseNonce,[D]),!0}z(f,E){E.windowLifecycleBound&&(this.B(n.Event.filter(this.p.onWillLoadWindow,S=>S.window.win===f)(()=>this.kill())),this.B(n.Event.fromNodeEventEmitter(f,"closed")(()=>this.kill())))}};a=ve([Q(0,R.ILogService),Q(1,d.IWindowsMainService),Q(2,v.ITelemetryService),Q(3,b.ILifecycleMainService)],a),e.WindowUtilityProcess=a}),define(Z[261],ee([0,1,13,2,3,5,20,72,46,260,7,14,37,4,36,94,30,24]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let f=class Pt{constructor(D,t,c,i){this.d=D,this.f=t,this.g=c,this.h=i,this.c=!1,this.b=new Map,this.f.onWillShutdown(s=>{this.c=!0,s.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(D){const t=this.b.get(D);if(!t)throw new Error("Unknown extension host!");return t}onDynamicStdout(D){return this.i(D).onStdout}onDynamicStderr(D){return this.i(D).onStderr}onDynamicMessage(D){return this.i(D).onMessage}onDynamicError(D){const t=this.i(D);return t instanceof p.WindowUtilityProcess?n.Event.None:t.onError}onDynamicExit(D){return this.i(D).onExit}async createExtensionHost(D){if(this.c)throw(0,I.canceled)();const t=String(++Pt.a);let c;return D?c=new p.WindowUtilityProcess(this.d,this.g,this.h,this.f):c=new E(t,this.d),this.b.set(t,c),c.onExit(({pid:i,code:s,signal:o})=>{this.d.info(`Extension host with pid ${i} exited with code: ${s}, signal: ${o}.`),setTimeout(()=>{c.dispose(),this.b.delete(t)})}),{id:t}}async start(D,t){if(this.c)throw(0,I.canceled)();this.i(D).start({...t,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:t.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:D})}async enableInspectPort(D){if(this.c)throw(0,I.canceled)();const t=this.b.get(D);return t?t.enableInspectPort():!1}async kill(D){if(this.c)throw(0,I.canceled)();const t=this.b.get(D);!t||t.kill()}async _killAllNow(){for(const[,D]of this.b)D.kill()}async _waitForAllExit(D){const t=[];for(const[,c]of this.b)t.push(c.waitForExit(D));return w.Promises.settled(t).then(()=>{})}};f.a=0,f=ve([Q(0,R.ILogService),Q(1,C.ILifecycleMainService),Q(2,a.IWindowsMainService),Q(3,g.ITelemetryService)],f),e.ExtensionHostStarter=f;let E=class extends M.Disposable{constructor(D,t){super(),this.id=D,this.c=t,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(D){u.isCI&&this.c.info("Calling fork to start extension host...");const t=k.StopWatch.create(!1);this.a=(0,m.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,y.cwd)()},D));const c=t.elapsed(),i=this.a.pid;this.c.info(`Starting extension host with pid ${i} (fork() took ${c} ms).`);const s=new d.StringDecoder("utf-8");this.a.stdout?.on("data",l=>{const r=typeof l=="string"?l:s.write(l);this._onStdout.fire(r)});const o=new d.StringDecoder("utf-8");this.a.stderr?.on("data",l=>{const r=typeof l=="string"?l:o.write(l);this._onStderr.fire(r)}),this.a.on("message",l=>{this._onMessage.fire(l)}),this.a.on("error",l=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(l)})}),this.a.on("exit",(l,r)=>{this.b=!0,this._onExit.fire({pid:i,code:l,signal:r})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):u.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(D){if(!this.a)return;const t=this.a.pid;this.c.info(`Waiting for extension host with pid ${t} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,w.timeout)(D)]),this.b||(this.c.info(`Extension host with pid ${t} did not exit within ${D}ms.`),this.a.kill())}};E=ve([Q(1,R.ILogService)],E)}),define(Z[262],ee([0,1,2,6,5,30,94,24,60,3,7,20]),function(x,e,I,M,n,R,C,k,m,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,M.createDecorator)("utilityProcessWorker");let b=class extends I.Disposable{constructor(p,a,g,f){super(),this.b=p,this.c=a,this.f=g,this.g=f,this.a=new Map}async createWorker(p){const a=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${a})`);const g=this.h(p);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${a})`),this.disposeWorker(p));const f=new u(this.b,this.c,this.f,this.g,p);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,f);const E=new w.DeferredPromise;return d.Event.once(f.onDidTerminate)(S=>{this.a.delete(g),E.complete({reason:S})}),E.p}h(p){return(0,m.hash)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const a=this.h(p),g=this.a.get(a);!g||(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),g.kill(),this.a.delete(a))}};b=ve([Q(0,n.ILogService),Q(1,R.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,v.ILifecycleMainService)],b),e.UtilityProcessWorkerMainService=b;let u=class extends I.Disposable{constructor(p,a,g,f,E){super(),this.c=p,this.f=a,this.g=g,this.h=f,this.i=E,this.a=this.B(new d.Emitter),this.onDidTerminate=this.a.event,this.b=new C.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const a=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:a,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};u=ve([Q(0,n.ILogService),Q(1,R.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,v.ILifecycleMainService)],u)}),define(Z[263],ee([0,1,15,3,2,256,30]),function(x,e,I,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends n.Disposable{constructor(d){super(),this.b=d,this.a=this.B(new M.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,w){let v;if(typeof d.windowId=="number"){const{windowId:b}=d,u=this.b.getWindowById(b);if(!u?.win)throw new Error(`Invalid windowId: ${b}`);v=u.win.webContents}else{const{webContentsId:b}=d;if(v=I.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(w)}async findInFrame(d,w,v,b){const y=this.c(d,w);if(typeof y.findInFrame=="function"){y.findInFrame(v,{findNext:b.findNext,forward:b.forward});const p=(a,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",p))};y.on("found-in-frame",p)}}async stopFindInFrame(d,w,v){const u=this.c(d,w);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(d,w){const v=this.b.getWindowById(d.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${d}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===w);if(!b)throw new Error(`Unknown frame: ${w}`);return b}};k=ve([Q(0,C.IWindowsMainService)],k),e.WebviewMainService=k}),define(Z[264],ee([0,1,7,3,2]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends n.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:m,getActiveWindowId:d}){super(),this.a=this.B(new n.DisposableStore),M.Event.latch(M.Event.any(k,m))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>d()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(Z[29],ee([0,1,183,9,61,19,8,6,14]),function(x,e,I,M,n,R,C,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function d(i){const s=i;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=d;function w(i){return typeof i?.id=="string"&&!d(i)&&!b(i)}e.isEmptyWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=v;function b(i){const s=i;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=b;function u(i){const s=i;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function p(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=p;function a(i){const s=i;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class g{constructor(s,o,l,r,h){this.h=s,this.j=l,this.k=r,this.l=h,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function E(i){return new f({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,s){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function D(i){let s;return C.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===m.Schemas.tmp}e.isTemporaryWorkspace=D;function t(i,s){return!S(i,s)&&!D(i)}e.isSavedWorkspace=t;function c(i){return(typeof i=="string"?(0,M.extname)(i):(0,R.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(Z[57],ee([0,1,15,7,60,45,2,80,4,10,23,160,88,6,5,21,29]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,u.createDecorator)("dialogMainService");let g=class{constructor(E,S){this.d=E,this.e=S,this.a=new Map,this.b=new Map,this.c=new M.Queue}pickFileFolder(E,S){return this.f({...E,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},S)}pickFolder(E,S){return this.f({...E,pickFolders:!0,title:(0,v.localize)(1,null)},S)}pickFile(E,S){return this.f({...E,pickFiles:!0,title:(0,v.localize)(2,null)},S)}pickWorkspace(E,S){const D=(0,v.localize)(3,null),t=(0,R.mnemonicButtonLabel)((0,v.localize)(4,null)),c=a.WORKSPACE_FILTER;return this.f({...E,pickFiles:!0,title:D,filters:c,buttonLabel:t},S)}async f(E,S){const D={title:E.title,buttonLabel:E.buttonLabel,filters:E.filters,defaultPath:E.defaultPath};(typeof E.pickFiles=="boolean"||typeof E.pickFolders=="boolean")&&(D.properties=void 0,E.pickFiles&&E.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",E.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,d.withNullAsUndefined)(S||I.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(E){if(E){let S=this.b.get(E.id);return S||(S=new M.Queue,this.b.set(E.id,S)),S}else return this.c}showMessageBox(E,S){return this.g(S).queue(async()=>{const{options:D,buttonIndeces:t}=(0,b.massageMessageBoxOptions)(E,this.e);let c;return S?c=await I.dialog.showMessageBox(S,D):c=await I.dialog.showMessageBox(D),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(E,S){const D=this.j(E,S);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(S).queue(async()=>{let t;return S?t=await I.dialog.showSaveDialog(S,E):t=await I.dialog.showSaveDialog(E),t.filePath=this.h(t.filePath),t})}finally{(0,C.dispose)(D)}}h(E){return E&&m.isMacintosh&&(E=(0,k.normalizeNFC)(E)),E}i(E){return E.map(S=>this.h(S))}async showOpenDialog(E,S){E.defaultPath&&(await w.Promises.exists(E.defaultPath)||(E.defaultPath=void 0));const D=this.j(E,S);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(S).queue(async()=>{let t;return S?t=await I.dialog.showOpenDialog(S,E):t=await I.dialog.showOpenDialog(E),t.filePaths=this.i(t.filePaths),t})}finally{(0,C.dispose)(D)}}j(E,S){if(!S)return C.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",E);let D=this.a.get(S.id);D||(D=new Set,this.a.set(S.id,D));const t=(0,n.hash)(E);if(!D.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",E),D.add(t),(0,C.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",E),D?.delete(t),D?.size===0&&this.a.delete(S.id)})}};g=ve([Q(0,y.ILogService),Q(1,p.IProductService)],g),e.DialogMainService=g}),define(Z[265],ee([0,1,3,2,83,29]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends M.Disposable{constructor(m,d){super(),this.f=m,this.g=d,this.b=this.B(new I.Emitter),this.c=new Map,this.h(d.applicationStorage,this.b)}h(m,d){this.B(I.Event.debounce(m.onDidChangeStorage,(w,v)=>(w?w.push(v):w=[v],w),C.a)(w=>{w.length&&d.fire(this.i(w,m))}))}i(m,d){const w=new Map,v=new Set;return m.forEach(b=>{const u=d.get(b.key);typeof u=="string"?w.set(b.key,u):v.add(b.key)}),{changed:Array.from(w.entries()),deleted:Array.from(v.values())}}listen(m,d,w){switch(d){case"onDidChangeStorage":{const v=w.profile?(0,n.revive)(w.profile):void 0;if(!v)return this.b.event;let b=this.c.get(v.id);return b||(b=this.B(new I.Emitter),this.h(this.g.profileStorage(v),b),this.c.set(v.id,b)),b.event}}throw new Error(`Event not found: ${d}`)}async call(m,d,w){const v=w.profile?(0,n.revive)(w.profile):void 0,b=(0,R.reviveIdentifier)(w.workspace),u=await this.j(v,b);switch(d){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=w;if(y.insert)for(const[p,a]of y.insert)u.set(p,a);y.delete?.forEach(p=>u.delete(p));break}case"isUsed":{const y=w.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${d}`)}}async j(m,d){let w;d?w=this.g.workspaceStorage(d):m?w=this.g.profileStorage(m):w=this.g.applicationStorage;try{await w.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${d?"workspace":m?"profile":"application"} storage due to ${v}`)}return w}}C.a=100,e.StorageDatabaseChannel=C}),define(Z[40],ee([0,1,60,3,2,19,8,180,34,16,6,5,29,35,39,7,31,27,10]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function E(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function S(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:C.URI.revive(i.location).with({scheme:s}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(i.extensionsResource)?.with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=S;function D(i,s,o,l){return{id:i,name:s,location:o,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=D;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,o,l,r){super(),this.m=s,this.n=o,this.r=l,this.s=r,this.f=!0,this.g=this.B(new M.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new M.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new M.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new M.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)try{for(const h of this.I()){if(!h.name||!(0,f.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}s.push(D((0,R.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}}catch(h){this.s.error(h)}const o=new u.ResourceMap,l=new Map,r=this.v();if(s.unshift({...r,extensionsResource:this.N()??r.extensionsResource,isDefault:!0}),s.length)try{const h=this.L();if(h.workspaces)for(const[P,A]of Object.entries(h.workspaces)){const T=C.URI.parse(P),N=s.find(z=>z.id===A);N&&o.set(T,N)}if(h.emptyWindows)for(const[P,A]of Object.entries(h.emptyWindows)){const T=s.find(N=>N.id===A);T&&l.set(P,T)}}catch(h){this.s.error(h)}this.t={profiles:s,workspaces:o,emptyWindows:l}}return this.t}v(){return D("__default__profile__",(0,k.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let r=0;for(const P of this.profiles){const A=l.exec(P.name),T=A?parseInt(A[1]):0;r=T>r?T:r}const h=`${o} ${r+1}`;return this.createProfile((0,I.hash)((0,a.generateUuid)()).toString(16),h,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,I.hash)((0,a.generateUuid)()).toString(16),s,o,l)}async createProfile(s,o,l,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.w(s,o,l);return r&&await this.setProfileForWorkspace(r,h),h}async w(s,o,l){if(!(0,f.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(o);return r||(r=(async()=>{try{const h=this.profiles.find(T=>T.name===o||T.id===s);if(h)return h;const P=D(s,o,(0,R.joinPath)(this.profilesHome,s),l);await this.n.createFolder(P.location);const A=[];return this.h.fire({profile:P,join(T){A.push(T)}}),await p.Promises.settled(A),this.C([P],[],[]),P}finally{this.k.delete(o)}})(),this.k.set(o,r)),r}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(r=>r.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=D(l.id,o.name??l.name,l.location,{shortName:o.shortName??l.shortName,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags}),this.C([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(r=>r.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.i.fire({profile:o,join(r){l.push(r)}});try{await Promise.allSettled(l)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(r=>r.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.F(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(s,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.y(s);return C.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}y(s){return(0,b.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,b.isWorkspaceIdentifier)(s)?s.configPath:s.id}z(s){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location)))}C(s,o,l){const r=[...this.profiles,...s],h=[];this.l.profiles=[];for(let P of r)P.isDefault||o.some(A=>P.id===A.id)||(P=l.find(A=>P.id===A.id)??P,P.isTransient?this.l.profiles.push(P):h.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.J(h),this.t=void 0,this.D(s,o,l)}D(s,o,l){this.g.fire({added:s,removed:o,updated:l,all:this.profiles})}F(s,o,l){l=o?.isTransient?!0:l,l||this.F(s,void 0,!0);const r=this.y(s),h=l?this.l:this.u;C.URI.isUri(r)?(h.workspaces.delete(r),o&&h.workspaces.set(r,o)):(h.emptyWindows.delete(r),o&&h.emptyWindows.set(r,o)),l||this.G()}G(){const s={};for(const[l,r]of this.u.workspaces.entries())s[l.toString()]=r.id;const o={};for(const[l,r]of this.u.emptyWindows.entries())o[l.toString()]=r.id;this.M({workspaces:s,emptyWindows:o}),this.t=void 0}H(s){const o={},l=this.v();if(s.workspaces)for(const[h,P]of Object.entries(s.workspaces)){const A=C.URI.parse(P);o[h]=this.r.extUri.isEqual(A,l.location)?l.id:this.r.extUri.basename(A)}const r={};if(s.emptyWindows)for(const[h,P]of Object.entries(s.emptyWindows)){const A=C.URI.parse(P);r[h]=this.r.extUri.isEqual(A,l.location)?l.id:this.r.extUri.basename(A)}return{workspaces:o,emptyWindows:r}}I(){return[]}J(s){throw new Error("not implemented")}L(){return{}}M(s){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([Q(0,m.IEnvironmentService),Q(1,d.IFileService),Q(2,y.IUriIdentityService),Q(3,v.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(s){this.a=s}L(){return this.Q}M(s){this.Q=s}}e.InMemoryUserDataProfilesService=c}),define(Z[78],ee([0,1,7,17,2,3,35,8,110,117,16,6,5,40,39,10,13,24]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class E extends Error{constructor(i,s){super(i),this.code=s}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let S=class extends n.Disposable{constructor(i,s,o,l,r,h){super(),this.i=i,this.j=s,this.k=o,this.l=l,this.m=r,this.n=h,this.b=this.B(new R.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(i,s){return this.p(i,void 0,s)}async addExtensionsToProfile(i,s){const o=[],l=[];try{return await this.p(s,r=>{const h=[];for(const P of r)i.some(([A])=>(0,d.areSameExtensions)(A.identifier,P.identifier)&&A.manifest.version!==P.version)?o.push(P):h.push(P);for(const[P,A]of i)if(!h.some(T=>(0,d.areSameExtensions)(T.identifier,P.identifier)&&T.version===P.manifest.version)){const T={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:A};l.push(T),h.push(T)}return l.length&&this.b.fire({extensions:l,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),h}),l.length&&this.c.fire({extensions:l,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),l}catch(r){throw l.length&&this.c.fire({extensions:l,error:r,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:r,profileLocation:s}),r}}async updateMetadata(i,s){const o=[];return await this.p(s,l=>{const r=[];for(const h of l){const P=i.find(([A])=>(0,d.areSameExtensions)(A.identifier,h.identifier)&&A.manifest.version===h.version);P&&(h.metadata={...h.metadata,...P[1]},o.push(h)),r.push(h)}return r}),o}async removeExtensionFromProfile(i,s){const o=[];this.f.fire({extensions:o,profileLocation:s});try{await this.p(s,l=>{const r=[];for(const h of l)(0,d.areSameExtensions)(h.identifier,i.identifier)?o.push(h):r.push(h);return o.length&&this.f.fire({extensions:o,profileLocation:s}),r}),o.length&&this.g.fire({extensions:o,profileLocation:s})}catch(l){throw o.length&&this.g.fire({extensions:o,error:l,profileLocation:s}),l}}async p(i,s,o){return this.w(i).queue(async()=>{let l=[],r;try{const h=await this.j.readFile(i);r=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,w.toFileOperationResult)(h)!==1)throw h;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(r=await this.v()),!r&&o?.bailOutWhenFileNotFound)throw new E((0,a.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.r(i);let h=!1;for(const P of r){D(P)||this.r(i);let A;if((0,p.isString)(P.relativeLocation)&&P.relativeLocation)A=this.t(P.relativeLocation);else if((0,p.isString)(P.location))A=this.t(P.location),h=!0,P.relativeLocation=P.location,P.location=A.toJSON();else{A=k.URI.revive(P.location);const T=this.s(A);T&&(h=!0,P.relativeLocation=T)}l.push({identifier:P.identifier,location:A,version:P.version,metadata:P.metadata})}h&&await this.j.writeFile(i,M.VSBuffer.fromString(JSON.stringify(r)))}if(s){l=s(l);const h=l.map(P=>({identifier:P.identifier,version:P.version,location:P.location.toJSON(),relativeLocation:this.s(P.location),metadata:P.metadata}));await this.j.writeFile(i,M.VSBuffer.fromString(JSON.stringify(h)))}return l})}r(i){const s=new E(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(i)).value.toString()}catch(r){if((0,w.toFileOperationResult)(r)===1)return;throw r}this.n.info("Migrating extensions from old default profile location",i.toString());let l;try{const r=JSON.parse(o);Array.isArray(r)&&r.every(h=>D(h))?l=r:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",r)}catch(r){this.n.error(r)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(r){if((0,w.toFileOperationResult)(r)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw r}try{await this.j.del(i)}catch(r){(0,w.toFileOperationResult)(r)!==1&&this.n.error(r)}try{await this.j.del(s)}catch(r){(0,w.toFileOperationResult)(r)!==1&&this.n.error(r)}return l})()),this.u}w(i){let s=this.h.get(i);return s||(s=new I.Queue,this.h.set(i,s)),s}};S=ve([Q(1,w.IFileService),Q(2,u.IUserDataProfilesService),Q(3,y.IUriIdentityService),Q(4,g.ITelemetryService),Q(5,b.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function D(c){return(0,p.isObject)(c)&&(0,m.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,p.isString)(c.location)&&c.location)&&((0,p.isUndefined)(c.relativeLocation)||(0,p.isString)(c.relativeLocation))&&c.version&&(0,p.isString)(c.version)}function t(c){return c?(0,p.isString)(c.path)&&(0,p.isString)(c.scheme):!1}}),define(Z[123],ee([0,1,25,7,37,17,13,43,145,2,14,9,4,19,197,73,10,8,165,34,117,114,196,16,6,5,21,3,83,78,40,39,194,195]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c,i,s,o,l,r,h,P,A,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var z;(function(me){function G(B,O){if(B===O)return!0;const q=Object.keys(B),Y=new Set;for(const te of Object.keys(O))Y.add(te);if(q.length!==Y.size)return!1;for(const te of q){if(B[te]!==O[te])return!1;Y.delete(te)}return Y.size===0}me.equals=G})(z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let H=class extends d.Disposable{constructor(G,B,O,q,Y,te,ne,L,F,W,U,$){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=B,this.l=O,this.m=q,this.n=Y,this.p=te,this.r=ne,this.s=L,this.t=F,this.u=W,this.v=U,this.w=$,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(oe,(0,u.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(oe,(0,u.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(G,B,O){const[q,Y]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(B)]),te=O?await this.scanExtensionsUnderDevelopment(G,[...q,...Y]):[];return this.F(q,Y,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const B=[];B.push(this.G(!!G.useCache,G.language)),B.push(this.H(G.language,!!G.checkControlFile));const[O,q]=await Promise.all(B);return this.D([...O,...q],0,G,!1)}async scanUserExtensions(G){const B=G.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",B);const O=this.v.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.J(B,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,O),Y=G.useCache&&!q.devMode&&q.excludeObsolete?this.j:this.k;let te;try{te=await Y.scanExtensions(q)}catch(ne){if(ne instanceof h.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),te=await Y.scanExtensions(q);else throw ne}return te=await this.D(te,1,G,!0),this.s.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(G,B){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const O=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(q=>q.scheme===w.Schemas.file).map(async q=>{const Y=await this.J(q,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Y)).map(ne=>(ne.type=B.find(L=>(0,S.areSameExtensions)(L.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,Y)))}))).flat();return this.D(O,"development",G,!0)}return[]}async scanExistingExtension(G,B,O){const q=await this.J(G,!1,B,!0,O.language,!0,void 0),Y=await this.k.scanExtension(q);return!Y||!O.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions(G,B,O){const q=await this.J(G,!1,B,!0,O.language,!0,void 0),Y=await this.k.scanOneOrMultipleExtensions(q);return this.D(Y,B,O,!0)}async scanMetadata(G){const B=(0,u.joinPath)(G,"package.json"),O=(await this.r.readFile(B)).value.toString();return JSON.parse(O).__metadata}async updateMetadata(G,B){const O=(0,u.joinPath)(G,"package.json"),q=(await this.r.readFile(O)).value.toString(),Y=JSON.parse(q);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,Y.__metadata={...Y.__metadata,...B},await this.r.writeFile((0,u.joinPath)(G,"package.json"),R.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof h.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw G}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.p.addExtensionsToProfile(G.map(B=>[B,B.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,c.toFileOperationResult)(B)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(B))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.s.error(G)}finally{this.z=void 0}})()),this.z}async D(G,B,O,q){return O.includeAllVersions||(G=this.F(B===0?G:void 0,B===1?G:void 0,B==="development"?G:void 0,await this.getTargetPlatform(),q)),O.includeInvalid||(G=G.filter(Y=>Y.isValid)),G.sort((Y,te)=>{const ne=v.basename(Y.location.fsPath),L=v.basename(te.location.fsPath);return ne<L?-1:ne>L?1:0})}F(G,B,O,q,Y){const te=(L,F,W)=>{if(L.isValid&&!F.isValid)return!1;if(L.isValid===F.isValid){if(Y&&y.gt(L.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${L.location.path} with version ${L.manifest.version}`),!1;if(y.eq(L.manifest.version,F.manifest.version)){if(L.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${L.location.path} with same version`),!1;if(L.targetPlatform===q)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${L.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${L.location.path} with ${F.location.path}.`),!0},ne=new Map;return G?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),W=ne.get(F);(!W||te(W,L,!1))&&ne.set(F,L)}),B?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),W=ne.get(F);if(!W&&G&&L.type===0){this.s.debug(`Skipping obsolete system extension ${L.location.path}.`);return}(!W||te(W,L,!1))&&ne.set(F,L)}),O?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),W=ne.get(F);(!W||te(W,L,!0))&&ne.set(F,L),ne.set(F,L)}),[...ne.values()]}async G(G,B){this.s.trace("Started scanning system extensions");const O=await this.J(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),Y=await(G&&!O.devMode?this.i:this.k).scanExtensions(O);return this.s.trace("Scanned system extensions:",Y.length),Y}async H(G,B){const O=this.t.isBuilt?[]:this.u.builtInExtensions;if(!O?.length)return[];this.s.trace("Started scanning dev system extensions");const q=B?await this.I():{},Y=[],te=g.URI.file(v.normalize(v.join(w.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const L of O){const F=q[L.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":Y.push((0,u.joinPath)(te,L.name));break;default:Y.push(g.URI.file(F));break}}const ne=await Promise.all(Y.map(async L=>this.k.scanExtension(await this.J(L,!1,0,!0,G,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ne.length),(0,I.coalesce)(ne)}async I(){try{const G=await this.r.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async J(G,B,O,q,Y,te,ne){const L=await this.f(Y??b.language),F=await this.L(G),W=B&&!this.v.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=W?await this.L(W):void 0;return new ie(G,F,W,U,B,ne,O,q,te,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Y,L)}async L(G){try{const B=await this.r.stat(G);if(typeof B.mtime=="number")return B.mtime}catch{}}};H=ve([Q(4,P.IUserDataProfilesService),Q(5,h.IExtensionsProfileScannerService),Q(6,c.IFileService),Q(7,s.ILogService),Q(8,E.IEnvironmentService),Q(9,o.IProductService),Q(10,A.IUriIdentityService),Q(11,i.IInstantiationService)],H),e.AbstractExtensionsScannerService=H;class ie{constructor(G,B,O,q,Y,te,ne,L,F,W,U,$,V,j,K){this.location=G,this.mtime=B,this.applicationExtensionslocation=O,this.applicationExtensionslocationMtime=q,this.profile=Y,this.profileScanOptions=te,this.type=ne,this.excludeObsolete=L,this.validate=F,this.productVersion=W,this.productDate=U,this.productCommit=$,this.devMode=V,this.language=j,this.translations=K}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,B){return(0,u.isEqual)(G.location,B.location)&&G.mtime===B.mtime&&(0,u.isEqual)(G.applicationExtensionslocation,B.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&G.profile===B.profile&&n.equals(G.profileScanOptions,B.profileScanOptions)&&G.type===B.type&&G.excludeObsolete===B.excludeObsolete&&G.validate===B.validate&&G.productVersion===B.productVersion&&G.productDate===B.productDate&&G.productCommit===B.productCommit&&G.devMode===B.devMode&&G.language===B.language&&z.equals(G.translations,B.translations)}}e.ExtensionScannerInput=ie;let se=class extends d.Disposable{constructor(G,B,O,q,Y){super(),this.f=G,this.g=B,this.h=O,this.i=q,this.j=Y}async scanExtensions(G){const B=G.profile?await this.l(G):await this.k(G);let O={};if(G.excludeObsolete&&G.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();O=JSON.parse(q)}catch{}return(0,a.isEmptyObject)(O)?B:B.filter(q=>!O[S.ExtensionKey.create(q).toString()])}async k(G){const B=await this.i.resolve(G.location);if(!B.children?.length)return[];const O=await Promise.all(B.children.map(async q=>{if(!q.isDirectory||G.type===1&&(0,u.basename)(q.resource).indexOf(".")===0)return null;const Y=new ie(q.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(Y)}));return(0,I.coalesce)(O).sort((q,Y)=>q.location.path<Y.location.path?-1:1)}async l(G){let B=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){B=B.filter(q=>!q.metadata?.isApplicationScoped);const O=await this.m(G.applicationExtensionslocation,q=>!!q.metadata?.isApplicationScoped,G);B.push(...O)}return B}async m(G,B,O){const q=await this.g.scanProfileExtensions(G,O.profileScanOptions);if(!q.length)return[];const Y=await Promise.all(q.map(async te=>{if(B(te)){const ne=new ie(te.location,O.mtime,O.applicationExtensionslocation,O.applicationExtensionslocationMtime,O.profile,O.profileScanOptions,O.type,O.excludeObsolete,O.validate,O.productVersion,O.productDate,O.productCommit,O.devMode,O.language,O.translations);return this.scanExtension(ne,te.metadata)}return null}));return(0,I.coalesce)(Y)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,u.joinPath)(G.location,"package.json"))){const B=await this.scanExtension(G);return B?[B]:[]}else return await this.scanExtensions(G)}catch(B){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,C.getErrorMessage)(B)),[]}}async scanExtension(G,B){try{let O=await this.scanExtensionManifest(G.location);if(O){O.publisher||(O.publisher=D.UNDEFINED_PUBLISHER),B=B??O.__metadata,delete O.__metadata;const q=(0,S.getGalleryExtensionId)(O.publisher,O.name),Y=B?.id?{id:q,uuid:B.id}:{id:q},te=B?.isSystem?0:G.type,ne=te===0||!!B?.isBuiltin;N.ImplicitActivationEvents.updateManifest(O),O=await this.n(G.location,O,ie.createNlsConfiguration(G));const L={type:te,identifier:Y,manifest:O,location:G.location,isBuiltin:ne,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return G.validate?this.validate(L,G):L}}catch(O){G.type!==0&&this.j.error(O)}return null}validate(G,B){let O=!0;const q=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,G.manifest,G.isBuiltin);for(const[Y,te]of q)Y===p.default.Error&&(O=!1,this.j.error(this.t(B.location,te)));return G.isValid=O,G.validations=q,G}async scanExtensionManifest(G){const B=(0,u.joinPath)(G,"package.json");let O;try{O=(await this.i.readFile(B)).value.toString()}catch(Y){return(0,c.toFileOperationResult)(Y)!==1&&this.j.error(this.t(G,(0,f.localize)(0,null,B.path,Y.message))),null}let q;try{q=JSON.parse(O)}catch{const te=[];(0,k.parse)(O,te);for(const ne of te)this.j.error(this.t(G,(0,f.localize)(1,null,B.path,ne.offset,ne.length,(0,m.getParseErrorMessage)(ne.error))));return null}return(0,k.getNodeType)(q)!=="object"?(this.j.error(this.t(G,(0,f.localize)(2,null,B.path))),null):q}async n(G,B,O){const q=await this.p(G,B,O);if(q)try{const Y=[],te=await this.r(q.default,Y);if(Y.length>0)return Y.forEach(L=>{this.j.error(this.t(G,(0,f.localize)(3,null,q.default?.path,(0,m.getParseErrorMessage)(L.error))))}),B;if((0,k.getNodeType)(q)!=="object")return this.j.error(this.t(G,(0,f.localize)(4,null,q.default?.path))),B;const ne=q.values||Object.create(null);return(0,T.localizeManifest)(B,ne,te)}catch{}return B}async p(G,B,O){const q=(0,u.joinPath)(G,"package.nls.json"),Y=(F,W)=>{W.forEach(U=>{this.j.error(this.t(G,(0,f.localize)(5,null,F?.path,(0,m.getParseErrorMessage)(U.error))))})},te=F=>{this.j.error(this.t(G,(0,f.localize)(6,null,F?.path)))},ne=`${B.publisher}.${B.name}`,L=O.translations[ne];if(L)try{const F=g.URI.file(L),W=(await this.i.readFile(F)).value.toString(),U=[],$=(0,k.parse)(W,U);return U.length>0?(Y(F,U),{values:void 0,default:q}):(0,k.getNodeType)($)!=="object"?(te(F),{values:void 0,default:q}):{values:$.contents?$.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let W;try{W=await this.s(G,O)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const U=(await this.i.readFile(W.localized)).value.toString(),$=[],V=(0,k.parse)(U,$);return $.length>0?(Y(W.localized,$),{values:void 0,default:W.original}):(0,k.getNodeType)(V)!=="object"?(te(W.localized),{values:void 0,default:W.original}):{values:V,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(G,B){if(G)try{const O=(await this.i.readFile(G)).value.toString();return(0,k.parse)(O,B)}catch{}}s(G,B){return new Promise((O,q)=>{const Y=te=>{const ne=(0,u.joinPath)(G,`package.nls.${te}.json`);this.i.exists(ne).then(L=>{L&&O({localized:ne,original:(0,u.joinPath)(G,"package.nls.json")});const F=te.lastIndexOf("-");F===-1?O({localized:(0,u.joinPath)(G,"package.nls.json"),original:null}):(te=te.substring(0,F),Y(te))})};if(B.devMode||B.pseudo||!B.language)return O({localized:(0,u.joinPath)(G,"package.nls.json"),original:null});Y(B.language)})}t(G,B){return`[${G.path}]: ${B}`}};se=ve([Q(1,h.IExtensionsProfileScannerService),Q(2,A.IUriIdentityService),Q(3,c.IFileService),Q(4,s.ILogService)],se);let oe=class extends se{constructor(G,B,O,q,Y,te){super(B,O,q,Y,te),this.y=G,this.v=this.B(new M.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(G){const B=await this.z();if(this.u=G,B&&B.input&&ie.equals(B.input,this.u))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.v.trigger(()=>this.D()),B.result.map(q=>(q.location=g.URI.revive(q.location),q));const O=await super.scanExtensions(G);return await this.C({input:G,result:O}),O}async z(){try{const G=await this.i.readFile(this.y),B=JSON.parse(G.value.toString());return{result:B.result,input:(0,r.revive)(B.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,C.getErrorMessage)(G))}return null}async C(G){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(G)))}catch(B){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,C.getErrorMessage)(B))}}async D(){if(!this.u)return;const G=await this.z();if(!G)return;const B=G.result,O=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(O,B))try{await this.i.del(this.y),this.w.fire()}catch(q){this.j.error(q)}}};oe=ve([Q(2,h.IExtensionsProfileScannerService),Q(3,A.IUriIdentityService),Q(4,c.IFileService),Q(5,s.ILogService)],oe);function ue(me,G){const B=(0,S.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:B,identifier:new D.ExtensionIdentifier(B),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:G,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=ue;class le extends H{constructor(G,B,O,q,Y,te,ne,L,F,W,U,$){super(G,B,(0,u.joinPath)(O,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(q,D.MANIFEST_CACHE_FOLDER),Y,te,ne,L,F,W,U,$),this.M=(async()=>{if(b.translationsConfigFile)try{const V=await this.r.readFile(g.URI.file(b.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}f(G){return this.M}}e.NativeExtensionsScannerService=le}),define(Z[266],ee([0,1,5,40,39,24,78,16,34,8]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let w=class extends C.AbstractExtensionsProfileScannerService{constructor(b,u,y,p,a,g){super(d.URI.file(b.extensionsPath),u,y,p,a,g)}};w=ve([Q(0,m.INativeEnvironmentService),Q(1,k.IFileService),Q(2,M.IUserDataProfilesService),Q(3,n.IUriIdentityService),Q(4,R.ITelemetryService),Q(5,I.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(Z[267],ee([0,1,8,34,78,123,16,6,5,21,39,40]),function(x,e,I,M,n,R,C,k,m,d,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends R.NativeExtensionsScannerService{constructor(y,p,a,g,f,E,S,D){super(I.URI.file(f.builtinExtensionsPath),I.URI.file(f.extensionsPath),f.userHome,I.URI.file(f.userDataPath),y,p,a,g,f,E,S,D)}};b=ve([Q(0,v.IUserDataProfilesService),Q(1,n.IExtensionsProfileScannerService),Q(2,C.IFileService),Q(3,m.ILogService),Q(4,M.INativeEnvironmentService),Q(5,d.IProductService),Q(6,w.IUriIdentityService),Q(7,k.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(Z[268],ee([0,1,15,2,14,9,4,61,8,31,42,34,5,40]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=class extends M.Disposable{constructor(a,g,f){super(),this.c=a,this.f=f,this.a=k.TernarySearchTree.forPaths(!C.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(a.appRoot),this.addValidFileRoot(a.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(a.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:a}=I.session;a.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(g,f)=>this.i(g,f)),a.protocol.interceptFileProtocol(n.Schemas.file,(g,f)=>this.h(g,f)),this.B((0,M.toDisposable)(()=>{a.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),a.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(a){const g=(0,R.normalize)(a);return this.a.get(g)?M.Disposable.None:(this.a.set(g,!0),(0,M.toDisposable)(()=>this.a.delete(g)))}h(a,g){const f=m.URI.parse(a.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${n.Schemas.file}: protocol (original URL: ${a.url})`),g({error:-3})}i(a,g){const f=this.j(a);let E;return this.c.crossOriginIsolated&&((0,R.basename)(f)==="workbench.html"||(0,R.basename)(f)==="workbench-dev.html"?E=n.COI.CoopAndCoep:E=n.COI.getHeadersFromQuery(a.url)),this.a.findSubstr(f)?g({path:f,headers:E}):this.b.has((0,R.extname)(f).toLowerCase())?g({path:f}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${a.url})`),g({error:-3}))}j(a){const g=m.URI.parse(a.url),f=n.FileAccess.uriToFileUri(g);return(0,R.normalize)(f.fsPath)}createIPCObjectUrl(){let a;const g=m.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),f=g.toString(),E=async()=>a;return w.validatedIpcMain.handle(f,E),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:g,update:S=>a=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),w.validatedIpcMain.removeHandler(f)}}}};y=ve([Q(0,v.INativeEnvironmentService),Q(1,u.IUserDataProfilesService),Q(2,b.ILogService)],y),e.ProtocolMainService=y}),define(Z[269],ee([0,1,15,42,7,3,2,14,10,105,28,20,5,66,67,69,44,40,38,65,94,18,48,108]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let i=class extends C.Disposable{constructor(o,l,r,h,P,A,T,N,z,H,ie){super(),this.i=o,this.j=l,this.k=r,this.l=h,this.m=P,this.n=A,this.r=T,this.s=N,this.t=z,this.u=H,this.v=ie,this.a=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.a.event),this.b=new n.Barrier,this.c=void 0,this.f=void 0,this.g=void 0,this.h=this.v.getValue("window.experimental.sharedProcessUseUtilityProcess"),this.F=void 0,this.G=void 0,this.w(),this.h&&this.n.info("[SharedProcess] using utility process")}w(){M.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(o,l)=>this.y(o,l)),M.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(o,l)=>this.z(o,l)),this.B(this.m.onWillShutdown(()=>this.C()))}async y(o,l){this.n.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.b.isOpen()||this.b.open(),await this.whenReady();const r=await this.connect();if(o.sender.isDestroyed())return r.close();o.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[r])}z(o,l){this.n.trace("[SharedProcess] onWorkerConnection",l);const r=new C.DisposableStore,h=A=>{!this.O()||(this.n.trace(`[SharedProcess] disposing worker (reason: '${A}')`,l),r.dispose(),this.D("vscode:electron-main->shared-process=disposeWorker",l))},P=I.BrowserWindow.fromId(l.reply.windowId);if(!P||P.isDestroyed()||P.webContents.isDestroyed()||!l.reply.channel){h("unavailable");return}r.add(R.Event.filter(this.m.onWillLoadWindow,A=>A.window.win===P)(()=>h("load"))),r.add(R.Event.fromNodeEventEmitter(P,"closed")(()=>h("closed"))),P.webContents.postMessage(l.reply.channel,l.reply.nonce,o.ports)}C(){if(this.n.trace("[SharedProcess] onWillShutdown"),this.g)this.g.postMessage("vscode:electron-main->shared-process=exit"),this.g=void 0;else{const o=this.c;if(!o)return;this.D("vscode:electron-main->shared-process=exit"),this.f&&(o.removeListener("close",this.f),this.f=void 0),setTimeout(()=>{try{this.n.trace("[SharedProcess] onWillShutdown window.close()"),o.close()}catch(l){this.n.trace(`[SharedProcess] onWillShutdown window.close() error: ${l}`)}this.c=void 0},0)}}D(o,...l){if(!this.O()){this.n.warn(`Sending IPC message to channel '${o}' for shared process that is destroyed`);return}try{this.c?.webContents.send(o,...l)}catch(r){this.n.warn(`Error sending IPC message to channel '${o}' of shared process: ${(0,a.toErrorMessage)(r)}`)}}whenReady(){return this.F||(this.F=(async()=>{await this.H;const o=new n.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=init-done",()=>o.complete()):M.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>o.complete()),await o.p,this.n.trace("[SharedProcess] Overall ready")})()),this.F}get H(){return this.G||(this.G=(async()=>{await this.b.wait(),this.I();const o=new n.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=ipc-ready",()=>o.complete()):M.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>o.complete()),await o.p,this.n.trace("[SharedProcess] IPC ready")})()),this.G}I(){this.h?this.J():this.L(),this.N()}J(){this.g=this.B(new S.UtilityProcess(this.n,t.NullTelemetryService,this.m));const o=(0,c.parseSharedProcessDebugPort)(this.k.args,this.k.isBuilt);let l;o.port&&(l=["--nolazy"],o.break?l.push(`--inspect-brk=${o.port}`):l.push(`--inspect=${o.port}`)),this.g.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.M(),execArgv:l})}L(){const o=this.B(this.u.createIPCObjectUrl());this.c=new I.BrowserWindow({show:!1,backgroundColor:this.t.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.k.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),o.update(this.M()),this.c.loadURL(k.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.k.isBuilt?"":"-dev"}.html`).toString(!0))}M(){return{machineId:this.i,windowId:this.c?.id??-1,appRoot:this.k.appRoot,codeCachePath:this.k.codeCachePath,profiles:{home:this.l.profilesHome,all:this.l.profiles},userEnv:this.j,args:this.k.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),product:u.default,policiesData:this.s.serialize()}}N(){this.c?(this.f=o=>{this.n.trace("SharedProcess#close prevented"),o.preventDefault(),this.c?.isVisible()&&this.c.hide()},this.c.on("close",this.f),this.c.webContents.on("render-process-gone",(o,l)=>this.a.fire({type:2,details:l})),this.c.on("unresponsive",()=>this.a.fire({type:1})),this.c.webContents.on("did-fail-load",(o,l,r)=>this.a.fire({type:3,details:{reason:r,exitCode:l}}))):this.g&&this.B(this.g.onCrash(o=>this.a.fire({type:2,details:{reason:o.reason,exitCode:o.code}})))}async connect(){return await this.H,this.g?this.g.connect():(0,d.connect)((0,m.assertIsDefined)(this.c))}async toggle(){await this.H,this.c&&(this.c.isVisible()?(this.c.webContents.closeDevTools(),this.c.hide()):(this.c.show(),this.c.webContents.openDevTools()))}isVisible(){return this.c?.isVisible()??!1}usingUtilityProcess(){return!!this.g}O(){const o=this.c;return o?!o.isDestroyed()&&!o.webContents.isDestroyed():!1}};i=ve([Q(2,w.IEnvironmentMainService),Q(3,g.IUserDataProfilesService),Q(4,v.ILifecycleMainService),Q(5,b.ILogService),Q(6,E.ILoggerMainService),Q(7,f.IPolicyService),Q(8,p.IThemeMainService),Q(9,y.IProtocolMainService),Q(10,D.IConfigurationService)],i),e.SharedProcess=i}),define(Z[95],ee([0,1,7,3,2,64,10,106,6,40]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,m.createDecorator)("storageService");var w;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var b;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function u(f){const E=f.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=u;class y extends n.Disposable{constructor(E={flushInterval:y.a}){super(),this.j=E,this.b=this.B(new M.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new M.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(E,S){if(S===e.TARGET_KEY){switch(E){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:S,target:this.F(E)[S]})}r(E){this.f.fire({reason:E})}get(E,S,D){return this.L(S)?.get(E,D)}getBoolean(E,S,D){return this.L(S)?.getBoolean(E,D)}getNumber(E,S,D){return this.L(S)?.getNumber(E,D)}store(E,S,D,t){if((0,C.isUndefinedOrNull)(S)){this.remove(E,D);return}this.t(()=>{this.u(E,D,t),this.L(D)?.set(E,S)})}remove(E,S){this.t(()=>{this.u(E,S,void 0),this.L(S)?.delete(E)})}t(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,S){const D=[],t=this.F(E);for(const c of Object.keys(t))t[c]===S&&D.push(c);return D}u(E,S,D){const t=this.F(S);typeof D=="number"?t[E]!==D&&(t[E]=D,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[E]=="number"&&(delete t[E],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(E){switch(E){case-1:return this.D;case 0:return this.z;default:return this.w}}G(E){const S=this.L(E);return S?u(S):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=w.NONE){this.f.fire({reason:E});const S=this.L(-1),D=this.L(0),t=this.L(1);switch(E){case w.NONE:await I.Promises.settled([S?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await I.Promises.settled([S?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return g(E,S,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(E,S){return this.r(w.NONE),(0,d.isUserDataProfile)(E)?this.N(E,S):this.O(E,S)}H(E,S){return!(E.id===S.id||p(S)&&p(E))}I(E,S,D,t){this.t(()=>{if(t)for(const[c,i]of E)S.set(c,i);else{const c=new Set;for(const[i,s]of E)c.add(i),S.get(i)!==s&&this.n(D,i);for(const[i]of S.items)c.has(i)||this.n(D,i)}})}}y.a=60*1e3,e.AbstractStorageService=y;function p(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class a extends y{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(E=>this.n(1,E))),this.B(this.P.onDidChangeStorage(E=>this.n(0,E))),this.B(this.p.onDidChangeStorage(E=>this.n(-1,E)))}L(E){switch(E){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(E){return!1}}e.InMemoryStorageService=a;async function g(f,E,S,D,t,c){const i=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,o=new Map;f.forEach((N,z)=>{s.set(z,N),o.set(z,i(N))});const l=new Map,r=new Map;E.forEach((N,z)=>{l.set(z,N),r.set(z,i(N))});const h=new Map,P=new Map;S.forEach((N,z)=>{h.set(z,N),P.set(z,i(N))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const A=[];if(s.forEach((N,z)=>{A.push({key:z,value:N})}),console.table(A),console.groupEnd(),console.log(o),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];l.forEach((z,H)=>{N.push({key:H,value:z})}),console.table(N),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${c})`);const T=[];h.forEach((N,z)=>{T.push({key:z,value:N})}),console.table(T),console.groupEnd(),console.log(P)}e.logStorage=g}),define(Z[270],ee([0,1,25,7,3,2,9,72,8,23,106,156,5,95,24,29]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class a extends R.Disposable{get storage(){return this.f}constructor(c,i){super(),this.j=c,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new M.DeferredPromise,this.whenInit=this.h.p,this.i=w.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===w.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(s=>this.b.fire({key:s}))),await this.m(c);const i=c.getBoolean(u.IS_NEW_KEY);i===void 0?c.set(u.IS_NEW_KEY,!0):i&&c.set(u.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=w.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===b.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,i){return this.f.get(c,i)}set(c,i){return this.f.set(c,i)}delete(c){return this.f.delete(c)}async close(){const c=new k.StopWatch(!1);await this.s(),c.stop(),c.elapsed()>a.a&&await this.r(c),this.c.fire()}async r(c){if(!!this.path)try{const i=(0,I.top)(Array.from(this.f.items.entries()).map(([o,l])=>({key:o,length:l.length})),(o,l)=>l.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),s=(await this.k.stat(m.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=w.StorageState.Closed,await this.f.close()}}a.a=2e3;class g extends a{get path(){if(!this.v.useInMemoryStorage)return(0,C.join)(this.u.globalStorageHome.fsPath,g.t)}constructor(c,i,s,o){super(s,o),this.u=c,this.v=i}async n(){return new w.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:w.StorageHint.STORAGE_IN_MEMORY})}}g.t="state.vscdb";class f extends g{constructor(c,i,s,o){super(c,i,s,o)}}e.ProfileStorageMain=f;class E extends g{constructor(c,i,s,o){super(i.defaultProfile,c,s,o)}async m(c){await super.m(c),this.z(c)}z(c){c.get(y.firstSessionDateStorageKey,void 0)===void 0&&c.set(y.firstSessionDateStorageKey,new Date().toUTCString());const s=c.get(y.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();c.set(y.lastSessionDateStorageKey,typeof s>"u"?null:s),c.set(y.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=E;class S extends a{get path(){if(!this.w.useInMemoryStorage)return(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(c,i,s,o,l){super(s,l),this.v=c,this.w=i,this.y=o}async n(){const{storageFilePath:c,wasCreated:i}=await this.C();return new w.Storage(new v.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.w.useInMemoryStorage?w.StorageHint.STORAGE_IN_MEMORY:i?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,C.join)(c,S.t);return await d.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await d.Promises.mkdir(c,{recursive:!0}),this.D(c),{storageFilePath:i,wasCreated:!0})}async D(c){let i;if((0,p.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const s=(0,C.join)(c,S.u);await d.Promises.exists(s)||await d.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}S.t="state.vscdb",S.u="workspace.json",e.WorkspaceStorageMain=S;class D extends a{get path(){}async n(){return new w.Storage(new w.InMemoryStorageDatabase,{hint:w.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(Z[271],ee([0,1,3,2,95]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends M.Disposable{constructor(k,m,d){super(),this.b=k,this.c=m,this.f=d;const w=this.B(new M.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>w.value=this.g(),onDidRemoveLastListener:()=>w.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new M.DisposableStore;return k.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(m,d)=>(m?m.push(d.key):m=[d.key],m),100)(m=>this.h(m))),k.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(m,d)=>{m||(m=new Map);let w=m.get(d.profile.id);return w||m.set(d.profile.id,w={profile:d.profile,keys:[],storage:d.storage}),w.keys.push(d.key),m},100)(m=>this.i(m))),k}h(k){const m=k.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],d=[];if(k=k.filter(w=>w!==n.TARGET_KEY),k.length){const w=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);d.push({profile:this.c.defaultProfile,changes:k.map(v=>({key:v,scope:0,target:w[v]}))})}this.j(m,d)}i(k){const m=[],d=new Map;for(const[w,v]of k.entries()){v.keys.includes(n.TARGET_KEY)&&m.push(v.profile);const b=v.keys.filter(u=>u!==n.TARGET_KEY);if(b.length){const u=(0,n.loadKeyTargets)(v.storage.storage);d.set(w,{profile:v.profile,changes:b.map(y=>({key:y,scope:0,target:u[y]}))})}}this.j(m,[...d.values()])}j(k,m){(k.length||m.length)&&this.a.fire({valueChanges:m,targetChanges:k})}listen(k,m,d){switch(m){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${m}`)}async call(k,m){throw new Error(`Call not found: ${m}`)}}e.ProfileStorageChangesListenerChannel=R}),define(Z[272],ee([0,1,8,34,16,5,33,39,40,10,116]),function(x,e,I,M,n,R,C,k,m,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let v=class dt extends m.UserDataProfilesService{constructor(p,a,g,f,E){super(g,f,a,E),this.O=p,this.P=g}I(){return this.O.getItem(dt.b,[]).map(a=>({...a,location:(0,d.isString)(a.location)?this.r.extUri.joinPath(this.profilesHome,a.location):I.URI.revive(a.location)}))}L(){const p=this.O.getItem(dt.c,{});return this.O.getItem(dt.a,!1)?p:this.H(p)}N(){return this.r.extUri.joinPath(I.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v.a="profileAssociationsMigration",v=ve([Q(0,C.IStateReadService),Q(1,k.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,n.IFileService),Q(4,R.ILogService)],v),e.UserDataProfilesReadonlyService=v;let b=class rt extends v{constructor(p,a,g,f,E){super(p,a,g,f,E),this.U=p}J(p){p.length?this.U.setItem(rt.b,p.map(a=>({...a,location:this.r.extUri.basename(a.location)}))):this.U.removeItem(rt.b)}I(){const p=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(p),this.U.setItem("userDataProfilesMigration",!0)),p}M(p){p.emptyWindows||p.workspaces?this.U.setItem(rt.c,p):this.U.removeItem(rt.c)}L(){const p="workspaceAndProfileInfo",a=this.U.getItem(p,void 0);if(a){this.U.removeItem(p);const f=a.reduce((E,{workspace:S,profile:D})=>(E[I.URI.revive(S).toString()]=I.URI.revive(D).toString(),E),{});this.U.setItem(rt.c,{workspaces:f})}const g=super.L();return this.U.getItem(rt.a,!1)||(this.M(g),this.U.setItem(rt.a,!0)),g}};b=ve([Q(0,C.IStateService),Q(1,k.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,n.IFileService),Q(4,R.ILogService)],b),e.UserDataProfilesService=b;let u=class extends b{constructor(p,a,g,f){super(new w.StateService(0,a,f,g),p,a,g,f)}async init(){return await this.U.init(),super.init()}};u=ve([Q(0,k.IUriIdentityService),Q(1,M.INativeEnvironmentService),Q(2,n.IFileService),Q(3,R.ILogService)],u),e.ServerUserDataProfilesService=u}),define(Z[52],ee([0,1,34,16,6,5,39,40,272,33]),function(x,e,I,M,n,R,C,k,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,n.refineServiceDecorator)(k.IUserDataProfilesService);let w=class extends m.UserDataProfilesService{constructor(b,u,y,p,a){super(b,u,y,p,a)}getAssociatedEmptyWindows(){const b=[];for(const u of this.u.emptyWindows.keys())b.push({id:u});return b}};w=ve([Q(0,d.IStateService),Q(1,C.IUriIdentityService),Q(2,I.INativeEnvironmentService),Q(3,M.IFileService),Q(4,R.ILogService)],w),e.UserDataProfilesMainService=w}),define(Z[96],ee([0,1,8,50,3,2,34,16,6,20,5,95,270,40,52,39]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,m.createDecorator)("storageMainService");let a=class extends R.Disposable{constructor(E,S,D,t,c,i){super(),this.c=E,this.f=S,this.g=D,this.h=t,this.i=c,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.n)E.join("profileStorage",S.close());for(const[,S]of this.r)E.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.i.exists(E.profile.globalStorageHome)||await this.i.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const S=this.n.get(E.profile.id);S&&E.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const E=new b.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,M.once)(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),E}profileStorage(E){if((0,v.isProfileUsingDefaultStorage)(E))return this.applicationStorage;let S=this.n.get(E.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),S=this.p(E),this.n.set(E.id,S);const D=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:E})));(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.n.delete(E.id),D.dispose()})}return S}p(E){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.ProfileStorageMain(E,this.k(),this.c,this.i)}workspaceStorage(E){let S=this.r.get(E.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),S=this.s(E),this.r.set(E.id,S),(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.r.delete(E.id)})),S}s(E){return this.a===2?new b.InMemoryStorageMain(this.c,this.i):new b.WorkspaceStorageMain(E,this.k(),this.c,this.f,this.i)}isUsed(E){const S=I.URI.file(E);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!D.path&&this.j.extUri.isEqualOrParent(I.URI.file(D.path),S))return!0;return!1}};a=ve([Q(0,w.ILogService),Q(1,C.IEnvironmentService),Q(2,y.IUserDataProfilesMainService),Q(3,d.ILifecycleMainService),Q(4,k.IFileService),Q(5,p.IUriIdentityService)],a),e.StorageMainService=a,e.IApplicationStorageMainService=(0,m.createDecorator)("applicationStorageMainService");let g=class extends v.AbstractStorageService{constructor(E,S){super(),this.p=E,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(E){if(E===-1)return this.s.applicationStorage.storage}M(E){if(E===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};g=ve([Q(0,u.IUserDataProfilesService),Q(1,e.IStorageMainService)],g),e.ApplicationStorageMainService=g}),define(Z[273],ee([0,1,2,20,52,29,7,30]),function(x,e,I,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let m=class extends I.Disposable{constructor(w,v,b){super(),this.a=v,this.b=b,this.B(w.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(w.onBeforeCloseWindow(u=>this.c(u))),this.B(new C.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(w){const v=this.f(w),b=this.a.getProfileForWorkspace(v);b?.isTransient&&(this.a.unsetWorkspace(v,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(w){return w.openedWorkspace??(0,R.toWorkspaceIdentifier)(w.backupPath,w.isExtensionDevelopmentHost)}g(){const w=this.a.getAssociatedEmptyWindows();if(w.length===0)return;const v=this.b.getWindows().map(b=>this.f(b));for(const b of w)v.some(u=>u.id===b.id)||this.a.unsetWorkspace(b,!1)}};m=ve([Q(0,M.ILifecycleMainService),Q(1,n.IUserDataProfilesMainService),Q(2,k.IWindowsMainService)],m),e.UserDataProfilesHandler=m}),define(Z[124],ee([0,1,19,8,29]),function(x,e,I,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(m,d,w){for(const b of m){const u=b.openedWorkspace;if((0,n.isWorkspaceIdentifier)(u)){const y=await w(u);if(y){if(y.folders.some(p=>I.extUriBiasedIgnorePathCase.isEqualOrParent(d,p.uri)))return b}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(d,u.configPath))return b}}const v=m.filter(b=>(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(d,b.openedWorkspace.uri));if(v.length)return v.sort((b,u)=>-(b.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function C(m,d){for(const w of m)if((0,n.isWorkspaceIdentifier)(w.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.configPath,d)||(0,n.isSingleFolderWorkspaceIdentifier)(w.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(w.openedWorkspace.uri,d))return w}e.findWindowOnWorkspaceOrFolder=C;function k(m,d){const w=v=>d.some(b=>I.extUriBiasedIgnorePathCase.isEqual(M.URI.file(b),M.URI.file(v)));for(const v of m)if(v.config?.extensionDevelopmentPath?.some(b=>w(b)))return v}e.findWindowOnExtensionDevelopmentPath=k}),define(Z[274],ee([0,1,15,2,4,19,8,18,20,5,33,30,122,29]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class wt extends M.Disposable{get state(){return this.b}constructor(S,D,t,c,i){super(),this.g=S,this.h=D,this.i=t,this.j=c,this.k=i,this.b=p(this.h.getItem(wt.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(S=>this.p(S)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(S=>{S.newCount-S.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(S=>this.p(S))}m(){this.f=!0,this.n()}n(){const S=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.r(i),D.lastActiveWindow.uiState.mode===3&&S.add(D.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.r(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(S.has(D.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):S.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.r(i);return s.uiState.mode===3&&(S.has(s.uiState.display)?n.isMacintosh&&s.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):S.add(s.uiState.display)),s}));const c=g(D);this.h.setItem(wt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(S){if(this.i.quitRequested)return;const D=this.r(S);S.isExtensionDevelopmentHost&&!S.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!S.isExtensionDevelopmentHost&&S.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,u.isWorkspaceIdentifier)(S.openedWorkspace)&&t.workspace?.id===S.openedWorkspace.id,i=(0,u.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&t.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(t.folderUri,S.openedWorkspace.uri);(c||i)&&(t.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(S){return{windowId:S.id,workspace:(0,u.isWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace.uri:void 0,backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.serializeWindowState()}}getNewWindowState(S){const D=this.s(S),t=this.k.getValue("window");if(D.mode===3){let c;D.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(D.mode=1)}return D}s(S){const D=this.g.getLastActiveWindow();if(!S.extensionTestsPath){if(!!S.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=S.workspace;if((0,u.isWorkspaceIdentifier)(l)){const h=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===l.id).map(P=>P.uiState);if(h.length)return h[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(l)){const h=this.state.openedWindows.filter(P=>P.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(P.folderUri,l.uri)).map(P=>P.uiState);if(h.length)return h[0]}else if(S.backupPath){const h=this.state.openedWindows.filter(P=>P.backupPath===S.backupPath).map(P=>P.uiState);if(h.length)return h[0]}const r=this.c||this.state.lastActiveWindow;if(!D&&r)return r.uiState}let t;const c=I.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(n.isMacintosh){const l=I.screen.getCursorScreenPoint();t=I.screen.getDisplayNearestPoint(l)}!t&&D&&(t=I.screen.getDisplayMatching(D.getBounds())),t||(t=I.screen.getPrimaryDisplay()||c[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const s=this.k.getValue("window");let o=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&D){const l=D.serializeWindowState();l.mode===3?i.mode=3:i=l,o=i.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(S){if(this.g.getWindows().length===0)return S;S.x=typeof S.x=="number"?S.x:0,S.y=typeof S.y=="number"?S.y:0;const D=this.g.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===S.x||t.y===S.y);)S.x+=30,S.y+=30;return S}};y.a="windowsState",y=ve([Q(0,v.IWindowsMainService),Q(1,w.IStateService),Q(2,m.ILifecycleMainService),Q(3,d.ILogService),Q(4,k.IConfigurationService)],y),e.WindowsStateHandler=y;function p(E){const S={openedWindows:[]},D=E||{openedWindows:[]};return D.lastActiveWindow&&(S.lastActiveWindow=a(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(S.lastPluginDevelopmentHostWindow=a(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(S.openedWindows=D.openedWindows.map(t=>a(t))),S}e.restoreWindowsState=p;function a(E){const S={uiState:E.uiState};return E.backupPath&&(S.backupPath=E.backupPath),E.remoteAuthority&&(S.remoteAuthority=E.remoteAuthority),E.folder&&(S.folderUri=C.URI.parse(E.folder)),E.workspaceIdentifier&&(S.workspace={id:E.workspaceIdentifier.id,configPath:C.URI.parse(E.workspaceIdentifier.configURIPath)}),S}function g(E){return{lastActiveWindow:E.lastActiveWindow&&f(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&f(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(S=>f(S))}}e.getWindowsStateStoreData=g;function f(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(Z[97],ee([0,1,32,43,129,45,14,9,4,19,8,6,55,29]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function y(P){return P.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function p(P){return P.hasOwnProperty("folderUri")}e.isRecentFolder=p;function a(P){return P.hasOwnProperty("fileUri")}e.isRecentFile=a;function g(P){return f(P)||E(P)}e.isStoredWorkspaceFolder=g;function f(P){const A=P;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function E(P){const A=P;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function S(P,A,T,N,z){if(P.scheme!==N.scheme)return{name:T,uri:P.toString(!0)};let H=A?void 0:z.relativePath(N,P);if(H!==void 0)H.length===0?H=".":m.isWindows&&(H=D(H));else if(P.scheme===C.Schemas.file)H=P.fsPath,m.isWindows&&(H=D(H));else if(z.isEqualAuthority(P.authority,N.authority))H=P.path;else return{name:T,uri:P.toString(!0)};return{name:T,path:H}}e.getStoredWorkspaceFolder=S;function D(P){return P=(0,R.normalizeDriveLetter)(P),(0,I.isUNC)(P)||(P=(0,I.toSlashes)(P)),P}function t(P,A,T){const N=[],z=new Set,H=T.dirname(A);for(const ie of P){let se;if(f(ie))ie.path&&(se=T.resolvePath(H,ie.path));else if(E(ie))try{se=w.URI.parse(ie.uri),se.path[0]!==k.posix.sep&&(se=se.with({path:k.posix.sep+se.path}))}catch(oe){console.warn(oe)}if(se){const oe=T.getComparisonKey(se);if(!z.has(oe)){z.add(oe);const ue=ie.name||T.basenameOrAuthority(se);N.push(new u.WorkspaceFolder({uri:se,name:ue,index:N.length},ie))}}}return N}e.toWorkspaceFolders=t;function c(P,A,T,N,z){const H=i(A,P),ie=z.dirname(A),se=z.dirname(N),oe=[];for(const G of H.folders){const B=f(G)?z.resolvePath(ie,G.path):w.URI.parse(G.uri);let O;T?O=!1:O=!f(G)||(0,k.isAbsolute)(G.path),oe.push(S(B,O,G.name,se,z))}const ue={insertSpaces:!1,tabSize:4,eol:m.isLinux||m.isMacintosh?`
`:`\r
`},le=n.setProperty(P,["folders"],oe,ue);let me=n.applyEdits(P,le);return(0,d.isEqualAuthority)(H.remoteAuthority,(0,b.getRemoteAuthority)(N))&&(me=n.applyEdits(me,n.removeProperty(me,["remoteAuthority"],ue))),me}e.rewriteWorkspaceFileForNewLocation=c;function i(P,A){const T=M.parse(A);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>g(N));else throw new Error(`${P} looks like an invalid workspace file.`);return T}function s(P){return P.workspace&&typeof P.workspace=="object"&&typeof P.workspace.id=="string"&&typeof P.workspace.configPath=="string"}function o(P){return typeof P.folderUri=="string"}function l(P){return typeof P.fileUri=="string"}function r(P,A){const T={workspaces:[],files:[]};if(P){const N=function(H,ie){for(let se=0;se<H.length;se++)try{ie(H[se],se)}catch(oe){A.warn(`Error restoring recent entry ${JSON.stringify(H[se])}: ${oe.toString()}. Skip entry.`)}},z=P;Array.isArray(z.entries)&&N(z.entries,H=>{const ie=H.label,se=H.remoteAuthority;s(H)?T.workspaces.push({label:ie,remoteAuthority:se,workspace:{id:H.workspace.id,configPath:w.URI.parse(H.workspace.configPath)}}):o(H)?T.workspaces.push({label:ie,remoteAuthority:se,folderUri:w.URI.parse(H.folderUri)}):l(H)&&T.files.push({label:ie,remoteAuthority:se,fileUri:w.URI.parse(H.fileUri)})})}return T}e.restoreRecentlyOpened=r;function h(P){const A={entries:[]};for(const T of P.workspaces)p(T)?A.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):A.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of P.files)A.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return A}e.toStoreData=h}),define(Z[98],ee([0,1,81,14,4,19]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(d){function w(){let v=d.scheme===M.Schemas.file?(0,R.originalFSPath)(d):d.toString();return n.isLinux||(v=v.toLowerCase()),(0,I.createHash)("md5").update(v).digest("hex")}return{id:w(),configPath:d}}e.getWorkspaceIdentifier=C;function k(d,w){function v(){if(d.scheme!==M.Schemas.file)return(0,I.createHash)("md5").update(d.toString()).digest("hex");if(!w)return;let u;return n.isLinux?u=w.ino:n.isMacintosh?u=w.birthtime.getTime():n.isWindows&&(typeof w.birthtimeMs=="number"?u=Math.floor(w.birthtimeMs):u=w.birthtime.getTime()),(0,I.createHash)("md5").update(d.fsPath).update(u?String(u):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:d}}e.getSingleFolderWorkspaceIdentifier=k;function m(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=m}),define(Z[275],ee([0,1,81,32,14,9,4,19,23,187,18,28,33,16,5,186,29,98]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let f=class vt{constructor(S,D,t,c){this.j=S,this.k=D,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,s)=>(0,M.isEqual)(i,s,!C.isLinux)}}async initialize(){const S=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(S.emptyWindows),this.d=await this.u((0,d.deserializeWorkspaceInfos)(S)),this.e=await this.v((0,d.deserializeFolderInfos)(S)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.HotExitConfiguration.OFF}q(){return this.s()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(S,D){this.d.some(c=>S.workspace.id===c.workspace.id)||(this.d.push(S),this.C());const t=(0,R.join)(this.c,S.workspace.id);return D?this.t(t,D).then(()=>t):t}async t(S,D){if(await m.Promises.exists(S)&&await this.z(S),await m.Promises.exists(D))try{await m.Promises.rename(D,S)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(S){return this.e.some(D=>this.h.isEqual(S.folderUri,D.folderUri))||(this.e.push(S),this.C()),(0,R.join)(this.c,this.D(S))}registerEmptyWindowBackup(S){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.backupFolder))||(this.g.push(S),this.C()),(0,R.join)(this.c,S.backupFolder)}async u(S){if(!Array.isArray(S))return[];const D=new Set,t=[];for(const c of S){const i=c.workspace;if(!(0,a.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const s=(0,R.join)(this.c,i.id);await this.B(s)?i.configPath.scheme!==n.Schemas.file||await m.Promises.exists(i.configPath.fsPath)?t.push(c):await this.z(s):await this.x(s)}}return t}async v(S){if(!Array.isArray(S))return[];const D=[],t=new Set;for(const c of S){const i=c.folderUri,s=this.h.getComparisonKey(i);if(!t.has(s)){t.add(s);const o=(0,R.join)(this.c,this.D(c));await this.B(o)?i.scheme!==n.Schemas.file||await m.Promises.exists(i.fsPath)?D.push(c):await this.z(o):await this.x(o)}}return D}async w(S){if(!Array.isArray(S))return[];const D=[],t=new Set;for(const c of S){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const s=(0,R.join)(this.c,i);await this.B(s)?D.push(c):await this.x(s)}}return D}async x(S){try{await m.Promises.rm(S,m.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let S=(0,g.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.id));)S=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:S.id}}async z(S){const D=this.y(),t=(0,R.join)(this.c,D.backupFolder);try{await m.Promises.rename(S,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const S=[];for(const D of this.d)await this.A(D)&&S.push(D);for(const D of this.e)await this.A(D)&&S.push(D);return S}A(S){let D;return(0,d.isEmptyWindowBackupInfo)(S)?D=(0,R.join)(this.c,S.backupFolder):(0,p.isFolderBackupInfo)(S)?D=(0,R.join)(this.c,this.D(S)):D=(0,R.join)(this.c,S.workspace.id),this.B(D)}async B(S){try{const D=await m.Promises.readdir(S);for(const t of D)try{if((await m.Promises.readdir((0,R.join)(S,t))).length>0)return!0}catch{}}catch{}return!1}C(){const S={workspaces:this.d.map(({workspace:D,remoteAuthority:t})=>{const c={id:D.id,configURIPath:D.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:D,remoteAuthority:t})=>{const c={folderUri:D.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:t})=>{const c={backupFolder:D};return t&&(c.remoteAuthority=t),c})};this.m.setItem(vt.a,S)}D(S){const D=S.folderUri;let t;return D.scheme===n.Schemas.file?t=C.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,I.createHash)("md5").update(t).digest("hex")}};f.a="backupWorkspaces",f=ve([Q(0,v.IEnvironmentMainService),Q(1,w.IConfigurationService),Q(2,y.ILogService),Q(3,b.IStateService)],f),e.BackupMainService=f}),define(Z[53],ee([0,1,15,3,43,2,14,9,19,10,23,185,63,57,28,6,5,52,124,29,97,98]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let t=class extends R.Disposable{constructor(i,s,o,l,r){super(),this.g=i,this.h=s,this.i=o,this.j=l,this.k=r,this.a=this.B(new M.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new M.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await w.Promises.readdir(this.c.fsPath)).map(s=>(0,m.joinPath)(this.c,s,E.UNTITLED_WORKSPACE_NAME));for(const s of i){const o=(0,D.getWorkspaceIdentifier)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:o,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,s=>w.Promises.readFile(s,"utf8"))}l(i,s){if(!!this.m(i)&&i.scheme===C.Schemas.file)try{const o=s(i.fsPath);return o instanceof Promise?o.then(l=>this.n(i,l),l=>{}):this.n(i,o)}catch{return}}m(i){return(0,E.isUntitledWorkspace)(i,this.g)||(0,E.hasWorkspaceFileExtension)(i)}n(i,s){try{const o=this.p(i,s),l=(0,D.getWorkspaceIdentifier)(i);return{id:l.id,configPath:l.configPath,folders:(0,S.toWorkspaceFolders)(o.folders,l.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(i,s){const o=(0,n.parse)(s);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(l=>(0,S.isStoredWorkspaceFolder)(l));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,s){const{workspace:o,storedWorkspace:l}=this.r(i,s),r=o.configPath.fsPath;return await w.Promises.mkdir((0,k.dirname)(r),{recursive:!0}),await w.Promises.writeFile(r,JSON.stringify(l,null,"	")),this.f.push({workspace:o,remoteAuthority:s}),o}r(i=[],s){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,m.joinPath)(this.c,o),r=(0,m.joinPath)(l,E.UNTITLED_WORKSPACE_NAME),h=[];for(const P of i)h.push((0,S.getStoredWorkspaceFolder)(P.uri,!0,P.name,l,m.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(r),storedWorkspace:{folders:h,remoteAuthority:s}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,E.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const s=(0,m.originalFSPath)(i.configPath);try{await w.Promises.rm((0,k.dirname)(s));const o=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await w.Promises.exists(o)&&await w.Promises.writeFile((0,k.join)(o,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==i.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${s} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,s,o){if(!i||!i.win||!i.isReady||!await this.t(i,s,o))return;const r=await this.u(i,(0,D.getWorkspaceIdentifier)(o));if(!!r)return this.b.fire({window:i,workspace:r.workspace}),r}async t(i,s,o){return o?(0,E.isWorkspaceIdentifier)(i.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,f.findWindowOnWorkspaceOrFolder)(s,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,m.basename)(o)),detail:(0,v.localize)(2,null)},(0,d.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,s){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:s,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:s,remoteAuthority:i.remoteAuthority})),(0,E.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=s,i.config.backupPath=o,{workspace:s,backupPath:o}}};t=ve([Q(0,y.IEnvironmentMainService),Q(1,a.ILogService),Q(2,g.IUserDataProfilesMainService),Q(3,b.IBackupMainService),Q(4,u.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(Z[125],ee([0,1,15,42,22,6,30,29,53,10,5]),function(x,e,I,M,n,R,C,k,m,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let v=class{constructor(u,y,p){this.a=u,this.b=y,this.c=p}async getRemoteDiagnostics(u){const y=this.a.getWindows();return(await Promise.all(y.map(async a=>{const g=a.remoteAuthority;if(!g)return;const f=`vscode:getDiagnosticInfoResponse${a.id}`,E={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.f(a):void 0};return new Promise(S=>{a.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:f,args:E}),M.validatedIpcMain.once(f,(D,t)=>{t||S({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),S(t)}),setTimeout(()=>{S({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(a=>!!a)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const u=[];for(const y of I.BrowserWindow.getAllWindows()){const p=this.a.getWindowById(y.id);p?u.push(await this.d(p)):u.push(this.e(y))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(u){const y=await this.f(u),p=(0,d.assertIsDefined)(u.win);return this.e(p,y,u.remoteAuthority)}e(u,y=[],p){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:y,remoteAuthority:p}}async f(u){const y=[],p=u.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(p))y.push(p.uri);else if((0,k.isWorkspaceIdentifier)(p)){const a=await this.b.resolveLocalWorkspace(p.configPath);a&&a.folders.forEach(f=>{y.push(f.uri)})}return y}};v=ve([Q(0,C.IWindowsMainService),Q(1,m.IWorkspacesManagementMainService),Q(2,w.ILogService)],v),e.DiagnosticsMainService=v}),define(Z[58],ee([0,1,46,15,26,150,54,3,2,14,9,4,8,102,84,23,100,175,57,28,6,20,5,21,69,30,29,53,17,233,226,33]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c,i,s,o,l,r,h,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,S.createDecorator)("nativeHostMainService");let T=class extends m.Disposable{constructor(z,H,ie,se,oe,ue,le,me,G,B){super(),this.a=z,this.b=H,this.c=ie,this.f=se,this.g=oe,this.h=ue,this.i=le,this.j=me,this.k=G,this.l=B,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,O=>O.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:O,x:q,y:Y})=>({windowId:O.id,x:q,y:Y})),({windowId:O})=>!!this.b.getWindowById(O)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-maximize",(O,q)=>q.id),O=>!!this.b.getWindowById(O)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-unmaximize",(O,q)=>q.id),O=>!!this.b.getWindowById(O)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-blur",(O,q)=>q.id),O=>!!this.b.getWindowById(O)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),O=>!!O),O=>O.id),k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-focus",(O,q)=>q.id),O=>!!this.b.getWindowById(O))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(M.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(M.screen,"display-metrics-changed",(O,q,Y)=>Y),O=>!(Array.isArray(O)&&O.length===1&&O[0]==="workArea")),k.Event.fromNodeEventEmitter(M.screen,"display-added"),k.Event.fromNodeEventEmitter(M.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(H=>({id:H.id,workspace:H.openedWorkspace??(0,o.toWorkspaceIdentifier)(H.backupPath,H.isExtensionDevelopmentHost),title:H.win?.getTitle()??"",filename:H.getRepresentedFilename(),dirty:H.isDocumentEdited()}))}async getWindowCount(z){return this.b.getWindowCount()}async getActiveWindowId(z){const H=M.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(H)return H.id}openWindow(z,H,ie){return Array.isArray(H)?this.n(z,H,ie):this.p(z,H)}async n(z,H,ie=Object.create(null)){H.length>0&&await this.b.open({context:5,contextWindowId:z,urisToOpen:H,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p(z,H){await this.b.openEmptyWindow({context:5,contextWindowId:z},H)}async toggleFullScreen(z){this.w(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.w(z)?.handleTitleDoubleClick()}async isMaximized(z){const H=this.w(z);return H?.win?H.win.isMaximized():!1}async maximizeWindow(z){const H=this.w(z);H?.win&&H.win.maximize()}async unmaximizeWindow(z){const H=this.w(z);H?.win&&H.win.unmaximize()}async minimizeWindow(z){const H=this.w(z);H?.win&&H.win.minimize()}async updateWindowControls(z,H){const ie=this.w(z);ie&&ie.updateWindowControls(H)}async focusWindow(z,H){H&&typeof H.windowId=="number"&&(z=H.windowId),this.w(z)?.focus({force:H?.force??!1})}async setMinimumSize(z,H,ie){const se=this.w(z);if(se?.win){const[oe,ue]=se.win.getSize(),[le,me]=se.win.getMinimumSize(),[G,B]=[H??le,ie??me],[O,q]=[Math.max(oe,G),Math.max(ue,B)];(le!==G||me!==B)&&se.win.setMinimumSize(G,B),(oe!==O||ue!==q)&&se.win.setSize(O,q)}}async saveWindowSplash(z,H){this.j.saveWindowSplash(z,H)}async installShellCommand(z){const{source:H,target:ie}=await this.r();try{const{symbolicLink:se}=await p.SymlinkSupport.stat(H);if(se&&!se.dangling){const oe=await(0,u.realpath)(H);if(ie===oe)return}await p.Promises.unlink(H)}catch(se){if(se.code!=="ENOENT")throw se}try{await p.Promises.symlink(ie,H)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:oe}=await this.showMessageBox(z,{type:"info",message:(0,g.localize)(0,null,this.i.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(oe===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${H}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,H))}}}async uninstallShellCommand(z){const{source:H}=await this.r();try{await p.Promises.unlink(H)}catch(ie){switch(ie.code){case"EACCES":{const{response:se}=await this.showMessageBox(z,{type:"info",message:(0,g.localize)(4,null,this.i.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(se===0)try{const oe=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(oe)}catch{throw new Error((0,g.localize)(7,null,H))}break}case"ENOENT":break;default:throw ie}}}async r(){const z=(0,w.resolve)(this.g.appRoot,"bin","code"),H=`/usr/local/bin/${this.i.applicationName}`;if(!await p.Promises.exists(z))throw new Error((0,g.localize)(8,null,z));return{source:H,target:z}}async showMessageBox(z,H){return this.c.showMessageBox(H,this.s(z))}async showSaveDialog(z,H){return this.c.showSaveDialog(H,this.s(z))}async showOpenDialog(z,H){return this.c.showOpenDialog(H,this.s(z))}s(z){const H=this.w(z);if(H?.win)return H.win}async pickFileFolderAndOpen(z,H){const ie=await this.c.pickFileFolder(H);ie&&await this.t(await Promise.all(ie.map(async se=>await p.SymlinkSupport.existsDirectory(se)?{folderUri:b.URI.file(se)}:{fileUri:b.URI.file(se)})),H,z)}async pickFolderAndOpen(z,H){const ie=await this.c.pickFolder(H);ie&&await this.t(ie.map(se=>({folderUri:b.URI.file(se)})),H,z)}async pickFileAndOpen(z,H){const ie=await this.c.pickFile(H);ie&&await this.t(ie.map(se=>({fileUri:b.URI.file(se)})),H,z)}async pickWorkspaceAndOpen(z,H){const ie=await this.c.pickWorkspace(H);ie&&await this.t(ie.map(se=>({workspaceUri:b.URI.file(se)})),H,z)}async t(z,H,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:z,forceNewWindow:H.forceNewWindow})}async showItemInFolder(z,H){M.shell.showItemInFolder(H)}async setRepresentedFilename(z,H){this.w(z)?.setRepresentedFilename(H)}async setDocumentEdited(z,H){this.w(z)?.setDocumentEdited(H)}async openExternal(z,H){return v.isLinuxSnap?this.u(H):M.shell.openExternal(H),!0}u(z){const H=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,M.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=H,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(z,H){return M.shell.trashItem(H)}async isAdmin(){let z;return v.isWindows?z=(await new Promise((H,ie)=>{x(["native-is-elevated"],H,ie)}))():z=process.getuid()===0,z}async writeElevated(z,H,ie,se){const oe=await new Promise((ue,le)=>{x(["@vscode/sudo-prompt"],ue,le)});return new Promise((ue,le)=>{const me=[`"${this.v}"`];se?.unlock&&me.push("--file-chmod"),me.push("--file-write",`"${H.fsPath}"`,`"${ie.fsPath}"`);const G={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,w.join)((0,w.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};oe.exec(me.join(" "),G,(B,O,q)=>{O&&this.h.trace(`[sudo-prompt] received stdout: ${O}`),q&&this.h.trace(`[sudo-prompt] received stderr: ${q}`),B?le(B):ue(void 0)})})}get v(){return v.isWindows?this.g.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,w.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,w.join)((0,w.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,w.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,w.join)(this.g.appRoot,"bin","code"):(0,w.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,h.hasWSLFeatureInstalled)()}async killProcess(z,H,ie){process.kill(H,ie)}async readClipboardText(z,H){return M.clipboard.readText(H)}async writeClipboardText(z,H,ie){return M.clipboard.writeText(H,ie)}async readClipboardFindText(z){return M.clipboard.readFindText()}async writeClipboardFindText(z,H){return M.clipboard.writeFindText(H)}async writeClipboardBuffer(z,H,ie,se){return M.clipboard.writeBuffer(H,Buffer.from(ie.buffer),se)}async readClipboardBuffer(z,H){return r.VSBuffer.wrap(M.clipboard.readBuffer(H))}async hasClipboard(z,H,ie){return M.clipboard.has(H,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){M.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){M.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){M.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){M.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){M.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,H){this.w(z)?.updateTouchBar(H)}async notifyReady(z){this.w(z)?.setReady()}async relaunch(z,H){return this.f.relaunch(H)}async reload(z,H){const ie=this.w(z);if(ie){if((0,o.isWorkspaceIdentifier)(ie.openedWorkspace)){const se=ie.openedWorkspace.configPath;if(se.scheme===d.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,H){const ie=this.w(H);if(ie?.win)return ie.win.close()}async quit(z){const H=this.b.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&H.win?H.win.close():this.f.quit()}async exit(z,H){await this.f.kill(H)}async resolveProxy(z,H){const se=this.w(z)?.win?.webContents?.session;if(se)return se.resolveProxy(H)}findFreePort(z,H,ie,se,oe=1){return(0,a.findFreePort)(H,ie,se,oe)}async openDevTools(z,H){const ie=this.w(z);ie?.win&&ie.win.webContents.openDevTools(H)}async toggleDevTools(z){const H=this.w(z);H?.win&&H.win.webContents.toggleDevTools()}async sendInputEvent(z,H){const ie=this.w(z);ie?.win&&(H.type==="mouseDown"||H.type==="mouseUp")&&ie.win.webContents.sendInputEvent(H)}async enableSandbox(z,H){H?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(z,H,ie){const se=this.w(z);if(!se||!se.win)throw new Error;return await new P.WindowProfiler(se.win,H,this.h).inspect(ie)}async windowsGetStringRegKey(z,H,ie,se){if(!v.isWindows)return;const oe=await new Promise((ue,le)=>{x(["@vscode/windows-registry"],ue,le)});try{return oe.GetStringRegKey(H,ie,se)}catch{return}}w(z){if(typeof z=="number")return this.b.getWindowById(z)}};ve([C.memoize],T.prototype,"v",null),T=ve([Q(1,s.IWindowsMainService),Q(2,f.IDialogMainService),Q(3,D.ILifecycleMainService),Q(4,E.IEnvironmentMainService),Q(5,t.ILogService),Q(6,c.IProductService),Q(7,i.IThemeMainService),Q(8,A.IStateService),Q(9,l.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(Z[276],ee([0,1,15,42,26,2,14,4,103,173,87,125,57,28,6,5,58,66,21,67,77,32,10,33]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");const i="issue.processExplorerWindowState";let s=class kt{constructor(r,h,P,A,T,N,z,H,ie,se){this.g=r,this.h=h,this.i=P,this.j=A,this.k=T,this.l=N,this.m=z,this.n=H,this.o=ie,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){M.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[h,P]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),A=await this.j.getSystemInfo(h,P);this.r(r,"vscode:issueSystemInfoResponse",A)}),M.validatedIpcMain.on("vscode:listProcesses",async r=>{const h=[];try{h.push({name:(0,d.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(A=>{(0,w.isRemoteDiagnosticError)(A)?h.push({name:A.hostName,rootProcess:A}):A.processes&&h.push({name:A.hostName,rootProcess:A.processes})})}catch(P){this.i.error(`Listing processes failed: ${P}`)}this.r(r,"vscode:listProcessesResponse",h)}),M.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{if(this.b){const{response:h}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(1,null),buttons:[(0,d.localize)(2,null),(0,d.localize)(3,null)]},this.b);this.r(r,"vscode:issueReporterClipboardResponse",h===0)}}),M.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const h=await this.v();this.r(r,"vscode:issuePerformanceInfoResponse",h)}),M.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:r}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(4,null),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]},this.b);r===0&&this.b&&(this.b.destroy(),this.b=null)}}),M.validatedIpcMain.on("vscode:workbenchCommand",(r,h)=>{const{id:P,from:A,args:T}=h;let N;switch(A){case"issueReporter":N=this.c;break;case"processExplorer":N=this.f;break;default:throw new Error(`Unexpected command source: ${A}`)}N?.webContents.send("vscode:runAction",{id:P,from:A,args:T})}),M.validatedIpcMain.on("vscode:openExternal",(r,h)=>{this.m.openExternal(void 0,h)}),M.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.b?.close()}),M.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.d?.close()}),M.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const h=await this.k.getMainDiagnostics();this.r(r,"vscode:windowsInfoResponse",h.windows)})}r(r,h,...P){r.sender.isDestroyed()||r.sender.send(h,...P)}async openReporter(r){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const h=new R.DisposableStore,P=h.add(this.n.createIPCObjectUrl()),A=this.u(this.c,700,800);this.b=this.t(A,P,{backgroundColor:r.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),P.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:r,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:g.default}),this.b.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,h.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,h.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(r){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const h=new R.DisposableStore,P=h.add(this.n.createIPCObjectUrl()),A=this.p.getItem(i,void 0),T=o(A)?A:this.u(this.f,800,500);this.d=this.t(T,P,{backgroundColor:r.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),P.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:r,product:g.default}),this.d.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,h.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,h.dispose())});const N=()=>{if(!this.d)return;const z=this.d.getSize(),H=this.d.getPosition();if(!z||!H)return;const ie={width:z[0],height:z[1],x:H[0],y:H[1]};this.p.setItem(i,ie)};this.d.on("moved",N),this.d.on("resized",N)}this.d&&this.s(this.d)}s(r){r.isMinimized()&&r.restore(),r.focus()}t(r,h,P,A){const T=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:P.title,backgroundColor:P.backgroundColor||kt.a,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${h.resource.toString()}`,`--vscode-window-kind=${A}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,S.zoomLevelToZoomFactor)(P.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:P.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}async getSystemStatus(){const[r,h]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(r,h)}u(r,h,P){let A;const T=I.screen.getAllDisplays();if(T.length===1)A=T[0];else{if(k.isMacintosh){const H=I.screen.getCursorScreenPoint();A=I.screen.getDisplayNearestPoint(H)}!A&&r&&(A=I.screen.getDisplayMatching(r.getBounds())),A||(A=I.screen.getPrimaryDisplay()||T[0])}const N=A.bounds,z={width:h,height:P,x:N.x+N.width/2-h/2,y:N.y+N.height/2-P/2};return N.width>0&&N.height>0&&(z.x<N.x&&(z.x=N.x),z.y<N.y&&(z.y=N.y),z.x>N.x+N.width&&(z.x=N.x),z.y>N.y+N.height&&(z.y=N.y),z.width>N.width&&(z.width=N.width),z.height>N.height&&(z.height=N.height)),z}async v(){try{const[r,h]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(r,h)}catch(r){throw this.i.warn("issueService#getPerformanceInfo ",r.message),r}}async stopTracing(){if(!this.h.args.trace)return;const r=await I.contentTracing.stopRecording(`${(0,D.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,d.localize)(9,null),detail:(0,d.localize)(10,null,r),buttons:[(0,d.localize)(11,null)]},(0,t.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,r)}};s.a="#1E1E1E",s=ve([Q(1,u.IEnvironmentMainService),Q(2,p.ILogService),Q(3,w.IDiagnosticsService),Q(4,v.IDiagnosticsMainService),Q(5,b.IDialogMainService),Q(6,a.INativeHostMainService),Q(7,E.IProtocolMainService),Q(8,f.IProductService),Q(9,c.IStateService)],s),e.IssueMainService=s;function o(l){return typeof l!="object"||l===null?!1:"x"in l&&"y"in l&&"width"in l&&"height"in l}}),define(Z[277],ee([0,1,22,18,28,20,5,58,21,56,24,49,93]),function(x,e,I,M,n,R,C,k,m,d,w,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends b.AbstractUpdateService{constructor(p,a,g,f,E,S,D,t){super(p,a,f,E,S,t),this.e=g,this.t=D}r(p){return(0,b.createUpdateURL)(`linux-${process.arch}`,p,this.k)}s(p){!this.a||(this.d(v.State.CheckingForUpdates(p)),this.i.request({url:this.a},I.CancellationToken.None).then(d.asJson).then(a=>{!a||!a.url||!a.version||!a.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(a))}).then(void 0,a=>{this.j.error(a),this.e.publicLog2("update:notAvailable",{explicit:!!p});const g=p?a.message||a:void 0;this.d(v.State.Idle(1,g))}))}async n(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.t.openExternal(void 0,p.update.url),this.d(v.State.Idle(1))}};u=ve([Q(0,R.ILifecycleMainService),Q(1,M.IConfigurationService),Q(2,w.ITelemetryService),Q(3,n.IEnvironmentMainService),Q(4,d.IRequestService),Q(5,C.ILogService),Q(6,k.INativeHostMainService),Q(7,m.IProductService)],u),e.LinuxUpdateService=u}),define(Z[278],ee([0,1,46,41,26,7,22,54,9,8,136,23,18,28,16,20,5,58,21,56,24,49,93]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(l,r=1e3){for(;!l();)await(0,R.timeout)(r)}let i;function s(){return typeof i>"u"&&(i=M.existsSync(m.join(m.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends t.AbstractUpdateService{get cachePath(){const r=m.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(r,{recursive:!0}).then(()=>r)}constructor(r,h,P,A,T,N,z,H,ie){super(r,h,A,T,N,ie),this.t=P,this.u=z,this.v=H}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(r){let h="win32";return process.arch!=="ia32"&&(h+=`-${process.arch}`),s()===1?h+="-archive":this.k.target==="user"&&(h+="-user"),(0,t.createUpdateURL)(h,r,this.k)}s(r){!this.a||(this.d(D.State.CheckingForUpdates(r)),this.i.request({url:this.a},C.CancellationToken.None).then(E.asJson).then(h=>{const P=s();return!h||!h.url||!h.version||!h.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!r}),this.d(D.State.Idle(P)),Promise.resolve(null)):P===1?(this.d(D.State.AvailableForDownload(h)),Promise.resolve(null)):(this.d(D.State.Downloading(h)),this.A(h.version).then(()=>this.z(h.version).then(A=>v.Promises.exists(A).then(T=>{if(T)return Promise.resolve(A);const N=h.url,z=h.hash,H=`${A}.tmp`;return this.i.request({url:N},C.CancellationToken.None).then(ie=>this.u.writeFile(d.URI.file(H),ie.stream)).then(z?()=>(0,w.checksum)(H,h.hash):()=>{}).then(()=>v.Promises.rename(H,A)).then(()=>A)})).then(A=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:A},T&&h.supportsFastUpdate?this.k.target==="user"?this.o():this.d(D.State.Downloaded(h)):this.d(D.State.Ready(h))})))}).then(void 0,h=>{this.j.error(h),this.t.publicLog2("update:notAvailable",{explicit:!!r});const P=r?h.message||h:void 0;this.d(D.State.Idle(s(),P))}))}async n(r){r.update.url&&this.v.openExternal(void 0,r.update.url),this.d(D.State.Idle(s()))}async z(r){const h=await this.cachePath;return m.join(h,`CodeSetup-${this.k.quality}-${r}.exe`)}async A(r=null){const h=r?N=>!new RegExp(`${this.k.quality}-${r}\\.exe$`).test(N):()=>!0,P=await this.cachePath,T=(await v.Promises.readdir(P)).filter(h).map(async N=>{try{await v.Promises.unlink(m.join(P,N))}catch{}});await Promise.all(T)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const r=this.state.update;this.d(D.State.Updating(r));const h=await this.cachePath;this.e.updateFilePath=m.join(h,`CodeSetup-${this.k.quality}-${r.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(s()))});const A=`${this.k.win32MutexName}-ready`,T=await new Promise((N,z)=>{x(["windows-mutex"],N,z)});c(()=>T.isActive(A)).then(()=>this.d(D.State.Ready(r)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?M.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return s()}async _applySpecificUpdate(r){if(this.state.type!=="idle")return;const h=this.g.getValue("update.enableWindowsBackgroundUpdates"),P={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!h};this.d(D.State.Downloading(P)),this.e={packagePath:r},h?this.k.target==="user"?this.o():this.d(D.State.Downloaded(P)):this.d(D.State.Ready(P))}};ve([k.memoize],o.prototype,"cachePath",null),o=ve([Q(0,p.ILifecycleMainService),Q(1,b.IConfigurationService),Q(2,S.ITelemetryService),Q(3,u.IEnvironmentMainService),Q(4,E.IRequestService),Q(5,a.ILogService),Q(6,y.IFileService),Q(7,g.INativeHostMainService),Q(8,f.IProductService)],o),e.Win32UpdateService=o}),define(Z[279],ee([0,1,15,7,22,44,3,2,14,9,64,4,8,181,63,18,57,28,62,16,20,5,21,67,241,96,24,135,69,77,30,29,53,122,126,38,33,52,58,243,118,48,92,26,119,65]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c,i,s,o,l,r,h,P,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.NAVIGATING=1]="NAVIGATING",ne[ne.READY=2]="READY"})(Y||(Y={}));let te=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const L=this.Q.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.Q.getProfileForWorkspace(this.config.workspace??(0,A.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(L,F,W,U,$,V,j,K,J,re,de,Ce,Re,De,Oe,$e,fe,pe,Me,_,ce){super(),this.M=F,this.N=W,this.O=U,this.P=$,this.Q=V,this.R=j,this.S=K,this.U=J,this.W=re,this.X=de,this.Y=Ce,this.Z=Re,this.ab=De,this.bb=Oe,this.db=$e,this.eb=fe,this.fb=pe,this.gb=Me,this.hb=_,this.ib=ce,this.c=this.B(new C.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new C.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new C.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.Emitter),this.onDidClose=this.h.event,this.j=this.B(new C.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.u=void 0,this.v=void 0,this.C=!1,this.D=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.B(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let he=!1;{const[Ie,Ae]=this.ub(L.state);this.s=Ie,this.M.trace("window#ctor: using window state",Ie);const Te=this.s.mode===0||this.s.mode===3;typeof ot.b>"u"&&(ot.b=this.hb.getItem("window.experimental.useSandbox",!1));const Fe=this.W.getValue("window");typeof Fe?.experimental?.useSandbox=="boolean"?he=Fe.experimental.useSandbox:this.eb.quality==="stable"&&ot.b?he=!0:he=typeof this.eb.quality=="string"&&this.eb.quality!=="stable",this.n=he;const je={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.X.getBackgroundColor(),minWidth:h.WindowMinimumSize.WIDTH,minHeight:h.WindowMinimumSize.HEIGHT,show:!Te,title:this.eb.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,h.zoomLevelToZoomFactor)(Fe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...he?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?je.icon=(0,d.join)(this.O.appRoot,"resources/linux/code.png"):v.isWindows&&!this.O.isBuilt&&(je.icon=(0,d.join)(this.O.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.Bb()&&(je.fullscreenable=!1),v.isMacintosh&&(je.acceptFirstMouse=!0,Fe?.clickThroughInactive===!1&&(je.acceptFirstMouse=!1));const ze=v.isMacintosh&&Fe?.nativeTabs===!0;ze&&(je.tabbingIdentifier=this.eb.nameShort);const We=(0,h.getTitleBarStyle)(this.W)==="custom";if(We&&(je.titleBarStyle="hidden",v.isMacintosh||(je.frame=!1),(0,h.useWindowControlsOverlay)(this.W))){const He=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),X=z.Color.fromHex(He).isDarker()?"#FFFFFF":"#000000";je.titleBarOverlay={height:29,color:He,symbolColor:X},this.C=!0}if((0,w.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(je),(0,w.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&We&&this.l.setSheetOffset(22),We&&(v.isWindows&&(0,h.useWindowControlsOverlay)(this.W)||v.isMacintosh)){const He=this.hb.getItem(ot.a);He&&this.updateWindowControls({height:He})}v.isWindows&&We&&this.l.hookWindowMessage(278,()=>{const[X,ae]=this.l.getPosition(),ge=I.screen.getCursorScreenPoint(),be=ge.x-X,we=ge.y-ae;return(()=>!(be>30&&we>=0&&we<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:be,y:we})),0}),(v.isMacintosh||v.isWindows)&&Ae&&(!ze||I.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(He=>typeof He=="number")&&this.l.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),Te&&((0,w.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.s.mode===3&&this.xb(!0),this.l.show(),(0,w.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(he)}setRepresentedFilename(L){v.isMacintosh?this.l.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.w}setDocumentEdited(L){v.isMacintosh&&this.l.setDocumentEdited(L),this.z=L}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.z}focus(L){v.isMacintosh&&L?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.D.length;)this.D.pop()(this);this.f.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.D.push(L)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(L=>{function F(){W.dispose(),U.dispose(),L()}const W=this.onDidClose(()=>F()),U=this.onWillLoad(()=>F())})}kb(L){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:L})),this.l.webContents.on("render-process-gone",(W,U)=>this.nb(2,{...U,sandboxed:L})),this.l.webContents.on("did-fail-load",(W,U,$)=>this.nb(3,{reason:$,exitCode:U,sandboxed:L})),this.l.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.r=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",W=>{this.r&&(this.r.maximized=!0),I.app.emit("browser-window-maximize",W,this.l)}),this.l.on("unmaximize",W=>{this.r&&(this.r.maximized=!1),I.app.emit("browser-window-unmaximize",W,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.B(this.W.onDidChangeConfiguration(W=>this.rb(W))),this.B(this.Y.onDidDeleteUntitledWorkspace(W=>this.qb(W)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(W,U)=>{const $=await this.mb();U({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,$)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(L,F){switch(L){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:L,reason:F?.reason,code:F?.exitCode,sandboxed:F?.sandboxed?"1":"0"}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:W,checkboxChecked:U}=await this.bb.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null),(0,u.localize)(2,null)],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),checkboxLabel:this.r?.workspace?(0,u.localize)(5,null):void 0},this.l);if(W!==2){const $=W===0;await this.pb($,U)}}else if(L===2)if(v.isWindows&&F?.reason==="launch-failed"&&F.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(F);else{let W;F?W=(0,u.localize)(7,null,F.reason,F.exitCode??"<unknown>"):W=(0,u.localize)(6,null);const{response:U,checkboxChecked:$}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,u.localize)(8,null):(0,u.localize)(9,null),(0,u.localize)(10,null)],message:W,detail:this.r?.workspace?(0,u.localize)(11,null):(0,u.localize)(12,null),checkboxLabel:this.r?.workspace?(0,u.localize)(13,null):void 0},this.l),V=U===0;await this.pb(V,$)}break}}async ob(L){const F=[],W=(0,me.isInternalTelemetry)(this.eb,this.W);if((0,me.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&F.push(new ue.OneDataSystemAppender(W,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const{installSourcePath:$}=this.O,V=await(0,O.resolveMachineId)(this.hb),j={appenders:F,sendErrorTelemetry:!1,commonProperties:(0,G.resolveCommonProperties)(this.R,(0,B.release)(),(0,B.hostname)(),process.arch,this.eb.commit,this.eb.version,V,W,$),piiPaths:(0,me.getPiiPathsFromEnvironment)(this.O)};await new le.TelemetryService(j,this.W,this.eb).publicLog2("windowadminerror",{reason:L.reason,code:L.exitCode})}const{response:U}=await this.bb.showMessageBox({type:"error",buttons:[(0,u.localize)(14,null),(0,u.localize)(15,null)],message:(0,u.localize)(16,null),detail:(0,u.localize)(17,null,this.eb.nameLong)},this.l);U===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(F.map($=>$.flush())),await this.pb(!1,!1)}async pb(L,F){const W=this.r?.workspace;if(F&&W)try{const U=this.U.workspaceStorage(W);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.M.error(U)}if(this.j.fire(),this.l?.destroy(),L&&this.r){let U,$;(0,A.isSingleFolderWorkspaceIdentifier)(W)?U={folderUri:W.uri}:(0,A.isWorkspaceIdentifier)(W)?U={workspaceUri:W.configPath}:$=!0;const[V]=await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.O.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});V.focus()}}qb(L){this.r?.workspace?.id===L.id&&(this.r.workspace=void 0)}rb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const F=this.Cb();F!==this.t&&(this.t=F,this.Db(F))}if(!L||L.affectsConfiguration("http.proxy")){let F=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.G||W!==this.H)){this.G=F,this.H=W;const U=F||"",$=W?`${W},<local>`:"<local>";this.M.trace(`Setting proxy to '${U}', bypassing '${$}'`),this.l.webContents.session.setProxy({proxyRules:U,proxyBypassRules:$,pacScript:""})}}}addTabbedWindow(L){v.isMacintosh&&L.win&&this.l.addTabbedWindow(L.win)}load(L,F=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!F.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(L,F),this.jb===0?this.r=L:this.J=L,this.jb=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.B(new M.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:L.workspace,reason:F.isReload?3:W?2:1})}sb(L,F){const W=(this.r??this.J)?.userEnv;if(W){const U=(0,f.isLaunchedFromCli)(W)&&!(0,f.isLaunchedFromCli)(L.userEnv),$=this.isExtensionDevelopmentHost;(U||$)&&(L.userEnv={...W,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(L["disable-extensions"]=F.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.l.isMaximized(),L.partsSplash=this.X.getWindowSplash(),(0,w.mark)("code/willOpenNewWindow"),L.perfMarks=(0,w.getMarks)(),this.I.update(L)}async reload(L){const F=Object.assign({},this.r);F.workspace=await this.tb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&L&&(F.verbose=L.verbose,F.debugId=L.debugId,F.extensionEnvironment=L.extensionEnvironment,F["inspect-extensions"]=L["inspect-extensions"],F["inspect-brk-extensions"]=L["inspect-brk-extensions"],F["extensions-dir"]=L["extensions-dir"]),F.accessibilitySupport=I.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.P.serialize(),F.continueOn=this.O.continueOn,F.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},F.logLevel=this.N.getLogLevel(),F.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async tb(L){if((0,A.isWorkspaceIdentifier)(L.workspace)){const F=L.workspace.configPath;if(F.scheme===m.Schemas.file&&!await this.R.exists(F))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(L.workspace)){const F=L.workspace.uri;if(F.scheme===m.Schemas.file&&!await this.R.exists(F))return}return L.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let W;try{W=I.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,N.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.s.width||U.width,height:this.s.height||U.height,x:this.s.x||0,y:this.s.y||0}}const L=Object.create(null);let F;if(!v.isMacintosh&&this.l.isMaximized()?F=0:F=1,F===0?L.mode=0:L.mode=1,F===1||F===0){let W;F===1?W=this.getBounds():W=this.l.getNormalBounds(),L.x=W.x,L.y=W.y,L.width=W.width,L.height=W.height}return L}updateWindowControls(L){if(L.height&&this.hb.setItem(ot.a,L.height),v.isWindows&&this.C)this.l.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(v.isMacintosh&&L.height!==void 0){const F=(L.height-15)/2;this.l.setTrafficLightPosition({x:F,y:F})}}ub(L){(0,w.mark)("code/willRestoreCodeWindowState");let F=!1;if(L)try{const W=I.screen.getAllDisplays();F=W.length>1,L=this.vb(L,W)}catch(W){this.M.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,w.mark)("code/didRestoreCodeWindowState"),[L||(0,N.defaultWindowState)(),F]}vb(L,F){if(this.M.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const $=this.wb(F[0]);if($){let V=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!$||(L.x<$.x&&(L.x=$.x),L.y<$.y&&(L.y=$.y))};this.M.trace("window#validateWindowState: 1 monitor working area",$),V(),L.width>$.width&&(L.width=$.width),L.height>$.height&&(L.height=$.height),L.x>$.x+$.width-128&&(L.x=$.x+$.width-L.width),L.y>$.y+$.height-128&&(L.y=$.y+$.height-L.height),V()}return L}if(L.display&&L.mode===3){const $=F.find(V=>V.id===L.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,N.defaultWindowState)(3);return V.x=$.bounds.x,V.y=$.bounds.y,V}}let W,U;try{W=I.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),U=this.wb(W)}catch{}if(W&&U&&L.x+L.width>U.x&&L.y+L.height>U.y&&L.x<U.x+U.width&&L.y<U.y+U.height)return this.M.trace("window#validateWindowState: multi-monitor working area",U),L}wb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,F]=this.l.getPosition(),[W,U]=this.l.getSize();return{x:L,y:F,width:W,height:U}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(L){this.Bb()?this.yb(L):this.Ab(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.t&&this.Db(this.t,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.u=="boolean"?this.u:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(L){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(L)}zb(L){v.isMacintosh&&(this.u=L,this.v=new M.DeferredPromise,Promise.race([this.v.p,(0,M.timeout)(1e3)]).finally(()=>this.u=void 0)),this.l.setFullScreen(L)}Ab(L){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(L),this.l.webContents.focus()}Bb(){const L=this.W.getValue("window");return!L||typeof L.nativeFullScreen!="boolean"||L.nativeTabs?!0:L.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let L=(0,h.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Db(L,F=!0){v.isMacintosh||(L==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,u.localize)(18,null)),L==="hidden"?setTimeout(()=>{this.Eb(L)}):this.Eb(L))}Eb(L){const F=this.isFullScreen;switch(L){case"classic":this.l.setMenuBarVisibility(!F),this.l.autoHideMenuBar=F;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(L,F,...W){this.isReady?this.send(L,...W):this.ready().then(()=>{F.isCancellationRequested||this.send(L,...W)})}send(L,...F){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.l.webContents.send(L,...F)}catch(W){this.M.warn(`Error sending IPC message to channel '${L}' of window ${this.k}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(L){!v.isMacintosh||this.F.forEach((F,W)=>{const U=L[W];F.segments=this.Hb(U)})}Fb(){if(!!v.isMacintosh){for(let L=0;L<10;L++){const F=this.Gb();this.F.push(F)}this.l.setTouchBar(new I.TouchBar({items:this.F}))}}Gb(L=[]){const F=this.Hb(L),W=new I.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:W.segments[U].id,from:"touchbar"})}});return W}Hb(L=[]){return L.map(W=>{let U;W.icon&&!l.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===m.Schemas.file&&(U=I.nativeImage.createFromPath(b.URI.revive(W.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:U?void 0:$,icon:U}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};te.a="windowControlHeight",te.b=void 0,te=ve([Q(1,D.ILogService),Q(2,q.ILoggerMainService),Q(3,g.IEnvironmentMainService),Q(4,H.IPolicyService),Q(5,se.IUserDataProfilesMainService),Q(6,E.IFileService),Q(7,s.IApplicationStorageMainService),Q(8,s.IStorageMainService),Q(9,p.IConfigurationService),Q(10,r.IThemeMainService),Q(11,T.IWorkspacesManagementMainService),Q(12,y.IBackupMainService),Q(13,o.ITelemetryService),Q(14,a.IDialogMainService),Q(15,S.ILifecycleMainService),Q(16,t.IProductService),Q(17,c.IProtocolMainService),Q(18,P.IWindowsMainService),Q(19,ie.IStateService),Q(20,oe.INativeHostMainService)],te),e.CodeWindow=te}),define(Z[79],ee([0,1,15,25,7,3,45,2,14,4,19,8,23,184,6,20,5,96,97,29,53,35]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,s,o,l){super(),this.f=i,this.g=s,this.h=o,this.j=l,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let s=[],o=[];for(const r of i)if((0,f.isRecentWorkspace)(r))!this.g.isUntitledWorkspace(r.workspace)&&!this.r(s,r.workspace)&&s.push(r);else if((0,f.isRecentFolder)(r))this.s(s,r.folderUri)||s.push(r);else{const h=this.t(o,r.fileUri),P=r.fileUri.scheme===m.Schemas.file&&tt.y.indexOf((0,w.basename)(r.fileUri))>=0;!h&&!P&&(o.push(r),d.isWindows&&r.fileUri.scheme===m.Schemas.file&&I.app.addRecentDocument(r.fileUri.fsPath))}const l=await this.l({workspaces:s,files:o});s=l.workspaces,o=l.files,s.length>tt.a&&(s.length=tt.a),o.length>tt.a&&(o.length=tt.a),await this.n({workspaces:s,files:o}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const s=h=>{const P=this.p(h);for(const A of i)if(w.extUriBiasedIgnorePathCase.isEqual(A,P))return!1;return!0},o=await this.getRecentlyOpened(),l=o.workspaces.filter(s),r=o.files.filter(s);(l.length!==o.workspaces.length||r.length!==o.files.length)&&(await this.n({files:r,workspaces:l}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const s=new D.ResourceMap(r=>w.extUriBiasedIgnorePathCase.getComparisonKey(r));if(i?.workspaces)for(const r of i.workspaces)s.set(this.p(r),r);const o=new D.ResourceMap(r=>w.extUriBiasedIgnorePathCase.getComparisonKey(r));if(i?.files)for(const r of i.files)o.set(this.p(r),r);const l=await this.m();for(const r of l.workspaces){const h=s.get(this.p(r));h?h.label=h.label??r.label:s.set(this.p(r),r)}for(const r of l.files){const h=o.get(this.p(r));h?h.label=h.label??r.label:o.set(this.p(r),r)}return{workspaces:[...s.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const s=this.j.get(tt.b,-1);if(typeof s=="string")try{i=JSON.parse(s)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,f.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,f.toStoreData)(i)),-1,1)}p(i){return(0,f.isRecentFolder)(i)?i.folderUri:(0,f.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,s){return!!i.find(o=>(0,f.isRecentWorkspace)(o)&&o.workspace.id===s.id)}s(i,s){return!!i.find(o=>(0,f.isRecentFolder)(o)&&w.extUriBiasedIgnorePathCase.isEqual(o.folderUri,s))}t(i,s){return!!i.find(o=>w.extUriBiasedIgnorePathCase.isEqual(o.fileUri,s))}async C(){!d.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!d.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const s=[];for(const r of I.app.getJumpListSettings().removedItems){const h=r.args;if(h){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);P&&s.push(v.URI.parse(P[2]))}}await this.removeRecentlyOpened(s);let o=!1;const l=(0,M.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.w).map(r=>{const h=(0,f.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:P,description:A}=this.F(h,r.label);let T;return v.URI.isUri(h)?T=`--folder-uri "${h.toString()}"`:(o=!0,T=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:A.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:o?(0,u.localize)(2,null):(0,u.localize)(3,null),items:l})}i.push({type:"recent"});try{const s=I.app.setJumpList(i);s&&s!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${s}`)}catch(s){this.f.warn("updateWindowsJumpList#setJumpList",s)}}F(i,s){if(s)return{title:(0,C.splitName)(s).name,description:s};if(v.URI.isUri(i))return{title:(0,w.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,u.localize)(4,null),description:""};let o=(0,w.basename)(i.configPath);return o.endsWith(E.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-E.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,C.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!d.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),s=[];let o=0;for(let r=0;r<i.workspaces.length&&o<tt.u;r++){const h=this.p(i.workspaces[r]);if(h.scheme===m.Schemas.file){const P=(0,w.originalFSPath)(h);await b.Promises.exists(P)&&(s.push(P),o++)}}const l=[];for(let r=0;r<i.files.length&&o<tt.v;r++){const h=this.p(i.files[r]);if(h.scheme===m.Schemas.file){const P=(0,w.originalFSPath)(h);if(tt.y.includes((0,w.basename)(h))||s.includes(P))continue;await b.Promises.exists(P)&&(l.push(P),o++)}}l.reverse().forEach(r=>I.app.addRecentDocument(r)),s.reverse().forEach(r=>I.app.addRecentDocument(r))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ve([Q(0,a.ILogService),Q(1,S.IWorkspacesManagementMainService),Q(2,p.ILifecycleMainService),Q(3,g.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(Z[280],ee([0,1,15,7,22,45,4,8,174,18,28,20,5,221,58,21,33,24,49,77,30,79]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class bt{constructor(o,l,r,h,P,A,T,N,z,H,ie){this.n=o,this.o=l,this.p=r,this.q=h,this.r=P,this.s=A,this.t=T,this.u=N,this.v=z,this.w=H,this.x=ie,this.m=Object.create(null),this.g=new M.RunOnceScheduler(()=>this.E(),0),this.h=new M.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.isMacintosh||(0,E.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(bt.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(A,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(A,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(A,T,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(A,T,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(A,T,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const r=this.x.reportIssueUrl;r&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(r,"openReportIssues"));const h=this.x.licenseUrl;h&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.language){const A=h.indexOf("?")>0?"&":"?";this.Z(`${h}${A}lang=${C.language}`,"openLicenseUrl")}else this.Z(h,"openLicenseUrl")});const P=this.x.privacyStatementUrl;P&&h&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(P,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!C.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,l){this.k=o.menus,this.l=o.keybindings,this.t.setItem(bt.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){!C.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){!C.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=I.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(C.isMacintosh?new I.Menu:null);return}const l=new I.Menu;let r;if(C.isMacintosh){const P=new I.Menu;r=new I.MenuItem({label:this.x.nameShort,submenu:P}),this.I(P),l.append(r)}if(C.isMacintosh&&!this.c){this.c=!0;const P=new I.Menu;P.append(new I.MenuItem({label:this.bb(m.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(P)}if(this.K("File")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(1,null)),submenu:P});this.M(P,"File"),l.append(A)}if(this.K("Edit")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(2,null)),submenu:P});this.M(P,"Edit"),l.append(A)}if(this.K("Selection")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(3,null)),submenu:P});this.M(P,"Selection"),l.append(A)}if(this.K("View")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(4,null)),submenu:P});this.M(P,"View"),l.append(A)}if(this.K("Go")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(5,null)),submenu:P});this.M(P,"Go"),l.append(A)}if(this.K("Run")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(6,null)),submenu:P});this.M(P,"Run"),l.append(A)}if(this.K("Terminal")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(7,null)),submenu:P});this.M(P,"Terminal"),l.append(A)}let h;if(this.K("Window")){const P=new I.Menu;h=new I.MenuItem({label:this.bb(m.localize(8,null)),submenu:P,role:"window"}),this.S(P)}if(h&&l.append(h),this.K("Help")){const P=new I.Menu,A=new I.MenuItem({label:this.bb(m.localize(9,null)),submenu:P,role:"help"});this.M(P,"Help"),l.append(A)}l.items&&l.items.length>0?I.Menu.setApplicationMenu(l):I.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const l=this.U(m.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),r=this.T();let h;if(this.K("Preferences")){const se=new I.Menu;this.M(se,"Preferences"),h=new I.MenuItem({label:this.bb(m.localize(11,null)),submenu:se})}const P=new I.Menu,A=new I.MenuItem({label:m.localize(12,null),role:"services",submenu:P}),T=new I.MenuItem({label:m.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new I.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new I.MenuItem({label:m.localize(15,null),role:"unhide"}),H=new I.MenuItem(this.Y("workbench.action.quit",{label:m.localize(16,null,this.x.nameLong),click:async(se,oe,ue)=>{const le=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),ie=[l];ie.push(...r),h&&ie.push(i(),h),ie.push(i(),A,i(),T,N,z,i(),H),ie.forEach(se=>o.append(se))}async J(o){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(o)){const{response:r}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[m.localize(17,null),m.localize(18,null)],message:m.localize(19,null)});return r===0}return!0}K(o){if(!C.isMacintosh&&(0,E.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,l){l.forEach(r=>{if((0,u.isMenubarMenuItemSeparator)(r))o.append(i());else if((0,u.isMenubarMenuItemSubmenu)(r)){const h=new I.Menu,P=new I.MenuItem({label:this.bb(r.label),submenu:h});this.L(h,r.submenu.items),o.append(P)}else(0,u.isMenubarMenuItemRecentAction)(r)?o.append(this.O(r)):(0,u.isMenubarMenuItemAction)(r)&&(r.id==="workbench.action.showAboutDialog"&&this.N(o),C.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[r.id]?o.append(new I.MenuItem(this.Y(r.id,{label:this.bb(r.label),click:this.m[r.id]}))):o.append(this.U(r.label,r.id,!1,r.checked)):o.append(this.U(r.label,r.id,r.enabled!==!1,!!r.checked)):o.append(this.U(r.label,r.id,r.enabled!==!1,!!r.checked)))})}M(o,l){this.k&&this.k[l]&&this.L(o,this.k[l].items)}N(o){const l=this.T();l.length&&(l.forEach(r=>o.append(r)),o.append(i()))}O(o){const l=k.URI.revive(o.uri),r=o.id,h=r==="openRecentFile"?{fileUri:l}:r==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new I.MenuItem(this.Y(r,{label:o.label,click:async(P,A,T)=>{const N=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[h],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(o){return!!(o&&(!C.isMacintosh&&(o.ctrlKey||o.shiftKey)||C.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,l,r){const h={label:this.bb(o),role:r,enabled:!0};return new I.MenuItem(this.X(l,h))}S(o){const l=new I.MenuItem({label:m.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),r=new I.MenuItem({label:m.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),h=new I.MenuItem({label:m.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),P=this.U(m.localize(23,null),"workbench.action.switchWindow"),A=[];this.C&&(A.push(i()),A.push(this.U(m.localize(24,null),"workbench.action.newWindowTab")),A.push(this.R(m.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.R(m.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.R(m.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.R(m.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,r,i(),P,...A,i(),h].forEach(T=>o.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(m.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:m.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(m.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:m.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(m.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:m.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(m.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,l,r,h){const P=this.bb(o),A=typeof l=="function"?l:(ie,se,oe)=>{const ue=ie?ie.userSettingsLabel:null;let le=l;Array.isArray(l)&&(le=this.P(oe)?l[1]:l[0]),ue&&oe.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:le})},T=typeof r=="boolean"?r:this.p.getWindowCount()>0,N=typeof h=="boolean"?h:!1,z={label:P,click:A,enabled:T};N&&(z.type="checkbox",z.checked=N);let H;return typeof l=="string"?H=l:Array.isArray(l)&&(H=l[0]),C.isMacintosh&&(H==="editor.action.clipboardCutAction"?z.role="cut":H==="editor.action.clipboardCopyAction"?z.role="copy":H==="editor.action.clipboardPasteAction"&&(z.role="paste"),H==="undo"?z.click=this.V(A,{inDevTools:ie=>ie.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?z.click=this.V(A,{inDevTools:ie=>ie.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(z.click=this.V(A,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(H,z))}V(o,l){return(r,h,P)=>{const A=I.BrowserWindow.getFocusedWindow();if(!A)return l.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return l.inDevTools(A.webContents.devToolsWebContents);o(r,h||A,P)}}W(o){let l=I.BrowserWindow.getFocusedWindow();if(!l){const h=this.p.getLastActiveWindow();h?.isMinimized()&&(l=h.win)}const r=l?this.p.getWindowById(l.id):void 0;if(r){if(this.v.trace("menubar#runActionInRenderer",o),C.isMacintosh&&!this.q.isBuilt&&!r.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const h={id:o.commandId,from:"menu"};r.sendWhenReady("vscode:runAction",n.CancellationToken.None,h)}else{const h={userSettingsLabel:o.userSettingsLabel};r.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,h)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,l){const r=typeof o=="string"?this.l[o]:void 0;if(r?.label){if(r.isNative!==!1)l.accelerator=r.label,l.userSettingsLabel=r.userSettingsLabel;else if(typeof l.label=="string"){const h=l.label.indexOf("[");h>=0?l.label=`${l.label.substr(0,h)} [${r.label}]`:l.label=`${l.label} [${r.label}]`}}else l.accelerator=void 0;return l}Y(o,l,r=!l.accelerator){r&&(l=this.X(o,l));const h=l.click;return l.click=(P,A,T)=>{this.ab(o),h?.(P,A,T)},l}Z(o,l){this.w.openExternal(void 0,o),this.ab(l)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,R.mnemonicMenuLabel)(o,!this.B)}};c.a="lastKnownMenubarData",c=ve([Q(0,f.IUpdateService),Q(1,d.IConfigurationService),Q(2,S.IWindowsMainService),Q(3,w.IEnvironmentMainService),Q(4,g.ITelemetryService),Q(5,D.IWorkspacesHistoryMainService),Q(6,a.IStateService),Q(7,v.ILifecycleMainService),Q(8,b.ILogService),Q(9,y.INativeHostMainService),Q(10,p.IProductService)],c),e.Menubar=c;function i(){return new I.MenuItem({type:"separator"})}}),define(Z[281],ee([0,1,6,20,5,280]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let C=class{constructor(m,d,w){this.b=m,this.c=d,this.d=w,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(m,d){this.d.trace("menubarService#updateMenubar",m),(await this.a).updateMenu(d,m)}};C=ve([Q(0,I.IInstantiationService),Q(1,M.ILifecycleMainService),Q(2,n.ILogService)],C),e.MenubarMainService=C}),define(Z[282],ee([0,1,15,23,26,25,22,3,32,50,45,2,14,9,64,4,36,19,10,8,182,63,18,57,28,16,6,20,5,66,67,55,33,77,279,124,274,29,98,79,53,69,38,52,65]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c,i,s,o,l,r,h,P,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(ne){return(0,se.isWorkspaceIdentifier)(ne?.workspace)}function Y(ne){return(0,se.isSingleFolderWorkspaceIdentifier)(ne?.workspace)}let te=class at extends v.Disposable{constructor(L,F,W,U,$,V,j,K,J,re,de,Ce,Re,De,Oe,$e,fe,pe){super(),this.k=L,this.l=F,this.m=W,this.n=U,this.r=$,this.s=V,this.t=j,this.u=K,this.v=J,this.w=re,this.z=de,this.C=Ce,this.D=Re,this.F=De,this.G=Oe,this.H=$e,this.I=fe,this.J=pe,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const F=new v.DisposableStore;if(F.add(k.Event.any(L.onDidClose,L.onDidDestroy)(()=>F.dispose())),L.config.extensionDevelopmentPath)for(const W of L.config.extensionDevelopmentPath)F.add(this.I.addValidFileRoot(W));L.config.extensionTestsPath&&F.add(this.I.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,F){const W=this.t.args,U=F?.remoteAuthority||void 0,$=!0,V=F?.forceReuseWindow,j=!V;return this.open({...L,cli:W,forceEmpty:$,forceNewWindow:j,forceReuseWindow:V,remoteAuthority:U})}openExistingWindow(L,F){L.focus(),this.M(F,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const F=[],W=[],U=[],$=[],V=[];let j,K=0;const J=await this.S(L);this.m.trace("windowsManager#open pathsToOpen",J);for(const De of J)Y(De)?L.addMode?F.push(De):W.push(De):q(De)?U.push(De):De.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),j.filesToOpenOrCreate.push(De)):De.backupPath?V.push({backupFolder:(0,u.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):K++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?($.push(...this.D.getUntitledWorkspaces()),U.push(...$),V.push(...this.w.getEmptyWindowBackups())):V.length=0;const{windows:re,filesOpenedInWindow:de}=await this.N(L,U,W,V,K,j,F);if(this.m.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${W.length}, emptyToRestore: ${V.length}, emptyToOpen: ${K})`),re.length>1)if(de)de.focus();else{const De=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Oe=!0,$e=!0;if(De){const fe=re.filter(pe=>this.j.state.lastActiveWindow&&pe.backupPath===this.j.state.lastActiveWindow.backupPath);fe.length&&(fe[0].focus(),Oe=!1,$e=!1)}if(Oe)for(let fe=re.length-1;fe>=0;fe--){const pe=re[fe];if(!(pe.openedWorkspace&&$.some(Me=>pe.openedWorkspace&&Me.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&V.some(Me=>pe.backupPath&&Me.backupFolder===(0,u.basename)(pe.backupPath)))){pe.focus(),$e=!1;break}}$e&&re[re.length-1].focus()}const Ce=j&&j.filesToDiff.length>0,Re=j&&j.filesToMerge.length>0;if(!re.some(De=>De.isExtensionDevelopmentHost)&&!Ce&&!Re&&!L.noRecentEntry){const De=[];for(const Oe of J)q(Oe)&&!Oe.transient?De.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):Y(Oe)?De.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&De.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.C.addRecentlyOpened(De)}return this.M(L,re),re}M(L,F){const W=L.waitMarkerFileURI;L.context===0&&W&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.H.del(W)}catch{}})()}async N(L,F,W,U,$,V,j){const K=[];let J;function re(fe,pe){K.push(fe),pe&&(J=fe,V=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:Ce}=this.fb(L);if(!L.initialStartup&&j.length>0){const fe=j[0].remoteAuthority,pe=this.kb(fe);pe&&re(this.P(pe,j.map(Me=>Me.workspace.uri)))}const Re=W.length+F.length+U.length;if(V&&Re===0){const fe=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],pe=this.getWindows().filter(_=>V&&(0,g.isEqualAuthority)(_.remoteAuthority,V.remoteAuthority));let Me;fe?.fileUri&&!Ce&&((L.context===4||L.context===0||L.context===1)&&(Me=await(0,H.findWindowOnFile)(pe,fe.fileUri,async _=>_.configPath.scheme===b.Schemas.file?this.D.resolveLocalWorkspace(_.configPath):void 0)),Me||(Me=this.lb(pe))),Me?(0,se.isWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?W.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):re(this.O(L,Me,V),!0):re(await this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const De=(0,R.distinct)(F,fe=>fe.workspace.id);if(De.length>0){const fe=(0,R.coalesce)(De.map(pe=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(fe.length>0){const pe=fe[0],Me=(0,g.isEqualAuthority)(V?.remoteAuthority,pe.remoteAuthority)?V:void 0;re(this.O(L,pe,Me),!!Me),de=!0}for(const pe of De){if(fe.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===pe.workspace.id))continue;const Me=pe.remoteAuthority,_=(0,g.isEqualAuthority)(V?.remoteAuthority,Me)?V:void 0;re(await this.R(L,pe,de,_),!!_),de=!0}}const Oe=(0,R.distinct)(W,fe=>g.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(Oe.length>0){const fe=(0,R.coalesce)(Oe.map(pe=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(fe.length>0){const pe=fe[0],Me=(0,g.isEqualAuthority)(V?.remoteAuthority,pe.remoteAuthority)?V:void 0;re(this.O(L,pe,Me),!!Me),de=!0}for(const pe of Oe){if(fe.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,pe.workspace.uri)))continue;const Me=pe.remoteAuthority,_=(0,g.isEqualAuthority)(V?.remoteAuthority,Me)?V:void 0;re(await this.R(L,pe,de,_),!!_),de=!0}}const $e=(0,R.distinct)(U,fe=>fe.backupFolder);if($e.length>0)for(const fe of $e){const pe=fe.remoteAuthority,Me=(0,g.isEqualAuthority)(V?.remoteAuthority,pe)?V:void 0;re(await this.Q(L,!0,pe,Me,fe),!!Me),de=!0}if(K.length===0||V){V&&!$&&$++;const fe=V?V.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<$;pe++)re(await this.Q(L,de,fe,V),!!V),de=!0}return{windows:(0,R.distinct)(K),filesOpenedInWindow:J}}O(L,F,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),F.focus();const U={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",C.CancellationToken.None,U),F}P(L,F){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),L.focus();const W={foldersToAdd:F};return L.sendWhenReady("vscode:addFolders",C.CancellationToken.None,W),L}Q(L,F,W,U,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:W,filesToOpen:U,forceNewWindow:F});let V;return!F&&typeof L.contextWindowId=="number"&&(V=this.getWindowById(L.contextWindowId)),this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:U,windowToUse:V,emptyWindowBackupInfo:$,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}R(L,F,W,U,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:U}),!W&&!$&&typeof L.contextWindowId=="number"&&($=this.getWindowById(L.contextWindowId)),this.gb({workspace:F.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:U,windowToUse:$,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async S(L){let F,W=!1,U=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(F=await this.U(L),W=!0):L.forceEmpty?F=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(F=await this.W(L.cli),F.length===0&&F.push(Object.create(null)),W=!0):(F=await this.Y(),F.length===0&&F.push(Object.create(null)),U=!0),!L.addMode&&W){const $=F.filter(V=>Y(V));if($.length>1){const V=$[0].remoteAuthority;if($.every(j=>(0,g.isEqualAuthority)(j.remoteAuthority,V))){const j=await this.D.createUntitledWorkspace($.map(K=>({uri:K.workspace.uri})));F.push({workspace:j,remoteAuthority:V}),F=F.filter(K=>!Y(K))}}}if(L.initialStartup&&!U&&this.z.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();F.unshift(...$.filter(V=>q(V)||Y(V)||V.backupPath))}return F}async U(L){const F={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},W=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async U=>{const $=await this.ab(U,F);if($)return $.label=U.label,$;const V=this.cb(U);this.G.showMessageBox({type:"info",buttons:[(0,S.localize)(0,null)],message:V.scheme===b.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:V.scheme===b.Schemas.file?(0,S.localize)(3,null,(0,w.getPathLabel)(V,{os:p.OS,tildify:this.t})):(0,S.localize)(4,null,V.toString(!0))},(0,f.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async W(L){const F=[],W={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},U=L["folder-uri"];if(U){const j=await Promise.all(U.map(K=>{const J=this.X(K);if(!!J)return this.ab({folderUri:J},W)}));F.push(...(0,R.coalesce)(j))}const $=L["file-uri"];if($){const j=await Promise.all($.map(K=>{const J=this.X(K);if(!!J)return this.ab((0,se.hasWorkspaceFileExtension)(K)?{workspaceUri:J}:{fileUri:J},W)}));F.push(...(0,R.coalesce)(j))}const V=await Promise.all(L._.map(j=>W.remoteAuthority?this.eb(j,W):this.db(j,W)));return F.push(...(0,R.coalesce)(V)),F}X(L){try{const F=E.URI.parse(L);if(!F.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return F}catch(F){this.m.error(`Invalid URI input string: ${L}, ${F.message}`)}}async Y(){const L=this.Z();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];L!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const W=await Promise.all(F.map(async U=>{if(U.workspace){const $=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(q($))return $}else if(U.folderUri){const $=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(Y($))return $}else if(L!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,R.coalesce)(W)}}}Z(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async ab(L,F=Object.create(null)){const W=this.cb(L);return W.scheme===b.Schemas.file?((0,N.isFileToOpen)(L)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,F)):this.bb(L,F)}bb(L,F){let W=this.cb(L);const U=(0,A.getRemoteAuthority)(W)||F.remoteAuthority;if(W=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(W)),(0,N.isFileToOpen)(L)){if(F.gotoLineMode){const{path:$,line:V,column:j}=(0,m.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:$}),options:{selection:V?{startLineNumber:V,startColumn:j||1}:void 0},remoteAuthority:U}}return{fileUri:W,remoteAuthority:U}}else if((0,N.isWorkspaceToOpen)(L))return{workspace:(0,oe.getWorkspaceIdentifier)(W),remoteAuthority:U};return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:U}}cb(L){return(0,N.isWorkspaceToOpen)(L)?L.workspaceUri:(0,N.isFolderToOpen)(L)?L.folderUri:L.fileUri}async db(L,F){let W,U;F.gotoLineMode&&({path:L,line:W,column:U}=(0,m.parseLineAndColumnAware)(L)),L=(0,m.sanitizeFilePath)((0,u.normalize)(L),(0,a.cwd)());try{const $=await M.Promises.stat(L);if($.isFile()){if(!F.forceOpenWorkspaceAsFile){const V=await this.D.resolveLocalWorkspace(E.URI.file(L));if(V)return V.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:s.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:E.URI.file(L),type:s.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:U||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(E.URI.file(L),$),type:s.FileType.Directory,exists:!0};if(!p.isWindows&&L==="/dev/null")return{fileUri:E.URI.file(L),type:s.FileType.File,exists:!0}}}catch{const V=E.URI.file(L);if(this.C.removeRecentlyOpened([V]),F.ignoreFileNotFound)return{fileUri:V,type:s.FileType.File,exists:!1}}}eb(L,F){const W=L.charCodeAt(0),U=F.remoteAuthority;let $,V;F.gotoLineMode&&({path:L,line:$,column:V}=(0,m.parseLineAndColumnAware)(L)),W!==47&&((0,m.isWindowsDriveLetter)(W)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,m.toSlashes)(L)),L=`/${L}`);const j=E.URI.from({scheme:b.Schemas.vscodeRemote,authority:U,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return F.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:V||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,oe.getWorkspaceIdentifier)(j),remoteAuthority:U};if(F.gotoLineMode||u.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:V||1}:void 0},remoteAuthority:U}}return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:U}}fb(L){const F=this.z.getValue("window"),W=F?.openFoldersInNewWindow||"default",U=F?.openFilesInNewWindow||"off";let $=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(W==="on"||W==="off")&&($=W==="on");let V=!1;return L.forceNewWindow||L.forceReuseWindow?V=!!L.forceNewWindow&&!L.forceReuseWindow:(p.isMacintosh?L.context===1&&(V=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!L.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(V=U==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(L,F){const W=(0,H.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(W)return this.v.reload(W,F.cli),W.focus(),[W];let U=F.cli["folder-uri"]||[],$=F.cli["file-uri"]||[],V=F.cli._;if(!V.length&&!U.length&&!$.length&&!F.cli.extensionTestsPath){const J=this.j.state.lastPluginDevelopmentHostWindow,re=J?.workspace??J?.folderUri;re&&(E.URI.isUri(re)?re.scheme===b.Schemas.file?V=[re.fsPath]:U=[re.toString()]:re.configPath.scheme===b.Schemas.file?V=[(0,g.originalFSPath)(re.configPath)]:$=[re.configPath.toString()])}let j=F.remoteAuthority;for(const J of L)if(J.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=E.URI.parse(J),de=(0,A.getRemoteAuthority)(re);de&&(j?(0,g.isEqualAuthority)(de,j)||this.m.error("more than one extension development path authority"):j=de)}V=V.filter(J=>{const re=E.URI.file(J);return(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,g.isEqualAuthority)((0,A.getRemoteAuthority)(re),j)}),U=U.filter(J=>{const re=this.X(J);return re&&!!(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,g.isEqualAuthority)((0,A.getRemoteAuthority)(re),j):!1}),$=$.filter(J=>{const re=this.X(J);return re&&!!(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,g.isEqualAuthority)((0,A.getRemoteAuthority)(re),j):!1}),F.cli._=V,F.cli["folder-uri"]=U,F.cli["file-uri"]=$;const K={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!V.length&&!U.length&&!$.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(K)}async gb(L){const F=this.z.getValue("window"),W=this.z.getValue("files"),U=this.getLastActiveWindow(),$=U?.profile??this.u.defaultProfile;let V;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||U,V&&V.focus());const j={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,u.join)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:$},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsPath,product:h.default,isInitialStartup:L.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn,preferUtilityProcess:W?.experimental?.watcherUseUtilityProcess??F?.experimental?.sharedProcessUseUtilityProcess??!1};if(V){const K=V.config;!j.extensionDevelopmentPath&&K?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=K.extensionDevelopmentPath,j.extensionDevelopmentKind=K.extensionDevelopmentKind,j["enable-proposed-api"]=K["enable-proposed-api"],j.verbose=K.verbose,j["inspect-extensions"]=K["inspect-extensions"],j["inspect-brk-extensions"]=K["inspect-brk-extensions"],j.debugId=K.debugId,j.extensionEnvironment=K.extensionEnvironment,j["extensions-dir"]=K["extensions-dir"],j["disable-extensions"]=K["disable-extensions"]),j.loggers=K?.loggers??j.loggers}else{const K=this.j.getNewWindowState(j);(0,y.mark)("code/willCreateCodeWindow");const J=V=this.F.createInstance(z.CodeWindow,{state:K,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(J),at.a.push(J),this.b.fire(J),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(J.onDidSignalReady)(()=>this.c.fire(J)),(0,d.once)(J.onDidClose)(()=>this.jb(J)),(0,d.once)(J.onDidDestroy)(()=>this.f.fire(J)),J.onDidTriggerSystemContextMenu(({x:de,y:Ce})=>this.h.fire({window:J,x:de,y:Ce}));const re=(0,f.assertIsDefined)(J.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.v.reload(J)),this.v.registerWindow(J)}return j.windowId=V.id,V.isReady?this.v.unload(V,4).then(async K=>{K||await this.hb(V,j,L,$)}):await this.hb(V,j,L,$),V}async hb(L,F,W,U){if(F.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.w.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.w.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.w.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,oe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.u.isEnabled()){const $=F.workspace??(0,se.toWorkspaceIdentifier)(F.backupPath,!1),V=this.ib(W,$,U),j=V instanceof Promise?await V:V;F.profiles.profile=j,F.extensionDevelopmentPath||await this.u.setProfileForWorkspace($,j)}L.load(F)}ib(L,F,W){return L.forceProfile?this.u.profiles.find(U=>U.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(F)??W}jb(L){const F=at.a.indexOf(L);at.a.splice(F,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=I.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(L){return this.lb(this.getWindows().filter(F=>(0,g.isEqualAuthority)(F.remoteAuthority,L)))}lb(L){const F=Math.max.apply(Math,L.map(W=>W.lastFocusTime));return L.find(W=>W.lastFocusTime===F)}sendToFocused(L,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,C.CancellationToken.None,...F)}sendToAll(L,F,W){for(const U of this.getWindows())W&&W.indexOf(U.id)>=0||U.sendWhenReady(L,C.CancellationToken.None,F)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(L){const F=this.getWindows().filter(W=>W.id===L);return(0,R.firstOrDefault)(F)}getWindowByWebContents(L){const F=I.BrowserWindow.fromWebContents(L);if(!!F)return this.getWindowById(F.id)}};te.a=[],te=ve([Q(2,r.ILogService),Q(3,O.ILoggerMainService),Q(4,T.IStateService),Q(5,G.IPolicyService),Q(6,i.IEnvironmentMainService),Q(7,B.IUserDataProfilesMainService),Q(8,l.ILifecycleMainService),Q(9,D.IBackupMainService),Q(10,t.IConfigurationService),Q(11,ue.IWorkspacesHistoryMainService),Q(12,le.IWorkspacesManagementMainService),Q(13,o.IInstantiationService),Q(14,c.IDialogMainService),Q(15,s.IFileService),Q(16,P.IProtocolMainService),Q(17,me.IThemeMainService)],te),e.WindowsMainService=te}),define(Z[283],ee([0,1,63,30,79,53]),function(x,e,I,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(m,d,w,v){this.a=m,this.b=d,this.c=w,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(m,d){const w=this.b.getWindowById(m);if(w)return this.a.enterWorkspace(w,this.b.getWindows(),d)}createUntitledWorkspace(m,d,w){return this.a.createUntitledWorkspace(d,w)}deleteUntitledWorkspace(m,d){return this.a.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(m,d){return this.a.getWorkspaceIdentifier(d)}getRecentlyOpened(m){return this.c.getRecentlyOpened()}addRecentlyOpened(m,d){return this.c.addRecentlyOpened(d)}removeRecentlyOpened(m,d){return this.c.removeRecentlyOpened(d)}clearRecentlyOpened(m){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};C=ve([Q(0,R.IWorkspacesManagementMainService),Q(1,M.IWindowsMainService),Q(2,n.IWorkspacesHistoryMainService),Q(3,I.IBackupMainService)],C),e.WorkspacesMainService=C}),define(Z[284],ee([0,1,15,42,26,17,44,13,32,50,43,45,2,14,9,4,10,8,31,140,47,154,105,257,157,63,275,18,75,190,87,125,57,109,211,28,62,115,201,225,202,261,111,203,204,16,215,90,74,6,89,276,238,259,20,5,281,58,21,55,269,91,33,265,96,92,24,240,118,48,49,247,248,277,249,278,121,251,252,253,255,263,30,282,264,29,97,79,283,53,258,38,223,52,234,56,78,123,267,273,271,7,119,266,218,65,88,262,254]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c,i,s,o,l,r,h,P,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O,q,Y,te,ne,L,F,W,U,$,V,j,K,J,re,de,Ce,Re,De,Oe,$e,fe,pe,Me,_,ce,he,Ie,Ae,Te,Fe,je,ze,We,He,X,ae,ge,be,we,Le,Ue,Ve,Ge,Ke,Ye,Ze,st,ct,ft,Dt,Ct,Rt,Mt,At,Lt,Ot,gt,Tt,Ft,Wt,Ut,Nt,mt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends b.Disposable{constructor(Pe,Ee,ye,Se,ke,Be,Xe,Qe,qe,Ne,xe){super(),this.c=Pe,this.f=Ee,this.g=ye,this.h=Se,this.i=ke,this.j=Be,this.k=Xe,this.l=Qe,this.m=qe,this.n=Ne,this.p=xe,this.r(),this.s()}r(){const Pe=qe=>qe?.startsWith(`${u.Schemas.vscodeWebview}://`),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?xe(Ee.has(Ne)):xe(!1)),I.session.defaultSession.setPermissionCheckHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?Ee.has(Ne):!1);const ye=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Se=qe=>{for(let Ne=qe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},ke=qe=>qe.resourceType==="xhr"||Se(qe.frame),Be=qe=>{const Ne=qe.frame;if(!Ne||!this.a)return!1;const xe=I.BrowserWindow.getAllWindows();for(const Je of xe)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Ne)=>{if(qe.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((qe,Ne)=>{const xe=g.URI.parse(qe.url);return xe.scheme===u.Schemas.vscodeWebview&&!Xe(xe,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Ne({cancel:!0})):xe.scheme===u.Schemas.vscodeFileResource&&!Be(qe)?(this.h.error("Blocked vscode-file request",qe.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!ye.has(xe.scheme)?Ne({cancel:!ke(qe)}):Ne({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((qe,Ne)=>{const xe=qe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=g.URI.parse(qe.url);if(_e.path.endsWith(".svg")&&ye.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(u.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!ke(qe)})}return Ne({cancel:!1})});const Qe=I.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,y.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(ye=>this.u(ye)),process.on("uncaughtException",ye=>(0,k.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,k.onUnexpectedError)(ye)),this.j.onWillShutdown(()=>this.dispose()),(0,E.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(ye,Se)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Se)}),I.app.on("activate",async(ye,Se)=>{this.h.trace("app#activate"),Se||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(ye,Se)=>{Se.on("will-navigate",ke=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Se.setWindowOpenHandler(({url:ke})=>(this.b?.openExternal(void 0,ke),{action:"deny"}))});let Pe=[],Ee;I.app.on("open-file",(ye,Se)=>{this.h.trace("app#open-file: ",Se),ye.preventDefault(),Pe.push((0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:g.URI.file(Se)}:{fileUri:g.URI.file(Se)}),Ee!==void 0&&(clearTimeout(Ee),Ee=void 0),Ee=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ee=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),M.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const Se=this.a?.getWindowByWebContents(ye.sender);let ke,Be;return Se?.config?(ke=Se.config,Be={...process.env,...Se.config.userEnv}):(ke=this.i.args,Be=process.env),this.M(ke,Be,!1)}),M.validatedIpcMain.handle("vscode:writeNlsFile",(ye,Se,ke)=>{const Be=this.t([Se]);if(!Be||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Be,R.VSBuffer.fromString(ke))}),M.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...Se)=>{const ke=this.t(Se);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(ke)).value.toString()}),M.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),M.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),M.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}t(Pe){let Ee;for(const ye of Pe)typeof ye=="string"&&(typeof Ee!="string"?Ee=ye:Ee=(0,y.join)(Ee,ye));if(!(typeof Ee!="string"||!(0,y.isAbsolute)(Ee)||!(0,m.isEqualOrParent)(Ee,this.i.cachedLanguagesPath,!p.isLinux)))return g.URI.file(Ee)}u(Pe){if(Pe){const Ee={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ee))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Pe=this.n.win32AppUserModelId;p.isWindows&&Pe&&I.app.setAppUserModelId(Pe);try{p.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ee=new D.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ee.dispose()}),this.h.trace("Resolving machine identifier...");const ye=await(0,Tt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:Se,sharedProcessReady:ke,sharedProcessClient:Be}=this.D(ye),Xe=await this.F(ye,Se,ke);this.B(Xe.createInstance(c.ProxyAuthHandler)),this.B(Xe.createInstance(Lt.UserDataProfilesHandler)),Xe.invokeFunction(Ne=>this.G(Ne,Ee,Be));const Qe=Xe.invokeFunction(Ne=>this.v(Ne,Ee));this.j.phase=2,await Xe.invokeFunction(Ne=>this.H(Ne,Qe)),this.j.phase=3,Xe.invokeFunction(Ne=>this.I(Ne,Se)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Pe,Ee){const ye=this.a=Pe.get(be.IWindowsMainService),Se=Pe.get(ze.IURLService),ke=this.b=Pe.get(J.INativeHostMainService),Be=this;Se.registerHandler({async handleURL(Je,_e){return Be.C(ye,Se,Je,_e)}});const Xe=this.B(new Le.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Qe=new S.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),qe=new We.URLHandlerRouter(Qe,this.h),Ne=Ee.getChannel("urlHandler",qe);Se.registerHandler(new We.URLHandlerChannelClient(Ne));const xe=this.w();return this.B(new X.ElectronURLListener(xe?.urls,Se,ye,this.i,this.n,this.h)),xe}w(){const Pe=this.i.args["open-url"]?this.i.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Pe.length+Ee.length===0)return;const ye=[];return{urls:[...Pe,...Ee].map(ke=>{try{return{uri:g.URI.parse(ke),originalUrl:ke}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",ke);return}}).filter(ke=>{if(!ke)return!1;if(this.y(ke.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",ke.uri.toString(!0)),!1;const Be=this.z(ke.uri);return Be?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",ke.uri.toString(!0),Be),ye.push(Be),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",ke.uri.toString(!0)),!0)}),openables:ye}}y(Pe){if(Pe.authority===u.Schemas.file&&p.isWindows){const{options:Ee,buttonIndeces:ye}=(0,Nt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(Pe,{os:p.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(ye[I.dialog.showMessageBoxSync(Ee)]===1)return!0}return!1}z(Pe){if(!!Pe.path){if(Pe.authority===u.Schemas.file){const Ee=g.URI.file(Pe.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Ee)?{workspaceUri:Ee}:{fileUri:Ee}}else if(Pe.authority===u.Schemas.vscodeRemote){const Ee=Pe.path.indexOf(y.posix.sep,1);if(Ee!==-1){const ye=Pe.path.substring(1,Ee),Se=Pe.path.substring(Ee),ke=g.URI.from({scheme:u.Schemas.vscodeRemote,authority:ye,path:Se,query:Pe.query,fragment:Pe.fragment});return(0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:ke}:/:[\d]+$/.test(Se)?{fileUri:ke}:{folderUri:ke}}}}}async C(Pe,Ee,ye,Se){if(this.h.trace("app#handleProtocolUrl():",ye.toString(!0),Se),ye.scheme===this.n.urlProtocol&&ye.path==="workspace"&&(ye=ye.with({authority:"file",path:g.URI.parse(ye.query).path,query:""})),this.y(ye))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",ye.toString(!0)),!0;let ke=!1;const Be=new URLSearchParams(ye.query);Be.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ye.toString(!0)),Be.delete("windowId"),ye=ye.with({query:Be.toString()}),ke=!0):p.isMacintosh&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ye.toString(!0)),ke=!0);const Xe=Be.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ye.toString(!0)),Be.delete("continueOn"),ye=ye.with({query:Be.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.z(ye);if(Qe){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,ye.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:ke,gotoLineMode:!0});return qe.focus(),!0}if(ke){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ye.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(ye)});return await qe.ready(),Ee.open(ye,Se)}return this.h.trace("app#handleProtocolUrl(): not handled",ye.toString(!0),Se),!1}D(Pe){const Ee=this.B(this.g.createInstance(Ce.SharedProcess,Pe,this.f)),ye=(async()=>{this.h.trace("Main->SharedProcess#connect");const ke=await Ee.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(ke,"main")})(),Se=(async()=>(await Ee.whenReady(),ye))();return{sharedProcess:Ee,sharedProcessReady:Se,sharedProcessClient:ye}}async F(Pe,Ee,ye){const Se=new F.ServiceCollection;switch(process.platform){case"win32":Se.set(he.IUpdateService,new ne.SyncDescriptor(je.Win32UpdateService));break;case"linux":p.isLinuxSnap?Se.set(he.IUpdateService,new ne.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(he.IUpdateService,new ne.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Se.set(he.IUpdateService,new ne.SyncDescriptor(Ae.DarwinUpdateService));break}Se.set(be.IWindowsMainService,new ne.SyncDescriptor(we.WindowsMainService,[Pe,this.f],!1));const ke=new T.DialogMainService(this.h,this.n);Se.set(T.IDialogMainService,ke),Se.set($.ILaunchMainService,new ne.SyncDescriptor($.LaunchMainService,void 0,!1)),Se.set(A.IDiagnosticsMainService,new ne.SyncDescriptor(A.DiagnosticsMainService,void 0,!1)),Se.set(P.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(ye.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(W.IIssueMainService,new ne.SyncDescriptor(W.IssueMainService,[this.f])),Se.set(N.IEncryptionMainService,new ne.SyncDescriptor(z.EncryptionMainService,[Pe])),Se.set(U.IKeyboardLayoutMainService,new ne.SyncDescriptor(U.KeyboardLayoutMainService)),Se.set(J.INativeHostMainService,new ne.SyncDescriptor(J.NativeHostMainService,[Ee],!1)),Se.set(r.ICredentialsMainService,new ne.SyncDescriptor(Ze.CredentialsNativeMainService)),Se.set(ae.IWebviewManagerService,new ne.SyncDescriptor(ge.WebviewMainService)),Se.set(K.IMenubarMainService,new ne.SyncDescriptor(K.MenubarMainService)),Se.set(oe.IExtensionUrlTrustService,new ne.SyncDescriptor(ue.ExtensionUrlTrustService)),Se.set(le.IExtensionHostStarter,new ne.SyncDescriptor(me.ExtensionHostStarter)),Se.set($e.IStorageMainService,new ne.SyncDescriptor($e.StorageMainService)),Se.set($e.IApplicationStorageMainService,new ne.SyncDescriptor($e.ApplicationStorageMainService)),p.isWindows?Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.WindowsExternalTerminalService)):p.isMacintosh?Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.MacExternalTerminalService)):p.isLinux&&Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.LinuxExternalTerminalService));const Be=new o.BackupMainService(this.i,this.k,this.h,this.l);Se.set(s.IBackupMainService,Be);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,Be,ke);if(Se.set(Ye.IWorkspacesManagementMainService,Xe),Se.set(Ve.IWorkspacesService,new ne.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Se.set(Ge.IWorkspacesHistoryMainService,new ne.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Se.set(ze.IURLService,new ne.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,ce.supportsTelemetry)(this.n,this.i)){const Qe=(0,ce.isInternalTelemetry)(this.n,this.k),qe=(0,S.getDelayedChannel)(ye.then(nt=>nt.getChannel("telemetryAppender"))),Ne=new Me.TelemetryAppenderClient(qe),xe=(0,fe.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,Pe,Qe,this.i.installSourcePath),Je=(0,ce.getPiiPathsFromEnvironment)(this.i),_e={appenders:[Ne],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Se.set(pe.ITelemetryService,new ne.SyncDescriptor(_.TelemetryService,[_e],!1))}else Se.set(pe.ITelemetryService,ce.NullTelemetryService);return Se.set(Rt.IExtensionsProfileScannerService,new ne.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Se.set(Mt.IExtensionsScannerService,new ne.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Se.set(mt.IUtilityProcessWorkerMainService,new ne.SyncDescriptor(mt.UtilityProcessWorkerMainService,void 0,!0)),await gt.Promises.settled([Be.initialize(),Xe.initialize()]),this.g.createChild(Se)}G(Pe,Ee,ye){const Se=S.ProxyChannel.fromService(Pe.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Se);const ke=S.ProxyChannel.fromService(Pe.get(A.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",ke);const Be=new ct.PolicyChannel(Pe.get(st.IPolicyService));Ee.registerChannel("policy",Be),ye.then(et=>et.registerChannel("policy",Be));const Xe=this.m.getProvider(u.Schemas.file);(0,a.assertType)(Xe instanceof te.DiskFileSystemProvider);const Qe=new Y.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ee.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),ye.then(et=>et.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const qe=S.ProxyChannel.fromService(Pe.get(ft.IUserDataProfilesMainService));Ee.registerChannel("userDataProfiles",qe),ye.then(et=>et.registerChannel("userDataProfiles",qe));const Ne=new Dt.RequestChannel(Pe.get(Ct.IRequestService));ye.then(et=>et.registerChannel("request",Ne));const xe=new Ie.UpdateChannel(Pe.get(he.IUpdateService));Ee.registerChannel("update",xe);const Je=S.ProxyChannel.fromService(Pe.get(W.IIssueMainService));Ee.registerChannel("issue",Je);const _e=S.ProxyChannel.fromService(Pe.get(N.IEncryptionMainService));Ee.registerChannel("encryption",_e);const nt=S.ProxyChannel.fromService(Pe.get(r.ICredentialsMainService));Ee.registerChannel("credentials",nt);const it=S.ProxyChannel.fromService(Pe.get(Re.ISignService));Ee.registerChannel("sign",it);const lt=S.ProxyChannel.fromService(Pe.get(U.IKeyboardLayoutMainService));Ee.registerChannel("keyboardLayout",lt),this.b=Pe.get(J.INativeHostMainService);const yt=S.ProxyChannel.fromService(this.b);Ee.registerChannel("nativeHost",yt),ye.then(et=>et.registerChannel("nativeHost",yt));const Bt=S.ProxyChannel.fromService(Pe.get(Ve.IWorkspacesService));Ee.registerChannel("workspaces",Bt);const $t=S.ProxyChannel.fromService(Pe.get(K.IMenubarMainService));Ee.registerChannel("menubar",$t);const zt=S.ProxyChannel.fromService(Pe.get(ze.IURLService));Ee.registerChannel("url",zt);const qt=S.ProxyChannel.fromService(Pe.get(oe.IExtensionUrlTrustService));Ee.registerChannel("extensionUrlTrust",qt);const Ht=S.ProxyChannel.fromService(Pe.get(ae.IWebviewManagerService));Ee.registerChannel("webview",Ht);const St=this.B(new Oe.StorageDatabaseChannel(this.h,Pe.get($e.IStorageMainService)));Ee.registerChannel("storage",St),ye.then(et=>et.registerChannel("storage",St));const Vt=this.B(new Ot.ProfileStorageChangesListenerChannel(Pe.get($e.IStorageMainService),Pe.get(ft.IUserDataProfilesMainService),this.h));ye.then(et=>et.registerChannel("profileStorageListener",Vt));const xt=S.ProxyChannel.fromService(Pe.get(G.IExternalTerminalMainService));Ee.registerChannel("externalTerminal",xt);const Et=new Wt.LoggerChannel(Pe.get(Ut.ILoggerMainService));Ee.registerChannel("logger",Et),ye.then(et=>et.registerChannel("logger",Et));const Gt=new h.ElectronExtensionHostDebugBroadcastChannel(Pe.get(be.IWindowsMainService));Ee.registerChannel("extensionhostdebugservice",Gt);const Kt=S.ProxyChannel.fromService(Pe.get(le.IExtensionHostStarter));Ee.registerChannel(le.ipcExtensionHostStarterChannelName,Kt);const Xt=S.ProxyChannel.fromService(Pe.get(mt.IUtilityProcessWorkerMainService));Ee.registerChannel(jt.ipcUtilityProcessWorkerChannelName,Xt)}async H(Pe,Ee){const ye=this.a=Pe.get(be.IWindowsMainService),Se=(0,ie.isLaunchedFromCli)(process.env)?0:4,ke=this.i.args;if(Ee){if(Ee.openables.length>0)return ye.open({context:Se,cli:ke,urisToOpen:Ee.openables,gotoLineMode:!0,initialStartup:!0});if(Ee.urls.length>0)for(const it of Ee.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),ye.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,Xe=ke._.length,Qe=!!ke["folder-uri"],qe=!!ke["file-uri"],Ne=ke["skip-add-to-recently-opened"]===!0,xe=ke.wait&&ke.waitMarkerFilePath?g.URI.file(ke.waitMarkerFilePath):void 0,Je=ke.remote||void 0,_e=ke.profile,nt=ke["profile-temp"];if(!Xe&&!Qe&&!qe){if(ke["new-window"]||_e||nt)return ye.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(Be.length)return ye.open({context:1,cli:ke,urisToOpen:Be.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:g.URI.file(it)}:{fileUri:g.URI.file(it)}),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return ye.open({context:Se,cli:ke,forceNewWindow:ke["new-window"]||!Xe&&ke["unity-launch"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(Pe,Ee){const ye=Pe.get(pe.ITelemetryService),Se=Pe.get(he.IUpdateService);this.L(ye,Ee),this.J(),I.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(ke,Be)=>{Be({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),(Se instanceof je.Win32UpdateService||Se instanceof Te.LinuxUpdateService||Se instanceof Ae.DarwinUpdateService)&&Se.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const Pe=this.n.win32MutexName;if(p.isWindows&&Pe)try{const Ee=await new Promise((Se,ke)=>{x(["windows-mutex"],Se,ke)}),ye=new Ee.Mutex(Pe);(0,d.once)(this.j.onWillShutdown)(()=>ye.release())}catch(Ee){this.h.error(Ee)}}L(Pe,Ee){let ye=!1;(0,d.once)(this.j.onWillShutdown)(()=>ye=!0),this.B(Ee.onDidError(({type:Se,details:ke})=>{switch(Se){case 2:this.h.error(`SharedProcess: renderer process gone (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break;case 1:this.h.error("SharedProcess: detected unresponsive");break;case 3:this.h.error(`SharedProcess: failed to load (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break}Pe.publicLog2("sharedprocesserror",{type:Se,reason:ke?.reason,code:ke?.exitCode,visible:Ee.isVisible(),utilityprocess:Ee.usingUtilityProcess()?"1":"0",shuttingdown:ye})}))}async M(Pe,Ee,ye){try{return await(0,se.getResolvedShellEnv)(this.k,this.h,Pe,Ee)}catch(Se){const ke=(0,C.toErrorMessage)(Se);ye?this.a?.sendToFocused("vscode:showResolveShellEnvError",ke):this.h.error(ke)}return{}}async N(){try{const Ee=(await this.m.readFile(this.i.argvResource)).value.toString(),ye=JSON.parse((0,w.stripComments)(Ee)),ke=(0,ce.getTelemetryLevel)(this.k)>=1;if(ye["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],Xe=Ee.substring(0,Ee.length-2).concat(`,
`,Be.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Xe))}else{const Be=Ee.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Be!==Ee&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};pt=ve([Q(2,L.IInstantiationService),Q(3,j.ILogService),Q(4,H.IEnvironmentMainService),Q(5,V.ILifecycleMainService),Q(6,l.IConfigurationService),Q(7,De.IStateService),Q(8,q.IFileService),Q(9,re.IProductService),Q(10,ft.IUserDataProfilesMainService)],pt),e.CodeApplication=pt}),define(Z[285],ee([0,1,236,7,17,13,2,10,18,34,115,5,235,292]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends C.Disposable{constructor(a,g,f){super(),this.h=a,this.i=g,this.j=f,this.k(),this.B(a.onDidChangeConfiguration(E=>{E.affectsConfiguration("http")&&this.k()}))}k(){const a=this.h.getValue("http");this.a=a?.proxy,this.b=!!a?.proxyStrictSSL,this.f=a?.proxyAuthorization}async request(a,g){this.j.trace("RequestService#request (node) - begin",a.url);const{a:f,b:E}=this;let S;try{S=await(0,w.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(c){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",c))}const D={...process.env,...S},t=a.agent?a.agent:await(0,b.getProxyAgent)(a.url||"",D,{proxyUrl:f,strictSSL:E});a.agent=t,a.strictSSL=E,this.f&&(a.headers={...a.headers||{},"Proxy-Authorization":this.f});try{const c=await this.m(a,g);return this.j.trace("RequestService#request (node) - success",a.url),c}catch(c){throw this.j.trace("RequestService#request (node) - error",a.url,c),c}}async l(a){return((0,I.parse)(a.url).protocol==="https:"?await new Promise((E,S)=>{x(["https"],E,S)}):await new Promise((E,S)=>{x(["http"],E,S)})).request}m(a,g){return M.Promises.withAsyncBody(async(f,E)=>{const S=(0,I.parse)(a.url),D=a.getRawRequest?a.getRawRequest(a):await this.l(a),t={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,k.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(t.auth=a.user+":"+a.password);const c=D(t,i=>{const s=(0,k.isNumber)(a.followRedirects)?a.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this.m({...a,url:i.headers.location,followRedirects:s-1},g).then(f,E);else{let o=i;!a.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,u.createGunzip)())),f({res:i,stream:(0,n.streamToBufferReadableStream)(o)})}});c.on("error",E),a.timeout&&c.setTimeout(a.timeout),a.isChromiumNetwork&&c.removeHeader("Content-Length"),a.data&&typeof a.data=="string"&&c.write(a.data),c.end(),g.onCancellationRequested(()=>{c.abort(),E(new R.CancellationError)})})}async resolveProxy(a){}};y=ve([Q(0,m.IConfigurationService),Q(1,d.INativeEnvironmentService),Q(2,v.ILogService)],y),e.RequestService=y}),define(Z[286],ee([0,1,15,285]),function(x,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(C){return I.net.request}class R extends M.RequestService{request(k,m){return super.request({...k||{},getRawRequest:n,isChromiumNetwork:!0},m)}}e.RequestMainService=R}),define(Z[293],ee([0,1,15,41,8,25,7,44,13,32,50,45,14,9,64,4,36,27,23,47,86,284,11,18,229,239,28,62,193,16,213,90,74,209,89,20,216,5,66,21,67,268,120,245,56,286,91,237,33,48,69,52,38,224,222,2,39,250,65,217,88,116,246]),function(x,e,I,M,n,R,C,k,m,d,w,v,b,u,y,p,a,g,f,E,S,D,t,c,i,s,o,l,r,h,P,A,T,N,z,H,ie,se,oe,ue,le,me,G,B,O,q,Y,te,ne,L,F,W,U,$,V,j,K,J,re,de,Ce,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class De{main(){try{this.a()}catch(fe){console.error(fe.message),I.app.exit(1)}}async a(){(0,m.setUnexpectedErrorHandler)(Te=>console.error(Te));const[fe,pe,Me,_,ce,he,Ie,Ae]=this.b();try{try{await this.d(Me,Ae,_,ce,Ie)}catch(Te){throw this.f(Me,Ie,Te),Te}await fe.invokeFunction(async Te=>{const Fe=Te.get(se.ILogService),je=Te.get(H.ILifecycleMainService),ze=Te.get(h.IFileService),We=Te.get(se.ILoggerService),He=await this.e(Fe,Me,je,fe,Ie,!0);return f.Promises.writeFile(Me.mainLockfile,String(process.pid)).catch(X=>{Fe.warn(`app#startup(): Error writing main lockfile: ${X.stack}`)}),he.logger=We.createLogger(n.URI.file((0,u.join)(Me.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,w.once)(je.onWillShutdown)(X=>{ze.dispose(),_.dispose(),X.join("instanceLockfile",f.Promises.unlink(Me.mainLockfile).catch(()=>{}))}),fe.createInstance(D.CodeApplication,He,pe).startup()})}catch(Te){fe.invokeFunction(this.i,Te)}}b(){const fe=new z.ServiceCollection,pe=new j.DisposableStore;process.once("exit",()=>pe.dispose());const Me={_serviceBrand:void 0,...oe.default};fe.set(ue.IProductService,Me);const _=new o.EnvironmentMainService(this.j(),Me),ce=this.c(_);fe.set(o.IEnvironmentMainService,_);const he=new re.LoggerMainService((0,se.getLogLevel)(_));fe.set(re.ILoggerMainService,he);const Ie=new ie.BufferLogger(he.getLogLevel()),Ae=pe.add(new de.LogService(Ie,[new se.ConsoleMainLogger(he.getLogLevel())]));fe.set(se.ILogService,Ae);const Te=new P.FileService(Ae);fe.set(h.IFileService,Te);const Fe=new A.DiskFileSystemProvider(Ae);Te.registerProvider(b.Schemas.file,Fe);const je=new J.UriIdentityService(Te);fe.set(K.IUriIdentityService,je);const ze=new Re.StateService(1,_,Ae,Te);fe.set(ne.IStateReadService,ze),fe.set(ne.IStateService,ze);const We=new W.UserDataProfilesMainService(ze,je,_,Te,Ae);fe.set(W.IUserDataProfilesMainService,We);const He=p.isWindows&&Me.win32RegValueName?pe.add(new $.NativePolicyService(Ae,Me.win32RegValueName)):_.policyFile?pe.add(new V.FilePolicyService(_.policyFile,Te,Ae)):new U.NullPolicyService;fe.set(U.IPolicyService,He);const X=new i.ConfigurationService(We.defaultProfile.settingsResource,Te,He,Ae);return fe.set(c.IConfigurationService,X),fe.set(H.ILifecycleMainService,new T.SyncDescriptor(H.LifecycleMainService,void 0,!1)),fe.set(O.IRequestService,new T.SyncDescriptor(q.RequestMainService,void 0,!0)),fe.set(F.IThemeMainService,new T.SyncDescriptor(F.ThemeMainService)),fe.set(Y.ISignService,new T.SyncDescriptor(te.SignService,void 0,!1)),fe.set(G.ITunnelService,new T.SyncDescriptor(B.TunnelService)),fe.set(le.IProtocolMainService,new me.ProtocolMainService(_,We,Ae)),[new N.InstantiationService(fe,!0),ce,_,X,ze,Ie,Me,We]}c(fe){const pe={VSCODE_IPC_HOOK:fe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Me=>{const _=process.env[Me];typeof _=="string"&&(pe[Me]=_)}),Object.assign(process.env,pe),pe}async d(fe,pe,Me,_,ce){await C.Promises.settled([Promise.all([fe.extensionsPath,fe.codeCachePath,fe.logsPath,pe.defaultProfile.globalStorageHome.fsPath,fe.workspaceStorageHome.fsPath,fe.localHistoryHome.fsPath,fe.backupHome].map(he=>he?f.Promises.mkdir(he,{recursive:!0}):void 0)),_.init(),Me.initialize()]),pe.init()}async e(fe,pe,Me,_,ce,he){let Ie;try{(0,y.mark)("code/willStartMainServer"),Ie=await(0,S.serve)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(Me.onWillShutdown)(()=>Ie.dispose())}catch(Ae){if(Ae.code!=="EADDRINUSE")throw this.f(pe,ce,Ae),Ae;let Te;try{Te=await(0,S.connect)(pe.mainIPCHandle,"main")}catch(We){if(!he||p.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.g((0,t.localize)(1,null,ce.nameShort),(0,t.localize)(2,null),ce),We;try{(0,M.unlinkSync)(pe.mainIPCHandle)}catch(He){throw fe.warn("Could not delete obsolete instance handle",He),He}return this.e(fe,pe,Me,_,ce,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const We=`Running extension tests from the command line is currently only supported if no other instance of ${ce.nameShort} is running.`;throw fe.error(We),Te.dispose(),new Error(We)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.g((0,t.localize)(3,null,ce.nameShort),(0,t.localize)(4,null),ce)},1e4));const je=E.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=E.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return _.invokeFunction(async()=>{const We=new s.DiagnosticsService(L.NullTelemetryService,ce),He=await ze.getMainDiagnostics(),X=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ae=await We.getDiagnostics(He,X);throw console.log(ae),new m.ExpectedError});throw p.isWindows&&await this.h(je,fe),fe.trace("Sending env to running instance..."),await je.start(pe.args,process.env),Te.dispose(),Fe&&clearTimeout(Fe),new m.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw fe.warn(`Warning: The --status argument can only be used if ${ce.nameShort} is already running. Please run it again after {0} has started.`),new m.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ie}f(fe,pe,Me){if(Me.code==="EACCES"||Me.code==="EPERM"){const _=(0,R.coalesce)([fe.userDataPath,fe.extensionsPath,S.XDG_RUNTIME_DIR]).map(ce=>(0,v.getPathLabel)(n.URI.file(ce),{os:p.OS,tildify:fe}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Me),_.join(`
`)),pe)}}g(fe,pe,Me){I.dialog.showMessageBoxSync((0,Ce.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:fe,detail:pe},Me).options)}async h(fe,pe){if(p.isWindows){const Me=await fe.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Me);try{(await new Promise((_,ce)=>{x(["windows-foreground-love"],_,ce)})).allowSetForegroundWindow(Me)}catch(_){pe.error(_)}}}i(fe,pe){const Me=fe.get(se.ILogService),_=fe.get(H.ILifecycleMainService);let ce=0;pe&&(pe.isExpected?pe.message&&Me.trace(pe.message):(ce=1,pe.stack?Me.error(pe.stack):Me.error(`Startup error: ${pe.toString()}`))),_.kill(ce)}j(){const fe=this.k((0,l.parseMainProcessArgv)(process.argv));if(fe.wait&&!fe.waitMarkerFilePath){const pe=(0,r.createWaitMarkerFileSync)(fe.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),fe.waitMarkerFilePath=pe)}return fe}k(fe){if(fe["open-url"]&&(fe._urls=fe._,fe._=[]),!fe.remote){const pe=this.l(fe._,fe.goto);fe._=pe}return fe}l(fe,pe){const Me=(0,a.cwd)(),_=fe.map(Ie=>{let Ae=String(Ie),Te;pe&&(Te=(0,d.parseLineAndColumnAware)(Ae),Ae=Te.path),Ae&&(Ae=this.m(Me,Ae));const Fe=(0,d.sanitizeFilePath)(Ae,Me),je=(0,u.basename)(Fe);return je&&!(0,d.isValidBasename)(je)?null:pe&&Te?(Te.path=Fe,this.n(Te)):Fe}),ce=p.isWindows||p.isMacintosh,he=(0,R.distinct)(_,Ie=>Ie&&ce?Ie.toLowerCase():Ie||"");return(0,R.coalesce)(he)}m(fe,pe){return p.isWindows&&(pe=(0,g.rtrim)(pe,'"')),pe=(0,g.trim)((0,g.trim)(pe," "),"	"),p.isWindows&&(pe=(0,u.resolve)(fe,pe),pe=(0,g.rtrim)(pe,".")),pe}n(fe){const pe=[fe.path];return typeof fe.line=="number"&&pe.push(String(fe.line)),typeof fe.column=="number"&&pe.push(String(fe.column)),pe.join(":")}}new De().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f44d5a4a4e72ca1461232d43d17a60f9ff555273/core/vs/code/electron-main/main.js.map
