/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/resources","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/map","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],re=function(_){for(var e=[],A=0,O=_.length;A<O;A++)e[A]=se[_[A]];return e};define(se[62],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function A(k){return(R,C,v)=>{let I=null,S=null;if(typeof v.value=="function"?(I="value",S=v.value):typeof v.get=="function"&&(I="get",S=v.get),!S)throw new Error("not supported");v[I]=k(S,C)}}function O(k,R,C){let v=null,I=null;if(typeof C.value=="function"?(v="value",I=C.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(v="get",I=C.get),!I)throw new Error("not supported");const S=`$memoize$${R}`;C[v]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,m)}),this[S]}}e.memoize=O;function l(k,R,C){return A((v,I)=>{const S=`$debounce$${I}`,m=`$debounce$result$${I}`;return function(...f){this[m]||(this[m]=C?C():void 0),clearTimeout(this[S]),R&&(this[m]=R(this[m],...f),f=[this[m]]),this[S]=setTimeout(()=>{v.apply(this,f),this[m]=C?C():void 0},k)}})}e.debounce=l;function D(k,R,C){return A((v,I)=>{const S=`$throttle$timer$${I}`,m=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,g=`$throttle$pending$${I}`;return function(...p){if(this[m]||(this[m]=C?C():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...p)),this[g])return;const h=this[f]+k;h<=Date.now()?(this[f]=Date.now(),v.apply(this,[this[m]]),this[m]=C?C():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[f]=Date.now(),v.apply(this,[this[m]]),this[m]=C?C():void 0},h-Date.now()))}})}e.throttle=D}),define(se[7],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class A{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?b.isErrorNoTelemetry(a)?new b(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=A,e.errorHandler=new A;function O(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=O;function l(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function D(t){v(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=D;function k(t){v(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=k;function R(t){if(t instanceof Error){const{name:a,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:n,noTelemetry:b.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=R;const C="Canceled";function v(t){return t instanceof I?!0:t instanceof Error&&t.name===C&&t.message===C}e.isCancellationError=v;class I extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=I;function S(){const t=new Error(C);return t.name=t.message,t}e.canceled=S;function m(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=m;function f(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=f;function g(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function p(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=p;function h(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=h;class u extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=u;class d extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=d;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class b extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof b)return a;const i=new b;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class P extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype);debugger}}e.BugIndicatingError=P}),define(se[18],re([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(G,Z=0){return G[G.length-(1+Z)]}e.tail=O;function l(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=l;function D(G,Z,te=(le,he)=>le===he){if(G===Z)return!0;if(!G||!Z||G.length!==Z.length)return!1;for(let le=0,he=G.length;le<he;le++)if(!te(G[le],Z[le]))return!1;return!0}e.equals=D;function k(G,Z){const te=G.length-1;Z<te&&(G[Z]=G[te]),G.pop()}e.removeFastWithoutKeepingOrder=k;function R(G,Z,te){return C(G.length,le=>te(G[le],Z))}e.binarySearch=R;function C(G,Z){let te=0,le=G-1;for(;te<=le;){const he=(te+le)/2|0,me=Z(he);if(me<0)te=he+1;else if(me>0)le=he-1;else return he}return-(te+1)}e.binarySearch2=C;function v(G,Z){let te=0,le=G.length;if(le===0)return 0;for(;te<le;){const he=Math.floor((te+le)/2);Z(G[he])?le=he:te=he+1}return te}e.findFirstInSorted=v;function I(G,Z,te){if(G=G|0,G>=Z.length)throw new TypeError("invalid index");const le=Z[Math.floor(Z.length*Math.random())],he=[],me=[],pe=[];for(const Se of Z){const Ce=te(Se,le);Ce<0?he.push(Se):Ce>0?me.push(Se):pe.push(Se)}return G<he.length?I(G,he,te):G<he.length+pe.length?pe[0]:I(G-(he.length+pe.length),me,te)}e.quickSelect=I;function S(G,Z){const te=[];let le;for(const he of G.slice(0).sort(Z))!le||Z(le[0],he)!==0?(le=[he],te.push(le)):le.push(he);return te}e.groupBy=S;function m(G,Z,te){const le=[];function he(Se,Ce,De){if(Ce===0&&De.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===Se?(ke.deleteCount+=Ce,ke.toInsert.push(...De)):le.push({start:Se,deleteCount:Ce,toInsert:De})}let me=0,pe=0;for(;;){if(me===G.length){he(me,0,Z.slice(pe));break}if(pe===Z.length){he(me,G.length-me,[]);break}const Se=G[me],Ce=Z[pe],De=te(Se,Ce);De===0?(me+=1,pe+=1):De<0?(he(me,1,[]),me+=1):De>0&&(he(me,0,[Ce]),pe+=1)}return le}e.sortedDiff=m;function f(G,Z,te){const le=m(G,Z,te),he=[],me=[];for(const pe of le)he.push(...G.slice(pe.start,pe.start+pe.deleteCount)),me.push(...pe.toInsert);return{removed:he,added:me}}e.delta=f;function g(G,Z,te){if(te===0)return[];const le=G.slice(0,te).sort(Z);return h(G,Z,le,te,G.length),le}e.top=g;function p(G,Z,te,le,he){return te===0?Promise.resolve([]):new Promise((me,pe)=>{(async()=>{const Se=G.length,Ce=G.slice(0,te).sort(Z);for(let De=te,ke=Math.min(te+le,Se);De<Se;De=ke,ke=Math.min(ke+le,Se)){if(De>te&&await new Promise(qe=>setTimeout(qe)),he&&he.isCancellationRequested)throw new A.CancellationError;h(G,Z,Ce,De,ke)}return Ce})().then(me,pe)})}e.topAsync=p;function h(G,Z,te,le,he){for(const me=te.length;le<he;le++){const pe=G[le];if(Z(pe,te[me-1])<0){te.pop();const Se=v(te,Ce=>Z(pe,Ce)<0);te.splice(Se,0,pe)}}}function u(G){return G.filter(Z=>!!Z)}e.coalesce=u;function d(G){let Z=0;for(let te=0;te<G.length;te++)G[te]&&(G[Z]=G[te],Z+=1);G.length=Z}e.coalesceInPlace=d;function y(G,Z,te){G.splice(te,0,G.splice(Z,1)[0])}e.move=y;function b(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=b;function P(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=P;function t(G,Z=te=>te){const te=new Set;return G.filter(le=>{const he=Z(le);return te.has(he)?!1:(te.add(he),!0)})}e.distinct=t;function a(G){const Z=new Set;return te=>{const le=G(te);return Z.has(le)?!1:(Z.add(le),!0)}}e.uniqueFilter=a;function i(G,Z){const te=n(G,Z);if(te!==-1)return G[te]}e.findLast=i;function n(G,Z){for(let te=G.length-1;te>=0;te--){const le=G[te];if(Z(le))return te}return-1}e.lastIndex=n;function r(G,Z){return G.length>0?G[0]:Z}e.firstOrDefault=r;function o(G,Z){return G.length>0?G[G.length-1]:Z}e.lastOrDefault=o;function s(G,Z,te=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(G.length,Z.length);he<me&&te(G[he],Z[he]);he++)le++;return le}e.commonPrefixLength=s;function c(G){return[].concat(...G)}e.flatten=c;function w(G,Z){let te=typeof Z=="number"?G:0;typeof Z=="number"?te=G:(te=0,Z=G);const le=[];if(te<=Z)for(let he=te;he<Z;he++)le.push(he);else for(let he=te;he>Z;he--)le.push(he);return le}e.range=w;function E(G,Z,te){return G.reduce((le,he)=>(le[Z(he)]=te?te(he):he,le),Object.create(null))}e.index=E;function L(G,Z){return G.push(Z),()=>T(G,Z)}e.insert=L;function T(G,Z){const te=G.indexOf(Z);if(te>-1)return G.splice(te,1),Z}e.remove=T;function F(G,Z,te){const le=G.slice(0,Z),he=G.slice(Z);return le.concat(te,he)}e.arrayInsert=F;function z(G,Z){let te;if(typeof Z=="number"){let le=Z;te=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let le=G.length-1;le>0;le-=1){const he=Math.floor(te()*(le+1)),me=G[le];G[le]=G[he],G[he]=me}}e.shuffle=z;function J(G,Z){const te=G.indexOf(Z);te>-1&&(G.splice(te,1),G.unshift(Z))}e.pushToStart=J;function Y(G,Z){const te=G.indexOf(Z);te>-1&&(G.splice(te,1),G.push(Z))}e.pushToEnd=Y;function W(G,Z){for(const te of Z)G.push(te)}e.pushMany=W;function N(G,Z){return Array.isArray(G)?G.map(Z):Z(G)}e.mapArrayOrNot=N;function B(G){return Array.isArray(G)?G:[G]}e.asArray=B;function ie(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=ie;function q(G,Z){for(const te of G){const le=Z(te);if(le!==void 0)return le}}e.mapFind=q;function x(G,Z,te){const le=K(G,Z),he=G.length,me=te.length;G.length=he+me;for(let pe=he-1;pe>=le;pe--)G[pe+me]=G[pe];for(let pe=0;pe<me;pe++)G[pe+le]=te[pe]}e.insertInto=x;function U(G,Z,te,le){const he=K(G,Z),me=G.splice(he,te);return x(G,he,le),me}e.splice=U;function K(G,Z){return Z<0?Math.max(Z+G.length,0):Math.min(Z,G.length)}var Q;(function(G){function Z(he){return he<0}G.isLessThan=Z;function te(he){return he>0}G.isGreaterThan=te;function le(he){return he===0}G.isNeitherLessOrGreaterThan=le,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function oe(G,Z){return(te,le)=>Z(G(te),G(le))}e.compareBy=oe;function ae(...G){return(Z,te)=>{for(const le of G){const he=le(Z,te);if(!Q.isNeitherLessOrGreaterThan(he))return he}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const V=(G,Z)=>G-Z;e.numberComparator=V;function j(G,Z){if(G.length===0)return;let te=G[0];for(let le=1;le<G.length;le++){const he=G[le];Z(he,te)>0&&(te=he)}return te}e.findMaxBy=j;function M(G,Z){if(G.length===0)return;let te=G[0];for(let le=1;le<G.length;le++){const he=G[le];Z(he,te)>=0&&(te=he)}return te}e.findLastMaxBy=M;function $(G,Z){return j(G,(te,le)=>-Z(te,le))}e.findMinBy=$;class H{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let te=this.c;for(;te<this.f.length&&Z(this.f[te]);)te++;const le=te===this.c?null:this.f.slice(this.c,te);return this.c=te,le}takeFromEndWhile(Z){let te=this.d;for(;te>=0&&Z(this.f[te]);)te--;const le=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const te=this.f.slice(this.c,this.c+Z);return this.c+=Z,te}}e.ArrayQueue=H;class ee{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(te=>(Z(te),!0))}toArray(){const Z=[];return this.iterate(te=>(Z.push(te),!0)),Z}filter(Z){return new ee(te=>this.iterate(le=>Z(le)?te(le):!0))}map(Z){return new ee(te=>this.iterate(le=>te(Z(le))))}some(Z){let te=!1;return this.iterate(le=>(te=Z(le),!te)),te}findFirst(Z){let te;return this.iterate(le=>Z(le)?(te=le,!1):!0),te}findLast(Z){let te;return this.iterate(le=>(Z(le)&&(te=le),!0)),te}findLastMaxBy(Z){let te,le=!0;return this.iterate(he=>((le||Q.isGreaterThan(Z(he,te)))&&(le=!1,te=he),!0)),te}}ee.empty=new ee(G=>{}),e.CallbackIterable=ee}),define(se[129],re([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(C,v){if(!C)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=O;function l(C,v="Unreachable"){throw new Error(v)}e.assertNever=l;function D(C){if(!C)throw new A.BugIndicatingError("Assertion Failed")}e.assert=D;function k(C){if(!C()){debugger;C(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function R(C,v){let I=0;for(;I<C.length-1;){const S=C[I],m=C[I+1];if(!v(S,m))return!1;I++}return!0}e.checkAdjacentItems=R}),define(se[82],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function A(O){const l=this;let D=!1,k;return function(){return D||(D=!0,k=O.apply(l,arguments)),k}}e.once=A}),define(se[63],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(O){function l(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}O.is=l;const D=Object.freeze([]);function k(){return D}O.empty=k;function*R(b){yield b}O.single=R;function C(b){return l(b)?b:R(b)}O.wrap=C;function v(b){return b||D}O.from=v;function I(b){return!b||b[Symbol.iterator]().next().done===!0}O.isEmpty=I;function S(b){return b[Symbol.iterator]().next().value}O.first=S;function m(b,P){for(const t of b)if(P(t))return!0;return!1}O.some=m;function f(b,P){for(const t of b)if(P(t))return t}O.find=f;function*g(b,P){for(const t of b)P(t)&&(yield t)}O.filter=g;function*p(b,P){let t=0;for(const a of b)yield P(a,t++)}O.map=p;function*h(...b){for(const P of b)for(const t of P)yield t}O.concat=h;function u(b,P,t){let a=t;for(const i of b)a=P(a,i);return a}O.reduce=u;function*d(b,P,t=b.length){for(P<0&&(P+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);P<t;P++)yield b[P]}O.slice=d;function y(b,P=Number.POSITIVE_INFINITY){const t=[];if(P===0)return[t,b];const a=b[Symbol.iterator]();for(let i=0;i<P;i++){const n=a.next();if(n.done)return[t,O.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return a}}]}O.consume=y})(A=e.Iterable||(e.Iterable={}))}),define(se[35],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var A;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(A=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function k(t,a=!1){let i=0;const n=t.length;let r="",o=0,s=16,c=0;function w(Y){let W=0,N=0;for(;W<Y;){const B=t.charCodeAt(i);if(B>=48&&B<=57)N=N*16+B-48;else if(B>=65&&B<=70)N=N*16+B-65+10;else if(B>=97&&B<=102)N=N*16+B-97+10;else break;i++,W++}return W<Y&&(N=-1),N}function E(Y){i=Y,r="",o=0,s=16,c=0}function L(){const Y=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&v(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&v(t.charCodeAt(i)))for(i++;i<t.length&&v(t.charCodeAt(i));)i++;else return c=3,t.substring(Y,i);let W=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&v(t.charCodeAt(i))){for(i++;i<t.length&&v(t.charCodeAt(i));)i++;W=i}else c=3;return t.substring(Y,W)}function T(){let Y="",W=i;for(;;){if(i>=n){Y+=t.substring(W,i),c=2;break}const N=t.charCodeAt(i);if(N===34){Y+=t.substring(W,i),i++;break}if(N===92){if(Y+=t.substring(W,i),i++,i>=n){c=2;break}switch(t.charCodeAt(i++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const ie=w(4);ie>=0?Y+=String.fromCharCode(ie):c=4;break}default:c=5}W=i;continue}if(N>=0&&N<=31)if(C(N)){Y+=t.substring(W,i),c=2;break}else c=6;i++}return Y}function F(){if(r="",c=0,o=i,i>=n)return o=n,s=17;let Y=t.charCodeAt(i);if(R(Y)){do i++,r+=String.fromCharCode(Y),Y=t.charCodeAt(i);while(R(Y));return s=15}if(C(Y))return i++,r+=String.fromCharCode(Y),Y===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch(Y){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=T(),s=10;case 47:{const W=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!C(t.charCodeAt(i));)i++;return r=t.substring(W,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const N=n-1;let B=!1;for(;i<N;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,B=!0;break}i++}return B||(i++,c=1),r=t.substring(W,i),s=13}return r+=String.fromCharCode(Y),i++,s=16}case 45:if(r+=String.fromCharCode(Y),i++,i===n||!v(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),s=11;default:for(;i<n&&z(Y);)i++,Y=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(Y),i++,s=16}}function z(Y){if(R(Y)||C(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let Y;do Y=F();while(Y>=12&&Y<=15);return Y}return{setPosition:E,getPosition:()=>i,scan:a?J:F,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>c}}e.createScanner=k;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function S(t,a){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function c(w,E,L,T){o.value=w,o.offset=E,o.length=L,o.type=T,o.colonOffset=void 0,r=o}try{y(t,{onObjectBegin:(w,E)=>{if(a<=w)throw n;r=void 0,s=a>w,i.push("")},onObjectProperty:(w,E,L)=>{if(a<E||(c(w,E,L,"property"),i[i.length-1]=w,a<=E+L))throw n},onObjectEnd:(w,E)=>{if(a<=w)throw n;r=void 0,i.pop()},onArrayBegin:(w,E)=>{if(a<=w)throw n;r=void 0,i.push(0)},onArrayEnd:(w,E)=>{if(a<=w)throw n;r=void 0,i.pop()},onLiteralValue:(w,E,L)=>{if(a<E||(c(w,E,L,P(w)),a<=E+L))throw n},onSeparator:(w,E,L)=>{if(a<=E)throw n;if(w===":"&&r&&r.type==="property")r.colonOffset=E,s=!1,r=void 0;else if(w===","){const T=i[i.length-1];typeof T=="number"?i[i.length-1]=T+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(w){if(w!==n)throw w}return{path:i,previousNode:r,isAtPropertyKey:s,matches:w=>{let E=0;for(let L=0;E<w.length&&L<i.length;L++)if(w[E]===i[L]||w[E]==="*")E++;else if(w[E]!=="**")return!1;return E===w.length}}}e.getLocation=S;function m(t,a=[],i=D.DEFAULT){let n=null,r=[];const o=[];function s(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}return y(t,{onObjectBegin:()=>{const w={};s(w),o.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const w=[];s(w),o.push(r),r=w,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:s,onError:(w,E,L)=>{a.push({error:w,offset:E,length:L})}},i),r[0]}e.parse=m;function f(t,a=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function o(w){return n.children.push(w),w}y(t,{onObjectBegin:w=>{n=o({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,E,L)=>{n=o({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:E,length:L,parent:n})},onObjectEnd:(w,E)=>{n.length=w+E-n.offset,n=n.parent,r(w+E)},onArrayBegin:(w,E)=>{n=o({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,E)=>{n.length=w+E-n.offset,n=n.parent,r(w+E)},onLiteralValue:(w,E,L)=>{o({type:P(w),offset:E,length:L,parent:n,value:w}),r(E+L)},onSeparator:(w,E,L)=>{n.type==="property"&&(w===":"?n.colonOffset=E:w===","&&r(E))},onError:(w,E,L)=>{a.push({error:w,offset:E,length:L})}},i);const c=n.children[0];return c&&delete c.parent,c}e.parseTree=f;function g(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=g;function p(t){if(!t.parent||!t.parent.children)return[];const a=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=p;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=h(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=h;function u(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=u;function d(t,a,i=!1){if(u(t,a,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const o=d(n[r],a,i);if(o)return o}return t}}e.findNodeAtOffset=d;function y(t,a,i=D.DEFAULT){const n=k(t,!1);function r(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(oe){return oe?ae=>oe(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=r(a.onObjectBegin),c=o(a.onObjectProperty),w=r(a.onObjectEnd),E=r(a.onArrayBegin),L=r(a.onArrayEnd),T=o(a.onLiteralValue),F=o(a.onSeparator),z=r(a.onComment),J=o(a.onError),Y=i&&i.disallowComments,W=i&&i.allowTrailingComma;function N(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:Y||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(oe){case 12:case 13:Y?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return oe}}}function B(oe,ae=[],V=[]){if(J(oe),ae.length+V.length>0){let j=n.getToken();for(;j!==17;){if(ae.indexOf(j)!==-1){N();break}else if(V.indexOf(j)!==-1)break;j=N()}}}function ie(oe){const ae=n.getTokenValue();return oe?T(ae):c(ae),N(),!0}function q(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(B(2),oe=0)}catch{B(2)}T(oe);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return N(),!0}function x(){return n.getToken()!==10?(B(3,[],[2,5]),!1):(ie(!1),n.getToken()===6?(F(":"),N(),Q()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function U(){s(),N();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||B(4,[],[]),F(","),N(),n.getToken()===2&&W)break}else oe&&B(6,[],[]);x()||B(4,[],[2,5]),oe=!0}return w(),n.getToken()!==2?B(7,[2],[]):N(),!0}function K(){E(),N();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||B(4,[],[]),F(","),N(),n.getToken()===4&&W)break}else oe&&B(6,[],[]);Q()||B(4,[],[4,5]),oe=!0}return L(),n.getToken()!==4?B(8,[4],[]):N(),!0}function Q(){switch(n.getToken()){case 3:return K();case 1:return U();case 10:return ie(!0);default:return q()}}return N(),n.getToken()===17?i.allowEmptyContent?!0:(B(4,[],[]),!1):Q()?(n.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=y;function b(t,a){const i=k(t),n=[];let r,o=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==s&&n.push(t.substring(o,s)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=b;function P(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(se[42],re([0,1,35]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(v,I,S){let m,f,g,p,h;if(I){for(p=I.offset,h=p+I.length,g=p;g>0&&!C(v,g-1);)g--;let s=h;for(;s<v.length&&!C(v,s);)s++;f=v.substring(g,s),m=k(f,S)}else f=v,m=0,g=0,p=0,h=v.length;const u=R(S,v);let d=!1,y=0,b;S.insertSpaces?b=D(" ",S.tabSize||4):b="	";const P=(0,A.createScanner)(f,!1);let t=!1;function a(){return u+D(b,m+y)}function i(){let s=P.scan();for(d=!1;s===15||s===14;)d=d||s===14,s=P.scan();return t=s===16||P.getTokenError()!==0,s}const n=[];function r(s,c,w){!t&&c<h&&w>p&&v.substring(c,w)!==s&&n.push({offset:c,length:w-c,content:s})}let o=i();if(o!==17){const s=P.getTokenOffset()+g,c=D(b,m);r(c,g,s)}for(;o!==17;){let s=P.getTokenOffset()+P.getTokenLength()+g,c=i(),w="";for(;!d&&(c===12||c===13);){const L=P.getTokenOffset()+g;r(" ",s,L),s=P.getTokenOffset()+P.getTokenLength()+g,w=c===12?a():"",c=i()}if(c===2)o!==1&&(y--,w=a());else if(c===4)o!==3&&(y--,w=a());else{switch(o){case 3:case 1:y++,w=a();break;case 5:case 12:w=a();break;case 13:d?w=a():w=" ";break;case 6:w=" ";break;case 10:if(c===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?w=" ":c!==5&&c!==17&&(t=!0);break;case 16:t=!0;break}d&&(c===12||c===13)&&(w=a())}const E=P.getTokenOffset()+g;r(w,s,E),o=c}return n}e.format=O;function l(v,I){const S=JSON.stringify(v,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?S.replace(/\r\n|\r|\n/g,I.eol):S}e.toFormattedString=l;function D(v,I){let S="";for(let m=0;m<I;m++)S+=v;return S}function k(v,I){let S=0,m=0;const f=I.tabSize||4;for(;S<v.length;){const g=v.charAt(S);if(g===" ")m++;else if(g==="	")m+=f;else break;S++}return Math.floor(m/f)}function R(v,I){for(let S=0;S<I.length;S++){const m=I.charAt(S);if(m==="\r")return S+1<I.length&&I.charAt(S+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=R;function C(v,I){return`\r
`.indexOf(v.charAt(I))!==-1}e.isEOL=C}),define(se[83],re([0,1,35,42]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(v,I,S){return D(v,I,void 0,S)}e.removeProperty=l;function D(v,I,S,m,f){const g=I.slice(),p=[],h=(0,A.parseTree)(v,p);let u,d;for(;g.length>0&&(d=g.pop(),u=(0,A.findNodeAtLocation)(h,g),u===void 0&&S!==void 0);)typeof d=="string"?S={[d]:S}:S=[S];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const y=(0,A.findNodeAtLocation)(u,[d]);if(y!==void 0)if(S===void 0){if(!y.parent)throw new Error("Malformed AST");const b=u.children.indexOf(y.parent);let P,t=y.parent.offset+y.parent.length;if(b>0){const a=u.children[b-1];P=a.offset+a.length}else P=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return k(v,{offset:P,length:t-P,content:""},m)}else return k(v,{offset:y.offset,length:y.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const b=`${JSON.stringify(d)}: ${JSON.stringify(S)}`,P=f?f(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(P>0){const a=u.children[P-1];t={offset:a.offset+a.length,length:0,content:","+b}}else u.children.length===0?t={offset:u.offset+1,length:0,content:b}:t={offset:u.offset+1,length:0,content:b+","};return k(v,t,m)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(S!==void 0){const y=`${JSON.stringify(S)}`;let b;if(u.children.length===0||d===0)b={offset:u.offset+1,length:0,content:u.children.length===0?y:y+","};else{const P=d===-1||d>u.children.length?u.children.length:d,t=u.children[P-1];b={offset:t.offset+t.length,length:0,content:","+y}}return k(v,b,m)}else{const y=d,b=u.children[y];let P;if(u.children.length===1)P={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===y){const t=u.children[y-1],a=t.offset+t.length,i=u.offset+u.length;P={offset:a,length:i-2-a,content:""}}else P={offset:b.offset,length:u.children[y+1].offset-b.offset,content:""};return k(v,P,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return k(v,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(S)},m)}}e.setProperty=D;function k(v,I,S){let m=R(v,I),f=I.offset,g=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;f>0&&!(0,O.isEOL)(m,f-1);)f--;for(;g<m.length&&!(0,O.isEOL)(m,g);)g++}const p=(0,O.format)(m,{offset:f,length:g-f},S);for(let u=p.length-1;u>=0;u--){const d=p[u];m=R(m,d),f=Math.min(f,d.offset),g=Math.max(g,d.offset+d.length),g+=d.content.length-d.length}const h=v.length-(m.length-g)-f;return[{offset:f,length:h,content:m.substring(f,g)}]}e.withFormatting=k;function R(v,I){return v.substring(0,I.offset)+I.content+v.substring(I.offset+I.length)}e.applyEdit=R;function C(v,I){const S=I.slice(0).sort((f,g)=>{const p=f.offset-g.offset;return p===0?f.length-g.length:p});let m=v.length;for(let f=S.length-1;f>=0;f--){const g=S[f];if(g.offset+g.length<=m)v=R(v,g);else throw new Error("Overlapping edit");m=g.offset}return v}e.applyEdits=C}),define(se[130],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class A{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=A}),define(se[2],re([0,1,82,63]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let D=null;function k(o){D=o}if(e.setDisposableTracker=k,l){const o="__is_disposable_tracked__";k(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==d.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==d.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function R(o){return D?.trackDisposable(o),o}function C(o){D?.markAsDisposed(o)}function v(o,s){D?.setParent(o,s)}function I(o,s){if(!!D)for(const c of o)D.setParent(c,s)}function S(o){return D?.markAsSingleton(o),o}e.markAsSingleton=S;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function f(o){if(O.Iterable.is(o)){const s=[];for(const c of o)if(c)try{c.dispose()}catch(w){s.push(w)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=f;function g(o){for(const s of o)m(s)&&s.dispose();return[]}e.disposeIfDisposable=g;function p(...o){const s=h(()=>f(o));return I(o,s),s}e.combinedDisposable=p;function h(o){const s=R({dispose:(0,A.once)(()=>{C(s),o()})});return s}e.toDisposable=h;class u{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(C(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return v(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class d{constructor(){this.q=new u,R(this),v(this.q,this)}dispose(){C(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}d.None=Object.freeze({dispose(){}}),e.Disposable=d;class y{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&v(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,C(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&v(s,null),s}}e.MutableDisposable=y;class b{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=b;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(s){let c=s;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,C(this))},this}}e.SafeDisposable=P;class t{constructor(){this.a=new Map}acquire(s,...c){let w=this.a.get(s);w||(w={counter:0,object:this.b(s,...c)},this.a.set(s,w));const{object:E}=w,L=(0,A.once)(()=>{--w.counter===0&&(this.c(s,w.object),this.a.delete(s))});return w.counter++,{object:E,dispose:L}}}e.ReferenceCollection=t;class a{constructor(s){this.a=s}async acquire(s,...c){const w=this.a.acquire(s,...c);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(E){throw w.dispose(),E}}}e.AsyncReferenceCollection=a;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(o){const s=new u;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n;class r{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){C(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,c,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(s)?.dispose(),this.a.set(s,c)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(se[84],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class A{constructor(D){this.element=D,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class O{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let D=this.a;for(;D!==A.Undefined;){const k=D.next;D.prev=A.Undefined,D.next=A.Undefined,D=k}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,k){const R=new A(D);if(this.a===A.Undefined)this.a=R,this.b=R;else if(k){const v=this.b;this.b=R,R.prev=v,v.next=R}else{const v=this.a;this.a=R,R.next=v,v.prev=R}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(R))}}shift(){if(this.a!==A.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==A.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==A.Undefined&&D.next!==A.Undefined){const k=D.prev;k.next=D.next,D.next.prev=k}else D.prev===A.Undefined&&D.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):D.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):D.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==A.Undefined;)yield D.element,D=D.next}}e.LinkedList=O}),define(se[38],re([0,1]),function(_,e){"use strict";var A,O,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function D(g,p,h){let u=g.get(p);return u===void 0&&(u=h,g.set(p,u)),u}e.getOrSet=D;function k(g){const p=[];return g.forEach((h,u)=>{p.push(`${u} => ${h}`)}),`Map(${g.size}) {${p.join(", ")}}`}e.mapToString=k;function R(g){const p=[];return g.forEach(h=>{p.push(h)}),`Set(${g.size}) {${p.join(", ")}}`}e.setToString=R;class C{constructor(p,h){this.uri=p,this.value=h}}class v{constructor(p,h){this[A]="ResourceMap",p instanceof v?(this.b=new Map(p.b),this.c=h??v.a):(this.b=new Map,this.c=p??v.a)}set(p,h){return this.b.set(this.c(p),new C(p,h)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,h){typeof h<"u"&&(p=p.bind(h));for(const[u,d]of this.b)p(d.value,d.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}v.a=g=>g.toString(),e.ResourceMap=v;class I{constructor(p,h){this[O]="ResourceSet",!p||typeof p=="function"?this.a=new v(p):(this.a=new v(h),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,h){this.a.forEach((u,d)=>p.call(h,d,d,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var S;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class m{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,h=0){const u=this.a.get(p);if(!!u)return h!==0&&this.j(u,h),u.value}set(p,h,u=0){let d=this.a.get(p);if(d)d.value=h,u!==0&&this.j(d,u);else{switch(d={key:p,value:h,next:void 0,previous:void 0},u){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(p,d),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const h=this.a.get(p);if(!!h)return this.a.delete(p),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,h){const u=this.e;let d=this.b;for(;d;){if(h?p.bind(h)(d.value,d.key,this):p(d.value,d.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const p=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.key,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return d}values(){const p=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:u.value,done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return d}entries(){const p=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const y={value:[u.key,u.value],done:!1};return u=u.next,y}else return{value:void 0,done:!0}}};return d}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>p;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const h=p.next,u=p.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}p.next=void 0,p.previous=void 0,this.e++}j(p,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(p===this.b)return;const u=p.next,d=p.previous;p===this.c?(d.next=void 0,this.c=d):(u.previous=d,d.next=u),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(h===2){if(p===this.c)return;const u=p.next,d=p.previous;p===this.b?(u.previous=void 0,this.b=u):(u.previous=d,d.next=u),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((h,u)=>{p.push([u,h])}),p}fromJSON(p){this.clear();for(const[h,u]of p)this.set(h,u)}}e.LinkedMap=m;class f extends m{constructor(p,h=1){super(),this.k=p,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,h=2){return super.get(p,h)}peek(p){return super.get(p,0)}set(p,h){return super.set(p,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(se[85],re([0,1,38]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new A.LRUCache(1e4);function l(v){return C(v,"NFC",O)}e.normalizeNFC=l;const D=new A.LRUCache(1e4);function k(v){return C(v,"NFD",D)}e.normalizeNFD=k;const R=/[^\u0000-\u0080]/;function C(v,I,S){if(!v)return v;const m=S.get(v);if(m)return m;let f;return R.test(v)?f=v.normalize(I):f=v,S.set(v,f),f}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(I){return k(I).replace(v,"")}}()}),define(se[131],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function A(R,C,v){return Math.min(Math.max(R,C),v)}e.clamp=A;function O(R,C){return(C+R%C)%C}e.rot=O;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class D{constructor(){this.a=1,this.b=0}update(C){return this.b=this.b+(C-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class k{constructor(C){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(C),this.c.fill(0,0,C)}update(C){const v=this.c[this.d];return this.c[this.d]=C,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=C,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function _(l){const D=[];typeof l=="number"&&D.push("code/timeOrigin",l);function k(C){D.push(C,Date.now())}function R(){const C=[];for(let v=0;v<D.length;v+=2)C.push({name:D[v],startTime:D[v+1]});return C}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(l+k.startTime)});return D}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function A(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=A(O))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var O in A)(typeof exports=="object"?exports:_)[O]=A[O]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function A(O){if(e[O])return e[O].exports;var l=e[O]={i:O,l:!1,exports:{}};return _[O].call(l.exports,l,l.exports,A),l.l=!0,l.exports}return A.m=_,A.c=e,A.d=function(O,l,D){A.o(O,l)||Object.defineProperty(O,l,{enumerable:!0,get:D})},A.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},A.t=function(O,l){if(1&l&&(O=A(O)),8&l||4&l&&typeof O=="object"&&O&&O.__esModule)return O;var D=Object.create(null);if(A.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:O}),2&l&&typeof O!="string")for(var k in O)A.d(D,k,function(R){return O[R]}.bind(null,k));return D},A.n=function(O){var l=O&&O.__esModule?function(){return O.default}:function(){return O};return A.d(l,"a",l),l},A.o=function(O,l){return Object.prototype.hasOwnProperty.call(O,l)},A.p="",A(A.s=0)}([function(_,e,A){(function(O){var l;e=_.exports=V,l=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],v=0,I=v++;C[I]="0|[1-9]\\d*";var S=v++;C[S]="[0-9]+";var m=v++;C[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=v++;C[f]="("+C[I]+")\\.("+C[I]+")\\.("+C[I]+")";var g=v++;C[g]="("+C[S]+")\\.("+C[S]+")\\.("+C[S]+")";var p=v++;C[p]="(?:"+C[I]+"|"+C[m]+")";var h=v++;C[h]="(?:"+C[S]+"|"+C[m]+")";var u=v++;C[u]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var d=v++;C[d]="(?:-?("+C[h]+"(?:\\."+C[h]+")*))";var y=v++;C[y]="[0-9A-Za-z-]+";var b=v++;C[b]="(?:\\+("+C[y]+"(?:\\."+C[y]+")*))";var P=v++,t="v?"+C[f]+C[u]+"?"+C[b]+"?";C[P]="^"+t+"$";var a="[v=\\s]*"+C[g]+C[d]+"?"+C[b]+"?",i=v++;C[i]="^"+a+"$";var n=v++;C[n]="((?:<|>)?=?)";var r=v++;C[r]=C[S]+"|x|X|\\*";var o=v++;C[o]=C[I]+"|x|X|\\*";var s=v++;C[s]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[u]+")?"+C[b]+"?)?)?";var c=v++;C[c]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[d]+")?"+C[b]+"?)?)?";var w=v++;C[w]="^"+C[n]+"\\s*"+C[s]+"$";var E=v++;C[E]="^"+C[n]+"\\s*"+C[c]+"$";var L=v++;C[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=v++;C[T]="(?:~>?)";var F=v++;C[F]="(\\s*)"+C[T]+"\\s+",R[F]=new RegExp(C[F],"g");var z=v++;C[z]="^"+C[T]+C[s]+"$";var J=v++;C[J]="^"+C[T]+C[c]+"$";var Y=v++;C[Y]="(?:\\^)";var W=v++;C[W]="(\\s*)"+C[Y]+"\\s+",R[W]=new RegExp(C[W],"g");var N=v++;C[N]="^"+C[Y]+C[s]+"$";var B=v++;C[B]="^"+C[Y]+C[c]+"$";var ie=v++;C[ie]="^"+C[n]+"\\s*("+a+")$|^$";var q=v++;C[q]="^"+C[n]+"\\s*("+t+")$|^$";var x=v++;C[x]="(\\s*)"+C[n]+"\\s*("+a+"|"+C[s]+")",R[x]=new RegExp(C[x],"g");var U=v++;C[U]="^\\s*("+C[s]+")\\s+-\\s+("+C[s]+")\\s*$";var K=v++;C[K]="^\\s*("+C[c]+")\\s+-\\s+("+C[c]+")\\s*$";var Q=v++;C[Q]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)l(oe,C[oe]),R[oe]||(R[oe]=new RegExp(C[oe]));function ae(ce,fe){if(ce instanceof V)return ce;if(typeof ce!="string"||ce.length>D||!(fe?R[i]:R[P]).test(ce))return null;try{return new V(ce,fe)}catch{return null}}function V(ce,fe){if(ce instanceof V){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof V))return new V(ce,fe);l("SemVer",ce,fe),this.loose=fe;var de=ce.trim().match(fe?R[i]:R[P]);if(!de)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<k)return Pe}return Ie}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var de=ae(ce,fe);return de?de.version:null},e.clean=function(ce,fe){var de=ae(ce.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(ce){return l("SemVer.compare",this.version,this.loose,ce),ce instanceof V||(ce=new V(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},V.prototype.compareMain=function(ce){return ce instanceof V||(ce=new V(ce,this.loose)),M(this.major,ce.major)||M(this.minor,ce.minor)||M(this.patch,ce.patch)},V.prototype.comparePre=function(ce){if(ce instanceof V||(ce=new V(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],Ie=ce.prerelease[fe];if(l("prerelease compare",fe,de,Ie),de===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(de===void 0)return-1;if(de!==Ie)return M(de,Ie)}while(++fe)},V.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,de,Ie){typeof de=="string"&&(Ie=de,de=void 0);try{return new V(ce,de).inc(fe,Ie).version}catch{return null}},e.diff=function(ce,fe){if(G(ce,fe))return null;var de=ae(ce),Ie=ae(fe);if(de.prerelease.length||Ie.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=M;var j=/^[0-9]+$/;function M(ce,fe){var de=j.test(ce),Ie=j.test(fe);return de&&Ie&&(ce=+ce,fe=+fe),de&&!Ie?-1:Ie&&!de?1:ce<fe?-1:ce>fe?1:0}function $(ce,fe,de){return new V(ce,de).compare(new V(fe,de))}function H(ce,fe,de){return $(ce,fe,de)>0}function ee(ce,fe,de){return $(ce,fe,de)<0}function G(ce,fe,de){return $(ce,fe,de)===0}function Z(ce,fe,de){return $(ce,fe,de)!==0}function te(ce,fe,de){return $(ce,fe,de)>=0}function le(ce,fe,de){return $(ce,fe,de)<=0}function he(ce,fe,de,Ie){var Pe;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof de=="object"&&(de=de.version),Pe=ce===de;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof de=="object"&&(de=de.version),Pe=ce!==de;break;case"":case"=":case"==":Pe=G(ce,de,Ie);break;case"!=":Pe=Z(ce,de,Ie);break;case">":Pe=H(ce,de,Ie);break;case">=":Pe=te(ce,de,Ie);break;case"<":Pe=ee(ce,de,Ie);break;case"<=":Pe=le(ce,de,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function me(ce,fe){if(ce instanceof me){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof me))return new me(ce,fe);l("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ce,fe){return M(fe,ce)},e.major=function(ce,fe){return new V(ce,fe).major},e.minor=function(ce,fe){return new V(ce,fe).minor},e.patch=function(ce,fe){return new V(ce,fe).patch},e.compare=$,e.compareLoose=function(ce,fe){return $(ce,fe,!0)},e.rcompare=function(ce,fe,de){return $(fe,ce,de)},e.sort=function(ce,fe){return ce.sort(function(de,Ie){return e.compare(de,Ie,fe)})},e.rsort=function(ce,fe){return ce.sort(function(de,Ie){return e.rcompare(de,Ie,fe)})},e.gt=H,e.lt=ee,e.eq=G,e.neq=Z,e.gte=te,e.lte=le,e.cmp=he,e.Comparator=me;var pe={};function Se(ce,fe){if(ce instanceof Se)return ce.loose===fe?ce:new Se(ce.raw,fe);if(ce instanceof me)return new Se(ce.value,fe);if(!(this instanceof Se))return new Se(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function De(ce,fe,de,Ie,Pe,Fe,Ae,je,Me,Ne,Be,ne,ue){return((fe=Ce(de)?"":Ce(Ie)?">="+de+".0.0":Ce(Pe)?">="+de+"."+Ie+".0":">="+fe)+" "+(je=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(Be)?"<"+Me+"."+(+Ne+1)+".0":ne?"<="+Me+"."+Ne+"."+Be+"-"+ne:"<="+je)).trim()}function ke(ce,fe){for(var de=0;de<ce.length;de++)if(!ce[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ce.length;de++)if(l(ce[de].semver),ce[de].semver!==pe&&ce[de].semver.prerelease.length>0){var Ie=ce[de].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function qe(ce,fe,de){try{fe=new Se(fe,de)}catch{return!1}return fe.test(ce)}function Ye(ce,fe,de,Ie){var Pe,Fe,Ae,je,Me;switch(ce=new V(ce,Ie),fe=new Se(fe,Ie),de){case">":Pe=H,Fe=le,Ae=ee,je=">",Me=">=";break;case"<":Pe=ee,Fe=te,Ae=H,je="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(ce,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var Be=fe.set[Ne],ne=null,ue=null;if(Be.forEach(function(ge){ge.semver===pe&&(ge=new me(">=0.0.0")),ne=ne||ge,ue=ue||ge,Pe(ge.semver,ne.semver,Ie)?ne=ge:Ae(ge.semver,ue.semver,Ie)&&(ue=ge)}),ne.operator===je||ne.operator===Me||(!ue.operator||ue.operator===je)&&Fe(ce,ue.semver)||ue.operator===Me&&Ae(ce,ue.semver))return!1}return!0}me.prototype.parse=function(ce){var fe=this.loose?R[ie]:R[q],de=ce.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ce);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new V(de[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(ce){return l("Comparator.test",ce,this.loose),this.semver===pe||(typeof ce=="string"&&(ce=new V(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ce,fe){if(!(ce instanceof me))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Se(ce.value,fe),qe(this.value,de,fe);if(ce.operator==="")return de=new Se(this.value,fe),qe(ce.semver,de,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Fe=this.semver.version===ce.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ie||Pe||Fe&&Ae||je||Me},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),l("range",ce,fe);var de=fe?R[K]:R[U];ce=ce.replace(de,De),l("hyphen replace",ce),ce=ce.replace(R[x],"$1$2$3"),l("comparator trim",ce,R[x]),ce=(ce=(ce=ce.replace(R[F],"$1~")).replace(R[W],"$1^")).split(/\s+/).join(" ");var Ie=fe?R[ie]:R[q],Pe=ce.split(" ").map(function(Fe){return function(Ae,je){return l("comp",Ae),Ae=function(Me,Ne){return Me.trim().split(/\s+/).map(function(Be){return function(ne,ue){l("caret",ne,ue);var ge=ue?R[B]:R[N];return ne.replace(ge,function(we,ve,Ee,Re,Le){var Te;return l("caret",ne,we,ve,Ee,Re,Le),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Le?(l("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+Le+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+Le+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+Le+" <"+(+ve+1)+".0.0"):(l("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+" <"+(+ve+1)+".0.0"),l("caret return",Te),Te})}(Be,Ne)}).join(" ")}(Ae,je),l("caret",Ae),Ae=function(Me,Ne){return Me.trim().split(/\s+/).map(function(Be){return function(ne,ue){var ge=ue?R[J]:R[z];return ne.replace(ge,function(we,ve,Ee,Re,Le){var Te;return l("tilde",ne,we,ve,Ee,Re,Le),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Le?(l("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Te=">="+ve+"."+Ee+"."+Re+Le+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0",l("tilde return",Te),Te})}(Be,Ne)}).join(" ")}(Ae,je),l("tildes",Ae),Ae=function(Me,Ne){return l("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(Be){return function(ne,ue){ne=ne.trim();var ge=ue?R[E]:R[w];return ne.replace(ge,function(we,ve,Ee,Re,Le,Te){l("xRange",ne,we,ve,Ee,Re,Le,Te);var Ue=Ce(Ee),$e=Ue||Ce(Re),ze=$e||Ce(Le);return ve==="="&&ze&&(ve=""),Ue?we=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?($e&&(Re=0),ze&&(Le=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,Re=0,Le=0):ze&&(Re=+Re+1,Le=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:Re=+Re+1),we=ve+Ee+"."+Re+"."+Le):$e?we=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(we=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),l("xRange return",we),we})}(Be,Ne)}).join(" ")}(Ae,je),l("xrange",Ae),Ae=function(Me,Ne){return l("replaceStars",Me,Ne),Me.trim().replace(R[Q],"")}(Ae,je),l("stars",Ae),Ae}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new me(Fe,fe)})},Se.prototype.intersects=function(ce,fe){if(!(ce instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ie){return ce.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ce,fe){return new Se(ce,fe).set.map(function(de){return de.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new V(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ce))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(ce,fe,de){var Ie=null,Pe=null;try{var Fe=new Se(fe,de)}catch{return null}return ce.forEach(function(Ae){Fe.test(Ae)&&(Ie&&Pe.compare(Ae)!==-1||(Pe=new V(Ie=Ae,de)))}),Ie},e.minSatisfying=function(ce,fe,de){var Ie=null,Pe=null;try{var Fe=new Se(fe,de)}catch{return null}return ce.forEach(function(Ae){Fe.test(Ae)&&(Ie&&Pe.compare(Ae)!==1||(Pe=new V(Ie=Ae,de)))}),Ie},e.validRange=function(ce,fe){try{return new Se(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,de){return Ye(ce,fe,"<",de)},e.gtr=function(ce,fe,de){return Ye(ce,fe,">",de)},e.outside=Ye,e.prerelease=function(ce,fe){var de=ae(ce,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ce,fe,de){return ce=new Se(ce,de),fe=new Se(fe,de),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof V)return ce;if(typeof ce!="string")return null;var fe=ce.match(R[L]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,A(1))},function(_,e){var A,O,l=_.exports={};function D(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(h){if(A===setTimeout)return setTimeout(h,0);if((A===D||!A)&&setTimeout)return A=setTimeout,setTimeout(h,0);try{return A(h,0)}catch{try{return A.call(null,h,0)}catch{return A.call(this,h,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:D}catch{A=D}try{O=typeof clearTimeout=="function"?clearTimeout:k}catch{O=k}})();var C,v=[],I=!1,S=-1;function m(){I&&C&&(I=!1,C.length?v=C.concat(v):S=-1,v.length&&f())}function f(){if(!I){var h=R(m);I=!0;for(var u=v.length;u;){for(C=v,v=[];++S<u;)C&&C[S].run();S=-1,u=v.length}C=null,I=!1,function(d){if(O===clearTimeout)return clearTimeout(d);if((O===k||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(d);try{O(d)}catch{try{return O.call(null,d)}catch{return O.call(this,d)}}}(h)}}function g(h,u){this.fun=h,this.array=u}function p(){}l.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];v.push(new g(h,u)),v.length!==1||I||R(f)},g.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=p,l.addListener=p,l.once=p,l.off=p,l.removeListener=p,l.removeAllListeners=p,l.emit=p,l.prependListener=p,l.prependOnceListener=p,l.listeners=function(h){return[]},l.binding=function(h){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(h){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(se[132],re([0,1]),function(_,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(R,C,v){this.level=R,this.key=C,this.value=v,this.forward=[]}}const l=void 0;class D{constructor(R,C=2**16){this.comparator=R,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new O(this.c,l,l)}get size(){return this.f}clear(){this.e=new O(this.c,l,l)}has(R){return Boolean(D.g(this,R,this.comparator))}get(R){return D.g(this,R,this.comparator)?.value}set(R,C){return D.h(this,R,C,this.comparator)&&(this.f+=1),this}delete(R){const C=D.k(this,R,this.comparator);return C&&(this.f-=1),C}forEach(R,C){let v=this.e.forward[0];for(;v;)R.call(C,v.value,v.key,this),v=v.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this.e.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static g(R,C,v){let I=R.e;for(let S=R.d-1;S>=0;S--)for(;I.forward[S]&&v(I.forward[S].key,C)<0;)I=I.forward[S];if(I=I.forward[0],I&&v(I.key,C)===0)return I}static h(R,C,v,I){const S=[];let m=R.e;for(let f=R.d-1;f>=0;f--){for(;m.forward[f]&&I(m.forward[f].key,C)<0;)m=m.forward[f];S[f]=m}if(m=m.forward[0],m&&I(m.key,C)===0)return m.value=v,!1;{const f=D.j(R);if(f>R.d){for(let g=R.d;g<f;g++)S[g]=R.e;R.d=f}m=new O(f,C,v);for(let g=0;g<f;g++)m.forward[g]=S[g].forward[g],S[g].forward[g]=m;return!0}}static j(R,C=.5){let v=1;for(;Math.random()<C&&v<R.c;)v+=1;return v}static k(R,C,v){const I=[];let S=R.e;for(let m=R.d-1;m>=0;m--){for(;S.forward[m]&&v(S.forward[m].key,C)<0;)S=S.forward[m];I[m]=S}if(S=S.forward[0],!S||v(S.key,C)!==0)return!1;for(let m=0;m<R.d&&I[m].forward[m]===S;m++)I[m].forward[m]=S.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===l;)R.d-=1;return!0}}e.SkipList=D}),define(se[43],re([0,1,7,2]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(b){const P=b;return P?typeof P.read=="function":!1}e.isReadable=l;function D(b){const P=b;return P?[P.on,P.pause,P.resume,P.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function k(b){const P=b;return P?D(P.stream)&&Array.isArray(P.buffer)&&typeof P.ended=="boolean":!1}e.isReadableBufferedStream=k;function R(b,P){return new C(b,P)}e.newWriteableStream=R;class C{constructor(P,t){this.e=P,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(P){if(!this.a.destroyed){if(this.a.flowing)this.g(P);else if(this.b.data.push(P),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(P){this.a.destroyed||(this.a.flowing?this.h(P):this.b.error.push(P))}end(P){this.a.destroyed||(typeof P<"u"&&this.write(P),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(P){this.c.data.slice(0).forEach(t=>t(P))}h(P){this.c.error.length===0?(0,A.onUnexpectedError)(P):this.c.error.slice(0).forEach(t=>t(P))}i(){this.c.end.slice(0).forEach(P=>P())}on(P,t){if(!this.a.destroyed)switch(P){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(P,t){if(this.a.destroyed)return;let a;switch(P){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const P=this.e(this.b.data);this.g(P),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const P of this.b.error)this.h(P);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(b,P){const t=[];let a;for(;(a=b.read())!==null;)t.push(a);return P(t)}e.consumeReadable=v;function I(b,P,t){const a=[];let i;for(;(i=b.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?P(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return b.read()}}}e.peekReadable=I;function S(b,P){return new Promise((t,a)=>{const i=[];m(b,{onData:n=>{P&&i.push(n)},onError:n=>{P?a(n):t(void 0)},onEnd:()=>{t(P?P(i):void 0)}})})}e.consumeStream=S;function m(b,P){let t=!1;return b.on("error",a=>{t||P.onError(a)}),b.on("end",()=>{t||P.onEnd()}),b.on("data",a=>{t||P.onData(a)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=m;function f(b,P){return new Promise((t,a)=>{const i=new O.DisposableStore,n=[],r=c=>{if(n.push(c),n.length>P)return i.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},o=c=>a(c),s=()=>t({stream:b,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>b.removeListener("error",o))),b.on("error",o),i.add((0,O.toDisposable)(()=>b.removeListener("end",s))),b.on("end",s),i.add((0,O.toDisposable)(()=>b.removeListener("data",r))),b.on("data",r)})}e.peekStream=f;function g(b,P){const t=R(P);return t.end(b),t}e.toStream=g;function p(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=p;function h(b){let P=!1;return{read:()=>P?null:(P=!0,b)}}e.toReadable=h;function u(b,P,t){const a=R(t);return m(b,{onData:i=>a.write(P.data(i)),onError:i=>a.error(P.error?P.error(i):i),onEnd:()=>a.end()}),a}e.transform=u;function d(b,P,t){let a=!1;return{read:()=>{const i=P.read();return a?i:(a=!0,i!==null?t([b,i]):b)}}}e.prefixedReadable=d;function y(b,P,t){let a=!1;const i=R(t);return m(P,{onData:n=>a?i.write(n):(a=!0,i.write(t([b,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(b)),i.end()}}),i}e.prefixedStream=y}),define(se[17],re([0,1,43]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let l,D;class k{static alloc(c){return O?new k(Buffer.allocUnsafe(c)):new k(new Uint8Array(c))}static wrap(c){return O&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new k(c)}static fromString(c,w){return!(w?.dontUseNodeBuffer||!1)&&O?new k(Buffer.from(c)):(l||(l=new TextEncoder),new k(l.encode(c)))}static fromByteArray(c){const w=k.alloc(c.length);for(let E=0,L=c.length;E<L;E++)w.buffer[E]=c[E];return w}static concat(c,w){if(typeof w>"u"){w=0;for(let T=0,F=c.length;T<F;T++)w+=c[T].byteLength}const E=k.alloc(w);let L=0;for(let T=0,F=c.length;T<F;T++){const z=c[T];E.set(z,L),L+=z.byteLength}return E}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=k.alloc(this.byteLength);return c.set(this),c}toString(){return O?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(c,w){return new k(this.buffer.subarray(c,w))}set(c,w){if(c instanceof k)this.buffer.set(c.buffer,w);else if(c instanceof Uint8Array)this.buffer.set(c,w);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),w);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return v(this.buffer,c)}writeUInt32BE(c,w){I(this.buffer,c,w)}readUInt32LE(c){return S(this.buffer,c)}writeUInt32LE(c,w){m(this.buffer,c,w)}readUInt8(c){return f(this.buffer,c)}writeUInt8(c,w){g(this.buffer,c,w)}}e.VSBuffer=k;function R(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0}e.readUInt16LE=R;function C(s,c,w){s[w+0]=c&255,c=c>>>8,s[w+1]=c&255}e.writeUInt16LE=C;function v(s,c){return s[c]*2**24+s[c+1]*2**16+s[c+2]*2**8+s[c+3]}e.readUInt32BE=v;function I(s,c,w){s[w+3]=c,c=c>>>8,s[w+2]=c,c=c>>>8,s[w+1]=c,c=c>>>8,s[w]=c}e.writeUInt32BE=I;function S(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0|s[c+2]<<16>>>0|s[c+3]<<24>>>0}e.readUInt32LE=S;function m(s,c,w){s[w+0]=c&255,c=c>>>8,s[w+1]=c&255,c=c>>>8,s[w+2]=c&255,c=c>>>8,s[w+3]=c&255}e.writeUInt32LE=m;function f(s,c){return s[c]}e.readUInt8=f;function g(s,c,w){s[w]=c}e.writeUInt8=g;function p(s){return A.consumeReadable(s,c=>k.concat(c))}e.readableToBuffer=p;function h(s){return A.toReadable(s)}e.bufferToReadable=h;function u(s){return A.consumeStream(s,c=>k.concat(c))}e.streamToBuffer=u;async function d(s){return s.ended?k.concat(s.buffer):k.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=d;function y(s){return A.toStream(s,c=>k.concat(c))}e.bufferToStream=y;function b(s){return A.transform(s,{data:c=>typeof c=="string"?k.fromString(c):k.wrap(c)},c=>k.concat(c))}e.streamToBufferReadableStream=b;function P(s){return A.newWriteableStream(c=>k.concat(c),s)}e.newWriteableBufferStream=P;function t(s,c){return A.prefixedReadable(s,c,w=>k.concat(w))}e.prefixedBufferReadable=t;function a(s,c){return A.prefixedStream(s,c,w=>k.concat(w))}e.prefixedBufferStream=a;function i(s){let c=0,w=0,E=0;const L=new Uint8Array(Math.floor(s.length/4*3)),T=z=>{switch(w){case 3:L[E++]=c|z,w=0;break;case 2:L[E++]=c|z>>>2,c=z<<6,w=3;break;case 1:L[E++]=c|z>>>4,c=z<<4,w=2;break;default:c=z<<2,w=1}};for(let z=0;z<s.length;z++){const J=s.charCodeAt(z);if(J>=65&&J<=90)T(J-65);else if(J>=97&&J<=122)T(J-97+26);else if(J>=48&&J<=57)T(J-48+52);else if(J===43||J===45)T(62);else if(J===47||J===95)T(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${s[z]}`)}}const F=E;for(;w>0;)T(0);return k.wrap(L).slice(0,F)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:s},c=!0,w=!1){const E=w?r:n;let L="";const T=s.byteLength%3;let F=0;for(;F<s.byteLength-T;F+=3){const z=s[F+0],J=s[F+1],Y=s[F+2];L+=E[z>>>2],L+=E[(z<<4|J>>>4)&63],L+=E[(J<<2|Y>>>6)&63],L+=E[Y&63]}if(T===1){const z=s[F+0];L+=E[z>>>2],L+=E[z<<4&63],c&&(L+="==")}else if(T===2){const z=s[F+0],J=s[F+1];L+=E[z>>>2],L+=E[(z<<4|J>>>4)&63],L+=E[J<<2&63],c&&(L+="=")}return L}e.encodeBase64=o}),define(se[133],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(se[12],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function A(a){return typeof a=="string"}e.isString=A;function O(a){return Array.isArray(a)&&a.every(i=>A(i))}e.isStringArray=O;function l(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=l;function D(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=D;function k(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=k;function R(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=R;function C(a){return a===!0||a===!1}e.isBoolean=C;function v(a){return typeof a>"u"}e.isUndefined=v;function I(a){return!S(a)}e.isDefined=I;function S(a){return v(a)||a===null}e.isUndefinedOrNull=S;function m(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=m;function f(a){if(S(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function g(...a){const i=[];for(let n=0;n<a.length;n++){const r=a[n];if(S(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(r)}return i}e.assertAllDefined=g;const p=Object.prototype.hasOwnProperty;function h(a){if(!l(a))return!1;for(const i in a)if(p.call(a,i))return!1;return!0}e.isEmptyObject=h;function u(a){return typeof a=="function"}e.isFunction=u;function d(...a){return a.length>0&&a.every(u)}e.areFunctions=d;function y(a,i){const n=Math.min(a.length,i.length);for(let r=0;r<n;r++)b(a[r],i[r])}e.validateConstraints=y;function b(a,i){if(A(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(a instanceof i)return}catch{}if(!S(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function P(a){return a===null?void 0:a}e.withNullAsUndefined=P;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(se[52],re([0,1,12]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const O=Object.create(null);function l(R,C){if((0,A.isString)(C)){const v=O[C];if(v===void 0)throw new Error(`${R} references an unknown codicon: ${C}`);C=v}return O[R]=C,{id:R}}function D(){return O}e.getCodiconFontCharacters=D;function k(){return Object.values(e.Codicon)}e.getAllCodicons=k,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(se[32],re([0,1,12]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([y,b])=>{d[y]=b&&typeof b=="object"?O(b):b}),d}e.deepClone=O;function l(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const y=d.shift();Object.freeze(y);for(const b in y)if(D.call(y,b)){const P=y[b];typeof P=="object"&&!Object.isFrozen(P)&&!(0,A.isTypedArray)(P)&&d.push(P)}}return u}e.deepFreeze=l;const D=Object.prototype.hasOwnProperty;function k(u,d){return R(u,d,new Set)}e.cloneAndChange=k;function R(u,d,y){if((0,A.isUndefinedOrNull)(u))return u;const b=d(u);if(typeof b<"u")return b;if(Array.isArray(u)){const P=[];for(const t of u)P.push(R(t,d,y));return P}if((0,A.isObject)(u)){if(y.has(u))throw new Error("Cannot clone recursive data-structure");y.add(u);const P={};for(const t in u)D.call(u,t)&&(P[t]=R(u[t],d,y));return y.delete(u),P}return u}function C(u,d,y=!0){return(0,A.isObject)(u)?((0,A.isObject)(d)&&Object.keys(d).forEach(b=>{b in u?y&&((0,A.isObject)(u[b])&&(0,A.isObject)(d[b])?C(u[b],d[b],y):u[b]=d[b]):u[b]=d[b]}),u):d}e.mixin=C;function v(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let y,b;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(y=0;y<u.length;y++)if(!v(u[y],d[y]))return!1}else{const P=[];for(b in u)P.push(b);P.sort();const t=[];for(b in d)t.push(b);if(t.sort(),!v(P,t))return!1;for(y=0;y<P.length;y++)if(!v(u[P[y]],d[P[y]]))return!1}return!0}e.equals=v;function I(u){const d=new Set;return JSON.stringify(u,(y,b)=>{if((0,A.isObject)(b)||Array.isArray(b)){if(d.has(b))return"[Circular]";d.add(b)}return b})}e.safeStringify=I;function S(u,d){const y=Object.create(null);return!u||!d||Object.keys(d).forEach(P=>{const t=u[P],a=d[P];v(t,a)||(y[P]=a)}),y}e.distinct=S;function m(u,d){const y=d.toLowerCase(),b=Object.keys(u).find(P=>P.toLowerCase()===y);return b?u[b]:u[d]}e.getCaseInsensitive=m;function f(u,d){const y=Object.create(null);for(const[b,P]of Object.entries(u))d(b,P)&&(y[b]=P);return y}e.filter=f;function g(u){let d=[],y=Object.getPrototypeOf(u);for(;Object.prototype!==y;)d=d.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return d}e.getAllPropertyNames=g;function p(u){const d=[];for(const y of g(u))typeof u[y]=="function"&&d.push(y);return d}e.getAllMethodNames=p;function h(u,d){const y=P=>function(){const t=Array.prototype.slice.call(arguments,0);return d(P,t)},b={};for(const P of u)b[P]=y(P);return b}e.createProxyObject=h}),define(se[134],re([0,1,52]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(k){function R(C){return C&&typeof C=="object"&&typeof C.id=="string"}k.isThemeColor=R})(O=e.ThemeColor||(e.ThemeColor={}));function l(k){return{id:k}}e.themeColorFromId=l;var D;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(d){const y=R.exec(d.id);if(!y)return C(A.Codicon.error);const[,b,P]=y,t=["codicon","codicon-"+b];return P&&t.push("codicon-modifier-"+P.substring(1)),t}k.asClassNameArray=C;function v(d){return C(d).join(" ")}k.asClassName=v;function I(d){return"."+C(d).join(".")}k.asCSSSelector=I;function S(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||O.isThemeColor(d.color))}k.isThemeIcon=S;const m=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function f(d){const y=m.exec(d);if(!y)return;const[,b]=y;return{id:b}}k.fromString=f;function g(d){return{id:d}}k.fromId=g;function p(d,y){let b=d.id;const P=b.lastIndexOf("~");return P!==-1&&(b=b.substring(0,P)),y&&(b=`${b}~${y}`),{id:b}}k.modify=p;function h(d){const y=d.id.lastIndexOf("~");if(y!==-1)return d.id.substring(y+1)}k.getModifier=h;function u(d,y){return d.id===y.id&&d.color?.id===y.color?.id}k.isEqual=u})(D=e.ThemeIcon||(e.ThemeIcon={}))}),define(se[31],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(l){return A.test(l)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(R){for(let C=0;C<R.length;C++)R[C]=Math.floor(Math.random()*256);return R};const D=new Uint8Array(16),k=[];for(let R=0;R<256;R++)k.push(R.toString(16).padStart(2,"0"));return function(){l(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let C=0,v="";return v+=k[D[C++]],v+=k[D[C++]],v+=k[D[C++]],v+=k[D[C++]],v+="-",v+=k[D[C++]],v+=k[D[C++]],v+="-",v+=k[D[C++]],v+=k[D[C++]],v+="-",v+=k[D[C++]],v+=k[D[C++]],v+="-",v+=k[D[C++]],v+=k[D[C++]],v+=k[D[C++]],v+=k[D[C++]],v+=k[D[C++]],v+=k[D[C++]],v}}()}),define(se[135],re([0,1,34]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(k){const R=k.replace(/\-/g,":").toLowerCase();return!O.has(R)}function D(){const k=(0,A.networkInterfaces)();for(const R in k){const C=k[R];if(C){for(const{mac:v}of C)if(l(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(se[136],re([0,1,86]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(R,C,v,I=1){let S=!1;return new Promise(m=>{const f=setTimeout(()=>{if(!S)return S=!0,m(0)},v);l(R,C,I,g=>{if(!S)return S=!0,clearTimeout(f),m(g)})})}e.findFreePort=O;function l(R,C,v,I){if(C===0)return I(0);const S=new A.Socket;S.once("connect",()=>(k(S),l(R+v,C-1,v,I))),S.once("data",()=>{}),S.once("error",m=>(k(S),m.code!=="ECONNREFUSED"?l(R+v,C-1,v,I):I(R))),S.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(R,C,v,I="127.0.0.1"){let S=!1,m,f=1;const g=A.createServer({pauseOnConnect:!0});function p(h,u){S||(S=!0,g.removeAllListeners(),g.close(),m&&clearTimeout(m),u(h))}return new Promise(h=>{m=setTimeout(()=>{p(0,h)},v),g.on("listening",()=>{p(R,h)}),g.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<C?(R++,f++,g.listen(R,I)):p(0,h)}),g.on("close",()=>{p(0,h)}),g.listen(R,I)})}e.findFreePortFaster=D;function k(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(se[137],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const A="Offline";function O(D){return D instanceof l?!0:D instanceof Error&&D.name===A&&D.message===A}e.isOfflineError=O;class l extends Error{constructor(){super(A),this.name=this.message}}e.OfflineError=l}),define(se[138],re([0,1,17,7,137]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(C,v){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((S,m)=>{I.open(C.type||"GET",C.url||"",!0,C.user,C.password),k(I,C),I.responseType="arraybuffer",I.onerror=f=>m(navigator.onLine?new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed"):new l.OfflineError),I.onload=f=>{S({res:{statusCode:I.status,headers:R(I)},stream:(0,A.bufferToStream)(A.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=f=>m(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(I.timeout=C.timeout),I.send(C.data),v.onCancellationRequested(()=>{I.abort(),m((0,O.canceled)())})})}e.request=D;function k(C,v){if(v.headers){e:for(const I in v.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(I,v.headers[I])}}}function R(C){const v=Object.create(null);for(const I of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const S=I.indexOf(":");v[I.substr(0,S).trim().toLowerCase()]=I.substr(S+1).trim()}return v}}),define(se[87],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function A(O){return!!O.parentPort}e.isUtilityProcess=A}),define(se[139],re([9,8]),function(_,e){return _.create("vs/base/common/date",e)}),define(se[64],re([0,1,139]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,l=O*60,D=l*24,k=D*7,R=D*30,C=D*365;function v(S,m,f,g){typeof S!="number"&&(S=S.getTime());const p=Math.round((new Date().getTime()-S)/1e3);if(p<-30)return(0,A.localize)(0,null,v(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,A.localize)(1,null);let h;return p<O?(h=p,m?h===1?f?(0,A.localize)(2,null,h):(0,A.localize)(3,null,h):f?(0,A.localize)(4,null,h):(0,A.localize)(5,null,h):h===1?f?(0,A.localize)(6,null,h):(0,A.localize)(7,null,h):f?(0,A.localize)(8,null,h):(0,A.localize)(9,null,h)):p<l?(h=Math.floor(p/O),m?h===1?f?(0,A.localize)(10,null,h):(0,A.localize)(11,null,h):f?(0,A.localize)(12,null,h):(0,A.localize)(13,null,h):h===1?f?(0,A.localize)(14,null,h):(0,A.localize)(15,null,h):f?(0,A.localize)(16,null,h):(0,A.localize)(17,null,h)):p<D?(h=Math.floor(p/l),m?h===1?f?(0,A.localize)(18,null,h):(0,A.localize)(19,null,h):f?(0,A.localize)(20,null,h):(0,A.localize)(21,null,h):h===1?f?(0,A.localize)(22,null,h):(0,A.localize)(23,null,h):f?(0,A.localize)(24,null,h):(0,A.localize)(25,null,h)):p<k?(h=Math.floor(p/D),m?h===1?(0,A.localize)(26,null,h):(0,A.localize)(27,null,h):h===1?(0,A.localize)(28,null,h):(0,A.localize)(29,null,h)):p<R?(h=Math.floor(p/k),m?h===1?f?(0,A.localize)(30,null,h):(0,A.localize)(31,null,h):f?(0,A.localize)(32,null,h):(0,A.localize)(33,null,h):h===1?f?(0,A.localize)(34,null,h):(0,A.localize)(35,null,h):f?(0,A.localize)(36,null,h):(0,A.localize)(37,null,h)):p<C?(h=Math.floor(p/R),m?h===1?f?(0,A.localize)(38,null,h):(0,A.localize)(39,null,h):f?(0,A.localize)(40,null,h):(0,A.localize)(41,null,h):h===1?f?(0,A.localize)(42,null,h):(0,A.localize)(43,null,h):f?(0,A.localize)(44,null,h):(0,A.localize)(45,null,h)):(h=Math.floor(p/C),m?h===1?f?(0,A.localize)(46,null,h):(0,A.localize)(47,null,h):f?(0,A.localize)(48,null,h):(0,A.localize)(49,null,h):h===1?f?(0,A.localize)(50,null,h):(0,A.localize)(51,null,h):f?(0,A.localize)(52,null,h):(0,A.localize)(53,null,h))}e.fromNow=v;function I(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(se[140],re([9,8]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(se[39],re([0,1,18,12,140]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(S,m){return m&&(S.stack||S.stacktrace)?l.localize(0,null,R(S),k(S.stack)||k(S.stacktrace)):R(S)}function k(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?l.localize(1,null,S.message):S.message||l.localize(2,null)}function C(S=null,m=!1){if(!S)return l.localize(3,null);if(Array.isArray(S)){const f=A.coalesce(S),g=C(f[0],m);return f.length>1?l.localize(4,null,g,f.length):g}if(O.isString(S))return S;if(S.detail){const f=S.detail;if(f.error)return D(f.error,m);if(f.exception)return D(f.exception,m)}return S.stack?D(S,m):S.message?S.message:l.localize(5,null)}e.toErrorMessage=C;function v(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=v;function I(S,m){let f;return typeof S=="string"?f=new Error(S):f=S,f.actions=m,f}e.createErrorWithActions=I}),define(se[141],re([9,8]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(se[142],re([0,1,141]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(l){switch(l){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(se[143],re([9,8]),function(_,e){return _.create("vs/base/common/platform",e)}),define(se[4],re([0,1,143]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,l=!1,D=!1,k=!1,R=!1,C=!1,v=!1,I=!1,S=!1,m=!1,f,g=e.LANGUAGE_DEFAULT,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const d=typeof u?.versions?.electron=="string",y=d&&u?.type==="renderer";if(typeof navigator=="object"&&!y)h=navigator.userAgent,O=h.indexOf("Windows")>=0,l=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,C=!0,f=A.getConfiguredDefaultLocale(A.localize(0,null))||e.LANGUAGE_DEFAULT,g=f;else if(typeof u=="object"){O=u.platform==="win32",l=u.platform==="darwin",D=u.platform==="linux",k=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,v=d,S=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),w=c.availableLanguages["*"];f=c.locale,g=w||e.LANGUAGE_DEFAULT,p=c._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function P(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let t=0;l?t=1:O?t=3:D&&(t=2),e.isWindows=O,e.isMacintosh=l,e.isLinux=D,e.isLinuxSnap=k,e.isNative=R,e.isElectron=v,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=m,e.isCI=S,e.platform=t,e.userAgent=h,e.language=g;var a;(function(s){function c(){return e.language}s.value=c;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=w;function E(){return e.language==="en"}s.isDefault=E})(a=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let E=0,L=s.length;E<L;E++){const T=s[E];if(T.id===w.data.vscodeScheduleAsyncWork){s.splice(E,1),T.callback();return}}});let c=0;return w=>{const E=++c;s.push({id:E,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||I?2:O?1:3;let n=!0,r=!1;function o(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(se[36],re([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const l=A.globals.vscode.process;O={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(se[13],re([0,1,36]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,l=97,D=90,k=122,R=46,C=47,v=92,I=58,S=63;class m extends Error{constructor(a,i,n){let r;typeof i=="string"&&i.indexOf("not ")===0?(r="must not be",i=i.replace(/^not /,"")):r="must be";const o=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${o} ${r} of type ${i}`;s+=`. Received type ${typeof n}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,a){if(t===null||typeof t!="object")throw new m(a,"Object",t)}function g(t,a){if(typeof t!="string")throw new m(a,"string",t)}const p=A.platform==="win32";function h(t){return t===C||t===v}function u(t){return t===C}function d(t){return t>=O&&t<=D||t>=l&&t<=k}function y(t,a,i,n){let r="",o=0,s=-1,c=0,w=0;for(let E=0;E<=t.length;++E){if(E<t.length)w=t.charCodeAt(E);else{if(n(w))break;w=C}if(n(w)){if(!(s===E-1||c===1))if(c===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const L=r.lastIndexOf(i);L===-1?(r="",o=0):(r=r.slice(0,L),o=r.length-1-r.lastIndexOf(i)),s=E,c=0;continue}else if(r.length!==0){r="",o=0,s=E,c=0;continue}}a&&(r+=r.length>0?`${i}..`:"..",o=2)}else r.length>0?r+=`${i}${t.slice(s+1,E)}`:r=t.slice(s+1,E),o=E-s-1;s=E,c=0}else w===R&&c!==-1?++c:c=-1}return r}function b(t,a){f(a,"pathObject");const i=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let a="",i="",n=!1;for(let r=t.length-1;r>=-1;r--){let o;if(r>=0){if(o=t[r],g(o,"path"),o.length===0)continue}else a.length===0?o=A.cwd():(o=A.env[`=${a}`]||A.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===v)&&(o=`${a}\\`));const s=o.length;let c=0,w="",E=!1;const L=o.charCodeAt(0);if(s===1)h(L)&&(c=1,E=!0);else if(h(L))if(E=!0,h(o.charCodeAt(1))){let T=2,F=T;for(;T<s&&!h(o.charCodeAt(T));)T++;if(T<s&&T!==F){const z=o.slice(F,T);for(F=T;T<s&&h(o.charCodeAt(T));)T++;if(T<s&&T!==F){for(F=T;T<s&&!h(o.charCodeAt(T));)T++;(T===s||T!==F)&&(w=`\\\\${z}\\${o.slice(F,T)}`,c=T)}}}else c=1;else d(L)&&o.charCodeAt(1)===I&&(w=o.slice(0,2),c=2,s>2&&h(o.charCodeAt(2))&&(E=!0,c=3));if(w.length>0)if(a.length>0){if(w.toLowerCase()!==a.toLowerCase())continue}else a=w;if(n){if(a.length>0)break}else if(i=`${o.slice(c)}\\${i}`,n=E,E&&a.length>0)break}return i=y(i,!n,"\\",h),n?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){g(t,"path");const a=t.length;if(a===0)return".";let i=0,n,r=!1;const o=t.charCodeAt(0);if(a===1)return u(o)?"\\":t;if(h(o))if(r=!0,h(t.charCodeAt(1))){let c=2,w=c;for(;c<a&&!h(t.charCodeAt(c));)c++;if(c<a&&c!==w){const E=t.slice(w,c);for(w=c;c<a&&h(t.charCodeAt(c));)c++;if(c<a&&c!==w){for(w=c;c<a&&!h(t.charCodeAt(c));)c++;if(c===a)return`\\\\${E}\\${t.slice(w)}\\`;c!==w&&(n=`\\\\${E}\\${t.slice(w,c)}`,i=c)}}}else i=1;else d(o)&&t.charCodeAt(1)===I&&(n=t.slice(0,2),i=2,a>2&&h(t.charCodeAt(2))&&(r=!0,i=3));let s=i<a?y(t.slice(i),!r,"\\",h):"";return s.length===0&&!r&&(s="."),s.length>0&&h(t.charCodeAt(a-1))&&(s+="\\"),n===void 0?r?`\\${s}`:s:r?`${n}\\${s}`:`${n}${s}`},isAbsolute(t){g(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return h(i)||a>2&&d(i)&&t.charCodeAt(1)===I&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let o=0;o<t.length;++o){const s=t[o];g(s,"path"),s.length>0&&(a===void 0?a=i=s:a+=`\\${s}`)}if(a===void 0)return".";let n=!0,r=0;if(typeof i=="string"&&h(i.charCodeAt(0))){++r;const o=i.length;o>1&&h(i.charCodeAt(1))&&(++r,o>2&&(h(i.charCodeAt(2))?++r:n=!1))}if(n){for(;r<a.length&&h(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a)return"";const i=e.win32.resolve(t),n=e.win32.resolve(a);if(i===n||(t=i.toLowerCase(),a=n.toLowerCase(),t===a))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===v;)r++;let o=t.length;for(;o-1>r&&t.charCodeAt(o-1)===v;)o--;const s=o-r;let c=0;for(;c<a.length&&a.charCodeAt(c)===v;)c++;let w=a.length;for(;w-1>c&&a.charCodeAt(w-1)===v;)w--;const E=w-c,L=s<E?s:E;let T=-1,F=0;for(;F<L;F++){const J=t.charCodeAt(r+F);if(J!==a.charCodeAt(c+F))break;J===v&&(T=F)}if(F!==L){if(T===-1)return n}else{if(E>L){if(a.charCodeAt(c+F)===v)return n.slice(c+F+1);if(F===2)return n.slice(c+F)}s>L&&(t.charCodeAt(r+F)===v?T=F:F===2&&(T=3)),T===-1&&(T=0)}let z="";for(F=r+T+1;F<=o;++F)(F===o||t.charCodeAt(F)===v)&&(z+=z.length===0?"..":"\\..");return c+=T,z.length>0?`${z}${n.slice(c,w)}`:(n.charCodeAt(c)===v&&++c,n.slice(c,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===v){if(a.charCodeAt(1)===v){const i=a.charCodeAt(2);if(i!==S&&i!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===I&&a.charCodeAt(2)===v)return`\\\\?\\${a}`;return t},dirname(t){g(t,"path");const a=t.length;if(a===0)return".";let i=-1,n=0;const r=t.charCodeAt(0);if(a===1)return h(r)?t:".";if(h(r)){if(i=n=1,h(t.charCodeAt(1))){let c=2,w=c;for(;c<a&&!h(t.charCodeAt(c));)c++;if(c<a&&c!==w){for(w=c;c<a&&h(t.charCodeAt(c));)c++;if(c<a&&c!==w){for(w=c;c<a&&!h(t.charCodeAt(c));)c++;if(c===a)return t;c!==w&&(i=n=c+1)}}}}else d(r)&&t.charCodeAt(1)===I&&(i=a>2&&h(t.charCodeAt(2))?3:2,n=i);let o=-1,s=!0;for(let c=a-1;c>=n;--c)if(h(t.charCodeAt(c))){if(!s){o=c;break}}else s=!1;if(o===-1){if(i===-1)return".";o=i}return t.slice(0,o)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let i=0,n=-1,r=!0,o;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,c=-1;for(o=t.length-1;o>=i;--o){const w=t.charCodeAt(o);if(h(w)){if(!r){i=o+1;break}}else c===-1&&(r=!1,c=o+1),s>=0&&(w===a.charCodeAt(s)?--s===-1&&(n=o):(s=-1,n=c))}return i===n?n=c:n===-1&&(n=t.length),t.slice(i,n)}for(o=t.length-1;o>=i;--o)if(h(t.charCodeAt(o))){if(!r){i=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(i,n)},extname(t){g(t,"path");let a=0,i=-1,n=0,r=-1,o=!0,s=0;t.length>=2&&t.charCodeAt(1)===I&&d(t.charCodeAt(0))&&(a=n=2);for(let c=t.length-1;c>=a;--c){const w=t.charCodeAt(c);if(h(w)){if(!o){n=c+1;break}continue}r===-1&&(o=!1,r=c+1),w===R?i===-1?i=c:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||r===-1||s===0||s===1&&i===r-1&&i===n+1?"":t.slice(i,r)},format:b.bind(null,"\\"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let n=0,r=t.charCodeAt(0);if(i===1)return h(r)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(h(r)){if(n=1,h(t.charCodeAt(1))){let T=2,F=T;for(;T<i&&!h(t.charCodeAt(T));)T++;if(T<i&&T!==F){for(F=T;T<i&&h(t.charCodeAt(T));)T++;if(T<i&&T!==F){for(F=T;T<i&&!h(t.charCodeAt(T));)T++;T===i?n=T:T!==F&&(n=T+1)}}}}else if(d(r)&&t.charCodeAt(1)===I){if(i<=2)return a.root=a.dir=t,a;if(n=2,h(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let o=-1,s=n,c=-1,w=!0,E=t.length-1,L=0;for(;E>=n;--E){if(r=t.charCodeAt(E),h(r)){if(!w){s=E+1;break}continue}c===-1&&(w=!1,c=E+1),r===R?o===-1?o=E:L!==1&&(L=1):o!==-1&&(L=-1)}return c!==-1&&(o===-1||L===0||L===1&&o===c-1&&o===s+1?a.base=a.name=t.slice(s,c):(a.name=t.slice(s,o),a.base=t.slice(s,c),a.ext=t.slice(o,c))),s>0&&s!==n?a.dir=t.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const P=(()=>{if(p){const t=/\\/g;return()=>{const a=A.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>A.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const r=n>=0?t[n]:P();g(r,"path"),r.length!==0&&(a=`${r}/${a}`,i=r.charCodeAt(0)===C)}return a=y(a,!i,"/",u),i?`/${a}`:a.length>0?a:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===C,i=t.charCodeAt(t.length-1)===C;return t=y(t,!a,"/",u),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===C},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const n=t[i];g(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(g(t,"from"),g(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,n=t.length,r=n-i,o=1,s=a.length-o,c=r<s?r:s;let w=-1,E=0;for(;E<c;E++){const T=t.charCodeAt(i+E);if(T!==a.charCodeAt(o+E))break;T===C&&(w=E)}if(E===c)if(s>c){if(a.charCodeAt(o+E)===C)return a.slice(o+E+1);if(E===0)return a.slice(o+E)}else r>c&&(t.charCodeAt(i+E)===C?w=E:E===0&&(w=0));let L="";for(E=i+w+1;E<=n;++E)(E===n||t.charCodeAt(E)===C)&&(L+=L.length===0?"..":"/..");return`${L}${a.slice(o+w)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===C;let i=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===C){if(!n){i=r;break}}else n=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&g(a,"ext"),g(t,"path");let i=0,n=-1,r=!0,o;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,c=-1;for(o=t.length-1;o>=0;--o){const w=t.charCodeAt(o);if(w===C){if(!r){i=o+1;break}}else c===-1&&(r=!1,c=o+1),s>=0&&(w===a.charCodeAt(s)?--s===-1&&(n=o):(s=-1,n=c))}return i===n?n=c:n===-1&&(n=t.length),t.slice(i,n)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===C){if(!r){i=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(i,n)},extname(t){g(t,"path");let a=-1,i=0,n=-1,r=!0,o=0;for(let s=t.length-1;s>=0;--s){const c=t.charCodeAt(s);if(c===C){if(!r){i=s+1;break}continue}n===-1&&(r=!1,n=s+1),c===R?a===-1?a=s:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||n===-1||o===0||o===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:b.bind(null,"/"),parse(t){g(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===C;let n;i?(a.root="/",n=1):n=0;let r=-1,o=0,s=-1,c=!0,w=t.length-1,E=0;for(;w>=n;--w){const L=t.charCodeAt(w);if(L===C){if(!c){o=w+1;break}continue}s===-1&&(c=!1,s=w+1),L===R?r===-1?r=w:E!==1&&(E=1):r!==-1&&(E=-1)}if(s!==-1){const L=o===0&&i?1:o;r===-1||E===0||E===1&&r===s-1&&r===o+1?a.base=a.name=t.slice(L,s):(a.name=t.slice(L,r),a.base=t.slice(L,s),a.ext=t.slice(r,s))}return o>0?a.dir=t.slice(0,o-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(se[144],re([0,1,13]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(I){const S=(0,A.extname)(I),m=O[S.toLowerCase()];return m!==void 0?m:k(I)}e.getMediaOrTextMime=D;function k(I){const S=(0,A.extname)(I);return l[S.toLowerCase()]}e.getMediaMime=k;function R(I){for(const S in l)if(l[S]===I)return S}e.getExtensionForMimeType=R;const C=/^(.+)\/(.+?)(;.+)?$/;function v(I,S){const m=C.exec(I);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:I}e.normalizeMimeType=v}),define(se[88],re([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var l;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(R,...C){const v=C.reduce((m,f)=>(m[f]=!0,m),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!v[m]).forEach(m=>{for(let f=0;f<I.length;f++)if(m.search(I[f])!==-1){delete R[m];break}})}e.sanitizeProcessEnvironment=D;function k(R){!R||(delete R.DEBUG,A.isMacintosh&&delete R.DYLD_LIBRARY_PATH,A.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(se[89],re([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const O=A.globals.performance&&typeof A.globals.performance.now=="function";class l{static create(k=!0){return new l(k)}constructor(k){this.a=O&&k,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?A.globals.performance.now():Date.now()}}e.StopWatch=l}),define(se[3],re([0,1,7,82,2,84,89]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,C=!1;var v;(function(o){o.None=()=>l.Disposable.None;function s($){if(C){const{onDidAddListener:H}=$,ee=g.create();let G=0;$.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),H?.()}}}function c($,H){return W($,()=>{},0,void 0,!0,void 0,H)}o.defer=c;function w($){return(H,ee=null,G)=>{let Z=!1,te;return te=$(le=>{if(!Z)return te?te.dispose():Z=!0,H.call(ee,le)},null,G),Z&&te.dispose(),te}}o.once=w;function E($,H,ee){return Y((G,Z=null,te)=>$(le=>G.call(Z,H(le)),null,te),ee)}o.map=E;function L($,H,ee){return Y((G,Z=null,te)=>$(le=>{H(le),G.call(Z,le)},null,te),ee)}o.forEach=L;function T($,H,ee){return Y((G,Z=null,te)=>$(le=>H(le)&&G.call(Z,le),null,te),ee)}o.filter=T;function F($){return $}o.signal=F;function z(...$){return(H,ee=null,G)=>(0,l.combinedDisposable)(...$.map(Z=>Z(te=>H.call(ee,te),null,G)))}o.any=z;function J($,H,ee,G){let Z=ee;return E($,te=>(Z=H(Z,te),Z),G)}o.reduce=J;function Y($,H){let ee;const G={onWillAddFirstListener(){ee=$(Z.fire,Z)},onDidRemoveLastListener(){ee?.dispose()}};H||s(G);const Z=new h(G);return H?.add(Z),Z.event}function W($,H,ee=100,G=!1,Z=!1,te,le){let he,me,pe,Se=0,Ce;const De={leakWarningThreshold:te,onWillAddFirstListener(){he=$(qe=>{Se++,me=H(me,qe),G&&!pe&&(ke.fire(me),me=void 0),Ce=()=>{const Ye=me;me=void 0,pe=void 0,(!G||Se>1)&&ke.fire(Ye),Se=0},typeof ee=="number"?(clearTimeout(pe),pe=setTimeout(Ce,ee)):pe===void 0&&(pe=0,queueMicrotask(Ce))})},onWillRemoveListener(){Z&&Se>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};le||s(De);const ke=new h(De);return le?.add(ke),ke.event}o.debounce=W;function N($,H=0,ee){return o.debounce($,(G,Z)=>G?(G.push(Z),G):[Z],H,void 0,!0,void 0,ee)}o.accumulate=N;function B($,H=(G,Z)=>G===Z,ee){let G=!0,Z;return T($,te=>{const le=G||!H(te,Z);return G=!1,Z=te,le},ee)}o.latch=B;function ie($,H,ee){return[o.filter($,H,ee),o.filter($,G=>!H(G),ee)]}o.split=ie;function q($,H=!1,ee=[]){let G=ee.slice(),Z=$(he=>{G?G.push(he):le.fire(he)});const te=()=>{G?.forEach(he=>le.fire(he)),G=null},le=new h({onWillAddFirstListener(){Z||(Z=$(he=>le.fire(he)))},onDidAddFirstListener(){G&&(H?setTimeout(te):te())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return le.event}o.buffer=q;class x{constructor(H){this.event=H,this.c=new l.DisposableStore}map(H){return new x(E(this.event,H,this.c))}forEach(H){return new x(L(this.event,H,this.c))}filter(H){return new x(T(this.event,H,this.c))}reduce(H,ee){return new x(J(this.event,H,ee,this.c))}latch(){return new x(B(this.event,void 0,this.c))}debounce(H,ee=100,G=!1,Z=!1,te){return new x(W(this.event,H,ee,G,Z,te,this.c))}on(H,ee,G){return this.event(H,ee,G)}once(H,ee,G){return w(this.event)(H,ee,G)}dispose(){this.c.dispose()}}function U($){return new x($)}o.chain=U;function K($,H,ee=G=>G){const G=(...he)=>le.fire(ee(...he)),Z=()=>$.on(H,G),te=()=>$.removeListener(H,G),le=new h({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return le.event}o.fromNodeEventEmitter=K;function Q($,H,ee=G=>G){const G=(...he)=>le.fire(ee(...he)),Z=()=>$.addEventListener(H,G),te=()=>$.removeEventListener(H,G),le=new h({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return le.event}o.fromDOMEventEmitter=Q;function oe($){return new Promise(H=>w($)(H))}o.toPromise=oe;function ae($,H){return H(void 0),$(ee=>H(ee))}o.runAndSubscribe=ae;function V($,H){let ee=null;function G(te){ee?.dispose(),ee=new l.DisposableStore,H(te,ee)}G(void 0);const Z=$(te=>G(te));return(0,l.toDisposable)(()=>{Z.dispose(),ee?.dispose()})}o.runAndSubscribeWithStore=V;class j{constructor(H,ee){this.obs=H,this.c=0,this.d=!1;const G={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};ee||s(G),this.emitter=new h(G),ee&&ee.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,ee){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function M($,H){return new j($,H).emitter.event}o.fromObservable=M})(v=e.Event||(e.Event={}));class I{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${I.c++}`,I.all.add(this)}start(s){this.d=new k.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}I.all=new Set,I.c=0,e.EventProfiling=I;let S=-1;function m(o){const s=S;return S=o,{dispose(){S=s}}}e.setGlobalLeakWarningThreshold=m;class f{constructor(s,c=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=c,this.d=0}dispose(){this.c?.clear()}check(s,c){const w=this.threshold;if(w<=0||c<w)return;this.c||(this.c=new Map);const E=this.c.get(s.value)||0;if(this.c.set(s.value,E+1),this.d-=1,this.d<=0){this.d=w*.5;let L,T=0;for(const[F,z]of this.c)(!L||T<z)&&(L=F,T=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${T}):`),console.warn(L)}return()=>{const L=this.c.get(s.value)||0;this.c.set(s.value,L-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(s,c,w){this.callback=s,this.callbackThis=c,this.stack=w,this.subscription=new l.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class h{constructor(s){this.j=!1,this.d=s,this.f=S>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new I(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const s=Array.from(this.q);queueMicrotask(()=>{for(const c of s)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,c,w)=>{if(this.q||(this.q=new D.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,T;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(T=g.create(),L=this.f.check(T,this.q.size+1)),R&&(T=T??g.create());const F=new p(s,c,T),z=this.q.push(F);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,c);const J=F.subscription.set(()=>{L?.(),this.j||(this.d?.onWillRemoveListener?.(this),z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return w instanceof l.DisposableStore?w.add(J):Array.isArray(w)&&w.push(J),J}),this.l}fire(s){if(this.q){this.m||(this.m=new d);for(const c of this.q)this.m.push(this,c,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class u{constructor(){this.c=new D.LinkedList}get size(){return this.c.size}push(s,c,w){this.c.push(new y(s,c,w))}clear(s){const c=new D.LinkedList;for(const w of this.c)w.emitter!==s&&c.push(w);this.c=c}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(c){(0,A.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=u;class d extends u{clear(s){this.c.clear()}}class y{constructor(s,c,w){this.emitter=s,this.listener=c,this.event=w}}class b extends h{async fireAsync(s,c,w){if(!!this.q){this.c||(this.c=new D.LinkedList);for(const E of this.q)this.c.push([E,s]);for(;this.c.size>0&&!c.isCancellationRequested;){const[E,L]=this.c.shift(),T=[],F={...L,token:c,waitUntil:z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");w&&(z=w(z,E.callback)),T.push(z)}};try{E.invoke(F)}catch(z){(0,A.onUnexpectedError)(z);continue}Object.freeze(T),await Promise.allSettled(T).then(z=>{for(const J of z)J.status==="rejected"&&(0,A.onUnexpectedError)(J.reason)})}}}}e.AsyncEmitter=b;class P extends h{constructor(s){super(s),this.h=0,this.s=new D.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=P;class t extends P{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class a extends h{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(c=>super.fire(c)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const c={event:s,listener:null};this.f.push(c),this.d&&this.j(c);const w=()=>{this.d&&this.k(c);const E=this.f.indexOf(c);this.f.splice(E,1)};return(0,l.toDisposable)((0,O.once)(w))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(c=>this.c.fire(c))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(s){return(c,w,E)=>s(L=>{const T=this.c[this.c.length-1];T?T.push(()=>c.call(w,L)):c.call(w,L)},void 0,E)}bufferEvents(s){const c=[];this.c.push(c);const w=s();return this.c.pop(),c.forEach(E=>E()),w}}e.EventBufferer=n;class r{constructor(){this.c=!1,this.d=v.None,this.f=l.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(se[23],re([0,1,3]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(R,C){const v=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(v)}}});var l;(function(R){function C(v){return v===R.None||v===R.Cancelled||v instanceof D?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(l=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new A.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(C){this.a=void 0,this.b=void 0,this.b=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new D),this.a}cancel(){this.a?this.a instanceof D&&this.a.cancel():this.a=l.Cancelled}dispose(C=!1){C&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof D&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=k}),define(se[145],re([0,1,23]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new A.CancellationTokenSource,C=this.b(R.token);return this.a={promise:C,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=O;class l{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const C=JSON.stringify(R);return this.b!==C&&(this.b=C,this.a=this.c(R)),this.a}}e.LRUCachedFunction=l;class D{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const C=this.b(R);return this.a.set(R,C),C}}e.CachedFunction=D}),define(se[26],re([0,1,145,130]),function(_,e,A,O){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=D;const k=/{(\d+)}/g;function R(ne,...ue){return ue.length===0?ne:ne.replace(k,function(ge,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=ue.length?ge:ue[ve]})}e.format=R;const C=/{([^}]+)}/g;function v(ne,ue){return ne.replace(C,(ge,we)=>ue[we]??ge)}e.format2=v;function I(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=I;function S(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function m(ne,ue){let ge=0;const we=ue.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===we&&ge++;return ge}e.count=m;function f(ne,ue,ge="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${ge}`}e.truncate=f;function g(ne,ue=" "){const ge=p(ne,ue);return h(ge,ue)}e.trim=g;function p(ne,ue){if(!ne||!ue)return ne;const ge=ue.length;if(ge===0||ne.length===0)return ne;let we=0;for(;ne.indexOf(ue,we)===we;)we=we+ge;return ne.substring(we)}e.ltrim=p;function h(ne,ue){if(!ne||!ue)return ne;const ge=ue.length,we=ne.length;if(ge===0||we===0)return ne;let ve=we,Ee=-1;for(;Ee=ne.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+ge!==ve);){if(Ee===0)return"";ve=Ee}return ne.substring(0,ve)}e.rtrim=h;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function d(ne){return ne.replace(/\*/g,"")}e.stripWildcards=d;function y(ne,ue,ge={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=S(ne)),ge.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let we="";return ge.global&&(we+="g"),ge.matchCase||(we+="i"),ge.multiline&&(we+="m"),ge.unicode&&(we+="u"),new RegExp(ne,we)}e.createRegExp=y;function b(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function P(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function t(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=t;function a(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=a;function i(ne){for(let ue=0,ge=ne.length;ue<ge;ue++){const we=ne.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function n(ne,ue=0,ge=ne.length){for(let we=ue;we<ge;we++){const ve=ne.charCodeAt(we);if(ve!==32&&ve!==9)return ne.substring(ue,we)}return ne.substring(ue,ge)}e.getLeadingWhitespace=n;function r(ne,ue=ne.length-1){for(let ge=ue;ge>=0;ge--){const we=ne.charCodeAt(ge);if(we!==32&&we!==9)return ge}return-1}e.lastNonWhitespaceIndex=r;function o(ne,ue,ge){const we=[];let ve=0;for(const Ee of ne.matchAll(ue)){if(we.push(ne.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,we.push(ge(Ee[0],...Ee.slice(1),Ee.index,ne,Ee.groups))}return we.push(ne.slice(ve)),Promise.all(we).then(Ee=>Ee.join(""))}e.replaceAsync=o;function s(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=s;function c(ne,ue,ge=0,we=ne.length,ve=0,Ee=ue.length){for(;ge<we&&ve<Ee;ge++,ve++){const Te=ne.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const Re=we-ge,Le=Ee-ve;return Re<Le?-1:Re>Le?1:0}e.compareSubstring=c;function w(ne,ue){return E(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=w;function E(ne,ue,ge=0,we=ne.length,ve=0,Ee=ue.length){for(;ge<we&&ve<Ee;ge++,ve++){let Te=ne.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return c(ne.toLowerCase(),ue.toLowerCase(),ge,we,ve,Ee);T(Te)&&(Te-=32),T(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const Re=we-ge,Le=Ee-ve;return Re<Le?-1:Re>Le?1:0}e.compareSubstringIgnoreCase=E;function L(ne){return ne>=48&&ne<=57}e.isAsciiDigit=L;function T(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=T;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function z(ne,ue){return ne.length===ue.length&&E(ne,ue)===0}e.equalsIgnoreCase=z;function J(ne,ue){const ge=ue.length;return ue.length>ne.length?!1:E(ne,ue,0,ge)===0}e.startsWithIgnoreCase=J;function Y(ne,ue){const ge=Math.min(ne.length,ue.length);let we;for(we=0;we<ge;we++)if(ne.charCodeAt(we)!==ue.charCodeAt(we))return we;return ge}e.commonPrefixLength=Y;function W(ne,ue){const ge=Math.min(ne.length,ue.length);let we;const ve=ne.length-1,Ee=ue.length-1;for(we=0;we<ge;we++)if(ne.charCodeAt(ve-we)!==ue.charCodeAt(Ee-we))return we;return ge}e.commonSuffixLength=W;function N(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=N;function B(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=B;function ie(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=ie;function q(ne,ue,ge){const we=ne.charCodeAt(ge);if(N(we)&&ge+1<ue){const ve=ne.charCodeAt(ge+1);if(B(ve))return ie(we,ve)}return we}e.getNextCodePoint=q;function x(ne,ue){const ge=ne.charCodeAt(ue-1);if(B(ge)&&ue>1){const we=ne.charCodeAt(ue-2);if(N(we))return ie(we,ge)}return ge}class U{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=x(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=q(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=U;class K{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new U(ue,ge)}nextGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,we=ge.offset;let ve=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Re=ue.getGraphemeBreakType(ge.nextCodePoint());if(fe(ve,Re)){ge.setOffset(Ee);break}ve=Re}return ge.offset-we}prevGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,we=ge.offset;let ve=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Re=ue.getGraphemeBreakType(ge.prevCodePoint());if(fe(Re,ve)){ge.setOffset(Ee);break}ve=Re}return we-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=K;function Q(ne,ue){return new K(ne,ue).nextGraphemeLength()}e.nextCharLength=Q;function oe(ne,ue){return new K(ne,ue).prevGraphemeLength()}e.prevCharLength=oe;function ae(ne,ue){ue>0&&B(ne.charCodeAt(ue))&&ue--;const ge=ue+Q(ne,ue);return[ge-oe(ne,ge),ge]}e.getCharContainingOffset=ae;function V(ne){const ue=new K(ne);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.charCount=V;let j;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(ne){return j||(j=M()),j.test(ne)}e.containsRTL=$;const H=/^[\t\n\r\x20-\x7E]*$/;function ee(ne){return H.test(ne)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=G;function Z(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Z;function te(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=te;function le(ne,ue){if(ne.length<ue)return ne;const ge=/\b/g;let we=0;for(;ge.test(ne)&&!(ne.length-ge.lastIndex<ue);)we=ge.lastIndex,ge.lastIndex+=1;return ne.substring(we).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function me(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Se(ne){return pe(ne)?ne.substr(1):ne}e.stripUTF8BOM=Se;function Ce(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const ge=ue.length,we=ne.toLowerCase();let ve=0,Ee=-1;for(;ve<ge;){const Re=we.indexOf(ue[ve],Ee+1);if(Re<0)return!1;Ee=Re,ve++}return!0}e.fuzzyContains=Ce;function De(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=De;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ke;function qe(ne,ue=1){if(ue===0)return"";let ge=-1;do ge=ne.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?ne:(ne[ge-1]==="\r"&&ge--,ne.substr(0,ge))}e.getNLines=qe;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function ce(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ce;function fe(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var de;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,we=ge.length/3;let ve=1;for(;ve<=we;)if(ue<ge[3*ve])ve=2*ve;else if(ue>ge[3*ve+1])ve=2*ve+1;else return ge[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ne,ue){if(ne===0)return 0;const ge=Ae(ne,ue);if(ge!==void 0)return ge;const we=new U(ue,ne);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Fe;function Ae(ne,ue){const ge=new U(ue,ne);let we=ge.prevCodePoint();for(;je(we)||we===65039||we===8419;){if(ge.offset===0)return;we=ge.prevCodePoint()}if(!te(we))return;let ve=ge.offset;return ve>0&&ge.prevCodePoint()===8205&&(ve=ge.offset),ve}function je(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ne,Ne.c=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new A.LRUCachedFunction(ne=>{function ue(Ue){const $e=new Map;for(let ze=0;ze<Ue.length;ze+=2)$e.set(Ue[ze],Ue[ze+1]);return $e}function ge(Ue,$e){const ze=new Map(Ue);for(const[et,st]of $e)ze.set(et,st);return ze}function we(Ue,$e){if(!Ue)return $e;const ze=new Map;for(const[et,st]of Ue)$e.has(et)&&ze.set(et,st);return ze}const ve=l.c.value;let Ee=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let Re;for(const Ue of Ee){const $e=ue(ve[Ue]);Re=we(Re,$e)}const Le=ue(ve._common),Te=ge(Le,Re);return new Ne(Te)}),Ne.e=new O.Lazy(()=>Object.keys(Ne.c.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Ne;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(ue){return Be.e().has(ue)}static get codePoints(){return Be.e()}}Be.d=void 0,e.InvisibleCharacters=Be}),define(se[48],re([0,1,13,4,26,12]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function R(r){return r.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=R;function C(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function v(r,o=A.posix.sep){if(!r)return"";const s=r.length,c=r.charCodeAt(0);if(k(c)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let E=3;const L=E;for(;E<s&&!k(r.charCodeAt(E));E++);if(L!==E&&!k(r.charCodeAt(E+1))){for(E+=1;E<s;E++)if(k(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,o)}}return o}else if(u(c)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<s;w++)if(k(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=v;function I(r){if(!O.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let s=2;const c=s;for(;s<r.length&&(o=r.charCodeAt(s),o!==92);s++);return!(c===s||(o=r.charCodeAt(s+1),isNaN(o)||o===92))}e.isUNC=I;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=O.isWindows){const s=o?S:m;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||o&&f.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function p(r,o,s){const c=r===o;return!s||c?c:!r||!o?!1:(0,l.equalsIgnoreCase)(r,o)}e.isEqual=p;function h(r,o,s,c=A.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(s){if(!(0,l.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let E=o.length;return o.charAt(o.length-1)===c&&E--,r.charAt(E)===c}return o.charAt(o.length-1)!==c&&(o+=c),r.indexOf(o)===0}e.isEqualOrParent=h;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function d(r,o){return O.isWindows&&r.endsWith(":")&&(r+=A.sep),(0,A.isAbsolute)(r)||(r=(0,A.join)(o,r)),r=(0,A.normalize)(r),O.isWindows?(r=(0,l.rtrim)(r,A.sep),r.endsWith(":")&&(r+=A.sep)):(r=(0,l.rtrim)(r,A.sep),r||(r=A.sep)),r}e.sanitizeFilePath=d;function y(r){const o=(0,A.normalize)(r);return O.isWindows?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===A.posix.sep}e.isRootOrDriveLetter=y;function b(r,o=O.isWindows){return o?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function P(r){return b(r)?r[0]:void 0}e.getDriveLetter=P;function t(r,o,s){return o.length>r.length?-1:r===o?0:(s&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=t;function a(r){const o=r.split(":");let s,c,w;for(const E of o){const L=Number(E);(0,D.isNumber)(L)?c===void 0?c=L:w===void 0&&(w=L):s=s?[s,E].join(":"):E}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:w!==void 0?w:c!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,o,s=8){let c="";for(let E=0;E<s;E++)c+=i.charAt(Math.floor(Math.random()*i.length));let w;return o?w=`${o}-${c}`:w=c,r?(0,A.join)(r,w):w}e.randomPath=n}),define(se[65],re([0,1,26]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(u){return l(u,0)}e.hash=O;function l(u,d){switch(typeof u){case"object":return u===null?D(349,d):Array.isArray(u)?C(u,d):v(u,d);case"string":return R(u,d);case"boolean":return k(u,d);case"number":return D(u,d);case"undefined":return D(937,d);default:return D(617,d)}}e.doHash=l;function D(u,d){return(d<<5)-d+u|0}e.numberHash=D;function k(u,d){return D(u?433:863,d)}function R(u,d){d=D(149417,d);for(let y=0,b=u.length;y<b;y++)d=D(u.charCodeAt(y),d);return d}e.stringHash=R;function C(u,d){return d=D(104579,d),u.reduce((y,b)=>l(b,y),d)}function v(u,d){return d=D(181387,d),Object.keys(u).sort().reduce((y,b)=>(y=R(b,y),l(u[b],y)),d)}class I{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=l(d,this.g),this.g}}e.Hasher=I;var S;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(u,d,y=32){const b=y-d,P=~((1<<b)-1);return(u<<d|(P&u)>>>b)>>>0}function f(u,d=0,y=u.byteLength,b=0){for(let P=0;P<y;P++)u[d+P]=b}function g(u,d,y="0"){for(;u.length<d;)u=y+u;return u}function p(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(y=>y.toString(16).padStart(2,"0")).join(""):g((u>>>0).toString(16),d/4)}e.toHexString=p;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const y=d.length;if(y===0)return;const b=this.p;let P=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=d.charCodeAt(0),i=0);;){let n=a;if(A.isHighSurrogate(a))if(i+1<y){const r=d.charCodeAt(i+1);A.isLowSurrogate(r)?(i++,n=A.computeCodePoint(a,r)):n=65533}else{t=a;break}else A.isLowSurrogate(a)&&(n=65533);if(P=this.w(b,P,n),i++,i<y)a=d.charCodeAt(i);else break}this.r=P,this.u=t}w(d,y,b){return b<128?d[y++]=b:b<2048?(d[y++]=192|(b&1984)>>>6,d[y++]=128|(b&63)>>>0):b<65536?(d[y++]=224|(b&61440)>>>12,d[y++]=128|(b&4032)>>>6,d[y++]=128|(b&63)>>>0):(d[y++]=240|(b&1835008)>>>18,d[y++]=128|(b&258048)>>>12,d[y++]=128|(b&4032)>>>6,d[y++]=128|(b&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=h.g,y=this.q;for(let s=0;s<64;s+=4)d.setUint32(s,y.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)d.setUint32(s,m(d.getUint32(s-12,!1)^d.getUint32(s-32,!1)^d.getUint32(s-56,!1)^d.getUint32(s-64,!1),1),!1);let b=this.h,P=this.l,t=this.m,a=this.n,i=this.o,n,r,o;for(let s=0;s<80;s++)s<20?(n=P&t|~P&a,r=1518500249):s<40?(n=P^t^a,r=1859775393):s<60?(n=P&t|P&a|t&a,r=2400959708):(n=P^t^a,r=3395469782),o=m(b,5)+n+i+r+d.getUint32(s*4,!1)&4294967295,i=a,a=t,t=m(P,30),P=b,b=o;this.h=this.h+b&4294967295,this.l=this.l+P&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}h.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(se[90],re([0,1,26]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(O||(O={})),function(l){const D="error",k="warning",R="warn",C="info",v="ignore";function I(m){return m?A.equalsIgnoreCase(D,m)?l.Error:A.equalsIgnoreCase(k,m)||A.equalsIgnoreCase(R,m)?l.Warning:A.equalsIgnoreCase(C,m)?l.Info:l.Ignore:l.Ignore}l.fromValue=I;function S(m){switch(m){case l.Error:return D;case l.Warning:return k;case l.Info:return C;default:return v}}l.toString=S}(O||(O={})),e.default=O}),define(se[49],re([0,1,18,26]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const g=f.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.StringIterator=l;class D{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,O.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,O.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=D;class k{constructor(f=!0,g=!0){this.f=f,this.g=g}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let g=f.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,O.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,O.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class C{constructor(f,g){this.f=f,this.g=g,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,O.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,O.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,O.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,O.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=C;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(I||(I={}));class S{static forUris(f=()=>!1,g=()=>!1){return new S(new C(f,g))}static forPaths(f=!1){return new S(new k(void 0,!f))}static forStrings(){return new S(new l)}static forConfigKeys(){return new S(new D)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,g){if(g){const p=g.slice(0);(0,A.shuffle)(p);for(const h of p)this.set(h,f)}else{const p=f.slice(0);(0,A.shuffle)(p);for(const h of p)this.set(h[0],h[1])}}set(f,g){const p=this.b.reset(f);let h;this.c||(this.c=new v,this.c.segment=p.value());const u=[];for(h=this.c;;){const y=p.cmp(h.segment);if(y>0)h.left||(h.left=new v,h.left.segment=p.value()),u.push([-1,h]),h=h.left;else if(y<0)h.right||(h.right=new v,h.right.segment=p.value()),u.push([1,h]),h=h.right;else if(p.hasNext())p.next(),h.mid||(h.mid=new v,h.mid.segment=p.value()),u.push([0,h]),h=h.mid;else break}const d=h.value;h.value=g,h.key=f;for(let y=u.length-1;y>=0;y--){const b=u[y][1];b.updateHeight();const P=b.balanceFactor();if(P<-1||P>1){const t=u[y][0],a=u[y+1][0];if(t===1&&a===1)u[y][1]=b.rotateLeft();else if(t===-1&&a===-1)u[y][1]=b.rotateRight();else if(t===1&&a===-1)b.right=u[y+1][1]=u[y+1][1].rotateRight(),u[y][1]=b.rotateLeft();else if(t===-1&&a===1)b.left=u[y+1][1]=u[y+1][1].rotateLeft(),u[y][1]=b.rotateRight();else throw new Error;if(y>0)switch(u[y-1][0]){case-1:u[y-1][1].left=u[y][1];break;case 1:u[y-1][1].right=u[y][1];break;case 0:u[y-1][1].mid=u[y][1];break}else this.c=u[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const g=this.b.reset(f);let p=this.c;for(;p;){const h=g.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(f){const g=this.d(f);return!(g?.value===void 0&&g?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,g){const p=this.b.reset(f),h=[];let u=this.c;for(;u;){const d=p.cmp(u.segment);if(d>0)h.push([-1,u]),u=u.left;else if(d<0)h.push([1,u]),u=u.right;else if(p.hasNext())p.next(),h.push([0,u]),u=u.mid;else break}if(!!u){if(g?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:y,value:b,segment:P}=d;this.e(d.key,!1),u.key=y,u.value=b,u.segment=P}}else{const d=u.left??u.right;if(h.length>0){const[y,b]=h[h.length-1];switch(y){case-1:b.left=d;break;case 0:b.mid=d;break;case 1:b.right=d;break}}else this.c=d}for(let d=h.length-1;d>=0;d--){const y=h[d][1];y.updateHeight();const b=y.balanceFactor();if(b>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),h[d][1]=y.rotateLeft()):b<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),h[d][1]=y.rotateRight()),d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const g=this.b.reset(f);let p=this.c,h;for(;p;){const u=g.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(g.hasNext())g.next(),h=p.value||h,p=p.mid;else break}return p&&p.value||h}findSuperstr(f){return this.g(f,!1)}g(f,g){const p=this.b.reset(f);let h=this.c;for(;h;){const u=p.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else return h.mid?this.h(h.mid):g?h.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[g,p]of this)f(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const g=[];return this.j(f,g),g[Symbol.iterator]()}j(f,g){!f||(f.left&&this.j(f.left,g),f.value&&g.push([f.key,f.value]),f.mid&&this.j(f.mid,g),f.right&&this.j(f.right,g))}_isBalanced(){const f=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:f(g.left)&&f(g.right)};return f(this.c)}}e.TernarySearchTree=S}),define(se[10],re([0,1,13,4]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,D=/^\//,k=/^\/\//;function R(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!l.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!D.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(i,n){return!i&&!n?"file":i}function v(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==S&&(n=S+n):n=S;break}return n}const I="",S="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,o,s,c,w=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=C(n,w),this.authority=r||I,this.path=v(this.scheme,o||I),this.query=s||I,this.fragment=c||I,R(this,w))}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:o,path:s,query:c,fragment:w}=n;return r===void 0?r=this.scheme:r===null&&(r=I),o===void 0?o=this.authority:o===null&&(o=I),s===void 0?s=this.path:s===null&&(s=I),c===void 0?c=this.query:c===null&&(c=I),w===void 0?w=this.fragment:w===null&&(w=I),r===this.scheme&&o===this.authority&&s===this.path&&c===this.query&&w===this.fragment?this:new p(r,o,s,c,w)}static parse(n,r=!1){const o=m.exec(n);return o?new p(o[2]||I,a(o[4]||I),a(o[5]||I),a(o[7]||I),a(o[9]||I),r):new p(I,I,I,I,I)}static file(n){let r=I;if(O.isWindows&&(n=n.replace(/\\/g,S)),n[0]===S&&n[1]===S){const o=n.indexOf(S,2);o===-1?(r=n.substring(2),n=S):(r=n.substring(2,o),n=n.substring(o)||S)}return new p("file",r,n,I,I)}static from(n){const r=new p(n.scheme,n.authority,n.path,n.query,n.fragment);return R(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return O.isWindows&&n.scheme==="file"?o=f.file(A.win32.join(y(n,!0),...r)).path:o=A.posix.join(n.path,...r),n.with({path:o})}toString(n=!1){return b(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const r=new p(n);return r._formatted=n.external,r._fsPath=n._sep===g?n.fsPath:null,r}}else return n}}e.URI=f;const g=O.isWindows?1:void 0;class p extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=g),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,r){let o,s=-1;for(let c=0;c<i.length;c++){const w=i.charCodeAt(c);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47||r&&w===91||r&&w===93||r&&w===58)s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const E=h[w];E!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o+=E):s===-1&&(s=c)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function d(i){let n;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(n===void 0&&(n=i.substr(0,r)),n+=h[o]):n!==void 0&&(n+=i[r])}return n!==void 0?n:i}function y(i,n){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,O.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=y;function b(i,n){const r=n?d:u;let o="",{scheme:s,authority:c,path:w,query:E,fragment:L}=i;if(s&&(o+=s,o+=":"),(c||s==="file")&&(o+=S,o+=S),c){let T=c.indexOf("@");if(T!==-1){const F=c.substr(0,T);c=c.substr(T+1),T=F.lastIndexOf(":"),T===-1?o+=r(F,!1,!1):(o+=r(F.substr(0,T),!1,!1),o+=":",o+=r(F.substr(T+1),!1,!0)),o+="@"}c=c.toLowerCase(),T=c.lastIndexOf(":"),T===-1?o+=r(c,!1,!0):(o+=r(c.substr(0,T),!1,!0),o+=c.substr(T))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const T=w.charCodeAt(1);T>=65&&T<=90&&(w=`/${String.fromCharCode(T+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const T=w.charCodeAt(0);T>=65&&T<=90&&(w=`${String.fromCharCode(T+32)}:${w.substr(2)}`)}o+=r(w,!0,!1)}return E&&(o+="?",o+=r(E,!1,!1)),L&&(o+="#",o+=n?L:u(L,!1,!1)),o}function P(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+P(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,n=>P(n)):i}}),define(se[146],re([0,1,10]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(v){const I=v;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=O;function l(v){const I=[];let S;try{const m=JSON.parse(v.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),S=f.__$stack),I.push(...m)}catch{I.push("Unable to log remote console arguments",v.arguments)}return{args:I,stack:S}}e.parse=l;function D(v){if(typeof v!="string")return D(l(v).stack);const I=v;if(I){const S=k(I),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:A.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=D;function k(v){if(!v)return v;const I=v.indexOf(`
`);return I===-1?v:v.substring(0,I)}function R(v,I){const{args:S,stack:m}=l(v),f=typeof S[0]=="string"&&S.length===1;let g=k(m);g&&(g=`(${g.trim()})`);let p=[];if(typeof S[0]=="string"?g&&f?p=[`%c[${I}] %c${S[0]} %c${g}`,C("blue"),C(""),C("grey")]:p=[`%c[${I}] %c${S[0]}`,C("blue"),C(""),...S.slice(1)]:p=[`%c[${I}]%`,C("blue"),...S],g&&!f&&p.push(g),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,p)}e.log=R;function C(v){return`color: ${v}`}}),define(se[91],re([0,1,17,26,10]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(v){return JSON.stringify(v,R)}e.stringify=D;function k(v){let I=JSON.parse(v);return I=C(I),I}e.parse=k;function R(v,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,O.regExpFlags)(I)}:I}function C(v,I=0){if(!v||I>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return l.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof A.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let S=0;S<v.length;++S)v[S]=C(v[S],I+1);else for(const S in v)Object.hasOwnProperty.call(v,S)&&(v[S]=C(v[S],I+1))}return v}e.revive=C}),define(se[21],re([0,1,7,4,10]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(I){this.d=I}setDelegate(I){this.e=I}setServerRootPath(I){this.f=`${I}/${D.vscodeRemoteResource}`}set(I,S,m){this.a[I]=S,this.b[I]=m}setConnectionToken(I,S){this.c[I]=S}getPreferredWebSchema(){return this.d}rewrite(I){if(this.e)try{return this.e(I)}catch(h){return A.onUnexpectedError(h),I}const S=I.authority;let m=this.a[S];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this.b[S],g=this.c[S];let p=`path=${encodeURIComponent(I.path)}`;return typeof g=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),l.URI.from({scheme:O.isWeb?this.d:D.vscodeRemoteResource,authority:`${m}:${f}`,path:this.f,query:p})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(I){const S=this.b(I,_);return this.uriToBrowserUri(S)}uriToBrowserUri(I){return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${D.vscodeFileResource}://${R.a}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||R.a,query:null,fragment:null}):I}asFileUri(I){const S=this.b(I,_);return this.uriToFileUri(S)}uriToFileUri(I){return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==R.a?I.authority:null,query:null,fragment:null}):I}b(I,S){return l.URI.isUri(I)?I:l.URI.parse(S.toUrl(I))}}R.a="vscode-app",e.FileAccess=new R;var C;(function(v){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(I.get("3"));const S="vscode-coi";function m(g){let p;typeof g=="string"?p=new URL(g).searchParams:g instanceof URL?p=g.searchParams:l.URI.isUri(g)&&(p=new URL(g.toString(!0)).searchParams);const h=p?.get(S);if(!!h)return I.get(h)}v.getHeadersFromQuery=m;function f(g,p,h){if(!globalThis.crossOriginIsolated)return;const u=p&&h?"3":h?"2":"1";g instanceof URLSearchParams?g.set(S,u):g[S]=u}v.addSearchParam=f})(C=e.COI||(e.COI={}))}),define(se[24],re([0,1,48,21,13,4,26,10]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(f){return(0,R.uriToFsPath)(f,!0)}e.originalFSPath=C;class v{constructor(g){this.a=g}compare(g,p,h=!1){return g===p?0:(0,k.compare)(this.getComparisonKey(g,h),this.getComparisonKey(p,h))}isEqual(g,p,h=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,h)===this.getComparisonKey(p,h)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,h=!1){if(g.scheme===p.scheme){if(g.scheme===O.Schemas.file)return A.isEqualOrParent(C(g),C(p),this.a(g))&&g.query===p.query&&(h||g.fragment===p.fragment);if((0,e.isEqualAuthority)(g.authority,p.authority))return A.isEqualOrParent(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(h||g.fragment===p.fragment)}return!1}joinPath(g,...p){return R.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return l.posix.basename(g.path)}extname(g){return l.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===O.Schemas.file?p=R.URI.file(l.dirname(C(g))).path:(p=l.posix.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===O.Schemas.file?p=R.URI.file(l.normalize(C(g))).path:p=l.posix.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.isEqualAuthority)(g.authority,p.authority))return;if(g.scheme===O.Schemas.file){const d=l.relative(C(g),C(p));return D.isWindows?A.toSlashes(d):d}let h=g.path||"/";const u=p.path||"/";if(this.a(g)){let d=0;for(const y=Math.min(h.length,u.length);d<y&&!(h.charCodeAt(d)!==u.charCodeAt(d)&&h.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);h=u.substr(0,d)+h.substr(d)}return l.posix.relative(h,u)}resolvePath(g,p){if(g.scheme===O.Schemas.file){const h=R.URI.file(l.resolve(C(g),p));return g.with({authority:h.authority,path:h.path})}return p=A.toPosixPath(p),g.with({path:l.posix.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,k.equalsIgnoreCase)(g,p)}hasTrailingPathSeparator(g,p=l.sep){if(g.scheme===O.Schemas.file){const h=C(g);return h.length>A.getRoot(h).length&&h[h.length-1]===p}else{const h=g.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=l.sep){return(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=l.sep){let h=!1;if(g.scheme===O.Schemas.file){const u=C(g);h=u!==void 0&&u.length===A.getRoot(u).length&&u[u.length-1]===p}else{p="/";const u=g.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path+"/"}):g}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(f=>f.scheme===O.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new v(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(f,g){const p=[];for(let h=0;h<f.length;h++){const u=g(f[h]);f.some((d,y)=>y===h?!1:(0,e.isEqualOrParent)(u,g(d)))||p.push(f[h])}return p}e.distinctParents=I;var S;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function g(p){const h=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(y=>{const[b,P]=y.split(":");b&&P&&h.set(b,P)});const d=p.path.substring(0,p.path.indexOf(";"));return d&&h.set(f.META_DATA_MIME,d),h}f.parseMetaData=g})(S=e.DataUri||(e.DataUri={}));function m(f,g,p){if(g){let h=f.path;return h&&h[0]!==l.posix.sep&&(h=l.posix.sep+h),f.with({scheme:p,authority:g,path:h})}return f.with({scheme:p})}e.toLocalResource=m}),define(se[6],re([0,1,23,7,3,2,24,4,133]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(V){return!!V&&typeof V.then=="function"}e.isThenable=v;function I(V){const j=new A.CancellationTokenSource,M=V(j.token),$=new Promise((H,ee)=>{const G=j.token.onCancellationRequested(()=>{G.dispose(),j.dispose(),ee(new O.CancellationError)});Promise.resolve(M).then(Z=>{G.dispose(),j.dispose(),H(Z)},Z=>{G.dispose(),j.dispose(),ee(Z)})});return new class{cancel(){j.cancel()}then(H,ee){return $.then(H,ee)}catch(H){return this.then(void 0,H)}finally(H){return $.finally(H)}}}e.createCancelablePromise=I;function S(V,j,M){return new Promise(($,H)=>{const ee=j.onCancellationRequested(()=>{ee.dispose(),$(M)});V.then($,H).finally(()=>ee.dispose())})}e.raceCancellation=S;function m(V,j){return new Promise((M,$)=>{const H=j.onCancellationRequested(()=>{H.dispose(),$(new O.CancellationError)});V.then(M,$).finally(()=>H.dispose())})}e.raceCancellationError=m;async function f(V){let j=-1;const M=V.map((H,ee)=>H.then(G=>(j=ee,G))),$=await Promise.race(M);return V.forEach((H,ee)=>{ee!==j&&H.cancel()}),$}e.raceCancellablePromises=f;function g(V,j,M){let $;const H=setTimeout(()=>{$?.(void 0),M?.()},j);return Promise.race([V.finally(()=>clearTimeout(H)),new Promise(ee=>$=ee)])}e.raceTimeout=g;function p(V){return new Promise((j,M)=>{const $=V();v($)?$.then(j,M):j($)})}e.asPromise=p;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(j){if(this.a){if(this.d=j,!this.b){const M=()=>{this.b=null;const $=this.queue(this.d);return this.d=null,$};this.b=new Promise($=>{this.a.then(M,M).then($)})}return new Promise((M,$)=>{this.b.then(M,$)})}return this.a=j(),new Promise((M,$)=>{this.a.then(H=>{this.a=null,M(H)},H=>{this.a=null,$(H)})})}}e.Throttler=h;class u{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.Sequencer=u;class d{constructor(){this.a=new Map}queue(j,M){const H=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(j)===H&&this.a.delete(j)});return this.a.set(j,H),H}}e.SequencerByKey=d;const y=(V,j)=>{let M=!0;const $=setTimeout(()=>{M=!1,j()},V);return{isTriggered:()=>M,dispose:()=>{clearTimeout($),M=!1}}},b=V=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,V())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class P{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,M=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((H,ee)=>{this.d=H,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const H=this.g;return this.g=null,H()}}));const $=()=>{this.a=null,this.d?.(null)};return this.a=M===C.MicrotaskDelay?b($):y(M,$),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=P;class t{constructor(j){this.a=new P(j),this.b=new h}trigger(j,M){return this.a.trigger(()=>this.b.queue(j),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((j,M)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(V,j){return j?new Promise((M,$)=>{const H=setTimeout(()=>{ee.dispose(),M()},V),ee=j.onCancellationRequested(()=>{clearTimeout(H),ee.dispose(),$(new O.CancellationError)})}):I(M=>n(V,M))}e.timeout=n;function r(V,j=0){const M=setTimeout(V,j);return(0,D.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=r;function o(V){const j=[];let M=0;const $=V.length;function H(){return M<$?V[M++]():null}function ee(G){G!=null&&j.push(G);const Z=H();return Z?Z.then(ee):Promise.resolve(j)}return Promise.resolve(null).then(ee)}e.sequence=o;function s(V,j=$=>!!$,M=null){let $=0;const H=V.length,ee=()=>{if($>=H)return Promise.resolve(M);const G=V[$++];return Promise.resolve(G()).then(te=>j(te)?Promise.resolve(te):ee())};return ee()}e.first=s;function c(V,j=$=>!!$,M=null){if(V.length===0)return Promise.resolve(M);let $=V.length;const H=()=>{$=-1;for(const ee of V)ee.cancel?.()};return new Promise((ee,G)=>{for(const Z of V)Z.then(te=>{--$>=0&&j(te)?(H(),ee(te)):$===0&&ee(M)}).catch(te=>{--$>=0&&(H(),G(te))})})}e.firstParallel=c;class w{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((M,$)=>{this.f.push({factory:j,c:M,e:$}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const M=j.factory();M.then(j.c,j.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=w;class E extends w{constructor(){super(1)}}e.Queue=E;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const j=new x;return this.b.add(j),j.p}d(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,M=k.extUri){const $=M.getComparisonKey(j);let H=this.a.get($);return H||(H=new E,l.Event.once(H.onDrained)(()=>{H?.dispose(),this.a.delete($),this.f()}),this.a.set($,H)),H}f(){!this.d()||this.g()}g(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class T{constructor(j,M){this.a=-1,typeof j=="function"&&typeof M=="number"&&this.setIfNotSet(j,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},M)}setIfNotSet(j,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},M))}}e.TimeoutTimer=T;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,M){this.cancel(),this.a=setInterval(()=>{j()},M)}}e.IntervalTimer=F;class z{constructor(j,M){this.b=-1,this.a=j,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=z;class J{constructor(j,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=j,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=J;class Y extends z{constructor(j,M){super(j,M),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Y;class W extends D.Disposable{constructor(j,M){super(),this.g=j,this.h=M,this.a=[],this.b=this.B(new D.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of j)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,R.setTimeout0)(()=>{if(j)return;const M=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(V,j)=>{const M=requestIdleCallback(V,typeof j=="number"?{timeout:j}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(M))}}}}();class N{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=N;async function B(V,j,M){let $;for(let H=0;H<M;H++)try{return await V()}catch(ee){$=ee,await n(j)}throw $}e.retry=B;class ie{hasPending(j){return this.a?typeof j=="number"?this.a.taskId===j:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(j,M,$){return this.a={taskId:j,cancel:()=>$?.(),promise:M},M.then(()=>this.d(j),()=>this.d(j)),M}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this.b)this.b.run=j;else{let M,$;const H=new Promise((ee,G)=>{M=ee,$=G});this.b={run:j,promise:H,promiseResolve:M,promiseReject:$}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=ie;class q{constructor(j,M=()=>Date.now()){this.d=j,this.f=M,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.IntervalCounter=q;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((j,M)=>{this.a=j,this.b=M})}complete(j){return new Promise(M=>{this.a(j),this.f=!0,M()})}error(j){return new Promise(M=>{this.b(j),this.d=!0,M()})}cancel(){new Promise(j=>{this.b(new O.CancellationError),this.d=!0,j()})}}e.DeferredPromise=x;var U;(function(V){async function j($){let H;const ee=await Promise.all($.map(G=>G.then(Z=>Z,Z=>{H||(H=Z)})));if(typeof H<"u")throw H;return ee}V.settled=j;function M($){return new Promise(async(H,ee)=>{try{await $(H,ee)}catch(G){ee(G)}})}V.withAsyncBody=M})(U=e.Promises||(e.Promises={}));var K;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(K||(K={}));class Q{static fromArray(j){return new Q(M=>{M.emitMany(j)})}static fromPromise(j){return new Q(async M=>{M.emitMany(await j)})}static fromPromises(j){return new Q(async M=>{await Promise.all(j.map(async $=>M.emitOne(await $)))})}static merge(j){return new Q(async M=>{await Promise.all(j.map(async $=>{for await(const H of $)M.emitOne(H)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const M={emitOne:$=>this.g($),emitMany:$=>this.h($),reject:$=>this.k($)};try{await Promise.resolve(j(M)),this.j()}catch($){this.k($)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(j,M){return new Q(async $=>{for await(const H of j)$.emitOne(M(H))})}map(j){return Q.map(this,j)}static filter(j,M){return new Q(async $=>{for await(const H of j)M(H)&&$.emitOne(H)})}filter(j){return Q.filter(this,j)}static coalesce(j){return Q.filter(j,M=>!!M)}coalesce(){return Q.coalesce(this)}static async toPromise(j){const M=[];for await(const $ of j)M.push($);return M}toPromise(){return Q.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}Q.EMPTY=Q.fromArray([]),e.AsyncIterableObject=Q;class oe extends Q{constructor(j,M){super(M),this.l=j}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function ae(V){const j=new A.CancellationTokenSource,M=V(j.token);return new oe(j,async $=>{const H=j.token.onCancellationRequested(()=>{H.dispose(),j.dispose(),$.reject(new O.CancellationError)});try{for await(const ee of M){if(j.token.isCancellationRequested)return;$.emitOne(ee)}H.dispose(),j.dispose()}catch(ee){H.dispose(),j.dispose(),$.reject(ee)}})}e.createCancelableAsyncIterable=ae}),define(se[92],re([0,1,18,6,48,38,13,4,26]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",S="[^/\\\\]",m=/\//g;function f(q,x){switch(q){case 0:return"";case 1:return`${S}*?`;default:return`(?:${I}|${S}+${I}${x?`|${I}${S}+`:""})*?`}}function g(q,x){if(!q)return[];const U=[];let K=!1,Q=!1,oe="";for(const ae of q){switch(ae){case x:if(!K&&!Q){U.push(oe),oe="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}oe+=ae}return oe&&U.push(oe),U}e.splitGlobAware=g;function p(q){if(!q)return"";let x="";const U=g(q,e.GLOB_SPLIT);if(U.every(K=>K===e.GLOBSTAR))x=".*";else{let K=!1;U.forEach((Q,oe)=>{if(Q===e.GLOBSTAR){if(K)return;x+=f(2,oe===U.length-1)}else{let ae=!1,V="",j=!1,M="";for(const $ of Q){if($!=="}"&&ae){V+=$;continue}if(j&&($!=="]"||!M)){let H;$==="-"?H=$:($==="^"||$==="!")&&!M?H="^":$===e.GLOB_SPLIT?H="":H=(0,C.escapeRegExpCharacters)($),M+=H;continue}switch($){case"{":ae=!0;continue;case"[":j=!0;continue;case"}":{x+=`(?:${g(V,",").map(G=>p(G)).join("|")})`,ae=!1,V="";break}case"]":{x+="["+M+"]",j=!1,M="";break}case"?":x+=S;continue;case"*":x+=f(1);continue;default:x+=(0,C.escapeRegExpCharacters)($)}}oe<U.length-1&&(U[oe+1]!==e.GLOBSTAR||oe+2<U.length)&&(x+=I)}K=Q===e.GLOBSTAR})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,P=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),a=function(){return!1},i=function(){return null};function n(q,x){if(!q)return i;let U;typeof q!="string"?U=q.pattern:U=q,U=U.trim();const K=`${U}_${!!x.trimForExclusions}`;let Q=t.get(K);if(Q)return r(Q,q);let oe;return h.test(U)?Q=s(U.substr(4),U):(oe=u.exec(o(U,x)))?Q=c(oe[1],U):(x.trimForExclusions?y:d).test(U)?Q=w(U,x):(oe=b.exec(o(U,x)))?Q=E(oe[1].substr(1),U,!0):(oe=P.exec(o(U,x)))?Q=E(oe[1],U,!1):Q=L(U),t.set(K,Q),r(Q,q)}function r(q,x){if(typeof x=="string")return q;const U=function(K,Q){return(0,l.isEqualOrParent)(K,x.base,!R.isLinux)?q((0,C.ltrim)(K.substr(x.base.length),k.sep),Q):null};return U.allBasenames=q.allBasenames,U.allPaths=q.allPaths,U.basenames=q.basenames,U.patterns=q.patterns,U}function o(q,x){return x.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function s(q,x){return function(U,K){return typeof U=="string"&&U.endsWith(q)?x:null}}function c(q,x){const U=`/${q}`,K=`\\${q}`,Q=function(ae,V){return typeof ae!="string"?null:V?V===q?x:null:ae===q||ae.endsWith(U)||ae.endsWith(K)?x:null},oe=[q];return Q.basenames=oe,Q.patterns=[x],Q.allBasenames=oe,Q}function w(q,x){const U=B(q.slice(1,-1).split(",").map(V=>n(V,x)).filter(V=>V!==i),q),K=U.length;if(!K)return i;if(K===1)return U[0];const Q=function(V,j){for(let M=0,$=U.length;M<$;M++)if(U[M](V,j))return q;return null},oe=U.find(V=>!!V.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const ae=U.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return ae.length&&(Q.allPaths=ae),Q}function E(q,x,U){const K=k.sep===k.posix.sep,Q=K?q:q.replace(m,k.sep),oe=k.sep+Q,ae=k.posix.sep+q;let V;return U?V=function(j,M){return typeof j=="string"&&(j===Q||j.endsWith(oe)||!K&&(j===q||j.endsWith(ae)))?x:null}:V=function(j,M){return typeof j=="string"&&(j===Q||!K&&j===q)?x:null},V.allPaths=[(U?"*/":"./")+q],V}function L(q){try{const x=new RegExp(`^${p(q)}$`);return function(U){return x.lastIndex=0,typeof U=="string"&&x.test(U)?q:null}}catch{return i}}function T(q,x,U){return!q||typeof x!="string"?!1:F(q)(x,void 0,U)}e.match=T;function F(q,x={}){if(!q)return a;if(typeof q=="string"||z(q)){const U=n(q,x);if(U===i)return a;const K=function(Q,oe){return!!U(Q,oe)};return U.allBasenames&&(K.allBasenames=U.allBasenames),U.allPaths&&(K.allPaths=U.allPaths),K}return W(q,x)}e.parse=F;function z(q){const x=q;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=z;function J(q){return q.allBasenames||[]}e.getBasenameTerms=J;function Y(q){return q.allPaths||[]}e.getPathTerms=Y;function W(q,x){const U=B(Object.getOwnPropertyNames(q).map(V=>N(V,q[V],x)).filter(V=>V!==i)),K=U.length;if(!K)return i;if(!U.some(V=>!!V.requiresSiblings)){if(K===1)return U[0];const V=function($,H){let ee;for(let G=0,Z=U.length;G<Z;G++){const te=U[G]($,H);if(typeof te=="string")return te;(0,O.isThenable)(te)&&(ee||(ee=[]),ee.push(te))}return ee?(async()=>{for(const G of ee){const Z=await G;if(typeof Z=="string")return Z}return null})():null},j=U.find($=>!!$.allBasenames);j&&(V.allBasenames=j.allBasenames);const M=U.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return M.length&&(V.allPaths=M),V}const Q=function(V,j,M){let $,H;for(let ee=0,G=U.length;ee<G;ee++){const Z=U[ee];Z.requiresSiblings&&M&&(j||(j=(0,k.basename)(V)),$||($=j.substr(0,j.length-(0,k.extname)(V).length)));const te=Z(V,j,$,M);if(typeof te=="string")return te;(0,O.isThenable)(te)&&(H||(H=[]),H.push(te))}return H?(async()=>{for(const ee of H){const G=await ee;if(typeof G=="string")return G}return null})():null},oe=U.find(V=>!!V.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const ae=U.reduce((V,j)=>j.allPaths?V.concat(j.allPaths):V,[]);return ae.length&&(Q.allPaths=ae),Q}function N(q,x,U){if(x===!1)return i;const K=n(q,U);if(K===i)return i;if(typeof x=="boolean")return K;if(x){const Q=x.when;if(typeof Q=="string"){const oe=(ae,V,j,M)=>{if(!M||!K(ae,V))return null;const $=Q.replace("$(basename)",()=>j),H=M($);return(0,O.isThenable)(H)?H.then(ee=>ee?q:null):H?q:null};return oe.requiresSiblings=!0,oe}}return K}function B(q,x){const U=q.filter(V=>!!V.basenames);if(U.length<2)return q;const K=U.reduce((V,j)=>{const M=j.basenames;return M?V.concat(M):V},[]);let Q;if(x){Q=[];for(let V=0,j=K.length;V<j;V++)Q.push(x)}else Q=U.reduce((V,j)=>{const M=j.patterns;return M?V.concat(M):V},[]);const oe=function(V,j){if(typeof V!="string")return null;if(!j){let $;for($=V.length;$>0;$--){const H=V.charCodeAt($-1);if(H===47||H===92)break}j=V.substr($)}const M=K.indexOf(j);return M!==-1?Q[M]:null};oe.basenames=K,oe.patterns=Q,oe.allBasenames=K;const ae=q.filter(V=>!V.basenames);return ae.push(oe),ae}function ie(q,x){return(0,A.equals)(q,x,(U,K)=>typeof U=="string"&&typeof K=="string"?U===K:typeof U!="string"&&typeof K!="string"?U.base===K.base&&U.pattern===K.pattern:!1)}e.patternsEquals=ie}),define(se[93],re([0,1,17,10]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(S){return S.toJSON()}class D{constructor(m){this.a=m}transformIncoming(m){const f=this.a.transformIncoming(m);return f===m?m:l(O.URI.from(f))}transformOutgoing(m){const f=this.a.transformOutgoing(m);return f===m?m:l(O.URI.from(f))}transformOutgoingURI(m){const f=this.a.transformOutgoing(m);return f===m?m:O.URI.from(f)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function k(S,m,f){if(!S||f>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return m.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const p=k(S[g],m,f+1);p!==null&&(S[g]=p)}}return null}function R(S,m){const f=k(S,m,0);return f===null?S:f}e.transformOutgoingURIs=R;function C(S,m,f,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return f?O.URI.revive(m.transformIncoming(S)):m.transformIncoming(S);if(S instanceof A.VSBuffer)return null;for(const p in S)if(Object.hasOwnProperty.call(S,p)){const h=C(S[p],m,f,g+1);h!==null&&(S[p]=h)}}return null}function v(S,m){const f=C(S,m,!1,0);return f===null?S:f}e.transformIncomingURIs=v;function I(S,m){const f=C(S,m,!0,0);return f===null?S:f}e.transformAndReviveIncomingURIs=I}),define(se[147],re([0,1,34,7,49,31,135]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,S=0;const m=(0,A.networkInterfaces)();for(const f in m){const g=m[f];if(g)for(const{mac:p,internal:h}of g)h||(S+=1,this.c(p.toUpperCase())&&(I+=1))}this.b=S>0?I/S:0}return this.b}};let R;async function C(){return R||(R=(async()=>await v()||D.generateUuid())()),R}e.getMachineId=C;async function v(){try{const I=await new Promise((m,f)=>{_(["crypto"],m,f)}),S=(0,k.getMac)();return I.createHash("sha256").update(S,"utf8").digest("hex")}catch(I){O.onUnexpectedError(I);return}}}),define(se[27],re([0,1,53,34,295,6,48,85,13,4,24,10]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function f(W,N=m.UNLINK){if((0,k.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return N===m.UNLINK?p(W):g(W)}async function g(W){try{const N=(0,k.randomPath)((0,O.tmpdir)());try{await A.promises.rename(W,N)}catch(B){return B.code==="ENOENT"?void 0:p(W)}p(N).catch(B=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function p(W){return(0,l.promisify)(A.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function h(W){if((0,k.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");A.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(W,N){return b(await(N?d(W):(0,l.promisify)(A.readdir)(W)))}async function d(W){try{return await(0,l.promisify)(A.readdir)(W,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const N=[],B=await u(W);for(const ie of B){let q=!1,x=!1,U=!1;try{const K=await e.Promises.lstat((0,C.join)(W,ie));q=K.isFile(),x=K.isDirectory(),U=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}N.push({name:ie,isFile:()=>q,isDirectory:()=>x,isSymbolicLink:()=>U})}return N}function y(W){return b(A.readdirSync(W))}e.readdirSync=y;function b(W){return W.map(N=>typeof N=="string"?v.isMacintosh?(0,R.normalizeNFC)(N):N:(N.name=v.isMacintosh?(0,R.normalizeNFC)(N.name):N.name,N))}async function P(W){const N=await u(W),B=[];for(const ie of N)await a.existsDirectory((0,C.join)(W,ie))&&B.push(ie);return B}function t(W,N=1e3){return new Promise(B=>{let ie=!1;const q=setInterval(()=>{ie||(ie=!0,A.access(W,x=>{ie=!1,x&&(clearInterval(q),B(void 0))}))},N)})}e.whenDeleted=t;var a;(function(W){async function N(q){let x;try{if(x=await e.Promises.lstat(q),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(v.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw K}throw U}}W.stat=N;async function B(q){try{const{stat:x,symbolicLink:U}=await W.stat(q);return x.isFile()&&U?.dangling!==!0}catch{}return!1}W.existsFile=B;async function ie(q){try{const{stat:x,symbolicLink:U}=await W.stat(q);return x.isDirectory()&&U?.dangling!==!0}catch{}return!1}W.existsDirectory=ie})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new D.ResourceQueue;function n(W,N,B){return i.queueFor(S.URI.file(W),I.extUriBiasedIgnorePathCase).queue(()=>{const ie=w(B);return new Promise((q,x)=>s(W,N,ie,U=>U?x(U):q()))})}let r=!0;function o(W){r=W}e.configureFlushOnWrite=o;function s(W,N,B,ie){if(!r)return A.writeFile(W,N,{mode:B.mode,flag:B.flag},ie);A.open(W,B.flag,B.mode,(q,x)=>{if(q)return ie(q);A.writeFile(x,N,U=>{if(U)return A.close(x,()=>ie(U));A.fdatasync(x,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),o(!1)),A.close(x,Q=>ie(Q))))})})}function c(W,N,B){const ie=w(B);if(!r)return A.writeFileSync(W,N,{mode:ie.mode,flag:ie.flag});const q=A.openSync(W,ie.flag,ie.mode);try{A.writeFileSync(q,N);try{A.fdatasyncSync(q)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),o(!1)}}finally{A.closeSync(q)}}e.writeFileSync=c;function w(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function E(W,N){if(W!==N)try{await e.Promises.rename(W,N)}catch(B){if(W.toLowerCase()!==N.toLowerCase()&&B.code==="EXDEV"||W.endsWith("."))await L(W,N,{preserveSymlinks:!1}),await f(W,m.MOVE);else throw B}}async function L(W,N,B){return F(W,N,{root:{source:W,target:N},options:B,handledSourcePaths:new Set})}const T=511;async function F(W,N,B){if(B.handledSourcePaths.has(W))return;B.handledSourcePaths.add(W);const{stat:ie,symbolicLink:q}=await a.stat(W);if(q){if(B.options.preserveSymlinks)try{return await Y(W,N,B)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(q.dangling)return}return ie.isDirectory()?z(W,N,ie.mode&T,B):J(W,N,ie.mode&T)}async function z(W,N,B,ie){await e.Promises.mkdir(N,{recursive:!0,mode:B});const q=await u(W);for(const x of q)await F((0,C.join)(W,x),(0,C.join)(N,x),ie)}async function J(W,N,B){await e.Promises.copyFile(W,N),await e.Promises.chmod(N,B)}async function Y(W,N,B){let ie=await e.Promises.readlink(W);(0,k.isEqualOrParent)(ie,B.root.source,!v.isLinux)&&(ie=(0,C.join)(B.root.target,ie.substr(B.root.source.length+1))),await e.Promises.symlink(ie,N)}e.Promises=new class{get access(){return(0,l.promisify)(A.access)}get stat(){return(0,l.promisify)(A.stat)}get lstat(){return(0,l.promisify)(A.lstat)}get utimes(){return(0,l.promisify)(A.utimes)}get read(){return(W,N,B,ie,q)=>new Promise((x,U)=>{A.read(W,N,B,ie,q,(K,Q,oe)=>K?U(K):x({bytesRead:Q,buffer:oe}))})}get readFile(){return(0,l.promisify)(A.readFile)}get write(){return(W,N,B,ie,q)=>new Promise((x,U)=>{A.write(W,N,B,ie,q,(K,Q,oe)=>K?U(K):x({bytesWritten:Q,buffer:oe}))})}get appendFile(){return(0,l.promisify)(A.appendFile)}get fdatasync(){return(0,l.promisify)(A.fdatasync)}get truncate(){return(0,l.promisify)(A.truncate)}get rename(){return(0,l.promisify)(A.rename)}get copyFile(){return(0,l.promisify)(A.copyFile)}get open(){return(0,l.promisify)(A.open)}get close(){return(0,l.promisify)(A.close)}get symlink(){return(0,l.promisify)(A.symlink)}get readlink(){return(0,l.promisify)(A.readlink)}get chmod(){return(0,l.promisify)(A.chmod)}get mkdir(){return(0,l.promisify)(A.mkdir)}get unlink(){return(0,l.promisify)(A.unlink)}get rmdir(){return(0,l.promisify)(A.rmdir)}get realpath(){return(0,l.promisify)(A.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return P}get writeFile(){return n}get rm(){return f}get move(){return E}get copy(){return L}}}),define(se[148],re([0,1,53,13,4,26,27]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(m){if(l.isLinux)return m;const f=(0,O.dirname)(m);if(m===f)return m;const g=((0,O.basename)(m)||m).toLowerCase();try{const h=(0,k.readdirSync)(f).filter(u=>u.toLowerCase()===g);if(h.length===1){const u=R(f);if(u)return(0,O.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(g);if(u>=0){const d=R(f);if(d)return(0,O.join)(d,h[u])}}}catch{}return null}e.realcaseSync=R;async function C(m){if(l.isLinux)return m;const f=(0,O.dirname)(m);if(m===f)return m;const g=((0,O.basename)(m)||m).toLowerCase();try{const h=(await k.Promises.readdir(f)).filter(u=>u.toLowerCase()===g);if(h.length===1){const u=await C(f);if(u)return(0,O.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(g);if(u>=0){const d=await C(f);if(d)return(0,O.join)(d,h[u])}}}catch{}return null}e.realcase=C;async function v(m){try{return await k.Promises.realpath(m)}catch{const g=S(m);return await k.Promises.access(g,A.constants.R_OK),g}}e.realpath=v;function I(m){try{return A.realpathSync(m)}catch{const g=S(m);return A.accessSync(g,A.constants.R_OK),g}}e.realpathSync=I;function S(m){return(0,D.rtrim)((0,O.normalize)(m),O.sep)}}),define(se[94],re([0,1,34,13,27]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(C||(C={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class S{constructor(P,t,a){this.exePath=P,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:b=!1}={}){return b?v===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:b=!1,findPreview:P=!1}={}){const t=m({useAlternateBitness:b});if(!t)return null;const a=O.join(t,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const s of await l.Promises.readdir(a)){let c=-1;if(P){const E=s.indexOf("-");if(E<0)continue;const L=s.substring(0,E);if(!D.test(L)||s.substring(E+1)!=="preview")continue;c=parseInt(L,10)}else{if(!D.test(s))continue;c=parseInt(s,10)}if(c<=i)continue;const w=O.join(a,s,"pwsh.exe");!await l.SymlinkSupport.existsFile(w)||(n=w,i=c)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=P?" Preview":"";return new S(n,`PowerShell${o}${r}`,!0)}async function g({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const P=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(P))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=b?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await l.Promises.readdir(P))if(t.test(i)){const n=O.join(P,i,"pwsh.exe");return new S(n,a)}return null}function p(){const b=O.join(A.homedir(),".dotnet","tools","pwsh.exe");return new S(b,".NET Core PowerShell Global Tool")}function h(){const b=O.join(process.env.windir,v===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(b,"Windows PowerShell",!0)}async function*u(){let b=await f();b&&(yield b),b=await f({useAlternateBitness:!0}),b&&(yield b),b=await g(),b&&(yield b),b=p(),b&&(yield b),b=await f({findPreview:!0}),b&&(yield b),b=await g({findPreview:!0}),b&&(yield b),b=await f({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=h(),b&&(yield b)}async function*d(){for await(const b of u())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=d;async function y(){for await(const b of d())return b;return null}e.getFirstAvailablePowerShellInstallation=y}),define(se[95],re([0,1,13,4,36,88,12,27]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function C(S=l.env){return S.comspec||"cmd.exe"}e.getWindowsShell=C;function v(S){let m=[],f=!1;const g=function(p){if(f){m.push(p);return}(!S.send(p,u=>{if(u&&console.error(u),f=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(y=>g(y))}})||O.isWindows)&&(f=!0)};return{send:g}}e.createQueuedSender=v;var I;(function(S){async function m(f,g,p){if(A.isAbsolute(f))return f;if(g===void 0&&(g=l.cwd()),A.dirname(f)!=="."||(p===void 0&&k.isString(l.env.PATH)&&(p=l.env.PATH.split(A.delimiter)),p===void 0||p.length===0))return A.join(g,f);async function u(d){if(await R.Promises.exists(d)){let y;try{y=await R.Promises.stat(d)}catch(b){b.message.startsWith("EACCES")&&(y=await R.Promises.lstat(d))}return y?!y.isDirectory():!1}return!1}for(const d of p){let y;if(A.isAbsolute(d)?y=A.join(d,f):y=A.join(g,d,f),await u(y))return y;let b=y+".com";if(await u(b)||(b=y+".exe",await u(b)))return b}return A.join(g,f)}S.findExecutable=m})(I=e.win32||(e.win32={}))}),define(se[149],re([0,1,50,21]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(k){return new Promise((R,C)=>{let v;const I=new Map;function S(f,g,p,h,u){const d=I.get(g);if(f===k||d){const y={name:m(p),cmd:p,pid:f,ppid:g,load:h,mem:u};I.set(f,y),f===k&&(v=y),d&&(d.children||(d.children=[]),d.children.push(y),d.children.length>1&&(d.children=d.children.sort((b,P)=>b.pid-P.pid)))}}function m(f){const g=/--vscode-window-kind=shared-process/i,p=/--vscode-window-kind=issue-reporter/i,h=/--vscode-window-kind=process-explorer/i,u=/--utility-sub-type=network/i,d=/--vscode-utility-kind=extensionHost/i,y=/--vscode-utility-kind=fileWatcher/i,b=/--vscode-utility-kind=shared-process/i,P=/--ms-enable-electron-run-as-node/i,t=/--crashes-directory/i,a=/\\pipe\\winpty-control/i,i=/conhost\.exe/i,n=/--type=([a-zA-Z-]+)/;if(t.exec(f))return"electron-crash-reporter";if(a.exec(f))return"winpty-process";if(i.exec(f))return"console-window-host (Windows internal process)";let r=n.exec(f);if(r&&r.length===2){if(r[1]==="renderer")return g.exec(f)?"shared-process":p.exec(f)?"issue-reporter":h.exec(f)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(f))return"utility-network-service";if(d.exec(f))return"extension-host";if(y.exec(f))return"file-watcher";if(b.exec(f))return"shared-process"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const o=/[a-zA-Z-]+\.js/g;let s="";do r=o.exec(f),r&&(s+=r+" ");while(r);return s&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs ${s}`:P.exec(f)?"electron-nodejs":f}if(process.platform==="win32"){const f=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,p)=>{_(["windows-process-tree"],g,p)}).then(g=>{g.getProcessList(k,p=>{if(!p){C(new Error(`Root process ${k} not found`));return}g.getProcessCpuUsage(p,h=>{const u=new Map;h.forEach(d=>{const y=f(d.commandLine||"");u.set(d.pid,{name:m(y),cmd:y,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),v=u.get(k),v?(u.forEach(d=>{const y=u.get(d.ppid);y&&(y.children||(y.children=[]),y.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((y,b)=>y.pid-b.pid))}),R(v)):C(new Error(`Root process ${k} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let f=function(){let g=[v];const p=[];for(;g.length;){const u=g.shift();u&&(p.push(u.pid),u.children&&(g=g.concat(u.children)))}let h=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+p.join(" "),(0,A.exec)(h,{},(u,d,y)=>{if(u||y)C(u||new Error(y.toString()));else{const b=d.toString().split(`
`);for(let P=0;P<p.length;P++){const t=I.get(p[P]);t.load=parseFloat(b[P])}if(!v){C(new Error(`Root process ${k} not found`));return}R(v)}})};(0,A.exec)("which ps",{},(g,p,h)=>{if(g||h)if(process.platform!=="linux")C(g||new Error(h.toString()));else{const u=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,A.exec)(u,{},(d,y,b)=>{d||b?C(d||new Error(b.toString())):(D(y,S),f())})}else{const u=p.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,A.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,b,P)=>{y||P&&!P.includes("screen size is bogus")?C(y||new Error(P.toString())):(D(b,S),process.platform==="linux"?f():v?R(v):C(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=l;function D(k,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=k.toString().split(`
`);for(const I of v){const S=C.exec(I.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(se[150],re([0,1,34,4,94,95]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(S,m){return S===1?O.isWindows?I():D.getWindowsShell(m):C(S,m)}e.getSystemShell=k;let R=null;function C(S,m){if(O.isLinux&&S===2||O.isMacintosh&&S===3)return"/bin/bash";if(!R){let f;if(O.isWindows)f="/bin/bash";else{if(f=m.SHELL,!f)try{f=(0,A.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}R=f}return R}let v=null;async function I(){return v||(v=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),v}});var ye=this&&this.__decorate||function(_,e,A,O){var l=arguments.length,D=l<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,A):O,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(_,e,A,O);else for(var R=_.length-1;R>=0;R--)(k=_[R])&&(D=(l<3?k(D):l>3?k(e,A,D):k(e,A))||D);return l>3&&D&&Object.defineProperty(e,A,D),D};define(se[37],re([0,1,18,6,17,23,62,7,3,2,91,26,12]),function(_,e,A,O,l,D,k,R,C,v,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(f||(f={}));function g(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p||(p={}));function h(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(u||(u={}));function d(x){let U=0;for(let K=0;;K+=7){const Q=x.read(1);if(U|=(Q.buffer[0]&127)<<K,!(Q.buffer[0]&128))return U}}const y=i(0);function b(x,U){if(U===0){x.write(y);return}let K=0;for(let oe=U;oe!==0;oe=oe>>>7)K++;const Q=l.VSBuffer.alloc(K);for(let oe=0;U!==0;oe++)Q.buffer[oe]=U&127,U=U>>>7,U>0&&(Q.buffer[oe]|=128);x.write(Q)}class P{constructor(U){this.b=U,this.a=0}read(U){const K=this.b.slice(this.a,this.a+U);return this.a+=K.byteLength,K}}e.BufferReader=P;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(a||(a={}));function i(x){const U=l.VSBuffer.alloc(1);return U.writeUInt8(x,0),U}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},r=typeof Buffer<"u";function o(x,U){if(typeof U>"u")x.write(n.Undefined);else if(typeof U=="string"){const K=l.VSBuffer.fromString(U);x.write(n.String),b(x,K.byteLength),x.write(K)}else if(r&&Buffer.isBuffer(U)){const K=l.VSBuffer.wrap(U);x.write(n.Buffer),b(x,K.byteLength),x.write(K)}else if(U instanceof l.VSBuffer)x.write(n.VSBuffer),b(x,U.byteLength),x.write(U);else if(Array.isArray(U)){x.write(n.Array),b(x,U.length);for(const K of U)o(x,K)}else if(typeof U=="number"&&(U|0)===U)x.write(n.Uint),b(x,U);else{const K=l.VSBuffer.fromString(JSON.stringify(U));x.write(n.Object),b(x,K.byteLength),x.write(K)}}e.serialize=o;function s(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(d(x)).toString();case a.Buffer:return x.read(d(x)).buffer;case a.VSBuffer:return x.read(d(x));case a.Array:{const K=d(x),Q=[];for(let oe=0;oe<K;oe++)Q.push(s(x));return Q}case a.Object:return JSON.parse(x.read(d(x)).toString());case a.Int:return d(x)}}e.deserialize=s;class c{constructor(U,K,Q=null,oe=1e3){this.h=U,this.j=K,this.k=Q,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(U,K){this.b.set(U,K),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const K=this.o([U.type]);this.k?.logOutgoing(K,0,1,h(U.type));return}case 201:case 202:case 204:case 203:{const K=this.o([U.type,U.id],U.data);this.k?.logOutgoing(K,U.id,1,h(U.type),U.data);return}}}o(U,K=void 0){const Q=new t;return o(Q,U),o(Q,K),this.p(Q.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const K=new P(U),Q=s(K),oe=s(K),ae=Q[0];switch(ae){case 100:return this.k?.logIncoming(U.byteLength,Q[1],1,`${g(ae)}: ${Q[2]}.${Q[3]}`,oe),this.s({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case 102:return this.k?.logIncoming(U.byteLength,Q[1],1,`${g(ae)}: ${Q[2]}.${Q[3]}`,oe),this.t({type:ae,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case 101:return this.k?.logIncoming(U.byteLength,Q[1],1,`${g(ae)}`),this.u({type:ae,id:Q[1]});case 103:return this.k?.logIncoming(U.byteLength,Q[1],1,`${g(ae)}`),this.u({type:ae,id:Q[1]})}}s(U){const K=this.b.get(U.channelName);if(!K){this.v(U);return}const Q=new D.CancellationTokenSource;let oe;try{oe=K.call(this.j,U.name,U.arg,Q.token)}catch(j){oe=Promise.reject(j)}const ae=U.id;oe.then(j=>{this.m({id:ae,data:j,type:201}),this.d.delete(U.id)},j=>{j instanceof Error?this.m({id:ae,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.m({id:ae,data:j,type:203}),this.d.delete(U.id)});const V=(0,v.toDisposable)(()=>Q.cancel());this.d.set(U.id,V)}t(U){const K=this.b.get(U.channelName);if(!K){this.v(U);return}const Q=U.id,ae=K.listen(this.j,U.name,U.arg)(V=>this.m({id:Q,data:V,type:204}));this.d.set(U.id,ae)}u(U){const K=this.d.get(U.id);K&&(K.dispose(),this.d.delete(U.id))}v(U){let K=this.g.get(U.channelName);K||(K=[],this.g.set(U.channelName,K));const Q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);K.push({request:U,timeoutTimer:Q})}w(U){const K=this.g.get(U);if(K){for(const Q of K)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=c;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(U,K=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=K}getChannel(U){const K=this;return{call(Q,oe,ae){return K.a?Promise.reject(new R.CancellationError):K.m(U,Q,oe,ae)},listen(Q,oe){return K.a?C.Event.None:K.o(U,Q,oe)}}}m(U,K,Q,oe=D.CancellationToken.None){const ae=this.g++,j={id:ae,type:100,channelName:U,name:K,arg:Q};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let M;return new Promise((H,ee)=>{if(oe.isCancellationRequested)return ee(new R.CancellationError);const G=()=>{const he=me=>{switch(me.type){case 201:this.f.delete(ae),H(me.data);break;case 202:{this.f.delete(ae);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,ee(pe);break}case 203:this.f.delete(ae),ee(me.data);break}};this.f.set(ae,he),this.p(j)};let Z=null;this.b===u.Idle?G():(Z=(0,O.createCancelablePromise)(he=>this.u()),Z.then(()=>{Z=null,G()}));const te=()=>{Z?(Z.cancel(),Z=null):this.p({id:ae,type:101}),ee(new R.CancellationError)},le=oe.onCancellationRequested(te);M=(0,v.combinedDisposable)((0,v.toDisposable)(te),le),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(U,K,Q){const oe=this.g++,V={id:oe,type:102,channelName:U,name:K,arg:Q};let j=null;const M=new C.Emitter({onWillAddFirstListener:()=>{j=(0,O.createCancelablePromise)(H=>this.u()),j.then(()=>{j=null,this.d.add(M),this.p(V)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.d.delete(M),this.p({id:oe,type:103}))}}),$=H=>M.fire(H.data);return this.f.set(oe,$),M.event}p(U){switch(U.type){case 100:case 102:{const K=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(K,U.id,0,`${g(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const K=this.q([U.type,U.id]);this.j?.logOutgoing(K,U.id,0,g(U.type));return}}}q(U,K=void 0){const Q=new t;return o(Q,U),o(Q,K),this.r(Q.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const K=new P(U),Q=s(K),oe=s(K),ae=Q[0];switch(ae){case 200:return this.j?.logIncoming(U.byteLength,0,0,h(ae)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Q[1],0,h(ae),oe),this.t({type:Q[0],id:Q[1],data:oe})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.dispose)(this.d.values()),this.d.clear()}}ye([k.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class L{get connections(){const U=[];return this.f.forEach(K=>U.push(K)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new C.Emitter,this.onDidAddConnection=this.g.event,this.h=new C.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:K,onDidClientDisconnect:Q})=>{C.Event.once(K.onMessage)(ae=>{const V=new P(ae),j=s(V),M=new c(K,j),$=new E(K);this.a.forEach((ee,G)=>M.registerChannel(G,ee));const H={channelServer:M,channelClient:$,ctx:j};this.f.add(H),this.g.fire(H),Q(()=>{M.dispose(),$.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(U,K){const Q=this;return{call(oe,ae,V){let j;if((0,m.isFunction)(K)){const $=(0,A.getRandomElement)(Q.connections.filter(K));j=$?Promise.resolve($):C.Event.toPromise(C.Event.filter(Q.onDidAddConnection,K))}else j=K.routeCall(Q,oe,ae);const M=j.then($=>$.channelClient.getChannel(U));return F(M).call(oe,ae,V)},listen(oe,ae){if((0,m.isFunction)(K))return Q.j(U,K,oe,ae);const V=K.routeEvent(Q,oe,ae).then(j=>j.channelClient.getChannel(U));return F(V).listen(oe,ae)}}}j(U,K,Q,oe){const ae=this;let V=new v.DisposableStore;const j=new C.Emitter({onWillAddFirstListener:()=>{V=new v.DisposableStore;const M=new C.EventMultiplexer,$=new Map,H=G=>{const te=G.channelClient.getChannel(U).listen(Q,oe),le=M.add(te);$.set(G,le)},ee=G=>{const Z=$.get(G);!Z||(Z.dispose(),$.delete(G))};ae.connections.filter(K).forEach(H),C.Event.filter(ae.onDidAddConnection,K)(H,void 0,V),ae.onDidRemoveConnection(ee,void 0,V),M.event(j.fire,j,V),V.add(M)},onDidRemoveLastListener:()=>{V.dispose()}});return j.event}registerChannel(U,K){this.a.set(U,K),this.f.forEach(Q=>{Q.channelServer.registerChannel(U,K)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class T{constructor(U,K,Q=null){const oe=new t;o(oe,K),U.send(oe.buffer),this.a=new E(U,Q),this.d=new c(U,K,Q)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,K){this.d.registerChannel(U,K)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=T;function F(x){return{call(U,K,Q){return x.then(oe=>oe.call(U,K,Q))},listen(U,K){const Q=new C.Relay;return x.then(oe=>Q.input=oe.listen(U,K)),Q.event}}}e.getDelayedChannel=F;function z(x){let U=!1;return{call(K,Q,oe){return U?x.call(K,Q,oe):(0,O.timeout)(0).then(()=>U=!0).then(()=>x.call(K,Q,oe))},listen(K,Q){if(U)return x.listen(K,Q);const oe=new C.Relay;return(0,O.timeout)(0).then(()=>U=!0).then(()=>oe.input=x.listen(K,Q)),oe.event}}}e.getNextTickChannel=z;class J{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const K of U.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await C.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=J;var Y;(function(x){function U(ae,V){const j=ae,M=V&&V.disableMarshalling,$=new Map;for(const H in j)Q(H)&&$.set(H,C.Event.buffer(j[H],!0));return new class{listen(H,ee,G){const Z=$.get(ee);if(Z)return Z;if(oe(ee)){const te=j[ee];if(typeof te=="function")return te.call(j,G)}throw new Error(`Event not found: ${ee}`)}call(H,ee,G){const Z=j[ee];if(typeof Z=="function"){if(!M&&Array.isArray(G))for(let te=0;te<G.length;te++)G[te]=(0,I.revive)(G[te]);return Z.apply(j,G)}throw new Error(`Method not found: ${ee}`)}}}x.fromService=U;function K(ae,V){const j=V&&V.disableMarshalling;return new Proxy({},{get(M,$){if(typeof $=="string")return V?.properties?.has($)?V.properties.get($):oe($)?function(H){return ae.listen($,H)}:Q($)?ae.listen($):async function(...H){let ee;V&&!(0,m.isUndefinedOrNull)(V.context)?ee=[V.context,...H]:ee=H;const G=await ae.call($,ee);return j?G:(0,I.revive)(G)};throw new Error(`Property not found: ${String($)}`)}})}x.toService=K;function Q(ae){return ae[0]==="o"&&ae[1]==="n"&&S.isUpperAsciiLetter(ae.charCodeAt(2))}function oe(ae){return/^onDynamic/.test(ae)&&S.isUpperAsciiLetter(ae.charCodeAt(9))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const U=x.toString();if(U!=="[object Object]")return U}return x}function B(x){return Array.isArray(x)?x.map(N):N(x)}function ie(x,U,K,Q,oe,ae,V){V=B(V);const j=W[oe],M=j[Q%j.length];let $=[`%c[${x}]%c[${String(U).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(ae)?($=$.concat(V),$.push(")")):$.push(V),console.log.apply(console,$)}class q{constructor(U,K){this.d=U,this.f=K,this.a=0,this.b=0}logOutgoing(U,K,Q,oe,ae){this.b+=U,ie(this.d,this.b,U,K,Q,oe,ae)}logIncoming(U,K,Q,oe,ae){this.a+=U,ie(this.f,this.a,U,K,Q,oe,ae)}}e.IPCLogger=q}),define(se[151],re([0,1,17,3,37]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(C){this.a=C,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",v=>A.VSBuffer.wrap(v.data)),C.start()}send(C){this.a.postMessage(C.buffer)}disconnect(){this.a.close()}}e.Protocol=D;class k extends l.IPCClient{constructor(C,v){const I=new D(C);super(I,v),this.b=I}dispose(){this.b.disconnect()}}e.Client=k}),define(se[96],re([0,1,6,17,3,2,37]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(E){E.enableDiagnostics=!1,E.records=[];const L=new WeakMap;let T=0;function F(J,Y){if(!L.has(J)){const W=String(++T);L.set(J,W)}return L.get(J)}function z(J,Y,W,N){if(!E.enableDiagnostics)return;const B=F(J,Y);if(N instanceof O.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const ie=O.VSBuffer.alloc(N.byteLength);ie.set(N),E.records.push({timestamp:Date.now(),id:B,label:Y,type:W,buff:ie})}else E.records.push({timestamp:Date.now(),id:B,label:Y,type:W,data:N})}E.traceSocketEvent=z})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function S(){return I||(I=O.VSBuffer.alloc(0)),I}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(L){this.a.push(L),this.b+=L.byteLength}read(L){return this.c(L,!0)}peek(L){return this.c(L,!1)}c(L,T){if(L===0)return S();if(L>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===L){const Y=this.a[0];return T&&(this.a.shift(),this.b-=L),Y}if(this.a[0].byteLength>L){const Y=this.a[0].slice(0,L);return T&&(this.a[0]=this.a[0].slice(L),this.b-=L),Y}const F=O.VSBuffer.alloc(L);let z=0,J=0;for(;L>0;){const Y=this.a[J];if(Y.byteLength>L){const W=Y.slice(0,L);F.set(W,z),z+=L,T&&(this.a[J]=Y.slice(L),this.b-=L),L-=L}else F.set(Y,z),z+=Y.byteLength,T?(this.a.shift(),this.b-=Y.byteLength):J++,L-=Y.byteLength}return F}}e.ChunkStream=m;var f;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function g(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(L,T,F,z){this.type=L,this.id=T,this.ack=F,this.data=z,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends D.Disposable{constructor(L){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=L,this.b=!1,this.c=new m,this.B(this.a.onData(T=>this.acceptChunk(T))),this.lastReadTime=Date.now()}acceptChunk(L){if(!(!L||L.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(L);this.c.byteLength>=this.g.readLen;){const T=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=T.readUInt32BE(9),this.g.messageType=T.readUInt8(0),this.g.id=T.readUInt32BE(1),this.g.ack=T.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,z=this.g.id,J=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",T),this.f.fire(new h(F,z,J,T)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(L){this.k=null,this.a=!1,this.b=!1,this.c=L,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(L){if(this.a)return;L.writtenTime=Date.now(),this.lastWriteTime=Date.now();const T=O.VSBuffer.alloc(13);T.writeUInt8(L.type,0),T.writeUInt32BE(L.id,1),T.writeUInt32BE(L.ack,5),T.writeUInt32BE(L.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(L.type),id:L.id,ack:L.ack,messageSize:L.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",L.data),this.j(T,L.data)}g(L,T){const F=this.f===0;return this.d.push(L,T),this.f+=L.byteLength+T.byteLength,F}h(){const L=O.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,L}j(L,T){this.g(L,T)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const L=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:L.byteLength}),this.c.write(L)}}class y extends D.Disposable{constructor(L){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=L,this.b=this.B(new d(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(T=>{T.type===1&&this.f.fire(T.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(L){this.b.write(new h(1,0,0,L))}}e.Protocol=y;class b extends k.IPCClient{static fromSocket(L,T){return new b(new y(L),T)}get onDidDispose(){return this.b.onDidDispose}constructor(L,T,F=null){super(L,T,F),this.b=L}dispose(){super.dispose();const L=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),L.end()}}e.Client=b;class P{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(L){this.b?this.d.length>0?this.d.push(L):this.a.fire(L):this.d.push(L)}flushBuffer(){this.d=[]}}e.BufferedEmitter=P;class t{constructor(L){this.data=L,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let L=0,T=this.a;for(;T;)T=T.next,L++;return L}peek(){return this.a?this.a.data:null}toArray(){const L=[];let T=0,F=this.a;for(;F;)L[T++]=F.data,F=F.next;return L}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(L){const T=new t(L);if(!this.a){this.a=T,this.b=T;return}this.b.next=T,this.b=T}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const L=Date.now();for(let T=0;T<i.a;T++)this.c[T]=L-1e3*T;setInterval(()=>{for(let T=i.a;T>=1;T--)this.c[T]=this.c[T-1];this.c[0]=Date.now()},1e3)}d(){const L=Date.now(),T=(1+i.a)*1e3;let F=0;for(let z=0;z<i.a;z++)L-this.c[z]<=T&&F++;return 1-F/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class o{constructor(L){this.connectionHealth=L}}e.ConnectionHealthChangedEvent=o;class s{constructor(L,T){this.roundTripTime=L,this.recentHighRoundTripCount=T}}e.HighRoundTripTimeEvent=s;class c{get unacknowledgedCount(){return this.c-this.d}constructor(L){this.x=new P,this.onControlMessage=this.x.event,this.y=new P,this.onMessage=this.y.event,this.z=new P,this.onDidDispose=this.z.event,this.A=new P,this.onSocketClose=this.A.event,this.B=new P,this.onSocketTimeout=this.B.event,this.C=new P,this.onHighRoundTripTime=this.C.event,this.D=new P,this.onDidChangeConnectionHealth=this.D.event,this.u=L.loadEstimator??i.getInstance(),this.v=L.measureRoundTripTime??!1,this.w=L.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new D.DisposableStore,this.o=L.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(T=>this.E(T))),this.t.add(this.o.onClose(T=>this.A.fire(T))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(T=>this.J(T))),this.t.add(this.r.onHighRoundTripTime(T=>this.C.fire(T))),this.t.add(this.r.onDidChangeConnectionHealth(T=>this.D.fire(T))),this.v&&this.r.start(),L.initialChunk&&this.q.acceptChunk(L.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const L=new h(5,0,0,S());this.p.write(L),this.p.flush()}sendPause(){const L=new h(7,0,0,S());this.p.write(L)}sendResume(){const L=new h(8,0,0,S());this.p.write(L)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(L,T){this.a=!0,this.t.dispose(),this.t=new D.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=L,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(T)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const L=new h(3,0,this.h,S());this.p.write(L);const T=this.b.toArray();for(let F=0,z=T.length;F<z;F++)this.p.write(T[F]);this.G()}acceptDisconnect(){this.z.fire()}E(L){if(L.ack>this.d){this.d=L.ack;do{const T=this.b.peek();if(T&&T.id<=L.ack)this.b.pop();else break}while(!0)}switch(L.type){case 0:break;case 1:{if(L.id>this.g)if(L.id!==this.g+1){const T=Date.now();T-this.m>1e4&&(this.m=T,this.p.write(new h(6,0,0,S())))}else this.g=L.id,this.j=Date.now(),this.F(),this.y.fire(L.data);break}case 2:{this.x.fire(L.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const T=this.b.toArray();for(let F=0,z=T.length;F<z;F++)this.p.write(T[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(L.data);break}case 11:{this.r.handleResponse(L.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(L){const T=++this.c;this.h=this.g;const F=new h(1,T,this.h,L);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(L){const T=new h(2,0,0,L);this.p.write(T)}F(){if(this.g<=this.h||this.k)return;const L=Date.now()-this.j;if(L>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-L+5)}G(){if(this.c<=this.d||this.f||this.a)return;const L=this.b.peek(),T=Date.now()-L.writtenTime,F=Date.now()-this.q.lastReadTime,z=Date.now()-this.n;if(T>=2e4&&F>=2e4&&z>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:T,timeSinceLastReceivedSomeData:F});return}const J=Math.max(2e4-T,2e4-F,2e4-z,500);this.f=setTimeout(()=>{this.f=null,this.G()},J)}H(){if(this.g<=this.h)return;this.h=this.g;const L=new h(3,0,this.h,S());this.p.write(L)}I(){this.h=this.g;const L=new h(9,0,this.h,S());this.p.write(L)}J(L){this.h=this.g;const T=new h(10,0,this.h,L);this.p.write(T)}K(L){this.h=this.g;const T=new h(11,0,this.h,L);this.p.write(T)}}e.PersistentProtocol=c;class w extends D.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new A.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},L=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const L=++this.h,T=O.VSBuffer.alloc(4);T.writeUInt32BE(L,0),this.a.fire(T)},6e4)}handleResponse(L){if(L.byteLength!==4)return;const T=L.readUInt32BE(0);if(this.g<=0||T!==this.h)return;const F=Date.now()-this.g,z=this.k++;this.j[z%this.j.length]=F;const J=this.l,Y=this.j.filter(W=>W>=1e3).length;this.l=Y>=3?1:0,F>1e3&&this.b.fire(new s(F,Y)),J!==this.l&&this.c.fire(this.l)}}}),define(se[152],re([0,1,153,3,37,151]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends l.IPCServer{static b(){const C=O.Event.fromNodeEventEmitter(A.ipcRenderer,"vscode:createMessageChannel",(v,I)=>I);return O.Event.map(C,v=>{const{port1:I,port2:S}=new MessageChannel,f={protocol:new D.Protocol(I),onDidClientDisconnect:O.Event.fromDOMEventEmitter(I,"close")};return A.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[S]),f})}constructor(){super(k.b())}}e.Server=k}),define(se[66],re([0,1,50,6,17,23,146,7,3,2,32,95,88,37]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends f.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",d=>l.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=g;class p{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new C.Emitter,this.onDidProcessExit=this.h.event;const y=d&&d.timeout?d.timeout:6e4;this.b=new O.Delayer(y),this.d=null,this.f=null}getChannel(u){const d=this;return{call(y,b,P){return d.k(u,y,b,P)},listen(y,b){return d.l(u,y,b)}}}k(u,d,y,b=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const P=this.n(u),t=(0,O.createCancelablePromise)(n=>P.call(d,y,n)),a=b.onCancellationRequested(()=>t.cancel()),i=(0,v.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,d,y){if(!this.b)return C.Event.None;this.b.cancel();let b;const P=new C.Emitter({onWillAddFirstListener:()=>{b=this.n(u).listen(d,y)(P.fire,P),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return P.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(d.env),this.d=(0,A.fork)(this.i,u,d);const y=new C.Emitter;C.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.j.serverName}`);return}y.fire(l.VSBuffer.wrap(Buffer.from(r,"base64")))});const P=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&P.send(r.buffer.toString("base64")),a=y.event,i={send:t,onMessage:a};this.f=new f.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(s=>(0,v.dispose)(s)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(se[154],re([0,1,87,17,37,3,12,18]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class C{constructor(m){this.a=m,this.onMessage=D.Event.fromNodeEventEmitter(this.a,"message",f=>O.VSBuffer.wrap(f.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class v extends l.IPCServer{static b(){(0,k.assertType)((0,A.isUtilityProcess)(process),"Electron Utility Process");const m=new D.Emitter;return process.parentPort.on("message",f=>{const g=(0,R.firstOrDefault)(f.ports);g&&m.fire(g)}),D.Event.map(m.event,f=>({protocol:new C(f),onDidClientDisconnect:D.Event.fromNodeEventEmitter(f,"close")}))}constructor(){super(v.b())}}e.Server=v;function I(S,m,f){const g=p=>{p.data===m&&(S.removeListener("message",g),f())};S.on("message",g)}e.once=I}),define(se[155],re([0,1,17,7,3,2,13,4,31,37,96]),function(_,e,A,O,l,D,k,R,C,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(s,c){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,c)}constructor(s,c=""){this.f=!0,this.debugLabel=c,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,O.onUnexpectedError)(w)}},this.socket.on("error",this.a),this.b=w=>{this.traceSocketEvent("close",{hadError:w}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const c=w=>{this.traceSocketEvent("read",w),s(A.VSBuffer.wrap(w))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(s){const c=w=>{s({type:0,hadError:w,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(s){const c=()=>{s()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,O.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,O.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var f;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var g;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(g||(g={}));class p extends D.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,c){this.socket.traceSocketEvent(s,c)}constructor(s,c,w,E){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:w?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new h(this,c,w,E,this.f,(L,T)=>this.k(L,T))),this.B(this.a.onError(L=>{console.error(L),(0,O.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new I.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,c){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let w=2;s.byteLength<126?w+=0:s.byteLength<2**16?w+=2:w+=8;const E=A.VSBuffer.alloc(w);if(c?E.writeUInt8(194,0):E.writeUInt8(130,0),s.byteLength<126)E.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){E.writeUInt8(126,1);let L=1;E.writeUInt8(s.byteLength>>>8&255,++L),E.writeUInt8(s.byteLength>>>0&255,++L)}else{E.writeUInt8(127,1);let L=1;E.writeUInt8(0,++L),E.writeUInt8(0,++L),E.writeUInt8(0,++L),E.writeUInt8(0,++L),E.writeUInt8(s.byteLength>>>24&255,++L),E.writeUInt8(s.byteLength>>>16&255,++L),E.writeUInt8(s.byteLength>>>8&255,++L),E.writeUInt8(s.byteLength>>>0&255,++L)}this.socket.write(A.VSBuffer.concat([E,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const c=this.b.peek(this.j.readLen),w=c.readUInt8(0),E=(w&128)>>>7,L=(w&64)>>>6,T=c.readUInt8(1),F=(T&128)>>>7,z=T&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const c=this.b.read(this.j.readLen),w=c.readUInt8(1),E=(w&128)>>>7;let L=w&127,T=1;L===126?L=c.readUInt8(++T)*2**8+c.readUInt8(++T):L===127&&(L=c.readUInt8(++T)*0+c.readUInt8(++T)*0+c.readUInt8(++T)*0+c.readUInt8(++T)*0+c.readUInt8(++T)*2**24+c.readUInt8(++T)*2**16+c.readUInt8(++T)*2**8+c.readUInt8(++T));let F=0;E&&(F=c.readUInt8(++T)*2**24+c.readUInt8(++T)*2**16+c.readUInt8(++T)*2**8+c.readUInt8(++T)),this.j.state=3,this.j.readLen=L,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const c=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),y(c,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(c,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends D.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(s,c,w,E,L,T){super(),this.k=s,this.l=L,this.m=T,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,c?(this.b=this.B(new u(this.k,E,w,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const c=await this.r(this.f,s);this.m(c,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,c){return new Promise((w,E)=>{s.write(c),s.flush(L=>w(L))})}acceptFrame(s,c,w){this.h.push({data:s,isCompressed:c,isLastFrameOfMessage:w}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const c=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(c)}else this.l.fire(s.data)}this.s=!1}}u(s,c,w){return new Promise((E,L)=>{s.write(c),w&&s.write(A.VSBuffer.fromByteArray([0,0,255,255])),s.flush(T=>E(T))})}}class u extends D.Disposable{get recordedInflateBytes(){return this.j?A.VSBuffer.concat(this.f):A.VSBuffer.alloc(0)}constructor(s,c,w,E){super(),this.h=s,this.j=c,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(E),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(A.VSBuffer.wrap(L))}),w&&(this.h.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this.b.write(w.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const c=A.VSBuffer.concat(this.g);this.g.length=0,s(c)})}}class d extends D.Disposable{constructor(s,c){super(),this.g=s,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",w=>{this.g.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.g.traceSocketEvent("zlibDeflateData",w),this.f.push(A.VSBuffer.wrap(w))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let c=A.VSBuffer.concat(this.f);this.f.length=0,c=c.slice(0,c.byteLength-4),s(c)})}}function y(o,s){if(s===0)return;const c=o.byteLength>>>2;for(let z=0;z<c;z++){const J=o.readUInt32BE(z*4);o.writeUInt32BE(J^s,z*4)}const w=c*4,E=o.byteLength-w,L=s>>>24&255,T=s>>>16&255,F=s>>>8&255;E>=1&&o.writeUInt8(o.readUInt8(w)^L,w),E>=2&&o.writeUInt8(o.readUInt8(w+1)^T,w+1),E>=3&&o.writeUInt8(o.readUInt8(w+2)^F,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const b={[2]:107,[1]:103};function P(){const o=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):s=(0,k.join)(S().os.tmpdir(),`vscode-ipc-${o}.sock`),a(s),s}e.createRandomIPCHandle=P;function t(o,s,c){const w=S().crypto.createHash("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${c}-${s}-sock`;const E=c.substr(0,4),L=s.substr(0,6),T=w.substr(0,8);let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${T}-${E}-${L}.sock`):F=(0,k.join)(o,`${E}-${L}.sock`),a(F),F}e.createStaticIPCHandle=t;function a(o){const s=b[R.platform];typeof s=="number"&&o.length>=s&&console.warn(`WARNING: IPC handle "${o}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends v.IPCServer{static b(s){const c=l.Event.fromNodeEventEmitter(s,"connection");return l.Event.map(c,w=>({protocol:new I.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(w,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(o){return new Promise((s,c)=>{const w=S().net.createServer();w.on("error",c),w.listen(o,()=>{w.removeListener("error",c),s(new i(w))})})}e.serve=n;function r(o,s){return new Promise((c,w)=>{const E=S().net.createConnection(o,()=>{E.removeListener("error",w),c(I.Client.fromSocket(new m(E,`ipc-client${s}`),s))});E.once("error",w)})}e.connect=r}),define(se[67],re([0,1,6,3,2,12]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k=e.StorageHint||(e.StorageHint={}));function R(S){const m=S;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class v extends l.Disposable{constructor(m,f=Object.create(null)){super(),this.m=m,this.n=f,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=C.None,this.f=new Map,this.g=new A.ThrottledDelayer(v.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((f,g)=>this.s(g,f)),m.deleted?.forEach(f=>this.s(f,void 0))}s(m,f){if(this.c===C.Closed)return;let g=!1;(0,D.isUndefinedOrNull)(f)?g=this.f.delete(m):this.f.get(m)!==f&&(this.f.set(m,f),g=!0),g&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===C.None&&(this.c=C.Initialized,this.n.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,f){const g=this.f.get(m);return(0,D.isUndefinedOrNull)(g)?f:g}getBoolean(m,f){const g=this.get(m);return(0,D.isUndefinedOrNull)(g)?f:g==="true"}getNumber(m,f){const g=this.get(m);return(0,D.isUndefinedOrNull)(g)?f:parseInt(g,10)}async set(m,f){if(this.c===C.Closed)return;if((0,D.isUndefinedOrNull)(f))return this.delete(m);const g=String(f);if(this.f.get(m)!==g)return this.f.set(m,g),this.j.set(m,g),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===C.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=C.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===k.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}v.a=100,e.Storage=v;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((f,g)=>this.a.set(g,f)),m.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=I}),define(se[156],re([9,8]),function(_,e){return _.create("vs/base/node/zip",e)}),define(se[157],re([9,8]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[158],re([9,8]),function(_,e){return _.create("vs/platform/environment/node/argv",e)}),define(se[159],re([9,8]),function(_,e){return _.create("vs/platform/environment/node/argvHelper",e)}),define(se[160],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[161],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[162],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[163],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[164],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(se[165],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[166],re([9,8]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[167],re([9,8]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[168],re([9,8]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(se[169],re([9,8]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(se[170],re([9,8]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(se[171],re([9,8]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[172],re([9,8]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[173],re([9,8]),function(_,e){return _.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(se[174],re([9,8]),function(_,e){return _.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(se[175],re([9,8]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(se[176],re([9,8]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(se[177],re([9,8]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(se[178],re([9,8]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[179],re([9,8]),function(_,e){return _.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[180],re([9,8]),function(_,e){return _.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[181],re([9,8]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[182],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(se[183],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(se[184],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/settingsSync",e)}),define(se[185],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(se[186],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSync",e)}),define(se[187],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(se[188],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(se[189],re([9,8]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(se[190],re([9,8]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(se[191],re([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(O=e.TokenType||(e.TokenType={}));class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(k){if(k.type!==19)throw(0,A.illegalArgument)(`expected an error token but got ${JSON.stringify(k)}`);switch(k.lexeme){case"=":return`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you mean '||'?`;default:{const R=k.lexeme;return R&&R.length>1&&R.startsWith("'")?`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you forget to close the string?`:R&&R.length>1&&R.endsWith("'")?`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you forget to open the string?`:`Unexpected token '${k.lexeme}' at offset ${k.offset}`}}}static getLexeme(k){switch(k.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return k.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return k.lexeme;case 18:return k.lexeme;case 19:return k.lexeme;case 20:return"EOF";default:throw(0,A.illegalState)(`unhandled token type: ${JSON.stringify(k)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(k){return this.c=k,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(k){return this.r()||this.c.charCodeAt(this.e)!==k?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(k){this.f.push({type:k,offset:this.d})}l(){const k={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(k),this.f.push(k)}n(){this.m.lastIndex=this.d;const k=this.m.exec(this.c);if(k){this.e=this.d+k[0].length;const R=this.c.substring(this.d,this.e),C=l.b.get(R);C?this.k(C):this.f.push({type:17,lexeme:R,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let k=this.e,R=!1,C=!1;for(;;){if(k>=this.c.length){this.e=k,this.l();return}const I=this.c.charCodeAt(k);if(R)R=!1;else if(I===47&&!C){k++;break}else I===91?C=!0:I===92?R=!0:I===93&&(C=!1);k++}for(;k<this.c.length&&l.a.has(this.c.charCodeAt(k));)k++;this.e=k;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}l.a=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0))),l.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=l}),define(se[192],re([0,1,64,62,21,13,36,24,10]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,D.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return C.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=k.env.VSCODE_PORTABLE;return f?C.URI.file((0,D.join)(f,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,D.resolve)(f):(0,D.normalize)((0,D.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?C.URI.file((0,D.resolve)(f)):C.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,D.resolve)(f);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const p=k.env.VSCODE_PORTABLE;return p?(0,D.join)(p,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(g=>/^[^:/?#]+?:\/\//.test(g)?C.URI.parse(g):C.URI.file((0,D.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?C.URI.parse(f):C.URI.file((0,D.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const g of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);p&&p[1]&&p[2]&&f.push([p[1],p[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return C.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=k.env.VSCODE_PORTABLE;return f?C.URI.file((0,D.join)(f,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,g,p){this.a=f,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}ye([O.memoize],v.prototype,"appRoot",null),ye([O.memoize],v.prototype,"userHome",null),ye([O.memoize],v.prototype,"userDataPath",null),ye([O.memoize],v.prototype,"appSettingsHome",null),ye([O.memoize],v.prototype,"tmpDir",null),ye([O.memoize],v.prototype,"cacheHome",null),ye([O.memoize],v.prototype,"stateResource",null),ye([O.memoize],v.prototype,"userRoamingDataHome",null),ye([O.memoize],v.prototype,"userDataSyncHome",null),ye([O.memoize],v.prototype,"userDataSyncLogResource",null),ye([O.memoize],v.prototype,"editSessionsLogResource",null),ye([O.memoize],v.prototype,"sync",null),ye([O.memoize],v.prototype,"machineSettingsResource",null),ye([O.memoize],v.prototype,"workspaceStorageHome",null),ye([O.memoize],v.prototype,"localHistoryHome",null),ye([O.memoize],v.prototype,"keyboardLayoutResource",null),ye([O.memoize],v.prototype,"argvResource",null),ye([O.memoize],v.prototype,"isExtensionDevelopment",null),ye([O.memoize],v.prototype,"untitledWorkspacesHome",null),ye([O.memoize],v.prototype,"installSourcePath",null),ye([O.memoize],v.prototype,"builtinExtensionsPath",null),ye([O.memoize],v.prototype,"extensionsPath",null),ye([O.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ye([O.memoize],v.prototype,"extensionDevelopmentKind",null),ye([O.memoize],v.prototype,"extensionTestsLocationURI",null),ye([O.memoize],v.prototype,"debugExtensionHost",null),ye([O.memoize],v.prototype,"logLevel",null),ye([O.memoize],v.prototype,"extensionLogLevel",null),ye([O.memoize],v.prototype,"serviceMachineIdResource",null),ye([O.memoize],v.prototype,"telemetryLogResource",null),ye([O.memoize],v.prototype,"disableWorkspaceTrust",null),ye([O.memoize],v.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=v;function I(m,f){return S(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function S(m,f,g,p,h,u){const y=Number(f||m)||(p?null:g),b=y?Boolean(!!f):!1;let P;if(u)try{P=JSON.parse(u)}catch{}return{port:y,break:b,debugId:h,env:P}}e.parseDebugParams=S}),define(se[193],re([0,1,296,4,158]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(p,h,u=k){const d=p.find(o=>o.length>0&&o[0]!=="-"),y={},b=["_"],P=[],t={};let a;for(const o in h){const s=h[o];s.type==="subcommand"?o===d&&(a=s):(s.alias&&(y[o]=s.alias),s.type==="string"||s.type==="string[]"?(b.push(o),s.deprecates&&b.push(...s.deprecates)):s.type==="boolean"&&(P.push(o),s.deprecates&&P.push(...s.deprecates)),s.global&&(t[o]=s))}if(a&&d){const o=t;for(const E in a.options)o[E]=a.options[E];const s=p.filter(E=>E!==d),c=u.getSubcommandReporter?u.getSubcommandReporter(d):void 0,w=R(s,o,c);return{[d]:w,_:[]}}const i=A(p,{string:b,boolean:P,alias:y}),n={},r=i;n._=i._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in h){const s=h[o];if(s.type==="subcommand")continue;s.alias&&delete r[s.alias];let c=r[o];if(s.deprecates)for(const w of s.deprecates)r.hasOwnProperty(w)&&(c||(c=r[w],c&&u.onDeprecatedOption(w,s.deprecationMessage||(0,l.localize)(36,null,o))),delete r[w]);if(typeof c<"u"){if(s.type==="string[]"){if(Array.isArray(c)||(c=[c]),!s.allowEmptyValue){const w=c.filter(E=>E.length>0);w.length!==c.length&&(u.onEmptyValue(o),c=w.length>0?w:void 0)}}else s.type==="string"&&(Array.isArray(c)?(c=c.pop(),u.onMultipleValues(o,c)):!c&&!s.allowEmptyValue&&(u.onEmptyValue(o),c=void 0));n[o]=c,s.deprecationMessage&&u.onDeprecatedOption(o,s.deprecationMessage)}delete r[o]}for(const o in r)u.onUnknownOption(o);return n}e.parseArgs=R;function C(p,h){let u="";return h.args&&(Array.isArray(h.args)?u=` <${h.args.join("> <")}>`:u=` <${h.args}>`),h.alias?`-${h.alias} --${p}${u}`:`--${p}${u}`}function v(p,h){const u=[];for(const d in p){const y=p[d],b=C(d,y);u.push([b,y.description])}return I(u,h)}e.formatOptions=v;function I(p,h){const d=p.reduce((P,t)=>Math.max(P,t[0].length),12)+2+1;if(h-d<25)return p.reduce((P,t)=>P.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const y=h-d-1,b=[];for(const P of p){const t=P[0],a=m(P[1],y),i=S(d-t.length-2);b.push("  "+t+i+a[0]);for(let n=1;n<a.length;n++)b.push(S(d)+a[n])}return b}function S(p){return" ".repeat(p)}function m(p,h){const u=[];for(;p.length;){const d=p.length<h?p.length:p.lastIndexOf(" ",h),y=p.slice(0,d).trim();p=p.slice(d),u.push(y)}return u}function f(p,h,u,d,y){const b=process.stdout.isTTY&&process.stdout.columns||80,P=y?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",t=[`${p} ${u}`];t.push(""),t.push(`${(0,l.localize)(38,null)}: ${h} [${(0,l.localize)(39,null)}]${P}`),t.push(""),y?.noPipe!==!0&&(O.isWindows?t.push((0,l.localize)(40,null,h)):t.push((0,l.localize)(41,null,h)),t.push(""));const a={},i=[];for(const n in d){const r=d[n];if(r.type==="subcommand")r.description&&i.push({command:n,description:r.description});else if(r.description&&r.cat){let o=a[r.cat];o||(a[r.cat]=o={}),o[n]=r}}for(const n in a){const r=n,o=a[r];o&&(t.push(D[r]),t.push(...v(o,b)),t.push(""))}return i.length&&(t.push((0,l.localize)(42,null)),t.push(...I(i.map(n=>[n.command,n.description]),b)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function g(p,h){return`${p||(0,l.localize)(43,null)}
${h||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=g}),define(se[194],re([0,1,297,159,193]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function k(m,f){const g=(b,P)=>{console.warn((0,O.localize)(0,null,b,P))},p=b=>{console.warn((0,O.localize)(1,null,b))},h=(b,P)=>{console.warn((0,O.localize)(2,null,b,P))},u=b=>({onUnknownOption:P=>{b!=="tunnel"&&console.warn((0,O.localize)(3,null,P,b))},onMultipleValues:g,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:b!=="tunnel"?u:void 0}),d={onUnknownOption:b=>{console.warn((0,O.localize)(4,null,b))},onMultipleValues:g,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:u},y=(0,l.parseArgs)(m,l.OPTIONS,f?d:void 0);return y.goto&&y._.forEach(b=>A(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,O.localize)(5,null))),y["max-memory"]&&A(parseInt(y["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),y}function R(m){const f=m.findIndex(g=>!/^-/.test(g));if(f>-1)return[...m.slice(0,f),...m.slice(f+1)]}function C(m){let[,...f]=m;process.env.VSCODE_DEV&&(f=R(f)||[]);const g=!S(process.env);return k(f,g)}e.parseMainProcessArgv=C;function v(m){let[,,...f]=m;return process.env.VSCODE_DEV&&(f=R(f)||[]),k(f,!0)}e.parseCLIProcessArgv=v;function I(m,...f){const g=m.indexOf("--");return g===-1?m.push(...f):m.splice(g,0,...f),m}e.addArg=I;function S(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function _(e,A,O){function l(k,R){const C=D(k,R),v=[C];return e.isAbsolute(C)||v.unshift(O),e.resolve(...v)}function D(k,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,R);const I=k["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(S,"AppData","Roaming")}break;case"darwin":v=e.join(A.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,R)}return{getUserDataPath:l}}if(typeof define=="function")define(se[195],re([298,34,36]),function(e,A,O){return _(e,A,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=_(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[97],re([0,1,34,192,195]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class D extends O.AbstractNativeEnvironmentService{constructor(v,I){super(v,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,l.getUserDataPath)(v,I.nameShort)},I)}}e.NativeEnvironmentService=D;function k(C,v){return(0,O.parseDebugParams)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,v,C.extensionEnvironment)}e.parsePtyHostDebugPort=k;function R(C,v){return(0,O.parseDebugParams)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,v,C.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(se[196],re([0,1,10]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const O=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,D=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(h){const u=h.match(k);return u?u[1]:null}function I(h){if(h.indexOf("://")===-1){const u=h.match(O);return u?v(u[2]):null}try{const u=A.URI.parse(h);if(u.authority)return v(u.authority)}catch{}return null}function S(h,u){const d=new Set;let y;for(;y=R.exec(h);){const P=I(y[1]);P&&d.add(P)}const b=new Set(u);return Array.from(d).map(P=>b.has(P)?P:P.replace(C,"a"))}e.getDomainsOfRemotes=S;function m(h){const u=h.match(D);return u?u[2]:null}function f(h,u,d){return h&&u?(d&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${h}${u}`:`${h}/${u}`):null}function g(h,u){if(h.indexOf("://")===-1){const d=h.match(l);if(d)return f(d[2],d[3],u)}try{const d=A.URI.parse(h);if(d.authority)return f(m(d.authority),d.path,u)}catch{}return null}function p(h,u=!1){const d=[];let y;for(;y=R.exec(h);){const b=g(y[1],u);b&&d.push(b)}return d}e.getRemotes=p}),define(se[197],re([0,1,12,162]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(k,R,C){try{D(k,R,C)}catch(v){console.error(v?.message??v)}return k}e.localizeManifest=l;function D(k,R,C){const v=(I,S,m)=>{const f=I[S];if((0,A.isString)(f)){const g=f,p=g.length;if(p>1&&g[0]==="%"&&g[p-1]==="%"){const h=g.substr(1,p-2);let u=R[h];u===void 0&&C&&(u=C[h]);const d=typeof u=="string"?u:u?.message,y=C?.[h],b=typeof y=="string"?y:y?.message;if(!d){b||console.warn(`[${k.name}]: ${(0,O.localize)(0,null,h)}`);return}if(m&&(S==="title"||S==="category")&&b&&b!==d){const P={value:d,original:b};I[S]=P}else I[S]=d}}else if((0,A.isObject)(f))for(const g in f)f.hasOwnProperty(g)&&(g==="commands"?v(f,g,!0):v(f,g,m));else if(Array.isArray(f))for(let g=0;g<f.length;g++)v(f,g,m)};for(const I in k)k.hasOwnProperty(I)&&v(k,I)}}),define(se[198],re([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(D,k){this.a.set(D,k)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const k in D.contributes){const R=this.a.get(k);if(!R)continue;const C=D.contributes[k],v=Array.isArray(C)?C:[C];try{R(v,D.activationEvents)}catch(I){(0,A.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(se[199],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class A{constructor(D){this.a=D}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(D,k,R,C){return this.a.call("promptImportantExtensionsInstallNotification",[D,k,R,C])}promptWorkspaceRecommendations(D){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=A;class O{constructor(D){this.a=D}listen(D,k){throw new Error(`Event not found: ${k}`)}call(D,k,R){switch(k){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(se[68],re([0,1,24,90,167,54]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||k.test(u)}e.isValidVersionStr=C;function v(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(k);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=v;function I(u){if(!u)return null;const d=u.majorBase,y=u.majorMustEqual,b=u.minorBase;let P=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(d===0||(P=!1),a=!1);let i=0;if(u.preRelease){const n=R.exec(u.preRelease);if(n){const[,r,o,s]=n;i=Date.UTC(Number(r),Number(o)-1,Number(s))}}return{majorBase:d,majorMustEqual:y,minorBase:b,minorMustEqual:P,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function S(u,d,y){let b;typeof u=="string"?b=I(v(u)):b=u;let P;d instanceof Date?P=d.getTime():typeof d=="string"&&(P=new Date(d).getTime());let t;if(typeof y=="string"?t=I(v(y)):t=y,!b||!t)return!1;const a=b.majorBase,i=b.minorBase,n=b.patchBase;let r=t.majorBase,o=t.minorBase,s=t.patchBase;const c=t.notBefore;let w=t.majorMustEqual,E=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:i>o?!0:i<o||P&&P<c?!1:n>=s:(a===1&&r===0&&(!w||!E||!L)&&(r=1,o=0,s=0,w=!0,E=!1,L=!1),a<r?!1:a>r?!w:i<o?!1:i>o?!E:n<s?!1:n>s?!L:!(P&&P<c))}e.isValidVersion=S;function m(u,d,y,b,P){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([O.default.Error,l.localize(0,null)]),t;if(typeof b.name!="string")return t.push([O.default.Error,l.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([O.default.Error,l.localize(2,null,"version")]),t;if(!b.engines)return t.push([O.default.Error,l.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([O.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!h(b.extensionDependencies))return t.push([O.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!h(b.activationEvents))return t.push([O.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([O.default.Error,l.localize(7,null,"activationEvents","main")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([O.default.Warning,l.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([O.default.Error,l.localize(9,null,"main")]),t;{const n=(0,A.joinPath)(y,b.main);(0,A.isEqualOrParent)(n,y)||t.push([O.default.Warning,l.localize(10,null,n.path,y.path)])}if(typeof b.activationEvents>"u")return t.push([O.default.Error,l.localize(11,null,"activationEvents","main")]),t}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([O.default.Error,l.localize(12,null,"browser")]),t;{const n=(0,A.joinPath)(y,b.browser);(0,A.isEqualOrParent)(n,y)||t.push([O.default.Warning,l.localize(13,null,n.path,y.path)])}if(typeof b.activationEvents>"u")return t.push([O.default.Error,l.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(b.version))return t.push([O.default.Error,l.localize(15,null)]),t;const a=[];if(!f(u,d,b,P,a))for(const n of a)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=m;function f(u,d,y,b,P){return b||typeof y.main>"u"&&typeof y.browser>"u"?!0:p(u,d,y.engines.vscode,P)}e.isValidExtensionVersion=f;function g(u,d,y){return u==="*"||p(d,y,u)}e.isEngineValid=g;function p(u,d,y,b=[]){const P=I(v(y));if(!P)return b.push(l.localize(16,null,y)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return b.push(l.localize(17,null,y)),!1}else if(!P.majorMustEqual)return b.push(l.localize(18,null,y)),!1;return S(u,d,P)?!0:(b.push(l.localize(19,null,u,y)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let d=0,y=u.length;d<y;d++)if(typeof u[d]!="string")return!1;return!0}}),define(se[44],re([0,1,17,31]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(D,k,R){let C=R&&R.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const I=(await k.readFile(D.serviceMachineIdResource)).value.toString();C=(0,O.isUUID)(I)?I:null}catch{C=null}if(!C){C=(0,O.generateUuid)();try{await k.writeFile(D.serviceMachineIdResource,A.VSBuffer.fromString(C))}catch{}}return R?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=l}),define(se[55],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class A{constructor(l,D=[],k=!1){this.ctor=l,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=A}),define(se[69],re([0,1,55]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var l;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function D(R,C,v){C instanceof A.SyncDescriptor||(C=new A.SyncDescriptor(C,[],Boolean(v))),O.push([R,C])}e.registerSingleton=D;function k(){return O}e.getSingletonServiceDescriptors=k}),define(se[200],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class A{constructor(D,k){this.key=D,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=A;class O{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const k of this.a.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const R=this.lookupOrInsertNode(D),C=this.lookupOrInsertNode(k);R.outgoing.set(C.key,C),C.incoming.set(R.key,R)}removeNode(D){const k=this.b(D);this.a.delete(k);for(const R of this.a.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(D){const k=this.b(D);let R=this.a.get(k);return R||(R=new A(k,D),this.a.set(k,R)),R}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[k,R]of this.a)D.push(`${k}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,k]of this.a){const R=new Set([D]),C=this.c(k,R);if(C)return C}}c(D,k){for(const[R,C]of D.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const v=this.c(C,k);if(v)return v;k.delete(R)}}}e.Graph=O}),define(se[5],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var A;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=R})(A=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function O(k,R,C){R[A.DI_TARGET]===R?R[A.DI_DEPENDENCIES].push({id:k,index:C}):(R[A.DI_DEPENDENCIES]=[{id:k,index:C}],R[A.DI_TARGET]=R)}function l(k){if(A.serviceIds.has(k))return A.serviceIds.get(k);const R=function(C,v,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(R,C,I)};return R.toString=()=>k,A.serviceIds.set(k,R),R}e.createDecorator=l;function D(k){return k}e.refineServiceDecorator=D}),define(se[201],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,A.createDecorator)("checksumService")}),define(se[16],re([0,1,12,10,5]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationOverrides=D;function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=k;var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function v(h,u){const d=Object.create(null);for(const y in h)I(d,y,h[y],u);return d}e.toValuesTree=v;function I(h,u,d,y){const b=u.split("."),P=b.pop();let t=h;for(let a=0;a<b.length;a++){const i=b[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${u} as ${b.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[P]=d}catch{y(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=I;function S(h,u){const d=u.split(".");m(h,d)}e.removeFromValueTree=S;function m(h,u){const d=u.shift();if(u.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const y=h[d];typeof y=="object"&&!Array.isArray(y)&&(m(y,u),Object.keys(y).length===0&&delete h[d])}}function f(h,u,d){function y(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const b=u.split("."),P=y(h,b);return typeof P>"u"?d:P}e.getConfigurationValue=f;function g(h,u,d){Object.keys(u).forEach(y=>{y!=="__proto__"&&(y in h?A.isObject(h[y])&&A.isObject(u[y])?g(h[y],u[y],d):d&&(h[y]=u[y]):h[y]=u[y])})}e.merge=g;function p(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(se[202],re([0,1,4,26,191,5]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",A.isMacintosh),k.set("isLinux",A.isLinux),k.set("isWindows",A.isWindows),k.set("isWeb",A.isWeb),k.set("isMacNative",A.isMacintosh&&!A.isWeb),k.set("isEdge",A.isEdge),k.set("isFirefox",A.isFirefox),k.set("isChrome",A.isChrome),k.set("isSafari",A.isSafari);const R=Object.prototype.hasOwnProperty;var C;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return g.INSTANCE}static true(){return p.INSTANCE}static has(N){return h.create(N)}static equals(N,B){return u.create(N,B)}static notEquals(N,B){return b.create(N,B)}static regex(N,B){return o.create(N,B)}static in(N,B){return d.create(N,B)}static notIn(N,B){return y.create(N,B)}static not(N){return P.create(N)}static and(...N){return w.create(N,null,!0)}static or(...N){return E.create(N,null,!0)}static greater(N,B){return a.create(N,B)}static greaterEquals(N,B){return i.create(N,B)}static smaller(N,B){return n.create(N,B)}static smallerEquals(N,B){return r.create(N,B)}static deserializeOrErrorNew(N){if(!N)return{type:"error",lexingErrors:[],parsingErrors:[]};const B=new S,ie=B.parse(N);return ie===void 0?{type:"error",lexingErrors:B.lexingErrors.map(q=>l.Scanner.reportError(q)),parsingErrors:B.parsingErrors}:{type:"ok",expr:ie}}static deserialize(N){if(!!N)return this.c(N)}static c(N){const B=N.split("||");return E.create(B.map(ie=>this.d(ie)),null,!0)}static d(N){const B=N.split("&&");return w.create(B.map(ie=>this.f(ie)),null,!0)}static f(N){if(N=N.trim(),N.indexOf("!=")>=0){const B=N.split("!=");return b.create(B[0].trim(),this.g(B[1]))}if(N.indexOf("==")>=0){const B=N.split("==");return u.create(B[0].trim(),this.g(B[1]))}if(N.indexOf("=~")>=0){const B=N.split("=~");return o.create(B[0].trim(),this.h(B[1]))}if(N.indexOf(" not in ")>=0){const B=N.split(" not in ");return y.create(B[0].trim(),this.g(B[1]))}if(N.indexOf(" in ")>=0){const B=N.split(" in ");return d.create(B[0].trim(),this.g(B[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const B=N.split(">=");return i.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const B=N.split(">");return a.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const B=N.split("<=");return r.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const B=N.split("<");return n.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(N)?P.create(N.substr(1).trim()):h.create(N)}static g(N){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const B=/^'([^']*)'$/.exec(N);return B?B[1].trim():N}static h(N){if((0,O.isFalsyOrWhitespace)(N))return console.warn("missing regexp-value for =~-expression"),null;const B=N.indexOf("/"),ie=N.lastIndexOf("/");if(B===ie||B<0)return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null;const q=N.slice(B+1,ie),x=N[ie+1]==="i"?"i":"";try{return new RegExp(q,x)}catch(U){return console.warn(`bad regexp-value '${N}', parse error: ${U}`),null}}}e.ContextKeyExpr=v;class I extends Error{}class S{constructor(){this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(N){if(N===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(N).scan(),this.f=0,this.g=[];try{const B=this.h();if(!this.D())throw this.z(this.C());return B}catch(B){if(!(B instanceof I)){const ie=this.C();this.g.push(`Unexpected error: ${B} for token ${l.Scanner.getLexeme(ie)} at offset ${ie.offset}.`)}return}}h(){return this.k()}k(){const N=[this.l()];for(;this.v(16);){const B=this.l();N.push(B)}return N.length===1?N[0]:v.or(...N)}l(){const N=[this.o()];for(;this.v(15);){const B=this.o();N.push(B)}return N.length===1?N[0]:v.and(...N)}o(){if(this.v(2)){const N=this.C();switch(N.type){case 17:return this.w(),v.not(N.lexeme);case 11:return this.w(),v.false();case 12:return this.w(),v.true();default:throw this.y("KEY, 'true', or 'false'",N)}}return this.s()}s(){const N=this.C();switch(N.type){case 11:return this.w(),v.true();case 12:return this.w(),v.false();case 0:{this.w();const B=this.h();return this.x(1,"')'"),B}case 17:{const B=N.lexeme;if(this.w(),this.v(9)){const q=this.C();switch(q.type){case 10:case 19:{const x=[q.lexeme];this.w();let U=this.C(),K=0;for(let j=0;j<q.lexeme.length;j++)q.lexeme.charCodeAt(j)===40?K++:q.lexeme.charCodeAt(j)===41&&K--;for(;!this.D()&&U.type!==15&&U.type!==16;){switch(U.type){case 0:K++;break;case 1:K--;break;case 10:case 18:for(let j=0;j<U.lexeme.length;j++)U.lexeme.charCodeAt(j)===40?K++:q.lexeme.charCodeAt(j)===41&&K--}if(K<0)break;x.push(l.Scanner.getLexeme(U)),this.w(),U=this.C()}const Q=x.join(""),oe=Q.lastIndexOf("/"),ae=oe===Q.length-1?void 0:Q.substring(oe+1),V=new RegExp(Q.substring(1,oe),ae);return v.regex(B,V)}case 18:{const x=q.lexeme;this.w();let U=null;if((0,O.isFalsyOrWhitespace)(x))console.warn("missing regexp-value for =~-expression");else{const K=x.indexOf("/"),Q=x.lastIndexOf("/");if(K===Q||K<0)console.warn(`bad regexp-value '${x}', missing /-enclosure`);else{const oe=x.slice(K+1,Q),ae=x[Q+1]==="i"?"i":"";try{U=new RegExp(oe,ae)}catch(V){console.warn(`bad regexp-value '${x}', parse error: ${V}`)}}}return o.create(B,U)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const q=this.t();return v.notIn(B,q)}switch(this.C().type){case 3:{this.w();const q=this.t();switch(q){case"true":return v.has(B);case"false":return v.not(B);default:return v.equals(B,q)}}case 4:{this.w();const q=this.t();switch(q){case"true":return v.not(B);case"false":return v.has(B);default:return v.notEquals(B,q)}}case 5:return this.w(),n.create(B,this.t());case 6:return this.w(),r.create(B,this.t());case 7:return this.w(),a.create(B,this.t());case 8:return this.w(),i.create(B,this.t());case 13:return this.w(),v.in(B,this.t());default:return v.has(B)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const N=this.C();switch(N.type){case 17:case 18:return this.w(),N.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(N){return this.B(N)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(N,B){if(this.B(N))return this.w();throw this.y(B,this.C())}y(N,B){return this.A(`Expected ${N} but got '${l.Scanner.getLexeme(B)}' at offset ${B.offset}.`)}z(N){return this.A(`Unexpected '${l.Scanner.getLexeme(N)}' at offset ${N.offset}.`)}A(N){return this.g.push(N),new I}B(N){return this.C().type===N}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=S;function m(W,N){const B=W?W.substituteConstants():void 0,ie=N?N.substituteConstants():void 0;return!B&&!ie?!0:!B||!ie?!1:B.equals(ie)}e.expressionsAreEqualWithConstantSubstitution=m;function f(W,N){return W.cmp(N)}class g{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return p.INSTANCE}}g.INSTANCE=new g,e.ContextKeyFalseExpr=g;class p{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return g.INSTANCE}}p.INSTANCE=new p,e.ContextKeyTrueExpr=p;class h{static create(N,B=null){const ie=k.get(N);return typeof ie=="boolean"?ie?p.INSTANCE:g.INSTANCE:new h(N,B)}constructor(N,B){this.key=N,this.c=B,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:T(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=k.get(this.key);return typeof N=="boolean"?N?p.INSTANCE:g.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=h;class u{static create(N,B,ie=null){if(typeof B=="boolean")return B?h.create(N,ie):P.create(N,ie);const q=k.get(N);return typeof q=="boolean"?B===(q?"true":"false")?p.INSTANCE:g.INSTANCE:new u(N,B,ie)}constructor(N,B,ie){this.c=N,this.d=B,this.f=ie,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:F(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=k.get(this.c);if(typeof N=="boolean"){const B=N?"true":"false";return this.d===B?p.INSTANCE:g.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class d{static create(N,B){return new d(N,B)}constructor(N,B){this.d=N,this.f=B,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:F(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const B=N.getValue(this.f),ie=N.getValue(this.d);return Array.isArray(B)?B.includes(ie):typeof ie=="string"&&typeof B=="object"&&B!==null?R.call(B,ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class y{static create(N,B){return new y(N,B)}constructor(N,B){this.d=N,this.f=B,this.type=11,this.c=d.create(N,B)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=y;class b{static create(N,B,ie=null){if(typeof B=="boolean")return B?P.create(N,ie):h.create(N,ie);const q=k.get(N);return typeof q=="boolean"?B===(q?"true":"false")?g.INSTANCE:p.INSTANCE:new b(N,B,ie)}constructor(N,B,ie){this.c=N,this.d=B,this.f=ie,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:F(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=k.get(this.c);if(typeof N=="boolean"){const B=N?"true":"false";return this.d===B?g.INSTANCE:p.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=b;class P{static create(N,B=null){const ie=k.get(N);return typeof ie=="boolean"?ie?g.INSTANCE:p.INSTANCE:new P(N,B)}constructor(N,B){this.c=N,this.d=B,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:T(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=k.get(this.c);return typeof N=="boolean"?N?g.INSTANCE:p.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.ContextKeyNotExpr=P;function t(W,N){if(typeof W=="string"){const B=parseFloat(W);isNaN(B)||(W=B)}return typeof W=="string"||typeof W=="number"?N(W):g.INSTANCE}class a{static create(N,B,ie=null){return t(B,q=>new a(N,q,ie))}constructor(N,B,ie){this.c=N,this.d=B,this.f=ie,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:F(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=a;class i{static create(N,B,ie=null){return t(B,q=>new i(N,q,ie))}constructor(N,B,ie){this.c=N,this.d=B,this.f=ie,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:F(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=i;class n{static create(N,B,ie=null){return t(B,q=>new n(N,q,ie))}constructor(N,B,ie){this.c=N,this.d=B,this.f=ie,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:F(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class r{static create(N,B,ie=null){return t(B,q=>new r(N,q,ie))}constructor(N,B,ie){this.c=N,this.d=B,this.f=ie,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:F(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class o{static create(N,B){return new o(N,B)}constructor(N,B){this.d=N,this.f=B,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const B=this.f?this.f.source:"",ie=N.f?N.f.source:"";return B<ie?-1:B>ie?1:0}equals(N){if(N.type===this.type){const B=this.f?this.f.source:"",ie=N.f?N.f.source:"";return this.d===N.d&&B===ie}return!1}substituteConstants(){return this}evaluate(N){const B=N.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=s.create(this)),this.c}}e.ContextKeyRegexExpr=o;class s{static create(N){return new s(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new s(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=s;function c(W){let N=null;for(let B=0,ie=W.length;B<ie;B++){const q=W[B].substituteConstants();if(W[B]!==q&&N===null){N=[];for(let x=0;x<B;x++)N[x]=W[x]}N!==null&&(N[B]=q)}return N===null?W:N}class w{static create(N,B,ie){return w.d(N,B,ie)}constructor(N,B){this.expr=N,this.c=B,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let B=0,ie=this.expr.length;B<ie;B++){const q=f(this.expr[B],N.expr[B]);if(q!==0)return q}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let B=0,ie=this.expr.length;B<ie;B++)if(!this.expr[B].equals(N.expr[B]))return!1;return!0}return!1}substituteConstants(){const N=c(this.expr);return N===this.expr?this:w.create(N,this.c,!1)}evaluate(N){for(let B=0,ie=this.expr.length;B<ie;B++)if(!this.expr[B].evaluate(N))return!1;return!0}static d(N,B,ie){const q=[];let x=!1;for(const U of N)if(!!U){if(U.type===1){x=!0;continue}if(U.type===0)return g.INSTANCE;if(U.type===6){q.push(...U.expr);continue}q.push(U)}if(q.length===0&&x)return p.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(f);for(let U=1;U<q.length;U++)q[U-1].equals(q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0];for(;q.length>1;){const U=q[q.length-1];if(U.type!==9)break;q.pop();const K=q.pop(),Q=q.length===0,oe=E.create(U.expr.map(ae=>w.create([ae,K],null,ie)),null,Q);oe&&(q.push(oe),q.sort(f))}if(q.length===1)return q[0];if(ie){for(let U=0;U<q.length;U++)for(let K=U+1;K<q.length;K++)if(q[U].negate().equals(q[K]))return g.INSTANCE;if(q.length===1)return q[0]}return new w(q,B)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const B of this.expr)N.push(...B.keys());return N}map(N){return new w(this.expr.map(B=>B.map(N)),null)}negate(){if(!this.c){const N=[];for(const B of this.expr)N.push(B.negate());this.c=E.create(N,this,!0)}return this.c}}class E{static create(N,B,ie){return E.d(N,B,ie)}constructor(N,B){this.expr=N,this.c=B,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let B=0,ie=this.expr.length;B<ie;B++){const q=f(this.expr[B],N.expr[B]);if(q!==0)return q}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let B=0,ie=this.expr.length;B<ie;B++)if(!this.expr[B].equals(N.expr[B]))return!1;return!0}return!1}substituteConstants(){const N=c(this.expr);return N===this.expr?this:E.create(N,this.c,!1)}evaluate(N){for(let B=0,ie=this.expr.length;B<ie;B++)if(this.expr[B].evaluate(N))return!0;return!1}static d(N,B,ie){let q=[],x=!1;if(N){for(let U=0,K=N.length;U<K;U++){const Q=N[U];if(!!Q){if(Q.type===0){x=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){q=q.concat(Q.expr);continue}q.push(Q)}}if(q.length===0&&x)return g.INSTANCE;q.sort(f)}if(q.length!==0){if(q.length===1)return q[0];for(let U=1;U<q.length;U++)q[U-1].equals(q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0];if(ie){for(let U=0;U<q.length;U++)for(let K=U+1;K<q.length;K++)if(q[U].negate().equals(q[K]))return p.INSTANCE;if(q.length===1)return q[0]}return new E(q,B)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const B of this.expr)N.push(...B.keys());return N}map(N){return new E(this.expr.map(B=>B.map(N)),null)}negate(){if(!this.c){const N=[];for(const B of this.expr)N.push(B.negate());for(;N.length>1;){const B=N.shift(),ie=N.shift(),q=[];for(const x of Y(B))for(const U of Y(ie))q.push(w.create([x,U],null,!1));N.unshift(E.create(q,null,!1))}this.c=E.create(N,this,!0)}return this.c}}class L extends h{static all(){return L.d.values()}constructor(N,B,ie){super(N,null),this.f=B,typeof ie=="object"?L.d.push({...ie,key:N}):ie!==!0&&L.d.push({key:N,description:ie,type:B!=null?typeof B:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return u.create(this.key,N)}notEqualsTo(N){return b.create(this.key,N)}}L.d=[],e.RawContextKey=L,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function T(W,N){return W<N?-1:W>N?1:0}function F(W,N,B,ie){return W<B?-1:W>B?1:N<ie?-1:N>ie?1:0}function z(W,N){if(W.type===0||N.type===1)return!0;if(W.type===9)return N.type===9?J(W.expr,N.expr):!1;if(N.type===9){for(const B of N.expr)if(z(W,B))return!0;return!1}if(W.type===6){if(N.type===6)return J(N.expr,W.expr);for(const B of W.expr)if(z(B,N))return!0;return!1}return W.equals(N)}e.implies=z;function J(W,N){let B=0,ie=0;for(;B<W.length&&ie<N.length;){const q=W[B].cmp(N[ie]);if(q<0)return!1;q===0&&B++,ie++}return B===W.length}function Y(W){return W.type===9?W.expr:[W]}}),define(se[98],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,A.createDecorator)(e.ID);function O(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=O;class l{async getPerformanceInfo(k,R){return{}}async getSystemInfo(k,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,R){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=l}),define(se[99],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,A.createDecorator)("downloadService")}),define(se[15],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,A.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,A.refineServiceDecorator)(e.IEnvironmentService)}),define(se[29],re([0,1,161,5]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function D(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function k(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function R(u,d){return d==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function C(u,d,y){return R(d,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:v(y).includes(u)}e.isTargetPlatformCompatible=C;function v(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=I;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(d,y){super(d),this.code=y,this.name=y}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,A.localize)(1,null),original:"Preferences"}}),define(se[203],re([0,1,3,2,32,10,93,29]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(h,u){return h?D.URI.revive(u?u.transformIncoming(h):h):void 0}function v(h,u){return u?u.transformOutgoingURI(h):h}function I(h,u){u=u||k.DefaultURITransformer;const d=h.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...h,manifest:void 0},u),manifest:d}}function S(h,u){return h?.profileLocation?(0,k.transformAndReviveIncomingURIs)(h,u??k.DefaultURITransformer):h}function m(h,u){return u?(0,l.cloneAndChange)(h,d=>d instanceof D.URI?u.transformOutgoingURI(d):void 0):h}class f{constructor(u,d){this.a=u,this.b=d,this.onInstallExtension=A.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=A.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=A.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=A.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=A.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const y=this.b(u);switch(d){case"onInstallExtension":return A.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?v(b.profileLocation,y):b.profileLocation}));case"onDidInstallExtensions":return A.Event.map(this.onDidInstallExtensions,b=>b.map(P=>({...P,local:P.local?m(P.local,y):P.local,profileLocation:P.profileLocation?v(P.profileLocation,y):P.profileLocation})));case"onUninstallExtension":return A.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?v(b.profileLocation,y):b.profileLocation}));case"onDidUninstallExtension":return A.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?v(b.profileLocation,y):b.profileLocation}));case"onDidUpdateExtensionMetadata":return A.Event.map(this.onDidUpdateExtensionMetadata,b=>m(b,y))}throw new Error("Invalid listen")}async call(u,d,y){const b=this.b(u);switch(d){case"zip":{const P=I(y[0],b),t=await this.a.zip(P);return v(t,b)}case"unzip":return this.a.unzip(C(y[0],b));case"install":return this.a.install(C(y[0],b),S(y[1],b));case"installFromLocation":return this.a.installFromLocation(C(y[0],b),C(y[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(y[0],C(y[1],b),C(y[2],b));case"getManifest":return this.a.getManifest(C(y[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(y[0]);case"installFromGallery":return this.a.installFromGallery(y[0],S(y[1],b));case"uninstall":return this.a.uninstall(I(y[0],b),S(y[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(I(y[0],b));case"getInstalled":return(await this.a.getInstalled(y[0],C(y[1],b))).map(t=>m(t,b));case"copyExtensions":return this.a.copyExtensions(C(y[0],b),C(y[1],b));case"updateMetadata":{const P=await this.a.updateMetadata(I(y[0],b),y[1],C(y[2],b));return m(P,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(y[0],y[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class g extends O.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new A.Emitter),this.f=this.B(new A.Emitter),this.g=this.B(new A.Emitter),this.h=this.B(new A.Emitter),this.j=this.B(new A.Emitter),this.B(this.k.listen("onInstallExtension")(d=>this.l(this.c,{...d,source:this.m(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(d=>this.l(this.f,d.map(y=>({...y,local:y.local?I(y.local,null):y.local,source:this.m(y.source)?D.URI.revive(y.source):y.source,profileLocation:D.URI.revive(y.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(d=>this.l(this.g,{...d,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(d=>this.l(this.h,{...d,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(I(d,null))))}l(u,d){u.fire(d)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(y=>(0,R.isTargetPlatformCompatible)(y,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(d=>D.URI.revive(d)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,d){return Promise.resolve(this.k.call("install",[u,d])).then(y=>I(y,null))}installFromLocation(u,d){return Promise.resolve(this.k.call("installFromLocation",[u,d])).then(y=>I(y,null))}async installExtensionsFromProfile(u,d,y){return(await this.k.call("installExtensionsFromProfile",[u,d,y])).map(P=>I(P,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.k.call("installFromGallery",[u,d])).then(y=>I(y,null))}uninstall(u,d){return Promise.resolve(this.k.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(d=>I(d,null))}getInstalled(u=null,d){return Promise.resolve(this.k.call("getInstalled",[u,d])).then(y=>y.map(b=>I(b,null)))}updateMetadata(u,d,y){return Promise.resolve(this.k.call("updateMetadata",[u,d,y])).then(b=>I(b,null))}copyExtensions(u,d){return this.k.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,d){const y=await this.k.call("download",[u,d]);return D.URI.revive(y)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class p{constructor(u){this.a=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,y){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(se[100],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,A.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((D,k)=>_(["node-vsce-sign"],async R=>D(R),k))),this.a}async verify(D,k,R){let C;try{C=await this.b()}catch{return!1}return C.verify(D,k,R)}}e.ExtensionSignatureVerificationService=O}),define(se[101],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(O=e.RecommendationSource||(e.RecommendationSource={}));function l(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var D;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(D=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,A.createDecorator)("IExtensionRecommendationNotificationService")}),define(se[14],re([0,1,49,13,26,12,10,169,5,4,21]),function(_,e,A,O,l,D,k,R,C,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function S(U){return U.create===!0}e.isFileOpenForWriteOptions=S;var m;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(m=e.FileType||(e.FileType={}));var f;(function(U){U[U.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var g;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=u;function d(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function y(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=y;function b(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var P;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(K,Q){const oe=new t(K.toString(),Q);return n(oe,Q),oe}constructor(K,Q){super(K),this.code=Q}}e.FileSystemProviderError=t;function a(U,K){return t.create(U,K)}e.createFileSystemProviderError=a;function i(U){return U||a((0,R.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=i;function n(U,K){return U.name=K?`${K} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=n;function r(U){if(!U)return P.Unknown;if(U instanceof t)return U.code;const K=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!K)return P.Unknown;switch(K[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=r;function o(U){if(U instanceof T)return U.fileOperationResult;switch(r(U)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(K,Q,oe){this.resource=K,this.operation=Q,this.target=oe}isOperation(K){return this.operation===K}}e.FileOperationEvent=c;var w;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class E{constructor(K,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const ae of K){const V=oe.get(ae.type);switch(V?V.push([ae.resource,ae]):oe.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,V]of oe)switch(ae){case 1:this.a=A.TernarySearchTree.forUris(()=>Q),this.a.fill(V);break;case 0:this.b=A.TernarySearchTree.forUris(()=>Q),this.b.fill(V);break;case 2:this.c=A.TernarySearchTree.forUris(()=>Q),this.c.fill(V);break}}contains(K,...Q){return this.d(K,{includeChildren:!1},...Q)}affects(K,...Q){return this.d(K,{includeChildren:!0},...Q)}d(K,Q,...oe){if(!K)return!1;const ae=oe.length>0;return!!((!ae||oe.includes(1))&&(this.a?.get(K)||Q.includeChildren&&this.a?.findSuperstr(K))||(!ae||oe.includes(0))&&(this.b?.get(K)||Q.includeChildren&&this.b?.findSuperstr(K))||(!ae||oe.includes(2))&&(this.c?.findSubstr(K)||Q.includeChildren&&this.c?.findSuperstr(K)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function L(U,K,Q){return!U||!K||U===K||K.length>U.length?!1:(K.charAt(K.length-1)!==O.sep&&(K+=O.sep),Q?(0,l.startsWithIgnoreCase)(U,K):U.indexOf(K)===0)}e.isParent=L;class T extends Error{constructor(K,Q,oe){super(K),this.fileOperationResult=Q,this.options=oe}}e.FileOperationError=T;class F extends T{constructor(K,Q,oe,ae){super(K,Q,ae),this.fileOperationResult=Q,this.size=oe}}e.TooLargeFileOperationError=F;class z extends T{constructor(K,Q,oe){super(K,2,oe),this.stat=Q}}e.NotModifiedSinceFileOperationError=z;var J;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Y;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=W;async function N(U,K){if(!K.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(Q=>{const oe=K.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===U.scheme&&ae.added&&(oe.dispose(),Q())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(K){return(0,D.isNumber)(K)||(K=0),K<B.KB?(0,R.localize)(1,null,K.toFixed(0)):K<B.MB?(0,R.localize)(2,null,(K/B.KB).toFixed(2)):K<B.GB?(0,R.localize)(3,null,(K/B.MB).toFixed(2)):K<B.TB?(0,R.localize)(4,null,(K/B.GB).toFixed(2)):(0,R.localize)(5,null,(K/B.TB).toFixed(2))}}B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB,e.ByteSize=B;var ie;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function q(U){return{maxFileSize:U===0?300*B.MB:16*B.GB,maxHeapSize:U===0?700*B.MB:2*700*B.MB}}e.getPlatformFileLimits=q;function x(U){const K=typeof U=="string"||U?.scheme===I.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===I.Schemas.file?1024*B.MB:K?10*B.MB:v.isWeb?50*B.MB:1024*B.MB}e.getLargeFileConfirmationLimit=x});var X=this&&this.__param||function(_,e){return function(A,O){e(A,O,_)}};define(se[204],re([0,1,102,43,14]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let D=class{constructor(R){this.a=R}async checksum(R){const C=(await this.a.readFileStream(R)).value;return new Promise((v,I)=>{const S=(0,A.createHash)("md5");(0,O.listenStream)(C,{onData:m=>S.update(m.buffer),onError:m=>I(m),onEnd:()=>v(S.digest("base64").replace(/=+$/,""))})})}};D=ye([X(0,l.IFileService)],D),e.ChecksumService=D}),define(se[205],re([0,1,17,39,7,3,2,43,10,31,14]),function(_,e,A,O,l,D,k,R,C,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends k.Disposable{constructor(f,g){super(),this.a=f,this.b=g,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.h=(0,v.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,g){const{buffer:p}=await this.a.call("readFile",[f,g]);return p}readFileStream(f,g,p){const h=(0,R.newWriteableStream)(d=>A.VSBuffer.concat(d.map(y=>A.VSBuffer.wrap(y))).buffer),u=this.a.listen("readFileStream",[f,g])(d=>{if(d instanceof A.VSBuffer)h.write(d.buffer);else{if(d==="end")h.end();else{let y;if(d instanceof Error)y=d;else{const b=d;y=(0,I.createFileSystemProviderError)(b.message??(0,O.toErrorMessage)(b),b.code??I.FileSystemProviderErrorCode.Unknown)}h.error(y),h.end()}u.dispose()}});return p.onCancellationRequested(()=>{h.error((0,l.canceled)()),h.end(),u.dispose()}),h}writeFile(f,g,p){return this.a.call("writeFile",[f,A.VSBuffer.wrap(g),p])}open(f,g){return this.a.call("open",[f,g])}close(f){return this.a.call("close",[f])}async read(f,g,p,h,u){const[d,y]=await this.a.call("read",[f,g,u]);return p.set(d.buffer.slice(0,y),h),y}write(f,g,p,h,u){return this.a.call("write",[f,g,A.VSBuffer.wrap(p),h,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,g){return this.a.call("delete",[f,g])}rename(f,g,p){return this.a.call("rename",[f,g,p])}copy(f,g,p){return this.a.call("copy",[f,g,p])}cloneFile(f,g){return this.a.call("cloneFile",[f,g])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const g=f;this.f.fire(g.map(p=>({resource:C.URI.revive(p.resource),type:p.type})))}else{const g=f;this.g.fire(g)}}))}watch(f,g){const p=(0,v.generateUuid)();return this.a.call("watch",[this.h,p,f,g]),(0,k.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=S}),define(se[103],re([0,1,17,7,170,14]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(I,S,m,f,g,p){let h;try{await R(I,S,m,f,g,p)}catch(u){h=u}finally{h&&g.errorTransformer&&(h=g.errorTransformer(h)),typeof h<"u"&&m.error(h),m.end()}}e.readFileIntoStream=k;async function R(I,S,m,f,g,p){C(p);const h=await I.open(S,{create:!1});try{C(p);let u=0,d=0,y=g&&typeof g.length=="number"?g.length:void 0,b=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof y=="number"?y:g.bufferSize)),P=g&&typeof g.position=="number"?g.position:0,t=0;do d=await I.read(h,P,b.buffer,t,b.byteLength-t),P+=d,t+=d,u+=d,typeof y=="number"&&(y-=d),t===b.byteLength&&(await m.write(f(b)),b=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof y=="number"?y:g.bufferSize)),t=0);while(d>0&&(typeof y!="number"||y>0)&&C(p)&&v(u,g));if(t>0){let a=t;typeof y=="number"&&(a=Math.min(t,y)),m.write(f(b.slice(0,a)))}}catch(u){throw(0,D.ensureFileSystemProviderError)(u)}finally{await I.close(h)}}function C(I){if(I.isCancellationRequested)throw(0,O.canceled)();return!0}function v(I,S){if(S?.limits){if(typeof S.limits.memory=="number"&&I>S.limits.memory)throw(0,D.createFileSystemProviderError)((0,l.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&I>S.limits.size)throw(0,D.createFileSystemProviderError)((0,l.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(se[56],re([0,1,92,2,13,4,10,14]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(u){return u.recursive===!0}e.isRecursiveWatchRequest=C;class v extends O.Disposable{constructor(d,y,b,P){super(),this.h=d,this.i=y,this.j=b,this.k=P,this.c=this.B(new O.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new O.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(y=>this.h(y))),d.add(this.b.onDidLogMessage(y=>this.i(y))),d.add(this.b.onDidError(y=>this.n(y)))}n(d){this.k.restartOnError?this.g<v.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}s(d){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}v.a=5,e.AbstractWatcherClient=v;class I extends v{constructor(d,y,b){super(d,y,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class S extends v{constructor(d,y,b){super(d,y,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function m(u){return u.map(d=>({type:d.type,resource:k.URI.file(d.path)}))}e.toFileChanges=m;function f(u){const d=new h;for(const y of u)d.processEvent(y);return d.coalesce()}e.coalesceEvents=f;function g(u,d){return typeof d=="string"&&!d.startsWith(A.GLOBSTAR)&&!(0,l.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=g;function p(u,d){const y=[];for(const b of d)y.push((0,A.parse)(g(u,b)));return y}e.parseWatcherPatterns=p;class h{constructor(){this.a=new Set,this.b=new Map}c(d){return D.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const y=this.b.get(this.c(d));let b=!1;if(y){const P=y.type,t=d.type;y.path!==d.path&&(d.type===2||d.type===1)?b=!0:P===1&&t===2?(this.b.delete(this.c(d)),this.a.delete(y)):P===2&&t===1?y.type=0:P===1&&t===0||(y.type=t)}else b=!0;b&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],y=[];return Array.from(this.a).filter(b=>b.type!==2?(d.push(b),!1):!0).sort((b,P)=>b.path.length-P.path.length).filter(b=>y.some(P=>(0,R.isParent)(b.path,P,!D.isLinux))?!1:(y.push(b.path),!0)).concat(d)}}}),define(se[206],re([0,1,53,6,23,48,2,85,13,4,148,27,56]),function(_,e,A,O,l,D,k,R,C,v,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends k.Disposable{constructor(h,u,d,y){super(),this.j=h,this.k=u,this.l=d,this.m=y,this.c=this.B(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.k(b))),this.f=this.B(new O.RunOnceWorker(b=>this.u(b),f.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const h=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await S.Promises.stat(h);this.B(await this.s(h,u.isDirectory()))}catch(h){h.code!=="ENOENT"?this.w(h):this.z(h)}}async r(h){let u=h.path;try{u=await S.Promises.realpath(h.path),h.path===u&&(u=await(0,I.realcase)(h.path)??h.path),h.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${u})`)}catch{}return u}async s(h,u){if(v.isMacintosh&&(0,D.isEqualOrParent)(h,"/Volumes/",!0))return this.w(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const d=new l.CancellationTokenSource(this.i.token),y=new k.DisposableStore;try{const b=(0,C.basename)(h),P=(0,A.watch)(h);y.add((0,k.toDisposable)(()=>{P.removeAllListeners(),P.close()})),this.z(`Started watching: '${h}'`);const t=new Set;if(u)try{for(const i of await S.Promises.readdir(h))t.add(i)}catch(i){this.w(i)}const a=new Map;y.add((0,k.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),P.on("error",(i,n)=>{this.w(`Failed to watch ${h} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),P.on("change",(i,n)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let r="";if(n&&(r=n.toString(),v.isMacintosh&&(r=(0,R.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){a.get(r)?.dispose();const o=setTimeout(async()=>{if(a.delete(r),r===b&&!await S.Promises.exists(h)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,C.join)(h,r));if(d.token.isCancellationRequested)return;let c;s?t.has(r)?c=0:(c=1,t.add(r)):(t.delete(r),c=2),this.t({path:(0,C.join)(this.j.path,r),type:c})},f.a);a.set(r,(0,k.toDisposable)(()=>clearTimeout(o)))}else{let o;t.has(r)?o=0:(o=1,t.add(r)),this.t({path:(0,C.join)(this.j.path,r),type:o})}else if(i==="rename"||r!==b){const o=setTimeout(async()=>{const s=await S.Promises.exists(h);d.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),y.add(await this.s(h,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);y.clear(),y.add((0,k.toDisposable)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(b){await S.Promises.exists(h)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${h} for changes using fs.watch() (${b.toString()})`)}return(0,k.toDisposable)(()=>{d.dispose(!0),y.dispose()})}t(h,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!u&&this.g.some(d=>d(h.path))?this.m&&this.z(` >> ignored (excluded) ${h.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(d=>d(h.path))?this.m&&this.z(` >> ignored (not included) ${h.path}`):this.f.work(h))}u(h){const u=(0,m.coalesceEvents)(h);if(u.length>0){if(this.m)for(const y of u)this.z(`>> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(h){if(v.isLinux)return S.Promises.exists(h);try{const u=(0,C.basename)(h);return(await S.Promises.readdir((0,C.dirname)(h))).some(y=>y===u)}catch(u){return this.z(u),!1}}setVerboseLogging(h){this.m=h}w(h){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}y(h){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}z(h){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}f.a=100,f.b=75,e.NodeJSFileWatcherLibrary=f;async function g(p,h,u,d,y=512){const b=await S.Promises.open(p,"r"),P=Buffer.allocUnsafe(y),t=new l.CancellationTokenSource(d);let a,i=!1;const n={path:p,excludes:[],recursive:!1},r=new f(n,o=>{(async()=>{for(const{type:s}of o)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:c}=await S.Promises.read(b,P,0,y,null);if(!c||t.token.isCancellationRequested)break;h(P.slice(0,c))}}catch(c){a=new Error(c),t.dispose(!0)}finally{i=!1}}})()});return await r.ready,u(),new Promise((o,s)=>{t.token.onCancellationRequested(async()=>{r.dispose();try{await S.Promises.close(b)}catch(c){a=new Error(c)}a?s(a):o()})})}e.watchFileContents=g}),define(se[207],re([0,1,3,92,2,4,206]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new A.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=A.Event.None,this.c=new Map,this.f=!1}async watch(v){const I=this.i(v),S=I.filter(f=>{const g=this.c.get(f.path);return g?!(0,O.patternsEquals)(g.request.excludes,f.excludes)||!(0,O.patternsEquals)(g.request.includes,f.includes):!0}),m=Array.from(this.c.values()).filter(({request:f})=>!I.find(g=>g.path===f.path&&(0,O.patternsEquals)(g.excludes,f.excludes)&&(0,O.patternsEquals)(g.includes,f.includes))).map(({request:f})=>f.path);S.length&&this.j(`Request to start watching: ${S.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const f of m)this.h(f);for(const f of S)this.g(f)}g(v){const I=new k.NodeJSFileWatcherLibrary(v,m=>this.a.fire(m),m=>this.b.fire(m),this.f),S={request:v,instance:I};this.c.set(v.path,S)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const I=this.c.get(v);I&&(this.c.delete(v),I.instance.dispose())}i(v){const I=new Map;for(const S of v){const m=D.isLinux?S.path:S.path.toLowerCase();I.set(m,S)}return Array.from(I.values())}async setVerboseLogging(v){this.f=v;for(const[,I]of this.c)I.instance.setVerboseLogging(v)}j(v){this.f&&this.b.fire({type:"trace",message:this.k(v)})}k(v,I){return I?`[File Watcher (node.js)] ${v} (path: ${I.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=R}),define(se[208],re([0,1,56,207]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends A.AbstractNonRecursiveWatcherClient{constructor(k,R,C){super(k,R,C),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(se[209],re([0,1,21,37,66,56]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(C,v,I){super(C,v,I),this.m()}l(C){const v=C.add(new l.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(v.onDidProcessExit(({code:I,signal:S})=>this.n(`terminated by itself with code ${I}, signal: ${S}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(se[70],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class A{constructor(...l){this.a=new Map;for(const[D,k]of l)this.set(D,k)}set(l,D){const k=this.a.get(l);return this.a.set(l,D),k}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=A}),define(se[210],re([0,1,6,7,2,55,200,5,70,84]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class S extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class m{constructor(h=new C.ServiceCollection,u=!1,d,y=I){this.f=h,this.g=u,this.h=d,this.i=y,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=y?d?._globalGraph??new k.Graph(b=>b):void 0}createChild(h){return new m(h,this.g,this,this.i)}invokeFunction(h,...u){const d=g.traceInvocation(this.i,h);let y=!1;try{return h({get:P=>{if(y)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(P,d);if(!t)throw new Error(`[invokeFunction] unknown service '${P}'`);return t}},...u)}finally{y=!0,d.stop()}}createInstance(h,...u){let d,y;return h instanceof D.SyncDescriptor?(d=g.traceCreation(this.i,h.ctor),y=this.j(h.ctor,h.staticArguments.concat(u),d)):(d=g.traceCreation(this.i,h),y=this.j(h,u,d)),d.stop(),y}j(h,u=[],d){const y=R._util.getServiceDependencies(h).sort((t,a)=>t.index-a.index),b=[];for(const t of y){const a=this.m(t.id,d);a||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(a)}const P=y.length>0?y[0].index:u.length;if(u.length!==P){console.trace(`[createInstance] First service dependency of ${h.name} at position ${P+1} conflicts with ${u.length} static arguments`);const t=P-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,P)}return Reflect.construct(h,u.concat(b))}k(h,u){if(this.f.get(h)instanceof D.SyncDescriptor)this.f.set(h,u);else if(this.h)this.h.k(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const u=this.f.get(h);return!u&&this.h?this.h.l(h):u}m(h,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const d=this.l(h);return d instanceof D.SyncDescriptor?this.q(h,d,u.branch(h,!0)):(u.branch(h,!1),d)}q(h,u,d){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,u,d)}finally{this.o.delete(h)}}r(h,u,d){const y=new k.Graph(t=>t.id.toString());let b=0;const P=[{id:h,desc:u,_trace:d}];for(;P.length;){const t=P.pop();if(y.lookupOrInsertNode(t),b++>1e3)throw new S(y);for(const a of R._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof D.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};y.insertEdge(t,n),P.push(n)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new S(y);break}for(const{data:a}of t){if(this.l(a.id)instanceof D.SyncDescriptor){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}y.removeNode(a)}}return this.l(h)}s(h,u,d=[],y,b){if(this.f.get(h)instanceof D.SyncDescriptor)return this.t(h,u,d,y,b);if(this.h)return this.h.s(h,u,d,y,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(h,u,d=[],y,b){if(y){const P=new m(void 0,this.g,this,this.i);P.c=String(h);const t=new Map,a=new A.IdleValue(()=>{const i=P.j(u,d,b);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const s of r)o.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new v.LinkedList,t.set(n,s)),(w,E,L)=>{const T=s.push([w,E,L]);return(0,l.toDisposable)(T)}}if(n in i)return i[n];const r=a.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return a.value[n]=r,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,d,b)}u(h,u){if(u&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=m;var f;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(f||(f={}));class g{static traceInvocation(h,u){return h?new g(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(h,u){return h?new g(1,u.name):g.c}constructor(h,u){this.type=h,this.name=u,this.g=Date.now(),this.h=[]}branch(h,u){const d=new g(3,h.toString());return this.h.push([h,u,d]),d}stop(){const h=Date.now()-this.g;g.f+=h;let u=!1;function d(b,P){const t=[],a=new Array(b+1).join("	");for(const[i,n,r]of P.h)if(n&&r){u=!0,t.push(`${a}CREATES -> ${i}`);const o=d(b+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(h>2||u)&&g.all.add(y.join(`
`))}}g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0,e.Trace=g}),define(se[211],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class A{constructor(l,D){this.a=l,this.b=D}getChannel(l){return this.a.getChannel(l,this.b)}registerChannel(l,D){this.a.registerChannel(l,D)}}e.MessagePortMainProcessService=A}),define(se[71],re([0,1,37,55,69,5]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(f,g,p,h){const u=p.getChannel(f);return R(g)?h.createInstance(new O.SyncDescriptor(g.channelClientCtor,[u])):A.ProxyChannel.toService(u,g?.proxyOptions)}}function R(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,D.createDecorator)("mainProcessService");let C=class extends k{constructor(f,g,p,h){super(f,g,p,h)}};C=ye([X(2,e.IMainProcessService),X(3,D.IInstantiationService)],C);function v(m,f,g){(0,l.registerSingleton)(m,new O.SyncDescriptor(C,[f,g],!0))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,D.createDecorator)("sharedProcessService");let I=class extends k{constructor(f,g,p,h){super(f,g,p,h)}};I=ye([X(2,e.ISharedProcessService),X(3,D.IInstantiationService)],I);function S(m,f,g){(0,l.registerSingleton)(m,new O.SyncDescriptor(I,[f,g],!0))}e.registerSharedProcessRemoteService=S}),define(se[72],re([0,1,23,2,4,172,29,5]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function C(I){return I.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=C,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let v=class extends O.Disposable{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new A.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const g=m.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(h=>h.startsWith("lp-"))).map(p=>{const h=p.properties.localizedLanguages?.[0],u=C(p);return{...this.f(u,h,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(S,m,f){const g=m??S;let p;if(g!==S&&(p=`(${S})`),S.toLowerCase()===l.language.toLowerCase()&&(p??="",p+=(0,D.localize)(0,null)),f?.installCount){p??="";const h=f.installCount;let u;h>1e6?u=`${Math.floor(h/1e5)/10}M`:h>1e3?u=`${Math.floor(h/1e3)}K`:u=String(h),p+=` $(cloud-download) ${u}`}return{id:S,label:g,description:p}}};v=ye([X(0,k.IExtensionGalleryService)],v),e.LanguagePackBaseService=v}),define(se[212],re([0,1,2,72]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends A.Disposable{constructor(k){super(),this.a=k,this.b()}b(){this.a.update()}};l=ye([X(0,O.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(se[11],re([0,1,39,3,2,38,4,12,10,5]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function I(){return new Date().toISOString()}function S(s){return(0,R.isNumber)(s)}e.isLogLevel=S;var m;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function f(s,c,w){switch(c){case m.Trace:s.trace(w);break;case m.Debug:s.debug(w);break;case m.Info:s.info(w);break;case m.Warning:s.warn(w);break;case m.Error:s.error(w);break;case m.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=f;function g(s){let c="";for(let w=0;w<s.length;w++){let E=s[w];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}c+=(w>0?" ":"")+E}return c}e.format=g;class p extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==m.Off&&this.b<=c}}e.AbstractLogger=p;class h extends p{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...w){this.f(m.Trace)&&this.g(m.Trace,g([c,...w]))}debug(c,...w){this.f(m.Debug)&&this.g(m.Debug,g([c,...w]))}info(c,...w){this.f(m.Info)&&this.g(m.Info,g([c,...w]))}warn(c,...w){this.f(m.Warning)&&this.g(m.Warning,g([c,...w]))}error(c,...w){if(this.f(m.Error))if(c instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=c.stack,this.g(m.Error,g(E))}else this.g(m.Error,g([c,...w]))}flush(){}}e.AbstractMessageLogger=h;class u extends p{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!k.isWindows}trace(c,...w){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,c,...w):console.log(`[main ${I()}]`,c,...w))}debug(c,...w){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,c,...w):console.log(`[main ${I()}]`,c,...w))}info(c,...w){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,c,...w):console.log(`[main ${I()}]`,c,...w))}warn(c,...w){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,c,...w):console.warn(`[main ${I()}]`,c,...w))}error(c,...w){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,c,...w):console.error(`[main ${I()}]`,c,...w))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class d extends p{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...w){this.f(m.Trace)&&console.log("%cTRACE","color: #888",c,...w)}debug(c,...w){this.f(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...w)}info(c,...w){this.f(m.Info)&&console.log("%c INFO","color: #33f",c,...w)}warn(c,...w){this.f(m.Warning)&&console.log("%c WARN","color: #993",c,...w)}error(c,...w){this.f(m.Error)&&console.log("%c  ERR","color: #f33",c,...w)}dispose(){}flush(){}}e.ConsoleLogger=d;class y extends p{constructor(c,w=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(w)}trace(c,...w){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(c),...w])}debug(c,...w){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(c),...w])}info(c,...w){this.f(m.Info)&&this.g.log(m.Info,[this.h(c),...w])}warn(c,...w){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(c),...w])}error(c,...w){this.f(m.Error)&&this.g.log(m.Error,[this.h(c),...w])}h(c){return typeof c=="string"?c:(0,A.toErrorMessage)(c,this.f(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=y;class b extends p{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const w of this.g)w.setLevel(c);super.setLevel(c)}trace(c,...w){for(const E of this.g)E.trace(c,...w)}debug(c,...w){for(const E of this.g)E.debug(c,...w)}info(c,...w){for(const E of this.g)E.info(c,...w)}warn(c,...w){for(const E of this.g)E.warn(c,...w)}error(c,...w){for(const E of this.g)E.error(c,...w)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogger=b;class P extends l.Disposable{constructor(c,w){if(super(),this.j=c,this.b=new D.ResourceMap,this.c=new D.ResourceMap,this.f=this.B(new O.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeVisibility=this.h.event,w)for(const E of w)this.c.set(E.resource,E)}getLogger(c){return this.b.get(c)}createLogger(c,w){let E=this.b.get(c);const L=w?.logLevel==="always"?m.Trace:w?.logLevel;return E||(E=this.k(c,L??this.getLogLevel(c)??this.j,w),this.b.set(c,E)),this.registerLogger({resource:c,id:w?.id??c.toString(),logLevel:L,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId}),E}setLogLevel(c,w){if(C.URI.isUri(c)){const E=c,L=w,T=this.c.get(E);T&&L!==T.logLevel&&(T.logLevel=L===this.j?void 0:L,this.b.get(E)?.setLevel(L),this.c.set(T.resource,T),this.g.fire([E,L]))}else{this.j=c;for(const[E,L]of this.b.entries())this.c.get(E)?.logLevel===void 0&&L.setLevel(this.j);this.g.fire(this.j)}}setVisibility(c,w){const E=this.c.get(c);E&&w!==!E.hidden&&(E.hidden=!w,this.c.set(E.resource,E),this.h.fire([c,w]))}getLogLevel(c){let w;return c&&(w=this.c.get(c)?.logLevel),w??this.j}registerLogger(c){const w=this.c.get(c.resource);w?w.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.c.set(c.resource,c),this.f.fire({added:[c],removed:[]}))}deregisterLogger(c){const w=this.c.get(c);if(w){this.c.delete(c);const E=this.b.get(c);E&&(this.b.delete(c),E.dispose()),this.f.fire({added:[],removed:[w]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(c){return this.c.get(c)}dispose(){this.b.forEach(c=>c.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=P;class t{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(c){}getLevel(){return m.Info}trace(c,...w){}debug(c,...w){}info(c,...w){}warn(c,...w){}error(c,...w){}critical(c,...w){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends P{constructor(){super(m.Info)}k(c,w,E){return new t}}e.NullLoggerService=i;function n(s){if(s.verbose)return m.Trace;if(typeof s.logLevel=="string"){const c=o(s.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(s){switch(s){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(s){switch(s){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(se[213],re([0,1,6,7,2,13,27,15,11]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let v=class extends l.Disposable{constructor(S,m){super(),this.a=S,this.b=m,this.B(new A.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const S=(0,D.basename)(this.a.logsPath),m=(0,D.dirname)(this.a.logsPath),p=(await k.Promises.readdir(m)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==S),h=p.slice(0,Math.max(0,p.length-9));h.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(u=>k.Promises.rm((0,D.join)(m,u)))))}catch(S){(0,O.onUnexpectedError)(S)}}};v=ye([X(0,R.IEnvironmentService),X(1,C.ILogService)],v),e.LogsDataCleaner=v}),define(se[214],re([0,1,18,6,7,3,2,13,56,11]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends k.Disposable{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(m,f):this.u(m,f)}l(m,f){const g={path:this.C(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive},p=(0,A.insert)(this.j,g);return this.m(),(0,k.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,l.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,C.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,C.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,C.isRecursiveWatchRequest)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,f){const g={path:this.C(m),excludes:f.excludes,includes:f.includes,recursive:!1},p=(0,A.insert)(this.s,g);return this.v(),(0,k.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,l.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,C.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,R.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(se[215],re([0,1,18,6,17,23,3,65,63,2,49,21,104,24,43,168,14,103,11,7]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends v.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new v.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new h.FileChangesEvent(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,v.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,v.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await O.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return C.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,f.isAbsolutePath)(t))throw new h.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new y.ErrorNoTelemetry;throw i.message=(0,p.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a)||(0,h.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,h.toFileSystemProviderErrorCode)(i)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,h.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,c=await i.stat(t);let w;return this.p(i,t,c,void 0,!!s,(E,L)=>(w||(w=I.TernarySearchTree.forUris(()=>!n),w.set(t,!0),r&&w.fill(!0,r)),w.get(E.resource)||w.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?L===1:!1))}async p(t,a,i,n,r,o){const{providerExtUri:s}=this.N(t),c={resource:a,name:s.basename(a),isFile:(i.type&h.FileType.File)!==0,isDirectory:(i.type&h.FileType.Directory)!==0,isSymbolicLink:(i.type&h.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&h.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,h.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(c.isDirectory&&o(c,n)){try{const w=await t.readdir(a),E=await O.Promises.settled(w.map(async([L,T])=>{try{const F=s.joinPath(a,L),z=r?await t.stat(F):{type:T};return await this.p(t,F,z,w.length,r,o)}catch(F){return this.b.trace(F),null}}));c.children=(0,A.coalesce)(E)}catch(w){this.b.trace(w),c.children=[]}return c}return c}async resolveAll(t){return O.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new h.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=l.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new h.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let s;if((0,h.hasReadWriteCapability)(n)&&!(a instanceof l.VSBuffer))if((0,g.isReadableStream)(a)){const c=await(0,g.peekStream)(a,3);c.ended?s=l.VSBuffer.concat(c.buffer):s=c}else s=(0,g.peekReadable)(a,c=>l.VSBuffer.concat(c),3);else s=a;!(0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)&&s instanceof l.VSBuffer?await this.cb(n,t,i,s):await this.Y(n,t,i,s instanceof l.VSBuffer?(0,l.bufferToReadable)(s):s),this.m.fire(new h.FileOperationEvent(t,4))}catch(o){throw new h.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,h.ensureFileSystemProviderError)(o).toString()),(0,h.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,p.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==h.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,h.etag)({mtime:i.mtime,size:r.size}))throw new h.FileOperationError((0,p.localize)(7,null),3,i);return r}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,a,i,n);r(s)}catch(s){o(s)}})})}async u(t,a,i,n){const r=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,l.streamToBuffer)(r.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const r=new D.CancellationTokenSource(n),o=this.F(a,i).then(c=>c,c=>{throw r.cancel(),c});let s;try{return typeof i?.etag=="string"&&i.etag!==h.ETAG_DISABLED&&await o,i?.atomic&&(0,h.hasFileAtomicReadCapability)(t)||!((0,h.hasOpenReadWriteCloseCapability)(t)||(0,h.hasFileReadStreamCapability)(t))||(0,h.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,a,i):(0,h.hasFileReadStreamCapability)(t)?s=this.z(t,a,r.token,i):s=this.C(t,a,r.token,i),{...await o,value:s}}catch(c){throw s&&await(0,g.consumeStream)(s),this.w(c,a,i)}}w(t,a,i){const n=(0,p.localize)(8,null,this.nb(a),(0,h.ensureFileSystemProviderError)(t).toString());return t instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof h.TooLargeFileOperationError?new h.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new h.FileOperationError(n,(0,h.toFileOperationResult)(t),i)}z(t,a,i,n=Object.create(null)){const r=t.readFileStream(a,n,i);return(0,g.transform)(r,{data:o=>o instanceof l.VSBuffer?o:l.VSBuffer.wrap(o),error:o=>this.w(o,a,n)},o=>l.VSBuffer.concat(o))}C(t,a,i,n=Object.create(null)){const r=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,a,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,a,n)},i),r}D(t,a,i){const n=(0,g.newWriteableStream)(r=>l.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,h.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(a,r.byteLength,i),n.end(l.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new h.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==h.ETAG_DISABLED&&a.etag===i.etag)throw new h.NotModifiedSinceFileOperationError((0,p.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&a>i.limits.size&&(n=7),typeof n=="number")throw new h.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),n,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(r,t,o,a,i,n)}catch(r){return r}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),o=await this.I(n,t,r,a,"move",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,o==="move"?2:3,s)),s}async copy(t,a,i){const n=await this.k(t),r=this.lb(await this.l(a),a),o=await this.I(n,t,r,a,"copy",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,o==="copy"?3:2,s)),s}async I(t,a,i,n,r,o){if(a.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.M(t,a,i,n,r,o);if(s&&!c&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,h.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:o});else{const w=await this.resolve(a);w.isDirectory?await this.L(t,w,i,n):await this.J(t,a,i,n)}return r}else return t===i?(await t.rename(a,n,{overwrite:o}),r):(await this.I(t,a,i,n,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,h.hasOpenReadWriteCloseCapability)(t)&&(0,h.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,n);if((0,h.hasOpenReadWriteCloseCapability)(t)&&(0,h.hasReadWriteCapability)(i))return this.kb(t,a,i,n);if((0,h.hasReadWriteCapability)(t)&&(0,h.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,n);if((0,h.hasReadWriteCapability)(t)&&(0,h.hasReadWriteCapability)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await O.Promises.settled(a.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,a,i,n,r,o){let s=!1;if(t===i){const{providerExtUri:w,isPathCaseSensitive:E}=this.N(t);if(E||(s=w.isEqual(a,n)),s&&r==="copy")throw new Error((0,p.localize)(12,null,this.nb(a),this.nb(n)));if(!s&&w.isEqualOrParent(n,a))throw new Error((0,p.localize)(13,null,this.nb(a),this.nb(n)))}const c=await this.exists(n);if(c&&!s){if(!o)throw new h.FileOperationError((0,p.localize)(14,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:w}=this.N(t);if(w.isEqualOrParent(a,n))throw new Error((0,p.localize)(15,null,this.nb(a),this.nb(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}N(t){const a=this.O(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(((await t.stat(a)).type&h.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(a)));break}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(a)),a=n.dirname(a)}for(let r=i.length-1;r>=0;r--){a=n.joinPath(a,i[r]);try{await t.mkdir(a)}catch(o){if((0,h.toFileSystemProviderErrorCode)(o)!==h.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new h.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,r=!!a?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new h.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,h.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,h.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new v.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,v.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);n?(0,v.dispose)(o):r=()=>(0,v.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,a){const i=await this.j(t),n=(0,R.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,a)},this.U.set(n,r)),r.count+=1,(0,v.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,v.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,v.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,g.isReadableStream)(n)||(0,g.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,a,i){let n=0,r;if((0,g.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=l.VSBuffer.concat(i.buffer);await this.bb(t,a,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,s)=>{(0,g.listenStream)(r,{onData:async c=>{r.pause();try{await this.bb(t,a,c,c.byteLength,n,0)}catch(w){return s(w)}n+=c.byteLength,setTimeout(()=>r.resume())},onError:c=>s(c),onEnd:()=>o()})})}async ab(t,a,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,a,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,a,i,n,r,o){let s=0;for(;s<n;)s+=await t.write(a,r+s,i.buffer,o+s,n-s)}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let r;n instanceof l.VSBuffer?r=n:(0,g.isReadableStream)(n)?r=await(0,l.streamToBuffer)(n):(0,g.isReadableBufferedStream)(n)?r=await(0,l.bufferedStreamToBuffer)(n):r=(0,l.readableToBuffer)(n),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let r,o;try{r=await t.open(a,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const s=l.VSBuffer.alloc(this.a);let c=0,w=0,E=0;do E=await t.read(r,c,s.buffer,w,s.byteLength-w),await this.bb(i,o,s,E,c,w),c+=E,w+=E,w===s.byteLength&&(w=0);while(E>0)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await O.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(i,r,l.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,a,i,n){const r=await(0,l.streamToBuffer)(this.C(t,a,D.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new h.FileOperationError((0,p.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};b=ye([X(0,d.ILogService)],b),e.FileService=b}),define(se[216],re([0,1,53,299,6,38,17,3,48,2,13,4,24,43,27,171,14,103,214,39,209,208]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(A)}catch(a){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(a)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=R.Event.None,this.H=new D.ResourceMap(r=>m.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await g.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await g.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let s;o.isSymbolicLink()?s=(await this.stat((0,m.joinPath)(i,o.name))).type:s=this.G(o),r.push([o.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=h.FileType.Unknown:i.isFile()?r=h.FileType.File:i.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new l.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await g.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,f.newWriteableStream)(s=>k.VSBuffer.concat(s.map(c=>k.VSBuffer.wrap(c))).buffer);return(0,u.readFileIntoStream)(this,i,o,s=>s.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const s=this.C(i);if(!r.create||!r.overwrite){if(await g.Promises.exists(s)){if(!r.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,h.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let s;try{if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await g.SymlinkSupport.stat(r);w.mode&128||await g.Promises.chmod(r,w.mode|128)}catch(w){this.a.trace(w)}let c;if((0,h.isFileOpenForWriteOptions)(n)){if(S.isWindows)try{await g.Promises.truncate(r,0),c="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}c||(c="w")}else c="r";s=await g.Promises.open(r,c)}catch(c){throw o?.dispose(),(0,h.isFileOpenForWriteOptions)(n)?await this.Z(i,c):this.Y(c)}if(this.L.set(s,0),(0,h.isFileOpenForWriteOptions)(n)&&this.N.set(s,i),o){const c=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.M.set(s,o),c&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),c.dispose())}return s}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await g.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await g.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,s){const c=this.P(i,n);let w=null;try{w=(await g.Promises.read(i,r,o,s,c)).bytesRead}catch(E){throw this.Y(E)}finally{this.Q(i,c,w)}return w}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,s){return(0,l.retry)(()=>this.R(i,n,r,o,s),100,3)}async R(i,n,r,o,s){const c=this.P(i,n);let w=null;try{w=(await g.Promises.write(i,r,o,s,c)).bytesWritten}catch(E){throw await this.Z(this.N.get(i),E)}finally{this.Q(i,c,w)}return w}async mkdir(i){try{await g.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),s=this.C(n);if(o!==s)try{await this.S(i,n,"move",r.overwrite),await g.Promises.move(o,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,p.localize)(2,null,(0,I.basename)(o),(0,I.basename)((0,I.dirname)(s)),c.toString()))),this.Y(c)}}async copy(i,n,r){const o=this.C(i),s=this.C(n);if(o!==s)try{await this.S(i,n,"copy",r.overwrite),await g.Promises.copy(o,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,p.localize)(3,null,(0,I.basename)(o),(0,I.basename)((0,I.dirname)(s)),c.toString()))),this.Y(c)}}async S(i,n,r,o){const s=this.C(i),c=this.C(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,C.isEqual)(s,c,!0)),w&&r==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!w&&await g.Promises.exists(c)){if(!o)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),s=this.C(n),c=!!(this.capabilities&1024);if((0,C.isEqual)(o,s,!c))return;const w=new v.DisposableStore;try{const[E,L]=await Promise.all([this.I(i),this.I(n)]);w.add(E),w.add(L),r&&await g.Promises.mkdir((0,I.dirname)(s),{recursive:!0}),await g.Promises.copyFile(o,s)}catch(E){if(E.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(E)}finally{w.dispose()}}p(i,n,r){return new b.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new P.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof h.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await g.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(se[105],re([0,1,3,2,5,11]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let k=class extends O.Disposable{constructor(C){super(),this.b=C,this.a=this.B(new A.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};k=ye([X(0,D.ILogService)],k),e.SharedProcessLifecycleService=k}),define(se[106],re([0,1,10,3,11,2]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends l.AbstractLoggerService{constructor(S,m,f,g){super(m,f),this.l=S,this.m=g,this.B(g.listen("onDidChangeLogLevel",S)(p=>{(0,l.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(A.URI.revive(p[0]),p[1])})),this.B(g.listen("onDidChangeVisibility",S)(([p,h])=>super.setVisibility(A.URI.revive(p),h))),this.B(g.listen("onDidChangeLoggers",S)(({added:p,removed:h})=>{for(const u of p)super.registerLogger({...u,resource:A.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(S,m)=>{this.m.call("consoleLog",[S,m])}})}registerLogger(S){super.registerLogger(S),this.m.call("registerLogger",[S,this.l])}deregisterLogger(S){super.deregisterLogger(S),this.m.call("deregisterLogger",[S,this.l])}setLogLevel(S,m){super.setLogLevel(S,m),this.m.call("setLogLevel",[S,m])}setVisibility(S,m){super.setVisibility(S,m),this.m.call("setVisibility",[S,m])}k(S,m,f){return new R(this.m,S,m,f,this.l)}static setLogLevel(S,m,f){return S.call("setLogLevel",[m,f])}}e.LoggerChannelClient=k;class R extends l.AbstractMessageLogger{constructor(S,m,f,g,p){super(g?.logLevel==="always"),this.m=S,this.n=m,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[m,g,p]).then(()=>{this.r(this.l),this.k=!0})}g(S,m){const f=[[S,m]];this.k?this.r(f):this.l.push(...f)}r(S){this.m.call("log",[this.n,S])}}class C{constructor(S,m){this.a=S,this.b=m}listen(S,m){const f=this.b(S);switch(m){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,f)),removed:[...g.removed].map(p=>this.c(p,f))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,g=>[f.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,g=>(0,l.isLogLevel)(g)?g:[f.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${m}`)}async call(S,m,f){const g=this.b(S);switch(m){case"setLogLevel":return(0,l.isLogLevel)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(A.URI.revive(g.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${m}`)}c(S,m){return{...S,resource:m.transformOutgoingURI(S.resource)}}}e.LoggerChannel=C;class v extends D.Disposable{constructor(S,m){super(),m.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(f=>m.call("setLogLevel",[f]))),m.call("getRegisteredLoggers").then(f=>{for(const g of f)S.registerLogger({...g,resource:A.URI.revive(g.resource)})}),this.B(m.listen("onDidChangeVisibility")(([f,g])=>S.setVisibility(A.URI.revive(f),g))),this.B(m.listen("onDidChangeLoggers")(({added:f,removed:g})=>{for(const p of f)S.registerLogger({...p,resource:A.URI.revive(p.resource)});for(const p of g)S.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=v}),define(se[217],re([0,1,2,11]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends A.Disposable{constructor(k,R=[]){super(),this.a=new O.MultiplexLogger([k,...R]),this.B(k.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...R){this.a.trace(k,...R)}debug(k,...R){this.a.debug(k,...R)}info(k,...R){this.a.info(k,...R)}warn(k,...R){this.a.warn(k,...R)}error(k,...R){this.a.error(k,...R)}flush(){this.a.flush()}}e.LogService=l}),define(se[57],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,A.createDecorator)("nativeHostService")}),define(se[58],re([0,1,3,63,2,5]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class k extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(v){const I=Object.keys(this.f).length;return this.f={...v,...this.f},I!==Object.keys(this.f).length&&await this.i(v),O.Iterable.reduce(this.g.entries(),(S,[m,f])=>({...S,[m]:f}),{})}getPolicyValue(v){return this.g.get(v)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(v,[I,S])=>({...v,[I]:{definition:S,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=k;class R{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(se[218],re([0,1,3,2,58]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class D{constructor(C){this.b=C,this.a=new O.DisposableStore}listen(C,v){switch(v){case"onDidChange":return A.Event.map(this.b.onDidChange,I=>I.reduce((S,m)=>({...S,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${v}`)}call(C,v,I){switch(v){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${v}`)}dispose(){this.a.dispose()}}e.PolicyChannel=D;class k extends l.AbstractPolicyService{constructor(C,v){super(),this.a=v;for(const I in C){const{definition:S,value:m}=C[I];this.f[I]=S,m!==void 0&&this.g.set(I,m)}this.a.listen("onDidChange")(I=>{for(const S in I){const m=I[S];m===null?this.g.delete(S):this.g.set(S,m)}this.h.fire(Object.keys(I))})}async i(C){const v=await this.a.call("updatePolicyDefinitions",C);for(const I in v)this.g.set(I,v[I])}}e.PolicyChannelClient=k}),define(se[107],re([0,1,4,36]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.context<"u"){const D=A.globals.vscode.context.configuration();if(D)l=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:D.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(se[25],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,A.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(se[219],re([0,1,6,7,2,13,27,11,25]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let v=class extends l.Disposable{constructor(S,m,f){super(),this.b=m,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new A.RunOnceScheduler(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),f=(0,D.dirname)(S),g=(0,D.basename)(S),p=await k.Promises.readdir(f);await Promise.all(p.map(async h=>{if(h===g)return;const u=(0,D.join)(f,h),d=await k.Promises.stat(u);if(d.isDirectory()&&m-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${h}.`),k.Promises.rm(u)}))}catch(m){(0,O.onUnexpectedError)(m)}}};v=ye([X(1,C.IProductService),X(2,R.ILogService)],v),e.CodeCacheCleaner=v}),define(se[220],re([0,1,6,7,2,13,27,15,11,25]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends l.Disposable{constructor(m,f,g){super(),this.b=m,this.c=f,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new A.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),f=JSON.parse(await k.Promises.readFile((0,D.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(f)){const y=f[d];m[`${y.hash}.${d}`]=!0}const g=(0,D.join)(this.b.userDataPath,"clp");if(!await k.Promises.exists(g))return;const h=await k.Promises.readdir(g);for(const d of h){if(m[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await k.Promises.rm((0,D.join)(g,d))}const u=Date.now();for(const d of Object.keys(m)){const y=(0,D.join)(g,d),b=await k.Promises.readdir(y);for(const P of b){if(P==="tcf.json")continue;const t=(0,D.join)(y,P),a=await k.Promises.stat(t);a.isDirectory()&&u-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,D.join)(d,P)}`),await k.Promises.rm(t))}}}catch(m){(0,O.onUnexpectedError)(m)}}};I=ye([X(0,R.INativeEnvironmentService),X(1,C.ILogService),X(2,v.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(se[221],re([0,1,18,2,24,196,14,25]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends O.Disposable{constructor(I,S){super(),this.b=I,this.c=S,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(I){return this.f(I)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(I){const S=[];for(const[m,f]of this.a)if(!(f.configScheme&&f.configScheme!==I.scheme))try{const g=await this.b.readFile((0,l.joinPath)(I,m)),p=new Map;Object.entries(f.recommendations).forEach(([u,d])=>{if((0,A.isNonEmptyArray)(d.remotes))for(const y of d.remotes)p.set(y,{extensionId:u,extensionName:d.name,configName:f.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else S.push({extensionId:u,extensionName:d.name,configName:f.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const h=(0,D.getDomainsOfRemotes)(g.value.toString(),[...p.keys()]);for(const u of h){const d=p.get(u);d&&S.push(d)}}catch{}return S}};C=ye([X(0,k.IFileService),X(1,R.IProductService)],C),e.ExtensionTipsService=C}),define(se[222],re([0,1,13,5]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var l;(function(D){function k(C){return Boolean(C.samples&&C.timeDeltas)}D.isValidProfile=k;function R(C,v="noAbsolutePaths"){for(const I of C.nodes)I.callFrame&&I.callFrame.url&&((0,A.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,A.join)(v,(0,A.basename)(I.callFrame.url)));return C}D.rewriteAbsolutePaths=R})(l=e.Utils||(e.Utils={}))}),define(se[223],re([0,1,31]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this.a=new Map}async startProfiling(D){const R=await(await new Promise((v,I)=>{_(["v8-inspect-profiler"],v,I)})).startProfiling({port:D.port,checkForPaused:!0}),C=(0,A.generateUuid)();return this.a.set(C,R),C}async stopProfiling(D){const k=this.a.get(D);if(!k)throw new Error(`UNKNOWN session '${D}'`);const R=await k.stop();return this.a.delete(D),R.profile}}e.InspectProfilingService=O}),define(se[40],re([0,1,129,12]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(k,R){A.ok(O.isString(k)),A.ok(O.isObject(R)),A.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,R)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new l}),define(se[108],re([0,1,3,40]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class D{constructor(){this.b=new A.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,v){this.a[l(C)]=v,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const k=new D;O.Registry.add(e.Extensions.JSONContribution,k)}),define(se[45],re([0,1,18,3,12,157,16,108,40]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=C.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s=this.a.get(o),c=s?.valuesSources??new Map;if(r)for(const T of Object.keys(n[o]))c.set(T,r);const w={...s?.value||{},...n[o]};this.a.set(o,{source:r,value:w,valuesSources:c});const E=(0,k.getLanguageTagSettingPlainKey)(o),L={type:"object",default:w,description:D.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:l.isString(r)?void 0:r,defaultValueSource:r};i.push(...p(o)),this.d[o]=L,this.b.properties[o]=L}else{this.a.set(o,{value:n[o],source:r});const s=this.d[o];s&&(this.w(o,s),this.r(o,s))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),s=l.isString(n)?n:n?.id,c=l.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const w=this.d[r];w&&(this.w(r,w),this.r(r,w))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const r in n.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,i,n,r=3,o){r=l.isUndefinedOrNull(t.scope)?r:t.scope;const s=t.properties;if(s)for(const w in s){const E=s[w];if(a&&y(w,E)){delete s[w];continue}if(E.source=i,E.defaultDefaultValue=s[w].default,this.w(w,E),e.OVERRIDE_PROPERTY_REGEX.test(w)?E.scope=void 0:(E.scope=l.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=l.isUndefinedOrNull(E.restricted)?!!n?.includes(w):E.restricted),s[w].hasOwnProperty("included")&&!s[w].included){this.f[w]=s[w],delete s[w];continue}else this.d[w]=s[w],s[w].policy?.name&&this.e.set(s[w].policy.name,w);!s[w].deprecationMessage&&s[w].markdownDeprecationMessage&&(s[w].deprecationMessage=s[w].markdownDeprecationMessage),o.add(w)}const c=t.allOf;if(c)for(const w of c)this.p(w,a,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,r=i?.source;l.isUndefined(n)&&(n=a.defaultDefaultValue,r=void 0),l.isUndefined(n)&&(n=u(a.type)),a.default=n,a.defaultValueSource=r}}const f="\\[([^\\]]+)\\]",g=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(P){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(P)){let a=g.exec(P);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=g.exec(P)}}return(0,A.distinct)(t)}e.overrideIdentifiersFromKey=p;function h(P){return P.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=h;function u(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new m;C.Registry.add(e.Extensions.Configuration,d);function y(P,t){return P.trim()?e.OVERRIDE_PROPERTY_REGEX.test(P)?D.localize(7,null,P):d.getConfigurationProperties()[P]!==void 0?D.localize(8,null,P):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,P,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=y;function b(){const P=[],t=d.getConfigurationProperties();for(const a of Object.keys(t))P.push([a,t[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=b}),define(se[73],re([0,1,18,3,35,2,38,32,12,10,16,45,40]),function(_,e,A,O,l,D,k,R,C,v,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:R.deepFreeze(a)}class g{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof g)return n;const r=new p("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,s=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:s}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,I.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return A.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return A.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=R.deepClone(this.contents),r=R.deepClone(this.overrides),o=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const c of i)if(s.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(n,c.contents);for(const w of c.overrides){const[E]=r.filter(L=>A.equals(L.identifiers,w.identifiers));E?(this.h(E.contents,w.contents),E.keys.push(...w.keys),E.keys=A.distinct(E.keys)):r.push(R.deepClone(w))}for(const w of c.keys)o.indexOf(w)===-1&&o.push(w)}return new g(n,o,r,s.every(c=>c instanceof g)?void 0:s)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[o];const c=n[o];c&&(typeof s=="object"&&typeof c=="object"?(s=R.deepClone(s),this.h(s,c)):s=c),r[o]=s}return new g(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&C.isObject(i[r])&&C.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=R.deepClone(n[r])}}i(i){let n=null,r=null;const o=s=>{s&&(r?this.h(r,s):r=R.deepClone(s))};for(const s of this.overrides)A.equals(s.identifiers,[i])?n=s.contents:s.identifiers.includes(i)&&o(s.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>A.equals(r.identifiers,(0,S.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,I.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),S.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,I.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=g;class p{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!C.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:s,restricted:c,hasExcludedProperties:w}=this.h(i,n);this.b=new g(r,o,s,w?[i]:void 0),this.c=c||[]}g(i){let n={},r=null,o=[];const s=[],c=[];function w(L){Array.isArray(o)?o.push(L):r!==null&&(o[r]=L)}const E={onObjectBegin:()=>{const L={};w(L),s.push(o),o=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const L=[];w(L),s.push(o),o=L,r=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:w,onError:(L,T,F)=>{c.push({error:L,offset:T,length:F})}};if(i)try{l.visit(i,E),n=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(i,n){const r=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const s=(0,I.toValuesTree)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),c=Object.keys(i),w=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:s,keys:c,overrides:w,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let s=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const c={},w=[];for(const E in i)if(S.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const L=this.i(i[E],n,!1,o);c[E]=L.raw,s=s||L.hasExcludedProperties,w.push(...L.restricted)}else{const L=n[E],T=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&w.push(E),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&!(o.skipRestricted&&L?.restricted)?c[E]=i[E]:s=!0}return{raw:c,restricted:w,hasExcludedProperties:s}}j(i,n){const r=[];for(const o of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(o)){const s={};for(const c in i[o])s[c]=i[o][c];r.push({identifiers:(0,S.overrideIdentifiersFromKey)(o),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,n)})}return r}}e.ConfigurationModelParser=p;class h extends D.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=h;class u{constructor(i,n,r,o,s,c,w,E,L,T,F,z,J){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=s,this.f=c,this.g=w,this.h=E,this.i=L,this.j=T,this.k=F,this.l=z,this.m=J}get value(){return f(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(i,n,r,o,s=new g,c=new g,w=new k.ResourceMap,E=new g,L=new k.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=s,this.i=c,this.j=w,this.l=E,this.m=L,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new g,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),s=this.u(n.resource,r),c=n.resource?this.m.get(n.resource)||this.l:this.l,w=new Set;for(const E of o.overrides)for(const L of E.identifiers)o.getOverrideValue(i,L)!==void 0&&w.add(L);return new u(i,n,o.getValue(i),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,s||void 0,c)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:s,removed:c}=P(this.c,i);n=[...o,...s,...c]}for(const o of n)for(const s of(0,S.overrideIdentifiersFromKey)(o)){const c=this.c.getKeysForOverrideIdentifier(s),w=i.getKeysForOverrideIdentifier(s),E=[...w.filter(L=>c.indexOf(L)===-1),...c.filter(L=>w.indexOf(L)===-1),...c.filter(L=>!R.equals(this.c.override(s).getValue(L),i.override(s).getValue(L)))];r.push([s,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=P(this.d,i),s=[...n,...r,...o];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=P(this.applicationConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=P(this.localUserConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=P(this.remoteUserConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=P(this.workspaceConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:s,removed:c,overrides:w}=P(r,n),E=[...o,...s,...c];return(E.length||!r)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:w}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:s,overrides:c}=P(n,void 0);return{keys:[...r,...o,...s],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const s=this.m.get(i);s&&(r=r.merge(s))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:s}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),s=this.x(i.user),c=this.x(i.workspace),w=i.folders.reduce((E,L)=>(E.set(v.URI.revive(L[0]),this.x(L[1])),E),new k.ResourceMap);return new d(n,r,o,s,new g,c,w,new g,new k.ResourceMap)}static x(i){return new g(i.contents,i.keys,i.overrides)}}e.Configuration=d;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const o of a)o.keys.forEach(s=>i.add(s)),o.overrides.forEach(([s,c])=>{const w=(0,k.getOrSet)(n,s,new Set);c.forEach(E=>w.add(E))});const r=[];return n.forEach((o,s)=>r.push([s,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=y;class b{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const c of s)this.affectedKeys.add(c);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const s=o+r.length;if(s>=this.d.length)return!1;const c=this.d.charCodeAt(s);if(c!==this.b&&c!==this.c)return!1;if(n){const w=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!R.equals(w,E)}return!0}}e.ConfigurationChangeEvent=b;function P(a,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,a?.rawConfiguration),s=[],c=a?.getAllOverrideIdentifiers()||[],w=i?.getAllOverrideIdentifiers()||[];if(i){const E=w.filter(L=>!c.includes(L));for(const L of E)s.push([L,i.getKeysForOverrideIdentifier(L)])}if(a){const E=c.filter(L=>!w.includes(L));for(const L of E)s.push([L,a.getKeysForOverrideIdentifier(L)])}if(i&&a){for(const E of c)if(w.includes(E)){const L=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});s.push([E,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:r,updated:o,overrides:s}}function t(a,i){const n=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],r=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],o=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const c=(0,I.getConfigurationValue)(i.contents,s),w=(0,I.getConfigurationValue)(a.contents,s);R.equals(c,w)||o.push(s)}}return{added:n,removed:r,updated:o}}}),define(se[224],re([0,1,18,3,2,32,12,73,45,11,58,40]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:u})=>this.c(Array.from(h),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(h,u){this.h(h,S.Registry.as(C.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:h})}f(){return{}}g(){this.b=new R.ConfigurationModel;const h=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(h),h)}h(h,u){const d=this.f();for(const y of h){const b=d[y],P=u[y];b!==void 0?this.b.addValue(y,b):P?this.b.addValue(y,P.default):this.b.removeValue(y)}}}e.DefaultConfiguration=m;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let g=class extends l.Disposable{get configurationModel(){return this.b}constructor(h,u,d){super(),this.c=h,this.f=u,this.g=d,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(h=>this.i(h))),this.B(this.c.onDidChangeConfiguration(async({properties:h})=>this.j(await this.h(h),!0))),this.b}async h(h){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",h);const u={},d=[],y=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const b of h){const P=y[b];if(!P){d.push(b);continue}if(P.policy){if(P.type!=="string"&&P.type!=="number"){this.g.warn(`Policy ${P.policy.name} has unsupported type ${P.type}`);continue}d.push(b),u[P.policy.name]={type:P.type}}}return(0,k.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),d}i(h){this.g.trace("PolicyConfiguration#onDidChangePolicies",h);const u=S.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),d=(0,A.coalesce)(h.map(y=>u.get(y)));this.j(d,!0)}j(h,u){this.g.trace("PolicyConfiguration#update",h);const d=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),y=[],b=this.b.isEmpty();for(const P of h){const t=d[P]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(b?a!==void 0:!(0,D.equals)(this.b.getValue(P),a))&&y.push([P,a])}else this.b.getValue(P)!==void 0&&y.push([P,void 0])}if(y.length){this.g.trace("PolicyConfiguration#changed",y);const P=this.b;this.b=new R.ConfigurationModel;for(const t of P.keys)this.b.setValue(t,P.getValue(t));for(const[t,a]of y)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};g=ye([X(1,I.IPolicyService),X(2,v.ILogService)],g),e.PolicyConfiguration=g}),define(se[225],re([0,1,6,3,2,24,16,73,224,58]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends l.Disposable{constructor(m,f,g,p){super(),this.i=m,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.DefaultConfiguration),this.c=g instanceof v.NullPolicyService?new C.NullPolicyConfiguration:this.B(new C.PolicyConfiguration(this.b,g,p)),this.f=this.B(new R.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,f)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new A.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:u})=>this.k(h,u))),this.B(this.c.onDidChangeConfiguration(h=>this.l(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,f,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(m,f,new R.ConfigurationModel,g)}getConfigurationData(){return this.a.toData()}getValue(m,f){const g=typeof m=="string"?m:void 0,p=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(f)?f:{};return this.a.getValue(g,p,void 0)}updateValue(m,f,g,p){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const f=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(g,f,2)}k(m,f){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(m,f);this.m(p,g,7)}l(m){const f=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(m);this.m(g,f,7)}m(m,f,g){const p=new R.ConfigurationChangeEvent(m,{data:f},this.a);p.source=g,p.sourceConfig=this.n(g),this.h.fire(p)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(se[226],re([0,1,7,5]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends A.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof D&&C._code===l.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof D&&C._code===l.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof D&&C._code===l.NoResolverFound}static isHandled(C){return C instanceof D&&C.isHandled}constructor(C,v=l.Unknown,I){super(C),this._message=C,this._code=v,this._detail=I,this.isHandled=v===l.NotAvailable&&I===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function k(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.getRemoteAuthorityPrefix=k}),define(se[74],re([0,1,21]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(v){return v.scheme===A.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=O;function l(v){if(!v)return;const I=v.indexOf("+");return I<0?v:v.substr(0,I)}e.getRemoteName=l;function D(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=D;function k(v){const{host:I,port:S}=C(v);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:S}}e.parseAuthorityWithPort=k;function R(v,I){let{host:S,port:m}=C(v);return typeof m>"u"&&(m=I),{host:S,port:m}}e.parseAuthorityWithOptionalPort=R;function C(v){const I=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const S=v.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=v.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:v,port:void 0}}}),define(se[46],re([0,1,26,5,74]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,p){if(typeof g>"u"||g===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof g=="string"||typeof p=="string"){const h=typeof g=="string"?g:g.value,u=typeof p=="string"?p:p.value;return A.equalsIgnoreCase(h,u)}return g.c===p.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=C;function v(f){return I(f)}e.isApplicationScopedExtension=v;function I(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function S(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function m(f,g){if(g){const p=`onResolveRemoteAuthority:${(0,l.getRemoteName)(g)}`;return!!f.activationEvents?.includes(p)}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(se[227],re([0,1,2,13,27,46]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends A.Disposable{constructor(C,v){super(),this.b=C,this.a=(0,O.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(v.onDidInstallExtensions(I=>this.c(I))),this.B(v.onDidUninstallExtension(I=>this.f(I)))}c(C){C.some(v=>!!v.local)&&this.invalidate()}f(C){C.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(se[228],re([0,1,6,17,23,7,3,2,104,89,31,96,226,74]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var p;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function h(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(M){const $=new l.CancellationTokenSource;return setTimeout(()=>$.cancel(),M),$.token}function d(M,$){if(M.isCancellationRequested||$.isCancellationRequested)return l.CancellationToken.Cancelled;const H=new l.CancellationTokenSource;return M.onCancellationRequested(()=>H.cancel()),$.onCancellationRequested(()=>H.cancel()),H.token}class y{get didTimeout(){return this.c==="timedout"}constructor($){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((H,ee)=>{this.f=H,this.g=ee}),$.isCancellationRequested?this.h():this.d.add($.onCancellationRequested(()=>this.h()))}registerDisposable($){this.c==="pending"?this.d.add($):$.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f($))}reject($){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g($))}}function b(M,$){const H=new y($);return H.registerDisposable(M.onControlMessage(ee=>{const G=JSON.parse(ee.toString()),Z=K(G);Z?H.reject(Z):H.resolve(G)})),H.promise}function P(M,$,H,ee,G,Z,te,le,he){const me=new y(he),pe=v.StopWatch.create(!1);return M.info(`Creating a socket (${le})...`),C.mark(`code/willCreateSocket/${te}`),$.connect(H,ee,G,Z,le,(Se,Ce)=>{me.didTimeout?(C.mark(`code/didCreateSocketError/${te}`),M.info(`Creating a socket (${le}) finished after ${pe.elapsed()} ms, but this is too late and has timed out already.`),Se&&M.error(Se),Ce?.dispose()):Se||!Ce?(C.mark(`code/didCreateSocketError/${te}`),M.info(`Creating a socket (${le}) returned an error after ${pe.elapsed()} ms.`),me.reject(Se)):(C.mark(`code/didCreateSocketOK/${te}`),M.info(`Creating a socket (${le}) was successful after ${pe.elapsed()} ms.`),me.resolve(Ce))}),me.promise}function t(M,$){const H=new y($);return M.then(ee=>{H.didTimeout||H.resolve(ee)},ee=>{H.didTimeout||H.reject(ee)}),H.promise}async function a(M,$,H,ee){const G=V(M,$);M.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await P(M.logService,M.socketFactory,M.host,M.port,(0,f.getRemoteServerRootPath)(M),`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,h($),`renderer-${h($)}-${M.reconnectionToken}`,ee)}catch(pe){throw M.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),M.logService.error(pe),pe}M.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let te,le;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(Z,null),te=M.reconnectionProtocol,le=!1):(te=new S.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),le=!0),M.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const he=await t(M.signService.createNewMessage((0,I.generateUuid)()),ee),me={type:"auth",auth:M.connectionToken||"00000000000000000000",data:he.data};te.sendControl(O.VSBuffer.fromString(JSON.stringify(me)));try{const pe=await b(te,d(ee,u(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(M.logService.trace(`${G} 4/6. received SignRequest control message.`),!await t(M.signService.validate(he,pe.signedData),ee)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await t(M.signService.sign(pe.data),ee),De={type:"connectionType",commit:M.commit,signedData:Ce,desiredConnectionType:$};return H&&(De.args=H),M.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(O.VSBuffer.fromString(JSON.stringify(De))),{protocol:te,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(M.logService.error(`${G} the handshake timed out. Error:`),M.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${G} received error control message when negotiating connection. Error:`),M.logService.error(pe)),le&&U(te),pe}}async function i(M,$,H,ee){const G=Date.now(),Z=V(M,$),{protocol:te,ownsProtocol:le}=await a(M,$,H,ee),he=new y(ee);return he.registerDisposable(te.onControlMessage(me=>{const pe=JSON.parse(me.toString()),Se=K(pe);Se?(M.logService.error(`${Z} received error control message when negotiating connection. Error:`),M.logService.error(Se),le&&U(te),he.reject(Se)):(M.reconnectionProtocol?.endAcceptReconnection(),M.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${j(G)}!`),he.resolve({protocol:te,firstMessage:pe}))})),he.promise}async function n(M,$){const{protocol:H}=await i(M,1,void 0,$);return{protocol:H}}async function r(M,$,H){const{protocol:ee,firstMessage:G}=await i(M,2,$,H),Z=G&&G.debugPort;return{protocol:ee,debugPort:Z}}async function o(M,$,H){const ee=Date.now(),G=V(M,3),{protocol:Z}=await a(M,3,$,H);return M.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${j(ee)}!`),Z}async function s(M,$,H){const{host:ee,port:G,connectionToken:Z}=await M.addressProvider.getAddress();return{commit:M.commit,quality:M.quality,host:ee,port:G,connectionToken:Z,reconnectionToken:$,reconnectionProtocol:H,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function c(M,$,H){return E(M,async ee=>{const{protocol:G}=await n(ee,l.CancellationToken.None);return new q(M,$,H,ee.reconnectionToken,G)})}e.connectRemoteAgentManagement=c;async function w(M,$){return E(M,async H=>{const{protocol:ee,debugPort:G}=await r(H,$,l.CancellationToken.None);return new x(M,$,H.reconnectionToken,ee,G)})}e.connectRemoteAgentExtensionHost=w;async function E(M,$){for(let ee=1;;ee++)try{const G=(0,I.generateUuid)(),Z=await s(M,G,null);return await $(Z)}catch(G){if(ee<5)M.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),M.logService.error(G);else throw M.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),M.logService.error(G),ie.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(G)),G}}async function L(M,$,H){const ee=await s(M,(0,I.generateUuid)(),null);return await o(ee,{host:$,port:H},l.CancellationToken.None)}e.connectRemoteAgentTunnel=L;function T(M){return(0,A.createCancelablePromise)($=>new Promise((H,ee)=>{const G=setTimeout(H,M*1e3);$.onCancellationRequested(()=>{clearTimeout(G),H()})}))}var F;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain",M[M.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class z{constructor($,H){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.type=0}}e.ConnectionLostEvent=z;class J{constructor($,H,ee,G){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.durationSeconds=ee,this.c=G,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=J;class Y{constructor($,H,ee){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.attempt=ee,this.type=2}}e.ReconnectionRunningEvent=Y;class W{constructor($,H,ee){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.attempt=ee,this.type=4}}e.ConnectionGainEvent=W;class N{constructor($,H){this.reconnectionToken=$,this.connectionHealth=H,this.type=5}}e.ConnectionHealthChangedEvent=N;class B{constructor($,H,ee,G){this.reconnectionToken=$,this.millisSinceLastIncomingData=H,this.attempt=ee,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class ie extends R.Disposable{static triggerPermanentFailure($,H,ee){this._permanentFailure=!0,this.f=$,this.g=H,this.h=ee,this.i.forEach(G=>G.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach($=>$.s())}static debugPauseSocketWriting(){this.i.forEach($=>$.w())}get k(){return this.c||ie._permanentFailure}constructor($,H,ee,G,Z){super(),this.n=$,this.p=H,this.reconnectionToken=ee,this.protocol=G,this.r=Z,this.j=this.B(new k.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new W(this.reconnectionToken,0,0)),this.B(G.onSocketClose(te=>{const le=ae(this.n,this.reconnectionToken,!0);te?te.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${te.hadError}).`),te.error&&this.p.logService.error(te.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.p.logService.error(te.event)):this.p.logService.info(`${le} received socket close event.`),this.s()})),this.B(G.onSocketTimeout(te=>{const le=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(G.onHighRoundTripTime(te=>{const le=oe(this.n,this.reconnectionToken);this.p.logService.info(`${le} high roundtrip time: ${te.roundTripTime}ms (${te.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(G.onDidChangeConnectionHealth(te=>{this.j.fire(new N(this.reconnectionToken,te))})),ie.i.push(this),this.B((0,R.toDisposable)(()=>{const te=ie.i.indexOf(this);te>=0&&ie.i.splice(te,1)})),this.k&&this.v(ie.f,ie.g,ie.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const $=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const H=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const G=ee<H.length?H[ee]:H[H.length-1];try{if(G>0){const te=T(G);this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,te)),this.p.logService.info(`${$} waiting for ${G} seconds before reconnecting...`);try{await te}catch{}}if(this.k){this.p.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.p.logService.info(`${$} resolving connection...`);const Z=await s(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${$} connecting to ${Z.host}:${Z.port}...`),await this.y(Z,u(g)),this.p.logService.info(`${$} reconnected!`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.p.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this.p.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.p.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((0,D.isCancellationError)(Z)){this.p.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if(Z instanceof m.RemoteAuthorityResolverError){this.p.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,m.RemoteAuthorityResolverError.isHandled(Z));break}this.p.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.k&&!this.m)}u($,H,ee){this.r?ie.triggerPermanentFailure($,H,ee):this.v($,H,ee)}v($,H,ee){this.j.fire(new B(this.reconnectionToken,$,H,ee)),U(this.protocol)}w(){this.protocol.pauseSocketWriting()}}ie._permanentFailure=!1,ie.f=0,ie.g=0,ie.h=!1,ie.i=[],e.PersistentConnection=ie;class q extends ie{constructor($,H,ee,G,Z){super(1,$,G,Z,!0),this.client=this.B(new S.Client(Z,{remoteAuthority:H,clientId:ee},$.ipcLogger))}async y($,H){await n($,H)}}e.ManagementPersistentConnection=q;class x extends ie{constructor($,H,ee,G,Z){super(2,$,ee,G,!1),this.z=H,this.debugPort=Z}async y($,H){await r($,this.z,H)}}e.ExtensionHostPersistentConnection=x;function U(M){try{M.acceptDisconnect();const $=M.getSocket();M.dispose(),$.dispose()}catch($){(0,D.onUnexpectedError)($)}}function K(M){if(M&&M.type==="error"){const $=new Error(`Connection error: ${M.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function Q(M,$){for(;M.length<$;)M+=" ";return M}function oe(M,$){return`[remote-connection][${Q(h(M),13)}][${$.substr(0,5)}\u2026]`}function ae(M,$,H){return`${oe(M,$)}[${H?"reconnect":"initial"}]`}function V(M,$){return`${ae($,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function j(M){return`${Date.now()-M} ms`}}),define(se[229],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,A.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(se[230],re([0,1,86,155]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,D,k,R,C,v){const I=m=>v(m,void 0),S=A.createConnection({host:l,port:D},()=>{S.removeListener("error",I);const m=Buffer.alloc(16);for(let h=0;h<16;h++)m[h]=Math.round(Math.random()*256);const f=m.toString("base64"),g=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${D}${k}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];S.write(g.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",p),v(void 0,new O.NodeSocket(S,C)))};S.on("data",p)});S.setNoDelay(!0),S.once("error",I)}}}),define(se[109],re([0,1,5,173]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,A.createDecorator)("IRemoteTunnelService");var l;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=k=>({type:"connected",info:k}),D.connecting=k=>({type:"connecting",progress:k})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,O.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(se[231],re([0,1,138,16,11]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let D=class{constructor(R,C){this.a=R,this.b=C}async request(R,C){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const v=await(0,A.request)(R,C);return this.b.trace("RequestService#request (browser) - success",R.url),v}catch(v){throw this.b.error("RequestService#request (browser) - error",R.url,v),v}}async resolveProxy(R){}};D=ye([X(0,O.IConfigurationService),X(1,l.ILogService)],D),e.RequestService=D}),define(se[59],re([0,1,17,175,45,5,40]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function R(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=R;function C(p){return p.res.statusCode===204}async function v(p){return C(p)?null:(await(0,A.streamToBuffer)(p.stream)).toString()}e.asText=v;async function I(p){if(!R(p))throw new Error("Server returned "+p.res.statusCode);return v(p)}e.asTextOrError=I;async function S(p){if(!R(p))throw new Error("Server returned "+p.res.statusCode);if(C(p))return null;const u=(await(0,A.streamToBuffer)(p.stream)).toString();try{return JSON.parse(u)}catch(d){throw d.message+=`:
`+u,d}}e.asJson=S;function m(p){g(p)}e.updateProxyConfigurationsScope=m;let f;function g(p){const h=k.Registry.as(l.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[f],remove:u?[u]:[]})}g(2)}),define(se[232],re([0,1,23,21,14,59]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(C,v){this.a=C,this.b=v}async download(C,v,I=A.CancellationToken.None){if(C.scheme===O.Schemas.file||C.scheme===O.Schemas.vscodeRemote){await this.b.copy(C,v);return}const S={type:"GET",url:C.toString(!0)},m=await this.a.request(S,I);if(m.res.statusCode===200)await this.b.writeFile(v,m.stream);else{const f=await(0,D.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};k=ye([X(0,D.IRequestService),X(1,l.IFileService)],k),e.DownloadService=k}),define(se[233],re([0,1,17,23]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(R){this.a=R}listen(R,C){throw new Error("Invalid listen")}call(R,C,v,I=O.CancellationToken.None){switch(C){case"request":return this.a.request(v[0],I).then(async({res:S,stream:m})=>{const f=await(0,A.streamToBuffer)(m);return[{statusCode:S.statusCode,headers:S.headers},f]});case"resolveProxy":return this.a.resolveProxy(v[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class D{constructor(R){this.a=R}async request(R,C){const[v,I]=await this.a.call("request",[R],C);return{res:v,stream:(0,A.bufferToStream)(I)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=D}),define(se[234],re([0,1,12,231,233]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class D{constructor(R,C,v){this.c=C,this.d=v,this.a=new O.RequestService(C,v),this.b=new l.RequestChannelClient(R.getChannel("request"))}request(R,C){return this.e().request(R,C)}async resolveProxy(R){return this.e().resolveProxy(R)}e(){return this.f()?(this.d.trace("Using main request service"),this.b):(this.d.trace("Using browser request service"),this.a)}f(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,A.isBoolean)(R)?R:!0}}e.SharedProcessRequestService=D}),define(se[110],re([0,1,65,5]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(D){return(0,A.hash)({moduleId:D.process.moduleId,windowId:D.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,O.createDecorator)("sharedProcessWorkerService")}),define(se[235],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var A;(function(O){O.Spawn="vscode:shared-process->shared-process-worker=spawn",O.Terminate="vscode:shared-process->shared-process-worker=terminate",O.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",O.Ready="vscode:shared-process-worker->shared-process=ready",O.Ack="vscode:shared-process-worker->shared-process=ack",O.Trace="vscode:shared-process-worker->shared-process=trace",O.Info="vscode:shared-process-worker->shared-process=info",O.Warn="vscode:shared-process-worker->shared-process=warn",O.Error="vscode:shared-process-worker->shared-process=error"})(A=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(se[236],re([0,1,153,6,23,3,2,21,31,11,110,235]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(p){this.d=p,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(p){const h=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${h})`);const u=(0,I.hash)(p);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${h})`),this.f(p));const d=new l.CancellationTokenSource;let y,b,P;this.b.set(u,n=>{d.dispose(!0),y?.terminate(p,l.CancellationToken.None),b?.close(),P?.close(),this.b.delete(u);const r=this.c.get(u);r&&(this.c.delete(u),r({reason:n}))}),y=await this.e(p);const t=new Promise(n=>{this.c.set(u,n)});if(d.token.isCancellationRequested)return t;const{port1:a,port2:i}=new MessageChannel;return b=a,P=i,await y.spawn(p,P,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${h})`),A.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[b])),t}e(p){let h=this.a.get(p.process.moduleId);if(!h){this.d.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const u=new f(p.process.type,this.d);h=u.init(),u.onDidProcessSelfTerminate(({configuration:d,reason:y})=>{this.f(d,y)}),this.a.set(p.process.moduleId,h)}return h}async disposeWorker(p){return this.f(p)}f(p,h){const u=this.b.get((0,I.hash)(p));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),u(h))}};m=ye([X(0,v.ILogService)],m),e.SharedProcessWorkerService=m;class f extends k.Disposable{constructor(p,h){super(),this.f=p,this.g=h,this.a=this.B(new D.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const p=new O.DeferredPromise,h=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return h.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},h.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},h.onmessage=u=>{const{id:d,message:y,configuration:b,nonce:P}=u.data;switch(d){case S.SharedProcessWorkerMessages.Ready:p.complete(h);break;case S.SharedProcessWorkerMessages.Ack:if(P){const t=this.c.get(P);t&&(this.c.delete(P),t())}break;case S.SharedProcessWorkerMessages.SelfTerminated:b&&y&&this.a.fire({configuration:b,reason:JSON.parse(y)});break;case S.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,y);break;case S.SharedProcessWorkerMessages.Info:y&&this.g.info(y);break;case S.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,y);break;case S.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,y);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},h.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async i(p,h,u){const d=await this.b;if(!h.isCancellationRequested)return new Promise(y=>{const b=(0,C.generateUuid)();this.c.set(b,y);const P={...p,nonce:b};u?d.postMessage(P,[u]):d.postMessage(P),h.onCancellationRequested(()=>{this.c.delete(b)&&y()})})}spawn(p,h,u){const d={id:S.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,u,h)}terminate(p,h){const u={id:S.SharedProcessWorkerMessages.Terminate,configuration:p};return this.i(u,h)}}}),define(se[237],re([0,1,62,21,97]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class D extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}}ye([A.memoize],D.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=D}),define(se[238],re([0,1,50,13,176,23,39,7,4,31,150,194,6,131]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let g;async function p(u,d,y,b){return y["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(b)&&!y["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(b)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=m.Promises.withAsyncBody(async(P,t)=>{const a=new D.CancellationTokenSource;let i=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,f.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,l.localize)(0,null)))},i);try{P(await h(d,a.token))}catch(o){!(0,R.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,l.localize)(1,null,(0,k.toErrorMessage)(o)))):P({})}finally{clearTimeout(r),a.dispose()}})),g)}e.getResolvedShellEnv=p;async function h(u,d){const y=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",y);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",b);const P=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(P+"({.*})"+P),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const i=await(0,I.getSystemShell)(C.OS,a);return u.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(d.isCancellationRequested)return r(new R.CancellationError);const o=(0,O.basename)(i);let s,c;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(s=`& '${process.execPath}' ${w} -p '''${P}'' + JSON.stringify(process.env) + ''${P}'''`,c=["-Login","-Command"]):(s=`'${process.execPath}' ${w} -p '"${P}" + JSON.stringify(process.env) + "${P}"'`,o==="tcsh"||o==="csh"?c=["-ic"]:c=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),s);const E=(0,A.spawn)(i,[...c,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});d.onCancellationRequested(()=>(E.kill(),r(new R.CancellationError))),E.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(F)),r(F)});const L=[];E.stdout.on("data",F=>L.push(F));const T=[];E.stderr.on("data",F=>T.push(F)),E.on("close",(F,z)=>{const J=Buffer.concat(L).toString("utf8");u.trace("getUnixShellEnvironment#raw",J);const Y=Buffer.concat(T).toString("utf8");if(Y.trim()&&u.trace("getUnixShellEnvironment#stderr",Y),F||z)return r(new Error((0,l.localize)(2,null,F,z)));const W=t.exec(J),N=W?W[1]:"{}";try{const B=JSON.parse(N);y?B.ELECTRON_RUN_AS_NODE=y:delete B.ELECTRON_RUN_AS_NODE,b?B.ELECTRON_NO_ATTACH_CONSOLE=b:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.VSCODE_RESOLVING_ENVIRONMENT,delete B.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",B),n(B)}catch(B){u.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(B)),r(B)}})})}}),define(se[111],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,A.createDecorator)(e.SIGN_SERVICE_ID)}),define(se[239],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class A{constructor(){this.b=new Map}c(){return new Promise((l,D)=>_(["vsda"],l,D))}async createNewMessage(l){try{const D=await this.c(),k=new D.validator;if(k){const R=String(A.a++);return this.b.set(R,k),{id:R,data:k.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,D){if(!l.id)return!0;const k=this.b.get(l.id);if(!k)return!1;this.b.delete(l.id);try{return k.validate(D)==="ok"}catch{return!1}}async sign(l){try{const D=await this.c(),k=new D.signer;if(k)return k.sign(l)}catch{}return l}}A.a=1,e.SignService=A}),define(se[75],re([0,1,3,2]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends O.Disposable{constructor(S,m,f){super(),this.a=S,this.b=m,this.c=f}async getItems(){const S={profile:this.b,workspace:this.c},m=await this.a.call("getItems",S);return new Map(m)}updateItems(S){const m={profile:this.b,workspace:this.c};return S.insert&&(m.insert=Array.from(S.insert.entries())),S.delete&&(m.delete=Array.from(S.delete.values())),this.a.call("updateItems",m)}}class D extends l{constructor(S,m){super(S,m,void 0),this.f=this.B(new A.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class k extends D{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class R extends D{constructor(S,m){super(S,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class C extends l{constructor(S,m){super(S,void 0,m),this.onDidChangeItemsExternal=A.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class v{constructor(S){this.a=S}isUsed(S){const m={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=v}),define(se[112],re([0,1,4,36,10,31]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(v){if(A.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function R(v,I,S,m,f,g,p,h,u,d){const y=Object.create(null);y["common.machineId"]=p,y.sessionID=(0,D.generateUuid)()+Date.now(),y.commitHash=f,y.version=g,y["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,A.PlatformToString)(A.platform),y["common.nodePlatform"]=O.platform,y["common.nodeArch"]=m,y["common.product"]=d||"desktop",h&&(y["common.msftInternal"]=h);let b=0;const P=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-P,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),A.isLinuxSnap&&(y["common.snap"]="true");const t=k(S);t&&(y["common.platformDetail"]=t);try{const a=await v.readFile(l.URI.file(u));y["common.source"]=a.value.toString().slice(0,30)}catch{}return y}e.resolveCommonProperties=R;function C(v){const I=O.env.USERDNSDOMAIN;if(!I)return!1;const S=I.toLowerCase();return v.some(m=>S===m)}e.verifyMicrosoftInternalDomain=C}),define(se[19],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,A.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,A.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(se[240],re([0,1,34,6,35,21,13,4,10,147,27,149,98,14,25,19]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function u(t,a){const i=`${t}::${a.join(":")}`,n=h.get(i);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,s=new Map,c=2e4;function w(L,T,F,z){const J=T.substring(L.length+1);return O.Promises.withAsyncBody(async Y=>{let W;try{W=await I.Promises.readdir(T,{withFileTypes:!0})}catch{Y();return}if(z.count>=c){z.count+=W.length,z.maxReached=!0,Y();return}let N=W.length;if(N===0){Y();return}let B=W;z.count+W.length>c&&(z.maxReached=!0,N=c-z.count,B=W.slice(0,N)),z.count+=W.length;for(const ie of B)if(ie.isDirectory()){if(F.includes(ie.name)||await w(L,(0,k.join)(T,ie.name),F,z),--N===0){Y();return}}else{const q=ie.name.lastIndexOf(".");if(q>=0){const x=ie.name.substring(q+1);x&&o.set(x,(o.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(J)!==!1&&x.filePattern.test(ie.name)&&s.set(x.tag,(s.get(x.tag)??0)+1);if(--N===0){Y();return}}})}const E=O.Promises.withAsyncBody(async L=>{const T={count:0,maxReached:!1};await w(t,t,a,T);const F=await b(t);L({configFiles:d(s),fileTypes:d(o),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:F})});return h.set(i,E),E}e.collectWorkspaceStats=u;function d(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function y(){const t={os:`${A.type()} ${A.arch()} ${A.release()}`,memory:`${(A.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(A.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},a=A.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=y;async function b(t){try{const a=new Map,i=(0,k.join)(t,".vscode","launch.json"),n=await I.Promises.readFile(i),r=[],o=(0,l.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,l.getNodeType)(o)==="object"&&o.configurations)for(const s of o.configurations){const c=s.type;c&&(a.has(c)?a.set(c,a.get(c)+1):a.set(c,1))}return d(a)}catch{return[]}}e.collectLaunchConfigs=b;let P=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${A.type()} ${A.arch()} ${A.release()}`);const n=A.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(A.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(A.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||i.push(`Load (avg):       ${A.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,S.listProcesses)(a.mainPID),this.k(a)]).then(async n=>{let[r,o]=n,s=this.m(a,r);return i.forEach(c=>{if((0,m.isRemoteDiagnosticError)(c))s+=`
${c.errorMessage}`,o+=`
${c.errorMessage}`;else if(s+=`

Remote: ${c.hostName}`,c.processes&&(s+=`
${this.m(a,c.processes)}`),c.workspaceMetadata){o+=`
|  Remote: ${c.hostName}`;for(const w of Object.keys(c.workspaceMetadata)){const E=c.workspaceMetadata[w];let L=`${E.fileCount} files`;E.maxFilesReached&&(L=`more than ${L}`),o+=`|    Folder (${w}): ${L}`,o+=this.h(E)}}}),{processInfo:s,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:n,vmHint:r,os:o,cpus:s}=y(),c={os:o,memory:n,cpus:s,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return R.isWindows||(c.load=`${A.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(c.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(c)}async getDiagnostics(a,i){const n=[];return(0,S.listProcesses)(a.mainPID).then(async r=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(o=>{if((0,m.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.f(o.machineInfo)),o.processes&&n.push(this.m(a,o.processes)),o.workspaceMetadata)for(const s of Object.keys(o.workspaceMetadata)){const c=o.workspaceMetadata[s];let w=`${c.fileCount} files`;c.maxFilesReached&&(w=`more than ${w}`),n.push(`Folder (${s}): ${w}`),n.push(this.h(c))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let r=0;const o=(E,L)=>{const T=` ${E}(${L})`;r+T.length>60?(i.push(s),s="|                 ",r=s.length):r+=T.length,s+=T};let s="|      File types:";const c=10,w=a.fileTypes.length>c?c:a.fileTypes.length;for(let E=0;E<w;E++){const L=a.fileTypes[E];o(L.name,L.count)}if(i.push(s),a.configFiles.length>=0&&(s="|      Conf files:",r=0,a.configFiles.forEach(E=>{o(E.name,E.count)}),i.push(s)),a.launchConfigFiles.length>0){let E="|      Launch Configs:";a.launchConfigFiles.forEach(L=>{E+=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`}),i.push(E)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const s=C.URI.revive(o);if(s.scheme===D.Schemas.file){const c=s.fsPath;n.push(u(c,["node_modules",".git"]).then(w=>{let E=`${w.fileCount} files`;w.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,k.basename)(c)}): ${E}`),i.push(this.h(w))}).catch(w=>{i.push(`|      Error: Unable to collect workspace stats for folder ${c} (${w.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(a,i){const n=new Map;a.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,r,i,0),r.join(`
`)}n(a,i,n,r,o){const s=o===0;let c;s?c=r.pid===a?`${this.d.applicationName} main`:"remote agent":(c=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(c=`${c} (${i.get(r.pid)})`));const w=process.platform==="win32"?r.mem:A.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(w/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${c}`),Array.isArray(r.children)&&r.children.forEach(E=>this.n(a,i,n,E,o+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const r=C.URI.revive(n);if(r.scheme!==D.Schemas.file)continue;const o=r.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(c=>i.add(c.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=C.URI.revive(i);if(n.scheme!==D.Schemas.file)continue;const r=n.fsPath;try{const o=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),o.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),o.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};P=ye([X(0,p.ITelemetryService),X(1,g.IProductService)],P),e.DiagnosticsService=P}),define(se[241],re([0,1,109,3,19,15,2,11,13,50,25,4,6,105,16,174,34,10]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const d=[A.CONFIGURATION_KEY_HOST_NAME,A.CONFIGURATION_KEY_PREVENT_SLEEP];let y=class extends k.Disposable{constructor(P,t,a,i,n,r){super(),this.r=P,this.s=t,this.t=a,this.u=r,this.b=new O.Emitter,this.onDidTokenFailed=this.b.event,this.f=new O.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new O.Emitter,this.onDidChangeAccount=this.g.event,this.k=A.TunnelStates.disconnected;const o=u.URI.file((0,C.join)(a.logsPath,A.LOG_FILE_NAME));this.h=this.B(i.createLogger(o,{name:A.LOGGER_NAME,id:A.LOG_CHANNEL_ID})),this.n=new m.Delayer(100),this.B(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,R.LogLevelToString)(s)))),this.B(n.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(r.onDidChangeConfiguration(s=>{d.some(c=>s.affectsConfiguration(c))&&this.n.trigger(()=>this.w())}))}async getAccount(){return this.i}async updateAccount(P){if(P&&this.i?P.token!==this.i.token||P.providerId!==this.i.providerId:P!==this.i){this.i=P,this.g.fire(P),P?this.h.info(`Account updated: ${P.accountLabel} (${P.providerId})`):this.h.info("Account reset"),this.r.publicLog2("remoteTunnel.enablement",{enabled:!!P});try{await this.n.trigger(()=>this.w())}catch(t){this.h.error(t)}}return this.k}v(){if(!this.p){let P;S.isMacintosh?P=this.t.appRoot:P=(0,C.dirname)((0,C.dirname)(this.t.appRoot)),this.p=(0,C.join)(P,"bin",`${this.s.tunnelApplicationName}${S.isWindows?".exe":""}`)}return this.p}async w(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.y(A.TunnelStates.disconnected);return}const{token:P,providerId:t,accountLabel:a}=this.i;this.y(A.TunnelStates.connecting((0,p.localize)(0,null,a,t)));const i=(c,w)=>{c=c.replaceAll(P,"*".repeat(4)),w?this.h.error(c):this.h.info(c),!this.t.isBuilt&&c.startsWith("   Compiling")&&this.y(A.TunnelStates.connecting((0,p.localize)(1,null)))},n=this.z("login",["user","login","--provider",t,"--access-token",P,"--log",(0,R.LogLevelToString)(this.h.getLevel())],i);this.j=n;try{if(await n,this.j!==n)return}catch(c){this.h.error(c),this.j=void 0,this.b.fire(!0),this.y(A.TunnelStates.disconnected);return}const r=this.D();r?this.y(A.TunnelStates.connecting((0,p.localize)(2,null,r))):this.y(A.TunnelStates.connecting((0,p.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.h.getLevel())];r?o.push("--name",r):o.push("--random-name"),this.C()&&o.push("--no-sleep");const s=this.z("tunnel",o,(c,w)=>{w?this.h.error(c):this.h.info(c);const E=c.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const L={link:E[1],domain:E[2],hostName:E[4]};this.y(A.TunnelStates.connected(L))}else c.match(/error refreshing token/)&&(s.cancel(),this.b.fire(!0),this.y(A.TunnelStates.disconnected))});this.j=s,s.finally(()=>{s===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(A.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}y(P){this.k=P,this.f.fire(P)}z(P,t,a=()=>{}){return(0,m.createCancelablePromise)(i=>new Promise((n,r)=>{i.isCancellationRequested&&n();let o;if(i.onCancellationRequested(()=>{o&&(this.h.info(`${P} terminating(${o.pid})`),o.kill())}),!this.t.isBuilt)a("Building tunnel CLI from sources and run",!1),a(`${P} Spawning: cargo run -- tunnel ${t.join(" ")}`,!1),o=(0,v.spawn)("cargo",["run","--","tunnel",...t],{cwd:(0,C.join)(this.t.appRoot,"cli")});else{a("Running tunnel CLI",!1);const s=this.v();a(`${P} Spawning: ${s} tunnel ${t.join(" ")}`,!1),o=(0,v.spawn)(s,["tunnel",...t],{cwd:(0,h.homedir)()})}o.stdout.on("data",s=>{if(o){const c=s.toString();a(c,!1)}}),o.stderr.on("data",s=>{if(o){const c=s.toString();a(c,!0)}}),o.on("exit",s=>{o&&(a(`${P} exit(${o.pid}): + ${s} `,!1),o=void 0,s===0?n():r())}),o.on("error",s=>{o&&(a(`${P} error(${o.pid}): + ${s} `,!0),o=void 0,r())})}))}async getHostName(){return this.D()}C(){return!!this.u.getValue(A.CONFIGURATION_KEY_PREVENT_SLEEP)}D(){let P=this.u.getValue(A.CONFIGURATION_KEY_HOST_NAME)||(0,h.hostname)();return P=P.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),P||void 0}};y=ye([X(0,l.ITelemetryService),X(1,I.IProductService),X(2,D.INativeEnvironmentService),X(3,R.ILoggerService),X(4,f.ISharedProcessLifecycleService),X(5,g.IConfigurationService)],y),e.RemoteTunnelService=y}),define(se[113],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class A{constructor(D){this.b=D}listen(D,k){throw new Error(`Event not found: ${k}`)}call(D,k,{eventName:R,data:C}){return this.b.forEach(v=>v.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=A;class O{constructor(D){this.b=D}log(D,k){return this.b.call("log",{eventName:D,data:k}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(se[47],re([0,1,32,12,3,16,74,112,19]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(s){this.value=s}}e.TelemetryTrustedValue=v;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,c){return Promise.resolve(void 0)}publicLog2(s,c){return this.publicLog(s,c)}publicLogError(s,c){return Promise.resolve(void 0)}publicLogError2(s,c){return this.publicLogError(s,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class S{async publicLog(s,c,w){}async publicLogError(s,c,w){}}e.NullEndpointTelemetryService=S,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(o,s){return l.Event.debounce(s.onDidChangeConfiguration,(w,E)=>{const L=w?new Set([...w.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:L}},1e3,!0)(w=>{w.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(w.source),configurationKeys:b(w.affectedKeys)})})}e.configurationTelemetry=m;function f(o,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!o.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=f;function g(o,s){return!(s.isBuilt||s.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=g;function p(o){const s=o.getValue(C.TELEMETRY_SETTING_ID),c=o.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function h(o){const s={},c={},w={};y(o,w);for(let E in w){E=E.length>150?E.substr(E.length-149):E;const L=w[E];typeof L=="number"?c[E]=L:typeof L=="boolean"?c[E]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${L.length}`),s[E]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(s[E]=L)}return{properties:s,measurements:c}}e.validateTelemetryData=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(o){if(!o)return"none";const s=(0,k.getRemoteName)(o);return u.has(s)?s:"other"}e.cleanRemoteAuthority=d;function y(o,s,c=0,w){if(!!o)for(const E of Object.getOwnPropertyNames(o)){const L=o[E],T=w?w+E:E;Array.isArray(L)?s[T]=(0,A.safeStringify)(L):L instanceof Date?s[T]=L.toISOString():(0,O.isObject)(L)?c<2?y(L,s,c+1,T+"."):s[T]=(0,A.safeStringify)(L):s[T]=L}}function b(o){if(!o)return[];const s=[];return P(s,"",o),s}function P(o,s,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(w=>P(o,s?`${s}.${w}`:w,c[w])):o.push(s)}function t(o,s){const c=o.msftInternalDomains||[],w=s.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(c)||w}e.isInternalTelemetry=t;function a(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(o,s){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let c=o;const w=[];for(const F of s)for(;;){const z=F.exec(o);if(!z)break;w.push([z.index,F.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let T=0;for(c="";;){const F=L.exec(o);if(!F)break;const z=w.some(([J,Y])=>F.index<Y&&J<L.lastIndex);!E.test(F[0])&&!z&&(c+=o.substring(T,F.index)+"<REDACTED: user-file-path>",T=L.lastIndex)}return T<o.length&&(c+=o.substr(T)),c}function n(o){if(!o)return o;const s=o.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const w of c)if(w.regex.test(s))return`<REDACTED: ${w.label}>`;return o}function r(o,s){return(0,A.cloneAndChange)(o,c=>{if(c instanceof v)return c.value;if(typeof c=="string"){let w=c.replaceAll("%20"," ");w=i(w,s);for(const E of s)w=w.replace(E,"");return w=n(w),w}})}e.cleanData=r}),define(se[33],re([0,1,26,29,46,4,10,7,36,47]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,A.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=I;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,r,o)}static parse(n){const r=S.exec(n);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(i){const n=f.exec(i);return n&&n[1]?[h(n[1]),n[2]]:[h(i),void 0]}e.getIdAndVersion=g;function p(i,n){return`${i}.${n}`}e.getExtensionId=p;function h(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(i,n){return h(p(i,n))}e.getGalleryExtensionId=u;function d(i,n){const r=[],o=s=>{for(const c of r)if(c.some(w=>I(n(w),n(s))))return c;return null};for(const s of i){const c=o(s);c?c.push(s):r.push([s])}return r}e.groupByExtension=d;function y(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function b(i){return{id:new v.TelemetryTrustedValue(i.identifier.id),name:new v.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function P(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const s=o.shift();if(s&&r.every(c=>!I(c.identifier,{id:s}))){const c=i.filter(w=>I(w.identifier,{id:s}));c.length===1&&(r.push(c[0]),o.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=P;async function t(i,n){if(!D.isLinux)return!1;let r;try{r=(await i.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const r=await t(i,n),o=(0,O.getTargetPlatform)(r?"alpine":D.platform,C.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(se[242],re([0,1,23,33]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(D,k,R,C,v){try{const I=await D.getExtensionsControlManifest();if(!I.deprecated)return;const S=await D.getInstalled(1);for(const[m,f]of Object.entries(I.deprecated)){if(!f?.extension)continue;const{id:g,autoMigrate:p,preRelease:h}=f.extension;if(!p)continue;const u=S.find(y=>(0,O.areSameExtensions)(y.identifier,{id:m}));if(!u)continue;const d=(await k.getExtensions([{id:g,preRelease:h}],{targetPlatform:await D.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0];if(!d){v.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{v.info(`Migrating '${u.identifier.id}' extension to '${g}' extension...`);const y=!C.getDisabledExtensions().some(P=>(0,O.areSameExtensions)(P,u.identifier));await D.uninstall(u),v.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let b=S.find(P=>(0,O.areSameExtensions)(P.identifier,{id:g}));(!b||!b.isPreReleaseVersion&&y)&&(b=await D.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),v.info(`Installed the pre-release extension '${b.identifier.id}'`),y||(await C.disableExtension(b.identifier),v.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,O.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,O.getExtensionId)(b.manifest.publisher,b.manifest.name)),v.info("Added pre-release extension to the storage migration list"))),v.info(`Migrated '${u.identifier.id}' extension to '${g}' extension.`)}catch(y){v.error(y)}}}catch(I){v.error(I)}}e.migrateUnsupportedExtensions=l}),define(se[243],re([0,1,3,2,38,33,46]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends O.Disposable{constructor(v,I,S,m,f,g,p){super(),this.f=v,this.g=I,this.h=S,this.i=m,this.j=f,this.k=g,this.l=p,this.a=this.B(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,h=>p.error(h))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(v=>this.p(v.added,v.removed))),this.B(this.i.onAddExtensions(v=>this.r(v))),this.B(this.i.onDidAddExtensions(v=>this.s(v))),this.B(this.i.onRemoveExtensions(v=>this.t(v))),this.B(this.i.onDidRemoveExtensions(v=>this.u(v))),this.B(this.k.onDidFilesChange(v=>this.v(v)))}async p(v,I){try{await Promise.all(I.map(S=>(this.c.deleteAndDispose(S.id),this.z(S.extensionsResource)))),v.length&&await Promise.all(v.map(S=>(this.c.set(S.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.y(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async r(v){for(const I of v.extensions)this.D(this.G(I.identifier,I.version),v.profileLocation)}async s(v){for(const I of v.extensions){const S=this.G(I.identifier,I.version);v.error?this.F(S,v.profileLocation):this.D(S,v.profileLocation)}}async t(v){for(const I of v.extensions)this.F(this.G(I.identifier,I.version),v.profileLocation)}async u(v){const I=[],S=[];for(const m of v.extensions){const f=this.G(m.identifier,m.version);v.error?this.D(f,v.profileLocation):(this.F(f,v.profileLocation),this.b.has(f)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),S.push(this.f.scanInstalledExtensionAtLocation(m.location).then(g=>{g?I.push(g):this.l.info("Extension not found at the location",m.location.toString())},g=>this.l.error(g)))))}try{await Promise.all(S),I.length&&await this.C(I)}catch(m){this.l.error(m)}}v(v){for(const I of this.h.profiles)v.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(v){const I=[],S=[],m=await this.i.scanProfileExtensions(v),f=new Set,g=new Set;for(const[p,h]of this.b)h.has(v)&&g.add(p);for(const p of m){const h=this.G(p.identifier,p.version);f.add(h),g.has(h)||(I.push(p.identifier),this.D(h,v))}for(const p of g)if(!f.has(p)){const h=this.H(p);h&&(S.push(h.identifier),this.F(p,v))}(I.length||S.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:v}:void 0,removed:S.length?{extensions:S,profileLocation:v}:void 0})}async y(v){const I=await this.i.scanProfileExtensions(v);for(const S of I)this.D(this.G(S.identifier,S.version),v)}async z(v){for(const I of[...this.b.keys()])this.F(I,v);await this.C()}async C(v){v||(v=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.G(S.identifier,S.manifest.version)))),v.length&&await this.f.markAsUninstalled(...v)}D(v,I){let S=this.b.get(v);S||this.b.set(v,S=new l.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),S.add(I)}F(v,I){const S=this.b.get(v);S&&S.delete(I),S?.size||this.b.delete(v)}G(v,I){return`${k.ExtensionIdentifier.toKey(v.id)}@${I}`}H(v){const[I,S]=(0,D.getIdAndVersion)(v);return S?{identifier:{id:I},version:S}:void 0}}e.ExtensionsWatcher=R}),define(se[244],re([0,1,44,47]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(D,k,R,C,v,I,S){const m={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${k.nameShort})`};if((0,O.supportsTelemetry)(k,R)&&(0,O.getTelemetryLevel)(C)===3){const f=await(0,A.getServiceMachineId)(R,v,I),{machineId:g}=await S.getTelemetryInfo();m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=g||f}return m}e.resolveMarketplaceHeaders=l}),define(se[245],re([0,1,102,18,6,2,21,13,27,15,29,33,11,72,10]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=class extends f.LanguagePackBaseService{constructor(y,b,P,t){super(P),this.h=y,this.i=t,this.g=this.B(new h(b,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(y,b){const t=(await this.g.getLanguagePacks())[b];if(!t){this.i.warn(`No language pack found for ${b}`);return}const a=t.translations[y];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),b=Object.keys(y).map(P=>{const t=y[P];return{...this.f(P,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((P,t)=>P.label.localeCompare(t.label)),b}async j(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",y.identifier.id),await this.update())}async k(y){const b=await this.g.getLanguagePacks();Object.keys(b).some(P=>b[P]&&b[P].extensions.some(t=>(0,S.areSameExtensions)(t.extensionIdentifier,y.identifier)))&&(this.i.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),P=await this.g.update(b);return!(0,O.equals)(Object.keys(y),Object.keys(P))}};p=ye([X(0,I.IExtensionManagementService),X(1,v.INativeEnvironmentService),X(2,I.IExtensionGalleryService),X(3,m.ILogService)],p),e.NativeLanguagePackService=p;let h=class extends D.Disposable{constructor(y,b){super(),this.i=b,this.c={},this.f=(0,R.join)(y.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.m(b=>{Object.keys(b).forEach(P=>delete b[P]),this.j(b,...y)}).then(()=>this.c)}j(y,...b){for(const P of b)P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&this.k(y,P);Object.keys(y).forEach(P=>this.l(y[P]))}k(y,b){const P=b.identifier,t=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of t)if(b.location.scheme===k.Schemas.file&&u(a)){let i=y[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},y[a.languageId]=i);const n=i.extensions.filter(r=>(0,S.areSameExtensions)(r.extensionIdentifier,P))[0];n?n.version=b.manifest.version:i.extensions.push({extensionIdentifier:P,version:b.manifest.version});for(const r of a.translations)i.translations[r.id]=(0,R.join)(b.location.fsPath,r.path)}}l(y){if(y){const b=(0,A.createHash)("md5");for(const P of y.extensions)b.update(P.extensionIdentifier.uuid||P.extensionIdentifier.id).update(P.version);y.hash=b.digest("hex")}}m(y=()=>null){return this.g.queue(()=>{let b=null;return C.Promises.readFile(this.f,"utf8").then(void 0,P=>P.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(P)).then(P=>{try{return JSON.parse(P)}catch{return{}}}).then(P=>(b=y(P),P)).then(P=>{for(const a of Object.keys(P))P[a]||delete P[a];this.c=P,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),C.Promises.writeFile(this.f,t)}).then(()=>b,P=>this.i.error(P))})}};h=ye([X(0,v.INativeEnvironmentService),X(1,m.ILogService)],h);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const y of d.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(se[246],re([0,1,7,32,47]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function R(v,I,S){const m=await new Promise((u,d)=>{_(["@microsoft/1ds-core-js"],u,d)}),f=await new Promise((u,d)=>{_(["@microsoft/1ds-post-js"],u,d)}),g=new m.AppInsightsCore,p=new f.PostChannel,h={instrumentationKey:v,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(S){h.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:S};h.extensionConfig[p.identifier]=u}return g.initialize(h,[]),g.addTelemetryInitializer(u=>{I&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),g}class C{constructor(I,S,m,f,g){this.e=I,this.f=S,this.g=m,this.h=g,this.c=D,this.d=k,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(I){if(!!this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(S=>{I(S)},S=>{(0,A.onUnexpectedError)(S),console.error(S)})}}log(I,S){if(!this.a)return;S=(0,O.mixin)(S,this.g),S=(0,l.validateTelemetryData)(S);const m=this.f+"/"+I;try{this.i(f=>{f.pluginVersionString=S?.properties.version??"Unknown",f.track({name:m,baseData:{name:m,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(se[114],re([0,1,2,177,15,11,25,47]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let C=class extends A.Disposable{constructor(I,S,m,f,g=""){super(),this.b=g;const p=S.getLogger(m.telemetryLogResource);if(p)this.a=this.B(p);else{const u=(0,R.isLoggingOnly)(f,m)?" (Not Sent)":"",d=m.telemetryLogResource,y=()=>(0,R.supportsTelemetry)(f,m)&&I.getLevel()===D.LogLevel.Trace;this.a=this.B(S.createLogger(d,{id:R.telemetryLogChannelId,name:(0,O.localize)(0,null,u),hidden:!y()})),this.B(I.onDidChangeLogLevel(()=>S.setVisibility(d,y()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,S){this.a.trace(`${this.b}telemetry/${I}`,(0,R.validateTelemetryData)(S))}};C=ye([X(0,D.ILogService),X(1,D.ILoggerService),X(2,l.IEnvironmentService),X(3,k.IProductService)],C),e.TelemetryLogAppender=C}),define(se[115],re([0,1,2,32,4,26,178,16,45,107,25,40,19,47]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(u,d,y){this.k=d,this.l=y,this.d={},this.i=new A.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(m.TELEMETRY_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,d){this.d[u]=d}m(){let u=(0,f.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const y=d.usage?3:d.error?2:0;u=Math.min(u,y)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,d=u.sessionID,y=u["common.machineId"],b=u["common.firstSessionDate"],P=u["common.msftInternal"];return{sessionId:d,machineId:y,firstSessionDate:b,msftInternal:P}}dispose(){this.i.dispose()}n(u,d,y){return this.g<d?Promise.resolve(void 0):this.c.then(b=>{y=(0,O.mixin)(y,this.d),y=(0,f.cleanData)(y,this.j),y=(0,O.mixin)(y,b),this.b.forEach(P=>P.log(u,y))},b=>{console.error(b)})}publicLog(u,d){return this.n(u,3,d)}publicLog2(u,d){return this.publicLog(u,d)}publicLogError(u,d){return this.h?this.n(u,2,d):Promise.resolve(void 0)}publicLogError2(u,d){return this.publicLogError(u,d)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ye([X(1,R.IConfigurationService),X(2,I.IProductService)],g),e.TelemetryService=g;function p(){const h=(0,k.localize)(0,null,v.default.nameLong),u=v.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=l.isWeb?"":(0,k.localize)(3,null),y=(0,k.localize)(4,null),b=(0,k.localize)(5,null),P=(0,k.localize)(6,null),t=(0,k.localize)(7,null),a=`
|       | ${y} | ${b} | ${P} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,k.localize)(8,null);return`
${h} ${u} ${d}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}S.Registry.as(C.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(C.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,k.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,k.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[247],re([0,1,300,246]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends O.AbstractOneDataSystemAppender{constructor(k,R,C,v){const I={sendPOST:(S,m)=>{const f={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const g=A.request(S.urlString,f,p=>{p.on("data",function(h){m(p.statusCode??200,p.headers,h.toString())}),p.on("error",function(h){m(0,{})})});g.write(S.data),g.end()}catch{m(0,{})}}};super(k,R,C,v,I)}}e.OneDataSystemAppender=l}),define(se[248],re([0,1,21,66,16,15,11,25,19,113,114,115]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(g,p,h,u,d,y){this.b=g,this.c=p,this.d=h,this.e=u,this.f=d,this.g=y,this.a=new Map}async h(g){if(!this.a.has(g.id)){const{machineId:p,sessionId:h}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=p,u["common.vscodesessionid"]=h;const d=[g.id,JSON.stringify(u),g.aiKey],b=new O.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new v.TelemetryAppenderClient(b),new I.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new S.TelemetryService({appenders:P,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}async publicLog(g,p,h){await(await this.h(g)).publicLog(p,h)}async publicLogError(g,p,h){await(await this.h(g)).publicLogError(p,h)}};m=ye([X(0,l.IConfigurationService),X(1,C.ITelemetryService),X(2,k.ILogService),X(3,k.ILoggerService),X(4,D.IEnvironmentService),X(5,R.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(se[116],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var A;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(A=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(se[249],re([0,1,4,116]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(C){this.collections=C,this.map=new Map,C.forEach((v,I)=>{const S=v.map.entries();let m=S.next();for(;!m.done;){const f=m.value[0];let g=this.map.get(f);if(g||(g=[],this.map.set(f,g)),g.length>0&&g[0].type===O.EnvironmentVariableMutatorType.Replace){m=S.next();continue}const p=m.value[1];g.unshift({extensionIdentifier:I,value:p.value,type:p.type}),m=S.next()}})}async applyToProcessEnvironment(C,v){let I;A.isWindows&&(I={},Object.keys(C).forEach(S=>I[S.toLowerCase()]=S));for(const[S,m]of this.map){const f=A.isWindows&&I[S.toLowerCase()]||S;for(const g of m){const p=v?await v(g.value):g.value;switch(g.type){case O.EnvironmentVariableMutatorType.Append:C[f]=(C[f]||"")+p;break;case O.EnvironmentVariableMutatorType.Prepend:C[f]=p+(C[f]||"");break;case O.EnvironmentVariableMutatorType.Replace:C[f]=p;break}}}}diff(C){const v=new Map,I=new Map,S=new Map;if(C.map.forEach((m,f)=>{const g=this.map.get(f),p=D(m,g);p&&v.set(f,p)}),this.map.forEach((m,f)=>{const g=C.map.get(f),p=D(m,g);p&&S.set(f,p)}),this.map.forEach((m,f)=>{const g=C.map.get(f),p=k(m,g);p&&I.set(f,p)}),!(v.size===0&&I.size===0&&S.size===0))return{added:v,changed:I,removed:S}}}e.MergedEnvironmentVariableCollection=l;function D(R,C){if(!C)return R;const v=new Set;C.forEach(S=>v.add(S.extensionIdentifier));const I=[];return R.forEach(S=>{v.has(S.extensionIdentifier)||I.push(S)}),I.length===0?void 0:I}function k(R,C){if(!C)return;const v=new Map;C.forEach(S=>v.set(S.extensionIdentifier,S));const I=[];return R.forEach(S=>{const m=v.get(S.extensionIdentifier);m&&(S.type!==m.type||S.value!==m.value)&&I.push(m)}),I.length===0?void 0:I}}),define(se[250],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function A(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=A;function O(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=O;function l(k){return Array.from(k.entries()).map(R=>[R[0],A(R[1].map)])}e.serializeEnvironmentVariableCollections=l;function D(k){return new Map(k.map(R=>[R[0],{map:O(R[1])}]))}e.deserializeEnvironmentVariableCollections=D}),define(se[251],re([0,1,6,23,3,2,11]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends D.Disposable{constructor(v,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=v===void 0?15e3:v}createRequest(v){return new Promise((I,S)=>{const m=++this.a;this.c.set(m,I),this.g.fire({requestId:m,...v});const f=new O.CancellationTokenSource;(0,A.timeout)(this.b,f.token).then(()=>S(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,D.toDisposable)(()=>f.cancel())])})}acceptReply(v,I){const S=this.c.get(v);S?(this.c.delete(v),(0,D.dispose)(this.f.get(v)||[]),this.f.delete(v),S(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${v}`)}};R=ye([X(1,k.ILogService)],R),e.RequestStore=R}),define(se[117],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var O;(function(y){y.Shell="terminal.integrated.shell.",y.ShellArgs="terminal.integrated.shellArgs.",y.DefaultProfile="terminal.integrated.defaultProfile.",y.Profiles="terminal.integrated.profiles."})(O=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var l;(function(y){y.ShellLinux="terminal.integrated.shell.linux",y.ShellMacOs="terminal.integrated.shell.osx",y.ShellWindows="terminal.integrated.shell.windows",y.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",y.AutomationShellLinux="terminal.integrated.automationShell.linux",y.AutomationShellMacOs="terminal.integrated.automationShell.osx",y.AutomationShellWindows="terminal.integrated.automationShell.windows",y.AutomationProfileLinux="terminal.integrated.automationProfile.linux",y.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",y.AutomationProfileWindows="terminal.integrated.automationProfile.windows",y.ShellArgsLinux="terminal.integrated.shellArgs.linux",y.ShellArgsMacOs="terminal.integrated.shellArgs.osx",y.ShellArgsWindows="terminal.integrated.shellArgs.windows",y.ProfilesWindows="terminal.integrated.profiles.windows",y.ProfilesMacOs="terminal.integrated.profiles.osx",y.ProfilesLinux="terminal.integrated.profiles.linux",y.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",y.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",y.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",y.UseWslProfiles="terminal.integrated.useWslProfiles",y.TabsDefaultColor="terminal.integrated.tabs.defaultColor",y.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",y.TabsEnabled="terminal.integrated.tabs.enabled",y.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",y.TabsHideCondition="terminal.integrated.tabs.hideCondition",y.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",y.TabsShowActions="terminal.integrated.tabs.showActions",y.TabsLocation="terminal.integrated.tabs.location",y.TabsFocusMode="terminal.integrated.tabs.focusMode",y.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",y.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",y.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",y.CopyOnSelection="terminal.integrated.copyOnSelection",y.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",y.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",y.FontFamily="terminal.integrated.fontFamily",y.FontSize="terminal.integrated.fontSize",y.LetterSpacing="terminal.integrated.letterSpacing",y.LineHeight="terminal.integrated.lineHeight",y.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",y.TabStopWidth="terminal.integrated.tabStopWidth",y.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",y.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",y.BellDuration="terminal.integrated.bellDuration",y.FontWeight="terminal.integrated.fontWeight",y.FontWeightBold="terminal.integrated.fontWeightBold",y.CursorBlinking="terminal.integrated.cursorBlinking",y.CursorStyle="terminal.integrated.cursorStyle",y.CursorWidth="terminal.integrated.cursorWidth",y.Scrollback="terminal.integrated.scrollback",y.DetectLocale="terminal.integrated.detectLocale",y.DefaultLocation="terminal.integrated.defaultLocation",y.GpuAcceleration="terminal.integrated.gpuAcceleration",y.TerminalTitleSeparator="terminal.integrated.tabs.separator",y.TerminalTitle="terminal.integrated.tabs.title",y.TerminalDescription="terminal.integrated.tabs.description",y.RightClickBehavior="terminal.integrated.rightClickBehavior",y.Cwd="terminal.integrated.cwd",y.ConfirmOnExit="terminal.integrated.confirmOnExit",y.ConfirmOnKill="terminal.integrated.confirmOnKill",y.EnableBell="terminal.integrated.enableBell",y.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",y.AllowChords="terminal.integrated.allowChords",y.AllowMnemonics="terminal.integrated.allowMnemonics",y.TabFocusMode="terminal.integrated.tabFocusMode",y.EnvMacOs="terminal.integrated.env.osx",y.EnvLinux="terminal.integrated.env.linux",y.EnvWindows="terminal.integrated.env.windows",y.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",y.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",y.ShowExitAlert="terminal.integrated.showExitAlert",y.SplitCwd="terminal.integrated.splitCwd",y.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",y.WordSeparators="terminal.integrated.wordSeparators",y.EnableFileLinks="terminal.integrated.enableFileLinks",y.UnicodeVersion="terminal.integrated.unicodeVersion",y.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",y.LocalEchoEnabled="terminal.integrated.localEchoEnabled",y.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",y.LocalEchoStyle="terminal.integrated.localEchoStyle",y.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",y.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",y.CustomGlyphs="terminal.integrated.customGlyphs",y.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",y.InheritEnv="terminal.integrated.inheritEnv",y.ShowLinkHover="terminal.integrated.showLinkHover",y.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",y.AutoReplies="terminal.integrated.autoReplies",y.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",y.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",y.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",y.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",y.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",y.SmoothScrolling="terminal.integrated.smoothScrolling"})(l=e.TerminalSettingId||(e.TerminalSettingId={}));var D;(function(y){y.FileName="ptyhost"})(D=e.TerminalLogConstants||(e.TerminalLogConstants={}));var k;(function(y){y.PowerShell="pwsh",y.Bash="bash",y.Fish="fish",y.Sh="sh",y.Csh="csh",y.Ksh="ksh",y.Zsh="zsh"})(k=e.PosixShellType||(e.PosixShellType={}));var R;(function(y){y.CommandPrompt="cmd",y.PowerShell="pwsh",y.Wsl="wsl",y.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence",y[y.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(y){y.LocalPty="localPty",y.PtyHost="ptyHost",y.Logger="logger",y.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,A.createDecorator)("ptyService");var I;(function(y){y.Cwd="cwd",y.InitialCwd="initialCwd",y.FixedDimensions="fixedDimensions",y.Title="title",y.ShellType="shellType",y.HasChildProcesses="hasChildProcesses",y.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",y.OverrideDimensions="overrideDimensions",y.FailedShellIntegrationActivation="failedShellIntegrationActivation",y.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(y){y[y.BeatInterval=5e3]="BeatInterval",y[y.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",y[y.SecondWaitMultiplier=1]="SecondWaitMultiplier",y[y.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(y){y[y.Panel=1]="Panel",y[y.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var f;(function(y){y.TerminalView="view",y.Editor="editor"})(f=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(y){y[y.GraceTime=6e4]="GraceTime",y[y.ShortGraceTime=6e3]="ShortGraceTime"})(g=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(y){y[y.HighWatermarkChars=1e5]="HighWatermarkChars",y[y.LowWatermarkChars=5e3]="LowWatermarkChars",y[y.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(y){y.GitBash="Git Bash",y.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}));var u;(function(y){y[y.Off=0]="Off",y[y.FinalTerm=1]="FinalTerm",y[y.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(y){y[y.Unknown=0]="Unknown",y[y.Shutdown=1]="Shutdown",y[y.Process=2]="Process",y[y.User=3]="User",y[y.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(se[252],re([0,1,52,10,180,134]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(m,f){const g=[{name:null,description:(0,l.localize)(0,null)}];return g.push(...m.map(p=>({name:p.profileName,description:R(p)}))),f&&g.push(...f.map(p=>({name:p.title,description:C(p)}))),{values:g.map(p=>p.name),markdownDescriptions:g.map(p=>p.description)}}e.createProfileSchemaEnums=k;function R(m){let f=`$(${D.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:A.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?f+=`
- args: "${m.args}"`:f+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(f+=`
- overrideName: ${m.overrideName}`),m.color&&(f+=`
- color: ${m.color}`),m.env&&(f+=`
- env: ${JSON.stringify(m.env)}`),f}function C(m){return`$(${D.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:A.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function v(m,f){if(!m&&!f)return!0;if(typeof m=="string"&&typeof f=="string")return m===f;if(Array.isArray(m)&&Array.isArray(f)){if(m.length!==f.length)return!1;for(let g=0;g<m.length;g++)if(m[g]!==f[g])return!1;return!0}return!1}e.terminalProfileArgsMatch=v;function I(m,f){if(!m&&!f)return!0;if(!m||!f)return!1;if(D.ThemeIcon.isThemeIcon(m)&&D.ThemeIcon.isThemeIcon(f))return m.id===f.id&&m.color===f.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof f=="object"&&"light"in f&&"dark"in f){const g=m,p=f;if((O.URI.isUri(g.light)||S(g.light))&&(O.URI.isUri(g.dark)||S(g.dark))&&(O.URI.isUri(p.light)||S(p.light))&&(O.URI.isUri(p.dark)||S(p.dark)))return g.light.path===p.light.path&&g.dark.path===p.dark.path}if(O.URI.isUri(m)&&O.URI.isUri(f)||S(m)||S(f)){const g=m,p=f;return g.path===p.path&&g.scheme===p.scheme}return!1}e.terminalIconsEqual=I;function S(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=S}),define(se[253],re([0,1,52,179,45,40,252]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,A.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,A.getAllCodicons)(),b=>`$(${b.id})`)};const R={args:{description:(0,O.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,O.localize)(1,null),type:"boolean"},icon:{description:(0,O.localize)(2,null),...e.terminalIconSchema},color:{description:(0,O.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,O.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},v={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,O.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,O.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,O.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,O.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),g=(0,O.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,O.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),h={id:"terminal",order:100,title:(0,O.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,O.localize)(26,null)}},{type:"string",markdownDescription:(0,O.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,O.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(30,null),type:"string"},id:{description:(0,O.localize)(31,null),type:"string"},title:{description:(0,O.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(34,null),type:"string"},id:{description:(0,O.localize)(35,null),type:"string"},title:{description:(0,O.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(38,null),type:"string"},id:{description:(0,O.localize)(39,null),type:"string"},title:{description:(0,O.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,O.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,O.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,O.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,O.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,O.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.Registry.as(l.Extensions.Configuration).registerConfiguration(h),y()}e.registerTerminalPlatformConfiguration=u;let d;function y(b,P){const t=D.Registry.as(l.Extensions.Configuration);let a;b&&(a=(0,k.createProfileSchemaEnums)(b?.profiles,P));const i=d;d={id:"terminal",order:100,title:(0,O.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?a?.values:void 0,markdownEnumDescriptions:b?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?a?.values:void 0,markdownEnumDescriptions:b?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?a?.values:void 0,markdownEnumDescriptions:b?.os===1?a?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[d],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(se[254],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,A.createDecorator)("localPtyService")}),define(se[255],re([0,1,34,21,32,13,4,36,26,12,27,116,250,249]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function g(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(A.release());let r=0;return n&&n.length===4&&(r=parseInt(n[3])),r}e.getWindowsBuildNumber=g;async function p(n,r,o,s=R.env,c=I.Promises.exists){if(D.isAbsolute(n))return await c(n)?n:void 0;if(r===void 0&&(r=R.cwd()),D.dirname(n)!=="."){const T=D.join(r,n);return await c(T)?T:void 0}const E=(0,l.getCaseInsensitive)(s,"PATH");if(o===void 0&&(0,v.isString)(E)&&(o=E.split(D.delimiter)),o===void 0||o.length===0){const T=D.join(r,n);return await c(T)?T:void 0}for(const T of o){let F;if(D.isAbsolute(T)?F=D.join(T,n):F=D.join(r,T,n),await c(F))return F;if(k.isWindows){let z=F+".com";if(await c(z)||(z=F+".exe",await c(z)))return z}}const L=D.join(r,n);return await c(L)?L:void 0}e.findExecutable=p;function h(n,r,o,s,c){const w=k.isWindows&&(!r.windowsEnableConpty||g()<18309);if(!r.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||w)return;const E=n.args,L=R.platform==="win32"?D.basename(n.executable).toLowerCase():D.basename(n.executable),T=D.dirname(O.FileAccess.asFileUri("").fsPath);let F;const z={VSCODE_INJECTION:"1"};if(k.isWindows){if(L==="pwsh.exe"||L==="powershell.exe")return!E||a(E)?F=y.get(d.WindowsPwsh):t(E)&&(F=y.get(d.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],T,""),r.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:z}):void 0;s.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(L){case"bash":return!E||E.length===0?F=y.get(d.Bash):i(E)&&(z.VSCODE_SHELL_LOGIN="1",u(r,z),F=y.get(d.Bash)),F?(F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],T),{newArgs:F,envMixin:z}):void 0;case"fish":{const J=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=D.join(T,"out/vs/workbench/contrib/xdg_data");return z.XDG_DATA_DIRS=`${J}:${Y}`,u(r,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!E||a(E)?F=y.get(d.Pwsh):t(E)&&(F=y.get(d.PwshLogin)),F?(r.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],T,""),{newArgs:F,envMixin:z}):void 0;case"zsh":{if(!E||E.length===0?F=y.get(d.Zsh):i(E)?(F=y.get(d.ZshLogin),u(r,z)):(E===y.get(d.Zsh)||E===y.get(d.ZshLogin))&&(F=E),!F)return;F=[...F],F[F.length-1]=(0,C.format)(F[F.length-1],T);let J;try{J=A.userInfo().username}catch{J="unknown"}const Y=D.join(A.tmpdir(),`${J}-${c.applicationName}-zsh`);z.ZDOTDIR=Y;const W=o?.ZDOTDIR??A.homedir()??"~";z.USER_ZDOTDIR=W;const N=[];return N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.join(Y,".zshrc")}),N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.join(Y,".zprofile")}),N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.join(Y,".zshenv")}),N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.join(Y,".zlogin")}),{newArgs:F,envMixin:z,filesToCopy:N}}}s.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=h;function u(n,r){if(k.isMacintosh&&n.environmentVariableCollections){const o=(0,m.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),c=new f.MergedEnvironmentVariableCollection(o).map.get("PATH"),w=[];if(c)for(const E of c)E.type===S.EnvironmentVariableMutatorType.Prepend&&w.push(E.value);w.length>0&&(r.VSCODE_PATH_PREFIX=w.join(""))}}var d;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(d||(d={}));const y=new Map;y.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(d.Zsh,["-i"]),y.set(d.ZshLogin,["-il"]),y.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],P=["-nol","-nologo"];function t(n){return typeof n=="string"?b.includes(n.toLowerCase()):n.length===1&&b.includes(n[0].toLowerCase())||n.length===2&&(b.includes(n[0].toLowerCase())||b.includes(n[1].toLowerCase()))&&(P.includes(n[0].toLowerCase())||P.includes(n[1].toLowerCase()))}function a(n){return typeof n=="string"?P.includes(n.toLowerCase()):n.length===0||n?.length===1&&P.includes(n[0].toLowerCase())}function i(n){return n==="string"&&b.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&b.includes(n[0].toLowerCase())}}),define(se[256],re([0,1,50,52,13,4,12,27,94,255]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,S=!0;function m(a,i,n,r,o=process.env,s,c,w,E){return s=s||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},D.isWindows?f(n,s,o,c,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),E,w):b(s,c,n,a&&typeof a=="object"?{...a}:r.getValue(D.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(D.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,w,o)}e.detectAvailableProfiles=m;async function f(a,i,n,r,o,s,c,w,E){const L=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${L?"Sysnative":"System32"}`;let F=!1;(0,v.getWindowsBuildNumber)()>=16299&&(F=!0),await h(w);const z=new Map;if(a){z.set("PowerShell",{source:"PowerShell",icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),z.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:O.Codicon.terminalCmd,isAutoDetected:!0}),z.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),z.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.Codicon.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;z.set("Cmder",{path:`${T}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}P(s,z);const J=await g(z.entries(),c,i,n,r,E);if(a||o)try{const Y=await d(`${T}\\${F?"wsl":"bash"}.exe`,c);for(const W of Y)(!s||!(W.profileName in s))&&J.push(W)}catch{S&&(r?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return J}async function g(a,i,n,r=process.env,o,s){const c=[];for(const[w,E]of a){if(E===null)continue;let L,T,F;if("source"in E){const W=I?.get(E.source);if(!W)continue;L=W.paths,T=E.args||W.args,E.icon?F=p(E.icon):W.icon&&(F=W.icon)}else L=Array.isArray(E.path)?E.path:[E.path],T=D.isWindows||Array.isArray(E.args)?E.args:void 0,F=p(E.icon);let z;if(s){const W=L.map(B=>typeof B=="string"?B:B.path),N=await s(W);z=new Array(L.length);for(let B=0;B<L.length;B++)typeof L[B]=="string"?z[B]=N[B]:z[B]={path:N[B],isUnsafe:!0}}else z=L.slice();let J;if(E.requiresPath){let W;if((0,k.isString)(E.requiresPath)?W=E.requiresPath:(W=E.requiresPath.path,E.requiresPath.isUnsafe&&(J=W)),!await n.existsFile(W))continue}const Y=await t(w,i,z,n,r,T,E.env,E.overrideName,E.isAutoDetected,J);Y?(Y.isAutoDetected=E.isAutoDetected,Y.icon=F,Y.color=E.color,c.push(Y)):o?.debug("Terminal profile not validated",w,L)}return o?.debug("Validated terminal profiles",c),c}function p(a){return typeof a=="string"?{id:a}:a}async function h(a){I&&!a||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:a||await u(),icon:O.Codicon.terminalPowershell}))}async function u(){const a=[];for await(const i of(0,C.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function d(a,i){const n=[],r=await new Promise((c,w)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,L)=>{if(E)return w("Problem occurred when getting wsl distros");c(L)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),s=r.split(o).filter(c=>c.trim().length>0&&c!=="");for(const c of s){if(c===""||c.startsWith("docker-desktop"))continue;const w=`${c} (WSL)`,E={profileName:w,path:a,args:["-d",`${c}`],isDefault:w===i,icon:y(c),isAutoDetected:!1};n.push(E)}return n}function y(a){return a.includes("Ubuntu")?O.Codicon.terminalUbuntu:a.includes("Debian")?O.Codicon.terminalDebian:O.Codicon.terminalLinux}async function b(a,i,n,r,o,s,c,w){const E=new Map;if(n){const L=(await a.readFile("/etc/shells")).toString(),T=s||L.split(`
`).filter(z=>z.trim().includes("#")&&z.trim().length>0),F=new Map;for(const z of T){let J=(0,l.basename)(z),Y=F.get(J)||0;Y++,Y>1&&(J=`${J} (${Y})`),F.set(J,Y),E.set(J,{path:z,isAutoDetected:!0})}}return P(r,E),await g(E.entries(),o,a,w,i,c)}function P(a,i){if(!!a)for(const[n,r]of Object.entries(a))r===null||typeof r!="object"||!("path"in r)&&!("source"in r)?i.delete(n):(r.icon=r.icon||i.get(n)?.icon,i.set(n,r))}async function t(a,i,n,r,o,s,c,w,E,L){if(n.length===0)return Promise.resolve(void 0);const T=n.shift();if(T==="")return t(a,i,n,r,o,s,c,w,E);const F=typeof T!="string"&&T.isUnsafe,z=typeof T=="string"?T:T.path,J={profileName:a,path:z,args:s,env:c,overrideName:w,isAutoDetected:E,isDefault:a===i,isUnsafePath:F,requiresUnsafePath:L};if((0,l.basename)(z)===z){const W=o.PATH?o.PATH.split(l.delimiter):void 0,N=await(0,v.findExecutable)(z,void 0,W,void 0,r.existsFile);return N?(J.path=N,J.isFromPath=!0,J):t(a,i,n,r,o,s)}return await r.existsFile((0,l.normalize)(z))?J:t(a,i,n,r,o,s,c,w,E)}}),define(se[257],re([0,1,3,2,21,4,37,66,16,15,97,238,11,251,117,253,256,106]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(P){P[P.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let y=0,b=class extends O.Disposable{constructor(t,a,i,n,r,o){super(),this.C=t,this.D=a,this.F=i,this.G=n,this.H=r,this.I=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new A.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new A.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new A.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new A.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new A.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new A.Emitter),this.onProcessData=this.s.event,this.t=this.B(new A.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new A.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new A.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new A.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new A.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new A.Emitter),this.onProcessExit=this.z.event,(0,p.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,O.toDisposable)(()=>this.O())),this.f=this.B(new f.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(D.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:y,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},a=(0,I.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);a&&(a.break&&a.port?t.debugBrk=a.port:!a.break&&a.port&&(t.debug=a.port));const i=new R.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),k.ProxyChannel.toService(i.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(i.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=d.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))})),this.B(new u.RemoteLoggerChannelClient(this.I,i.getChannel(g.TerminalIpcChannels.Logger)));const r=k.ProxyChannel.toService(i.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(r.onProcessData(o=>this.s.fire(o))),this.B(r.onProcessReady(o=>this.t.fire(o))),this.B(r.onProcessExit(o=>this.z.fire(o))),this.B(r.onDidChangeProperty(o=>this.y.fire(o))),this.B(r.onProcessReplay(o=>this.u.fire(o))),this.B(r.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(r.onDidRequestDetach(o=>this.w.fire(o))),[i,r]}dispose(){this.i=!0,super.dispose()}async createProcess(t,a,i,n,r,o,s,c,w,E,L){const T=setTimeout(()=>this.S(),g.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(t,a,i,n,r,o,s,c,w,E,L);return clearTimeout(T),y=Math.max(y,F),F}updateTitle(t,a,i){return this.b.updateTitle(t,a,i)}updateIcon(t,a,i,n){return this.b.updateIcon(t,a,i,n)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,a){return this.b.detachFromProcess(t,a)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,a){return this.b.shutdown(t,a)}input(t,a){return this.b.input(t,a)}processBinary(t,a){return this.b.processBinary(t,a)}resize(t,a,i){return this.b.resize(t,a,i)}acknowledgeDataEvent(t,a){return this.b.acknowledgeDataEvent(t,a)}setUnicodeVersion(t,a){return this.b.setUnicodeVersion(t,a)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,a){return this.b.installAutoReply(t,a)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,a,i,n=!1){const r=await this.c;return(0,h.detectAvailableProfiles)(a,i,n,this.F,r,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,a){return this.b.getWslPath(t,a)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,a){return this.b.requestDetachInstance(t,a)}async acceptDetachInstanceReply(t,a){return this.b.acceptDetachInstanceReply(t,a)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,a){return this.b.reviveTerminalProcesses(t,a)}async refreshProperty(t,a){return this.b.refreshProperty(t,a)}async updateProperty(t,a,i){return this.b.updateProperty(t,a,i)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,a){return this.f.createRequest({workspaceId:t,originalText:a})}async acceptPtyHostResolvedVariables(t,a){this.f.acceptReply(t,a)}};b=ye([X(2,C.IConfigurationService),X(3,v.IEnvironmentService),X(4,m.ILogService),X(5,m.ILoggerService)],b),e.PtyHostService=b}),define(se[76],re([0,1,3,16,5,11]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var k;(function(p){p.Http="http",p.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=S;function m(p,h,u,d){if(u===1)return!1;if(u===2&&S(h)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(y?.length===4&&parseInt(y[1])>=18)return!1}return p<1024}e.isPortPrivileged=m;class f{constructor(h,u,d){this.remoteAddress=h,this.localAddress=u,this.b=d,this.a=new A.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let g=class{constructor(h,u){this.i=h,this.j=u,this.a=new A.Emitter,this.onTunnelOpened=this.a.event,this.b=new A.Emitter,this.onTunnelClosed=this.b.event,this.c=new A.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],u=Array.from(this.d.values());for(const d of u){const y=Array.from(d.values());for(const b of y){const P=await b.value;P&&h.push(P)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:u}of h.values())await u.then(d=>d?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,u,d,y,b){this.o(h,u,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:u,localAddress:d,privacy:y,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,u){(S(h)||I(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const d=this.q(h,u);if(d)return++d.refcount,d.value}openTunnel(h,u,d,y,b,P=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${d} on local port ${b}.`),!h)return;if(u||(u="localhost"),y||(y=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(h,u,d,y,b,P,t,a);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this.d.get(h.tunnelRemoteHost);if(u){const d=u.get(h.tunnelRemotePort);d&&(d.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,d))}}}}async n(h,u,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const y=d.value.then(async b=>{b&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(u),y}}async closeTunnel(h,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const d=this.d.get(h);if(d&&d.has(u)){const y=d.get(u);y.refcount=0,await this.n(h,u,y)}}o(h,u,d){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(u,{refcount:1,value:d})}async p(h,u){const d=this.d.get(h);d&&(await d.get(u)||d.delete(u),d.size===0&&this.d.delete(h))}q(h,u){const d=[h];I(h)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):S(h)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const y=d.map(b=>this.d.get(b));for(const b of y){const P=b?.get(u);if(P)return P}}canTunnel(h){return!!v(h)}s(h,u,d,y,b,P,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${d} on local port ${y}.`);const a=d;this.h.add(a);const i=y===void 0?d:y,n={elevationRequired:b?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:d},localAddressPort:y,privacy:P,public:P?P!==R.Private:void 0,protocol:t},o=h.forwardPort(r,n);return o?(this.o(u,d,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),o}};g=ye([X(0,D.ILogService),X(1,O.IConfigurationService)],g),e.AbstractTunnelService=g}),define(se[258],re([0,1,11,76,2,7,6]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new k.DeferredPromise),this.b.p)}setAddress(I){this.a=I,this.b&&(this.b.complete(I),this.b=null)}setTunnel(I){this.B(I)}}let C=class Rt extends l.Disposable{constructor(I,S){super(),this.f=I,this.g=S,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Rt.a)}}async startTunnel(I,S,m,f,g,p,h){const u=new R,d=await Promise.resolve(this.f.openTunnel(I,u,m,f,g,p,h));if(!d)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${f} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(S))throw this.c.delete(S),u.dispose(),await d.dispose(),(0,D.canceled)();return u.setTunnel(d),this.b.set(S,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${S}: ${d.localAddress} (local) to ${m}:${f} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(I,S){const m=this.b.get(I);!m||m.setAddress(S)}async destroyTunnel(I){const S=this.b.get(I);if(S){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this.b.delete(I),await S.dispose();return}this.c.add(I)}};C.a=0,C=ye([X(0,O.ISharedTunnelsService),X(1,A.ILogService)],C),e.SharedProcessTunnelService=C}),define(se[259],re([0,1,86,34,136,230,6,2,16,11,25,228,76,111,4]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(b,P,t,a,i){let n;for(let r=3;r&&(n?.dispose(),n=await new h(b,P,t,a,i).waitForReady(),!(i&&l.BROWSER_RESTRICTED_PORTS[i]||!l.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));r--);return n}class h extends R.Disposable{constructor(P,t,a,i,n){super(),this.j=t,this.k=n,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=P,this.b=A.createServer(),this.c=new k.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const P=this.k??this.tunnelRemotePort,t=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,l.findFreePortFaster)(P,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(P){P.pause();const t=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,S.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&P.write(n.buffer),P.on("end",()=>{P.localAddress&&this.i.delete(P.localAddress),i.end()}),P.on("close",()=>i.end()),P.on("error",()=>{P.localAddress&&this.i.delete(P.localAddress),i.destroy()}),i.on("end",()=>P.end()),i.on("close",()=>P.end()),i.on("error",()=>{P.destroy()}),P.pipe(i),i.pipe(P),P.localAddress&&this.i.set(P.localAddress,()=>{P.end(),i.end()})}}let u=class extends m.AbstractTunnelService{constructor(P,t,a,i,n){super(t,n),this.t=P,this.u=a,this.v=i}isPortPrivileged(P){return(0,m.isPortPrivileged)(P,this.k,g.OS,O.release())}r(P,t,a,i,n,r,o,s){const c=this.q(t,a);if(c)return++c.refcount,c.value;if(this.e)return this.s(this.e,t,a,n,r,o,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${n}.`);const w={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:P,signService:this.u,logService:this.i,ipcLogger:null},E=p(w,i,t,a,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,E),E}}};u=ye([X(1,v.ILogService),X(2,f.ISignService),X(3,I.IProductService),X(4,C.IConfigurationService)],u),e.BaseTunnelService=u;let d=class extends u{constructor(P,t,a,i){super(D.nodeSocketFactory,P,t,a,i)}};d=ye([X(0,v.ILogService),X(1,f.ISignService),X(2,I.IProductService),X(3,C.IConfigurationService)],d),e.TunnelService=d;let y=class extends R.Disposable{constructor(P,t,a,i){super(),this.b=P,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(P,t,a,i,n,r,o,s,c){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${r}.`),!this.a.has(P)){const w=new d(this.b,this.f,this.c,this.g);this.B(w),this.a.set(P,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(P))})}return this.a.get(P).openTunnel(t,a,i,n,r,o,s,c)}};y=ye([X(0,v.ILogService),X(1,I.IProductService),X(2,f.ISignService),X(3,C.IConfigurationService)],y),e.SharedTunnelsService=y}),define(se[30],re([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,A.createDecorator)("IUriIdentityService")}),define(se[260],re([0,1,30,69,14,24,132,3,2]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{constructor(m){this.uri=m,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let I=class{constructor(m){this.g=m,this.c=new C.DisposableStore,this.f=2**16;const f=new Map,g=p=>{let h=f.get(p.scheme);return h===void 0&&(h=m.hasProvider(p)&&!this.g.hasCapability(p,1024),f.set(p.scheme,h)),h};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(p=>{f.delete(p.scheme)})),this.extUri=new D.ExtUri(g),this.d=new k.SkipList((p,h)=>this.extUri.compare(p,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,D.normalizePath)(m));const f=this.d.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new v(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);v._clock=0,this.d.clear();const f=this.f*.5;for(let g=0;g<f;g++)this.d.set(m[g][0],m[g][1].touch())}};I=ye([X(0,l.IFileService)],I),e.UriIdentityService=I,(0,O.registerSingleton)(A.IUriIdentityService,I,1)}),define(se[261],re([0,1,3,2,14,43,49,17]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends O.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(I,S,m,f){super(),this.c=I,this.f=S,this.g=m,this.h=f,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new A.Emitter),this.onDidChangeFile=this.a.event,this.b=k.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(g=>this.i(g)))}watch(I,S){this.b.set(I,I);const m=this.f.watch(this.j(I),S);return(0,O.toDisposable)(()=>{this.b.delete(I),m.dispose()})}stat(I){return this.f.stat(this.j(I))}mkdir(I){return this.f.mkdir(this.j(I))}rename(I,S,m){return this.f.rename(this.j(I),this.j(S),m)}readFile(I){return this.f.readFile(this.j(I),{atomic:!0})}readFileStream(I,S,m){const f=(0,D.newWriteableStream)(g=>R.VSBuffer.concat(g.map(p=>R.VSBuffer.wrap(p))).buffer);return(async()=>{try{const g=await this.readFile(I);f.end(g)}catch(g){f.error(g),f.end()}})(),f}readdir(I){return this.f.readdir(this.j(I))}writeFile(I,S,m){return this.f.writeFile(this.j(I),S,m)}delete(I,S){return this.f.delete(this.j(I),S)}copy(I,S,m){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(I),this.j(S),m);throw new Error("copy not supported")}i(I){const S=[];for(const m of I){if(m.resource.scheme!==this.c)continue;const f=this.k(m.resource);this.b.findSubstr(f)&&S.push({resource:f,type:m.type})}S.length&&(this.h.debug("User data changed"),this.a.fire(S))}j(I){return I.with({scheme:this.c})}k(I){return I.with({scheme:this.g})}}e.FileUserDataProvider=C}),define(se[60],re([0,1,83]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(k,R,C,v){const I=(0,A.setProperty)(k,R,C,v)[0];return I&&(k=k.substring(0,I.offset)+I.content+k.substring(I.offset+I.length)),k}e.edit=O;function l(k,R,C){let v=C;for(;v>=0;){if(k.charAt(v)===R.charAt(R.length-1)&&R.length===1)return v+1;if(v--,R.length===2&&v>=0&&k.charAt(v)===R.charAt(0))return v+2}return 0}e.getLineStartOffset=l;function D(k,R,C){let v=C;for(;v>=0;)if(k.charAt(v)===R.charAt(R.length-1)&&R.length===1||(v++,R.length===2&&v>=0&&k.charAt(v)===R.charAt(1)))return v;return k.length-1}e.getLineEndOffset=D}),define(se[262],re([0,1,32,54,12]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(f,g,p,h,u,d){const y=[],b=[],P=[];if(!g){const Y=f.filter(({identifier:W})=>u.every(N=>N.toLowerCase()!==W.id.toLowerCase()));return{local:{added:y,removed:b,updated:P},remote:Y.length>0?{added:Y,updated:[],removed:[],all:Y}:null}}f=f.map(S),g=g.map(S),p=p?p.map(S):null;const t=new Map,a=Y=>{Y.uuid&&t.set(Y.id.toLowerCase(),Y.uuid)};f.forEach(({identifier:Y})=>a(Y)),g.forEach(({identifier:Y})=>a(Y)),p?.forEach(({identifier:Y})=>a(Y));const i=Y=>{const W=Y.identifier.uuid||t.get(Y.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${Y.identifier.id.toLowerCase()}`},n=(Y,W)=>(Y.set(i(W),W),Y),r=f.reduce(n,new Map),o=g.reduce(n,new Map),s=g.reduce((Y,W)=>n(Y,(0,A.deepClone)(W)),new Map),c=p?p.reduce(n,new Map):null,w=h.reduce(n,new Map),E=u.reduce((Y,W)=>{const N=t.get(W.toLowerCase());return Y.add(N?`uuid:${N}`:`id:${W.toLowerCase()}`)},new Set),L=d?d.reduce((Y,{id:W,uuid:N})=>(N=N??t.get(W.toLowerCase()),Y.add(N?`uuid:${N}`:`id:${W.toLowerCase()}`)),new Set):null,T=k(r,o,E,!1);if(T.added.size>0||T.removed.size>0||T.updated.size>0){const Y=k(c,r,E,!1),W=k(c,o,E,!0),N=(B,ie,q,x)=>{let U,K,Q;return ie.installed?(U=x.pinned,Q=x.preRelease,U&&(K=x.version)):(U=q.pinned,Q=q.preRelease,U&&(K=q.version)),U===void 0&&(U=ie.pinned,U&&(K=ie.version)),Q===void 0&&(Q=ie.preRelease),{...x,installed:ie.installed||q.installed,pinned:U,preRelease:Q,version:K??(q.version&&(!ie.installed||O.gt(q.version,ie.version))?q.version:ie.version),state:C(ie,q,c?.get(B))}};for(const B of W.removed.values()){const ie=r.get(B);if(!ie)continue;const q=(0,l.assertIsDefined)(c?.get(B)),x=L&&!L.has(B)&&q.installed;ie.installed&&x?b.push(ie.identifier):s.set(B,ie)}for(const B of W.added.values()){const ie=(0,l.assertIsDefined)(o.get(B)),q=r.get(B);if(q){if(T.updated.has(B)){const x=N(B,q,ie,ie);R(q,ie,!1,!1)||P.push(m(x,B)),s.set(B,x)}}else ie.installed&&y.push(m(ie,B))}for(const B of W.updated.values()){const ie=(0,l.assertIsDefined)(o.get(B)),q=(0,l.assertIsDefined)(c?.get(B)),x=r.get(B);if(x)if(L&&!L.has(B)&&q.installed&&x.installed&&!ie.installed)b.push(x.identifier);else{const K=N(B,x,ie,ie);P.push(m(K,B)),s.set(B,K)}else ie.installed&&y.push(m(ie,B))}for(const B of Y.added.values())W.added.has(B)||s.set(B,(0,l.assertIsDefined)(r.get(B)));for(const B of Y.updated.values()){if(W.removed.has(B)||W.updated.has(B))continue;const ie=(0,l.assertIsDefined)(r.get(B)),q=(0,l.assertIsDefined)(o.get(B));s.set(B,N(B,ie,q,ie))}for(const B of Y.removed.values())W.updated.has(B)||W.removed.has(B)||w.has(B)||!(0,l.assertIsDefined)(o.get(B)).installed||!L||L.has(B)||!(0,l.assertIsDefined)(c?.get(B)).installed||s.delete(B)}const F=[],z=k(o,s,new Set,!0),J=z.added.size>0||z.updated.size>0||z.removed.size>0;return J&&s.forEach((Y,W)=>F.push(m(Y,W))),{local:{added:y,removed:b,updated:P},remote:J?{added:[...z.added].map(Y=>s.get(Y)),updated:[...z.updated].map(Y=>s.get(Y)),removed:[...z.removed].map(Y=>o.get(Y)),all:F}:null}}e.merge=D;function k(f,g,p,h){const u=f?[...f.keys()].filter(t=>!p.has(t)):[],d=[...g.keys()].filter(t=>!p.has(t)),y=d.filter(t=>u.indexOf(t)===-1).reduce((t,a)=>(t.add(a),t),new Set),b=u.filter(t=>d.indexOf(t)===-1).reduce((t,a)=>(t.add(a),t),new Set),P=new Set;for(const t of u){if(b.has(t))continue;const a=f.get(t),i=g.get(t);(!i||!R(a,i,h,!0))&&P.add(t)}return{added:y,removed:b,updated:P}}function R(f,g,p,h){return!(f.disabled!==g.disabled||h&&f.installed!==g.installed||f.installed&&g.installed&&(f.preRelease!==g.preRelease||f.pinned!==g.pinned||g.pinned&&f.version!==g.version)||!I(f.state,g.state)||p&&f.version!==g.version)}function C(f,g,p){const h=f.state,u=g.state,d=p?.state;if(!g.version||h&&O.gt(f.version,g.version))return h;if(u&&O.gt(g.version,f.version)||!h)return u;if(!u)return h;const y=(0,A.deepClone)(h),b=d?v(d,u):{added:Object.keys(u).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set},P=d?v(d,h):{added:Object.keys(h).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set};for(const t of[...b.added.values(),...b.updated.values()])y[t]=u[t];for(const t of b.removed.values())P.updated.has(t)||delete y[t];return y}function v(f,g){const p=Object.keys(f),h=Object.keys(g),u=h.filter(b=>p.indexOf(b)===-1).reduce((b,P)=>(b.add(P),b),new Set),d=p.filter(b=>h.indexOf(b)===-1).reduce((b,P)=>(b.add(P),b),new Set),y=new Set;for(const b of p){if(d.has(b))continue;const P=f[b],t=g[b];(0,A.equals)(P,t)||y.add(b)}return{added:u,removed:d,updated:y}}function I(f={},g={}){const{added:p,removed:h,updated:u}=v(f,g);return p.size===0&&h.size===0&&u.size===0}function S(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function m(f,g){const p={identifier:{id:f.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},version:f.version,preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled&&(p.disabled=!0),f.installed&&(p.installed=!0),f.state&&(p.state=f.state),p}}),define(se[118],re([0,1,18,16,5]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let D=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let v=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return v=v.filter(I=>I!==R&&I!==`-${R}`),C&&v.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}updateSynchronizedExtensions(R,C){let v=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return v=v.filter(I=>I!==R&&I!==`-${R}`),C&&v.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}getIgnoredExtensions(R){const C=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),v=this.b().map(m=>m.toLowerCase()),I=[],S=[];if(Array.isArray(v))for(const m of v)m.startsWith("-")?S.push(m.substring(1)):I.push(m);return(0,A.distinct)([...C,...I].filter(m=>S.indexOf(m)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};D=ye([X(0,O.IConfigurationService)],D),e.IgnoredExtensionsManagementService=D}),define(se[263],re([0,1,18,35,32,202,60]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(b){return(0,O.parse)(b)||[]}async function C(b,P,t,a,i){const n=R(b),r=R(P),o=t?R(t):null,s=[...n,...r,...o||[]].map(N=>N.key),c=await i.resolveUserBindings(s),w=I(n,r,o,c);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:P,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const E=m(n),L=m(r),T=o?m(o):null,F=g(E,L,c),z=T?g(T,E,c):{added:[...E.keys()].reduce((N,B)=>(N.add(B),N),new Set),removed:new Set,updated:new Set},J=T?g(T,L,c):{added:[...L.keys()].reduce((N,B)=>(N.add(B),N),new Set),removed:new Set,updated:new Set},Y=v(F,z,J);let W=b;for(const N of Y.removed.values())Y.conflicts.has(N)||(W=d(W,N,a));for(const N of Y.added.values()){if(Y.conflicts.has(N))continue;const B=L.get(N);if(B.some(ie=>ie.command!==`-${N}`&&w.conflicts.has(c[ie.key]))){Y.conflicts.add(N);continue}W=u(W,B,a)}for(const N of Y.updated.values()){if(Y.conflicts.has(N))continue;const B=L.get(N);if(B.some(ie=>ie.command!==`-${N}`&&w.conflicts.has(c[ie.key]))){Y.conflicts.add(N);continue}W=y(W,N,B,a)}return{mergeContent:W,hasChanges:!0,hasConflicts:Y.conflicts.size>0}}e.merge=C;function v(b,P,t){const a=new Set,i=new Set,n=new Set,r=new Set;for(const o of P.removed.values())t.updated.has(o)&&r.add(o);for(const o of t.removed.values())r.has(o)||(P.updated.has(o)?r.add(o):i.add(o));for(const o of P.added.values())r.has(o)||t.added.has(o)&&b.updated.has(o)&&r.add(o);for(const o of t.added.values())r.has(o)||(P.added.has(o)?b.updated.has(o)&&r.add(o):a.add(o));for(const o of P.updated.values())r.has(o)||t.updated.has(o)&&b.updated.has(o)&&r.add(o);for(const o of t.updated.values())r.has(o)||(P.updated.has(o)?b.updated.has(o)&&r.add(o):n.add(o));return{added:a,removed:i,updated:n,conflicts:r}}function I(b,P,t,a){const i=new Set,n=S(b,a),r=S(P,a),o=t?S(t,a):null,s=f(n,r);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const c=o?f(o,n):{added:[...n.keys()].reduce((z,J)=>(z.add(J),z),new Set),removed:new Set,updated:new Set};if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=o?f(o,r):{added:[...r.keys()].reduce((z,J)=>(z.add(J),z),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:E,removed:L,updated:T,conflicts:F}=v(s,c,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:L,updated:T,conflicts:F}}function S(b,P){const t=new Map;for(const a of b){const i=P[a.key];let n=t.get(i);n||(n=[],t.set(i,n)),n.push(a)}return t}function m(b){const P=new Map;for(const t of b){const a=t.command[0]==="-"?t.command.substring(1):t.command;let i=P.get(a);i||(i=[],P.set(a,i)),i.push(t)}return P}function f(b,P){const t=[...b.keys()],a=[...P.keys()],i=a.filter(o=>t.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),n=t.filter(o=>a.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),r=new Set;for(const o of t){if(n.has(o))continue;const s=b.get(o).map(w=>({...w,key:o})),c=P.get(o).map(w=>({...w,key:o}));(0,A.equals)(s,c,(w,E)=>h(w,E))||r.add(o)}return{added:i,removed:n,updated:r}}function g(b,P,t){const a=[...b.keys()],i=[...P.keys()],n=i.filter(s=>a.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),r=a.filter(s=>i.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of a){if(r.has(s))continue;const c=b.get(s).map(E=>({...E,key:t[E.key]})),w=P.get(s).map(E=>({...E,key:t[E.key]}));p(c,w)||o.add(s)}return{added:n,removed:r,updated:o}}function p(b,P){return!(!(0,A.equals)(b.filter(({command:t})=>t[0]!=="-"),P.filter(({command:t})=>t[0]!=="-"),(t,a)=>h(t,a))||!(0,A.equals)(b.filter(({command:t})=>t[0]==="-"),P.filter(({command:t})=>t[0]==="-"),(t,a)=>h(t,a)))}function h(b,P){if(b.command!==P.command||b.key!==P.key)return!1;const t=D.ContextKeyExpr.deserialize(b.when),a=D.ContextKeyExpr.deserialize(P.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!l.equals(b.args,P.args))}function u(b,P,t){for(const a of P)b=k.edit(b,[-1],a,t);return b}function d(b,P,t){const a=R(b);for(let i=a.length-1;i>=0;i--)(a[i].command===P||a[i].command===`-${P}`)&&(b=k.edit(b,[i],void 0,t));return b}function y(b,P,t,a){const i=R(b),n=i.findIndex(r=>r.command===P||r.command===`-${P}`);for(let r=i.length-1;r>=0;r--)(i[r].command===P||i[r].command===`-${P}`)&&(b=k.edit(b,[r],void 0,a));for(let r=t.length-1;r>=0;r--)b=k.edit(b,[n],t[r],a);return b}}),define(se[264],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function A(D,k,R){const C={},v={},I=new Set;if(!k)return{local:{added:C,updated:v,removed:[...I.values()]},remote:{added:D,updated:{},removed:[]},conflicts:[]};const S=O(D,k);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:C,updated:v,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=O(R,D),f=O(R,k),g={},p={},h=new Set,u=new Set;for(const d of m.removed.values())f.updated.has(d)?C[d]=k[d]:h.add(d);for(const d of f.removed.values())u.has(d)||(m.updated.has(d)?u.add(d):I.add(d));for(const d of m.updated.values())u.has(d)||(f.updated.has(d)?S.updated.has(d)&&u.add(d):p[d]=D[d]);for(const d of f.updated.values())u.has(d)||(m.updated.has(d)?S.updated.has(d)&&u.add(d):D[d]!==void 0&&(v[d]=k[d]));for(const d of m.added.values())u.has(d)||(f.added.has(d)?S.updated.has(d)&&u.add(d):g[d]=D[d]);for(const d of f.added.values())u.has(d)||(m.added.has(d)?S.updated.has(d)&&u.add(d):C[d]=k[d]);return{local:{added:C,removed:[...I.values()],updated:v},remote:{added:g,removed:[...h.values()],updated:p},conflicts:[...u.values()]}}e.merge=A;function O(D,k){const R=D?Object.keys(D):[],C=k?Object.keys(k):[],v=C.filter(m=>R.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),I=R.filter(m=>C.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),S=new Set;for(const m of R){if(I.has(m))continue;const f=D[m],g=k[m];f!==g&&S.add(m)}return{added:v,removed:I,updated:S}}function l(D,k){const{added:R,removed:C,updated:v}=O(D,k);return R.size===0&&C.size===0&&v.size===0}e.areSame=l}),define(se[265],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(l,D,k,R){const C={added:[],removed:[],updated:[]};let v={added:[],removed:[],updated:[]};if(!D){const S=l.filter(({id:m})=>!R.includes(m));return S.length?v.added=S:v=null,{local:C,remote:v}}const I=O(l,D,R);if(I.added.length>0||I.removed.length>0||I.updated.length>0){const S=O(k,l,R),m=O(k,D,R);for(const f of m.removed){const g=l.find(p=>p.id===f);g&&C.removed.push(g)}for(const f of m.added){const g=D.find(p=>p.id===f);S.added.includes(f)?I.updated.includes(f)&&C.updated.push(g):C.added.push(g)}for(const f of m.updated)C.updated.push(D.find(g=>g.id===f));for(const f of S.added)m.added.includes(f)||v.added.push(l.find(g=>g.id===f));for(const f of S.updated)m.removed.includes(f)||m.updated.includes(f)||v.updated.push(l.find(g=>g.id===f));for(const f of S.removed){const g=D.find(p=>p.id===f);g&&v.removed.push(g)}}return v.added.length===0&&v.removed.length===0&&v.updated.length===0&&(v=null),{local:C,remote:v}}e.merge=A;function O(l,D,k){l=l?l.filter(({id:m})=>!k.includes(m)):[],D=D.filter(({id:m})=>!k.includes(m));const R=l.map(({id:m})=>m),C=D.map(({id:m})=>m),v=C.filter(m=>R.indexOf(m)===-1),I=R.filter(m=>C.indexOf(m)===-1),S=[];for(const{id:m,name:f,shortName:g}of l){if(I.includes(m))continue;const p=D.find(h=>h.id===m);(!p||p.name!==f||p.shortName!==g)&&S.push(m)}return{added:v,removed:I,updated:S}}}),define(se[22],re([0,1,18,12,186,45,29,5,108,40]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const r=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(o=>!!r[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function S(){const r=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(r).filter(w=>!!r[w].ignoreSync),s=Object.keys(r).filter(w=>r[w].scope===2||r[w].scope===6),c=I();return(0,A.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...s,...c])}e.getDefaultIgnoredSettings=S,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const r="vscode://schemas/ignoredSettings",o=v.Registry.as(D.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const s=v.Registry.as(C.Extensions.JSONContribution),c=()=>{const w=I(),E=S().filter(z=>z!==e.CONFIGURATION_SYNC_STORE_KEY),L=Object.keys(D.allSettings.properties).filter(z=>E.indexOf(z)===-1),T=E.filter(z=>w.indexOf(z)===-1),F={items:{type:"string",enum:[...L,...T.map(z=>`-${z}`)]}};s.registerSchema(r,F)};return o.onDidUpdateConfiguration(()=>c())}e.registerConfiguration=m;function f(r){return r&&(0,O.isObject)(r)&&(0,O.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=f;var g;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(g=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(r,...o){return r?[r,...o]:o}e.getPathSegments=p;function h(r,o,s,c){return c.joinPath(s.userDataSyncHome,...p(r,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=h,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(r){const o={};return o[e.HEADER_EXECUTION_ID]=r,o}e.createSyncHeaders=u;var d;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(o,s,c,w){super(o),this.code=s,this.resource=c,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class b extends y{constructor(o,s,c,w,E){super(o,c,void 0,E),this.url=s,this.serverCode=w}}e.UserDataSyncStoreError=b;class P extends y{constructor(o,s){super(o,s)}}e.UserDataAutoSyncError=P,function(r){function o(s){if(s instanceof r)return s;const c=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(s.name);if(c&&c[1]){const w=c[2]==="unknown"?void 0:c[2],E=c[3]==="unknown"?void 0:c[3];return new r(s.message,c[1],w,E)}return new r(s.message,"Unknown")}r.toUserDataSyncError=o}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var a;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(r){return`sync.enable.${r}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(se[266],re([0,1,32,22]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(k,R,C,v,I){if(!R)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const S=D(k,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=C?D(C,R):{added:Object.keys(R).reduce((d,y)=>(d.add(y),d),new Set),removed:new Set,updated:new Set},f=C?D(C,k):{added:Object.keys(k).reduce((d,y)=>(d.add(y),d),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},p=A.deepClone(R),h=!C;for(const d of f.added.values())d!==O.SYNC_SERVICE_URL_TYPE&&h&&m.added.has(d)||(p[d]=k[d]);for(const d of f.updated.values())p[d]=k[d];for(const d of f.removed.values())v.unregistered.includes(d)||delete p[d];for(const d of m.added.values()){const y=R[d];if(v.machine.includes(d)){I.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(C&&f.added.has(d))continue;const b=k[d];b&&b.value===y.value||d===O.SYNC_SERVICE_URL_TYPE&&h&&f.added.has(d)||(b?g.updated[d]=y:g.added[d]=y)}for(const d of m.updated.values()){const y=R[d];if(v.machine.includes(d)){I.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(d)||f.removed.has(d))continue;const b=k[d];b&&b.value===y.value||(g.updated[d]=y)}for(const d of m.removed.values()){if(v.machine.includes(d)){I.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}f.updated.has(d)||f.removed.has(d)||g.removed.push(d)}const u=D(R,p);return{local:g,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}e.merge=l;function D(k,R){const C=Object.keys(k),v=Object.keys(R),I=v.filter(f=>C.indexOf(f)===-1).reduce((f,g)=>(f.add(g),f),new Set),S=C.filter(f=>v.indexOf(f)===-1).reduce((f,g)=>(f.add(g),f),new Set),m=new Set;for(const f of C){if(S.has(f))continue;const g=k[f],p=R[f];A.equals(g,p)||m.add(f)}return{added:I,removed:S,updated:m}}}),define(se[267],re([0,1,18,35,83,42,32,60,22]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function v(s,c,w){let E=[];w?E=S(w):E=I(c);const L=[],T=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const F of E)F.startsWith("-")?T.push(F.substring(1)):L.push(F);return(0,A.distinct)([...s,...L].filter(F=>T.indexOf(F)===-1))}e.getIgnoredSettings=v;function I(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function S(s){const c=(0,O.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function m(s,c){const w=(0,O.parse)(s)||{};let E="{}";for(const L of Object.keys(w)){const T=(0,l.setProperty)(E,[L],w[L],c);E=(0,l.applyEdits)(E,T)}return E}e.removeComments=m;function f(s,c,w,E){if(w.length){const L=o(c),T=(0,O.parse)(c)||{},F=(0,O.parse)(s);if(!F)return s;const z=[];for(const J of w){const Y=T[J],W=F[J];Y===void 0?s=R.edit(s,[J],void 0,E):W!==void 0?s=R.edit(s,[J],Y,E):z.push(t(J,L))}z.sort((J,Y)=>J.startOffset-Y.startOffset),z.forEach(J=>s=d(J.setting.key,c,s,E))}return s}e.updateIgnoredSettings=f;function g(s,c,w,E,L,T){const F=f(s,c,E,T),z=w!==F,J=w!==c;if(!z&&!J)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!J)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(J&&!z)return{conflictsSettings:[],localContent:f(c,s,E,T),remoteContent:null,hasConflicts:!1};if(w===null&&h(s)){const $=p(s,c,E)?null:f(c,s,E,T);return{conflictsSettings:[],localContent:$,remoteContent:null,hasConflicts:!1}}let Y=s,W=c;const N=(0,O.parse)(s),B=(0,O.parse)(c),ie=w?(0,O.parse)(w):null,q=E.reduce(($,H)=>($.add(H),$),new Set),x=u(N,B,q),U=u(ie,N,q),K=u(ie,B,q),Q=new Map,oe=new Set,ae=$=>{oe.add($);const H=L.filter(({key:ee})=>ee===$)[0];H?(Y=R.edit(Y,[$],H.value,T),W=R.edit(W,[$],H.value,T)):Q.set($,{key:$,localValue:N[$],remoteValue:B[$]})};for(const $ of U.removed.values())K.updated.has($)?ae($):W=R.edit(W,[$],void 0,T);for(const $ of K.removed.values())oe.has($)||(U.updated.has($)?ae($):Y=R.edit(Y,[$],void 0,T));for(const $ of U.updated.values())oe.has($)||(K.updated.has($)?x.updated.has($)&&ae($):W=R.edit(W,[$],N[$],T));for(const $ of K.updated.values())oe.has($)||(U.updated.has($)?x.updated.has($)&&ae($):Y=R.edit(Y,[$],B[$],T));for(const $ of U.added.values())oe.has($)||(K.added.has($)?x.updated.has($)&&ae($):W=d($,Y,W,T));for(const $ of K.added.values())oe.has($)||(U.added.has($)?x.updated.has($)&&ae($):Y=d($,W,Y,T));const V=Q.size>0||!p(Y,W,E),j=V||!p(Y,s,[]),M=V||!p(W,c,[]);return{localContent:j?Y:null,remoteContent:M?W:null,conflictsSettings:[...Q.values()],hasConflicts:V}}e.merge=g;function p(s,c,w){if(s===c)return!0;const E=(0,O.parse)(s),L=(0,O.parse)(c),T=w.reduce((J,Y)=>(J.add(Y),J),new Set),F=o(s).filter(J=>!(J.setting&&T.has(J.setting.key))),z=o(c).filter(J=>!(J.setting&&T.has(J.setting.key)));if(F.length!==z.length)return!1;for(let J=0;J<F.length;J++){const Y=F[J],W=z[J];if(Y.setting&&W.setting){if(Y.setting.key!==W.setting.key||!k.equals(E[Y.setting.key],L[Y.setting.key]))return!1}else if(!Y.setting&&!W.setting){if(Y.value!==W.value)return!1}else return!1}return!0}function h(s){return s?o(s).length===0:!0}e.isEmpty=h;function u(s,c,w){const E=s?Object.keys(s).filter(J=>!w.has(J)):[],L=Object.keys(c).filter(J=>!w.has(J)),T=L.filter(J=>E.indexOf(J)===-1).reduce((J,Y)=>(J.add(Y),J),new Set),F=E.filter(J=>L.indexOf(J)===-1).reduce((J,Y)=>(J.add(Y),J),new Set),z=new Set;if(s)for(const J of E){if(F.has(J))continue;const Y=s[J],W=c[J];k.equals(Y,W)||z.add(J)}return{added:T,removed:F,updated:z}}function d(s,c,w,E){const L=(0,O.parse)(c),T=o(c),F=o(w),z=y(s,T,F);return b(w,s,L[s],z,F,E)}e.addSetting=d;function y(s,c,w){const E=c.findIndex(T=>T.setting?.key===s),L=c[E-1];if(L){if(L.setting){const F=t(L.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!0}}else{const F=a(E,c);if(F){const z=t(F.setting.key,w);if(z){const J=i(w.indexOf(z),w),Y=n(c,F,c[E]);if(J){const W=n(w,z,J),N=r(Y,W);return N?{index:w.indexOf(N),insertAfter:!0}:{index:w.indexOf(J),insertAfter:!1}}else{const W=n(w,z,w[w.length-1]),N=r(Y,W);return N?{index:w.indexOf(N),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const T=c[E+1];if(T)if(T.setting){const F=t(T.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!1}}else{const F=i(E,c);if(F){const z=t(F.setting.key,w);if(z){const J=a(w.indexOf(z),w),Y=n(c,c[E],F);if(J){const W=n(w,J,z),N=r(Y.reverse(),W.reverse());return N?{index:w.indexOf(N),insertAfter:!1}:{index:w.indexOf(J),insertAfter:!0}}else{const W=n(w,w[0],z),N=r(Y.reverse(),W.reverse());return N?{index:w.indexOf(N),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function b(s,c,w,E,L,T){let F;return E.index===-1?F=(0,l.setProperty)(s,[c],w,T):F=P(s,c,w,E,L,T).map(z=>(0,l.withFormatting)(s,z,T)[0]),(0,l.applyEdits)(s,F)}function P(s,c,w,E,L,T){const F=`${JSON.stringify(c)}: ${JSON.stringify(w)}`,z=(0,D.getEOL)(T,s),J=L[E.index];if(E.insertAfter){const Y=[];if(J.setting)Y.push({offset:J.endOffset,length:0,content:","+F});else{const W=i(E.index,L),N=a(E.index,L),B=N?.setting?.commaOffset;N&&B===void 0&&Y.push({offset:N.endOffset,length:0,content:","});const ie=B!==void 0&&B>J.endOffset;Y.push({offset:ie?B+1:J.endOffset,length:0,content:W?z+F+",":z+F})}return Y}else{if(J.setting)return[{offset:J.startOffset,length:0,content:F+","}];const Y=(L[E.index-1]&&!L[E.index-1].setting?z:"")+F+(i(E.index,L)?",":"")+z;return[{offset:J.startOffset,length:0,content:Y}]}}function t(s,c){return c.filter(w=>w.setting?.key===s)[0]}function a(s,c){for(let w=s-1;w>=0;w--)if(c[w].setting)return c[w]}function i(s,c){for(let w=s+1;w<c.length;w++)if(c[w].setting)return c[w]}function n(s,c,w){const E=s.indexOf(c),L=s.indexOf(w);return s.filter((T,F)=>E<F&&F<L)}function r(s,c){if(s.length&&c.length){let w=0;for(;w<c.length&&w<s.length;w++)if(s[w].value!==c[w].value)return c[w-1];return c[w-1]}}function o(s){const c=[];let w=-1,E,L;const T={onObjectBegin:F=>{w++},onObjectProperty:(F,z,J)=>{w===0&&(E=z,L=F)},onObjectEnd:(F,z)=>{w--,w===0&&c.push({startOffset:E,endOffset:F+z,value:s.substring(E,F+z),setting:{key:L,commaOffset:void 0}})},onArrayBegin:(F,z)=>{w++},onArrayEnd:(F,z)=>{w--,w===0&&c.push({startOffset:E,endOffset:F+z,value:s.substring(E,F+z),setting:{key:L,commaOffset:void 0}})},onLiteralValue:(F,z,J)=>{w===0&&c.push({startOffset:E,endOffset:z+J,value:s.substring(E,z+J),setting:{key:L,commaOffset:void 0}})},onSeparator:(F,z,J)=>{if(w===0&&F===","){let Y=c.length-1;for(;Y>=0&&!c[Y].setting;Y--);const W=c[Y];W&&c.splice(Y,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:z}})}},onComment:(F,z)=>{w===0&&c.push({startOffset:F,endOffset:F+z,value:s.substring(F,F+z)})}};return(0,O.visit)(s,T),c}}),define(se[77],re([0,1,3,2,5,22]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let k=class extends O.Disposable{get account(){return this.a}constructor(C,v){super(),this.g=C,this.h=v,this.b=this.B(new A.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new A.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};k=ye([X(0,D.IUserDataSyncStoreService),X(1,D.IUserDataSyncLogService)],k),e.UserDataSyncAccountService=k}),define(se[268],re([0,1,2,10]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(m){this.a=m}listen(m,f){switch(f){case"onError":return this.a.onError}throw new Error(`Event not found: ${f}`)}call(m,f,g){switch(f){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class D{constructor(m){this.a=m}listen(m,f){throw new Error(`Event not found: ${f}`)}call(m,f,g){switch(f){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(O.URI.revive(g[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=D;class k{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=k;class R{constructor(m){this.a=m}listen(m,f){switch(f){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${f}`)}async call(m,f,g){switch(f){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(m){this.a=m}listen(m,f){switch(f){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${f}`)}call(m,f,g){switch(f){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class v{constructor(m){this.a=m}listen(m,f){switch(f){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${f}`)}call(m,f,g){switch(f){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class I extends A.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:O.URI.revive(m.url),type:m.type,defaultUrl:O.URI.revive(m.defaultUrl),insidersUrl:O.URI.revive(m.insidersUrl),stableUrl:O.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(se[269],re([0,1,187,15,11,22]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends l.AbstractLogger{constructor(C,v){super(),this.g=this.B(C.createLogger(v.userDataSyncLogResource,{id:D.USER_DATA_SYNC_LOG_ID,name:(0,A.localize)(0,null)}))}trace(C,...v){this.g.trace(C,...v)}debug(C,...v){this.g.debug(C,...v)}info(C,...v){this.g.info(C,...v)}warn(C,...v){this.g.warn(C,...v)}error(C,...v){this.g.error(C,...v)}flush(){this.g.flush()}};k=ye([X(0,l.ILoggerService),X(1,O.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(se[270],re([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(se[271],re([0,1,6,3,2]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends l.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:v}){super(),this.a=this.B(new l.DisposableStore),O.Event.latch(O.Event.any(R,C))(this.f,this,this.a),this.b=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=D}),define(se[119],re([0,1,190,13,49,24,10,5,21]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function v(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=v;function I(i){return typeof i?.id=="string"&&!v(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=S;function m(i){const n=i;return typeof n?.id=="string"&&k.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=m;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:k.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=f;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=p;function h(i){const n=i;return!!(n&&typeof n=="object"&&k.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(n,r,o,s,c){this.h=n,this.j=o,this.k=s,this.l=c,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function y(i){return new d({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function P(i){let n;return k.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=P;function t(i,n){return!b(i,n)&&!P(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,O.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(se[28],re([0,1,65,3,2,24,10,181,15,14,5,11,119,38,30,6,31,26,12]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}e.isUserDataProfile=y,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function b(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:k.URI.revive(i.location).with({scheme:n}),globalStorageHome:k.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=b;function P(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,D.joinPath)(r,"globalStorage"),settingsResource:(0,D.joinPath)(r,"settings.json"),keybindingsResource:(0,D.joinPath)(r,"keybindings.json"),tasksResource:(0,D.joinPath)(r,"tasks.json"),snippetsHome:(0,D.joinPath)(r,"snippets"),extensionsResource:(0,D.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=P;let t=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,s){super(),this.m=n,this.n=r,this.r=o,this.s=s,this.f=!0,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const c of this.I()){if(!c.name||!(0,d.isString)(c.name)||!c.location){this.s.warn("Skipping the invalid stored profile",c.location||c.name);continue}n.push(P((0,D.basename)(c.location),c.name,c.location,{shortName:c.shortName,useDefaultFlags:c.useDefaultFlags}))}}catch(c){this.s.error(c)}const r=new f.ResourceMap,o=new Map,s=this.v();if(n.unshift({...s,extensionsResource:this.N()??s.extensionsResource,isDefault:!0}),n.length)try{const c=this.L();if(c.workspaces)for(const[w,E]of Object.entries(c.workspaces)){const L=k.URI.parse(w),T=n.find(F=>F.id===E);T&&r.set(L,T)}if(c.emptyWindows)for(const[w,E]of Object.entries(c.emptyWindows)){const L=n.find(T=>T.id===E);L&&o.set(w,L)}}catch(c){this.s.error(c)}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}v(){return P("__default__profile__",(0,R.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let s=0;for(const w of this.profiles){const E=o.exec(w.name),L=E?parseInt(E[1]):0;s=L>s?L:s}const c=`${r} ${s+1}`;return this.createProfile((0,A.hash)((0,h.generateUuid)()).toString(16),c,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,A.hash)((0,h.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=await this.w(n,r,o);return s&&await this.setProfileForWorkspace(s,c),c}async w(n,r,o){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(r);return s||(s=(async()=>{try{const c=this.profiles.find(L=>L.name===r||L.id===n);if(c)return c;const w=P(n,r,(0,D.joinPath)(this.profilesHome,n),o);await this.n.createFolder(w.location);const E=[];return this.h.fire({profile:w,join(L){E.push(L)}}),await p.Promises.settled(E),this.C([w],[],[]),w}finally{this.k.delete(r)}})(),this.k.set(r,s)),s}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(s=>s.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=P(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.C([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(s){o.push(s)}});try{await Promise.allSettled(o)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(s=>s.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return k.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,o){const s=[...this.profiles,...n],c=[];this.l.profiles=[];for(let w of s)w.isDefault||r.some(E=>w.id===E.id)||(w=o.find(E=>w.id===E.id)??w,w.isTransient?this.l.profiles.push(w):c.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.J(c),this.t=void 0,this.D(n,r,o)}D(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}F(n,r,o){o=r?.isTransient?!0:o,o||this.F(n,void 0,!0);const s=this.y(n),c=o?this.l:this.u;k.URI.isUri(s)?(c.workspaces.delete(s),r&&c.workspaces.set(s,r)):(c.emptyWindows.delete(s),r&&c.emptyWindows.set(s,r)),o||this.G()}G(){const n={};for(const[o,s]of this.u.workspaces.entries())n[o.toString()]=s.id;const r={};for(const[o,s]of this.u.emptyWindows.entries())r[o.toString()]=s.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},o=this.v();if(n.workspaces)for(const[c,w]of Object.entries(n.workspaces)){const E=k.URI.parse(w);r[c]=this.r.extUri.isEqual(E,o.location)?o.id:this.r.extUri.basename(E)}const s={};if(n.emptyWindows)for(const[c,w]of Object.entries(n.emptyWindows)){const E=k.URI.parse(w);s[c]=this.r.extUri.isEqual(E,o.location)?o.id:this.r.extUri.basename(E)}return{workspaces:r,emptyWindows:s}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([X(0,C.IEnvironmentService),X(1,v.IFileService),X(2,g.IUriIdentityService),X(3,S.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=a}),define(se[272],re([0,1,6,2,28]),function(_,e,A,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let D=class extends O.Disposable{constructor(R){super(),this.B(new A.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};D=ye([X(0,l.IUserDataProfilesService)],D),e.UserDataProfilesCleaner=D}),define(se[273],re([0,1,18,6,23,7,3,2,4,10,160,29,33,46,11,25,19,28]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let y=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,s,c){super(),this.t=n,this.u=r,this.v=o,this.w=s,this.y=c,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,S.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new S.ExtensionManagementError(I.localize(0,null),S.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),P(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const s={...o,installOnlyNewlyAddedFromExtensionPack:v.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,f.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},c=z=>`${m.ExtensionKey.create(z).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!v.URI.isUri(r)){const z=this.j.get(c(r));if(z)return this.v.info("Extensions is already requested to install",r.identifier.id),z.task.waitUntilTaskIsFinished()}const w=[],E=[],L=[],T=this.Q(n,r,s);v.URI.isUri(r)||this.j.set(c(r),{task:T,waitingTasks:[]}),this.l.fire({identifier:T.identifier,source:r,profileLocation:s.profileLocation}),this.v.info("Installing extension:",T.identifier.id),w.push({task:T,manifest:n});let F=!1;try{if(s.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const J=await this.F(T.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),Y=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:W,manifest:N}of(0,A.distinct)(J,({gallery:B})=>B.identifier.id)){F=F||!!N.extensionDependencies?.some(q=>(0,m.areSameExtensions)({id:q},T.identifier));const B=c(W),ie=this.j.get(B);if(ie){if(this.C(T,ie.task)){const q=ie.task.identifier;this.v.info("Waiting for already requested installing extension",q.id,T.identifier.id),ie.waitingTasks.push(T),E.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,x=>x.some(U=>(0,m.areSameExtensions)(U.identifier,q)))).then(x=>{if(this.v.info("Finished waiting for already requested installing extension",q.id,T.identifier.id),!x.find(K=>(0,m.areSameExtensions)(K.identifier,q))?.local)throw new Error(`Extension ${q.id} is not installed`)}))}}else if(!Y.some(({identifier:q})=>(0,m.areSameExtensions)(q,W.identifier))){const q=this.Q(N,W,{...s,donotIncludePackAndDependencies:!0});this.j.set(B,{task:q,waitingTasks:[T]}),this.l.fire({identifier:q.identifier,source:W,profileLocation:s.profileLocation}),this.v.info("Installing extension:",q.identifier.id,T.identifier.id),w.push({task:q,manifest:N})}}}catch(J){if(v.URI.isUri(T.source))(0,A.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",T.identifier.id,J.message),(0,A.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",T.identifier.id,J.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),J}const z=w.reduce((J,{task:Y,manifest:W})=>(J.set(Y.identifier.id.toLowerCase(),{task:Y,manifest:W}),J),new Map);for(;z.size;){let J;const Y=[...z.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(N=>z.has(N.toLowerCase())));Y.length?J=z.size===1?Y:Y.filter(({task:W})=>!(W===T&&!F)):(this.v.info("Found extensions with circular dependencies",Y.map(({task:W})=>W.identifier.id)),J=[...z.values()]),await this.D(J.map(async({task:W})=>{const N=new Date().getTime();try{const B=await W.run();if(await this.D(this.s.map(ie=>ie.postInstall(B,W.source,s,l.CancellationToken.None))),!v.URI.isUri(W.source)){const ie=W.operation===3,q=ie?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(t(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:q}),C.isWeb&&W.operation!==3)try{await this.t.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}L.push({local:B,identifier:W.identifier,operation:W.operation,source:W.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:B.isApplicationScoped})}catch(B){throw v.URI.isUri(W.source)||t(this.u,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-N,error:B}),this.v.error("Error while installing the extension:",W.identifier.id),B}finally{z.delete(W.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),L.forEach(({identifier:J})=>this.v.info("Extension installed successfully:",J.id)),this.m.fire(L),L.filter(({identifier:J})=>(0,m.areSameExtensions)(J,T.identifier))[0].local}catch(z){if(w.forEach(({task:J})=>J.cancel()),L.length)try{const J=await Promise.allSettled(L.map(({local:Y})=>this.R(Y,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let Y=0;Y<J.length;Y++){const W=J[Y],{identifier:N}=L[Y];W.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",N.id):this.v.warn("Rollback: Error while uninstalling extension",N.id,(0,D.getErrorMessage)(W.reason))}}catch(J){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(J),L.map(({identifier:Y})=>Y.id))}throw this.m.fire(w.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:s.context,profileLocation:s.profileLocation}))),z}finally{for(const{task:z}of w)z.source&&!v.URI.isUri(z.source)&&this.j.delete(c(z.source))}}C(n,r){for(const[,{task:o,waitingTasks:s}]of this.j.entries())if(o===n&&(s.includes(r)||s.some(c=>this.C(c,r)))||o===r&&s[0]&&!this.C(n,s[0]))return!1;return!0}async D(n){const r=[],o=[],s=await Promise.allSettled(n);for(const c of s)c.status==="fulfilled"?r.push(c.value):o.push(c.reason);if(o.length)throw b(o);return r}async F(n,r,o,s,c){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,c),E=[],L=[],T=async(F,z)=>{E.push(F);const J=z.extensionDependencies||[],Y=[...J];if(z.extensionPack){const W=o?w.find(N=>(0,m.areSameExtensions)(N.identifier,F)):void 0;for(const N of z.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(B=>(0,m.areSameExtensions)({id:B},{id:N}))||Y.every(B=>!(0,m.areSameExtensions)({id:B},{id:N}))&&Y.push(N)}if(Y.length){const W=Y.filter(N=>E.every(B=>!(0,m.areSameExtensions)(B,{id:N})));if(W.length){const N=await this.t.getExtensions(W.map(B=>({id:B,preRelease:s})),l.CancellationToken.None);for(const B of N){if(E.find(x=>(0,m.areSameExtensions)(x,B.identifier)))continue;const ie=J.some(x=>(0,m.areSameExtensions)({id:x},B.identifier));let q;try{q=await this.G(B,!1,s)}catch(x){if(x instanceof S.ExtensionManagementError&&x.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.v.info("Skipping the packed extension as it cannot be installed",B.identifier.id);continue}else throw x}L.push({gallery:q.extension,manifest:q.manifest}),await T(q.extension.identifier,q.manifest)}}}};return await T(n,r),L}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,m.areSameExtensions)(n.identifier,E)))throw new S.ExtensionManagementError(I.localize(1,null,n.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const E=await this.getTargetPlatform();throw new S.ExtensionManagementError(I.localize(2,null,n.identifier.id,this.w.nameLong,(0,S.TargetPlatformToString)(E)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.H(n,r,o);if(c){if(o&&!r&&n.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],l.CancellationToken.None))[0]?new S.ExtensionManagementError(I.localize(4,null,n.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",c.identifier.id);const w=await this.t.getManifest(c,l.CancellationToken.None);if(w===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(w.version!==c.version)throw new S.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:w}}async H(n,r,o){const s=await this.getTargetPlatform();let c=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(c=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:s,compatible:!0},l.CancellationToken.None))[0]||null),!c&&await this.t.isExtensionCompatible(n,o,s)&&(c=n),c||(r?c=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:s,compatible:!0},l.CancellationToken.None))[0]||null:c=await this.t.getCompatibleExtension(n,o,s)),c}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},s=F=>`${F.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,c=this.k.get(s(n.identifier));if(c)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),c.waitUntilTaskIsFinished();const w=F=>{const z=this.R(F,o);return this.k.set(s(z.extension.identifier),z),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped}),z},E=(F,z)=>{z?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString(),z.message):this.v.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,z.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(F),error:z}),this.p.fire({identifier:F.identifier,error:z?.code,profileLocation:o.profileLocation,applicationScoped:F.isApplicationScoped})},L=[],T=[];try{L.push(w(n));const F=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const z=this.M(n,F);for(const J of z)this.k.has(s(J.identifier))?this.v.info("Extensions is already requested to uninstall",J.identifier.id):L.push(w(J))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(L.map(z=>z.extension),F,n),await this.D(L.map(async z=>{try{if(await z.run(),await this.D(this.s.map(J=>J.postUninstall(z.extension,o,l.CancellationToken.None))),z.extension.identifier.uuid)try{await this.t.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}E(z.extension)}catch(J){const Y=J instanceof S.ExtensionManagementError?J:new S.ExtensionManagementError((0,D.getErrorMessage)(J),S.ExtensionManagementErrorCode.Internal);throw E(z.extension,Y),Y}finally{T.push(z)}}))}catch(F){const z=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,D.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);for(const J of L){try{J.cancel()}catch{}T.includes(J)||E(J.extension,z)}throw z}finally{for(const F of L)this.k.delete(s(F.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(n,r,o){for(const s of n){const c=this.N(s,r);if(c.length){const w=c.filter(E=>!n.some(L=>(0,m.areSameExtensions)(L.identifier,E.identifier)));if(w.length)throw new Error(this.L(s,w,o))}}}L(n,r,o){return o===n?r.length===1?I.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const s=n.manifest.extensionPack?n.manifest.extensionPack:[];if(s.length){const c=r.filter(E=>!E.isBuiltin&&s.some(L=>(0,m.areSameExtensions)({id:L},E.identifier))),w=[];for(const E of c)w.push(...this.M(E,r,o));return[...c,...w]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(s=>(0,m.areSameExtensions)({id:s},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};y=ye([X(0,S.IExtensionGalleryService),X(1,h.ITelemetryService),X(2,g.ILogService),X(3,p.IProductService),X(4,u.IUserDataProfilesService)],y),e.AbstractExtensionManagementService=y;function b(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=b;function P(i){if(i instanceof S.ExtensionManagementError)return i;const n=new S.ExtensionManagementError(i.message,S.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:s,error:c,durationSinceUpdate:w}){let E,L;c&&(c instanceof S.ExtensionManagementError?(E=c.code,c.code===S.ExtensionManagementErrorCode.Signature&&(L=c.message)):E=S.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!c,duration:s,errorcode:E,errorcodeDetail:L,durationSinceUpdate:w})}class a{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(n=>new Promise((r,o)=>{const s=n.onCancellationRequested(()=>{s.dispose(),o(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(se[51],re([0,1,6,17,2,3,38,10,29,33,14,5,11,28,30,12,7,19]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class y extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=y,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let b=class extends l.Disposable{constructor(i,n,r,o,s,c){super(),this.i=i,this.j=n,this.k=r,this.l=o,this.m=s,this.n=c,this.b=this.B(new D.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new k.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.p(n,s=>{const c=[];for(const w of s)i.some(([E])=>(0,v.areSameExtensions)(E.identifier,w.identifier)&&E.manifest.version!==w.version)?r.push(w):c.push(w);for(const[w,E]of i)if(!c.some(L=>(0,v.areSameExtensions)(L.identifier,w.identifier)&&L.version===w.manifest.version)){const L={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:E};o.push(L),c.push(L)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),c}),o.length&&this.c.fire({extensions:o,profileLocation:n}),r.length&&this.g.fire({extensions:r,profileLocation:n}),o}catch(s){throw o.length&&this.c.fire({extensions:o,error:s,profileLocation:n}),r.length&&this.g.fire({extensions:r,error:s,profileLocation:n}),s}}async updateMetadata(i,n){const r=[];return await this.p(n,o=>{const s=[];for(const c of o){const w=i.find(([E])=>(0,v.areSameExtensions)(E.identifier,c.identifier)&&E.manifest.version===c.version);w&&(c.metadata={...c.metadata,...w[1]},r.push(c)),s.push(c)}return s}),r}async removeExtensionFromProfile(i,n){const r=[];this.f.fire({extensions:r,profileLocation:n});try{await this.p(n,o=>{const s=[];for(const c of o)(0,v.areSameExtensions)(c.identifier,i.identifier)?r.push(c):s.push(c);return r.length&&this.f.fire({extensions:r,profileLocation:n}),s}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:n}),o}}async p(i,n,r){return this.w(i).queue(async()=>{let o=[],s;try{const c=await this.j.readFile(i);s=JSON.parse(c.value.toString().trim()||"[]")}catch(c){if((0,I.toFileOperationResult)(c)!==1)throw c;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(s=await this.v()),!s&&r?.bailOutWhenFileNotFound)throw new y((0,h.getErrorMessage)(c),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.r(i);let c=!1;for(const w of s){P(w)||this.r(i);let E;if((0,p.isString)(w.relativeLocation)&&w.relativeLocation)E=this.t(w.relativeLocation);else if((0,p.isString)(w.location))E=this.t(w.location),c=!0,w.relativeLocation=w.location,w.location=E.toJSON();else{E=R.URI.revive(w.location);const L=this.s(E);L&&(c=!0,w.relativeLocation=L)}o.push({identifier:w.identifier,location:E,version:w.version,metadata:w.metadata})}c&&await this.j.writeFile(i,O.VSBuffer.fromString(JSON.stringify(s)))}if(n){o=n(o);const c=o.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.s(w.location),metadata:w.metadata}));await this.j.writeFile(i,O.VSBuffer.fromString(JSON.stringify(c)))}return o})}r(i){const n=new y(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(s){if((0,I.toFileOperationResult)(s)===1)return;throw s}this.n.info("Migrating extensions from old default profile location",i.toString());let o;try{const s=JSON.parse(r);Array.isArray(s)&&s.every(c=>P(c))?o=s:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.n.error(s)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(s){if((0,I.toFileOperationResult)(s)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw s}try{await this.j.del(i)}catch(s){(0,I.toFileOperationResult)(s)!==1&&this.n.error(s)}try{await this.j.del(n)}catch(s){(0,I.toFileOperationResult)(s)!==1&&this.n.error(s)}return o})()),this.u}w(i){let n=this.h.get(i);return n||(n=new A.Queue,this.h.set(i,n)),n}};b=ye([X(1,I.IFileService),X(2,f.IUserDataProfilesService),X(3,g.IUriIdentityService),X(4,u.ITelemetryService),X(5,m.ILogService)],b),e.AbstractExtensionsProfileScannerService=b;function P(a){return(0,p.isObject)(a)&&(0,C.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,p.isString)(a.location)&&a.location)&&((0,p.isUndefined)(a.relativeLocation)||(0,p.isString)(a.relativeLocation))&&a.version&&(0,p.isString)(a.version)}function t(a){return a?(0,p.isString)(a.path)&&(0,p.isString)(a.scheme):!1}}),define(se[78],re([0,1,18,6,32,17,7,35,142,2,21,13,4,24,54,90,12,10,163,15,33,46,68,14,5,11,25,3,91,51,28,30,197,198]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P,t,a,i,n,r,o,s,c,w,E,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(ie){function q(x,U){if(x===U)return!0;const K=Object.keys(x),Q=new Set;for(const oe of Object.keys(U))Q.add(oe);if(K.length!==Q.size)return!1;for(const oe of K){if(x[oe]!==U[oe])return!1;Q.delete(oe)}return Q.size===0}ie.equals=q})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let z=class extends v.Disposable{constructor(q,x,U,K,Q,oe,ae,V,j,M,$,H){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=x,this.l=U,this.m=K,this.n=Q,this.p=oe,this.r=ae,this.s=V,this.t=j,this.u=M,this.v=$,this.w=H,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(W,(0,f.joinPath)(this.m,P.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(W,(0,f.joinPath)(this.m,P.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Y,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,b.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(q,x,U){const[K,Q]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(x)]),oe=U?await this.scanExtensionsUnderDevelopment(q,[...K,...Q]):[];return this.F(K,Q,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const x=[];x.push(this.G(!!q.useCache,q.language)),x.push(this.H(q.language,!!q.checkControlFile));const[U,K]=await Promise.all(x);return this.D([...U,...K],0,q,!1)}async scanUserExtensions(q){const x=q.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",x);const U=this.v.extUri.isEqual(q.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,K=await this.J(x,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,U),Q=q.useCache&&!K.devMode&&K.excludeObsolete?this.j:this.k;let oe;try{oe=await Q.scanExtensions(K)}catch(ae){if(ae instanceof c.ExtensionsProfileScanningError&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),oe=await Q.scanExtensions(K);else throw ae}return oe=await this.D(oe,1,q,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(q,x){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(K=>K.scheme===I.Schemas.file).map(async K=>{const Q=await this.J(K,!1,1,!0,q.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Q)).map(ae=>(ae.type=x.find(V=>(0,b.areSameExtensions)(V.identifier,ae.identifier))?.type??ae.type,this.k.validate(ae,Q)))}))).flat();return this.D(U,"development",q,!0)}return[]}async scanExistingExtension(q,x,U){const K=await this.J(q,!1,x,!0,U.language,!0,void 0),Q=await this.k.scanExtension(K);return!Q||!U.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(q,x,U){const K=await this.J(q,!1,x,!0,U.language,!0,void 0),Q=await this.k.scanOneOrMultipleExtensions(K);return this.D(Q,x,U,!0)}async scanMetadata(q){const x=(0,f.joinPath)(q,"package.json"),U=(await this.r.readFile(x)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(q,x){const U=(0,f.joinPath)(q,"package.json"),K=(await this.r.readFile(U)).value.toString(),Q=JSON.parse(K);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,Q.__metadata={...Q.__metadata,...x},await this.r.writeFile((0,f.joinPath)(q,"package.json"),D.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof c.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw q}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.p.addExtensionsToProfile(q.map(x=>[x,x.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(x){(0,a.toFileOperationResult)(x)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(x))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.s.error(q)}finally{this.z=void 0}})()),this.z}async D(q,x,U,K){return U.includeAllVersions||(q=this.F(x===0?q:void 0,x===1?q:void 0,x==="development"?q:void 0,await this.getTargetPlatform(),K)),U.includeInvalid||(q=q.filter(Q=>Q.isValid)),q.sort((Q,oe)=>{const ae=S.basename(Q.location.fsPath),V=S.basename(oe.location.fsPath);return ae<V?-1:ae>V?1:0})}F(q,x,U,K,Q){const oe=(V,j,M)=>{if(V.isValid&&!j.isValid)return!1;if(V.isValid===j.isValid){if(Q&&g.gt(V.manifest.version,j.manifest.version))return this.s.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(g.eq(V.manifest.version,j.manifest.version)){if(V.type===0)return this.s.debug(`Skipping extension ${j.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===K)return this.s.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return M?this.s.warn(`Overwriting user extension ${V.location.path} with ${j.location.path}.`):this.s.debug(`Overwriting user extension ${V.location.path} with ${j.location.path}.`),!0},ae=new Map;return q?.forEach(V=>{const j=P.ExtensionIdentifier.toKey(V.identifier.id),M=ae.get(j);(!M||oe(M,V,!1))&&ae.set(j,V)}),x?.forEach(V=>{const j=P.ExtensionIdentifier.toKey(V.identifier.id),M=ae.get(j);if(!M&&q&&V.type===0){this.s.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!M||oe(M,V,!1))&&ae.set(j,V)}),U?.forEach(V=>{const j=P.ExtensionIdentifier.toKey(V.identifier.id),M=ae.get(j);(!M||oe(M,V,!0))&&ae.set(j,V),ae.set(j,V)}),[...ae.values()]}async G(q,x){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),Q=await(q&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(q,x){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const K=x?await this.I():{},Q=[],oe=u.URI.file(S.normalize(S.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of U){const j=K[V.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":Q.push((0,f.joinPath)(oe,V.name));break;default:Q.push(u.URI.file(j));break}}const ae=await Promise.all(Q.map(async V=>this.k.scanExtension(await this.J(V,!1,0,!0,q,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ae.length),(0,A.coalesce)(ae)}async I(){try{const q=await this.r.readFile(this.l);return JSON.parse(q.value.toString())}catch{return{}}}async J(q,x,U,K,Q,oe,ae){const V=await this.f(Q??m.language),j=await this.L(q),M=x&&!this.v.extUri.isEqual(q,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,$=M?await this.L(M):void 0;return new J(q,j,M,$,x,ae,U,K,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,V)}async L(q){try{const x=await this.r.stat(q);if(typeof x.mtime=="number")return x.mtime}catch{}}};z=ye([X(4,w.IUserDataProfilesService),X(5,c.IExtensionsProfileScannerService),X(6,a.IFileService),X(7,n.ILogService),X(8,y.IEnvironmentService),X(9,r.IProductService),X(10,E.IUriIdentityService),X(11,i.IInstantiationService)],z),e.AbstractExtensionsScannerService=z;class J{constructor(q,x,U,K,Q,oe,ae,V,j,M,$,H,ee,G,Z){this.location=q,this.mtime=x,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=K,this.profile=Q,this.profileScanOptions=oe,this.type=ae,this.excludeObsolete=V,this.validate=j,this.productVersion=M,this.productDate=$,this.productCommit=H,this.devMode=ee,this.language=G,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,x){return(0,f.isEqual)(q.location,x.location)&&q.mtime===x.mtime&&(0,f.isEqual)(q.applicationExtensionslocation,x.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&q.profile===x.profile&&l.equals(q.profileScanOptions,x.profileScanOptions)&&q.type===x.type&&q.excludeObsolete===x.excludeObsolete&&q.validate===x.validate&&q.productVersion===x.productVersion&&q.productDate===x.productDate&&q.productCommit===x.productCommit&&q.devMode===x.devMode&&q.language===x.language&&F.equals(q.translations,x.translations)}}e.ExtensionScannerInput=J;let Y=class extends v.Disposable{constructor(q,x,U,K,Q){super(),this.f=q,this.g=x,this.h=U,this.i=K,this.j=Q}async scanExtensions(q){const x=q.profile?await this.l(q):await this.k(q);let U={};if(q.excludeObsolete&&q.type===1)try{const K=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(K)}catch{}return(0,h.isEmptyObject)(U)?x:x.filter(K=>!U[b.ExtensionKey.create(K).toString()])}async k(q){const x=await this.i.resolve(q.location);if(!x.children?.length)return[];const U=await Promise.all(x.children.map(async K=>{if(!K.isDirectory||q.type===1&&(0,f.basename)(K.resource).indexOf(".")===0)return null;const Q=new J(K.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q)}));return(0,A.coalesce)(U).sort((K,Q)=>K.location.path<Q.location.path?-1:1)}async l(q){let x=await this.m(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){x=x.filter(K=>!K.metadata?.isApplicationScoped);const U=await this.m(q.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,q);x.push(...U)}return x}async m(q,x,U){const K=await this.g.scanProfileExtensions(q,U.profileScanOptions);if(!K.length)return[];const Q=await Promise.all(K.map(async oe=>{if(x(oe)){const ae=new J(oe.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ae,oe.metadata)}return null}));return(0,A.coalesce)(Q)}async scanOneOrMultipleExtensions(q){try{if(await this.i.exists((0,f.joinPath)(q.location,"package.json"))){const x=await this.scanExtension(q);return x?[x]:[]}else return await this.scanExtensions(q)}catch(x){return this.j.error(`Error scanning extensions at ${q.location.path}:`,(0,k.getErrorMessage)(x)),[]}}async scanExtension(q,x){try{let U=await this.scanExtensionManifest(q.location);if(U){U.publisher||(U.publisher=P.UNDEFINED_PUBLISHER),x=x??U.__metadata,delete U.__metadata;const K=(0,b.getGalleryExtensionId)(U.publisher,U.name),Q=x?.id?{id:K,uuid:x.id}:{id:K},oe=x?.isSystem?0:q.type,ae=oe===0||!!x?.isBuiltin;T.ImplicitActivationEvents.updateManifest(U),U=await this.n(q.location,U,J.createNlsConfiguration(q));const V={type:oe,identifier:Q,manifest:U,location:q.location,isBuiltin:ae,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return q.validate?this.validate(V,q):V}}catch(U){q.type!==0&&this.j.error(U)}return null}validate(q,x){let U=!0;const K=(0,t.validateExtensionManifest)(x.productVersion,x.productDate,x.location,q.manifest,q.isBuiltin);for(const[Q,oe]of K)Q===p.default.Error&&(U=!1,this.j.error(this.t(x.location,oe)));return q.isValid=U,q.validations=K,q}async scanExtensionManifest(q){const x=(0,f.joinPath)(q,"package.json");let U;try{U=(await this.i.readFile(x)).value.toString()}catch(Q){return(0,a.toFileOperationResult)(Q)!==1&&this.j.error(this.t(q,(0,d.localize)(0,null,x.path,Q.message))),null}let K;try{K=JSON.parse(U)}catch{const oe=[];(0,R.parse)(U,oe);for(const ae of oe)this.j.error(this.t(q,(0,d.localize)(1,null,x.path,ae.offset,ae.length,(0,C.getParseErrorMessage)(ae.error))));return null}return(0,R.getNodeType)(K)!=="object"?(this.j.error(this.t(q,(0,d.localize)(2,null,x.path))),null):K}async n(q,x,U){const K=await this.p(q,x,U);if(K)try{const Q=[],oe=await this.r(K.default,Q);if(Q.length>0)return Q.forEach(V=>{this.j.error(this.t(q,(0,d.localize)(3,null,K.default?.path,(0,C.getParseErrorMessage)(V.error))))}),x;if((0,R.getNodeType)(K)!=="object")return this.j.error(this.t(q,(0,d.localize)(4,null,K.default?.path))),x;const ae=K.values||Object.create(null);return(0,L.localizeManifest)(x,ae,oe)}catch{}return x}async p(q,x,U){const K=(0,f.joinPath)(q,"package.nls.json"),Q=(j,M)=>{M.forEach($=>{this.j.error(this.t(q,(0,d.localize)(5,null,j?.path,(0,C.getParseErrorMessage)($.error))))})},oe=j=>{this.j.error(this.t(q,(0,d.localize)(6,null,j?.path)))},ae=`${x.publisher}.${x.name}`,V=U.translations[ae];if(V)try{const j=u.URI.file(V),M=(await this.i.readFile(j)).value.toString(),$=[],H=(0,R.parse)(M,$);return $.length>0?(Q(j,$),{values:void 0,default:K}):(0,R.getNodeType)(H)!=="object"?(oe(j),{values:void 0,default:K}):{values:H.contents?H.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.i.exists(K))return;let M;try{M=await this.s(q,U)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const $=(await this.i.readFile(M.localized)).value.toString(),H=[],ee=(0,R.parse)($,H);return H.length>0?(Q(M.localized,H),{values:void 0,default:M.original}):(0,R.getNodeType)(ee)!=="object"?(oe(M.localized),{values:void 0,default:M.original}):{values:ee,default:M.original}}catch{return{values:void 0,default:M.original}}}}async r(q,x){if(q)try{const U=(await this.i.readFile(q)).value.toString();return(0,R.parse)(U,x)}catch{}}s(q,x){return new Promise((U,K)=>{const Q=oe=>{const ae=(0,f.joinPath)(q,`package.nls.${oe}.json`);this.i.exists(ae).then(V=>{V&&U({localized:ae,original:(0,f.joinPath)(q,"package.nls.json")});const j=oe.lastIndexOf("-");j===-1?U({localized:(0,f.joinPath)(q,"package.nls.json"),original:null}):(oe=oe.substring(0,j),Q(oe))})};if(x.devMode||x.pseudo||!x.language)return U({localized:(0,f.joinPath)(q,"package.nls.json"),original:null});Q(x.language)})}t(q,x){return`[${q.path}]: ${x}`}};Y=ye([X(1,c.IExtensionsProfileScannerService),X(2,E.IUriIdentityService),X(3,a.IFileService),X(4,n.ILogService)],Y);let W=class extends Y{constructor(q,x,U,K,Q,oe){super(x,U,K,Q,oe),this.y=q,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(q){const x=await this.z();if(this.u=q,x&&x.input&&J.equals(x.input,this.u))return this.j.debug("Using cached extensions scan result",q.location.toString()),this.v.trigger(()=>this.D()),x.result.map(K=>(K.location=u.URI.revive(K.location),K));const U=await super.scanExtensions(q);return await this.C({input:q,result:U}),U}async z(){try{const q=await this.i.readFile(this.y),x=JSON.parse(q.value.toString());return{result:x.result,input:(0,s.revive)(x.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,k.getErrorMessage)(q))}return null}async C(q){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(q)))}catch(x){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,k.getErrorMessage)(x))}}async D(){if(!this.u)return;const q=await this.z();if(!q)return;const x=q.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!l.equals(U,x))try{await this.i.del(this.y),this.w.fire()}catch(K){this.j.error(K)}}};W=ye([X(2,c.IExtensionsProfileScannerService),X(3,E.IUriIdentityService),X(4,a.IFileService),X(5,n.ILogService)],W);function N(ie,q){const x=(0,b.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:x,identifier:new P.ExtensionIdentifier(x),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=N;class B extends z{constructor(q,x,U,K,Q,oe,ae,V,j,M,$,H){super(q,x,(0,f.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(K,P.MANIFEST_CACHE_FOLDER),Q,oe,ae,V,j,M,$,H),this.M=(async()=>{if(m.translationsConfigFile)try{const ee=await this.r.readFile(u.URI.file(m.translationsConfigFile));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(q){return this.M}}e.NativeExtensionsScannerService=B}),define(se[274],re([0,1,11,28,30,19,51,14,15,10]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends k.AbstractExtensionsProfileScannerService{constructor(m,f,g,p,h,u){super(v.URI.file(m.extensionsPath),f,g,p,h,u)}};I=ye([X(0,C.INativeEnvironmentService),X(1,R.IFileService),X(2,O.IUserDataProfilesService),X(3,l.IUriIdentityService),X(4,D.ITelemetryService),X(5,A.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(se[275],re([0,1,50,6,39,3,2,21,13,27,11,28]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends k.Disposable{constructor(g,p){super(),this.b=g,this.f=p,this.a=new O.Limiter(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(h){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(h)}}));try{await v.Promises.rm(this.j(g))}catch(h){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(h)}}g(g,p){const h=`vscode:${p}`;if(g.location.scheme===R.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[h]=="string"){const u=g.manifest.scripts[h].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${h} should be a node script`),null):{script:(0,C.join)(g.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(g,p,h,u,d){return new Promise((y,b)=>{const P=this.i(g,p,h,d);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?b(i):y(void 0)};P.on("error",i=>{a((0,l.toErrorMessage)(i)||"Unknown")}),P.on("exit",(i,n)=>{a(i?`post-${p} process exited with code ${i}`:void 0)}),u&&(t=setTimeout(()=>{t=null,P.kill(),b("timed out")},5e3))})}i(g,p,h,u){const d={silent:!0,execArgv:void 0},y=(0,A.fork)(g,[`--type=extension-post-${p}`,...h],d);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const b=D.Event.fromNodeEventEmitter(y.stdout,"data"),P=D.Event.fromNodeEventEmitter(y.stderr,"data");b(i=>this.f.info(u.identifier.id,u.manifest.version,`post-${p}`,i)),P(i=>this.f.error(u.identifier.id,u.manifest.version,`post-${p}`,i));const t=D.Event.any(D.Event.map(b,i=>({data:`%c${i}`,format:[""]})),D.Event.map(P,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}j(g){return(0,C.join)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};m=ye([X(0,S.IUserDataProfilesService),X(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(se[276],re([0,1,10,15,51,78,14,5,11,25,30,28]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends D.NativeExtensionsScannerService{constructor(g,p,h,u,d,y,b,P){super(A.URI.file(d.builtinExtensionsPath),A.URI.file(d.extensionsPath),d.userHome,A.URI.file(d.userDataPath),g,p,h,u,d,y,b,P)}};m=ye([X(0,S.IUserDataProfilesService),X(1,l.IExtensionsProfileScannerService),X(2,k.IFileService),X(3,C.ILogService),X(4,O.INativeEnvironmentService),X(5,v.IProductService),X(6,I.IUriIdentityService),X(7,R.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(se[20],re([0,1,6,3,2,104,12,67,5,28]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function f(d){const y=d.get(e.TARGET_KEY);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.loadKeyTargets=f;class g extends l.Disposable{constructor(y={flushInterval:g.a}){super(),this.j=y,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new A.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,A.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(y,b){if(b===e.TARGET_KEY){switch(y){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:y})}else this.b.fire({scope:y,key:b,target:this.F(y)[b]})}r(y){this.f.fire({reason:y})}get(y,b,P){return this.L(b)?.get(y,P)}getBoolean(y,b,P){return this.L(b)?.getBoolean(y,P)}getNumber(y,b,P){return this.L(b)?.getNumber(y,P)}store(y,b,P,t){if((0,k.isUndefinedOrNull)(b)){this.remove(y,P);return}this.t(()=>{this.u(y,P,t),this.L(P)?.set(y,b)})}remove(y,b){this.t(()=>{this.u(y,b,void 0),this.L(b)?.delete(y)})}t(y){this.b.pause(),this.c.pause();try{y()}finally{this.b.resume(),this.c.resume()}}keys(y,b){const P=[],t=this.F(y);for(const a of Object.keys(t))t[a]===b&&P.push(a);return P}u(y,b,P){const t=this.F(b);typeof P=="number"?t[y]!==P&&(t[y]=P,this.L(b)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.L(b)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(y){switch(y){case-1:return this.D;case 0:return this.z;default:return this.w}}G(y){const b=this.L(y);return b?f(b):Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=I.NONE){this.f.fire({reason:y});const b=this.L(-1),P=this.L(0),t=this.L(1);switch(y){case I.NONE:await A.Promises.settled([b?.whenFlushed()??Promise.resolve(),P?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await A.Promises.settled([b?.flush(0)??Promise.resolve(),P?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.L(-1)?.items??new Map,b=this.L(0)?.items??new Map,P=this.L(1)?.items??new Map;return u(y,b,P,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(y,b){return this.r(I.NONE),(0,v.isUserDataProfile)(y)?this.N(y,b):this.O(y,b)}H(y,b){return!(y.id===b.id||p(b)&&p(y))}I(y,b,P,t){this.t(()=>{if(t)for(const[a,i]of y)b.set(a,i);else{const a=new Set;for(const[i,n]of y)a.add(i),b.get(i)!==n&&this.n(P,i);for(const[i]of b.items)a.has(i)||this.n(P,i)}})}}g.a=60*1e3,e.AbstractStorageService=g;function p(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class h extends g{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(y=>this.n(1,y))),this.B(this.P.onDidChangeStorage(y=>this.n(0,y))),this.B(this.p.onDidChangeStorage(y=>this.n(-1,y)))}L(y){switch(y){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(y){return!1}}e.InMemoryStorageService=h;async function u(d,y,b,P,t,a){const i=T=>{try{return JSON.parse(T)}catch{return T}},n=new Map,r=new Map;d.forEach((T,F)=>{n.set(F,T),r.set(F,i(T))});const o=new Map,s=new Map;y.forEach((T,F)=>{o.set(F,T),s.set(F,i(T))});const c=new Map,w=new Map;b.forEach((T,F)=>{c.set(F,T),w.set(F,i(T))}),console.group(P!==t?`Storage: Application (path: ${P})`:`Storage: Application & Profile (path: ${P}, default profile)`);const E=[];if(n.forEach((T,F)=>{E.push({key:F,value:T})}),console.table(E),console.groupEnd(),console.log(r),P!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const T=[];o.forEach((F,z)=>{T.push({key:z,value:F})}),console.table(T),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${a})`);const L=[];c.forEach((T,F)=>{L.push({key:F,value:T})}),console.table(L),console.groupEnd(),console.log(w)}e.logStorage=u}),define(se[120],re([0,1,3,2,12,29,33,20]),function(_,e,A,O,l,D,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends O.Disposable{constructor(S,m){super(),this.a=new A.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new v(S)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(m.onDidInstallExtensions(f=>f.forEach(({local:g,operation:p})=>{g&&p===4&&this.f(g.identifier)})))}async enableExtension(S,m){return this.f(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}async disableExtension(S,m){return this.c(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}getDisabledExtensions(){return this.h(D.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const m=this.getDisabledExtensions();return m.every(f=>!(0,k.areSameExtensions)(f,S))?(m.push(S),this.g(m),!0):!1}f(S){const m=this.getDisabledExtensions();for(let f=0;f<m.length;f++){const g=m[f];if((0,k.areSameExtensions)(g,S))return m.splice(f,1),this.g(m),!0}return!1}g(S){this.i(D.DISABLED_EXTENSIONS_STORAGE_PATH,S)}h(S){return this.b.get(S,0)}i(S,m){this.b.set(S,m,0)}};C=ye([X(0,R.IStorageService),X(1,D.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class v extends O.Disposable{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new A.Emitter),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(m=>this.f(m)))}get(S,m){let f;return m===0?((0,l.isUndefinedOrNull)(this.a[S])&&(this.a[S]=this.g(S,m)),f=this.a[S]):f=this.g(S,m),JSON.parse(f)}set(S,m,f){const g=JSON.stringify(m.map(({id:h,uuid:u})=>({id:h,uuid:u})));this.g(S,f)!==g&&(f===0&&(m.length?this.a[S]=g:delete this.a[S]),this.h(S,m.length?g:void 0,f))}f(S){if(S.scope===0&&!(0,l.isUndefinedOrNull)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const f=this.get(S.key,S.scope);delete this.a[S.key];const g=this.get(S.key,S.scope),p=f.filter(u=>!g.some(d=>(0,k.areSameExtensions)(u,d))),h=g.filter(u=>!f.some(d=>(0,k.areSameExtensions)(d,u)));(p.length||h.length)&&this.b.fire([...p,...h])}}g(S,m){return this.c.get(S,m,"[]")}h(S,m,f){m?this.c.store(S,m,f,1):this.c.remove(S,f)}}e.StorageManager=v}),define(se[277],re([0,1,18,23,7,4,36,12,10,16,15,29,33,68,14,11,25,59,244,20,19]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const P=D.isWeb?"web":(0,S.getTargetPlatform)(D.platform,k.arch),t="X-Market-Search-Activity-Id";var a;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...j){return String(j.reduce((M,$)=>M|$,0))}var n;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class w{constructor(M=c){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,$=this.d.pageSize){return new w({...this.d,pageNumber:M,pageSize:$})}withFilter(M,...$){const H=[...this.d.criteria,...$.length?$.map(ee=>({filterType:M,value:ee})):[{filterType:M}]];return new w({...this.d,criteria:H})}withSortBy(M){return new w({...this.d,sortBy:M})}withSortOrder(M){return new w({...this.d,sortOrder:M})}withFlags(...M){return new w({...this.d,flags:M.reduce(($,H)=>$|H,0)})}withAssetTypes(...M){return new w({...this.d,assetTypes:M})}withSource(M){return new w({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:$,pageSize:H,sortBy:ee,sortOrder:G,flags:Z,assetTypes:te}=this.d;return{filters:[{criteria:M,pageNumber:$,pageSize:H,sortBy:ee,sortOrder:G}],assetTypes:te,flags:Z}}get searchText(){const M=this.d.criteria.filter($=>$.filterType===n.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(j,M){const $=(j||[]).filter(H=>H.statisticName===M)[0];return $?$.value:0}function L(j){const M="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(H=>H.assetType.indexOf(M)===0).reduce((H,ee)=>{const G=z(j,ee.assetType);return G&&H.push([ee.assetType.substring(M.length),G]),H},[])}function T(j){if(j.properties){const M=j.properties.filter(ee=>ee.key===r.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=M.filter(ee=>$.test(ee.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return z(j,r.Repository)}function F(j){return{uri:`${j.fallbackAssetUri}/${r.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${r.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function z(j,M){return j.files.filter(H=>H.assetType===M)[0]?{uri:`${j.assetUri}/${M}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${M}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function J(j,M){const $=j.properties?j.properties.filter(ee=>ee.key===M):[],H=$.length>0&&$[0].value;return H?H.split(",").map(ee=>(0,m.adoptToGalleryExtensionId)(ee)):[]}function Y(j){const M=j.properties?j.properties.filter($=>$.key===o.Engine):[];return M.length>0&&M[0].value||""}function W(j){const M=j.properties?j.properties.filter($=>$.key===o.PreRelease):[];return M.length>0&&M[0].value==="true"}function N(j){const M=j.properties?j.properties.filter(H=>H.key===o.LocalizedLanguages):[],$=M.length>0&&M[0].value||"";return $?$.split(","):[]}function B(j){return j.properties?.find(M=>M.key===o.SponsorLink)?.value}function ie(j){return j.indexOf("preview")!==-1}function q(j){return j.targetPlatform?(0,S.toTargetPlatform)(j.targetPlatform):"undefined"}function x(j){const M=(0,A.distinct)(j.versions.map(q)),$=!!j.tags?.includes(S.WEB_EXTENSION_TAG),H=M.indexOf("web");return $?H===-1&&M.push("web"):H!==-1&&M.splice(H,1),M}function U(j,M){const $=(0,S.getFallbackTargetPlarforms)(M);for(let H=0;H<j.length;H++){const ee=j[H];if(ee.version===j[H-1]?.version){let G=H;const Z=q(ee);if(Z===M)for(;G>0&&j[G-1].version===ee.version;)G--;else if($.includes(Z))for(;G>0&&j[G-1].version===ee.version&&q(j[G-1])!==M;)G--;G!==H&&(j.splice(H,1),j.splice(G,0,ee))}}return j}e.sortExtensionVersions=U;function K(j,M,$){j.telemetryData={index:M,querySource:$,queryActivityId:j.queryContext?.[t]}}function Q(j,M,$,H){const ee=j.versions[0],G={manifest:z(M,r.Manifest),readme:z(M,r.Details),changelog:z(M,r.Changelog),license:z(M,r.License),repository:T(M),download:F(M),icon:z(M,r.Icon),signature:z(M,r.Signature),coreTranslations:L(M)};return{identifier:{id:(0,m.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:M.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ee),description:j.shortDescription||"",installCount:E(j.statistics,"install"),rating:E(j.statistics,"averagerating"),ratingCount:E(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:$,assets:G,properties:{dependencies:J(M,o.Dependency),extensionPack:J(M,o.ExtensionPack),engine:Y(M),localizedLanguages:N(M),targetPlatform:q(M),isPreReleaseVersion:W(M)},hasPreReleaseVersion:W(ee),hasReleaseVersion:!0,preview:ie(j.flags),isSigned:!!G.signature,queryContext:H}}let oe=class{constructor(M,$,H,ee,G,Z,te,le){this.k=$,this.l=H,this.n=ee,this.o=G,this.q=Z,this.u=te,this.w=le;const he=te.extensionsGallery,me=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=me?he.servicePPEUrl:he?.serviceUrl,this.g=me?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,$,H){const ee=O.CancellationToken.isCancellationToken($)?{}:$,G=O.CancellationToken.isCancellationToken($)?$:H,Z=[],te=[],le=[],he=[];let me=!0;for(const Ce of M){Ce.uuid?te.push(Ce.uuid):Z.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);le.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),me=me&&!!Ce.hasPreRelease&&!De}if(!te.length&&!Z.length)return[];let pe=new w().withPage(1,M.length);te.length&&(pe=pe.withFilter(n.ExtensionId,...te)),Z.length&&(pe=pe.withFilter(n.ExtensionName,...Z)),(ee.queryAllVersions||me)&&(pe=pe.withFlags(pe.flags,a.IncludeVersions)),ee.source&&(pe=pe.withSource(ee.source));const{extensions:Se}=await this.z(pe,{targetPlatform:ee.targetPlatform??P,includePreRelease:le,versions:he,compatible:!!ee.compatible},G);return ee.source&&Se.forEach((Ce,De)=>K(Ce,De,ee.source)),Se}async getCompatibleExtension(M,$,H){if((0,S.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(M,$,H))return M;const ee=new w().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,M.identifier.uuid),{extensions:G}=await this.z(ee,{targetPlatform:H,compatible:!0,includePreRelease:$},O.CancellationToken.None);return G[0]||null}async isExtensionCompatible(M,$,H){if(!(0,S.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,H)||!$&&M.properties.isPreReleaseVersion)return!1;let ee=M.properties.engine;if(!ee){const G=await this.getManifest(M,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");ee=G.engines.vscode}return(0,f.isEngineValid)(ee,this.u.version,this.u.date)}async y(M,$,H,ee,G){if(!(0,S.isTargetPlatformCompatible)(q(M),ee,G)||$!=="any"&&W(M)!==($==="prerelease"))return!1;if(H)try{const Z=await this.E(M);if(!(0,f.isEngineValid)(Z,this.u.version,this.u.date))return!1}catch(Z){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,l.getErrorMessage)(Z)),!1}return!0}async query(M,$){let H=M.text||"";const ee=M.pageSize??50;let G=new w().withPage(1,ee);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Se)=>(G=G.withFilter(n.Category,Se||pe),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Se)=>(G=G.withFilter(n.Tag,Se||pe),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(n.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),G=G.withFilter(n.SearchText,H)),G=G.withSortBy(0)):M.ids?G=G.withFilter(n.ExtensionId,...M.ids):M.names?G=G.withFilter(n.ExtensionName,...M.names):G=G.withSortBy(4),typeof M.sortBy=="number"&&(G=G.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(G=G.withSortOrder(M.sortOrder)),M.source&&(G=G.withSource(M.source));const Z=async(me,pe)=>{const{extensions:Se,total:Ce}=await this.z(me,{targetPlatform:P,compatible:!1,includePreRelease:!!M.includePreRelease},pe);return Se.forEach((De,ke)=>K(De,(me.pageNumber-1)*me.pageSize+ke,M.source)),{extensions:Se,total:Ce}},{extensions:te,total:le}=await Z(G,$),he=async(me,pe)=>{if(pe.isCancellationRequested)throw new l.CancellationError;const{extensions:Se}=await Z(G.withPage(me+1),pe);return Se};return{firstPage:te,total:le,pageSize:G.pageSize,getPage:he}}async z(M,$,H){const ee=M.flags;!!(M.flags&a.IncludeLatestVersionOnly)&&!!(M.flags&a.IncludeVersions)&&(M=M.withFlags(M.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(M.flags&a.IncludeLatestVersionOnly)&&!(M.flags&a.IncludeVersions)&&(M=M.withFlags(M.flags,a.IncludeLatestVersionOnly)),$.versions?.length&&(M=M.withFlags(M.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),M=M.withFlags(M.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:G,total:Z,context:te}=await this.B(M,H);if(!(M.flags&a.IncludeLatestVersionOnly)){const pe=[];for(const Se of G){const Ce=await this.A(Se,$,te);Ce&&pe.push(Ce)}return{extensions:pe,total:Z}}const he=[],me=new Map;for(let pe=0;pe<G.length;pe++){const Se=G[pe],Ce={id:(0,m.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},De=(0,R.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(qe=>(0,m.areSameExtensions)(qe,Ce))?.includePreRelease;if($.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(x(Se),$.targetPlatform))continue;const ke=await this.A(Se,$,te);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==$.targetPlatform&&ke.hasPreReleaseVersion?me.set(Se.extensionId,pe):he.push([pe,ke])}if(me.size){const pe=new Date().getTime(),Se=new w().withFlags(ee&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:Ce}=await this.z(Se,$,H);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:me.size});for(const De of Ce){const ke=me.get(De.identifier.uuid);he.push([ke,De])}}return{extensions:he.sort((pe,Se)=>pe[0]-Se[0]).map(([,pe])=>pe),total:Z}}async A(M,$,H){const ee={id:(0,m.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},G=$.versions?.find(he=>(0,m.areSameExtensions)(he,ee))?.version,Z=(0,R.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(he=>(0,m.areSameExtensions)(he,ee))?.includePreRelease,te=x(M),le=U(M.versions,$.targetPlatform);if($.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(te,$.targetPlatform))return null;for(let he=0;he<le.length;he++){const me=le[he];if(!(G&&me.version!==G)){if(await this.y(me,Z?"any":"release",$.compatible,te,$.targetPlatform))return Q(M,me,te,H);if(G&&me.version===G)return null}}return G||$.compatible?null:Q(M,M.versions[0],te)}async B(M,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const H=await this.j,ee=JSON.stringify(M.raw),G={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let te,le,he=0;try{if(te=await this.k.request({type:"POST",url:this.g&&M.criteria.some(pe=>pe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:G},$),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(te);if(me){const pe=me.results[0],Se=pe.extensions,Ce=pe.resultMetadata&&pe.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:he,context:{[t]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw le=me,me}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:le?(0,l.isCancellationError)(le)?"canceled":(0,l.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(M,$,H,ee){if(!this.isEnabled())return;const G=D.isWeb?this.x(`/itemName/${M}.${$}/version/${H}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${$}/${H}/stats?statType=${ee}`),Z=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:G,headers:le},O.CancellationToken.None)}catch{}}async download(M,$,H){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const ee=(0,m.getGalleryExtensionTelemetryData)(M),G=new Date().getTime(),Z=pe=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:pe}),te=H===2?"install":H===3?"update":"",le=te?{uri:`${M.assets.download.uri}${C.URI.parse(M.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${M.assets.download.fallbackUri}${C.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:M.assets.download,he=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,me=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile($,me.stream),Z(new Date().getTime()-G)}async downloadSignatureArchive(M,$){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const H=await this.D(M.assets.signature);await this.q.writeFile($,H.stream)}async getReadme(M,$){if(M.assets.readme){const H=await this.D(M.assets.readme,{},$);return await(0,u.asTextOrError)(H)||""}return""}async getManifest(M,$){if(M.assets.manifest){const H=await this.D(M.assets.manifest,{},$),ee=await(0,u.asTextOrError)(H);return ee?JSON.parse(ee):null}return null}async C(M,$){const H=z(M,r.Manifest);if(!H)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},G=await this.D(H,{headers:ee});return await(0,u.asJson)(G)}async getCoreTranslation(M,$){const H=M.assets.coreTranslations.filter(ee=>ee[0]===$.toUpperCase())[0];if(H){const ee=await this.D(H[1]),G=await(0,u.asTextOrError)(ee);return G?JSON.parse(G):null}return null}async getChangelog(M,$){if(M.assets.changelog){const H=await this.D(M.assets.changelog,{},$);return await(0,u.asTextOrError)(H)||""}return""}async getAllCompatibleVersions(M,$,H){let ee=new w().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ee=ee.withFilter(n.ExtensionId,M.identifier.uuid):ee=ee.withFilter(n.ExtensionName,M.identifier.id);const{galleryExtensions:G}=await this.B(ee,O.CancellationToken.None);if(!G.length)return[];const Z=x(G[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(Z,H))return[];const te=[];await Promise.all(G[0].versions.map(async me=>{try{await this.y(me,$?"any":"release",!0,Z,H)&&te.push(me)}catch{}}));const le=[],he=new Set;for(const me of U(te,H))he.has(me.version)||(he.add(me.version),le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:W(me)}));return le}async D(M,$={},H=O.CancellationToken.None){const ee=await this.j,G={type:"GET"},Z={...ee,...$.headers||{}};$={...$,...G,headers:Z};const te=M.uri,le=M.fallbackUri,he={...$,url:te};try{const me=await this.k.request(he,H);if(me.res.statusCode===200)return me;const pe=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${pe}`)}catch(me){if((0,l.isCancellationError)(me))throw me;const pe=(0,l.getErrorMessage)(me);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:pe});const Se={...$,url:le};return this.k.request(Se,H)}}async E(M){let $=Y(M);if(!$){const H=await this.C(M,O.CancellationToken.None);if(!H)throw new Error("Manifest was not found");$=H.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,u.asJson)(M),H=[],ee={};if($){for(const G of $.malicious)H.push({id:G});if($.migrateToPreRelease)for(const[G,Z]of Object.entries($.migrateToPreRelease))(!Z.engine||(0,f.isEngineValid)(Z.engine,this.u.version,this.u.date))&&(ee[G.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if($.deprecated)for(const[G,Z]of Object.entries($.deprecated))Z&&(ee[G.toLowerCase()]=(0,R.isBoolean)(Z)?{}:Z)}return{malicious:H,deprecated:ee}}};oe=ye([X(1,u.IRequestService),X(2,p.ILogService),X(3,I.IEnvironmentService),X(4,b.ITelemetryService),X(5,g.IFileService),X(6,h.IProductService),X(7,v.IConfigurationService)],oe);let ae=class extends oe{constructor(M,$,H,ee,G,Z,te,le){super(M,$,H,ee,G,Z,te,le)}};ae=ye([X(0,y.IStorageService),X(1,u.IRequestService),X(2,p.ILogService),X(3,I.IEnvironmentService),X(4,b.ITelemetryService),X(5,g.IFileService),X(6,h.IProductService),X(7,v.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let V=class extends oe{constructor(M,$,H,ee,G,Z,te){super(void 0,M,$,H,ee,G,Z,te)}};V=ye([X(0,u.IRequestService),X(1,p.ILogService),X(2,I.IEnvironmentService),X(3,b.ITelemetryService),X(4,g.IFileService),X(5,h.IProductService),X(6,v.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(se[79],re([0,1,5,3,2,20,33,25,18,11,12]),function(_,e,A,O,l,D,k,R,C,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,A.createDecorator)("IExtensionStorageService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Xe extends l.Disposable{static b(g){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static c(g){const p=S.exec(g);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(g,p){const h=await g.getInstalled(),u=[];for(const[d,y]of Xe.f(p)){const b=h.find(P=>(0,k.areSameExtensions)(P.identifier,{id:d}))?.manifest.version;for(const P of y)b!==P&&u.push(Xe.b({id:d,version:P}))}for(const d of u)p.remove(d,0)}static f(g){const p=new Map,h=g.keys(0,1);for(const u of h){const d=Xe.c(u);if(d){let y=p.get(d.id.toLowerCase());y||p.set(d.id.toLowerCase(),y=[]),y.push(d.version)}}return p}constructor(g,p,h){super(),this.i=g,this.j=p,this.k=h,this.g=this.B(new O.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(g),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(g){if(g.scope!==0)return;if(this.h.has(g.key.toLowerCase())){this.g.fire();return}const p=Xe.c(g.key);if(p){if(this.i.get(g.key,0)===void 0)this.h.delete(p.id.toLowerCase());else{let h=this.h.get(p.id.toLowerCase());h||this.h.set(p.id.toLowerCase(),h=[]),h.push(p.version),this.g.fire()}return}}m(g){if((0,I.isString)(g))return g;const p=g.manifest?g.manifest.publisher:g.publisher,h=g.manifest?g.manifest.name:g.name;return(0,k.getExtensionId)(p,h)}getExtensionState(g,p){const h=this.m(g),u=this.getExtensionStateRaw(g,p);if(u)try{return JSON.parse(u)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${p}): ${d}`)}}getExtensionStateRaw(g,p){const h=this.m(g),u=this.i.get(h,p?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${p}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(g,p,h){const u=this.m(g);p===void 0?this.i.remove(u,h?0:1):this.i.store(u,JSON.stringify(p),h?0:1,1)}setKeysForSync(g,p){this.i.store(Xe.b(g),JSON.stringify(p),0,1)}getKeysForSync(g){const p=this.j.extensionSyncedKeys?.[g.id.toLowerCase()],h=this.i.get(Xe.b(g),0),u=h?JSON.parse(h):void 0;return u&&p?(0,C.distinct)([...u,...p]):u||p}addToMigrationList(g,p){if(g!==p){const h=this.n.filter(u=>!u.includes(g)&&!u.includes(p));h.push([g,p]),this.n=h}}getSourceExtensionToMigrate(g){const p=this.n.find(([,h])=>g===h);return p?p[0]:void 0}get n(){const g=this.i.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(g);if(Array.isArray(p))return p}catch{}return[]}set n(g){g.length?this.i.store("extensionStorage.migrationList",JSON.stringify(g),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,m=ye([X(0,D.IStorageService),X(1,R.IProductService),X(2,v.ILogService)],m),e.ExtensionStorageService=m}),define(se[278],re([0,1,18,6,3,13,4,36,10,164,15,29,33,221,101,14,57,25,20,19]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const b="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";let t=class extends f.ExtensionTipsService{constructor(i,n,r,o,s,c,w,E){super(w,E),this.m=i,this.n=n,this.p=r,this.r=o,this.s=s,this.t=c,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([L,T])=>{const F=[],z=[],J=[];Object.entries(T.recommendations).forEach(([Y,W])=>{W.important?T.important?F.push({extensionId:Y,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):z.push({extensionId:Y,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):J.push({extensionId:Y,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),F.length&&this.g.set(L,{exeFriendlyName:T.friendlyName,windowsPath:T.windowsPath,recommendations:F}),z.length&&this.h.set(L,{exeFriendlyName:T.friendlyName,windowsPath:T.windowsPath,recommendations:z}),J.length&&this.j.set(L,{exeFriendlyName:T.friendlyName,windowsPath:T.windowsPath,recommendations:J})}),(0,O.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const i=await this.I(this.g),n=await this.I(this.h);return[...i,...n]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const i=await this.I(this.g),n=await this.I(this.h),r=await this.p.getInstalled();this.k=this.v(i,r),this.l=this.v(n,r)}v(i,n){const r=new Map;i.forEach(E=>r.set(E.extensionId.toLowerCase(),E));const{installed:o,uninstalled:s}=this.H([...r.keys()],n);for(const E of o){const L=r.get(E);L&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:L.exeName})}for(const E of s){const L=r.get(E);L&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:L.exeName})}const c=this.F(),w=new Map;for(const E of s){const L=r.get(E);if(L&&(!c[L.exeName]||!c[L.exeName].includes(L.extensionId))){let T=w.get(L.exeName);T||(T=[],w.set(L.exeName,T)),T.push(L)}}return w}w(){if(this.k.size===0)return;const[i,n]=[...this.k.entries()][0];this.z(n).then(r=>{switch(r){case"reacted":this.G(n[0].exeName,n);break;case"ignored":this.k.delete(i);break;case"incompatibleWindow":{const o=l.Event.once(l.Event.latch(l.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(o(()=>this.w()));break}case"toomany":{const o=this.B((0,O.disposableTimeout)(()=>{o.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const i=this.C(),n=Date.now()-i,r=7*24*60*60*1e3;if(n<r){const c=this.B((0,O.disposableTimeout)(()=>{c.dispose(),this.y()},r-n));return}const[o,s]=[...this.l.entries()][0];this.z(s).then(c=>{switch(c){case"reacted":{this.D(Date.now()),this.l.delete(o),this.G(s[0].exeName,s);const w=this.B((0,O.disposableTimeout)(()=>{w.dispose(),this.y()},r));break}case"ignored":this.l.delete(o),this.y();break;case"incompatibleWindow":{const w=l.Event.once(l.Event.latch(l.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(w(()=>this.y()));break}case"toomany":{const w=this.B((0,O.disposableTimeout)(()=>{w.dispose(),this.y()},36e5));break}}})}async z(i){const n=await this.p.getInstalled(1),r=i.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(c=>n.every(w=>!(0,m.areSameExtensions)(w.identifier,{id:c})))).map(({extensionId:s})=>s.toLowerCase()),o=(0,v.localize)(0,null,i[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(r,o,`@exe:"${i[0].exeName}"`,3)}C(){let i=this.r.getNumber(P,-1);return i||(i=Date.now(),this.D(i)),i}D(i){this.r.store(P,i,-1,1)}F(){return JSON.parse(this.r.get(b,-1,"{}"))}G(i,n){const r=this.F();r[i]=n.map(({extensionId:o})=>o.toLowerCase()),this.r.store(b,JSON.stringify(r),-1,0)}H(i,n){const r=[],o=[],s=n.reduce((c,w)=>(c.add(w.identifier.id.toLowerCase()),c),new Set);return i.forEach(c=>{s.has(c.toLowerCase())?r.push(c):o.push(c)}),{installed:r,uninstalled:o}}async I(i){const n=[],r=new Map;for(const o of i.keys()){const s=i.get(o);if(!s||!(0,A.isNonEmptyArray)(s.recommendations))continue;const c=[];k.isWindows?s.windowsPath&&c.push(s.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(c.push((0,D.join)("/usr/local/bin",o)),c.push((0,D.join)("/usr/bin",o)),c.push((0,D.join)(this.m.userHome.fsPath,o)));for(const w of c){let E=r.get(w);if(E===void 0&&(E=await this.b.exists(C.URI.file(w)),r.set(w,E)),E)for(const{extensionId:L,extensionName:T,isExtensionPack:F,whenNotInstalled:z}of s.recommendations)n.push({extensionId:L,extensionName:T,isExtensionPack:F,exeName:o,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:z})}}return n}};t=ye([X(0,I.INativeEnvironmentService),X(1,y.ITelemetryService),X(2,S.IExtensionManagementService),X(3,d.IStorageService),X(4,h.INativeHostService),X(5,g.IExtensionRecommendationNotificationService),X(6,p.IFileService),X(7,u.IProductService)],t),e.ExtensionTipsService=t}),define(se[279],re([0,1,6,2,24,67,20,75,28]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends k.AbstractStorageService{constructor(S,m,f,g){super(),this.X=S,this.Y=m,this.Z=f,this.ab=g,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new O.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new O.DisposableStore),this.W=this.db(this.X)}bb(){const S=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new D.Storage(S));return this.B(m.onDidChangeStorage(f=>this.n(-1,f))),m}cb(S){this.Q.clear(),this.P=S;let m;if((0,k.isProfileUsingDefaultStorage)(S))m=this.s;else{const f=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),S));m=this.Q.add(new D.Storage(f))}return this.Q.add(m.onDidChangeStorage(f=>this.n(0,f))),m}db(S){this.U.clear(),this.S=S?.id;let m;if(S){const f=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),S));m=this.U.add(new D.Storage(f)),this.U.add(m.onDidChangeStorage(g=>this.n(1,g)))}return m}async J(){await A.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(S){switch(S){case-1:return this.s;case 0:return this.R;default:return this.W}}M(S){switch(S){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(k.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(S,m){if(!this.H(this.P,S))return;const f=this.R,g=f.items;f!==this.s&&await f.close(),this.R=this.cb(S),await this.R.init(),this.I(g,this.R,0,m)}async O(S,m){const f=this.W,g=f?.items??new Map;await f?.close(),this.W=this.db(S),await this.W.init(),this.I(g,this.W,1,m)}hasScope(S){return(0,C.isUserDataProfile)(S)?this.P.id===S.id:this.S===S.id}}e.NativeStorageService=v}),define(se[280],re([0,1,3,2,28,93]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(v,I){this.a=v,this.b=I}listen(v,I){const S=this.b(v);switch(I){case"onDidChangeProfiles":return A.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(f=>(0,D.transformOutgoingURIs)({...f},S)),added:m.added.map(f=>(0,D.transformOutgoingURIs)({...f},S)),removed:m.removed.map(f=>(0,D.transformOutgoingURIs)({...f},S)),updated:m.updated.map(f=>(0,D.transformOutgoingURIs)({...f},S))}))}throw new Error(`Invalid listen ${I}`)}async call(v,I,S){const m=this.b(v);switch(I){case"createProfile":{const f=await this.a.createProfile(S[0],S[1],S[2]);return(0,D.transformOutgoingURIs)({...f},m)}case"updateProfile":{let f=(0,l.reviveProfile)((0,D.transformIncomingURIs)(S[0],m),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,S[1]),(0,D.transformOutgoingURIs)({...f},m)}case"removeProfile":{const f=(0,l.reviveProfile)((0,D.transformIncomingURIs)(S[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${I}`)}}e.RemoteUserDataProfilesServiceChannel=k;class R extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(v,I,S){super(),this.profilesHome=I,this.f=S,this.a=[],this.b=this.B(new A.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=v.map(m=>(0,l.reviveProfile)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const f=m.added.map(h=>(0,l.reviveProfile)(h,this.profilesHome.scheme)),g=m.removed.map(h=>(0,l.reviveProfile)(h,this.profilesHome.scheme)),p=m.updated.map(h=>(0,l.reviveProfile)(h,this.profilesHome.scheme));this.a=m.all.map(h=>(0,l.reviveProfile)(h,this.profilesHome.scheme)),this.b.fire({added:f,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(v){this.c=v}isEnabled(){return this.c}async createNamedProfile(v,I,S){const m=await this.f.call("createNamedProfile",[v,I,S]);return(0,l.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(v,I,S,m){const f=await this.f.call("createProfile",[v,I,S,m]);return(0,l.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(v){const I=await this.f.call("createTransientProfile",[v]);return(0,l.reviveProfile)(I,this.profilesHome.scheme)}async setProfileForWorkspace(v,I){await this.f.call("setProfileForWorkspace",[v,I])}removeProfile(v){return this.f.call("removeProfile",[v])}async updateProfile(v,I){const S=await this.f.call("updateProfile",[v,I]);return(0,l.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(se[61],re([0,1,2,67,5,20]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let k=class extends A.Disposable{constructor(v){super(),this.a=v}async readStorageData(v){return this.withProfileScopedStorageService(v,async I=>this.b(I))}async updateStorageData(v,I,S){return this.withProfileScopedStorageService(v,async m=>this.c(m,I,S))}async withProfileScopedStorageService(v,I){if(this.a.hasScope(v))return I(this.a);const S=await this.g(v),m=new R(S);try{await m.initialize();const f=await I(m);return await m.flush(),f}finally{m.dispose(),await this.f(S)}}b(v){const I=new Map,S=m=>{for(const f of v.keys(0,m))I.set(f,{value:v.get(f,0),target:m})};return S(0),S(1),I}c(v,I,S){for(const[m,f]of I)v.store(m,f,0,S)}async f(v){try{await v.close()}finally{(0,A.isDisposable)(v)&&v.dispose()}}};k=ye([X(0,D.IStorageService)],k),e.AbstractUserDataProfileStorageService=k;class R extends D.AbstractStorageService{constructor(v){super({flushInterval:100}),this.p=this.B(new O.Storage(v))}J(){return this.p.init()}L(v){return v===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(se[281],re([0,1,3,2,71,11,61,20,75,28,69]),function(_,e,A,O,l,D,k,R,C,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let S=class extends k.AbstractUserDataProfileStorageService{constructor(f,g,p,h){super(p),this.i=f;const u=f.getChannel("profileStorageListener"),d=this.B(new O.MutableDisposable);this.h=this.B(new A.Emitter({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(y=>{h.trace("profile storage changes",y),this.h.fire({targetChanges:y.targetChanges.map(b=>(0,v.reviveProfile)(b,g.profilesHome.scheme)),valueChanges:y.valueChanges.map(b=>({...b,profile:(0,v.reviveProfile)(b.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(f){const g=this.i.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(f)?new C.ApplicationStorageDatabaseClient(g):new C.ProfileStorageDatabaseClient(g,f)}};S=ye([X(0,l.IMainProcessService),X(1,v.IUserDataProfilesService),X(2,R.IStorageService),X(3,D.ILogService)],S),e.UserDataProfileStorageService=S,(0,I.registerSingleton)(k.IUserDataProfileStorageService,S,1)}),define(se[41],re([0,1,18,6,17,23,3,35,2,26,12,182,16,15,14,44,20,19,30,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function b(r){return!!(r&&r.ref!==void 0&&typeof r.ref=="string"&&r.ref!==""&&r.syncData!==void 0&&(r.syncData===null||P(r.syncData)))}e.isRemoteUserData=b;function P(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&(Object.keys(r).length===2||Object.keys(r).length===3&&r.machineId!==void 0&&typeof r.machineId=="string"))}e.isSyncData=P;function t(r,o){return`${(0,v.uppercaseFirstLetter)(r)}${o.isDefault?"":` (${o.name})`}`}e.getSyncResourceLogLabel=t;let a=class extends C.Disposable{get status(){return this.j}get conflicts(){return{...this.syncResource,conflicts:this.l}}constructor(o,s,c,w,E,L,T,F,z,J,Y,W){super(),this.syncResource=o,this.collection=s,this.z=c,this.C=w,this.D=E,this.F=L,this.G=T,this.H=F,this.I=z,this.J=J,this.L=Y,this.c=null,this.j="idle",this.k=this.B(new k.Emitter),this.onDidChangeStatus=this.k.event,this.l=[],this.m=this.B(new k.Emitter),this.onDidChangeConflicts=this.m.event,this.n=new O.ThrottledDelayer(50),this.s=this.B(new k.Emitter),this.onDidChangeLocal=this.s.event,this.u=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.v=!1,this.y={},this.resource=this.syncResource.syncResource,this.w=t(o.syncResource,o.profile),this.h=W.extUri,this.f=this.h.joinPath(w.userDataSyncHome,...(0,y.getPathSegments)(o.profile.isDefault?void 0:o.profile.id,o.syncResource)),this.g=this.h.joinPath(this.f,y.PREVIEW_DIR_NAME),this.t=(0,y.getLastSyncResourceUri)(o.profile.isDefault?void 0:o.profile.id,o.syncResource,w,this.h),this.i=(0,p.getServiceMachineId)(w,c,E)}M(){this.n.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.J.info(`${this.w}: In conflicts state and local change detected. Syncing again...`);const o=await this.c;this.c=null;const s=await this.S(o.remoteUserData,o.lastSyncUserData,!0,this.lb());this.O(s)}else{this.J.trace(`${this.w}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?await this.rb(o):!0)&&this.s.fire()}}O(o){this.j!==o&&(this.j=o,this.k.fire(o))}async sync(o,s={}){await this.P(o,!0,this.lb(),s)}async preview(o,s,c={}){return this.P(o,!1,s,c)}async apply(o,s={}){try{this.y={...s};const c=await this.X(o);return this.O(c),this.c}finally{this.y={}}}async P(o,s,c,w){try{if(this.y={...w},this.status==="hasConflicts")return this.J.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.J.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.J.trace(`${this.w}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let E="idle";try{const L=await this.getLastSyncUserData(),T=await this.R(o,L);return E=await this.S(T,L,s,c),E==="hasConflicts"?this.J.info(`${this.w}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.J.trace(`${this.w}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(E)}}finally{this.y={}}}async replace(o){const s=this.hb(o);if(!s)return!1;await this.stop();try{this.J.trace(`${this.w}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const c=await this.getLastSyncUserData(),w=await this.R(null,c),E=await this.Q(w),L=await this.nb({ref:w.ref,syncData:s},c,E,this.lb(),D.CancellationToken.None),T=[];for(const F of L){const z=await this.pb(F,F.remoteResource,void 0,D.CancellationToken.None),{remoteChange:J}=await this.pb(F,F.previewResource,F.remoteContent,D.CancellationToken.None);T.push([F,{...z,remoteChange:J!==0?J:2}])}await this.qb(w,c,T,!1),this.J.info(`${this.w}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(o){const s=await this.i;return!!o.syncData?.machineId&&o.syncData.machineId===s}async R(o,s){if(s){const c=o?o[this.resource]:void 0;if(s.ref===c||c===void 0&&s.syncData===null)return s}return this.getRemoteUserData(s)}async S(o,s,c,w){if(o.syncData&&o.syncData.version>this.mb)throw this.I.publicLog2("sync/incompatible",{source:this.resource}),new y.UserDataSyncError((0,S.localize)(0,null,this.resource,this.mb,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(o,s,c,w)}catch(E){if(E instanceof y.UserDataSyncError)switch(E.code){case"LocalPreconditionFailed":return this.J.info(`${this.w}: Failed to synchronize ${this.w} as there is a new local version available. Synchronizing again...`),this.S(o,s,c,w);case"Conflict":case"PreconditionFailed":return this.J.info(`${this.w}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),s=await this.getLastSyncUserData(),this.S(o,s,c,w)}throw E}}async U(o,s,c,w){try{const E=await this.Q(o),L=!E&&s===null&&this.db()!==void 0,T=c&&!L;this.c||(this.c=(0,O.createCancelablePromise)(z=>this.bb(o,s,E,T,w,z)));let F=await this.c;if(c&&L){this.J.info(`${this.w}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of F.resourcePreviews)F=await this.accept(z.remoteResource)||F}return this.Z(F.resourcePreviews),F.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":c?await this.X(!1):"syncing"}catch(E){throw this.c=null,E}}async merge(o){return await this.W(o,async s=>{const c=await this.ob(s,D.CancellationToken.None);await this.z.writeFile(s.previewResource,l.VSBuffer.fromString(c?.content||""));const w=c&&!c.hasConflicts?await this.pb(s,s.previewResource,void 0,D.CancellationToken.None):void 0;return s.acceptResult=w,s.mergeState=c.hasConflicts?"conflict":w?"accepted":"preview",s.localChange=w?w.localChange:c.localChange,s.remoteChange=w?w.remoteChange:c.remoteChange,s}),this.c}async accept(o,s){return await this.W(o,async c=>{const w=await this.pb(c,o,s,D.CancellationToken.None);return c.acceptResult=w,c.mergeState="accepted",c.localChange=w.localChange,c.remoteChange=w.remoteChange,c}),this.c}async discard(o){return await this.W(o,async s=>{const c=await this.ob(s,D.CancellationToken.None);return await this.z.writeFile(s.previewResource,l.VSBuffer.fromString(c.content||"")),s.acceptResult=void 0,s.mergeState="preview",s.localChange=c.localChange,s.remoteChange=c.remoteChange,s}),this.c}async W(o,s){if(!this.c)return;let c=await this.c;const w=c.resourcePreviews.findIndex(({localResource:E,remoteResource:L,previewResource:T})=>this.h.isEqual(E,o)||this.h.isEqual(L,o)||this.h.isEqual(T,o));w!==-1&&(this.c=(0,O.createCancelablePromise)(async E=>{const L=[...c.resourcePreviews];return L[w]=await s(L[w]),{...c,resourcePreviews:L}}),c=await this.c,this.Z(c.resourcePreviews),c.resourcePreviews.some(({mergeState:E})=>E==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(o){if(!this.c)return"idle";const s=await this.c;return s.resourcePreviews.some(({mergeState:c})=>c==="conflict")?"hasConflicts":s.resourcePreviews.some(({mergeState:c})=>c!=="accepted")?"syncing":(await this.qb(s.remoteUserData,s.lastSyncUserData,s.resourcePreviews.map(c=>[c,c.acceptResult]),o),this.c=null,await this.Y(),"idle")}async Y(){try{await this.z.del(this.g,{recursive:!0})}catch{}}Z(o){const s=o.filter(({mergeState:c})=>c==="conflict");(0,A.equals)(this.l,s,(c,w)=>this.h.isEqual(c.previewResource,w.previewResource))||(this.l=s,this.m.fire(this.conflicts))}async hasPreviouslySynced(){const o=await this.getLastSyncUserData();return!!o&&o.syncData!==null}async ab(o){const s=this.c?await this.c:null;if(s)for(const c of s.resourcePreviews){if(this.h.isEqual(c.acceptedResource,o))return c.acceptResult?c.acceptResult.content:null;if(this.h.isEqual(c.remoteResource,o))return c.remoteContent;if(this.h.isEqual(c.localResource,o))return c.localContent;if(this.h.isEqual(c.baseResource,o))return c.baseContent}return null}async resetLocal(){this.D.remove(this.u,-1);try{await this.z.del(this.t)}catch(o){(0,g.toFileOperationResult)(o)!==1&&this.J.error(o)}}async bb(o,s,c,w,E,L){const T=await this.nb(o,s,c,E,L),F=[];for(const z of T){const J=z.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)F.push({...z,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=w?await this.ob(z,L):void 0;if(L.isCancellationRequested)break;await this.z.writeFile(z.previewResource,l.VSBuffer.fromString(Y?.content||""));const W=Y&&!Y.hasConflicts?await this.pb(z,z.previewResource,void 0,L):void 0;F.push({...z,acceptResult:W,mergeState:Y?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:Y?Y.localChange:z.localChange,remoteChange:W?W.remoteChange:Y?Y.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:o,lastSyncUserData:s,resourcePreviews:F,isLastSyncFromCurrentMachine:c}}async getLastSyncUserData(){let o=this.db();if(o||(o=await this.gb()),!o)return this.J.info(`${this.w}: Last sync data state does not exist.`),null;const s=JSON.parse(o),c=this.H.getResourceSyncStateVersion(this.resource);if(this.v=!!s.version&&!!c&&s.version!==c,this.v)return this.J.info(`${this.w}: Reset last sync state because last sync state version ${s.version} is not compatible with current sync state version ${c}.`),await this.resetLocal(),null;let w,E=1;for(;w===void 0&&E++<6;)try{const L=await this.eb();L&&(L.ref===s.ref?w=L.syncData:this.J.info(`${this.w}: Last sync data stored locally is not same as the last sync state.`));break}catch(L){if(L instanceof g.FileOperationError&&L.fileOperationResult===1){this.J.info(`${this.w}: Last sync resource does not exist locally.`);break}else{if(L instanceof y.UserDataSyncError)throw L;this.J.error(L,E)}}if(w===void 0)try{const L=await this.F.resolveResourceContent(this.resource,s.ref,this.collection,this.y);w=L===null?null:this.hb(L),await this.fb({ref:s.ref,syncData:w})}catch(L){if(L instanceof y.UserDataSyncError&&L.code==="NotFound")this.J.info(`${this.w}: Last sync resource does not exist remotely.`);else throw L}return w===void 0?null:{...s,syncData:w}}async cb(o,s={}){if(s.ref||s.version)throw new Error("Cannot have core properties as additional");const c=this.H.getResourceSyncStateVersion(this.resource),w={ref:o.ref,version:c,...s};this.D.store(this.u,JSON.stringify(w),-1,1),await this.fb(o)}db(){return this.D.get(this.u,-1)}async eb(){const o=(await this.z.readFile(this.t)).value.toString();try{const s=o?JSON.parse(o):void 0;if(b(s))return s}catch(s){this.J.error(s)}}async fb(o){await this.z.writeFile(this.t,l.VSBuffer.fromString(JSON.stringify(o)))}async gb(){try{const o=await this.z.readFile(this.t),s=JSON.parse(o.value.toString());await this.z.del(this.t),s.ref&&s.content!==void 0?(this.D.store(this.u,JSON.stringify({...s,content:void 0}),-1,1),await this.fb({ref:s.ref,syncData:s.content===null?null:JSON.parse(s.content)})):this.J.info(`${this.w}: Migrating last sync user data. Invalid data.`,s)}catch(o){o instanceof g.FileOperationError&&o.fileOperationResult===1?this.J.info(`${this.w}: Migrating last sync user data. Resource does not exist.`):this.J.error(o)}return this.D.get(this.u,-1)}async getRemoteUserData(o){const{ref:s,content:c}=await this.ib(o);let w=null;return c!==null&&(w=this.hb(c)),{ref:s,syncData:w}}hb(o){try{const s=JSON.parse(o);if(P(s))return s}catch(s){this.J.error(s)}throw new y.UserDataSyncError((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(o){const s=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.F.readResource(this.resource,s,this.collection,this.y)}async jb(o,s){const c=await this.i,w={version:this.mb,machineId:c,content:o};try{return s=await this.F.writeResource(this.resource,JSON.stringify(w),s,this.collection,this.y),{ref:s,syncData:w}}catch(E){throw E instanceof y.UserDataSyncError&&E.code==="TooLarge"&&(E=new y.UserDataSyncError(E.message,E.code,this.resource)),E}}async kb(o){const s={version:this.mb,content:o};return this.G.backup(this.syncResource.profile,this.resource,JSON.stringify(s))}async stop(){this.status!=="idle"&&(this.J.trace(`${this.w}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.J.info(`${this.w}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.L.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=ye([X(2,g.IFileService),X(3,f.IEnvironmentService),X(4,h.IStorageService),X(5,y.IUserDataSyncStoreService),X(6,y.IUserDataSyncBackupStoreService),X(7,y.IUserDataSyncEnablementService),X(8,u.ITelemetryService),X(9,y.IUserDataSyncLogService),X(10,m.IConfigurationService),X(11,d.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(o,s,c,w,E,L,T,F,z,J,Y,W,N){super(s,c,w,E,L,T,F,z,J,Y,W,N),this.p=o,this.B(this.z.watch(this.h.dirname(o))),this.B(this.z.onDidFilesChange(B=>this.ub(B)))}async r(){try{return await this.z.readFile(this.p)}catch{return null}}async sb(o,s,c){try{s?await this.z.writeFile(this.p,l.VSBuffer.fromString(o),c?void 0:s):await this.z.createFile(this.p,l.VSBuffer.fromString(o),{overwrite:c})}catch(w){throw w instanceof g.FileOperationError&&w.fileOperationResult===1||w instanceof g.FileOperationError&&w.fileOperationResult===3?new y.UserDataSyncError(w.message,"LocalPreconditionFailed"):w}}async tb(){try{await this.z.del(this.p)}catch(o){if(!(o instanceof g.FileOperationError&&o.fileOperationResult===1))throw o}}ub(o){!o.contains(this.p)||this.M()}};i=ye([X(3,g.IFileService),X(4,f.IEnvironmentService),X(5,h.IStorageService),X(6,y.IUserDataSyncStoreService),X(7,y.IUserDataSyncBackupStoreService),X(8,y.IUserDataSyncEnablementService),X(9,u.ITelemetryService),X(10,y.IUserDataSyncLogService),X(11,m.IConfigurationService),X(12,d.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let n=class extends i{constructor(o,s,c,w,E,L,T,F,z,J,Y,W,N,B){super(o,s,c,w,E,L,T,F,z,J,Y,N,B),this.vb=W,this.xb=void 0}wb(o,s){const c=[],w=(0,R.parse)(o,c,{allowEmptyContent:!0,allowTrailingComma:!0});return c.length>0||!(0,I.isUndefined)(w)&&s!==Array.isArray(w)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.p)),this.xb}};n=ye([X(3,g.IFileService),X(4,f.IEnvironmentService),X(5,h.IStorageService),X(6,y.IUserDataSyncStoreService),X(7,y.IUserDataSyncBackupStoreService),X(8,y.IUserDataSyncEnablementService),X(9,u.ITelemetryService),X(10,y.IUserDataSyncLogService),X(11,y.IUserDataSyncUtilService),X(12,m.IConfigurationService),X(13,d.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n}),define(se[121],re([0,1,6,23,7,3,42,2,26,16,15,120,29,33,79,14,5,70,20,19,30,41,262,118,22,61]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P,t,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(E,L){const T=JSON.parse(E.content);if(E.version===1||E.version===2){const F=(await L.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of T)E.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),E.version===2&&F.every(J=>!(0,f.areSameExtensions)(J.identifier,z.identifier))&&(z.installed=!0)}return T}function o(E){return JSON.parse(E.content)}e.parseExtensions=o;function s(E,L){return E.sort((T,F)=>!T.identifier.uuid&&F.identifier.uuid?-1:T.identifier.uuid&&!F.identifier.uuid?1:(0,C.compare)(T.identifier.id,F.identifier.id)),L?(0,k.toFormattedString)(E,{}):JSON.stringify(E)}e.stringify=s;let c=class extends P.AbstractSynchroniser{constructor(L,T,F,z,J,Y,W,N,B,ie,q,x,U,K,Q,oe,ae){super({syncResource:"extensions",profile:L},T,z,F,J,Y,W,x,U,ie,q,Q),this.yb=N,this.zb=B,this.Ab=ae,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(w),this.B(D.Event.any(D.Event.filter(this.yb.onDidInstallExtensions,V=>V.some(({local:j})=>!!j)),D.Event.filter(this.yb.onDidUninstallExtension,V=>!V.error),D.Event.filter(oe.onDidChange,V=>V.valueChanges.some(({profile:j,changes:M})=>this.syncResource.profile.id===j.id&&M.some($=>$.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),K.onDidChangeExtensionStorageToSync)(()=>this.M()))}async nb(L,T){const F=L.syncData?await r(L.syncData,this.yb):null,z=T?.skippedExtensions??[],J=T?.builtinExtensions??null,Y=T?.syncData?await r(T.syncData,this.yb):null,{localExtensions:W,ignoredExtensions:N}=await this.xb.getLocalExtensions(this.syncResource.profile);F?this.J.trace(`${this.w}: Merging remote extensions with local extensions...`):this.J.trace(`${this.w}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,t.merge)(W,F,Y,z,N,J),q={local:B,remote:ie,content:this.Db(W,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},x=this.Kb(W,!1);return[{skippedExtensions:z,builtinExtensions:J,baseResource:this.tb,baseContent:Y?this.Kb(Y,!1):x,localResource:this.ub,localContent:x,localExtensions:W,remoteResource:this.vb,remoteExtensions:F,remoteContent:F?this.Kb(F,!1):null,previewResource:this.sb,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.wb}]}async rb(L){const T=L.syncData?await r(L.syncData,this.yb):null,{localExtensions:F,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:J}=(0,t.merge)(F,T,T,L.skippedExtensions||[],z,L.builtinExtensions||[]);return J!==null}Db(L,T,F,z){const J=[...T,...F],Y=new Set,W=N=>{Y.add(N.id.toLowerCase()),N.uuid&&Y.add(N.uuid)};J.forEach(({identifier:N})=>W(N)),z.forEach(W);for(const N of L)Y.has(N.identifier.id.toLowerCase())||N.identifier.uuid&&Y.has(N.identifier.uuid)||J.push(N);return this.Kb(J,!1)}async ob(L,T){return{...L.previewResult,hasConflicts:!1}}async pb(L,T,F,z){if(this.h.isEqual(T,this.ub))return this.Gb(L);if(this.h.isEqual(T,this.vb))return this.Hb(L);if(this.h.isEqual(T,this.sb))return L.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(L){const T=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),F=this.zb.getIgnoredExtensions(T),z=(0,t.merge)(L.localExtensions,null,null,L.skippedExtensions,F,L.builtinExtensions),{local:J,remote:Y}=z;return{content:L.localContent,local:J,remote:Y,localChange:J.added.length>0||J.removed.length>0||J.updated.length>0?2:0,remoteChange:Y!==null?2:0}}async Hb(L){const T=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),F=this.zb.getIgnoredExtensions(T),z=L.remoteContent?JSON.parse(L.remoteContent):null;if(z!==null){const J=(0,t.merge)(L.localExtensions,z,L.localExtensions,[],F,L.builtinExtensions),{local:Y,remote:W}=J;return{content:L.remoteContent,local:Y,remote:W,localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:L.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(L,T,F,z){let{skippedExtensions:J,builtinExtensions:Y,localExtensions:W}=F[0][0];const{local:N,remote:B,localChange:ie,remoteChange:q}=F[0][1];if(ie===0&&q===0&&this.J.info(`${this.w}: No changes found during synchronizing extensions.`),ie!==0&&(await this.kb(JSON.stringify(W)),J=await this.xb.updateLocalExtensions(N.added,N.removed,N.updated,J,this.syncResource.profile)),B){this.J.trace(`${this.w}: Updating remote extensions...`);const x=JSON.stringify(B.all);L=await this.jb(x,z?null:L.ref),this.J.info(`${this.w}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(U=>U.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(U=>U.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(U=>U.identifier.id))}.`:""}`)}T?.ref!==L.ref&&(this.J.trace(`${this.w}: Updating last synchronized extensions...`),Y=this.Jb(W,Y),await this.cb(L,{skippedExtensions:J,builtinExtensions:Y}),this.J.info(`${this.w}: Updated last synchronized extensions.${J.length?` Skipped: ${JSON.stringify(J.map(x=>x.identifier.id))}.`:""}`))}Jb(L,T){const F=new Set,z=[];for(const J of L)F.add(J.identifier.id.toLowerCase()),J.installed||z.push(J.identifier);if(T)for(const J of T)F.has(J.id.toLowerCase())||z.push(J);return z}async resolveContent(L){if(this.h.isEqual(this.vb,L)||this.h.isEqual(this.tb,L)||this.h.isEqual(this.ub,L)||this.h.isEqual(this.wb,L)){const T=await this.ab(L);return T&&this.Kb(JSON.parse(T),!0)}return null}Kb(L,T){return s(L,T)}async hasLocalData(){try{const{localExtensions:L}=await this.xb.getLocalExtensions(this.syncResource.profile);if(L.some(T=>T.installed||T.disabled))return!0}catch{}return!1}};c=ye([X(2,I.IEnvironmentService),X(3,p.IFileService),X(4,d.IStorageService),X(5,i.IUserDataSyncStoreService),X(6,i.IUserDataSyncBackupStoreService),X(7,m.IExtensionManagementService),X(8,a.IIgnoredExtensionsManagementService),X(9,i.IUserDataSyncLogService),X(10,v.IConfigurationService),X(11,i.IUserDataSyncEnablementService),X(12,y.ITelemetryService),X(13,g.IExtensionStorageService),X(14,b.IUriIdentityService),X(15,n.IUserDataProfileStorageService),X(16,h.IInstantiationService)],c),e.ExtensionsSynchroniser=c;let w=class{constructor(L,T,F,z,J,Y){this.a=L,this.b=T,this.c=F,this.d=z,this.f=J,this.g=Y}async getLocalExtensions(L){const T=await this.a.getInstalled(void 0,L.extensionsResource),F=this.d.getIgnoredExtensions(T);return{localExtensions:await this.i(L,async(J,Y)=>{const W=J.getDisabledExtensions();return T.map(N=>{const{identifier:B,isBuiltin:ie,manifest:q,preRelease:x,pinned:U}=N,K={identifier:B,preRelease:x,version:q.version,pinned:!!U};W.some(Q=>(0,f.areSameExtensions)(Q,B))&&(K.disabled=!0),ie||(K.installed=!0);try{const Q=Y.getKeysForSync({id:B.id,version:q.version});if(Q){const oe=Y.getExtensionState(N,!0)||{};K.state=Object.keys(oe).reduce((ae,V)=>(Q.includes(V)&&(ae[V]=oe[V]),ae),{})}}catch(Q){this.g.info(`${(0,P.getSyncResourceLogLabel)("extensions",L)}: Error while parsing extension state`,(0,l.getErrorMessage)(Q))}return K})}),ignoredExtensions:F}}async updateLocalExtensions(L,T,F,z,J){const Y=(0,P.getSyncResourceLogLabel)("extensions",J),W=[],N=[],B=[],ie=await this.a.getInstalled(void 0,J.extensionsResource);if((L.length||F.length)&&await this.i(J,async(x,U)=>{await A.Promises.settled([...L,...F].map(async K=>{const Q=ie.find(V=>(0,f.areSameExtensions)(V.identifier,K.identifier));if(Q&&Q.isBuiltin){K.state&&Q.manifest.version===K.version&&this.h(K.state,Q,Q.manifest.version,U),x.getDisabledExtensions().some(j=>(0,f.areSameExtensions)(j,K.identifier))!==!!K.disabled&&(K.disabled?(this.g.trace(`${Y}: Disabling extension...`,K.identifier.id),await x.disableExtension(K.identifier),this.g.info(`${Y}: Disabled extension`,K.identifier.id)):(this.g.trace(`${Y}: Enabling extension...`,K.identifier.id),await x.enableExtension(K.identifier),this.g.info(`${Y}: Enabled extension`,K.identifier.id))),N.push(K.identifier);return}const oe=K.pinned?K.version:void 0,ae=(await this.c.getExtensions([{...K.identifier,version:oe,preRelease:oe?void 0:K.preRelease}],O.CancellationToken.None))[0];if(K.state&&(Q?Q.manifest.version===K.version:!!ae)&&this.h(K.state,Q||ae,Q?.manifest.version,U),ae)try{x.getDisabledExtensions().some(j=>(0,f.areSameExtensions)(j,K.identifier))!==!!K.disabled&&(K.disabled?(this.g.trace(`${Y}: Disabling extension...`,K.identifier.id,ae.version),await x.disableExtension(ae.identifier),this.g.info(`${Y}: Disabled extension`,K.identifier.id,ae.version)):(this.g.trace(`${Y}: Enabling extension...`,K.identifier.id,ae.version),await x.enableExtension(ae.identifier),this.g.info(`${Y}: Enabled extension`,K.identifier.id,ae.version))),(!Q||Q.preRelease!==K.preRelease||Q.pinned!==K.pinned||oe&&Q.manifest.version!==oe)&&(await this.a.canInstall(ae)?W.push([K,ae]):(this.g.info(`${Y}: Skipped synchronizing extension because it cannot be installed.`,ae.displayName||ae.identifier.id),B.push(K)))}catch(V){B.push(K),this.g.error(V),this.g.info(`${Y}: Skipped synchronizing extension`,ae.displayName||ae.identifier.id)}else B.push(K),this.g.info(`${Y}: Skipped synchronizing extension because the extension is not found.`,K.identifier.id)}))}),T.length){const x=ie.filter(({identifier:U,isBuiltin:K})=>!K&&T.some(Q=>(0,f.areSameExtensions)(U,Q)));await A.Promises.settled(x.map(async U=>{this.g.trace(`${Y}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:J.extensionsResource}),this.g.info(`${Y}: Uninstalled local extension.`,U.identifier.id),N.push(U.identifier)}))}for(const[x,U]of W)try{this.g.trace(`${Y}: Installing extension...`,U.identifier.id,U.version),await this.a.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:x.pinned&&!!x.version,installPreReleaseVersion:x.preRelease,profileLocation:J.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${Y}: Installed extension.`,U.identifier.id,U.version),N.push(U.identifier)}catch(K){B.push(x),K instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(K.code)?this.g.info(`${Y}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.g.error(K),this.g.info(`${Y}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}const q=[];for(const x of z)N.some(U=>(0,f.areSameExtensions)(U,x.identifier))||q.push(x);for(const x of B)q.some(U=>(0,f.areSameExtensions)(U.identifier,x.identifier))||q.push(x);return q}h(L,T,F,z){const J=z.getExtensionState(T,!0)||{},Y=F?z.getKeysForSync({id:T.identifier.id,version:F}):void 0;Y?Y.forEach(W=>{J[W]=L[W]}):Object.keys(L).forEach(W=>J[W]=L[W]),z.setExtensionState(T,J,!0)}async i(L,T){return this.b.withProfileScopedStorageService(L,async F=>{const z=new R.DisposableStore,J=this.f.createChild(new u.ServiceCollection([d.IStorageService,F])),Y=z.add(J.createInstance(S.GlobalExtensionEnablementService)),W=z.add(J.createInstance(g.ExtensionStorageService));try{return await T(Y,W)}finally{z.dispose()}})}};w=ye([X(0,m.IExtensionManagementService),X(1,n.IUserDataProfileStorageService),X(2,m.IExtensionGalleryService),X(3,a.IIgnoredExtensionsManagementService),X(4,h.IInstantiationService),X(5,i.IUserDataSyncLogService)],w),e.LocalExtensionsProvider=w}),define(se[122],re([0,1,17,7,3,35,42,4,31,16,15,14,11,44,20,19,30,41,60,266,22,61,5]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const a="globalState.argv.",i=["locale"];function n(w,E){const L=w.storage?Object.keys(w.storage).sort():[],T={};return L.forEach(F=>T[F]=w.storage[F]),w.storage=T,E?(0,k.toFormattedString)(w,{}):JSON.stringify(w)}e.stringify=n;const r=1;let o=class extends u.AbstractSynchroniser{constructor(E,L,T,F,z,J,Y,W,N,B,ie,q,x,U){super({syncResource:"globalState",profile:E},L,F,W,q,z,J,N,B,Y,ie,x),this.xb=T,this.mb=r,this.r=this.h.joinPath(this.g,"globalState.json"),this.sb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=U.createInstance(s),this.B(F.watch(this.h.dirname(this.C.argvResource))),this.B(l.Event.any(l.Event.filter(F.onDidFilesChange,K=>K.contains(this.C.argvResource)),l.Event.filter(T.onDidChange,K=>!!(K.targetChanges.some(Q=>this.syncResource.profile.id===Q.id)||K.valueChanges.some(({profile:Q,changes:oe})=>this.syncResource.profile.id===Q.id&&oe.some(ae=>ae.target===0)))))(()=>this.M()))}async nb(E,L,T){const F=E.syncData?JSON.parse(E.syncData.content):null;L=L===null&&T?E:L;const z=L&&L.syncData?JSON.parse(L.syncData.content):null,J=await this.wb.getLocalGlobalState(this.syncResource.profile);F?this.J.trace(`${this.w}: Merging remote ui state with local ui state...`):this.J.trace(`${this.w}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Y=await this.Fb(z),{local:W,remote:N}=(0,y.merge)(J.storage,F?F.storage:null,z?z.storage:null,Y,this.J),B={content:null,local:W,remote:N,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:N.all!==null?2:0},ie=n(J,!1);return[{baseResource:this.sb,baseContent:z?n(z,!1):ie,localResource:this.tb,localContent:ie,localUserData:J,remoteResource:this.ub,remoteContent:F?n(F,!1):null,previewResource:this.r,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.vb,storageKeys:Y}]}async rb(E){const L=E.syncData?JSON.parse(E.syncData.content):null;if(L===null)return!0;const T=await this.wb.getLocalGlobalState(this.syncResource.profile),F=await this.Fb(L),{remote:z}=(0,y.merge)(T.storage,L.storage,L.storage,F,this.J);return z.all!==null}async ob(E,L){return{...E.previewResult,hasConflicts:!1}}async pb(E,L,T,F){if(this.h.isEqual(L,this.tb))return this.Cb(E);if(this.h.isEqual(L,this.ub))return this.Db(E);if(this.h.isEqual(L,this.r))return E.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Cb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:0,remoteChange:2}}async Db(E){if(E.remoteContent!==null){const L=JSON.parse(E.remoteContent),{local:T,remote:F}=(0,y.merge)(E.localUserData.storage,L.storage,null,E.storageKeys,this.J);return{content:E.remoteContent,local:T,remote:F,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(E,L,T,F){const{localUserData:z}=T[0][0],{local:J,remote:Y,localChange:W,remoteChange:N}=T[0][1];if(W===0&&N===0&&this.J.info(`${this.w}: No changes found during synchronizing ui state.`),W!==0&&(this.J.trace(`${this.w}: Updating local ui state...`),await this.kb(JSON.stringify(z)),await this.wb.writeLocalGlobalState(J,this.syncResource.profile),this.J.info(`${this.w}: Updated local ui state`)),N!==0){this.J.trace(`${this.w}: Updating remote ui state...`);const B=JSON.stringify({storage:Y.all});E=await this.jb(B,F?null:E.ref),this.J.info(`${this.w}: Updated remote ui state.${Y.added.length?` Added: ${Y.added}.`:""}${Y.updated.length?` Updated: ${Y.updated}.`:""}${Y.removed.length?` Removed: ${Y.removed}.`:""}`)}L?.ref!==E.ref&&(this.J.trace(`${this.w}: Updating last synchronized ui state...`),await this.cb(E),this.J.info(`${this.w}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.ub,E)||this.h.isEqual(this.sb,E)||this.h.isEqual(this.tb,E)||this.h.isEqual(this.vb,E)){const L=await this.ab(E);return L&&n(JSON.parse(L),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${a}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(E){const L=await this.xb.readStorageData(this.syncResource.profile),T=[],F=[];for(const[Y,W]of L)W.target===0?T.push(Y):W.target===1&&F.push(Y);const z=[...T,...F],J=E?.storage?Object.keys(E.storage).filter(Y=>!Y.startsWith(a)&&!z.includes(Y)&&L.get(Y)!==void 0):[];if(!R.isWeb){const Y=[...b.ALL_SYNC_RESOURCES.map(W=>(0,b.getEnablementKey)(W)),b.SYNC_SERVICE_URL_TYPE];J.push(...Y),F.push(...Y)}return{user:T,machine:F,unregistered:J}}};o=ye([X(2,P.IUserDataProfileStorageService),X(3,S.IFileService),X(4,b.IUserDataSyncStoreService),X(5,b.IUserDataSyncBackupStoreService),X(6,b.IUserDataSyncLogService),X(7,I.IEnvironmentService),X(8,b.IUserDataSyncEnablementService),X(9,p.ITelemetryService),X(10,v.IConfigurationService),X(11,g.IStorageService),X(12,h.IUriIdentityService),X(13,t.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let s=class{constructor(E,L,T,F){this.a=E,this.b=L,this.c=T,this.d=F}async getLocalGlobalState(E){const L={};if(E.isDefault){const F=await this.f(),z=(0,D.parse)(F);for(const J of i)z[J]!==void 0&&(L[`${a}${J}`]={version:1,value:z[J]})}const T=await this.c.readStorageData(E);for(const[F,z]of T)z.value&&z.target===0&&(L[F]={version:1,value:z.value});return{storage:L}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,O.getErrorMessage)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:L,updated:T},F){const z=(0,u.getSyncResourceLogLabel)("globalState",F),J={},Y=new Map,W=await this.c.readStorageData(F),N=(B,ie)=>{for(const q of B){if(q.startsWith(a)){J[q.substring(a.length)]=ie?ie[q].value:void 0;continue}if(ie){const x=ie[q];x.value!==W.get(q)?.value&&Y.set(q,x.value)}else W.get(q)!==void 0&&Y.set(q,void 0)}};if(N(Object.keys(E),E),N(Object.keys(T),T),N(L),Object.keys(J).length){this.d.trace(`${z}: Updating locale...`);const B=await this.f();let ie=B;for(const q of Object.keys(J))ie=(0,d.edit)(ie,[q],J[q],{});B!==ie&&(this.d.trace(`${z}: Updating locale...`),await this.a.writeFile(this.b.argvResource,A.VSBuffer.fromString(ie)),this.d.info(`${z}: Updated locale.`)),this.d.info(`${z}: Updated locale`)}Y.size&&(this.d.trace(`${z}: Updating global state...`),await this.c.updateStorageData(F,Y,0),this.d.info(`${z}: Updated global state`,[...Y.keys()]))}};s=ye([X(0,S.IFileService),X(1,I.IEnvironmentService),X(2,P.IUserDataProfileStorageService),X(3,b.IUserDataSyncLogService)],s),e.LocalGlobalStateProvider=s;let c=class{constructor(E,L,T,F,z){this.a=E,this.b=L,this.c=T,this.d=F,this.f=z}getSyncStoreType(E){return this.h(E)?.storage[b.SYNC_SERVICE_URL_TYPE]?.value}async sync(E){const L=(0,b.createSyncHeaders)((0,C.generateUuid)());try{return await this.g(E,L)}catch(T){if(T instanceof b.UserDataSyncError)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,L)}throw T}}async g(E,L){const T=await this.a.readResource("globalState",null,void 0,L),F=this.h(T)||{storage:{}};F.storage[b.SYNC_SERVICE_URL_TYPE]={value:E,version:r};const z=await(0,f.getServiceMachineId)(this.c,this.d,this.b),J={version:r,machineId:z,content:n(F,!1)};await this.a.writeResource("globalState",JSON.stringify(J),T.ref,void 0,L)}h({content:E}){if(!E)return null;const L=JSON.parse(E);if((0,u.isSyncData)(L))return L?JSON.parse(L.content):null;throw new Error("Invalid remote data")}};c=ye([X(1,g.IStorageService),X(2,I.IEnvironmentService),X(3,S.IFileService),X(4,m.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(se[123],re([0,1,18,3,35,4,12,183,16,15,14,20,19,30,41,263,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(y,b,P){try{const t=JSON.parse(y);if(!b)return(0,k.isUndefined)(t.all)?null:t.all;switch(D.OS){case 2:return(0,k.isUndefined)(t.mac)?null:t.mac;case 3:return(0,k.isUndefined)(t.linux)?null:t.linux;case 1:return(0,k.isUndefined)(t.windows)?null:t.windows}}catch(t){return P.error(t),null}}e.getKeybindingsContentFromSyncContent=u;let d=class extends g.AbstractJsonFileSynchroniser{constructor(b,P,t,a,i,n,r,o,s,c,w,E,L){super(b.keybindingsResource,{syncResource:"keybindings",profile:b},P,o,s,c,t,a,r,E,i,w,n,L),this.mb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(O.Event.filter(n.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.M()))}async nb(b,P,t,a){const i=b.syncData?u(b.syncData.content,a.keybindingsPerPlatform??this.Mb(),this.J):null;P=P===null&&t?b:P;const n=P?this.Kb(P):null,r=await this.r(),o=await this.yb();let s=null,c=!1,w=!1,E=!1;if(i){let F=r?r.value.toString():"[]";if(F=F||"[]",this.wb(F,!0))throw new h.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource);if(!n||n!==F||n!==i){this.J.trace(`${this.w}: Merging remote keybindings with local keybindings...`);const z=await(0,p.merge)(F,i,n,o,this.vb);z.hasChanges&&(s=z.mergeContent,E=z.hasConflicts,c=E||z.mergeContent!==F,w=E||z.mergeContent!==i)}}else r&&(this.J.trace(`${this.w}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),s=r.value.toString(),w=!0);const L={content:E?n:s,localChange:c?r?2:1:0,remoteChange:w?2:0,hasConflicts:E},T=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:n,localResource:this.Cb,localContent:T,localChange:L.localChange,remoteResource:this.Db,remoteContent:i,remoteChange:L.remoteChange,previewResource:this.Ab,previewResult:L,acceptedResource:this.Eb}]}async rb(b){const P=this.Kb(b);if(P===null)return!0;const t=await this.r(),a=t?t.value.toString():"",i=await this.yb(),n=await(0,p.merge)(a||"[]",P,P,i,this.vb);return n.hasConflicts||n.mergeContent!==P}async ob(b,P){return b.previewResult}async pb(b,P,t,a){if(this.h.isEqual(P,this.Cb))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(P,this.Db))return{content:b.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(P,this.Ab))return t===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${P.toString()}`)}async qb(b,P,t,a){const{fileContent:i}=t[0][0];let{content:n,localChange:r,remoteChange:o}=t[0][1];if(r===0&&o===0&&this.J.info(`${this.w}: No changes found during synchronizing keybindings.`),n!==null&&(n=n.trim(),n=n||"[]",this.wb(n,!0)))throw new h.UserDataSyncError((0,R.localize)(1,null),"LocalInvalidContent",this.resource);if(r!==0&&(this.J.trace(`${this.w}: Updating local keybindings...`),i&&await this.kb(this.Lb(i.value.toString())),await this.sb(n||"[]",i,a),this.J.info(`${this.w}: Updated local keybindings`)),o!==0){this.J.trace(`${this.w}: Updating remote keybindings...`);const s=this.Lb(n||"[]",b.syncData?.content);b=await this.jb(s,a?null:b.ref),this.J.info(`${this.w}: Updated remote keybindings`)}try{await this.z.del(this.Ab)}catch{}P?.ref!==b.ref&&(this.J.trace(`${this.w}: Updating last synchronized keybindings...`),await this.cb(b,{platformSpecific:this.Mb()}),this.J.info(`${this.w}: Updated last synchronized keybindings`))}async hasLocalData(){try{const b=await this.r();if(b){const P=(0,l.parse)(b.value.toString());if((0,A.isNonEmptyArray)(P))return!0}}catch(b){if(b.fileOperationResult!==1)return!0}return!1}async resolveContent(b){return this.h.isEqual(this.Db,b)||this.h.isEqual(this.Bb,b)||this.h.isEqual(this.Cb,b)||this.h.isEqual(this.Eb,b)?this.ab(b):null}Kb(b){return!b.syncData||b.platformSpecific!==void 0&&b.platformSpecific!==this.Mb()?null:u(b.syncData.content,this.Mb(),this.J)}Lb(b,P){let t={};try{t=JSON.parse(P||"{}")}catch(a){this.J.error(a)}switch(this.Mb()?delete t.all:t.all=b,D.OS){case 2:t.mac=b;break;case 3:t.linux=b;break;case 1:t.windows=b;break}return JSON.stringify(t)}Mb(){return!!this.L.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};d=ye([X(2,h.IUserDataSyncStoreService),X(3,h.IUserDataSyncBackupStoreService),X(4,h.IUserDataSyncLogService),X(5,C.IConfigurationService),X(6,h.IUserDataSyncEnablementService),X(7,I.IFileService),X(8,v.IEnvironmentService),X(9,S.IStorageService),X(10,h.IUserDataSyncUtilService),X(11,m.ITelemetryService),X(12,f.IUriIdentityService)],d),e.KeybindingsSynchroniser=d}),define(se[124],re([0,1,3,184,16,73,15,29,14,20,19,30,41,60,267,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function h(y){return y&&y.settings&&typeof y.settings=="string"&&Object.keys(y).length===1}function u(y){const b=JSON.parse(y);return h(b)?b:{settings:y}}e.parseSettingsSyncContent=u;let d=class extends m.AbstractJsonFileSynchroniser{constructor(b,P,t,a,i,n,r,o,s,c,w,E,L,T){super(b.settingsResource,{syncResource:"settings",profile:b},P,t,a,i,n,r,w,E,o,s,c,T),this.Ab=L,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(b){const P=await this.getLastSyncUserData(),t=await this.R(b,P),a=this.Hb(t),i=new D.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&i.parse(a.settings),i.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(b,P,t){const a=await this.r(),i=await this.yb(),n=this.Hb(b);P=P===null&&t?b:P;const r=P?this.Hb(P):null,o=await this.Lb();let s=null,c=!1,w=!1,E=!1;if(n){let z=a?a.value.toString().trim():"{}";z=z||"{}",this.Mb(z),this.J.trace(`${this.w}: Merging remote settings with local settings...`);const J=(0,g.merge)(z,n.settings,r?r.settings:null,o,[],i);s=J.localContent||J.remoteContent,c=J.localContent!==null,w=J.remoteContent!==null,E=J.hasConflicts}else a&&(this.J.trace(`${this.w}: Remote settings does not exist. Synchronizing settings for the first time.`),s=a.value.toString().trim()||"{}",this.Mb(s),w=!0);const L=a?a.value.toString():null,T=r?.settings??null,F={content:E?T:s,localChange:c?2:0,remoteChange:w?2:0,hasConflicts:E};return[{fileContent:a,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:L,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:n?n.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async rb(b){const P=this.Hb(b);if(P===null)return!0;const t=await this.r(),a=t?t.value.toString().trim():"",i=await this.Lb(),n=await this.yb();return(0,g.merge)(a||"{}",P.settings,P.settings,i,[],n).remoteContent!==null}async ob(b,P){const t=await this.yb(),a=await this.Lb();return{...b.previewResult,content:b.previewResult.content?(0,g.updateIgnoredSettings)(b.previewResult.content,"{}",a,t):null}}async pb(b,P,t,a){const i=await this.yb(),n=await this.Lb();if(this.h.isEqual(P,this.localResource))return{content:b.fileContent?(0,g.updateIgnoredSettings)(b.fileContent.value.toString(),"{}",n,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(P,this.remoteResource))return{content:b.remoteContent!==null?(0,g.updateIgnoredSettings)(b.remoteContent,b.fileContent?b.fileContent.value.toString():"{}",n,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(P,this.previewResource))return t===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:t!==null?(0,g.updateIgnoredSettings)(t,b.fileContent?b.fileContent.value.toString():"{}",n,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${P.toString()}`)}async qb(b,P,t,a){const{fileContent:i}=t[0][0];let{content:n,localChange:r,remoteChange:o}=t[0][1];if(r===0&&o===0&&this.J.info(`${this.w}: No changes found during synchronizing settings.`),n=n?n.trim():"{}",n=n||"{}",this.Mb(n),r!==0&&(this.J.trace(`${this.w}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Jb(i.value.toString()))),await this.sb(n,i,a),await this.L.reloadConfiguration(3),this.J.info(`${this.w}: Updated local settings`)),o!==0){const s=await this.yb(),c=this.Hb(b),w=await this.Lb(n);n=(0,g.updateIgnoredSettings)(n,c?c.settings:"{}",w,s),this.J.trace(`${this.w}: Updating remote settings...`),b=await this.jb(JSON.stringify(this.Jb(n)),a?null:b.ref),this.J.info(`${this.w}: Updated remote settings`)}try{await this.z.del(this.previewResource)}catch{}P?.ref!==b.ref&&(this.J.trace(`${this.w}: Updating last synchronized settings...`),await this.cb(b),this.J.info(`${this.w}: Updated last synchronized settings`))}async hasLocalData(){try{const b=await this.r();if(b){const P=await this.yb(),t=(0,f.edit)(b.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,P);return!(0,g.isEmpty)(t)}}catch(b){if(b.fileOperationResult!==1)return!0}return!1}async resolveContent(b){return this.h.isEqual(this.remoteResource,b)||this.h.isEqual(this.localResource,b)||this.h.isEqual(this.acceptedResource,b)||this.h.isEqual(this.baseResource,b)?this.ab(b):null}async ab(b){let P=await super.ab(b);if(P){const t=await this.yb(),a=await this.Lb();P=(0,g.updateIgnoredSettings)(P,"{}",a,t)}return P}Hb(b){return b.syncData?this.Ib(b.syncData.content):null}Ib(b){try{return u(b)}catch(P){this.J.error(P)}return null}Jb(b){return{settings:b}}async Lb(b){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const t=A.Event.any(A.Event.filter(this.Ab.onDidInstallExtensions,a=>a.some(({local:i})=>!!i)),A.Event.filter(this.Ab.onDidUninstallExtension,a=>!a.error))(()=>{t.dispose(),this.Kb=void 0})}const P=await this.Kb;return(0,g.getIgnoredSettings)(P,this.L,b)}Mb(b){if(this.wb(b,!1))throw new p.UserDataSyncError((0,O.localize)(0,null),"LocalInvalidContent",this.resource)}};d=ye([X(2,C.IFileService),X(3,k.IEnvironmentService),X(4,v.IStorageService),X(5,p.IUserDataSyncStoreService),X(6,p.IUserDataSyncBackupStoreService),X(7,p.IUserDataSyncLogService),X(8,p.IUserDataSyncUtilService),X(9,l.IConfigurationService),X(10,p.IUserDataSyncEnablementService),X(11,I.ITelemetryService),X(12,R.IExtensionManagementService),X(13,S.IUriIdentityService)],d),e.SettingsSynchroniser=d}),define(se[125],re([0,1,17,3,32,16,15,14,20,19,30,41,264,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsSynchroniser=e.parseSnippets=void 0;function g(h){return JSON.parse(h.content)}e.parseSnippets=g;let p=class extends S.AbstractSynchroniser{constructor(u,d,y,b,P,t,a,i,n,r,o,s){super({syncResource:"snippets",profile:u},d,b,y,P,t,a,r,o,i,n,s),this.mb=1,this.r=u.snippetsHome,this.B(this.z.watch(y.userRoamingDataHome)),this.B(this.z.watch(this.r)),this.B(O.Event.filter(this.z.onDidFilesChange,c=>c.affects(this.r))(()=>this.M()))}async nb(u,d,y){const b=await this.Db(),P=this.Cb(b),t=u.syncData?this.Bb(u.syncData):null;d=d===null&&y?u:d;const a=d&&d.syncData?this.Bb(d.syncData):null;t?this.J.trace(`${this.w}: Merging remote snippets with local snippets...`):this.J.trace(`${this.w}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,m.merge)(P,t,a);return this.xb(i,b,t||{},a||{})}async rb(u){const d=u.syncData?this.Bb(u.syncData):null;if(d===null)return!0;const y=await this.Db(),b=this.Cb(y),P=(0,m.merge)(b,d,d);return Object.keys(P.remote.added).length>0||Object.keys(P.remote.updated).length>0||P.remote.removed.length>0||P.conflicts.length>0}async ob(u,d){return u.previewResult}async pb(u,d,y,b){if(this.h.isEqualOrParent(d,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return y===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:y,localChange:y===null?u.fileContent!==null?3:0:2,remoteChange:y===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(u,d,y,b){const P=y.map(([t,a])=>({...t,acceptResult:a}));P.every(({localChange:t,remoteChange:a})=>t===0&&a===0)&&this.J.info(`${this.w}: No changes found during synchronizing snippets.`),P.some(({localChange:t})=>t!==0)&&(await this.yb(P),await this.zb(P,b)),P.some(({remoteChange:t})=>t!==0)&&(u=await this.Ab(P,u,b)),d?.ref!==u.ref&&(this.J.trace(`${this.w}: Updating last synchronized snippets...`),await this.cb(u),this.J.info(`${this.w}: Updated last synchronized snippets`));for(const{previewResource:t}of P)try{await this.z.del(t)}catch{}}xb(u,d,y,b){const P=new Map;for(const t of Object.keys(u.local.added)){const a={content:u.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.local.updated)){const a={content:u.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},i=d[t]?d[t].value.toString():null;P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[t]?d[t].value.toString():null;P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.added)){const a={content:u.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},i=d[t]?d[t].value.toString():null;P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.updated)){const a={content:u.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},i=d[t]?d[t].value.toString():null;P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.conflicts){const a={content:b[t]??null,hasConflicts:!0,localChange:d[t]?2:1,remoteChange:y[t]?2:1},i=d[t]?d[t].value.toString():null;P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d))if(!P.has(t)){const a={content:d[t]?d[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[t]?d[t].value.toString():null;P.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...P.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(u):null}async hasLocalData(){try{const u=await this.Db();if(Object.keys(u).length)return!0}catch{}return!1}async yb(u){const d={};for(const y of u)y.fileContent&&(d[this.h.basename(y.localResource)]=y.fileContent);await this.kb(JSON.stringify(this.Cb(d)))}async zb(u,d){for(const{fileContent:y,acceptResult:b,localResource:P,remoteResource:t,localChange:a}of u)if(a!==0){const i=t?this.h.basename(t):this.h.basename(P),n=this.h.joinPath(this.r,i);a===3?(this.J.trace(`${this.w}: Deleting snippet...`,this.h.basename(n)),await this.z.del(n),this.J.info(`${this.w}: Deleted snippet`,this.h.basename(n))):a===1?(this.J.trace(`${this.w}: Creating snippet...`,this.h.basename(n)),await this.z.createFile(n,A.VSBuffer.fromString(b.content),{overwrite:d}),this.J.info(`${this.w}: Created snippet`,this.h.basename(n))):(this.J.trace(`${this.w}: Updating snippet...`,this.h.basename(n)),await this.z.writeFile(n,A.VSBuffer.fromString(b.content),d?void 0:y),this.J.info(`${this.w}: Updated snippet`,this.h.basename(n)))}}async Ab(u,d,y){const b=d.syncData?this.Bb(d.syncData):{},P=(0,l.deepClone)(b);for(const{acceptResult:t,localResource:a,remoteResource:i,remoteChange:n}of u)if(n!==0){const r=a?this.h.basename(a):this.h.basename(i);n===3?delete P[r]:P[r]=t.content}return(0,m.areSame)(b,P)||(this.J.trace(`${this.w}: Updating remote snippets...`),d=await this.jb(JSON.stringify(P),y?null:d.ref),this.J.info(`${this.w}: Updated remote snippets`)),d}Bb(u){return g(u)}Cb(u){const d={};for(const y of Object.keys(u))d[y]=u[y].value.toString();return d}async Db(){const u={};let d;try{d=await this.z.resolve(this.r)}catch(y){if(y instanceof R.FileOperationError&&y.fileOperationResult===1)return u;throw y}for(const y of d.children||[]){const b=y.resource,P=this.h.extname(b);if(P===".json"||P===".code-snippets"){const t=this.h.relativePath(this.r,b),a=await this.z.readFile(b);u[t]=a}}return u}};p=ye([X(2,k.IEnvironmentService),X(3,R.IFileService),X(4,C.IStorageService),X(5,f.IUserDataSyncStoreService),X(6,f.IUserDataSyncBackupStoreService),X(7,f.IUserDataSyncLogService),X(8,D.IConfigurationService),X(9,f.IUserDataSyncEnablementService),X(10,v.ITelemetryService),X(11,I.IUriIdentityService)],p),e.SnippetsSynchroniser=p}),define(se[126],re([0,1,16,15,14,20,19,30,41,22]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function I(f,g){try{return JSON.parse(f).tasks??null}catch(p){return g.error(p),null}}e.getTasksContentFromSyncContent=I;let S=class extends C.AbstractFileSynchroniser{constructor(g,p,h,u,d,y,b,P,t,a,i,n){super(g.tasksResource,{syncResource:"tasks",profile:g},p,P,t,a,h,u,b,i,d,y,n),this.mb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(g,p,h,u){const d=g.syncData?I(g.syncData.content,this.J):null;p=p===null&&h?g:p;const y=p?.syncData?I(p.syncData.content,this.J):null,b=await this.r();let P=null,t=!1,a=!1,i=!1;if(g.syncData){const o=b?b.value.toString():null;if(!y||y!==o||y!==d){this.J.trace(`${this.w}: Merging remote tasks with local tasks...`);const s=m(o,d,y);P=s.content,i=s.hasConflicts,t=s.hasLocalChanged,a=s.hasRemoteChanged}}else b&&(this.J.trace(`${this.w}: Remote tasks does not exist. Synchronizing tasks for the first time.`),P=b.value.toString(),a=!0);const n={content:i?y:P,localChange:t?b?2:1:0,remoteChange:a?2:0,hasConflicts:i},r=b?b.value.toString():null;return[{fileContent:b,baseResource:this.xb,baseContent:y,localResource:this.yb,localContent:r,localChange:n.localChange,remoteResource:this.zb,remoteContent:d,remoteChange:n.remoteChange,previewResource:this.wb,previewResult:n,acceptedResource:this.Ab}]}async rb(g){const p=g?.syncData?I(g.syncData.content,this.J):null;if(p===null)return!0;const h=await this.r(),u=h?h.value.toString():null,d=m(u,p,p);return d.hasLocalChanged||d.hasRemoteChanged}async ob(g,p){return g.previewResult}async pb(g,p,h,u){if(this.h.isEqual(p,this.yb))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(p,this.zb))return{content:g.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(p,this.wb))return h===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async qb(g,p,h,u){const{fileContent:d}=h[0][0],{content:y,localChange:b,remoteChange:P}=h[0][1];if(b===0&&P===0&&this.J.info(`${this.w}: No changes found during synchronizing tasks.`),b!==0&&(this.J.trace(`${this.w}: Updating local tasks...`),d&&await this.kb(JSON.stringify(this.Gb(d.value.toString()))),y?await this.sb(y,d,u):await this.tb(),this.J.info(`${this.w}: Updated local tasks`)),P!==0){this.J.trace(`${this.w}: Updating remote tasks...`);const t=JSON.stringify(this.Gb(y));g=await this.jb(t,u?null:g.ref),this.J.info(`${this.w}: Updated remote tasks`)}try{await this.z.del(this.wb)}catch{}p?.ref!==g.ref&&(this.J.trace(`${this.w}: Updating last synchronized tasks...`),await this.cb(g),this.J.info(`${this.w}: Updated last synchronized tasks`))}async hasLocalData(){return this.z.exists(this.p)}async resolveContent(g){return this.h.isEqual(this.zb,g)||this.h.isEqual(this.xb,g)||this.h.isEqual(this.yb,g)||this.h.isEqual(this.Ab,g)?this.ab(g):null}Gb(g){return g?{tasks:g}:{}}};S=ye([X(2,v.IUserDataSyncStoreService),X(3,v.IUserDataSyncBackupStoreService),X(4,v.IUserDataSyncLogService),X(5,A.IConfigurationService),X(6,v.IUserDataSyncEnablementService),X(7,l.IFileService),X(8,O.IEnvironmentService),X(9,D.IStorageService),X(10,k.ITelemetryService),X(11,R.IUriIdentityService)],S),e.TasksSynchroniser=S;function m(f,g,p){if(f===null&&g===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===g)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=p!==f,u=p!==g;return!h&&!u?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!u?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:u&&!h?{content:g,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(se[127],re([0,1,42,16,15,14,20,19,30,28,41,265,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let f=class extends I.AbstractSynchroniser{constructor(u,d,y,b,P,t,a,i,n,r,o,s,c){super({syncResource:"profiles",profile:u},d,b,P,t,a,i,o,s,n,r,c),this.sb=y,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),y=await this.R(u,d);return y?.syncData?p(y.syncData):null}async nb(u,d,y){if(!this.sb.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const b=u.syncData?p(u.syncData):null,P=d?.syncData?p(d.syncData):null,t=this.Ab(),{local:a,remote:i}=(0,S.merge)(t,b,P,[]),n={local:a,remote:i,content:P?this.Bb(P):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:i!==null?2:0},r=g(t,!1);return[{baseResource:this.baseResource,baseContent:P?this.Bb(P):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:b?this.Bb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(u){const d=u?.syncData?p(u.syncData):null,y=this.Ab(),{remote:b}=(0,S.merge)(y,d,d,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async ob(u,d){return{...u.previewResult,hasConflicts:!1}}async pb(u,d,y,b){if(this.h.isEqual(d,this.localResource))return this.xb(u);if(this.h.isEqual(d,this.remoteResource))return this.yb(u);if(this.h.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async xb(u){const d=this.Ab(),y=(0,S.merge)(d,null,null,[]),{local:b,remote:P}=y;return{content:u.localContent,local:b,remote:P,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:P!==null?2:0}}async yb(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,y=[],b=[];for(const P of this.Ab()){const t=d?.find(a=>a.id===P.id);t&&(y.push({id:P.id,name:P.name,collection:t.collection}),b.push(P))}if(d!==null){const P=(0,S.merge)(b,d,y,[]),{local:t,remote:a}=P;return{content:u.remoteContent,local:t,remote:a,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(u,d,y,b){const{local:P,remote:t,localChange:a,remoteChange:i}=y[0][1];a===0&&i===0&&this.J.info(`${this.w}: No changes found during synchronizing profiles.`);const n=y[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.kb(g(this.Ab(),!1));const r=[];for(const o of P.added)r.push((async()=>{this.J.trace(`${this.w}: Creating '${o.name}' profile...`),await this.sb.createProfile(o.id,o.name,{shortName:o.shortName}),this.J.info(`${this.w}: Created profile '${o.name}'.`)})());for(const o of P.removed)r.push((async()=>{this.J.trace(`${this.w}: Removing '${o.name}' profile...`),await this.sb.removeProfile(o),this.J.info(`${this.w}: Removed profile '${o.name}'.`)})());for(const o of P.updated){const s=this.sb.profiles.find(c=>c.id===o.id);s?r.push((async()=>{this.J.trace(`${this.w}: Updating '${o.name}' profile...`),await this.sb.updateProfile(s,{name:o.name,shortName:o.shortName}),this.J.info(`${this.w}: Updated profile '${o.name}'.`)})()):this.J.info(`${this.w}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(r)}if(i!==0){this.J.trace(`${this.w}: Updating remote profiles...`);const r=[],o=n.length+(t?.added.length??0)<=20;if(o)for(const s of t?.added||[]){const c=await this.F.createCollection(this.y);r.push(c),n.push({id:s.id,name:s.name,collection:c,shortName:s.shortName})}else this.J.info(`${this.w}: Could not create remote profiles as there are too many profiles.`);for(const s of t?.removed||[])n.splice(n.findIndex(({id:c})=>s.id===c),1);for(const s of t?.updated||[]){const c=n.find(({id:w})=>s.id===w);c&&n.splice(n.indexOf(c),1,{id:s.id,name:s.name,collection:c.collection,shortName:s.shortName})}try{u=await this.updateRemoteProfiles(n,b?null:u.ref),this.J.info(`${this.w}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(s=>s.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(s=>s.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(s=>s.name))}.`:""}`)}catch(s){if(r.length){this.J.info(`${this.w}: Failed to update remote profiles. Cleaning up added collections...`);for(const c of r)await this.F.deleteCollection(c,this.y)}throw s}for(const s of t?.removed||[])await this.F.deleteCollection(s.collection,this.y)}d?.ref!==u.ref&&(this.J.trace(`${this.w}: Updating last synchronized profiles...`),await this.cb(u),this.J.info(`${this.w}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.jb(this.Bb(u),d)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const d=await this.ab(u);return d&&(0,A.toFormattedString)(JSON.parse(d),{})}return null}Ab(){return this.sb.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((d,y)=>d.name.localeCompare(y.name)))}};f=ye([X(2,v.IUserDataProfilesService),X(3,D.IFileService),X(4,l.IEnvironmentService),X(5,k.IStorageService),X(6,m.IUserDataSyncStoreService),X(7,m.IUserDataSyncBackupStoreService),X(8,m.IUserDataSyncLogService),X(9,O.IConfigurationService),X(10,m.IUserDataSyncEnablementService),X(11,R.ITelemetryService),X(12,C.IUriIdentityService)],f),e.UserDataProfilesManifestSynchroniser=f;function g(h,u){const d=[...h].sort((y,b)=>y.name.localeCompare(b.name)).map(y=>({id:y.id,name:y.name}));return u?(0,A.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=g;function p(h){return JSON.parse(h.content)}e.parseUserDataProfilesManifest=p}),define(se[282],re([0,1,6,17,64,2,24,16,15,14,28,22]),function(_,e,A,O,l,D,k,R,C,v,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends D.Disposable{constructor(g,p,h,u,d){super(),this.a=g,this.b=p,this.c=h,this.f=u,this.g=d,this.h()}async h(){for(const p of this.g.profiles)for(const h of S.ALL_SYNC_RESOURCES)try{await this.j(this.i(p,h))}catch(u){this.f.error(u)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,v.toFileOperationResult)(p)!==1&&this.f.error(p);return}if(g.children){for(const p of g.children)if(p.isDirectory&&!this.g.profiles.some(h=>h.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(h){this.f.error(h)}}}async getAllRefs(g,p){const h=this.i(g,p);try{const u=await this.b.resolve(h);if(u.children)return u.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort().reverse().map(y=>({ref:y.name,created:this.k(y)}))}catch(u){if((0,v.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(g,p,h){const u=this.i(g,p),d=(0,k.joinPath)(u,h);try{return(await this.b.readFile(d)).value.toString()}catch(y){return this.f.error(y),null}}async backup(g,p,h){const u=this.i(g,p),d=(0,k.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,O.VSBuffer.fromString(h))}catch(y){this.f.error(y)}try{this.j(u)}catch{}}i(g,p){return(0,k.joinPath)(this.a.userDataSyncHome,...g.isDefault?[p]:[g.id,p])}async j(g){try{try{if(!await this.b.exists(g))return}catch{return}const p=await this.b.resolve(g);if(p.children){const h=p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=h.filter(b=>Date.now()-this.k(b)>u);const y=h.length-d.length;y<10&&(d=d.slice(10-y)),await A.Promises.settled(d.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(p){this.f.error(p)}}k(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};m=ye([X(0,C.IEnvironmentService),X(1,v.IFileService),X(2,R.IConfigurationService),X(3,S.IUserDataSyncLogService),X(4,I.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(se[283],re([0,1,3,2,4,15,20,19,22]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const v="sync.enable";let I=class extends O.Disposable{constructor(m,f,g,p){super(),this.c=m,this.f=f,this.g=g,this.h=p,this.a=new A.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new A.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(h=>this.j(h)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(v,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(v,{enabled:m}),this.c.store(v,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,C.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,f){if(this.isResourceEnabled(m)!==f){const g=(0,C.getEnablementKey)(m);this.i(g,f)}}getResourceSyncStateVersion(m){}i(m,f){this.c.store(m,f,-1,l.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(v===m.key){this.a.fire(this.isEnabled());return}const f=C.ALL_SYNC_RESOURCES.filter(g=>(0,C.getEnablementKey)(g)===m.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};I=ye([X(0,k.IStorageService),X(1,R.ITelemetryService),X(2,D.IEnvironmentService),X(3,C.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(se[80],re([0,1,3,2,4,26,188,15,14,5,25,44,20,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const g="sync.currentMachineName",p="Safari",h="Chrome",u="Edge",d="Firefox",y="Android";function b(a){switch(a){case p:case h:case u:case d:case y:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function P(){return l.isSafari?p:l.isChrome?h:l.isEdge?u:l.isFirefox?d:l.isAndroid?y:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let t=class nt extends O.Disposable{constructor(i,n,r,o,s,c){super(),this.h=r,this.i=o,this.j=s,this.k=c,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.getServiceMachineId)(i,n,r)}async getMachines(i){const n=await this.f;return(await this.m(i)).machines.map(o=>({...o,isCurrent:o.id===n}))}async addCurrentMachine(i){const n=await this.f,r=await this.m(i);r.machines.some(({id:o})=>o===n)||(r.machines.push({id:n,name:this.l(r.machines),platform:P()}),await this.n(r))}async removeCurrentMachine(i){const n=await this.f,r=await this.m(i),o=r.machines.filter(({id:s})=>s!==n);o.length!==r.machines.length&&(r.machines=o,await this.n(r))}async renameMachine(i,n,r){const o=await this.m(r),s=o.machines.find(({id:c})=>c===i);if(s){s.name=n,await this.n(o);const c=await this.f;i===c&&this.h.store(g,n,-1,1)}}async setEnablements(i){const n=await this.m();for(const[r,o]of i){const s=n.machines.find(c=>c.id===r);s&&(s.disabled=o?void 0:!0)}await this.n(n)}l(i){const n=this.h.get(g,-1);if(n)return n;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${P()} (${this.k.nameShort})`,o=new RegExp(`${(0,D.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let s=0;for(const c of i){const w=o.exec(c.name),E=w?parseInt(w[1]):0;s=E>s?E:s}return`${r} #${s+1}`}async m(i){this.g=await this.p(i);const n=this.r(this.g);if(n.version!==nt.a)throw new Error((0,k.localize)(0,null,this.k.nameLong));return n}async n(i){const n=JSON.stringify(i),r=await this.i.writeResource(nt.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async p(i){if(this.g){const n=i&&i.latest?i.latest[nt.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(nt.b,this.g)}r(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.j.error(n)}return{version:nt.a,machines:[]}}};t.a=1,t.b="machines",t=ye([X(0,R.IEnvironmentService),X(1,C.IFileService),X(2,m.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncLogService),X(5,I.IProductService)],t),e.UserDataSyncMachinesService=t}),define(se[284],re([0,1,6,64,39,7,3,2,4,24,10,185,25,20,19,22,77,80]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",y="sync.sessionId",b="sync.storeUrl",P="sync.productQuality";let t=class extends R.Disposable{get j(){const n=this.z.get(b,-1);return n?I.URI.parse(n):void 0}set j(n){n?this.z.store(b,n.toString(),-1,1):this.z.remove(b,-1)}get l(){return this.z.get(P,-1)}set l(n){n?this.z.store(P,n,-1,1):this.z.remove(P,-1)}constructor(n,r,o,s,c,w,E,L,T,F){super(),this.n=r,this.p=o,this.r=s,this.s=c,this.u=w,this.v=E,this.w=L,this.y=T,this.z=F,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new k.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new A.ThrottledDelayer(this.O())),this.i=this.j,this.j=r.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(r.onDidChangeUserDataSyncStore(()=>{(0,v.isEqual)(this.j,r.userDataSyncStore?.url)||(this.i=this.j,this.j=r.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(E.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(c.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(k.Event.filter(this.r.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:r}=this.F();n?this.a.value===void 0&&(this.a.value=new a(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(r&&this.u.info(r),this.a.clear()):r&&this.r.isEnabled()&&this.u.info(r))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,r,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(y,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(s){if(this.u.error(s),r)this.G(!1);else throw s}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const r=p.UserDataSyncError.toUserDataSyncError(n);r instanceof p.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:r.code,service:this.n.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?C.isWeb&&r.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(r),this.b++),this.h.fire(r)}async J(){this.z.store(d,!0,-1,1),await(0,A.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(n,r,o){if(this.a.value===void 0)return this.f.cancel();if(r&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const s=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:s}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};t=ye([X(0,m.IProductService),X(1,p.IUserDataSyncStoreManagementService),X(2,p.IUserDataSyncStoreService),X(3,p.IUserDataSyncEnablementService),X(4,p.IUserDataSyncService),X(5,p.IUserDataSyncLogService),X(6,h.IUserDataSyncAccountService),X(7,g.ITelemetryService),X(8,u.IUserDataSyncMachinesService),X(9,f.IStorageService)],t),e.UserDataAutoSyncService=t;class a extends R.Disposable{constructor(n,r,o,s,c,w,E,L){super(),this.j=n,this.k=r,this.l=o,this.m=s,this.n=c,this.p=w,this.r=E,this.s=L,this.b=this.B(new R.MutableDisposable),this.c=this.B(new k.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new k.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}u(){this.b.value=(0,A.disposableTimeout)(()=>this.sync(a.a,!1),this.k)}sync(n,r){const o=(0,A.createCancelablePromise)(async s=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(c){if((0,D.isCancellationError)(c))return}return this.y(n,r,s)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,v.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),r=this.l.userDataSyncStore;return!!r&&!!n&&(!(0,v.isEqual)(r.defaultUrl,n.defaultUrl)||!(0,v.isEqual)(r.insidersUrl,n.insidersUrl)||!(0,v.isEqual)(r.stableUrl,n.stableUrl))}async y(n,r,o){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let s;try{await this.z(r,o)}catch(c){if(this.r.error(c),s=c,p.UserDataSyncError.toUserDataSyncError(c).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(r,o),s=void 0}catch(w){this.r.error(w),s=w}}this.f.fire(s)}async z(n,r){if(this.h=await this.n.createSyncTask(this.g,n),r.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new p.UserDataAutoSyncError((0,S.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,S.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,S.localize)(2,null),"TurnedOff");const o=this.s.get(y,-1);if(o&&this.g&&o!==this.g.session)throw this.v()?await this.w()?new p.UserDataAutoSyncError((0,S.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,S.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,S.localize)(5,null),"SessionExpired");const s=await this.p.getMachines(this.g||void 0);if(r.isCancellationRequested)return;const c=s.find(w=>w.isCurrent);if(c?.disabled)throw new p.UserDataAutoSyncError((0,S.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(w){throw new p.UserDataAutoSyncError((0,l.toErrorMessage)(w),w instanceof p.UserDataSyncError?w.code:"Unknown")}this.g&&this.g.session!==o&&this.s.store(y,this.g.session,-1,1),!r.isCancellationRequested&&(c||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}a.a="Interval"}),define(se[285],re([0,1,10,189,15,14,44,20,30,22,28,41,125,124,123,16,126,121,122,5,127,42]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let t=class He{constructor(i,n,r,o,s,c,w,E,L,T){this.e=i,this.f=n,this.g=r,this.h=s,this.i=c,this.j=w,this.k=E,this.l=L,this.m=T,this.d=o.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const n=this.K(i.content,"profiles");return(0,b.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(i,n){return(await this.e.getAllResourceRefs(i,n?.collection)).map(({created:o,ref:s})=>({created:o,uri:this.I({remote:!0,syncResource:i,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:s,node:void 0})}))}async getLocalSyncResourceHandles(i,n){return(await this.f.getAllRefs(n,i)).map(({created:o,ref:s})=>({created:o,uri:this.I({remote:!1,syncResource:i,profile:n.id,collection:void 0,ref:s,node:void 0})}))}resolveUserDataSyncResource({uri:i}){const n=this.J(i),r=n?this.k.profiles.find(o=>o.id===n.profile):void 0;return n&&r?{profile:r,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:i}){const n=this.J(i);if(!n)return[];const r=this.k.profiles.find(o=>o.id===n.profile);switch(n.syncResource){case"settings":return this.r(i,r);case"keybindings":return this.t(i,r);case"tasks":return this.v(i,r);case"snippets":return this.x(i,r);case"globalState":return this.C(i,r);case"extensions":return this.z(i,r);case"profiles":return this.F(i,r)}}async getMachineId({uri:i}){const n=this.J(i);if(!!n){if(n.remote){if(n.ref){const{content:r}=await this.L(n.syncResource,n.ref,n.collection);if(r)return this.K(r,n.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(i){const n=this.J(i);if(!n||n.node===He.a)return null;if(n.ref){const r=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&r?this.o(n.syncResource,r,n.node):r}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(i,n,r,o,s){if(i){const{content:w}=await this.L(n,s,o);return w}const c=this.k.profiles.find(w=>w.id===r);return c?this.f.resolveContent(c,n,s):null}o(i,n,r){const o=this.K(n,i);switch(i){case"settings":return this.s(o,r);case"keybindings":return this.u(o,r);case"tasks":return this.w(o,r);case"snippets":return this.y(o,r);case"globalState":return this.D(o,r);case"extensions":return this.A(o,r);case"profiles":return this.G(o,r)}}async q(i,n){const r=this.k.profiles.find(o=>o.id===n);if(!r)return null;switch(i){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(i,n){const r=this.d.joinPath(i,"settings.json"),o=n?n.settingsResource:this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}s(i,n){switch(n){case"settings.json":return(0,f.parseSettingsSyncContent)(i.content).settings}return null}t(i,n){const r=this.d.joinPath(i,"keybindings.json"),o=n?n.keybindingsResource:this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}u(i,n){switch(n){case"keybindings.json":return(0,g.getKeybindingsContentFromSyncContent)(i.content,!!this.l.getValue(v.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(i,n){const r=this.d.joinPath(i,"tasks.json"),o=n?n.tasksResource:this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}w(i,n){switch(n){case"tasks.json":return(0,h.getTasksContentFromSyncContent)(i.content,this.g)}return null}async x(i,n){const r=await this.resolveContent(i);if(r){const o=this.K(r,"snippets");if(o){const s=(0,m.parseSnippets)(o),c=[];for(const w of Object.keys(s)){const E=this.d.joinPath(i,w),L=n?this.d.joinPath(n.snippetsHome,w):this.d.joinPath(i,He.a);c.push({resource:E,comparableResource:L})}return c}}return[]}y(i,n){return(0,m.parseSnippets)(i)[n]||null}z(i,n){const r=this.d.joinPath(i,"extensions.json"),o=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}A(i,n){switch(n){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(i),!0)}return null}async B(i){const{localExtensions:n}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(i);return(0,u.stringify)(n,!0)}C(i,n){const r=this.d.joinPath(i,"globalState.json"),o=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}D(i,n){switch(n){case"globalState.json":return(0,d.stringify)(JSON.parse(i.content),!0)}return null}async E(i){const n=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,d.stringify)(n,!0)}F(i,n){const r=this.d.joinPath(i,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:o}]}G(i,n){switch(n){case"profiles.json":return(0,P.toFormattedString)(JSON.parse(i.content),{})}return null}async H(i){return(0,b.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(i){const n=i.remote?He.b:He.c,r=[i.syncResource,i.profile];return i.collection&&r.push(`collection:${i.collection}`),i.ref&&r.push(`ref:${i.ref}`),i.node&&r.push(i.node),this.d.joinPath(A.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...r)}J(i){if(i.scheme!==v.USER_DATA_SYNC_SCHEME||i.authority!==He.c&&i.authority!==He.b)return;const n=[];for(;i.path!=="/";)n.unshift(this.d.basename(i)),i=this.d.dirname(i);if(n.length<2)return;const r=i.authority===He.b,o=n.shift(),s=n.shift();let c,w,E;for(;n.length;){const L=n.shift();L.startsWith("collection:")?c=L.substring(11):L.startsWith("ref:")?w=L.substring(4):E=L}return{remote:r,syncResource:o,profile:s,collection:c,ref:w,node:E}}K(i,n){try{const r=JSON.parse(i);if((0,S.isSyncData)(r))return r}catch(r){this.g.error(r)}throw new v.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",n)}async L(i,n,r){const o=await this.e.resolveResourceContent(i,n,r);return{ref:n,content:o}}};t.a="not-existing-resource",t.b="remote-backup",t.c="local-backup",t=ye([X(0,v.IUserDataSyncStoreService),X(1,v.IUserDataSyncBackupStoreService),X(2,v.IUserDataSyncLogService),X(3,C.IUriIdentityService),X(4,l.IEnvironmentService),X(5,R.IStorageService),X(6,D.IFileService),X(7,I.IUserDataProfilesService),X(8,p.IConfigurationService),X(9,y.IInstantiationService)],t),e.UserDataSyncResourceProviderService=t}),define(se[286],re([0,1,18,6,23,39,3,2,24,12,31,16,29,5,20,19,28,121,122,123,124,125,126,127,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(E,L,T,F,z,J,Y,W,N){super(),this.v=E,this.w=L,this.y=T,this.z=F,this.C=z,this.D=J,this.F=Y,this.G=W,this.H=N,this.f="uninitialized",this.g=this.B(new k.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new k.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new k.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new k.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new k.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new k.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=L.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(E,L){this.X(),this.z.info("Sync started.");const T=new Date().getTime(),F=(0,I.generateUuid)();try{const W=(0,i.createSyncHeaders)(F);L&&(W["Cache-Control"]="no-cache"),E=await this.v.manifest(E,W)}catch(W){const N=i.UserDataSyncError.toUserDataSyncError(W);throw c(N,F,this.w,this.C),N}const z=!1,J=this;let Y;return{manifest:E,async run(){if(z)throw new Error("Can run a task only once");Y=(0,O.createCancelablePromise)(W=>J.I(E,!1,F,W)),await Y.finally(()=>Y=void 0),J.z.info(`Sync done. Took ${new Date().getTime()-T}ms`),J.S()},stop(){return Y?.cancel(),J.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const E=new Date().getTime(),L=(0,I.generateUuid)(),T=(0,i.createSyncHeaders)(L);let F;try{F=await this.v.manifest(null,T)}catch(Y){const W=i.UserDataSyncError.toUserDataSyncError(Y);throw c(W,L,this.w,this.C),W}await this.resetLocal();const z=this,J=new l.CancellationTokenSource;return{id:L,async merge(){return z.I(F,!0,L,J.token)},async apply(){try{try{await z.L(F,L,J.token)}catch(Y){if(i.UserDataSyncError.toUserDataSyncError(Y).code==="MethodNotFound")z.z.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.z.info("Applying manual sync again..."),await z.L(F,L,J.token);else throw Y}}catch(Y){throw z.z.error(Y),Y}z.z.info(`Sync done. Took ${new Date().getTime()-E}ms`),z.S()},async stop(){J.cancel(),await z.N(),await z.resetLocal()}}}async I(E,L,T,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(z,E,L,T,F));const J=z.enabled.find(Y=>Y.resource==="profiles");if(J){const Y=await J.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J(Y,E,L,T,F)}}finally{this.l.fire(this.k)}}async J(E,L,T,F,z){for(const J of E){if(z.isCancellationRequested)return;const Y=this.G.profiles.find(N=>N.id===J.id);if(!Y){this.z.error(`Profile with id:${J.id} and name: ${J.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",J.name);const W=this.getOrCreateActiveProfileSynchronizer(Y,J);this.k.push(...await this.M(W,L,T,F,z))}for(const[J,Y]of this.u.entries())this.G.profiles.some(W=>W.id===Y[0].profile.id)||(Y[1].dispose(),this.u.delete(J))}async L(E,L,T){const F=this.U();for(const N of F){if(T.isCancellationRequested)return;await N.apply(L,T)}const z=F.find(N=>N.profile.isDefault);if(!z)return;const J=z.enabled.find(N=>N.resource==="profiles");if(!J)return;const W=(await J.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(N=>F.every(B=>B.profile.id!==N.id));W.length&&await this.J(W,E,!1,L,T)}async M(E,L,T,F,z){return(await E.sync(L,T,F,z)).map(([Y,W])=>({profile:E.profile,syncResource:Y,error:W}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(E=>E.stop()))}async resolveContent(E){const L=await this.H.resolveContent(E);if(L)return L;for(const T of this.U())for(const F of T.enabled){const z=await F.resolveContent(E);if(z)return z}return null}async replace(E){this.X();const L=this.H.resolveUserDataSyncResource(E);if(!L)return;const T=await this.resolveContent(E.uri);!T||await this.O(L.profile,async F=>{if(L.syncResource===F.resource)return await F.replace(T),!0})}async accept(E,L,T,F){this.X(),await this.O(E.profile,async z=>{if(E.syncResource===z.resource)return await z.accept(L,T),F&&await z.apply((0,v.isBoolean)(F)?!1:F.force,(0,i.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,L){return this.H.getRemoteSyncResourceHandles(E,L)}async getLocalSyncResourceHandles(E,L){return this.H.getLocalSyncResourceHandles(E,L??this.G.defaultProfile)}async getAssociatedResources(E){return this.H.getAssociatedResources(E)}async getMachineId(E){return this.H.getMachineId(E)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async L=>{if(L.resource!=="globalState"&&await L.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async L=>{if(await L.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(E){this.z.error(E)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[E]of this.u.values())try{await E.resetLocal()}catch(L){this.z.error(L)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.H.getRemoteSyncedProfiles(),L=E.map(J=>J.collection),T=await this.v.getAllCollections(),F=T.filter(J=>!L.includes(J));F.length&&(this.z.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(J=>this.v.deleteCollection(J))),this.z.info("Deleted redundant collections on server"));const z=E.filter(J=>T.includes(J.collection));if(z.length!==E.length){this.z.info("Updating remote profiles with invalid collections on server");const J=this.y.createInstance(a.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await J.updateRemoteProfiles(z,null),this.z.info("Updated remote profiles on server")}finally{J.dispose()}}}async O(E,L){const T=new R.DisposableStore;try{const F=this.u.get(E.id);if(F){const N=await this.P(F[0],L,T);return(0,v.isUndefined)(N)?null:N}if(E.isDefault){const N=T.add(this.y.createInstance(o,E,void 0)),B=await this.P(N,L,T);return(0,v.isUndefined)(B)?null:B}if(this.G.isEnabled())return null;const z=T.add(this.y.createInstance(a.UserDataProfilesManifestSynchroniser,E,void 0)),J=await this.v.manifest(null),W=(await z.getRemoteSyncedProfiles(J?.latest??null)||[]).find(N=>N.id===E.id);if(W){const N=T.add(this.y.createInstance(o,E,W.collection)),B=await this.P(N,L,T);return(0,v.isUndefined)(B)?null:B}return null}finally{T.dispose()}}async P(E,L,T){const F=[...E.enabled,...E.disabled.map(z=>T.add(E.createSynchronizer(z)))];for(const z of F){const J=await L(z);if(!(0,v.isUndefined)(J))return J}}Q(E){const L=this.f;this.f!==E&&(this.f=E,this.g.fire(E),L==="hasConflicts"&&this.S())}R(){const E=this.U().map(L=>L.conflicts).flat();(0,A.equals)(this.i,E,(L,T)=>L.profile.id===T.profile.id&&L.syncResource===T.syncResource&&(0,A.equals)(L.conflicts,T.conflicts,(F,z)=>(0,C.isEqual)(F.previewResource,z.previewResource)))||(this.i=E,this.j.fire(E))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(E,L){let T=this.u.get(E.id);if(T&&T[0].collection!==L?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.u.delete(E.id)),!T){const F=new R.DisposableStore,z=F.add(this.y.createInstance(o,E,L?.collection));F.add(z.onDidChangeStatus(J=>this.Q(J))),F.add(z.onDidChangeConflicts(J=>this.R())),F.add(z.onDidChangeLocal(J=>this.h.fire(J))),this.u.set(E.id,T=[z,F])}return T[0]}U(){const E=[];for(const[L]of this.u.values())E.push(L);return E}W(){this.u.forEach(([,E])=>E.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};r=ye([X(0,i.IUserDataSyncStoreService),X(1,i.IUserDataSyncStoreManagementService),X(2,f.IInstantiationService),X(3,i.IUserDataSyncLogService),X(4,p.ITelemetryService),X(5,g.IStorageService),X(6,i.IUserDataSyncEnablementService),X(7,h.IUserDataProfilesService),X(8,i.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let o=class extends R.Disposable{get enabled(){return this.f.sort((E,L)=>E[1]-L[1]).map(([E])=>E)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(E=>!this.l.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.j}constructor(E,L,T,F,z,J,Y,W,N,B){super(),this.profile=E,this.collection=L,this.l=T,this.m=F,this.n=z,this.r=J,this.t=Y,this.u=W,this.v=N,this.w=B,this.f=[],this.g="idle",this.h=this.B(new k.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new k.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new k.Emitter),this.onDidChangeConflicts=this.k.event,this.B(T.onDidChangeResourceEnablement(([ie,q])=>this.y(ie,q))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.ALL_SYNC_RESOURCES)T.isResourceEnabled(ie)&&this.z(ie)}y(E,L){L?this.z(E):this.C(E)}z(E){if(this.f.some(([z])=>z.resource===E))return;if(E==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const L=new R.DisposableStore,T=L.add(this.createSynchronizer(E));L.add(T.onDidChangeStatus(()=>this.G())),L.add(T.onDidChangeConflicts(()=>this.H())),L.add(T.onDidChangeLocal(()=>this.i.fire(E)));const F=this.I(E);this.f.push([T,F,L])}C(E){const L=this.f.findIndex(([T])=>T.resource===E);if(L!==-1){const[[T,,F]]=this.f.splice(L,1);F.dispose(),this.G(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,z=>this.u.error(z))}}createSynchronizer(E){switch(E){case"settings":return this.m.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(y.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(P.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(a.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,L,T,F){if(F.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const J=[],Y=(0,i.createSyncHeaders)(T),W=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,N=L?await this.D(W):{};for(const B of z){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(B.resource))return[];try{if(L){const ie=await B.preview(W,N,Y);if(ie)for(const q of ie.resourcePreviews)(q.localChange!==0||q.remoteChange!==0)&&q.mergeState==="preview"&&await B.merge(q.previewResource)}else await B.sync(W,Y)}catch(ie){const q=i.UserDataSyncError.toUserDataSyncError(ie);if(c(q,T,this.r,this.t),s(ie))throw q;this.u.error(ie),this.u.error(`${B.resource}: ${(0,D.toErrorMessage)(ie)}`),J.push([B.resource,q])}}return J}finally{this.G()}}async apply(E,L){const T=(0,i.createSyncHeaders)(E);for(const F of this.enabled){if(L.isCancellationRequested)return;try{await F.apply(!1,T)}catch(z){const J=i.UserDataSyncError.toUserDataSyncError(z);if(c(J,E,this.r,this.t),s(z))throw J;this.u.error(z),this.u.error(`${F.resource}: ${(0,D.toErrorMessage)(z)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(L){this.u.error(L)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(L){this.u.error(`${E.resource}: ${(0,D.toErrorMessage)(L)}`),this.u.error(L)}}async D(E){if(!this.profile.isDefault)return{};const L=this.w.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),T=this.enabled.find(F=>F instanceof b.SettingsSynchroniser);if(T){const F=await T.getRemoteUserDataSyncConfiguration(E);return{...L,...F}}return L}F(E){this.g!==E&&(this.g=E,this.h.fire(E))}G(){return this.H(),this.enabled.some(E=>E.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const E=this.enabled.filter(L=>L.status==="hasConflicts").filter(L=>L.conflicts.conflicts.length>0).map(L=>L.conflicts);(0,A.equals)(this.j,E,(L,T)=>L.syncResource===T.syncResource&&(0,A.equals)(L.conflicts,T.conflicts,(F,z)=>(0,C.isEqual)(F.previewResource,z.previewResource)))||(this.j=E,this.k.fire(E))}I(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=ye([X(2,i.IUserDataSyncEnablementService),X(3,f.IInstantiationService),X(4,m.IExtensionGalleryService),X(5,i.IUserDataSyncStoreManagementService),X(6,p.ITelemetryService),X(7,i.IUserDataSyncLogService),X(8,h.IUserDataProfilesService),X(9,S.IConfigurationService)],o);function s(w){if(w instanceof i.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function c(w,E,L,T){T.publicLog2("sync/error",{code:w.code,serverCode:w instanceof i.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof i.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:E,service:L.userDataSyncStore.url.toString()})}}),define(se[287],re([0,1,3,2,10,28,22]),function(_,e,A,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(m,f){return{...m,profile:(0,D.reviveProfile)(m.profile,f.profilesHome.scheme)}}function C(m){return{created:m.created,uri:l.URI.revive(m.uri)}}class v{constructor(f,g,p){this.c=f,this.d=g,this.f=p,this.a=new Map,this.b=new A.Emitter}listen(f,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(f,g,p){try{return await this.g(f,g,p)}catch(h){throw this.f.error(h),h}}async g(f,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),l.URI.revive(p[1]),p[2],p[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(p[0],p[1]?(0,D.reviveProfile)(p[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(p[0],p[1]);case"replace":return this.c.replace(C(p[0]));case"getAssociatedResources":return this.c.getAssociatedResources(C(p[0]));case"getMachineId":return this.c.getMachineId(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const h=g.substring(11),u=p[0],d=this.h(u);switch(p=p.slice(1),h){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(f){const g=this.a.get(this.j(f));if(!g)throw new Error(`Manual sync taks not found: ${f}`);return g}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=v;let I=class extends O.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,g){super(),this.k=g,this.b="uninitialized",this.c=this.B(new A.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new A.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new A.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new A.Emitter),this.onSyncErrors=this.j.event,this.a={call(p,h,u){return f.call(p,h,u).then(null,d=>{throw k.UserDataSyncError.toUserDataSyncError(d)})},listen(p,h){return f.listen(p,h)}},this.a.call("_getInitialData").then(([p,h,u])=>{this.l(p),this.m(h),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.m(p))),this.B(this.a.listen("onSyncErrors")(p=>this.j.fire(p.map(h=>({...h,error:k.UserDataSyncError.toUserDataSyncError(h.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),g=this;return new S(f,{async call(h,u,d){return g.a.call(`manualSync/${h}`,[f,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,g,p,h){return this.a.call("accept",[f,g,p,h])}resolveContent(f){return this.a.call("resolveContent",[f])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(f,g){return(await this.a.call("getLocalSyncResourceHandles",[f,g])).map(({created:h,uri:u})=>({created:h,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(f,g){return(await this.a.call("getRemoteSyncResourceHandles",[f,g])).map(({created:h,uri:u})=>({created:h,uri:l.URI.revive(u)}))}async getAssociatedResources(f){return(await this.a.call("getAssociatedResources",[f])).map(({resource:p,comparableResource:h})=>({resource:l.URI.revive(p),comparableResource:l.URI.revive(h)}))}getMachineId(f){return this.a.call("getMachineId",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}async l(f){this.b=f,this.c.fire(f)}async m(f){this.f=f.map(g=>({syncResource:g.syncResource,profile:(0,D.reviveProfile)(g.profile,this.k.profilesHome.scheme),conflicts:g.conflicts.map(p=>({...p,baseResource:l.URI.revive(p.baseResource),localResource:l.URI.revive(p.localResource),remoteResource:l.URI.revive(p.remoteResource),previewResource:l.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}n(f){this.h!==f&&(this.h=f,this.i.fire(f))}};I=ye([X(1,D.IUserDataProfilesService)],I),e.UserDataSyncChannelClient=I;class S extends O.Disposable{constructor(f,g){super(),this.id=f,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(se[288],re([0,1,6,23,7,3,2,144,4,24,12,10,31,16,15,14,25,59,44,20,22]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const P="sync.previous.store",t="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",n=100,r=1e3*60*5;let o=class extends k.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.SYNC_SERVICE_URL_TYPE,-1)}set c(T){this.h.store(b.SYNC_SERVICE_URL_TYPE,T,-1,C.isWeb?0:1)}constructor(T,F,z){super(),this.f=T,this.g=F,this.h=z,this.a=this.B(new D.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(D.Event.filter(z.onDidChangeValue,J=>J.key===b.SYNC_SERVICE_URL_TYPE&&J.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[b.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(b.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(T,F){T=C.isWeb&&T?.web?{...T,...T.web}:T;const z={...T||{},...F||{}};if(z&&(0,I.isString)(z.url)&&(0,I.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(J=>Array.isArray(z.authenticationProviders[J].scopes))){const J=z,Y=!!J.canSwitch&&!F?.url,W=J.url===J.insidersUrl?"insiders":"stable",N=(Y?this.c:void 0)||W,B=F?.url||(N==="insiders"?J.insidersUrl:N==="stable"?J.stableUrl:J.url);return{url:S.URI.parse(B),type:N,defaultType:W,defaultUrl:S.URI.parse(J.url),stableUrl:S.URI.parse(J.stableUrl),insidersUrl:S.URI.parse(J.insidersUrl),canSwitch:Y,authenticationProviders:Object.keys(J.authenticationProviders).reduce((ie,q)=>(ie.push({id:q,scopes:J.authenticationProviders[q].scopes}),ie),[])}}}};o=ye([X(0,h.IProductService),X(1,f.IConfigurationService),X(2,y.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let s=class extends o{constructor(T,F,z){super(T,F,z);const J=this.h.get(P,-1);J&&(this.k=JSON.parse(J));const Y=this.f[b.CONFIGURATION_SYNC_STORE_KEY];Y?this.h.store(P,JSON.stringify(Y),-1,1):this.h.remove(P,-1)}async switch(T){T!==this.c&&(this.c=T,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};s=ye([X(0,h.IProductService),X(1,f.IConfigurationService),X(2,y.IStorageService)],s),e.UserDataSyncStoreManagementService=s;let c=class extends k.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(T,F,z,J,Y,W,N){super(),this.k=z,this.l=J,this.n=N,this.g=this.B(new D.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new D.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new D.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(T),this.c=(0,d.getServiceMachineId)(Y,W,N).then(B=>{const ie={"X-Client-Name":`${F.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new E(n,r,this.k,this.l),this.r(),this.B((0,k.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(T,F){this.b={token:T,type:F}}p(T){this.a=T?(0,v.joinPath)(T,"v1"):void 0}r(){const T=this.n.getNumber(t,-1);T&&Date.now()<T&&this.t(new Date(T))}t(T){this.i?.getTime()!==T?.getTime()&&(this.i=T,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(t,this.i.getTime(),-1,1),this.s=(0,A.createCancelablePromise)(F=>(0,A.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.t(void 0))),this.s.then(null,F=>null)):this.n.remove(t,-1),this.j.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,v.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const z=await this.w(F,{type:"GET",headers:T},[],O.CancellationToken.None);return(await(0,u.asJson)(z))?.map(({id:J})=>J)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,v.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.Mimes.text;const z=await this.w(F,{type:"POST",headers:T},[],O.CancellationToken.None),J=await(0,u.asTextOrError)(z);if(!J)throw new b.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",z.res.statusCode,z.res.headers[b.HEADER_OPERATION_ID]);return J}async deleteCollection(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=T?(0,v.joinPath)(this.a,"collection",T).toString():(0,v.joinPath)(this.a,"collection").toString();F={...F},await this.w(z,{type:"DELETE",headers:F},[],O.CancellationToken.None)}async getAllResourceRefs(T,F){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,F,T),J={},Y=await this.w(z.toString(),{type:"GET",headers:J},[],O.CancellationToken.None);return(await(0,u.asJson)(Y)||[]).map(({url:N,created:B})=>({ref:(0,v.relativePath)(z,z.with({path:N})),created:B*1e3}))}async resolveResourceContent(T,F,z,J={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,v.joinPath)(this.u(this.a,z,T),F).toString();J={...J},J["Cache-Control"]="no-cache";const W=await this.w(Y,{type:"GET",headers:J},[],O.CancellationToken.None);return await(0,u.asTextOrError)(W)}async deleteResource(T,F,z){if(!this.a)throw new Error("No settings sync store url configured.");const J=F!==null?(0,v.joinPath)(this.u(this.a,z,T),F).toString():this.u(this.a,z,T).toString(),Y={};await this.w(J,{type:"DELETE",headers:Y},[],O.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,v.joinPath)(this.a,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.w(T,{type:"DELETE",headers:F},[],O.CancellationToken.None)}async readResource(T,F,z,J={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,v.joinPath)(this.u(this.a,z,T),"latest").toString();J={...J},J["Cache-Control"]="no-cache",F&&(J["If-None-Match"]=F.ref);const W=await this.w(Y,{type:"GET",headers:J},[304],O.CancellationToken.None);let N=null;if(W.res.statusCode===304&&(N=F),N===null){const B=W.res.headers.etag;if(!B)throw new b.UserDataSyncStoreError("Server did not return the ref",Y,"NoRef",W.res.statusCode,W.res.headers[b.HEADER_OPERATION_ID]);const ie=await(0,u.asTextOrError)(W);if(!ie&&W.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",Y,"EmptyResponse",W.res.statusCode,W.res.headers[b.HEADER_OPERATION_ID]);N={ref:B,content:ie}}return N}async writeResource(T,F,z,J,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.u(this.a,J,T).toString();Y={...Y},Y["Content-Type"]=R.Mimes.text,z&&(Y["If-Match"]=z);const N=await this.w(W,{type:"POST",data:F,headers:Y},[],O.CancellationToken.None),B=N.res.headers.etag;if(!B)throw new b.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",N.res.statusCode,N.res.headers[b.HEADER_OPERATION_ID]);return B}async manifest(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,v.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const J=await this.w(z,{type:"GET",headers:F},[304],O.CancellationToken.None);let Y=null;if(J.res.statusCode===304&&(Y=T),!Y){const N=J.res.headers.etag;if(!N)throw new b.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",J.res.statusCode,J.res.headers[b.HEADER_OPERATION_ID]);const B=await(0,u.asTextOrError)(J);if(!B&&J.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",z,"EmptyResponse",J.res.statusCode,J.res.headers[b.HEADER_OPERATION_ID]);B&&(Y={...JSON.parse(B),ref:N})}const W=this.n.get(a,-1);return W&&Y&&W!==Y.session&&this.v(),Y===null&&W&&this.v(),Y&&this.n.store(a,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(T,F,z){return F?(0,v.joinPath)(T,"collection",F,"resource",z):(0,v.joinPath)(T,"resource",z)}v(){this.n.remove(a,-1),this.n.remove(i,-1)}async w(T,F,z,J){if(!this.b)throw new b.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const Y=await this.c;F.headers={...F.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(F.headers),this.l.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let W;try{W=await this.f.request(T,F,J)}catch(x){if(!(x instanceof b.UserDataSyncStoreError)){let U="RequestFailed";const K=(0,l.getErrorMessage)(x).toLowerCase();K.includes("xhr timeout")?U="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?U="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?U="RequestPathNotEscaped":K.includes("headers must be an object")?U="RequestHeadersNotObject":(0,l.isCancellationError)(x)&&(U="RequestCanceled"),x=new b.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,U,void 0,void 0)}throw this.l.info("Request failed",T),x}const N=W.res.headers[b.HEADER_OPERATION_ID],B={url:T,status:W.res.statusCode,"execution-id":F.headers[b.HEADER_EXECUTION_ID],"operation-id":N},ie=(0,u.isSuccess)(W)||W.res.statusCode&&z.indexOf(W.res.statusCode)!==-1;let q="";if(ie?this.l.trace("Request succeeded",B):(this.l.info("Request failed",B),q=await(0,u.asText)(W)||""),W.res.statusCode===401)throw this.b=void 0,this.g.fire(),new b.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",W.res.statusCode,N);if(this.h.fire(),W.res.statusCode===404)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",W.res.statusCode,N);if(W.res.statusCode===405)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested endpoint is not found (405). ${q}`,T,"MethodNotFound",W.res.statusCode,N);if(W.res.statusCode===409)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",W.res.statusCode,N);if(W.res.statusCode===410)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",W.res.statusCode,N);if(W.res.statusCode===412)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",W.res.statusCode,N);if(W.res.statusCode===413)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",W.res.statusCode,N);if(W.res.statusCode===426)throw new b.UserDataSyncStoreError(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",W.res.statusCode,N);if(W.res.statusCode===429){const x=W.res.headers["retry-after"];throw x?(this.t(new Date(Date.now()+parseInt(x)*1e3)),new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",W.res.statusCode,N)):new b.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",W.res.statusCode,N)}if(!ie)throw new b.UserDataSyncStoreError("Server returned "+W.res.statusCode,T,"Unknown",W.res.statusCode,N);return W}y(T){let F=this.n.get(i,-1);F===void 0&&(F=(0,m.generateUuid)(),this.n.store(i,F,-1,1)),T["X-Machine-Session-Id"]=F;const z=this.n.get(a,-1);z!==void 0&&(T["X-User-Session-Id"]=z)}};c=ye([X(1,h.IProductService),X(2,u.IRequestService),X(3,b.IUserDataSyncLogService),X(4,g.IEnvironmentService),X(5,p.IFileService),X(6,y.IStorageService)],c),e.UserDataSyncStoreClient=c;let w=class extends c{constructor(T,F,z,J,Y,W,N){super(T.userDataSyncStore?.url,F,z,J,Y,W,N),this.B(T.onDidChangeUserDataSyncStore(()=>this.p(T.userDataSyncStore?.url)))}};w=ye([X(0,b.IUserDataSyncStoreManagementService),X(1,h.IProductService),X(2,u.IRequestService),X(3,b.IUserDataSyncLogService),X(4,g.IEnvironmentService),X(5,p.IFileService),X(6,y.IStorageService)],w),e.UserDataSyncStoreService=w;class E{constructor(T,F,z,J){this.c=T,this.d=F,this.f=z,this.g=J,this.a=[],this.b=void 0}request(T,F,z){if(this.h()&&this.i(),F.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(F,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=E}),define(se[289],re([0,1,3,57,25,20,19,284,22,77,80]),function(_,e,A,O,l,D,k,R,C,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let S=class extends R.UserDataAutoSyncService{constructor(f,g,p,h,u,d,y,b,P,t,a){super(f,g,p,h,u,y,b,P,t,a),this.B(A.Event.debounce(A.Event.any(A.Event.map(d.onDidFocusWindow,()=>"windowFocus"),A.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(i,n)=>i?[...i,n]:[n],1e3)(i=>this.triggerSync(i,!0,!1)))}};S=ye([X(0,l.IProductService),X(1,C.IUserDataSyncStoreManagementService),X(2,C.IUserDataSyncStoreService),X(3,C.IUserDataSyncEnablementService),X(4,C.IUserDataSyncService),X(5,O.INativeHostService),X(6,C.IUserDataSyncLogService),X(7,v.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,I.IUserDataSyncMachinesService),X(10,D.IStorageService)],S),e.UserDataAutoSyncService=S}),define(se[290],re([0,1,102,21,4,24]),function(_,e,A,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(v){function I(){let S=v.scheme===O.Schemas.file?(0,D.originalFSPath)(v):v.toString();return l.isLinux||(S=S.toLowerCase()),(0,A.createHash)("md5").update(S).digest("hex")}return{id:I(),configPath:v}}e.getWorkspaceIdentifier=k;function R(v,I){function S(){if(v.scheme!==O.Schemas.file)return(0,A.createHash)("md5").update(v.toString()).digest("hex");if(!I)return;let f;return l.isLinux?f=I.ino:l.isMacintosh?f=I.birthtime.getTime():l.isWindows&&(typeof I.birthtimeMs=="number"?f=Math.floor(I.birthtimeMs):f=I.birthtime.getTime()),(0,A.createHash)("md5").update(v.fsPath).update(f?String(f):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:v}}e.getSingleFolderWorkspaceIdentifier=R;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(se[291],re([0,1,6,7,2,13,27,15,11,75,119,290,71,57]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let g=class extends l.Disposable{constructor(h,u,d,y){super(),this.a=h,this.b=u,this.c=d,this.f=y,this.B(new A.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=await k.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new v.StorageClient(this.f.getChannel("storage"));await Promise.all(h.map(async d=>{const y=(0,D.join)(this.a.workspaceStorageHome.fsPath,d);d.length===S.NON_EMPTY_WORKSPACE_ID_LENGTH||d===I.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(t=>t.workspace?.id===d)||await u.isUsed(y)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await k.Promises.rm(y))}))}catch(h){(0,O.onUnexpectedError)(h)}}};g=ye([X(0,R.INativeEnvironmentService),X(1,C.ILogService),X(2,f.INativeHostService),X(3,m.IMainProcessService)],g),e.UnusedWorkspaceStorageDataCleaner=g}),define(se[81],re([0,1,53,6,13,12,27,156,301,302]),function(_,e,A,O,l,D,k,R,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class S extends Error{constructor(a,i){let n=i.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=i}}e.ExtractError=S;function m(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,n)=>i+n,a&61440)}function f(t){if(t instanceof S)return t;let a;return I.test(t.message)&&(a="CorruptZip"),new S(a,t)}function g(t,a,i,n,r,o){const s=l.dirname(a),c=l.join(n,s);if(!c.startsWith(n))return Promise.reject(new Error(R.localize(0,null,a)));const w=l.join(n,a);let E;return o.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(k.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((L,T)=>{if(!o.isCancellationRequested)try{E=(0,A.createWriteStream)(w,{mode:i}),E.once("close",()=>L()),E.once("error",T),t.once("error",T),t.pipe(E)}catch(F){T(F)}}))}function p(t,a,i,n){let r=(0,O.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((s,c)=>{const w=new O.Sequencer,E=L=>{L.isCancellationRequested||(o++,t.readEntry())};t.once("error",c),t.once("close",()=>r.then(()=>{n.isCancellationRequested||t.entryCount===o?s():c(new S("Incomplete",new Error(R.localize(1,null,o,t.entryCount))))},c)),t.readEntry(),t.on("entry",L=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(L.fileName)){E(n);return}const T=L.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(T)){const J=l.join(a,T);r=(0,O.createCancelablePromise)(Y=>k.Promises.mkdir(J,{recursive:!0}).then(()=>E(Y)).then(void 0,c));return}const F=u(t,L),z=m(L);r=(0,O.createCancelablePromise)(J=>w.queue(()=>F.then(Y=>g(Y,T,z,a,i,J).then(()=>E(J)))).then(null,c))})})}function h(t,a=!1){return new Promise((i,n)=>{(0,C.open)(t,a?{lazyEntries:!0}:void 0,(r,o)=>{r?n(f(r)):i((0,D.assertIsDefined)(o))})})}function u(t,a){return new Promise((i,n)=>{t.openReadStream(a,(r,o)=>{r?n(f(r)):i((0,D.assertIsDefined)(o))})})}function d(t,a){return new Promise((i,n)=>{const r=new v.ZipFile;a.forEach(s=>{s.contents?r.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&r.addFile(s.localPath,s.path)}),r.end();const o=(0,A.createWriteStream)(t);r.outputStream.pipe(o),r.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>i(t))})}e.zip=d;function y(t,a,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=h(t,!0);return i.overwrite&&(o=o.then(s=>k.Promises.rm(a).then(()=>s))),o.then(s=>p(s,a,{sourcePathRegex:r},n))}e.extract=y;function b(t,a){return h(t).then(i=>new Promise((n,r)=>{i.on("entry",o=>{o.fileName===a&&u(i,o).then(s=>n(s),s=>r(s))}),i.once("close",()=>r(new Error(R.localize(2,null,a))))}))}function P(t,a){return b(t,a).then(i=>new Promise((n,r)=>{const o=[];i.once("error",r),i.on("data",s=>o.push(s)),i.on("end",()=>n(Buffer.concat(o)))}))}e.buffer=P}),define(se[292],re([0,1,6,7,2,21,4,24,54,12,31,27,81,16,15,29,33,100,14,11]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let b=class yt extends l.Disposable{constructor(t,a,i,n,r,o){super(),this.h=a,this.i=i,this.j=n,this.k=r,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,a){await this.g;const i=(0,R.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,r=>this.i.download(t,r,a))}catch(r){throw new p.ExtensionManagementError(r.message,p.ExtensionManagementErrorCode.Download)}let n="Unverified";if(this.m(t)){const r=await this.n(t);try{await this.k.verify(i.fsPath,r.fsPath,this.l.getLevel()===y.LogLevel.Trace)&&(n="Verified"),this.l.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(o){const s=o,c=s.code;if(s.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${s.output}`),c==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else{if(c==="PackageIsInvalidZip"||c==="SignatureArchiveIsInvalidZip")throw new p.ExtensionManagementError(m.CorruptZipMessage,p.ExtensionManagementErrorCode.CorruptZip);if(!s.didExecute)this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n} (${c})`);else throw await this.delete(i),new p.ExtensionManagementError(c,p.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(r)}catch(o){this.l.error(o)}}}return{location:i,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,v.isBoolean)(a)?a:!0}async n(t){await this.g;const a=(0,R.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${yt.c}`);return await this.r(t,a,i=>this.i.downloadSignatureArchive(t,i)),a}async r(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==D.Schemas.file){await i(a);return}const n=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.t(n,a,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.l.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async t(t,a,i){try{await S.Promises.rename(t.fsPath,a.fsPath)}catch(n){if(k.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.t(t,a,i);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],n=[];for(const s of t.children)if(s.name.endsWith(yt.c))n.push(s.resource);else{const c=h.ExtensionKey.parse(s.name);c&&i.push([c,s])}const r=(0,h.groupByExtension)(i,([s])=>s),o=[];for(const s of r)s.sort((c,w)=>C.rcompare(c[0].version,w[0].version)),a.push(...s.slice(1).map(c=>c[1].resource)),o.push(s[0][1]);o.sort((s,c)=>s.mtime-c.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.f)).map(s=>s.resource)),a.push(...n),await A.Promises.settled(a.map(s=>(this.l.trace("Deleting from cache",s.path),this.h.del(s))))}}catch(t){this.l.error(t)}}v(t){return this.f?h.ExtensionKey.create(t).toString().toLowerCase():(0,I.generateUuid)()}};b.c=".sigzip",b=ye([X(0,g.INativeEnvironmentService),X(1,d.IFileService),X(2,p.IExtensionGalleryService),X(3,f.IConfigurationService),X(4,u.IExtensionSignatureVerificationService),X(5,y.ILogService)],b),e.ExtensionsDownloader=b}),define(se[293],re([0,1,81,166]),function(_,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(D){return(0,A.buffer)(D,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=l}),define(se[128],re([0,1,6,17,23,39,7,3,2,38,21,13,4,24,54,12,10,31,27,81,165,99,15,273,29,33,51,78,292,275,293,227,243,46,68,14,5,11,25,19,30,28]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P,t,a,i,n,r,o,s,c,w,E,L,T,F,z,J,Y,W,N,B,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,J.refineServiceDecorator)(i.IExtensionManagementService);let q=class extends a.AbstractExtensionManagementService{constructor(V,j,M,$,H,ee,G,Z,te,le,he,me){super(V,j,M,le,me),this.Z=H,this.ab=ee,this.bb=G,this.cb=te,this.db=he,this.X=this.B(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new v.ResourceSet;const pe=this.B(Z.createInstance(c.ExtensionsLifecycle));this.S=this.B(Z.createInstance(x,Ce=>pe.postUninstall(Ce))),this.U=this.B(new E.ExtensionsManifestCache($,this)),this.W=this.B(Z.createInstance(s.ExtensionsDownloader));const Se=this.B(new L.ExtensionsWatcher(this,this.Z,me,ee,he,te,M));this.B(Se.onDidChangeExtensionsByAnotherSource(Ce=>this.kb(Ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(V){this.v.trace("ExtensionManagementService#zip",V.identifier.id);const j=await this.jb(V),M=await(0,y.zip)((0,f.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,j);return h.URI.file(M)}async unzip(V){return this.v.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:j,cleanup:M}=await this.fb(V),$=S.resolve(j.fsPath);try{return await(0,w.getManifest)($)}finally{await M()}}getInstalled(V,j=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(V??null,j)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.S.scanUserExtensionAtLocation(V)}async install(V,j={}){this.v.trace("ExtensionManagementService#install",V.toString());const{location:M,cleanup:$}=await this.fb(V);try{const H=await(0,w.getManifest)(S.resolve(M.fsPath));if(H.engines&&H.engines.vscode&&!(0,F.isEngineValid)(H.engines.vscode,this.w.version,this.w.date))throw new Error(b.localize(0,null,(0,n.getGalleryExtensionId)(H.publisher,H.name),this.w.version));return await this.z(H,M,j)}finally{await $()}}async installFromLocation(V,j){this.v.trace("ExtensionManagementService#installFromLocation",V.toString());const M=await this.S.scanUserExtensionAtLocation(V);if(!M)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.ob([[M,void 0]],j),this.v.info("Successfully installed extension",M.identifier.id,j.toString()),M}async installExtensionsFromProfile(V,j,M){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",V,j.toString(),M.toString());const $=(await this.S.scanExtensions(1,j)).filter(H=>V.some(ee=>(0,n.areSameExtensions)(ee,H.identifier)));if($.length){const H=await Promise.all($.map(ee=>this.S.scanMetadata(ee,j)));await this.ob($.map((ee,G)=>[ee,H[G]]),M),this.v.info("Successfully installed extensions",$.map(ee=>ee.identifier.id),M.toString())}return $}async updateMetadata(V,j,M=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",V.identifier.id),j.isPreReleaseVersion&&(j.preRelease=!0),j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.pinned=j.pinned||void 0,V=await this.S.updateMetadata(V,j,M),this.U.invalidate(),this.X.fire(V),V}async reinstallFromGallery(V){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.t.isEnabled())throw new Error(b.localize(1,null));const j=await this.getTargetPlatform(),[M]=await this.t.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:j,compatible:!0},l.CancellationToken.None);if(!M)throw new Error(b.localize(2,null));await this.S.setUninstalled(V);try{await this.S.removeUninstalledExtension(V)}catch($){throw new Error(b.localize(3,null,(0,D.toErrorMessage)($)))}return this.installFromGallery(M)}copyExtensions(V,j){return this.S.copyExtensions(V,j)}markAsUninstalled(...V){return this.S.setUninstalled(...V)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(V){this.v.error(V)}}async download(V,j){const{location:M}=await this.W.download(V,j);return M}async fb(V){if(V.scheme===I.Schemas.file)return{location:V,async cleanup(){}};this.v.trace("Downloading extension from",V.toString());const j=(0,f.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(V,j),this.v.info("Downloaded extension to",j.toString()),{location:j,cleanup:async()=>{try{await this.cb.del(j)}catch($){this.v.error($)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(V,j,M){if(h.URI.isUri(j))return new Q(V,j,M,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const $=n.ExtensionKey.create(j).toString();let H=this.Y.get($);return H||(this.Y.set($,H=new K(V,j,M,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),H.waitUntilTaskIsFinished().then(()=>this.Y.delete($))),H}R(V,j){return new oe(V,j.profileLocation,this.ab)}async jb(V){const j=async $=>{let H=await d.Promises.readdir($);H=H.map(Z=>S.join($,Z));const ee=await Promise.all(H.map(Z=>d.Promises.stat(Z)));let G=Promise.resolve([]);return ee.forEach((Z,te)=>{const le=H[te];Z.isFile()&&(G=G.then(he=>[...he,le])),Z.isDirectory()&&(G=G.then(he=>j(le).then(me=>[...he,...me])))}),G};return(await j(V.location.fsPath)).map($=>({path:`extension/${S.relative(V.location.fsPath,$)}`,localPath:$}))}async kb({added:V,removed:j}){if(j)for(const M of j.extensions)this.v.info("Extensions removed from another source",M.id,j.profileLocation.toString()),this.p.fire({identifier:M,profileLocation:j.profileLocation});if(V){const $=(await this.S.scanExtensions(1,V.profileLocation)).filter(H=>V.extensions.some(ee=>(0,n.areSameExtensions)(ee,H.identifier)));this.m.fire($.map(H=>(this.v.info("Extensions added from another source",H.identifier.id,V.profileLocation.toString()),{identifier:H.identifier,local:H,profileLocation:V.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(j=>this.lb.add(j)));const V=await this.cb.resolve(this.Z.userExtensionsLocation);for(const j of V.children??[])j.isDirectory&&this.lb.add(j.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(j=>this.nb(j)))}async nb(V){if(!V.affects(this.Z.userExtensionsLocation,1))return;const j=[];for(const M of V.rawAdded){if(this.lb.has(M)||!this.db.extUri.isEqual(this.db.extUri.dirname(M),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(M,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(M).startsWith(".")||!(await this.cb.stat(M)).isDirectory)continue;const $=await this.S.scanUserExtensionAtLocation(M);$&&$.installedTimestamp===void 0&&(this.lb.add(M),j.push($))}j.length&&(await this.ob(j.map(M=>[M,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",j.map(M=>M.identifier.id)))}async ob(V,j){const M=V.map($=>$[0]);await this.pb(M),await this.ab.addExtensionsToProfile(V,j),this.m.fire(M.map($=>({local:$,identifier:$.identifier,operation:1,profileLocation:j})))}async pb(V){const j=await this.S.getUninstalledExtensions();for(const M of V){const $=n.ExtensionKey.create(M);!j[$.toString()]||(this.v.trace("Removing the extension from uninstalled list:",$.id),await this.S.setInstalled($),this.v.info("Removed the extension from uninstalled list:",$.id))}}};q=ye([X(0,i.IExtensionGalleryService),X(1,N.ITelemetryService),X(2,Y.ILogService),X(3,t.INativeEnvironmentService),X(4,o.IExtensionsScannerService),X(5,r.IExtensionsProfileScannerService),X(6,P.IDownloadService),X(7,J.IInstantiationService),X(8,z.IFileService),X(9,W.IProductService),X(10,B.IUriIdentityService),X(11,ie.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let x=class extends C.Disposable{constructor(V,j,M,$,H,ee){super(),this.k=V,this.l=j,this.m=M,this.n=$,this.p=H,this.s=ee,this.h=this.B(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,f.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new A.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(V,j){const M={includeInvalid:!0,profileLocation:j};let $=[];return V===null||V===0?$.push(...await this.m.scanAllExtensions({includeInvalid:!0},M,!1)):V===1&&$.push(...await this.m.scanUserExtensions(M)),$=V!==null?$.filter(H=>H.type===V):$,Promise.all($.map(H=>this.y(H)))}async scanAllUserExtensions(V){const j=await this.m.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(j.map(M=>this.y(M)))}async scanUserExtensionAtLocation(V){try{const j=await this.m.scanExistingExtension(V,1,{includeInvalid:!0});if(j)return await this.y(j)}catch(j){this.s.error(j)}return null}async extractUserExtension(V,j,M,$){await this.j.catch(()=>{});const H=V.toString(),ee=S.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),G=S.join(this.m.userExtensionsLocation.fsPath,H);try{await d.Promises.rm(G)}catch{throw new i.ExtensionManagementError(b.localize(4,null,G,V.id),i.ExtensionManagementErrorCode.Delete)}await this.u(V,j,ee,$),await this.m.updateMetadata(h.URI.file(ee),M);try{this.h.fire(h.URI.file(G)),await this.v(V,ee,G,Date.now()+2*60*1e3),this.s.info("Renamed to",G)}catch(Z){try{await d.Promises.rm(ee)}catch{}if(Z.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.s.info(`Rename failed because of ${(0,k.getErrorMessage)(Z)}. Deleted from extracted location`,ee),Z}return this.w(h.URI.file(G),1)}async scanMetadata(V,j){return j?(await this.n.scanProfileExtensions(j)).find($=>(0,n.areSameExtensions)($.identifier,V.identifier))?.metadata:this.m.scanMetadata(V.location)}async updateMetadata(V,j,M){return M?await this.n.updateMetadata([[V,j]],M):await this.m.updateMetadata(V.location,j),this.w(V.location,V.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...V){const j=V.map(M=>n.ExtensionKey.create(M));await this.t(M=>j.forEach($=>{M[$.toString()]=!0,this.s.info("Marked extension as uninstalled",$.toString())}))}async setInstalled(V){await this.t(j=>delete j[V.toString()])}async removeExtension(V,j){this.s.trace(`Deleting ${j} extension from disk`,V.identifier.id,V.location.fsPath);const M=this.p.extUri.joinPath(this.p.extUri.dirname(V.location),`.${(0,u.generateUuid)()}`);await this.v(V.identifier,V.location.fsPath,M.fsPath,Date.now()+2*60*1e3),await this.l.del(M,{recursive:!0}),this.s.info("Deleted from disk",V.identifier.id,V.location.fsPath)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.t(j=>delete j[n.ExtensionKey.create(V).toString()])}async copyExtensions(V,j){const M=await this.scanExtensions(1,V),$=await Promise.all(M.filter(H=>!H.isApplicationScoped).map(async H=>[H,await this.scanMetadata(H,V)]));await this.n.addExtensionsToProfile($,j)}async t(V){return this.g.queue(async()=>{let j;try{j=(await this.l.readFile(this.c,"utf8")).value.toString()}catch($){if((0,z.toFileOperationResult)($)!==1)throw $}let M={};if(j)try{M=JSON.parse(j)}catch{}return V&&(V(M),Object.keys(M).length?await this.l.writeFile(this.c,O.VSBuffer.fromString(JSON.stringify(M))):await this.l.del(this.c)),M})}async u(V,j,M,$){this.s.trace(`Started extracting the extension from ${j} to ${M}`);try{await d.Promises.rm(M)}catch(H){throw new i.ExtensionManagementError(this.D(H).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(j,M,{sourcePath:"extension",overwrite:!0},$),this.s.info(`Extracted extension to ${M}:`,V.id)}catch(H){try{await d.Promises.rm(M)}catch{}let ee=i.ExtensionManagementErrorCode.Extract;throw H instanceof y.ExtractError&&(H.type==="CorruptZip"?ee=i.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(ee=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(H.message,ee)}}async v(V,j,M,$){try{await d.Promises.rename(j,M)}catch(H){if(m.isWindows&&H&&H.code==="EPERM"&&Date.now()<$)return this.s.info(`Failed renaming ${j} to ${M} with 'EPERM' error. Trying again...`,V.id),this.v(V,j,M,$);throw new i.ExtensionManagementError(H.message||b.localize(5,null,j,M),H.code||i.ExtensionManagementErrorCode.Rename)}}async w(V,j){const M=await this.m.scanExistingExtension(V,j,{includeInvalid:!0});if(M)return this.y(M);throw new Error(b.localize(6,null,V.path))}async y(V){const j=await this.l.resolve(V.location);let M,$;return j.children&&(M=j.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,$=j.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:M,changelogUrl:$,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned}}async z(){const V=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(V));const j=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const H of j)V[n.ExtensionKey.create(H).toString()]||M.add(H.identifier.id.toLowerCase());try{const H=(0,n.groupByExtension)(j,ee=>ee.identifier);await A.Promises.settled(H.map(async ee=>{const G=ee.sort((Z,te)=>g.rcompare(Z.manifest.version,te.manifest.version))[0];M.has(G.identifier.id.toLowerCase())||await this.k(await this.y(G))}))}catch(H){this.s.error(H)}const $=j.filter(H=>H.metadata&&V[n.ExtensionKey.create(H).toString()]);await Promise.allSettled($.map(H=>this.removeUninstalledExtension(H)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const V=[];let j;try{j=await this.l.resolve(this.m.userExtensionsLocation)}catch(M){(0,z.toFileOperationResult)(M)!==1&&this.s.error(M)}for(const M of j?.children??[])M.isDirectory&&M.name.startsWith(".")&&(0,u.isUUID)(M.name.substring(1))&&V.push((async()=>{this.s.trace("Deleting the generated extension folder",M.resource.toString());try{await this.l.del(M.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",M.resource.toString())}catch($){this.s.error($)}})());await Promise.allSettled(V)}D(V){const j=Array.isArray(V)?V:[V];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((M,$)=>new Error(`${M.message}${M.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}};x=ye([X(1,z.IFileService),X(2,o.IExtensionsScannerService),X(3,r.IExtensionsProfileScannerService),X(4,B.IUriIdentityService),X(5,Y.ILogService)],x),e.ExtensionsScanner=x;class U extends a.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,p.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(V,j,M,$,H,ee,G,Z,te){super(),this.identifier=V,this.source=j,this.l=M,this.m=$,this.n=H,this.o=ee,this.p=G,this.q=Z,this.s=te,this.j="Unverified",this.k=2}async h(V){const[j,M]=await this.x(V);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[j,M]],this.l.profileLocation),j}async u({zipPath:V,key:j,metadata:M},$){let H=await this.v(j);return H||(this.s.trace("Extracting extension...",j.id),H=await this.m.extractUserExtension(j,V,M,$),this.s.info("Extracting extension completed.",j.id)),H}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find($=>n.ExtensionKey.create($).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class K extends U{constructor(V,j,M,$,H,ee,G,Z,te,le){super(j.identifier,j,M,H,ee,G,Z,te,le),this.y=V,this.z=j,this.A=$}async x(V){const M=(await this.m.scanExtensions(null,this.l.profileLocation)).find(G=>(0,n.areSameExtensions)(G.identifier,this.z.identifier));M&&(this.k=3);const $={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,T.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||M?.isMachineScoped,isBuiltin:this.l.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,p.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.z.version)return[await this.m.updateMetadata(M,$),$];const{location:H,verificationStatus:ee}=await this.A.download(this.z,this.k);try{return this.j=ee,this.C(H.fsPath),[await this.u({zipPath:H.fsPath,key:n.ExtensionKey.create(this.z),metadata:$},V),$]}catch(G){try{await this.A.delete(H)}catch(Z){this.s.warn("Error while deleting the downloaded file",H.toString(),(0,k.getErrorMessage)(Z))}throw G}}async C(V){try{await(0,w.getManifest)(V)}catch(j){throw new i.ExtensionManagementError((0,a.joinErrors)(j).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=K;class Q extends U{constructor(V,j,M,$,H,ee,G,Z,te,le){super({id:(0,n.getGalleryExtensionId)(V.publisher,V.name)},j,M,H,ee,G,Z,te,le),this.y=V,this.z=j,this.A=$}async x(V){const j=new n.ExtensionKey(this.identifier,this.y.version),$=(await this.m.scanExtensions(1,this.l.profileLocation)).find(G=>(0,n.areSameExtensions)(this.identifier,G.identifier)),H=await this.C(this.identifier.id,this.y.version,V);if(H.isApplicationScoped=(0,T.isApplicationScopedExtension)(this.y),H.isMachineScoped=this.l.isMachineScoped||$?.isMachineScoped,H.isBuiltin=this.l.isBuiltin||$?.isBuiltin,H.installedTimestamp=Date.now(),H.pinned=this.l.installGivenVersion?!0:void 0,$)if(this.k=3,j.equals(new n.ExtensionKey($.identifier,$.manifest.version)))try{await this.m.removeExtension($,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&g.gt($.manifest.version,this.y.version)&&await this.m.setUninstalled($);else{const G=await this.v(j);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:S.resolve(this.z.fsPath),key:j,metadata:H},V),H]}async C(V,j,M){try{let[$]=await this.A.getExtensions([{id:V,version:j}],M);if($||([$]=await this.A.getExtensions([{id:V}],M)),$)return{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class oe extends a.AbstractExtensionTask{constructor(V,j,M){super(),this.extension=V,this.j=j,this.k=M}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[294],re([0,1,2,29,79,242,128,11,20]),function(_,e,A,O,l,D,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let v=class extends A.Disposable{constructor(S,m,f,g,p,h){super(),S.cleanUp(),(0,D.migrateUnsupportedExtensions)(S,m,f,g,h),l.ExtensionStorageService.removeOutdatedExtensionVersions(S,p)}};v=ye([X(0,k.INativeServerExtensionManagementService),X(1,O.IExtensionGalleryService),X(2,l.IExtensionStorageService),X(3,O.IGlobalExtensionEnablementService),X(4,C.IStorageService),X(5,R.ILogService)],v),e.ExtensionsContributions=v}),define(se[303],re([0,1,34,39,7,2,21,24,10,37,154,219,220,212,213,291,201,204,16,225,98,240,99,232,15,237,120,277,29,100,203,128,101,14,215,216,55,5,210,70,72,245,11,106,107,25,59,20,112,19,113,114,115,47,248,117,257,79,118,22,77,282,268,269,80,283,286,287,288,61,271,111,239,76,259,229,258,110,30,260,4,261,205,223,222,78,276,28,51,218,58,280,247,272,109,285,294,8,217,270,87,152,278,199,211,71,57,279,254,289,281,236,234,241,105,274]),function(_,e,A,O,l,D,k,R,C,v,I,S,m,f,g,p,h,u,d,y,b,P,t,a,i,n,r,o,s,c,w,E,L,T,F,z,J,Y,W,N,B,ie,q,x,U,K,Q,oe,ae,V,j,M,$,H,ee,G,Z,te,le,he,me,pe,Se,Ce,De,ke,qe,Ye,ce,fe,de,Ie,Pe,Fe,Ae,je,Me,Ne,Be,ne,ue,ge,we,ve,Ee,Re,Le,Te,Ue,$e,ze,et,st,Dt,vt,kt,At,wt,Lt,Ot,Ze,Tt,Nt,Ut,Mt,Ft,jt,$t,St,Bt,zt,qt,Wt,xt,bt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ht extends D.Disposable{constructor(be,Oe){super(),this.f=be,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.B(new I.Server):this.a=this.B(new Tt.Server),this.h()}h(){const be=async()=>{this.c?.fireOnWillShutdown(),this.dispose()};if(process.once("exit",be),(0,Ze.isUtilityProcess)(process)?(0,I.once)(process.parentPort,"vscode:electron-main->shared-process=exit",be):this.g.once("vscode:electron-main->shared-process=exit",be),!(0,Ze.isUtilityProcess)(process)){const Oe="vscode:electron-main->shared-process=disposeWorker",We=(xe,tt)=>{this.i(tt)};this.g.on(Oe,We),this.B((0,D.toDisposable)(()=>this.g.removeListener(Oe,We)))}}i(be){this.b?.disposeWorker(be)}async init(){const be=await this.j();(0,he.registerConfiguration)(),be.invokeFunction(Oe=>{const We=Oe.get(q.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(We)}),this.B((0,D.combinedDisposable)(be.createInstance(S.CodeCacheCleaner,this.f.codeCachePath),be.createInstance(m.LanguagePackCachedDataCleaner),be.createInstance(p.UnusedWorkspaceStorageDataCleaner),be.createInstance(g.LogsDataCleaner),be.createInstance(f.LocalizationsUpdater),be.createInstance(At.ExtensionsContributions),be.createInstance(Dt.UserDataProfilesCleaner)))}async j(){const be=new N.ServiceCollection,Oe={_serviceBrand:void 0,...U.default};be.set(K.IProductService,Oe);const We=new v.StaticRouter(Ge=>Ge==="main"),xe=new Mt.MessagePortMainProcessService(this.a,We);be.set(Ft.IMainProcessService,xe);const tt=this.f.policiesData?new $e.PolicyChannelClient(this.f.policiesData,xe.getChannel("policy")):new ze.NullPolicyService;be.set(ze.IPolicyService,tt);const Je=new n.SharedProcessEnvironmentService(this.f.args,Oe);be.set(i.INativeEnvironmentService,Je);const _e=new x.LoggerChannelClient(void 0,this.f.logLevel,this.f.loggers.map(Ge=>({...Ge,resource:C.URI.revive(Ge.resource)})),xe.getChannel("logger"));be.set(q.ILoggerService,_e);const ct=this.B(_e.createLogger((0,R.joinPath)(C.URI.file(Je.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,wt.localize)(0,null)})),ht=this.B(new q.ConsoleLogger(ct.getLevel())),Ve=this.B(new Lt.LogService(ct,[ht]));be.set(q.ILogService,Ve),this.c=this.B(new bt.SharedProcessLifecycleService(Ve)),be.set(bt.ISharedProcessLifecycleService,this.c),this.b=new qt.SharedProcessWorkerService(Ve),be.set(Ne.ISharedProcessWorkerService,this.b);const Qe=this.B(new F.FileService(Ve));be.set(T.IFileService,Qe);const ft=this.B(new z.DiskFileSystemProvider(Ve));Qe.registerProvider(k.Schemas.file,ft);const dt=this.B(new ge.FileUserDataProvider(k.Schemas.file,this.B(new we.DiskFileSystemProviderClient(xe.getChannel(we.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ue.isLinux})),k.Schemas.vscodeUserData,Ve));Qe.registerProvider(k.Schemas.vscodeUserData,dt);const it=this.B(new et.UserDataProfilesService(this.f.profiles.all,C.URI.revive(this.f.profiles.home),xe.getChannel("userDataProfiles")));be.set(Te.IUserDataProfilesService,it);const Ke=this.B(new y.ConfigurationService(it.defaultProfile.settingsResource,Qe,tt,Ve));be.set(d.IConfigurationService,Ke);const rt=new $t.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},xe,Je);be.set(oe.IStorageService,rt),this.B((0,D.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]);const gt=new ne.UriIdentityService(Qe);be.set(Be.IUriIdentityService,gt),be.set(Q.IRequestService,new Wt.SharedProcessRequestService(xe,Ke,Ve)),be.set(h.IChecksumService,new J.SyncDescriptor(u.ChecksumService,void 0,!1)),be.set(Ee.IV8InspectProfilingService,new J.SyncDescriptor(ve.InspectProfilingService,void 0,!1));const lt=v.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.f.windowId});be.set(jt.INativeHostService,lt),be.set(t.IDownloadService,new J.SyncDescriptor(a.DownloadService,void 0,!0));const mt=this.B(new de.ActiveWindowManager(lt)),Gt=new v.StaticRouter(Ge=>mt.getActiveClientId().then(pt=>Ge===pt));be.set(L.IExtensionRecommendationNotificationService,new Ut.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Gt)));let ut;const ot=[],Ct=(0,H.isInternalTelemetry)(Oe,Ke);if((0,H.supportsTelemetry)(Oe,Je)){const Ge=new M.TelemetryLogAppender(Ve,_e,Je,Oe);ot.push(Ge);const{installSourcePath:pt}=Je;if(Oe.aiConfig?.ariaKey){const Pt=new st.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.B((0,D.toDisposable)(()=>Pt.flush())),ot.push(Pt)}ut=new $.TelemetryService({appenders:ot,commonProperties:(0,ae.resolveCommonProperties)(Qe,(0,A.release)(),(0,A.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,Ct,pt),sendErrorTelemetry:!0,piiPaths:(0,H.getPiiPathsFromEnvironment)(Je)},Ke,Oe)}else{ut=H.NullTelemetryService;const Ge=H.NullAppender;ot.push(Ge)}this.a.registerChannel("telemetryAppender",new j.TelemetryAppenderChannel(ot)),be.set(V.ITelemetryService,ut);const Jt=new ee.CustomEndpointTelemetryService(Ke,ut,Ve,_e,Je,Oe);be.set(V.ICustomEndpointTelemetryService,Jt),be.set(Ue.IExtensionsProfileScannerService,new J.SyncDescriptor(Vt.ExtensionsProfileScannerService,void 0,!0)),be.set(Re.IExtensionsScannerService,new J.SyncDescriptor(Le.ExtensionsScannerService,void 0,!0)),be.set(c.IExtensionSignatureVerificationService,new J.SyncDescriptor(c.ExtensionSignatureVerificationService,void 0,!0)),be.set(E.INativeServerExtensionManagementService,new J.SyncDescriptor(E.ExtensionManagementService,void 0,!0)),be.set(s.IExtensionGalleryService,new J.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),be.set(s.IExtensionTipsService,new J.SyncDescriptor(Nt.ExtensionTipsService,void 0,!1)),be.set(B.ILanguagePackService,new J.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1)),be.set(b.IDiagnosticsService,new J.SyncDescriptor(P.DiagnosticsService,void 0,!1)),be.set(me.IUserDataSyncAccountService,new J.SyncDescriptor(me.UserDataSyncAccountService,void 0,!0)),be.set(he.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),be.set(he.IUserDataSyncUtilService,new Se.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),be.set(s.IGlobalExtensionEnablementService,new J.SyncDescriptor(r.GlobalExtensionEnablementService,void 0,!1)),be.set(le.IIgnoredExtensionsManagementService,new J.SyncDescriptor(le.IgnoredExtensionsManagementService,void 0,!0)),be.set(te.IExtensionStorageService,new J.SyncDescriptor(te.ExtensionStorageService)),be.set(he.IUserDataSyncStoreManagementService,new J.SyncDescriptor(ce.UserDataSyncStoreManagementService,void 0,!0)),be.set(he.IUserDataSyncStoreService,new J.SyncDescriptor(ce.UserDataSyncStoreService,void 0,!0)),be.set(De.IUserDataSyncMachinesService,new J.SyncDescriptor(De.UserDataSyncMachinesService,void 0,!0)),be.set(he.IUserDataSyncBackupStoreService,new J.SyncDescriptor(pe.UserDataSyncBackupStoreService,void 0,!1)),be.set(he.IUserDataSyncEnablementService,new J.SyncDescriptor(ke.UserDataSyncEnablementService,void 0,!0)),be.set(he.IUserDataSyncService,new J.SyncDescriptor(qe.UserDataSyncService,void 0,!1)),be.set(fe.IUserDataProfileStorageService,new J.SyncDescriptor(zt.UserDataProfileStorageService,void 0,!0)),be.set(he.IUserDataSyncResourceProviderService,new J.SyncDescriptor(kt.UserDataSyncResourceProviderService,void 0,!0));const It=new Z.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,wt.localize)(1,null),Ke,Je,Ve,_e);return It.initialize(),be.set(St.ILocalPtyService,this.B(It)),be.set(Ie.ISignService,new J.SyncDescriptor(Pe.SignService,void 0,!1)),be.set(Fe.ISharedTunnelsService,new J.SyncDescriptor(Ae.SharedTunnelsService)),be.set(je.ISharedProcessTunnelService,new J.SyncDescriptor(Me.SharedProcessTunnelService)),be.set(vt.IRemoteTunnelService,new J.SyncDescriptor(xt.RemoteTunnelService)),new W.InstantiationService(be)}k(be){const Oe=new w.ExtensionManagementChannel(be.get(s.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const We=v.ProxyChannel.fromService(be.get(B.ILanguagePackService));this.a.registerChannel("languagePacks",We);const xe=v.ProxyChannel.fromService(be.get(b.IDiagnosticsService));this.a.registerChannel("diagnostics",xe);const tt=new w.ExtensionTipsChannel(be.get(s.IExtensionTipsService));this.a.registerChannel("extensionTipsService",tt);const Je=v.ProxyChannel.fromService(be.get(h.IChecksumService));this.a.registerChannel("checksum",Je);const _e=v.ProxyChannel.fromService(be.get(Ee.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",_e);const ct=new Se.UserDataSyncMachinesServiceChannel(be.get(De.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=v.ProxyChannel.fromService(be.get(V.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ve=new Se.UserDataSyncAccountServiceChannel(be.get(me.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ve);const Qe=new Se.UserDataSyncStoreManagementServiceChannel(be.get(he.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new Ye.UserDataSyncChannel(be.get(he.IUserDataSyncService),be.get(Te.IUserDataProfilesService),be.get(q.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(be.get(Y.IInstantiationService).createInstance(Bt.UserDataAutoSyncService)),it=new Se.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",it);const Ke=be.get(St.ILocalPtyService),rt=v.ProxyChannel.fromService(Ke);this.a.registerChannel(G.TerminalIpcChannels.LocalPty,rt);const gt=v.ProxyChannel.fromService(be.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,gt);const lt=v.ProxyChannel.fromService(be.get(Ne.ISharedProcessWorkerService));this.a.registerChannel(Ot.ipcUtilityProcessWorkerChannelName,lt);const mt=v.ProxyChannel.fromService(be.get(vt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(be){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,l.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,l.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,l.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,l.setUnexpectedErrorHandler)(Oe=>{const We=(0,O.toErrorMessage)(Oe,!0);!We||be.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Et(at){let be;(0,Ze.isUtilityProcess)(process)||(be=(await new Promise((We,xe)=>{_(["electron"],We,xe)})).ipcRenderer);const Oe=new Ht(at,be);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):be.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):be.send("vscode:shared-process->electron-main=init-done")}e.main=Et,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Et(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f44d5a4a4e72ca1461232d43d17a60f9ff555273/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
